Package: YAPSA
Type: Package
Title: Yet Another Package for Signature Analysis
Version: 1.36.0
Date: 2025-07-22
Authors@R: c(person("Daniel", "Huebschmann", role = "aut"),
    person("Lea", "Jopp-Saile", role = "aut"),
    person("Carolin", "Andresen", role = "aut"),
    person("Zuguang", "Gu", role = c("aut", "cre"), email = "z.gu@dkfz.de"),
    person("Matthias", "Schlesner", role = "aut"))
Imports: limSolve, SomaticSignatures, VariantAnnotation, Seqinfo,
        reshape2, gridExtra, corrplot, dendextend, GetoptLong,
        circlize, gtrellis, doParallel, parallel, PMCMRplus,
        ggbeeswarm, ComplexHeatmap, KEGGREST, grDevices, Biostrings,
        BSgenome.Hsapiens.UCSC.hg19, magrittr, pracma, dplyr, utils
Depends: R (>= 4.0.0), GenomicRanges, ggplot2, grid
Description: This package provides functions and routines for supervised 
    analyses of mutational signatures (i.e., the signatures have to be known,
    cf. L. Alexandrov et al., Nature 2013 and L. Alexandrov et al., Bioaxiv
    2018). In particular, the family of functions LCD (LCD = linear combination 
    decomposition) can use optimal signature-specific cutoffs which takes care of
    different detectability of the different signatures. Moreover, the package 
    provides different sets of mutational signatures, including the COSMIC and 
    PCAWG SNV signatures and the PCAWG Indel signatures; the latter infering that 
    with YAPSA, the concept of supervised analysis of mutational signatures is 
    extended to Indel signatures. YAPSA also provides confidence intervals as 
    computed by profile likelihoods and can perform signature analysis on a 
    stratified mutational catalogue (SMC = stratify mutational catalogue) in 
    order to analyze enrichment and depletion patterns for the signatures in 
    different strata. 
License: GPL-3
Suggests: testthat, BiocStyle, knitr, rmarkdown
VignetteBuilder: knitr
LazyLoad: yes
biocViews: Sequencing, DNASeq, SomaticMutation, Visualization,
        Clustering, GenomicVariation, StatisticalMethod,
        BiologicalQuestion
RoxygenNote: 7.2.3
Encoding: UTF-8
git_url: https://git.bioconductor.org/packages/YAPSA
git_branch: RELEASE_3_22
git_last_commit: 568357f
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.22
Date/Publication: 2025-10-29
NeedsCompilation: no
Packaged: 2025-10-30 07:16:33 UTC; biocbuild
Author: Daniel Huebschmann [aut],
  Lea Jopp-Saile [aut],
  Carolin Andresen [aut],
  Zuguang Gu [aut, cre],
  Matthias Schlesner [aut]
Maintainer: Zuguang Gu <z.gu@dkfz.de>

# Copyright © 2014-2019  The YAPSA package contributors
# This file is part of the YAPSA package. The YAPSA package is licenced under
# GPL-3

#' Construct a VRanges Object from a data frame
#'
#' In this package, big data frames are generated from cohort wide vcf-like
#' files. This function constructs a VRanges object from such a data frame by
#' using \code{\link{makeGRangesFromDataFrame}} from the package
#' \code{\link{GenomicRanges}}
#'
#' @param in_df A big dataframe constructed from a vcf-like file of a whole
#'   cohort. The first columns are those of a standard vcf file, followed by an
#'   arbitrary number of custom or user defined columns. One of these can carry
#'   a PID (patient or sample identifyier) and one can carry subgroup
#'   information.
#' @param in_keep.extra.columns in_seqinfo Argument passed on to
#'   \code{\link{makeGRangesFromDataFrame}}
#' @param in_seqinfo A seqInfo object, referring to the reference genome used.
#'   Argument passed on to \code{\link{makeGRangesFromDataFrame}}
#' @param in_seqnames.field Indicates the name of the column in which the
#'   chromosome is encoded
#' @param in_start.field Indicates the name of the column in which the start
#'   coordinate is encoded
#' @param in_end.field Indicates the name of the column in which the end
#'   coordinate is encoded
#' @param in_PID.field Indicates the name of the column in which the PID
#'   (patient or sample identifier) is encoded
#' @param in_subgroup.field Indicates the name of the column in which the
#'   subgroup information is encoded
#' @param in_strand.field Indicates the name of the column in which the
#'   strandedness is encoded
#' @param verbose_flag Verbose if 1
#'
#' @return The constructed VRanges object
#'
#' @examples
#'  data(lymphoma_test)
#'  temp_vr <- makeVRangesFromDataFrame(lymphoma_test_df,
#'                                      in_seqnames.field="CHROM",
#'                                      in_subgroup.field="SUBGROUP",
#'                                      verbose_flag=1)
#'
#' @seealso \code{\link{makeGRangesFromDataFrame}}
#'
#' @rawNamespace import(GenomicRanges, except=c(subtract))
#' @import VariantAnnotation
#' @importFrom Seqinfo seqlengths seqlengths<-
#' @export
#' 
makeVRangesFromDataFrame <- function(in_df,in_keep.extra.columns=TRUE,
                                    in_seqinfo=NULL,
                                    in_seqnames.field="X.CHROM",
                                    in_start.field="POS",
                                    in_end.field="POS",in_PID.field="PID",
                                    in_subgroup.field="subgroup",
                                    in_strand.field="strand",
                                    verbose_flag=1) {
    out_vr <- NULL
    name_list <- tolower(names(in_df))
    match_list <- c("ref","alt",tolower(in_seqnames.field),
                    tolower(in_start.field),tolower(in_end.field))
    if(length(which(match_list %in% name_list)) == length(match_list)) {
        my_gr <- GenomicRanges::makeGRangesFromDataFrame(in_df,
                                keep.extra.columns=in_keep.extra.columns,
                                seqinfo=in_seqinfo,
                                seqnames.field=in_seqnames.field,
                                start.field=in_start.field,
                                end.field=in_end.field,
                                strand.field=in_strand.field)
        if(!("+" %in% unique(strand(my_gr))) & 
                !("-" %in% unique(strand(my_gr)))){
                strand(my_gr) <- "+"
                if(verbose_flag==1){
                    cat("YAPSA:::makeVRangesFromDataFrame::warning:strand ",
                    "information missing, set to \"+\".\n")
        }
    }    
    out_vr <- VRanges(seqnames=seqnames(my_gr),ranges=ranges(my_gr),
                        ref=my_gr$REF,alt=my_gr$ALT)
    if(tolower(in_PID.field) %in% name_list) {
        if(verbose_flag==1){
            cat("YAPSA:::makeVRangesFromDataFrame::in_PID.field found. ",
                "Retrieving PID information.\n")
        }
        column_ind <- 
            min(which(tolower(names(mcols(my_gr)))==tolower(in_PID.field)))
        out_vr$PID <- mcols(my_gr)[,column_ind]
        sampleNames(out_vr) <- mcols(my_gr)[,column_ind]
        } else if("pid" %in% name_list) {
            if(verbose_flag==1){
                cat(paste0(
                "YAPSA:::makeVRangesFromDataFrame::warning:in_PID.field ",
                "not a valid column name,",
                " but default is valid. Retrieving PID information.\n"))
        }
        out_vr$PID <- mcols(my_gr)[,"PID"]
        sampleNames(out_vr) <- mcols(my_gr)[,column_ind]
    } else {
        if(verbose_flag==1){
            cat("YAPSA:::makeVRangesFromDataFrame::warning:PID information ",
            "missing. Filling up with dummy entries.\n");}
            out_vr$PID <- "dummy_PID"
            sampleNames(out_vr) <- "dummyPID"
    }
    if(tolower(in_subgroup.field) %in% name_list) {
        if(verbose_flag==1){
            cat("YAPSA:::makeVRangesFromDataFrame::in_subgroup.field found. ",
                "Retrieving subgroup information.\n")
        }
    column_ind <- 
        min(which(tolower(names(mcols(my_gr)))==tolower(in_subgroup.field)))
        #out_vr$Type <- mcols(my_gr)[,column_ind]
        mcols(out_vr)[,in_subgroup.field] <- mcols(my_gr)[,column_ind]
    } else if("subgroup" %in% name_list) {
        if(verbose_flag==1){
            cat(paste0("YAPSA:::makeVRangesFromDataFrame::warning:",
                "in_subgroup.field not a valid column name, ",
                "but default is valid. Retrieving subgroup information.\n"))
    }
    #out_vr$Type <- my_gr$subgroup
    mcols(out_vr)[,in_subgroup.field] <- my_gr$subgroup
    } else {
        if(verbose_flag==1){
            cat("YAPSA:::makeVRangesFromDataFrame::warning:",
                "subgroup information missing. ",
                "Filling up with dummy entries.\n");}
        #out_vr$Type <- "dummy_subgroup"
        mcols(out_vr)[,in_subgroup.field] <- "dummy_subgroup"
    }
    seqlengths(out_vr) <- seqlengths(my_gr)    
    } else {
        if(verbose_flag==1){
            cat("YAPSA:::makeVRangesFromDataFrame::
                error:mismatch in column names, ","return NULL.\n")
        }
    }
    return(out_vr)
}


#' Create a Mutational Catalogue from a VRanges Object
#'
#' This function creates a mutational catalogue from a VRanges Object by first
#' calling \code{\link[SomaticSignatures]{mutationContext}} to establish the
#' motif context of the variants in the input VRanges and then calling
#' \code{\link[SomaticSignatures]{motifMatrix}} to build the mutational
#' catalogue \code{V}.
#'
#' @param in_vr A VRanges object constructed from a vcf-like file of a whole
#'   cohort. The first columns are those of a standard vcf file, followed by an
#'   arbitrary number of custom or used defined columns. One of these can carry
#'   a PID (patient or sample identifyier) and one can carry subgroup
#'   information.
#' @param in_refGenome The reference genome handed over to
#'   \code{\link[SomaticSignatures]{mutationContext}} and used to extract the
#'   motif context of the variants in \code{in_vr}.
#' @param in_wordLength The size of the motifs to be extracted by
#'   \code{\link[SomaticSignatures]{mutationContext}}
#' @param in_PID.field Indicates the name of the column in which the PID
#'   (patient or sample identifier) is encoded
#' @param in_verbose Verbose if \code{in_verbose=1}
#' @param in_rownames Optional parameter to specify rownames of the mutational
#'   catalogue \code{V} i.e. the names of the features.
#' @param adapt_rownames Rownames of the output \code{matrix} will be adapted if
#'   \code{adapt_rownames=1}
#'
#' @return A list with entries \code{matrix}, \code{frame}, \itemize{ \item
#'   \code{matrix}: The mutational catalogue \code{V} \item \code{frame}:
#'   Additional and meta information on rownames (features), colnames (PIDs) and
#'   subgroup attribution. }
#'
#' @examples
#'  library(BSgenome.Hsapiens.UCSC.hg19)
#'  data(lymphoma_test)
#'  data(sigs)
#'  word_length <- 3
#'  temp_vr <- makeVRangesFromDataFrame(
#'    lymphoma_test_df,in_seqnames.field="CHROM",
#'    in_subgroup.field="SUBGROUP",verbose_flag=1)
#'  temp_list <- create_mutation_catalogue_from_VR(
#'    temp_vr,in_refGenome=BSgenome.Hsapiens.UCSC.hg19,
#'    in_wordLength=word_length,in_PID.field="PID",
#'    in_verbose=1)
#'  dim(temp_list$matrix)
#'  head(temp_list$matrix)
#'  test_list <- split(lymphoma_test_df,f=lymphoma_test_df$PID)
#'  other_list <- list()
#'  for(i in seq_len(length(test_list))){
#'    other_list[[i]] <- test_list[[i]][c(1:80),]
#'  }
#'  other_df <- do.call(rbind,other_list)
#'  other_vr <- makeVRangesFromDataFrame(
#'    other_df,in_seqnames.field="CHROM",
#'    in_subgroup.field="SUBGROUP",verbose_flag=1)
#'  other_list <- create_mutation_catalogue_from_VR(
#'    other_vr,in_refGenome=BSgenome.Hsapiens.UCSC.hg19,
#'    in_wordLength=word_length,in_PID.field="PID",
#'    in_verbose=1,in_rownames=rownames(AlexCosmicValid_sig_df))
#'  dim(other_list$matrix)
#'  head(other_list$matrix)
#'
#' @seealso \code{\link[SomaticSignatures]{mutationContext}}
#' @seealso \code{\link[SomaticSignatures]{motifMatrix}}
#'
#' @importFrom SomaticSignatures mutationContext
#' @importFrom SomaticSignatures motifMatrix
#' @export
#' 
create_mutation_catalogue_from_VR <- function(in_vr,in_refGenome,in_wordLength,
                                            in_PID.field="PID",in_verbose=0,
                                            in_rownames=c(),adapt_rownames=1){
    # adapt levels of in_PID.field
    PID_index <- which(names(mcols(in_vr))==in_PID.field)
    names(mcols(in_vr))[PID_index] <- "PID"
    in_vr$PID <- factor(as.character(in_vr$PID))
    # now start real work of the function
    if ( in_verbose==1 ) {
        cat("YAPSA:::create_mutation_catalogue_from_VR::Extracting mutation ",
        "context for the SNVs from the reference genome...\n");
    }
    my_motifs <- mutationContext(in_vr, in_refGenome, 
                                    k=in_wordLength, unify=TRUE)
    if ( in_verbose==1 ) {
        cat("YAPSA:::create_mutation_catalogue_from_VR::Building mutational ",
        "catalogue...\n");
    }
    ## cave: mutationContextMatrix is the old version of the SomaticSignatures 
    ##       package motifMatrix is the new version, but return a list instead 
    ##       of a matrix when the data is sparse
    #my_matrix = mutationContextMatrix(my_motifs, group=in_PID.field,
    #                                  normalize = FALSE)
    my_matrix = motifMatrix(my_motifs, group=in_PID.field,normalize = FALSE)
    ## check if unallowed nucleotides in matrix
    deselect_ind <- grep("[NX]",rownames(my_matrix))
    if (length(deselect_ind) > 0) {
        my_matrix <- my_matrix[-deselect_ind]
    }
    # account for sparsity of the matrix
    if(length(in_rownames) > 0) {
        if(length(in_rownames) < dim(my_matrix)[1]) {
            if(in_verbose==1) {
                cat("YAPSA:::create_mutation_catalogue_from_VR::
                Warning: supplied ", "rownames too short\n");
            }
        } else if (!is.character(in_rownames)) {
            if(in_verbose==1) {
                cat("YAPSA:::create_mutation_catalogue_from_VR::
                    Warning: supplied ", "rownames not character format\n");
            }
        } else {
            my_rownames <- transform_rownames_MATLAB_to_R(in_rownames,
                                                        in_wordLength)
            temp_matrix <- matrix(0,nrow=length(my_rownames),
                                    ncol=dim(my_matrix)[2])
            match_ind <- match(rownames(my_matrix),my_rownames)
            if( (length(match_ind) < dim(my_matrix)[1]) |
                (any(is.na(match_ind)))){
                if(in_verbose==1) {
                    cat("YAPSA:::create_mutation_catalogue_from_VR::
                        Warning: my_matrix"," contains rownames which are not
                        in supplied rownames.\n");
                }
            } else {
                temp_colnames <- colnames(my_matrix)
                temp_matrix[match_ind,] <- my_matrix
                my_matrix <- temp_matrix
                rownames(my_matrix) <- my_rownames
                colnames(my_matrix) <- temp_colnames
            }
        }
    }
    # string manipulations for export to matlab
    if ( in_verbose==1 ) {
        cat("YAPSA:::create_mutation_catalogue_from_VR::
            Performing string ", "manipulations for output to matlab...\n");
    }
    temp_frame <- data.frame(strsplit(rownames(my_matrix)," "))
    colnames(temp_frame) <- rownames(my_matrix)
    my_frame <- as.data.frame(t(temp_frame[,]))
    colnames(my_frame) <- c("exchange","context")
    my_frame$types <- 
        paste0(substr(my_frame$exchange,1,1),">",substr(my_frame$exchange,2,2))
    ## adapt for word length here
    fraction_length <- floor(in_wordLength/2)
    my_frame$subtypes <- 
        paste0(substr(my_frame$context,1,fraction_length),
                substr(my_frame$exchange,1,1),
                substr(my_frame$context,
                in_wordLength-fraction_length+1,in_wordLength))  
    my_frame$newnames <- paste0(my_frame$types," ",my_frame$subtypes)
    if(adapt_rownames==1) {
        rownames(my_matrix) <- my_frame$newnames
    }
    return(list(matrix=my_matrix,frame=my_frame))
}


#' Create a Mutational Catalogue from a data frame
#'
#' This function creates a mutational catalogue from a data frame. It is a
#' wrapper function for \code{\link{create_mutation_catalogue_from_VR}}: it
#' first creates a VRanges object from the data frame by
#' \code{\link{makeVRangesFromDataFrame}} and then passes this object on to the
#' above mentioned custom function.
#'
#' @param this_df A data frame constructed from a vcf-like file of a whole
#'   cohort. The first columns are those of a standard vcf file, followed by an
#'   arbitrary number of custom or used defined columns. One of these can carry
#'   a PID (patient or sample identifyier) and one can carry subgroup
#'   information.
#' @param this_refGenome_Seqinfo A seqInfo object, referring to the reference
#'   genome used. Argument passed on to \code{\link{makeGRangesFromDataFrame}}
#'   and thus indirectly to \code{\link{makeGRangesFromDataFrame}}.
#' @param this_seqnames.field Indicates the name of the column in which the
#'   chromosome is encoded
#' @param this_start.field Indicates the name of the column in which the start
#'   coordinate is encoded
#' @param this_end.field Indicates the name of the column in which the end
#'   coordinate is encoded
#' @param this_PID.field Indicates the name of the column in which the PID
#'   (patient or sample identifier) is encoded
#' @param this_subgroup.field Indicates the name of the column in which the
#'   subgroup information is encoded
#' @param this_refGenome The reference genome handed over to
#'   \code{\link{create_mutation_catalogue_from_VR}} and indirectly to
#'   \code{\link[SomaticSignatures]{mutationContext}} and used to extract the
#'   motif context of the variants in \code{in_vr}.
#' @param this_wordLength The size of the motifs to be extracted by
#'   \code{\link[SomaticSignatures]{mutationContext}}
#' @param this_verbose Verbose if \code{this_verbose=1}
#' @param this_rownames Optional parameter to specify rownames of the mutational
#'   catalogue \code{V} i.e. the names of the features.
#' @param this_adapt_rownames Rownames of the output \code{matrix} will be
#'   adapted if \code{this_adapt_rownames=1}
#'
#' @return A list with entries \code{matrix} and \code{frame} obtained from
#'   \code{\link{create_mutation_catalogue_from_VR}}: \itemize{ \item
#'   \code{matrix}: The mutational catalogue \code{V} \item \code{frame}:
#'   Additional and meta information on rownames (features), colnames (PIDs) and
#'   subgroup attribution. }
#'
#' @examples
#'  library(BSgenome.Hsapiens.UCSC.hg19)
#'  data(lymphoma_test)
#'  word_length <- 3
#'  temp_list <- create_mutation_catalogue_from_df(
#'    lymphoma_test_df,this_seqnames.field = "CHROM",
#'    this_start.field = "POS",this_end.field = "POS",
#'    this_PID.field = "PID",this_subgroup.field = "SUBGROUP",
#'    this_refGenome = BSgenome.Hsapiens.UCSC.hg19,
#'    this_wordLength = word_length)
#'    dim(temp_list$matrix)
#'    head(temp_list$matrix)
#'
#' @seealso \code{\link{makeVRangesFromDataFrame}}
#' @seealso \code{\link{create_mutation_catalogue_from_VR}}
#'
#' @export
#' 
create_mutation_catalogue_from_df <- function(this_df,
                                        this_refGenome_Seqinfo=NULL,
                                        this_seqnames.field="X.CHROM",
                                        this_start.field="POS",
                                        this_end.field="POS",
                                        this_PID.field="PID",
                                        this_subgroup.field="subgroup",
                                        this_refGenome,this_wordLength,
                                        this_verbose=1,
                                        this_rownames=c(),
                                        this_adapt_rownames=1) {
    if(is.null(this_refGenome_Seqinfo)){
        this_refGenome_Seqinfo <- seqinfo(this_refGenome)
    }
    my_vr <- makeVRangesFromDataFrame(this_df,
                                    in_keep.extra.columns=TRUE,
                                    in_seqinfo=this_refGenome_Seqinfo,
                                    in_seqnames.field=this_seqnames.field,
                                    in_start.field=this_start.field,
                                    in_end.field=this_end.field,
                                    in_PID.field=this_PID.field,
                                    in_subgroup.field=this_subgroup.field,
                                    verbose_flag=this_verbose)
    my_result_list <- create_mutation_catalogue_from_VR(my_vr,
                                                this_refGenome,
                                                this_wordLength,
                                                this_PID.field,
                                                this_verbose,
                                                this_rownames,
                                                this_adapt_rownames)
    return(my_result_list)
}


#' Change rownames from one naming convention to another
#'
#' Rownames or names of the features used differ between the different contexts
#' a signature analysis is carried out in. The function
#' \code{transform_rownames_R_to_MATLAB} changes from the convention used in
#' the YAPSA pacakge to the one used by Alexandrov et al. in the MATLAB
#' framework.
#'
#' @param in_rownames 
#'  Character vector of input rownames
#' @param wordLength 
#'  Size of the considered motif context
#'
#' @return A character vector of the translated rownames.
#' 
#' @examples
#' NULL
#' 
#' @export
#'
transform_rownames_R_to_MATLAB <- function(in_rownames,wordLength=3) {
    out_rownames <- in_rownames
    temp_frame <- data.frame(strsplit(in_rownames," "))
    colnames(temp_frame) <- in_rownames
    my_frame <- as.data.frame(t(temp_frame[,]))
    colnames(my_frame) <- c("exchange","context")
    my_frame$types <- paste0(substr(my_frame$exchange,1,1),">",
                                substr(my_frame$exchange,2,2))
    ## adapt for word length here
    fraction_length <- floor(wordLength/2)
    my_frame$subtypes <- paste0(
        substr(my_frame$context,1,fraction_length),
        substr(my_frame$exchange,1,1),
        substr(my_frame$context,wordLength-fraction_length+1,wordLength))  
    out_rownames <- paste0(my_frame$types," ",my_frame$subtypes)
    return(out_rownames)
}


#' Change rownames from one naming convention to another
#'
#' The function \code{transform_rownames_MATLAB_to_R} changes from the 
#' convention used in Alexandrov et al. in the MATLAB framework to the one used
#' by the YAPSA pacakge.
#' 
#' @export
#' @rdname transform_rownames_R_to_MATLAB
#'
transform_rownames_MATLAB_to_R <- function(in_rownames,wordLength=3) {
    out_rownames <- in_rownames
    temp_frame <- data.frame(strsplit(in_rownames," "))
    colnames(temp_frame) <- in_rownames
    my_frame <- as.data.frame(t(temp_frame[,]))
    colnames(my_frame) <- c("exchange","context")
    my_frame$types <- paste0(substr(my_frame$exchange,1,1),
                                substr(my_frame$exchange,3,3))
    ## adapt for word length here
    fraction_length <- floor(wordLength/2)
    my_frame$subtypes <- paste0(
        substr(my_frame$context,1,fraction_length),".",
        substr(my_frame$context,wordLength-fraction_length+1,wordLength))  
    out_rownames <- paste0(my_frame$types," ",my_frame$subtypes)
    return(out_rownames)
}


#' Change rownames from one naming convention to another
#'
#' The function \code{transform_rownames_MATLAB_to_R} changes from the 
#' convention used in stored mutational catalogues by Alexandrov et al. to the 
#' one used by the YAPSA pacakge.
#'
#' @export
#' @rdname transform_rownames_R_to_MATLAB
#'
transform_rownames_nature_to_R <- function(in_rownames,wordLength=3) {
    out_rownames <- in_rownames
    ## adapt for word length here
    fraction_length <- floor(wordLength/2)
    string_length <- nchar(as.character(in_rownames[1]))
    my_frame <- repeat_df(in_value = "a",in_rows = length(in_rownames),
                            in_cols = 2)
    colnames(my_frame) <- c("types","subtypes")
    my_frame$subtypes <- paste0(
        substr(in_rownames,1,fraction_length),
        substr(in_rownames,fraction_length+2,fraction_length+2),
        substr(in_rownames,string_length-fraction_length+1,string_length))  
    my_frame$types <- substr(in_rownames,fraction_length+2,fraction_length+4)
    out_rownames <- paste0(my_frame$types," ",my_frame$subtypes)
    return(out_rownames)
}


#' Change rownames from one naming convention to another
#'
#' The function \code{transform_rownames_YAPSA_to_deconstructSigs} changes from
#' the convention used in the YAPSA package to the one used by the 
#' deconstructSigs package.
#'
#' @export
#' @rdname transform_rownames_R_to_MATLAB
#'
transform_rownames_YAPSA_to_deconstructSigs <- function(in_rownames,
                                                        wordLength=3) {
    out_rownames <- in_rownames
    ## adapt for word length here
    fraction_length <- floor(wordLength/2)
    string_length <- nchar(as.character(in_rownames[1]))
    my_frame <- repeat_df(in_value = "a",in_rows = length(in_rownames),
                            in_cols = 2)
    colnames(my_frame) <- c("types","subtypes")
    my_frame$subtypes <- lapply(in_rownames,function(x) strsplit(x," ")[[1]][2])
    my_frame$types <- lapply(in_rownames,function(x) strsplit(x," ")[[1]][1])
    out_rownames <- paste0(
        substr(my_frame$subtypes,1,fraction_length),"[",
        my_frame$types,"]",
        substr(my_frame$subtypes,fraction_length+2,2*fraction_length+1))
    return(out_rownames)
}


#' Change rownames from one naming convention to another
#'
#' The function \code{transform_rownames_YAPSA_to_deconstructSigs} changes from
#' the convention used in the deconstructSigs package to the one used by the 
#' YAPSA pacakge.
#'
#' @export
#' @rdname transform_rownames_R_to_MATLAB
#'
transform_rownames_deconstructSigs_to_YAPSA <- function(in_rownames,
                                                        wordLength=3) {
    out_rownames <- in_rownames
    ## adapt for word length here
    fraction_length <- floor(wordLength/2)
    string_length <- nchar(as.character(in_rownames[1]))
    my_frame <- repeat_df(in_value = "a",in_rows = length(in_rownames),
                            in_cols = 2)
    colnames(my_frame) <- c("types","subtypes")
    my_frame$subtypes <- paste0(
        substr(in_rownames,1,fraction_length),
        substr(in_rownames,2+fraction_length,2+fraction_length),
        substr(in_rownames,6+fraction_length,5+2*fraction_length))
    my_frame$types <- substr(in_rownames,2+fraction_length,4+fraction_length)
    out_rownames <- paste0(my_frame$types," ",my_frame$subtypes)  
    return(out_rownames)
}


#' Normalize Somatic Motifs with different rownames
#'
#' This is a wrapper function to
#' \code{\link[SomaticSignatures]{normalizeMotifs}}. The rownames are first
#' transformed to fit the convention of the
#' \code{\link[SomaticSignatures]{SomaticSignatures}} package and then passed on
#' to the above mentioned function.
#'
#' @param in_matrix,in_norms Arguments to
#'   \code{\link[SomaticSignatures]{normalizeMotifs}}
#' @param adjust_counts Whether to rescale the counts after adaption or not.
#'   Default is true.
#'
#' @return The matrix returned by
#' \code{\link[SomaticSignatures]{normalizeMotifs}}, but with rownames
#' transformed back to the convention of the input
#'
#' @examples
#'  NULL
#'
#' @importFrom SomaticSignatures normalizeMotifs
#' @export
#' 
normalizeMotifs_otherRownames <- function(in_matrix,
                                            in_norms,
                                            adjust_counts=TRUE) {
    my_matrix <- in_matrix
    rownames(my_matrix) <- transform_rownames_MATLAB_to_R(rownames(in_matrix))
    out_matrix <- SomaticSignatures::normalizeMotifs(my_matrix,in_norms)
    rownames(out_matrix) <- rownames(in_matrix)
    if(adjust_counts){
        total_counts <- colSums(in_matrix)
        intermediate_counts <- colSums(out_matrix)
        mult_factors <- total_counts/intermediate_counts
        out_matrix <- as.data.frame(t(t(out_matrix)*mult_factors))
    }
    return(out_matrix)
}


adjust_number_of_columns_in_list_of_catalogues <- 
    function(in_all_list, in_merged_results_list) {
    out_list <- list()
    number_of_strata <- length(in_all_list$results_lists_list)
    reference_matrix <- in_merged_results_list$matrix
    zero_df <- as.data.frame(reference_matrix-reference_matrix)
    colname_vector <- colnames(reference_matrix)
    for (i in seq_len(number_of_strata)) {
        temp_df <- as.data.frame(in_all_list$results_lists_list[[i]]$matrix)
        match_ind <- match(names(temp_df),colname_vector)
        new_df <- zero_df
        new_df[,match_ind] <- temp_df
        out_list[[i]] <- new_df
    }
    return(out_list)
}


save_mutation_catalogue <- function(in_table,in_matrix,in_frame,
                                    in_subgroup_flag,in_meta_info,in_subDir,
                                    in_verbose) {
    type_df <- aggregate(data=in_table,subgroup~PID, function(l) return(l[1]))
    if (dim(type_df)[1] != length(colnames(in_matrix))) {
        cat("YAPSA:::save_mutation_catalogue::Warning: 
            mismatch between subgroup",
            " information and colnames(in_matrix).\n");
    }
    subgroup_vector <- rep("dummy",dim(in_matrix)[2])
    if (in_subgroup_flag==1) {
        subgroup_vector <- 
            as.character(in_meta_info$Diagnosis[match(colnames(in_matrix),
                                                in_meta_info$PID)])
    }
    if (in_subgroup_flag==2) {
        subgroup_vector <- 
            as.character(type_df$subgroup[match(colnames(in_matrix),
                                                type_df$PID)])
    }
    # store to text files
    if ( in_verbose==1 ) {cat("Store to specified files...\n");}
    save(in_table,in_matrix,file=file.path(in_subDir,"MotifMatrix.RData"))
    write.table(in_matrix,sep="\t",file=file.path(in_subDir,"MotifMatrix.txt"),
                col.names=FALSE,row.names=FALSE)
    write(c("PIDs",colnames(in_matrix)),sep="\t",
        file=file.path(in_subDir,"MotifMatrix_colnames.txt"))
    write(c("subgroup",subgroup_vector),sep="\t",
        file=file.path(in_subDir,"MotifMatrix_subgroups.txt"))
    write(c("types",in_frame$types),sep="\t",
        file=file.path(in_subDir,"MotifMatrix_types.txt"))
    write(c("subtypes",in_frame$subtypes),sep="\t",
        file=file.path(in_subDir,"MotifMatrix_subtypes.txt"))
}


stratify_vcf_like_df <- function(in_table,in_column_name,in_verbose=0) {
    out_table_list <- list()
    out_name_list <- list()
    stratification_index <- which(names(in_table)==in_column_name)
    name_list <- unique(in_table[,stratification_index])
    index_range <- sort(name_list)
    counter <- 0
    if(in_verbose == 1) {
        cat("\nYAPSA:::stratify_vcf_like_df::Stratify...\n")
    }
    for (i in index_range) {
        counter <- counter + 1
        temp_ind <- which(in_table[,stratification_index]==i)
        temp_table <- in_table[temp_ind,]
        temp_name <- i
        if(in_verbose == 1) {
            cat("YAPSA:::stratify_vcf_like_df:: temp_name =",temp_name,
                "; number of variants:",dim(temp_table)[1],"; number of PIDs:",
                length(unique(temp_table$PID)),"\n")
        }
        out_table_list[[counter]] <- temp_table
        out_name_list[[counter]] <- temp_name
    }    
    return(list(table_list=out_table_list,name_list=out_name_list))
}


save_stratified_vcf_like_df <- function(in_table_list,in_name_list,
                                        in_target_dir,in_verbose) {
    number_of_strata <- length(in_table_list)
    subDir <- file.path(in_target_dir, "vcf_like")
    strataDir <- file.path(in_target_dir, "strata")
    dir.create(in_target_dir)
    dir.create(subDir)
    dir.create(strataDir)
    if(in_verbose == 1) {
        cat("\nYAPSA:::save_stratified_vcf_like_df::Write to file...\n")
    }
    for (i in seq_len(number_of_strata)) {
        temp_table <- in_table_list[[i]]
        temp_name <- in_name_list[[i]]
        if(in_verbose == 1) {
            cat("YAPSA:::save_stratified_vcf_like_df:: 
                temp_name =",temp_name,"; number of variants:",
                dim(temp_table)[1],"; number of PIDs:",
                length(unique(temp_table$PID)),"\n")
        }
        file_name <- paste0(subDir,"/somatic_SNVs_",temp_name,".tsv")
        names(temp_table) <- sub("X.CHROM","\\#CHROM",names(temp_table))
        write.table(temp_table, file=file_name,sep="\t",
                    quote =FALSE, row.names=FALSE)
        temp_dir <- file.path(in_target_dir, "strata", temp_name)
        dir.create(temp_dir)
    }    
    return(1)
}


stratify_and_create_mutational_catalogue <- 
    function(our_table, our_column_name, vcf_target_dir, strata_target_dir,
            our_refGenome_Seqinfo, our_seqnames.field="X.CHROM",
            our_start.field="POS", our_end.field="POS", our_PID.field="PID",
            our_subgroup.field="subgroup", our_refGenome, our_wordLength,
            in_verbose=1, our_rownames=c()) {
    results_lists_list <- list()
    results_list <- stratify_vcf_like_df(our_table,our_column_name,in_verbose)
    table_list <- results_list$table_list
    name_list <- results_list$name_list
    if(!is.null(vcf_target_dir)) {
        status <- save_stratified_vcf_like_df(table_list,name_list,
                                            vcf_target_dir,in_verbose)    
    }
    number_of_strata <- length(table_list)
    if(in_verbose == 1) {
        cat("\nYAPSA:::stratify_and_create_mutational_catalogue::Create ",
            "mutational catalogues...\n")
    }
    for (i in seq_len(number_of_strata)) {
        if(in_verbose == 1) {
            cat("\nYAPSA:::stratify_and_create_mutational_catalogue::
                Processing ","stratum: ",i,"\n")
    }
        temp_table <- table_list[[i]]
        temp_name <- name_list[[i]]
        temp_results_list <- create_mutation_catalogue_from_df(
            temp_table,
            our_refGenome_Seqinfo,
            this_seqnames.field=our_seqnames.field,
            this_start.field=our_start.field,
            this_end.field=our_end.field,
            this_PID.field=our_PID.field,
            this_subgroup.field=our_subgroup.field,
            our_refGenome,our_wordLength,in_verbose,
            our_rownames)
        if(!is.null(strata_target_dir)) {
            temp_matrix <- temp_results_list$matrix
            temp_frame <- temp_results_list$frame
            MotifMatrix_dir <- file.path(strata_target_dir,temp_name)
            save_mutation_catalogue(temp_table,temp_matrix,temp_frame,
                                    2,NULL,MotifMatrix_dir,in_verbose)
        }
        results_lists_list[[i]] <- temp_results_list
    }    
    return(list(table_list=table_list,name_list=name_list,
                results_lists_list=results_lists_list))  
}


#' Wrapper for cut
#'
#' In this wrapper function for the known \code{\link{cut}} function, the
#' \code{breaks} vector need not be supplied directly, instead, for every break,
#' an interval is supplied and the function optimizes the choice of the
#' breakpoint by chosing a local minimum of the distribution.
#'
#' @param in_vector Vector of numerical continuously distributed input
#' @param in_outlier_cutoffs Interval specifyinf the upper and lower bounds of
#'   the range to be considered
#' @param in_cutoff_ranges_list List if intervals in which the cutoffs for
#'   \code{\link{cut}} have to be optimized.
#' @param in_labels Labels assigned to the strata or factors returned
#' @param in_name String specifying the name of the quantity analyzed (and
#'   plotted on the x-axis of the figure to be created).
#' @param output_path Path where the figure produced by the density function
#'   should be stored if non-NULL.
#'
#' @return A list with entries \code{category_vector}, and \code{density_plot}
#'   and \code{cutoffs} \itemize{ \item \code{category_vector}: Factor vector of
#'   the categories or strata, of the same length as \code{in_vector} \item
#'   \code{density_plot}: Density plot produced by the density function and
#'   indication of the chosen cutoffs. \item \code{cutoffs}: Vector of the
#'   computed optimal cutoffs }
#'
#' @examples
#'  data(lymphoma_test)
#'  lymphoma_test_df$random_norm <- rnorm(dim(lymphoma_test_df)[1])
#'  temp_list <- cut_breaks_as_intervals(
#'    lymphoma_test_df$random_norm,
#'    in_outlier_cutoffs=c(-4,4),
#'    in_cutoff_ranges_list=list(c(-2.5,-1.5),c(0.5,1.5)),
#'    in_labels=c("small","intermediate","big"))
#'   temp_list$density_plot
#'
#' @seealso \code{\link{cut}}
#' @seealso \code{\link[stats]{density}}
#'
#' @export
#' 
cut_breaks_as_intervals <- function(in_vector,
                                    in_outlier_cutoffs=c(0,3000),
                                    in_cutoff_ranges_list=list(c(60,69),
                                                                c(25,32)),
                                    in_labels=c("late","intermediate","early"),
                                    in_name="",
                                    output_path=NULL) {
    ## prepare
    .e <- environment()
    finite_ind <- which(is.finite(in_vector))
    finite_vector <- in_vector[finite_ind]
    choice_ind <- which(finite_vector<=in_outlier_cutoffs[2] &
                        finite_vector>=in_outlier_cutoffs[1])
    my_density <- density(finite_vector[choice_ind])
    my_density_df <- data.frame(x=my_density$x,y=my_density$y)
    ## find appropriate cutoffs in the ranges provided (refine!!)
    number_of_cutoffs <- length(in_cutoff_ranges_list)
    my_cutoff_vector <- rep(0,number_of_cutoffs)
    for(j in seq_len(number_of_cutoffs)) {
        my_cutoff_interval <- in_cutoff_ranges_list[[j]]
        my_range_ind <- which(my_density_df$x<my_cutoff_interval[2] & 
                                my_density_df$x>my_cutoff_interval[1])
        my_min_ind <- which.min(my_density_df$y[my_range_ind])
        my_cutoff_vector[j] <- my_density_df$x[my_range_ind[my_min_ind]]
    }
    ## make density plot
    p <- ggplot(my_density_df,aes_string(x="x",y="y"), environment = .e) + 
        geom_line() + labs(x=in_name, y="density") + 
        geom_vline(xintercept=my_cutoff_vector,colour="red")
    if(!is.null(output_path)) {
        png(output_path,width=400,height=400); p; dev.off()    
    }
    my_cutoff_vector <- c(in_outlier_cutoffs[1],my_cutoff_vector,
                            in_outlier_cutoffs[2])
    ## discretize into categories
    cut_vector <- cut(in_vector,my_cutoff_vector,right=FALSE,labels=in_labels)
    cut_vector <- as.character(cut_vector)
    cut_vector[which(is.na(cut_vector))] <- "undetermined"
    cut_vector <- factor(cut_vector)
    return(list(category_vector=cut_vector,density_plot=p,
                cutoffs=my_cutoff_vector))
}


#' Return those PIDs which have an extreme pattern for signature exposure
#'
#' For all signatures found in a project, this function returns the sample
#' identifiers (PIDs) with extremely high or extremely low exposures of the
#' respective signatures.
#'
#' @param in_exposures_df Data frame with the signature exposures
#' @param in_quantile Quantile for the amount of extreme PIDs to be selected.
#'
#' @return A data frame with 4 rows per signature (high PIDs, high exposures,
#'   low PIDs, low exposures); the number of columns depends on the quantile
#'   chosen.
#'
#' @examples
#'  data(lymphoma_cohort_LCD_results)
#'  get_extreme_PIDs(lymphoma_Nature2013_COSMIC_cutoff_exposures_df,0.05)
#'
#' @import ggplot2
#' @export
#' 
get_extreme_PIDs <- function(in_exposures_df,in_quantile=0.03) {
    in_exposures_df = as.matrix(in_exposures_df)
    my_number_of_sigs <- dim(in_exposures_df)[1]
    my_number_of_PIDs <- dim(in_exposures_df)[2]
    my_number_of_extremes <- ceiling(in_quantile*my_number_of_PIDs)
    extreme_PID_df <- repeat_df(0,my_number_of_extremes,my_number_of_sigs*4)
    for(i in seq_len(my_number_of_sigs)) {
        this_sig <- rownames(in_exposures_df)[i]
        my_exposure_vector <- unlist(in_exposures_df[i,])
        my_breaks <- as.numeric(quantile(my_exposure_vector,
                        probs=c(in_quantile,(1-in_quantile))))
        extreme_low_ind <- which(my_exposure_vector<=my_breaks[1])
        extreme_high_ind <- which(my_exposure_vector>=my_breaks[2])
        extreme_PID_df[,4*i-3] <- names(
            my_exposure_vector[extreme_low_ind[seq_len
                                                (my_number_of_extremes)]])
        names(extreme_PID_df)[4*i-3] <- paste0(this_sig,"_low_PIDs")
        extreme_PID_df[,4*i-2] <- as.numeric(
            my_exposure_vector[extreme_low_ind[seq_len
                                                (my_number_of_extremes)]])
        names(extreme_PID_df)[4*i-2] <- paste0(this_sig,"_low_exp")
        extreme_PID_df[,4*i-1] <- names(
            my_exposure_vector[extreme_high_ind[seq_len
                                                (my_number_of_extremes)]])
        names(extreme_PID_df)[4*i-1] <- paste0(this_sig,"_high_PIDs")
        extreme_PID_df[,4*i] <- as.numeric(
            my_exposure_vector[extreme_high_ind[seq_len
                                                (my_number_of_extremes)]])
        names(extreme_PID_df)[4*i] <- paste0(this_sig,"_high_exp")
    }
    out_df <- data.frame(t(extreme_PID_df))
    names(out_df) <- paste0("PID_",seq_len(dim(out_df)[2]))
    return(out_df)
}


#' Test if mutated PIDs are enriched in signatures
#'
#' For all signatures found in a project, this function tests whether PIDs
#' having mutations in a specified list of genes of interest have significantly
#' higher exposures.
#'
#' @param in_gene_list List with genes of interest
#' @param in_exposure_df Data frame with the signature exposures
#' @param in_mut_table Data frame or table of mutations (derived from
#'   vcf-format)
#' @param in_gene.field Name of the column in which the gene names are to be
#'   looked up
#' @param in_p_cutoff Significance threshold
#'
#' @return A list with entries \code{pvals}, \code{exposure_df},
#'   \code{number_of_mutated}, \itemize{ \item \code{pvals}: p-values of the
#'   t-tests performed on mutated vs. unmutated PIDs \item \code{exposure_df}:
#'   Transposed input exposures data frame with additional annotations for
#'   mutation status \item \code{number_of_mutated}: Number of PIDs carrying a
#'   mutation }
#'
#' @examples
#'  NULL
#'
#' @export
#' 
test_gene_list_in_exposures <- function(in_gene_list,
                                        in_exposure_df,
                                        in_mut_table,
                                        in_gene.field="GENE_short",
                                        in_p_cutoff=0.05) {
    gene_index <- which(names(in_mut_table)==in_gene.field)
    number_of_signatures <- dim(in_exposure_df)[1]
    choice_ind <- which(in_mut_table[,gene_index] %in% in_gene_list)
    #choice_table <- in_mut_table[choice_ind,c(1:5,16:18,20,24,26,29)]
    choice_table <- in_mut_table[choice_ind,]
    this_PIDs <- unique(choice_table$PID)
    temp_ind <- match(this_PIDs,names(in_exposure_df))
    temp_ind_ind <- which(temp_ind>0)
    cat("test_gene_list_in_exposures: number of PIDs in overlap ",
        "between exposures, gene list and mutation table: ",
        length(temp_ind_ind),"\n")
    this_exposure_df <- as.data.frame(t(in_exposure_df))
    this_exposure_df$this_status <- "none"
    this_exposure_df$this_col <- "green"
    this_exposure_df$this_status[temp_ind[temp_ind_ind]] <- "mut"
    this_exposure_df$this_col[temp_ind[temp_ind_ind]] <- "red"
    ## now check for differences in signature counts
    significance_counter <- 0
    out_t_test_vector <- c()
    for (i in seq_len(number_of_signatures)) {
        temp_test_dat <- t.test(
            this_exposure_df[which(this_exposure_df$this_status=="none"),i],
            this_exposure_df[which(this_exposure_df$this_status=="mut"),i],
            alternative="less")
        out_t_test_vector[i] <- temp_test_dat$p.value
        if(out_t_test_vector[i] < in_p_cutoff & !is.na(out_t_test_vector[i])) {
            significance_counter <- significance_counter + 1
        }
    }
    cat("test_gene_list_in_exposures: Number of significancies: ",
        significance_counter,"\n")
    return(list(pvals=out_t_test_vector,
                exposure_df=this_exposure_df,
                number_of_mutated=length(temp_ind_ind)))
}


#' Compare one mutational catalogue to reference mutational catalogues
#'
#' Compare one mutational catalogue (e.g. of one index patient) to a list of
#' reference mutational catalogues (e.g. from the initial Alexandrov
#' puplication) by cosine similarities
#'
#' @param in_index_df Data frame containing the mutational catalogue of interest
#' @param in_comparison_list List of data frames (ideally named) containing the
#'   reference mutational catalogues
#'
#' @return A similarity dataframe
#'
#' @examples
#'  NULL
#'
#' @export
#' 
compare_to_catalogues <- function(in_index_df,in_comparison_list){
    sim_vec_list <- lapply(in_comparison_list,FUN=function(x){
        temp_list <- compare_sets(in_index_df,x)
        return(c(as.numeric(1-as.matrix(temp_list$distance))))
    })
    sim_df_list <- list()
    for(i in seq_along(sim_vec_list)) {
        my_entity <- names(sim_vec_list)[i]
        temp_df <- data.frame(entity=my_entity,sim=sim_vec_list[[i]])
        sim_df_list[[i]] <- temp_df
    }
    sim_df <- do.call(rbind,sim_df_list)
    return(sim_df)
}


#' Extract statistical measures for entity comparison
#'
#' Compare one mutational catalogue (e.g. of one index patient) to a list of
#' reference mutational catalogues (e.g. from the initial Alexandrov
#' puplication) by cosine similarities
#'
#' @param in_sim_df A similarity data frame as extracted by
#'   \code{\link{compare_to_catalogues}}
#'
#' @return A dataframe containing statistical measures, prepared for bar plot
#'
#' @examples
#'  NULL
#'
#' @export
#' 
compute_comparison_stat_df <- function(in_sim_df){
    mean_df <- aggregate(sim~entity,data=in_sim_df,FUN=mean)
    median_df <- aggregate(sim~entity,data=in_sim_df,FUN=median)
    sd_df <- aggregate(sim~entity,data=in_sim_df,FUN=sd)
    stat_df <- mean_df
    stat_df$median_sim <- median_df$sim
    stat_df$sd_sim <- sd_df$sim
    names(stat_df)[2] <- "mean_sim"
    return(stat_df)
}


#' Aggregate exposures by category
#'
#' If a valid category (i.e. it matches to a category specified in
#' in_sig_ind_df) is supplied, then the exposures are aggregated over this
#' category.
#'
#' @param in_exposures_df Input data frame of exposures.
#' @param in_sig_ind_df Input data frame of meta information on the signatures.
#'   Has to match the signatures in \code{in_exposures_df}
#' @param in_category Category to be aggregated over
#'
#' @return A list with entries: \itemize{ \item \code{exposures}: The exposures
#'   \code{H}, a numeric data frame with \code{l} rows and \code{m} columns,
#'   \code{l} being the number of aggregated signatures and \code{m} being the
#'   number of samples \item \code{norm_exposures}: The normalized exposures
#'   \code{H}, a numeric data frame with \code{l} rows and \code{m} columns,
#'   \code{l} being the number of aggregated signatures and \code{m} being the
#'   number of samples \item \code{out_sig_ind_df}: Data frame of the type
#'   \code{signature_indices_df}, i.e. indicating name, function and
#'   meta-information of the aggregated signatures.. }
#'
#' @seealso \code{\link{LCD_complex_cutoff}}
#'
#' @examples
#'  NULL
#'
#' @export
#' 
aggregate_exposures_by_category <- function(
    in_exposures_df,in_sig_ind_df,in_category){
    if(any(in_category==names(in_sig_ind_df))) {
        ## process exposures
        temp_exposures <- cbind(
            in_exposures_df,in_sig_ind_df[,in_category,drop=FALSE])
        names(temp_exposures) <- gsub(in_category,"cat",names(temp_exposures))
        temp_aggregate_exposures <- aggregate(.~cat,data=temp_exposures,FUN=sum)
        rownames(temp_aggregate_exposures) <- temp_aggregate_exposures$cat
        temp_aggregate_exposures$cat <- NULL
        ## normalize exposures
        norm_aggregate_exposures <- 
            normalize_df_per_dim(temp_aggregate_exposures, 2)
        ## process sig_ind_df
        names(in_sig_ind_df) <- gsub(in_category,"cat",names(in_sig_ind_df))
        out_sig_ind_df <- aggregate(.~cat,data=in_sig_ind_df,FUN=head,1)
        out_sig_ind_df$sig <- out_sig_ind_df$cat
        out_sig_ind_df$cat <- NULL
        out_sig_ind_df$colour <- as.character(out_sig_ind_df$colour)
        return(list(exposures=temp_aggregate_exposures,
                    norm_exposures=norm_aggregate_exposures,
                    out_sig_ind_df=out_sig_ind_df))
    } else {
        return(NULL)
    }
}

test_that("Test cosine_dist with 2-dim vectors", {
  a <- c(1,0)
  b <- c(0,1)
  d <- c(1,1)
  expect_equal(YAPSA:::cosineDist(a,b), 1)
  expect_equal(YAPSA:::cosineDist(a,a), 0)
  expect_equal(YAPSA:::cosineDist(b,b), 0)
  expect_lt(YAPSA:::cosineDist(a,d) - (1-cos(pi/4)),1e-08)
})


test_that("Test makeVRangesFromDataFrame with real data", {
  data(lymphoma_test)
  temp_vr <- makeVRangesFromDataFrame(lymphoma_test_df,
                                      in_seqnames.field="CHROM",
                                      in_subgroup.field="SUBGROUP")
  expect_equal(length(temp_vr),dim(lymphoma_test_df)[1])
  expect_that(as.character(seqnames(temp_vr)),
              is_equivalent_to(lymphoma_test_df$CHROM))
  expect_that(as.data.frame(ranges(temp_vr))[,1],
              is_equivalent_to(lymphoma_test_df$POS))
})


test_that("Test cut_breaks_as_intervals with partially real data",{
  my_precision <- 0.05
  data(lymphoma_test)
  my_outlier_cutoffs <- c(-4,4)
  my_cutoff_ranges_list <- list(c(-2.5,-1.5),c(0.5,1.5))
  lymphoma_test_df$random_norm <- rnorm(dim(lymphoma_test_df)[1])
  temp_list <- 
    cut_breaks_as_intervals(lymphoma_test_df$random_norm,
                            in_outlier_cutoffs=my_outlier_cutoffs,
                            in_cutoff_ranges_list=my_cutoff_ranges_list,
                            in_labels=c("small","intermediate","big"))
  expect_equal(temp_list$cutoffs[c(1,4)],my_outlier_cutoffs)
  expect_lt(max(abs(temp_list$cutoffs[c(2,3)]-
                        c(min(my_cutoff_ranges_list[[1]]),
                          max(my_cutoff_ranges_list[[2]])))),
                   my_precision)
})


test_that("Test stratify_vcf_like_df with real data",{
  data(lymphoma_test)
  my_labels <- c("small","intermediate","big")
  strata_list <- 
    cut_breaks_as_intervals(lymphoma_test_df$random_norm,
                            in_outlier_cutoffs=c(-4,4),
                            in_cutoff_ranges_list=list(c(-2.5,-1.5),
                                                       c(0.5,1.5)),
                            in_labels=my_labels)
  lymphoma_test_df$random_cat <- strata_list$category_vector
  stratification_list <- 
    stratify_vcf_like_df(lymphoma_test_df,"random_cat",in_verbose=0)
  expect_equal(length(stratification_list$name_list),
              length(unique(lymphoma_test_df$random_cat)))
  expect_that(sort(unlist(stratification_list$name_list)),
              is_equivalent_to(sort(my_labels)))
  expect_equal(length(stratification_list$table_list),
              length(unique(lymphoma_test_df$random_cat)))
  sum <- 0
  for (i in seq_len(3)){
    temp_table <- stratification_list$table_list[[i]]
    sum <- sum + dim(temp_table)[1]
    expect_equal(as.character(unique(temp_table$random_cat)),
                stratification_list$name_list[[i]])
  }
  expect_equal(sum,dim(lymphoma_test_df)[1])
})

## ----loadStyle, warning=FALSE, echo=FALSE, message=FALSE, results="hide"------
library(BiocStyle)

## ----packages, include=FALSE--------------------------------------------------
library(YAPSA)
library(Biostrings)
library(BSgenome.Hsapiens.UCSC.hg19)
library(knitr)
opts_chunk$set(echo=TRUE)
opts_chunk$set(fig.show='asis')

## ----loadStoredSigData--------------------------------------------------------
data(sigs)
data(cutoffs)
data("lymphomaNature2013_mutCat_df")
current_cutoff_vector <- cutoffCosmicValid_abs_df[6,]

## ----LCDwithCutoffs-----------------------------------------------------------
lymphoma_COSMIC_listsList <-
  LCD_complex_cutoff_combined(
      in_mutation_catalogue_df = lymphomaNature2013_mutCat_df,
      in_cutoff_vector = current_cutoff_vector, 
      in_signatures_df = AlexCosmicValid_sig_df, 
      in_sig_ind_df = AlexCosmicValid_sigInd_df)

## ----subrgroupAnnotation------------------------------------------------------
data(lymphoma_PID)
colnames(lymphoma_PID_df) <- "SUBGROUP"
lymphoma_PID_df$PID <- rownames(lymphoma_PID_df)
COSMIC_subgroups_df <- 
  make_subgroups_df(lymphoma_PID_df,
                    lymphoma_COSMIC_listsList$cohort$exposures)

## ----captionExposures, echo=FALSE---------------------------------------------
cap <- "Exposures to SNV mutational signatures"

## ----exposuresCutoffs, warning=FALSE, fig.width=8, fig.height=6, fig.cap= cap----
exposures_barplot(
  in_exposures_df = lymphoma_COSMIC_listsList$cohort$exposures,
  in_signatures_ind_df = lymphoma_COSMIC_listsList$cohort$out_sig_ind_df,
  in_subgroups_df = COSMIC_subgroups_df)               

## ----captionCI, echo=FALSE----------------------------------------------------
cap <- "Confidence interval calculation for exposures to mutational 
        signatures"

## ----computeCI, echo=TRUE, warning=FALSE--------------------------------------
complete_df <- variateExp(
  in_catalogue_df = lymphomaNature2013_mutCat_df,
  in_sig_df = lymphoma_COSMIC_listsList$cohort$signatures,
  in_exposures_df = lymphoma_COSMIC_listsList$cohort$exposures,
  in_sigLevel = 0.025, in_delta = 0.4)

## ----displayCompleteDf, echo=TRUE, warning=FALSE------------------------------
head(complete_df, 12)

## ----plotCI, echo=TRUE, warning=FALSE, fig.width=17, fig.height=15, fig.cap=cap----
plotExposuresConfidence(
  in_complete_df = complete_df, 
  in_subgroups_df = COSMIC_subgroups_df,
  in_sigInd_df = lymphoma_COSMIC_listsList$cohort$out_sig_ind_df)

# Copyright © 2014-2019  The YAPSA package contributors
# This file is part of the YAPSA package. The YAPSA package is licenced under
# GPL-3

#'Linear Combination Decomposition
#'
#'\code{LCD} performs a mutational signatures decomposition of a given
#'mutational catalogue \code{V} with known signatures \code{W} by solving the
#'minimization problem \eqn{min(||W*H - V||)} with additional constraints of
#'non-negativity on H where W and V are known
#'
#'@param in_mutation_catalogue_df A numeric data frame \code{V} with \code{n}
#'  rows and \code{m} columns, \code{n} being the number of features and
#'  \code{m} being the number of samples
#'@param in_signatures_df A numeric data frame \code{W} with \code{n} rows and
#'  \code{l} columns, \code{n} being the number of features and \code{l} being
#'  the number of signatures
#'@param in_per_sample_cutoff A numeric value less than 1. Signatures from
#'  within \code{W} with an exposure per sample less than \code{in_cutoff} will
#'  be discarded.
#'
#'@return The exposures \code{H}, a numeric data frame with \code{l} rows and
#'  \code{m} columns, \code{l} being the number of signatures and \code{m} being
#'  the number of samples
#'
#'@seealso \code{\link[limSolve]{lsei}}
#'
#' @examples
#'
#' ## define raw data
#' W_prim <- matrix(c(1,2,3,4,5,6),ncol=2)
#' W_prim_df <- as.data.frame(W_prim)
#' W_df <- YAPSA:::normalize_df_per_dim(W_prim_df,2) # corresponds to the sigs
#' W <- as.matrix(W_df)
#' ## 1. Simple case: non-negativity already in raw data
#' H <- matrix(c(2,5,3,6,1,9,1,2),ncol=4)
#' H_df <- as.data.frame(H) # corresponds to the exposures
#' V <- W %*% H # matrix multiplication
#' V_df <- as.data.frame(V) # corresponds to the mutational catalogue
#' exposures_df <- YAPSA:::LCD(V_df,W_df)
#' ## 2. more complicated: raw data already contains negative elements
#' ## define indices where sign is going to be swapped
#' sign_ind <- c(5,7)
#' ## now compute the indices of the other fields in the columns affected
#' ## by the sign change
#' row_ind <- sign_ind %% dim(H)[1]
#' temp_ind <- 2*row_ind -1
#' other_ind <- sign_ind + temp_ind
#' ## alter the matrix H to yield a new mutational catalogue
#' H_compl <- H
#' H_compl[sign_ind] <- (-1)*H[sign_ind]
#' H_compl_df <- as.data.frame(H_compl) # corresponds to the exposures
#' V_compl <- W %*% H_compl # matrix multiplication
#' V_compl_df <- as.data.frame(V_compl) # corresponds to the mutational catalog
#' exposures_df <- YAPSA:::LCD(V_compl_df,W_df)
#' exposures <- as.matrix(exposures_df)
#'
#'@importFrom limSolve lsei
#'
#'@export
#'
LCD <- function(in_mutation_catalogue_df,
                in_signatures_df,
                in_per_sample_cutoff=0){
  signatures_matrix <- as.matrix(in_signatures_df)
  out_exposures_df <- data.frame()
  G <- diag(dim(signatures_matrix)[2])
  H <- rep(0,dim(signatures_matrix)[2])
  for (i in seq_len(ncol(in_mutation_catalogue_df))) {
    temp_fractions <- limSolve::lsei(A = signatures_matrix,
                                     B = in_mutation_catalogue_df[,i],
                                     G=G, H=H, verbose=FALSE)
    temp_exposures_vector <- as.vector(temp_fractions$X)
    # temp_fractions <- lsei::lsei(a = signatures_matrix, 
    #                              b = in_mutation_catalogue_df[,i],
    #                              e=G, f=H)
    # temp_exposures_vector <- round(temp_fractions,digits = 6)
    names(temp_exposures_vector) <- names(in_signatures_df)
    rel_exposures_vector <- temp_exposures_vector/sum(temp_exposures_vector)
    deselect_ind <- which(rel_exposures_vector<in_per_sample_cutoff)
    temp_exposures_vector[deselect_ind] <- 0
    out_exposures_df[seq(1,dim(signatures_matrix)[2],1),i] <- 
      temp_exposures_vector
    rm(temp_fractions)
  }
  colnames(out_exposures_df) <- colnames(in_mutation_catalogue_df)
  rownames(out_exposures_df) <- colnames(in_signatures_df)
  return(out_exposures_df) 
}


#' @importFrom limSolve lsei
#' 
LCD_cutoff <- function(in_mutation_catalogue_df,in_signatures_df,
                       in_cutoff=0.01,in_filename=NULL,
                       in_method="abs",in_convention="weak",
                       in_per_sample_cutoff=0) {
  # first run analysis without cutoff
  if(in_convention=="strict"){
    all_exposures_df <- LCD(in_mutation_catalogue_df,in_signatures_df)
  } else{
    all_exposures_df <- LCD(in_mutation_catalogue_df,
                            in_signatures_df,
                            in_per_sample_cutoff=in_per_sample_cutoff)
  }
  # now apply cutoff criteria to choose the main signatures
  if(in_method=="rel"){
    rel_all_exposures_df <- normalize_df_per_dim(all_exposures_df,2)
    average_rel_exposure_vector <- average_over_present(rel_all_exposures_df,1)
    sig_choice_ind <- which(average_rel_exposure_vector >= in_cutoff)
  } else {
    all_exposures_sum_df <- data.frame(sum=apply(all_exposures_df,1,sum))
    all_exposures_sum_df$sum_norm <- 
      all_exposures_sum_df$sum/sum(all_exposures_sum_df$sum)
    sig_choice_ind <- which(all_exposures_sum_df$sum_norm >= in_cutoff)
    if (!is.null(in_filename)) {
      break_vector <- seq(0,0.5,0.01)
      png(in_filename,width=400,height=400)
      hist(all_exposures_sum_df$sum_norm,breaks=break_vector,
           xlab="exposures per sig",main="Sum over whole cohort")    
      dev.off()
    }
  }
  choice_signatures_df <- in_signatures_df[,sig_choice_ind,drop=FALSE]
  # now rerun the decomposition with only the chosen signatures
  if(in_convention=="strict"){
    #out_exposures_df <- LCD_strict(in_mutation_catalogue_df,
    #                               choice_signatures_df)    
    out_exposures_df <- LCD(in_mutation_catalogue_df,choice_signatures_df)    
  } else{
    out_exposures_df <- LCD(in_mutation_catalogue_df,
                            choice_signatures_df,
                            in_per_sample_cutoff=in_per_sample_cutoff)
  }
  out_exposures_sum_df <- data.frame(sum=apply(out_exposures_df,1,sum))
  out_exposures_sum_df$sum_norm <- 
    out_exposures_sum_df$sum/sum(out_exposures_sum_df$sum)
  exposure_order <- order(out_exposures_sum_df$sum,decreasing=TRUE)
  # compute QC and error measures
  fit_catalogue_df <- as.data.frame(
    as.matrix(choice_signatures_df) %*% as.matrix(out_exposures_df))
  residual_catalogue_df <- in_mutation_catalogue_df - fit_catalogue_df
  rss <- sum(residual_catalogue_df^2)
  cosDist_fit_orig_per_matrix <- cosineDist(in_mutation_catalogue_df,
                                            fit_catalogue_df)
  cosDist_fit_orig_per_col <- rep(0,dim(in_mutation_catalogue_df)[2])
  for(i in dim(in_mutation_catalogue_df)[2]){
    cosDist_fit_orig_per_col[i] <- cosineDist(in_mutation_catalogue_df[,i],
                                              fit_catalogue_df[,i])
  }
  total_counts <- colSums(in_mutation_catalogue_df)
  sum_ind <- rev(order(total_counts))
  return(list(exposures=out_exposures_df,
              signatures=choice_signatures_df,
              choice=sig_choice_ind,
              order=exposure_order,
              residual_catalogue=residual_catalogue_df,
              rss=rss,
              cosDist_fit_orig_per_matrix=cosDist_fit_orig_per_matrix,
              cosDist_fit_orig_per_col=cosDist_fit_orig_per_col,
              sum_ind=sum_ind))
}


#'LCD with a signature-specific cutoff on exposures
#'
#'\code{LCD_cutoff} performs a mutational signatures decomposition by Linear
#'Combination Decomposition (LCD) of a given mutational catalogue \code{V} with
#'known signatures \code{W} by solving the minimization problem \eqn{min(||W*H -
#'V||)} with additional constraints of non-negativity on H where W and V are
#'known, but excludes signatures with an overall contribution less than a given
#'signature-specific cutoff (and thereby accounting for a background model) over
#'the whole cohort.
#'
#'@param in_mutation_catalogue_df A numeric data frame \code{V} with \code{n}
#'  rows and \code{m} columns, \code{n} being the number of features and
#'  \code{m} being the number of samples
#'@param in_signatures_df A numeric data frame \code{W} with \code{n} rows and
#'  \code{l} columns, \code{n} being the number of features and \code{l} being
#'  the number of signatures
#'@param in_cutoff_vector A numeric vector of values less than 1. Signatures
#'  from within \code{W} with an overall exposure less than the respective value
#'  in \code{in_cutoff_vector} will be discarded.
#'@param in_filename A path to generate a histogram of the signature exposures
#'  if non-NULL
#'@param in_method Indicate to which data the cutoff shall be applied: absolute
#'  exposures, relative exposures
#'@param in_per_sample_cutoff A numeric value less than 1. Signatures from
#'  within \code{W} with an exposure per sample less than \code{in_cutoff} will
#'  be discarded.
#'@param in_rescale Boolean, if TRUE (default) the exposures are rescaled such
#'  that colSums over exposures match colSums over mutational catalogue
#'@param in_sig_ind_df Data frame of type signature_indices_df, i.e. indicating
#'  name, function and meta-information of the signatures. Default is NULL.
#'@param in_cat_list List of categories for aggregation. Have to be among the
#'  column names of \code{in_sig_ind_df}. Default is NULL.
#'
#'@return A list with entries: \itemize{ \item \code{exposures}: The exposures
#'  \code{H}, a numeric data frame with \code{l} rows and \code{m} columns,
#'  \code{l} being the number of signatures and \code{m} being the number of
#'  samples \item \code{norm_exposures}: The normalized exposures \code{H}, a
#'  numeric data frame with \code{l} rows and \code{m} columns, \code{l} being
#'  the number of signatures and \code{m} being the number of samples \item
#'  \code{signatures}: The reduced signatures that have exposures bigger than
#'  \code{in_cutoff} \item \code{choice}: Index vector of the reduced signatures
#'  in the input signatures \item \code{order}: Order vector of the signatures
#'  by exposure \item \code{residual_catalogue}: Numerical data frame (matrix)
#'  of the difference between fit (product of signatures and exposures) and
#'  input mutational catalogue \item \code{rss}: Residual sum of squares (i.e.
#'  sum of squares of the residual catalogue) \item
#'  \code{cosDist_fit_orig_per_matrix}: Cosine distance between the fit (product
#'  of signatures and exposures) and input mutational catalogue computed after
#'  putting the matrix into vector format (i.e. one scaler product for the whole
#'  matrix) \item \code{cosDist_fit_orig_per_col}: Cosine distance between the
#'  fit (product of signatures and exposures) and input mutational catalogue
#'  computed per column (i.e. per sample, i.e. as many scaler products as there
#'  are samples in the cohort) \item \code{sum_ind}: Decreasing order of
#'  mutational loads based on the input mutational catalogue \item
#'  \code{out_sig_ind_df}: Data frame of the type \code{signature_indices_df}, 
#'  i.e. indicating name, function and meta-information of the signatures. 
#'  Default is NULL, non-NULL only if \code{in_sig_ind_df} is non-NULL. \item
#'  \code{aggregate_exposures_list}: List of exposure data frames aggregated
#'  over different categories. Default is NULL, non-NULL only if
#'  \code{in_sig_ind_df} and \code{in_cat_list} are non-NULL and if the
#'  categories specified in \code{in_cat_list} are among the column names of
#'  \code{in_sig_ind_df}. }
#'
#'@seealso \code{\link[YAPSA]{LCD}}
#'@seealso \code{\link[YAPSA]{aggregate_exposures_by_category}}
#'@seealso \code{\link[limSolve]{lsei}}
#'
#' @examples
#'  NULL
#'
#'@importFrom limSolve lsei
#'@export
#'
LCD_complex_cutoff <- function(in_mutation_catalogue_df,
                               in_signatures_df,
                               in_cutoff_vector=NULL,
                               in_filename=NULL,
                               in_method="abs",
                               in_per_sample_cutoff=0,
                               in_rescale=TRUE,
                               in_sig_ind_df=NULL,
                               in_cat_list=NULL) {
  # first run analysis without cutoff
  all_exposures_df <- LCD(in_mutation_catalogue_df,
                          in_signatures_df,
                          in_per_sample_cutoff=in_per_sample_cutoff)
  # now apply cutoff criteria to choose the main signatures
  if(in_method=="rel"){
    rel_all_exposures_df <- normalize_df_per_dim(all_exposures_df,2)
    average_rel_exposure_vector <- average_over_present(rel_all_exposures_df,1)
    sig_choice_ind <- which(average_rel_exposure_vector >= in_cutoff_vector &
                              average_rel_exposure_vector > 0)
    if (length(sig_choice_ind) == 0) { 
      #case that can occure in the new set of sigantures 
      return()
    }
  } else {
    all_exposures_sum_df <- data.frame(sum=apply(all_exposures_df,1,sum))
    all_exposures_sum_df$sum_norm <- 
      all_exposures_sum_df$sum/sum(all_exposures_sum_df$sum)
    sig_choice_ind <- which(all_exposures_sum_df$sum_norm >= in_cutoff_vector &
                              all_exposures_sum_df$sum_norm > 0)
    if (length(sig_choice_ind) == 0) {
      #case that can occure in the new set of sigantures 
      return()
    }
    if (!is.null(in_filename)) {
      break_vector <- seq(0,0.5,0.01)
      png(in_filename,width=400,height=400)
      hist(all_exposures_sum_df$sum_norm,breaks=break_vector,
           xlab="exposures per sig",main="Sum over whole cohort")    
      dev.off()
    }
  }
  choice_signatures_df <- in_signatures_df[,sig_choice_ind,drop=FALSE]
  # now rerun the decomposition with only the chosen signatures
  out_exposures_df <- LCD(in_mutation_catalogue_df,
                          choice_signatures_df,
                          in_per_sample_cutoff=in_per_sample_cutoff)
  out_norm_exposures_df <- normalize_df_per_dim(out_exposures_df,2)
  total_counts <- colSums(in_mutation_catalogue_df)
  sum_ind <- rev(order(total_counts))
  if(in_rescale){
    out_exposures_df <- as.data.frame(t(t(out_norm_exposures_df)*total_counts))
  }
  out_exposures_sum_df <- data.frame(sum=apply(out_exposures_df,1,sum))
  out_exposures_sum_df$sum_norm <-
    out_exposures_sum_df$sum/sum(out_exposures_sum_df$sum)
  exposure_order <- order(out_exposures_sum_df$sum,decreasing=TRUE)
  # compute QC and error measures
  fit_catalogue_df <- as.data.frame(
    as.matrix(choice_signatures_df) %*% as.matrix(out_exposures_df))
  residual_catalogue_df <- in_mutation_catalogue_df - fit_catalogue_df
  rss <- sum(residual_catalogue_df^2)
  cosDist_fit_orig_per_matrix <- cosineDist(in_mutation_catalogue_df,
                                            fit_catalogue_df)
  cosDist_fit_orig_per_col <- rep(0,dim(in_mutation_catalogue_df)[2])
  for(i in dim(in_mutation_catalogue_df)[2]){
    cosDist_fit_orig_per_col[i] <- cosineDist(in_mutation_catalogue_df[,i],
                                              fit_catalogue_df[,i])
  }
  out_sig_ind_df <- NULL
  aggregate_exposures_list <- NULL
  if(!is.null(in_sig_ind_df)){
    out_sig_ind_df <- in_sig_ind_df[sig_choice_ind,]
    if(!is.null(in_cat_list)){
      aggregate_exposures_list <- lapply(
        in_cat_list,FUN=function(current_category){
          aggregate_exposures_by_category(
            out_exposures_df,out_sig_ind_df,current_category)
        })   
      names(aggregate_exposures_list) <- in_cat_list
    }
  }
  return(list(exposures=out_exposures_df,
              norm_exposures=out_norm_exposures_df,
              signatures=choice_signatures_df,
              choice=sig_choice_ind,
              order=exposure_order,
              residual_catalogue=residual_catalogue_df,
              rss=rss,
              cosDist_fit_orig_per_matrix=cosDist_fit_orig_per_matrix,
              cosDist_fit_orig_per_col=cosDist_fit_orig_per_col,
              sum_ind=sum_ind,
              out_sig_ind_df=out_sig_ind_df,
              aggregate_exposures_list=aggregate_exposures_list))
}

#' LCD, signature-specific cutoff on exposures, per PID
#'
#'\code{\link[YAPSA]{LCD_complex_cutoff_perPID}} is a wrapper for
#'\code{\link[YAPSA]{LCD_complex_cutoff}} and runs individually for every PID.
#'
#' @export
#' @rdname LCD_complex_cutoff
#' 
LCD_complex_cutoff_perPID <- function(in_mutation_catalogue_df,
                                      in_signatures_df,
                                      in_cutoff_vector=NULL,
                                      in_filename=NULL,
                                      in_method="abs",
                                      in_rescale=TRUE,
                                      in_sig_ind_df=NULL,
                                      in_cat_list=NULL,
                                      minimumNumberOfAlterations=25){
  complex_COSMIC_list_list <- lapply(
    seq_along(in_mutation_catalogue_df), FUN=function(current_col){
      current_mut_cat <- in_mutation_catalogue_df[,current_col,drop=FALSE]
      complex_COSMIC_list <- LCD_complex_cutoff(
        current_mut_cat,
        in_signatures_df,
        in_cutoff_vector=in_cutoff_vector,
        in_filename=NULL,
        in_method=in_method,
        in_rescale=in_rescale)
      return(complex_COSMIC_list)
    })
  exposures_list <- lapply(complex_COSMIC_list_list,FUN=function(x) {
    return(x$exposures)})
  exposures_df <- merge_exposures(exposures_list,
                                  in_signatures_df)
  names_del <- setdiff(colnames(in_mutation_catalogue_df), 
                       colnames(exposures_df)) 
                       #new makes sure that names are the same 
  if(length(names_del)>0){
    temp_df<- data.frame(replicate(length(names_del),
                                   rep(0,dim(exposures_df)[1])))
    colnames(temp_df)<-names_del
    exposures_full_df <- cbind(exposures_df, temp_df)
  }else{
    exposures_full_df<-exposures_df
  }
  norm_exposures_df <- normalize_df_per_dim(exposures_full_df,2)
  
  sig_choice_ind <- match(rownames(exposures_full_df),names(in_signatures_df))
  choice_signatures_df <- in_signatures_df[,sig_choice_ind,drop=FALSE]
  exposure_order <- order(rowSums(exposures_full_df),decreasing=TRUE)
  fit_catalogue_df <- as.data.frame(
    as.matrix(choice_signatures_df) %*% as.matrix(exposures_full_df))
  residual_catalogue_df <- in_mutation_catalogue_df - fit_catalogue_df
  rss <- sum(residual_catalogue_df^2)
  cosDist_fit_orig_per_matrix <- cosineDist(in_mutation_catalogue_df,
                                            fit_catalogue_df)
  cosDist_fit_orig_per_col <- rep(0,dim(in_mutation_catalogue_df)[2])
  for(i in dim(in_mutation_catalogue_df)[2]){
    cosDist_fit_orig_per_col[i] <- cosineDist(in_mutation_catalogue_df[,i],
                                              fit_catalogue_df[,i])
  }
  total_counts <- colSums(in_mutation_catalogue_df)
  sum_ind <- rev(order(total_counts))
  out_sig_ind_df <- NULL
  aggregate_exposures_list <- NULL
  if(!is.null(in_sig_ind_df)){
    out_sig_ind_df <- in_sig_ind_df[sig_choice_ind,]
    if(!is.null(in_cat_list)){
      aggregate_exposures_list <- lapply(
        in_cat_list,FUN=function(current_category){
          aggregate_exposures_by_category(
            exposures_full_df,out_sig_ind_df,current_category)
        })   
      names(aggregate_exposures_list) <- in_cat_list
    }
  }
  # print out warning if minimum number of mutations is not reached!
  mutationalLoad <- colSums(exposures_full_df)
  insufficient_boolean <- mutationalLoad < minimumNumberOfAlterations
  if(any(insufficient_boolean)) 
    warning("Insufficient number of alterations in samples ", 
            paste0(colnames(exposures_full_df)[insufficient_boolean], 
                   collapse = ";"))
  return(list(exposures=exposures_full_df,
              norm_exposures=norm_exposures_df,
              signatures=choice_signatures_df,
              choice=sig_choice_ind,
              order=exposure_order,
              residual_catalogue=residual_catalogue_df,
              rss=rss,
              cosDist_fit_orig_per_matrix=cosDist_fit_orig_per_matrix,
              cosDist_fit_orig_per_col=cosDist_fit_orig_per_col,
              sum_ind=sum_ind,
              out_sig_ind_df=out_sig_ind_df,
              aggregate_exposures_list=aggregate_exposures_list))
}


#' LCD, identify signatures present in cohort but then call them per PID
#'
#'\code{\link[YAPSA]{LCD_extractCohort_callPerPID}} runs
#'\code{\link[YAPSA]{LCD_complex_cutoff}} and takes the identified signatures as 
#'input for \code{\link[YAPSA]{LCD_complex_cutoff_perPID}}.
#'
#'@param cutoff_type If chosen to be "adaptive", the default, then 
#'  signature-specific cutoffs are used for the the per-PID analysis in 
#'  \code{\link[YAPSA]{LCD_extractCohort_callPerPID}}, otherwise, no cutoffs 
#'  are used.
#'  
#' @export
#' @rdname LCD_complex_cutoff
#' 
LCD_extractCohort_callPerPID <- function(in_mutation_catalogue_df,
                                         in_signatures_df,
                                         in_cutoff_vector = NULL,
                                         in_filename = NULL,
                                         in_method = "abs",
                                         in_rescale = TRUE,
                                         in_sig_ind_df = NULL,
                                         in_cat_list = NULL,
                                         in_verbose = FALSE,
                                         minimumNumberOfAlterations = 25,
                                         cutoff_type = "adaptive"){
  ## run cohort-wide analysis
  if(!is.null(in_mutation_catalogue_df) & !is.null(in_signatures_df)){
    my_cohort_LCDlist <- LCD_complex_cutoff(
      in_mutation_catalogue_df,
      in_signatures_df,
      in_cutoff_vector = in_cutoff_vector,
      in_filename = in_filename,
      in_method = in_method,
      in_rescale = in_rescale,
      in_sig_ind_df = in_sig_ind_df,
      in_cat_list = in_cat_list) 
  } else {
    if(in_verbose) cat("YAPSA:::LCD_complex_cutoff_combined::error:",
                       "neither in_cohort_LCDlist nor sufficient input ",
                       "provided. Abort. \n")
    return(NULL)
  }
  ## run per PID analysis but with only those signatures which have been
  ## identified in the cohort-wide analysis
  if(cutoff_type == "adaptive" & !is.null(names(in_cutoff_vector)))
    my_cutoff_vector <- in_cutoff_vector[names(my_cohort_LCDlist$signatures)]
  else
    my_cutoff_vector <- rep(0, ncol(my_cohort_LCDlist$signatures))
  out_perPID_LCDlist <- LCD_complex_cutoff_perPID(
    in_mutation_catalogue_df,
    my_cohort_LCDlist$signatures,
    in_cutoff_vector = my_cutoff_vector,
    in_filename = in_filename,
    in_method = in_method,
    in_rescale = in_rescale,
    in_sig_ind_df = my_cohort_LCDlist$out_sig_ind_df,
    in_cat_list = in_cat_list,
    minimumNumberOfAlterations = minimumNumberOfAlterations) 
  return(out_perPID_LCDlist)
}


#'LCD, consensus between cohort-wide AND per-PID extraction
#'
#'\code{\link[YAPSA]{LCD_complex_cutoff_consensus}} calls
#'\code{\link[YAPSA]{LCD_complex_cutoff_combined}} AND
#'\code{\link[YAPSA]{LCD_complex_cutoff_perPID}} and makes a consensus
#'signature call set.
#'
#'@param in_cohort_LCDlist Optional, if not provided, the cohort-wide exposures
#'  are recalculated by calling \code{\link[YAPSA]{LCD_complex_cutoff}}
#'@param in_perPID_LCDlist Optional, if not provided, the per sample exposures
#'  are recalculated by calling \code{\link[YAPSA]{LCD_complex_cutoff_perPID}}
#'@param addSigs_cohort_cutoff Numeric value for a cutoff: signatures which are
#'  detected in a fraction of the samples of the cohort greater than this cutoff
#'  are kept for the consensus set of signatures
#'@param addSigs_perPID_cutoff Numeric value for a cutoff: signatures which are
#'  detected in one sample with exposure greater than this cutoff are kept for
#'  the consensus set of signatures
#'@param addSigs_relAbs_cutoff Numeric value for a cutoff: signatures which are
#'  detected with at least this fraction of all variants cohort wide are kept
#'  for the consensus set of signatures
#'@param keep.unassigned Boolean, if TRUE the exposures from the signatures
#'  which don't fulfill the criteria to be kept will be added and stored in the
#'  exposures as "unassigned", otherwise the exposures are rescaled.
#'@param keep.all.cohort.sigs If TRUE (default), all signatures extracted cohort
#'  wide are kept, if FALSE, the function reevaluates whether the signatures
#'  extracted cohort wide still fulfill their criteria (i.e. exposures > cutoff)
#'  after perPID extraction.
#'@param in_verbose Verbose if \code{in_verbose=1}
#'@param minimumNumberOfAlterations The perPID part of the analysis issues a
#'  warning if one sample has less mutations than this minimum cutoff.
#'
#'@export
#'@rdname LCD_complex_cutoff
#'  
LCD_complex_cutoff_consensus <- function(in_mutation_catalogue_df = NULL,
                                         in_signatures_df = NULL,
                                         in_cutoff_vector = NULL,
                                         in_filename = NULL,
                                         in_method = "abs",
                                         in_rescale = TRUE,
                                         in_sig_ind_df = NULL,
                                         in_cat_list = NULL,
                                         in_cohort_LCDlist = NULL,
                                         in_perPID_LCDlist = NULL,
                                         addSigs_cohort_cutoff = 0.25,
                                         addSigs_perPID_cutoff = 0.25,
                                         addSigs_relAbs_cutoff = 0.01,
                                         keep.unassigned = FALSE,
                                         keep.all.cohort.sigs = TRUE,
                                         in_verbose = FALSE,
                                         minimumNumberOfAlterations = 25){
  ## run cohort-wide analysis
  if(is.null(in_cohort_LCDlist)){
    if(!is.null(in_mutation_catalogue_df) & !is.null(in_signatures_df)){
      in_cohort_LCDlist <- LCD_complex_cutoff(
        in_mutation_catalogue_df,
        in_signatures_df,
        in_cutoff_vector = in_cutoff_vector,
        in_filename = in_filename,
        in_method = in_method,
        in_rescale = in_rescale,
        in_sig_ind_df = in_sig_ind_df,
        in_cat_list = in_cat_list) 
    } else {
      if(in_verbose) cat("YAPSA:::LCD_complex_cutoff_combined::error:",
                         "neither in_cohort_LCDlist nor sufficient input ",
                         "provided. Abort. \n")
      return(NULL)
    }
  }
  ## run per PID analysis
  if(is.null(in_perPID_LCDlist)){
    if(!is.null(in_mutation_catalogue_df) & !is.null(in_signatures_df)){
      in_perPID_LCDlist <- LCD_complex_cutoff_perPID(
        in_mutation_catalogue_df,
        in_signatures_df,
        in_cutoff_vector = in_cutoff_vector,
        in_filename = in_filename,
        in_method = in_method,
        in_rescale = in_rescale,
        in_sig_ind_df = in_sig_ind_df,
        in_cat_list = in_cat_list,
        minimumNumberOfAlterations = minimumNumberOfAlterations) 
    } else {
      if(in_verbose) cat("YAPSA:::LCD_complex_cutoff_combined::error:",
                         "neither in_perPID_LCDlist nor sufficient input ",
                         "provided. Abort. \n")
      return(NULL)
    }
  }
  ## initialize output
  out_LCDlist <- in_perPID_LCDlist
  ## determine signatures to be removed
  if(!keep.all.cohort.sigs){
    cohortMatch_sigs <- intersect(in_cohort_LCDlist$out_sig_ind_df$sig,
                                  in_perPID_LCDlist$out_sig_ind_df$sig)
    cohortMatch_ind <- match(cohortMatch_sigs, in_sig_ind_df$sig)
    cohortMatch_CumulExpo_abs <- 
      rowSums(in_perPID_LCDlist$exposures[cohortMatch_sigs,])
    cohortMatch_CumulExpo_rel <- 
      cohortMatch_CumulExpo_abs / sum(in_perPID_LCDlist$exposures)
    select_ind <- cohortMatch_CumulExpo_rel >= in_cutoff_vector[cohortMatch_ind]
    keep_sigs <- cohortMatch_sigs[select_ind]
    keep_ind <- sort(match(keep_sigs, names(in_signatures_df)))
  }
  ## determine signatures to be added
  absExposures_sumVector <- rowSums(in_perPID_LCDlist$exposures)
  relAbsExposures_sumVector <- 
    absExposures_sumVector/sum(absExposures_sumVector)
  # addSigs_relAbs <- 
  #   names(which(relAbsExposures_sumVector > 
  #            median(relAbsExposures_sumVector)))
  addSigs_relAbs <- 
    names(which(relAbsExposures_sumVector > addSigs_relAbs_cutoff))
  # absExposures_maxVector <- apply(in_perPID_LCDlist$exposures, 1, max)
  normExposures_maxVector <- 
    apply(in_perPID_LCDlist$norm_exposures, 1, max)
  temp_df <- in_perPID_LCDlist$exposures
  temp_df[temp_df > 0] <- 1
  affected_PIDnumVector <- apply(temp_df, 1, sum)
  rel_affected_PIDnumVector <- 
    affected_PIDnumVector/dim(in_perPID_LCDlist$exposures)[2]
  addSigs_cohort <- 
    names(which(rel_affected_PIDnumVector > addSigs_cohort_cutoff))
  addSigs_perPID <- 
    names(which(normExposures_maxVector > addSigs_perPID_cutoff))
  addSigs <- 
    Reduce(union, list(addSigs_relAbs, addSigs_cohort, addSigs_perPID))
  add_ind <- sort(match(addSigs, names(in_signatures_df)))
  # relExposures_maxVector <- absExposures_maxVector/
  #    sum(absExposures_sumVector)
  # addSigs <- names(which(relExposures_maxVector > 
  #    median(relExposures_maxVector)))
  # addSigs <- names(which(normExposures_maxVector > 
  #    median(normExposures_maxVector)))
  # add_ind <- match(addSigs, names(in_signatures_df))
  # combined_cutoff <- 0.015
  # temp_cutoff_vector <- 
  #   sapply(CosmicValid_cutoffAbs_vector[names(relExposures_sumVector)],
  #          min, combined_cutoff)
  # choice_ind <- which(relExposures_sumVector >= temp_cutoff_vector)
  if(!keep.all.cohort.sigs){
    choice_ind <- sort(unique(c(keep_ind, add_ind)))
  } else {
    choice_ind <- sort(unique(c(in_cohort_LCDlist$choice, add_ind)))
  }
  out_LCDlist$choice <- choice_ind
  choice_sigs <- names(in_signatures_df)[choice_ind]
  # sig_choice_ind <- which(AlexCosmicValid_sigInd_df$sig %in% 
  #    names(choice_ind))
  # in_sig_ind_df <- AlexCosmicValid_sigInd_df[sig_choice_ind,]
  # current_cutoff_vector <- CosmicValid_cutoffAbs_vector[sig_choice_ind]
  # current_caption <- paste0("Signatures with cohort-wide exposures > ",
  #                           "combined_cutoff")
  # run_chunk(chunk_LCD_complex_cutoff_perPID)
  # out_LCDlist <- current_LCDlist
  ##  adapt output
  choice_exposures_df <- in_perPID_LCDlist$exposures[choice_sigs,]
  if(keep.unassigned){
    unassigned_vector <- colSums(in_perPID_LCDlist$exposures) - 
      colSums(choice_exposures_df)
    choice_exposures_df <- rbind(choice_exposures_df,unassigned_vector)
    rownames(choice_exposures_df)[dim(choice_exposures_df)[1]] <- "unassigned"
    out_LCDlist$exposures <- choice_exposures_df
    out_LCDlist$norm_exposures <- 
      normalize_df_per_dim(out_LCDlist$exposures, 2)
    out_LCDlist$out_sig_ind_df <- 
      in_sig_ind_df[c(choice_ind, dim(in_sig_ind_df)[1]),]
  } else {
    out_LCDlist$norm_exposures <- normalize_df_per_dim(choice_exposures_df, 2)
    total_counts <- colSums(in_mutation_catalogue_df)
    out_LCDlist$exposures <- 
      as.data.frame(t(t(out_LCDlist$norm_exposures)*total_counts))
    out_LCDlist$out_sig_ind_df <- in_sig_ind_df[choice_ind,]
  }
  out_LCDlist$signatures <- 
    in_signatures_df[,choice_sigs]
  return(out_LCDlist)
}


#' LCD, wrapper for cohort-wide, per-PID AND consensus extraction
#'
#'\code{\link[YAPSA]{LCD_complex_cutoff_combined}} is a wrapper for
#'\code{\link[YAPSA]{LCD_complex_cutoff}},
#'\code{\link[YAPSA]{LCD_complex_cutoff_perPID}},
#'\code{\link[YAPSA]{LCD_complex_cutoff_consensus}} AND
#'\code{\link[YAPSA]{LCD_extractCohort_callPerPID}}.
#'
#' @export
#' @rdname LCD_complex_cutoff
#' 
LCD_complex_cutoff_combined <- function(in_mutation_catalogue_df = NULL,
                                        in_signatures_df = NULL,
                                        in_cutoff_vector = NULL,
                                        in_filename = NULL,
                                        in_method = "abs",
                                        in_rescale = TRUE,
                                        in_sig_ind_df = NULL,
                                        in_cat_list = NULL,
                                        addSigs_cohort_cutoff = 0.25,
                                        addSigs_perPID_cutoff = 0.25,
                                        addSigs_relAbs_cutoff = 0.01,
                                        keep.all.cohort.sigs = TRUE,
                                        in_verbose = FALSE,
                                        minimumNumberOfAlterations = 25,
                                        cutoff_type = "adaptive"){
  cohort_LCDlist <- LCD_complex_cutoff(
    in_mutation_catalogue_df,
    in_signatures_df,
    in_cutoff_vector = in_cutoff_vector,
    in_filename = in_filename,
    in_method = in_method,
    in_rescale = in_rescale,
    in_sig_ind_df = in_sig_ind_df,
    in_cat_list = in_cat_list)
  perPID_LCDlist <- LCD_complex_cutoff_perPID(
    in_mutation_catalogue_df,
    in_signatures_df,
    in_cutoff_vector = in_cutoff_vector,
    in_filename = in_filename,
    in_method = in_method,
    in_rescale = in_rescale,
    in_sig_ind_df = in_sig_ind_df,
    in_cat_list = in_cat_list,
    minimumNumberOfAlterations = minimumNumberOfAlterations) 
  consensus_LCDlist <- LCD_complex_cutoff_consensus(
    in_mutation_catalogue_df = in_mutation_catalogue_df,
    in_signatures_df = in_signatures_df,
    in_sig_ind_df = in_sig_ind_df,
    in_cohort_LCDlist = cohort_LCDlist,
    in_perPID_LCDlist = perPID_LCDlist,
    addSigs_cohort_cutoff = addSigs_cohort_cutoff,
    addSigs_perPID_cutoff = addSigs_perPID_cutoff,
    addSigs_relAbs_cutoff = addSigs_relAbs_cutoff,
    keep.unassigned = TRUE,
    keep.all.cohort.sigs = keep.all.cohort.sigs,
    minimumNumberOfAlterations = minimumNumberOfAlterations)
  consensusRescale_LCDlist <- LCD_complex_cutoff_consensus(
    in_mutation_catalogue_df = in_mutation_catalogue_df,
    in_signatures_df = in_signatures_df,
    in_sig_ind_df = in_sig_ind_df,
    in_cohort_LCDlist = cohort_LCDlist,
    in_perPID_LCDlist = perPID_LCDlist,
    addSigs_cohort_cutoff = addSigs_cohort_cutoff,
    addSigs_perPID_cutoff = addSigs_perPID_cutoff,
    addSigs_relAbs_cutoff = addSigs_relAbs_cutoff,
    keep.unassigned = FALSE,
    keep.all.cohort.sigs = keep.all.cohort.sigs,
    minimumNumberOfAlterations = minimumNumberOfAlterations)
  extractCohort_callPerPID_LCDlist <- LCD_extractCohort_callPerPID(
    in_mutation_catalogue_df,
    in_signatures_df,
    in_cutoff_vector = in_cutoff_vector,
    in_filename = in_filename,
    in_method = in_method,
    in_rescale = in_rescale,
    in_sig_ind_df = in_sig_ind_df,
    in_cat_list = in_cat_list,
    minimumNumberOfAlterations = minimumNumberOfAlterations,
    cutoff_type = cutoff_type) 
  return(list(cohort = cohort_LCDlist,
              perPID = perPID_LCDlist,
              consensus = consensus_LCDlist,
              consensusRescale = consensusRescale_LCDlist,
              extractCohort_callPerPID = extractCohort_callPerPID_LCDlist))
}


res <- function(x,b,in_matrix){
  b - in_matrix %*% x
}


norm_res <- function(x,b,in_matrix){
  norm(as.matrix(b - in_matrix %*% x),"F")
}



#' CD stratification analysis
#'
#' @param in_mutation_sub_catalogue_list A list of \code{s} stratified
#'   mutational catalogues \code{Vi} \(numeric data frames\) with \code{n} rows
#'   and \code{m} columns each, \code{n} being the number of features and
#'   \code{m} being the number of samples. This list is naturally provided in
#'   \code{\link{run_SMC}}.
#' @param in_signatures_df A numeric data frame \code{W} with \code{n} rows and
#'   \code{l} columns, \code{n} being the number of features and \code{l} being
#'   the number of signatures
#' @param in_F_df Default NULL
#'
#' @return Returns a list with all exposures and the stratified ones
#'
#' @importFrom limSolve lsei
#'   
LCD_SMC <- function(in_mutation_sub_catalogue_list,
                    in_signatures_df,in_F_df=NULL){
  ## find general properties
  number_of_strata <- length(in_mutation_sub_catalogue_list)
  number_of_sigs <- dim(in_signatures_df)[2]
  number_of_PIDs <- dim(in_mutation_sub_catalogue_list[[1]])[2]
  number_of_features <- dim(in_mutation_sub_catalogue_list[[1]])[1]
  ## 1. construct composite signatures_matrix
  signatures_matrix_element <- as.matrix(in_signatures_df)
  zero_element <- matrix(
    rep(0,dim(signatures_matrix_element)[1]*dim(signatures_matrix_element)[2]),
    ncol=dim(signatures_matrix_element)[2])
  temp_matrix <- NULL
  for (i in seq_len(number_of_strata)) {
    temp_row <- NULL
    for (j in seq_len(number_of_strata)) {
      if (i==j) {
        temp_row <- cbind(temp_row,signatures_matrix_element)
      } else {
        temp_row <- cbind(temp_row,zero_element)
      }
    }
    temp_matrix <- rbind(temp_matrix,temp_row)
  }
  signatures_matrix <- temp_matrix
  ## 2. construct composite mutation catalogue
  temp_matrix <- NULL
  for (i in seq_len(number_of_strata)) {
    temp_matrix <- rbind(temp_matrix,in_mutation_sub_catalogue_list[[i]])
  }
  pasted_mutation_catalogue_df <- temp_matrix
  ## 3. account for boundary conditions
  ## 3.a) account for equality boundary condition
  if (!is.null(in_F_df)) {
    # This condition is fulfilled when an exposures file has been supplied.
    F_df <- in_F_df
  } else {
    # This is the standard case when no exposures file has been supplied and 
    # the exposures have to be computed by LCD.
    sum_df <- data.frame(matrix(rep(0,number_of_PIDs*number_of_features),
                                ncol=number_of_PIDs))
    for (i in seq_len(number_of_strata)) {
      sum_df <- sum_df + in_mutation_sub_catalogue_list[[i]]
    }
    all_mutation_catalogue_df <- sum_df
    F_df <- LCD(all_mutation_catalogue_df,in_signatures_df)    
  }
  diagonal_element <- diag(number_of_sigs)
  temp_matrix <- NULL
  for (i in seq_len(number_of_strata)) {
    temp_matrix <- cbind(temp_matrix,diagonal_element)
  }
  E <- temp_matrix
  ## 3.b) account for inequality boundary condition
  G <- diag(dim(signatures_matrix)[2])
  H <- rep(0,dim(signatures_matrix)[2])
  out_exposures_df <- data.frame()
  for (i in seq_len(ncol(pasted_mutation_catalogue_df))) {
    temp_fractions <- limSolve::lsei(A = signatures_matrix,
                                     B = pasted_mutation_catalogue_df[,i],
                                     E=E, F=F_df[,i], G=G, H=H)
    # temp_fractions <- lsei::lsei(a = signatures_matrix, 
    #                              b = pasted_mutation_catalogue_df[,i], 
    #                              c=E, d=F_df[,i], e=G, f=H)
    # temp_exposures_vector <- round(temp_fractions,digits = 6)
    # names(temp_exposures_vector) <- names(in_signatures_df)
    out_exposures_df[seq(1,dim(signatures_matrix)[2],1),i] <- 
      as.vector(temp_fractions$X)
      # as.vector(temp_exposures_vector)
    rm(temp_fractions)
  }
  out_list <- list()
  for (i in seq_len(number_of_strata)) {
    out_list[[i]] <- as.data.frame(
      out_exposures_df[seq((number_of_sigs*(i-1)+1),(number_of_sigs*i),1),])
    colnames(out_list[[i]]) <- colnames(in_mutation_sub_catalogue_list[[1]])
    rownames(out_list[[i]]) <- colnames(in_signatures_df)
  }
  colnames(F_df) <- colnames(in_mutation_sub_catalogue_list[[1]])
  rownames(F_df) <- colnames(in_signatures_df)
  return(list(exposures_all_df=F_df,sub_exposures_list=out_list))
}

test_that(paste0("Test LCD (linear combination decomposition) ",
                 "with small hand made data frames"), {
  ## define raw data
  W_prim <- matrix(c(1,2,3,4,5,6),ncol=2) 
  W_prim_df <- as.data.frame(W_prim)
  W_df <- YAPSA:::normalize_df_per_dim(W_prim_df,2) # corresponds to the sigs
  W <- as.matrix(W_df) 

  ## 1. Simple case: non-negativity already in raw data
  H <- matrix(c(2,5,3,6,1,9,1,2),ncol=4)
  H_df <- as.data.frame(H) # corresponds to the exposures
  V <- W %*% H # matrix multiplication
  V_df <- as.data.frame(V) # corresponds to the mutational catalogue
  ## apply function to be tested
  exposures_df <- YAPSA:::LCD(V_df,W_df)
  ## compare
  expect_lt(max(abs(exposures_df - H_df)),1e-05)
  
  ## 2. more complicated: raw data already contains negative elements
  ## define indices where sign is going to be swapped
  sign_ind <- c(5,7)
  ## now compute the indices of the other fields in the columns affected
  ## by the sign change
  row_ind <- sign_ind %% dim(H)[1]
  temp_ind <- 2*row_ind -1
  other_ind <- sign_ind + temp_ind
  ## alter the matrix H to yield a new mutational catalogue
  H_compl <- H
  H_compl[sign_ind] <- (-1)*H[sign_ind]
  H_compl_df <- as.data.frame(H_compl) # corresponds to the exposures
  V_compl <- W %*% H_compl # matrix multiplication
  V_compl_df <- as.data.frame(V_compl) # corresponds to the mutational catalog
  ## apply function to be tested
  exposures_df <- YAPSA:::LCD(V_compl_df,W_df)
  exposures <- as.matrix(exposures_df)
  test_df <- rep(0,length(sign_ind))
  expect_that(exposures[sign_ind], is_identical_to(test_df))
  expect_true(all(exposures[other_ind]<H_compl[other_ind]))
})

test_that("Test LCD_cutoff with small hand made data frames", {
  ## define raw data
  W_prim <- matrix(c(1,2,3,4,5,6),ncol=2) 
  W_prim_df <- as.data.frame(W_prim)
  W_df <- YAPSA:::normalize_df_per_dim(W_prim_df,2) # corresponds to the sigs
  W <- as.matrix(W_df) 
  H <- matrix(c(2,5,3,6,1,9,1,2),ncol=4)
  H_df <- as.data.frame(H) # corresponds to the exposures
  V <- W %*% H # matrix multiplication
  V_df <- as.data.frame(V) # corresponds to the mutational catalog
  ## apply function to be tested
  exposures_small_cutoff_list <- YAPSA:::LCD_cutoff(V_df,W_df,in_cutoff = 0.05)
  exposures_big_cutoff_list <- YAPSA:::LCD_cutoff(V_df,W_df,in_cutoff = 0.4)
  ## compare
  expect_lt(max(abs(exposures_small_cutoff_list$exposures - H_df)),1e-05)
  expect_equal(dim(exposures_big_cutoff_list$exposures)[1], dim(H_df)[1] - 1)
})

test_that("Test LCD_SMC with small hand made data frames", {
  ## define raw data
  W_prim <- matrix(c(1,2,3,4,5,6),ncol=2) 
  W_prim_df <- as.data.frame(W_prim)
  W_df <- YAPSA:::normalize_df_per_dim(W_prim_df,2) # corresponds to the sigs
  W <- as.matrix(W_df) 
  H <- matrix(c(2,5,3,6,1,9,1,2),ncol=4)
  ## define indices where sign is going to be swapped for 
  ## different strata (perturbation)
  sign_ind_1 <- c(5,7)
  sign_ind_2 <- c(1)
  ## compute the column-wise index complements for the different strata 
  ## for later use
  col_ind_1 <- sign_ind_1 %/% dim(H)[1]
  other_col_ind_1 <- setdiff(c(0:(dim(H)[2]-1)),col_ind_1)
  other_ind_1 <- rep(other_col_ind_1*dim(H)[1],each=dim(H)[1]) + 
    rep(seq_len(dim(H)[1]),length(other_col_ind_1))
  col_ind_2 <- sign_ind_2 %/% dim(H)[1]
  other_col_ind_2 <- setdiff(c(0:(dim(H)[2]-1)),col_ind_2)
  other_ind_2 <- rep(other_col_ind_2*dim(H)[1],each=dim(H)[1]) + 
    rep(seq_len(dim(H)[1]),length(other_col_ind_2))
  ## alter the matrix H to yield a new mutational catalogue for 
  ## every stratum (perturbation)
  H_1 <- H
  H_2 <- H
  H_1[sign_ind_1] <- (-1)*H[sign_ind_1]
  H_2[sign_ind_2] <- (-1)*H[sign_ind_2]
  H_1_df <- as.data.frame(H_1)
  H_2_df <- as.data.frame(H_2)
  V_1 <- W %*% H_1 # matrix multiplication
  V_2 <- W %*% H_2 # matrix multiplication
  V <- V_1 + V_2
  V_1_df <- as.data.frame(V_1) # mutational catalog of stratum 1
  V_2_df <- as.data.frame(V_2) # mutational catalog of stratum 2
  V_df <- as.data.frame(V) # mutational catalog of the whole cohort
  V_list <- list()  # make list of data frames
  V_list[[1]] <- V_1_df
  V_list[[2]] <- V_2_df
  ## apply function to be tested
  exposures_strata_list <- YAPSA:::LCD_SMC(V_list,W_df)
  ## compare
  simple_exposures_all_df <- YAPSA:::LCD(V_df,W_df)
  simple_exposures_1_df <- YAPSA:::LCD(V_1_df,W_df)
  simple_exposures_1 <- as.matrix(simple_exposures_1_df)
  simple_exposures_2_df <- YAPSA:::LCD(V_2_df,W_df)
  simple_exposures_2 <- as.matrix(simple_exposures_2_df)
  ## check if the overall decomposition is equal to the result of 
  ## the normal LCD
  expect_that(exposures_strata_list$exposures_all_df, 
              is_identical_to(simple_exposures_all_df))
  ## check if the sum of the exposures of the strata equals 
  ## the result of the normal LCD
  expect_equal(exposures_strata_list$sub_exposures_list[[1]] +
                exposures_strata_list$sub_exposures_list[[2]],
              simple_exposures_all_df)
  ## check if the positions not affected by the perturbation remain the same
  # comp_exposures_1_df <- exposures_strata_list$sub_exposures_list[[1]]
  # comp_exposures_1_sub_df <- comp_exposures_1_df[,other_col_ind_2+1]
  # simple_exposures_1_sub_df <- simple_exposures_1_df[,other_col_ind_2+1]
  # expect_lt(max(abs(comp_exposures_1_sub_df - 
  #   simple_exposures_1_sub_df)),1e-05)
  # comp_exposures_2_df <- exposures_strata_list$sub_exposures_list[[2]]
  # comp_exposures_2_sub_df <- comp_exposures_2_df[,other_col_ind_1+1]
  # simple_exposures_2_sub_df <- simple_exposures_2_df[,other_col_ind_1+1]
  # expect_lt(max(abs(comp_exposures_2_sub_df - 
  #   simple_exposures_2_sub_df)),1e-05)
})

# Copyright © 2014-2019  The YAPSA package contributors
# This file is part of the YAPSA package. The YAPSA package is licenced under
# GPL-3

#' Group strata from different stratification axes
#'
#' For a comparison of the strata from different orthogonal stratification axes,
#' i.e. othogonal SMCs, the strata have to be grouped and reformatted. This
#' function does this task for the comparison by cosine similarity of signature
#' exposures. Output of this function is the basis for applying
#' \code{\link{plot_strata}} and \code{\link{make_comparison_matrix}}. It is
#' called by the wrapper functions \code{\link{compare_SMCs}},
#' \code{\link{run_plot_strata_general}} or
#' \code{\link{run_comparison_general}}.
#'
#' @param in_stratification_lists_list List of lists with entries from different
#'   (orthogonal) stratification axes or SMCs
#' @param in_remove_signature_ind Omit one of the signatures in
#'   \code{in_signatures_ind_df} for the comparison if non-NULL. The parameter
#'   specifies the index of the signature to be removed.
#' @param in_additional_stratum Include an additionally supplied stratum in
#'   comparison in non-NULL.
#'
#' @return A list with entries \code{strata_df}, \code{number_of_SMCs},
#'   \code{number_of_strata}. \itemize{ \item \code{strata_df}: Pasted numerical
#'   data frame of all strata (these are going to be compared e.g. by
#'   \code{\link{make_comparison_matrix}}). \item \code{number_of_SMCs}: Number
#'   of orthogonal stratifications in \code{in_stratification_lists_list} and
#'   additional ones. \item \code{number_of_strata}: Cumulative number of strata
#'   (sum over the numbers of strata of the different stratifications in
#'   \code{in_stratification_lists_list}) and additional ones. }
#'
#' @examples
#'  NULL
#'
#' @seealso \code{\link{plot_strata}}
#' @seealso \code{\link{make_comparison_matrix}}
#' @seealso \code{\link{compare_SMCs}}
#' @seealso \code{\link{run_plot_strata_general}}
#' @seealso \code{\link{run_comparison_general}}
#'
#' @export
#' 
make_strata_df <- function(in_stratification_lists_list,
                            in_remove_signature_ind=NULL,
                            in_additional_stratum=NULL) {
    my_number_of_signatures <- 
        dim(in_stratification_lists_list[[1]]$cohort[[1]])[1]
    my_SMCs <- names(in_stratification_lists_list)
    my_strata <- c()
    for(SMC in my_SMCs) {
        temp_strata_names <- 
            paste0(SMC,"_",
                    unlist(in_stratification_lists_list[[SMC]]$name_list))
        temp_all <- paste0(SMC,"_all")
        my_strata <- c(my_strata,temp_all,temp_strata_names)
    }
    out_strata_df <- repeat_df(0,my_number_of_signatures,length(my_strata))
    stratum_counter <- 0
    SMC_counter <- 0
    my_number_of_strata <- c()
    for(SMC in my_SMCs) {
        SMC_counter <- SMC_counter + 1
        my_number_of_strata[SMC_counter] <- 
            length(in_stratification_lists_list[[SMC]]$cohort)
    for(stratum in seq_len(my_number_of_strata[SMC_counter])) {
        stratum_counter <- stratum_counter + 1
        temp_df <- in_stratification_lists_list[[SMC]]$cohort[[stratum]]
        out_strata_df[,stratum_counter] <- temp_df$exposure
        names(out_strata_df)[stratum_counter] <- my_strata[stratum_counter]
        }
    }
    rownames(out_strata_df) <- paste0("S",rownames(out_strata_df))
    my_number_of_SMCs <- length(my_SMCs)
    if(!(is.null(in_remove_signature_ind))) {
        out_strata_df <- out_strata_df[(-1)*in_remove_signature_ind,]
    }
    if(!(is.null(in_additional_stratum))) {
        out_strata_df$compare <- in_additional_stratum
        my_number_of_SMCs <- my_number_of_SMCs+1
        my_number_of_strata <- c(my_number_of_strata,1)
    }
    return(list(strata_df=out_strata_df,
                number_of_SMCs=my_number_of_SMCs,
                number_of_strata=my_number_of_strata))
}


#' Group strata from different stratification axes
#'
#' For a comparison of the strata from different orthogonal stratification axes,
#' i.e. othogonal SMCs, the strata have to be grouped and reformatted. This
#' function does this task for the comparison by cosine similarity of mutational
#' catalogues. Output of this function is the basis for applying
#' \code{\link{make_comparison_matrix}}. It is called by the wrapper function
#' \code{\link{run_comparison_catalogues}}.
#'
#' @param in_stratification_lists_list List of lists with entries from different
#'   (orthogonal) stratification axes or SMCs
#' @param in_additional_stratum Include an additionally supplied stratum in
#'   comparison in non-NULL.
#'
#' @return A list with entries \code{strata_df}, \code{number_of_SMCs},
#'   \code{number_of_strata}. \itemize{ \item \code{strata_df}: Pasted numerical
#'   data frame of all strata (these are going to be compared e.g. by
#'   \code{\link{make_comparison_matrix}}). \item \code{number_of_SMCs}: Number
#'   of orthogonal stratifications in \code{in_stratification_lists_list} and
#'   additional ones. \item \code{number_of_strata}: Cumulative number of strata
#'   (sum over the numbers of strata of the different stratifications in
#'   \code{in_stratification_lists_list}) and additional ones. }
#'
#' @examples
#'  NULL
#'
#' @seealso \code{\link{plot_strata}}
#' @seealso \code{\link{make_comparison_matrix}}
#' @seealso \code{\link{run_comparison_catalogues}}
#'
#' @export
#' 
make_catalogue_strata_df <- function(in_stratification_lists_list,
                                    in_additional_stratum=NULL) {
    my_number_of_PIDs <- 
        dim(in_stratification_lists_list[[1]]$catalogues_list[[1]])[2]
    my_number_of_features <- 
        dim(in_stratification_lists_list[[1]]$catalogues_list[[1]])[1]
    my_SMCs <- names(in_stratification_lists_list)
    my_strata <- c()
    ## normalize the catalogues
    normalized_catalogues_lists_list <- list()
    for(SMC in my_SMCs) {
        temp_strata_names <- 
            paste0(SMC,"_",
                    unlist(in_stratification_lists_list[[SMC]]$name_list))
        temp_all <- paste0(SMC,"_all")
        my_strata <- c(my_strata,temp_all,temp_strata_names)
        my_catalogues_list <- 
                    in_stratification_lists_list[[SMC]]$catalogues_list
        sum_catalogue <- sum_over_list_of_df(my_catalogues_list)
        temp_length <- length(my_catalogues_list)
        my_catalogues_list[[temp_length+1]] <- sum_catalogue
        permut_ind <- c(temp_length+1,seq_len(temp_length))
        this_catalogues_list <- my_catalogues_list[permut_ind]
        normalized_catalogues_lists_list[[SMC]] <- 
            base::lapply(this_catalogues_list,
                function(l) normalize_df_per_dim(l,2))
    }
    out_strata_df <- repeat_df(0,my_number_of_features,length(my_strata))
    stratum_counter <- 0
    SMC_counter <- 0
    my_number_of_strata <- c()
    for(SMC in my_SMCs) {
        SMC_counter <- SMC_counter + 1
        my_number_of_strata[SMC_counter] <- 
            length(in_stratification_lists_list[[SMC]]$cohort)
        for(stratum in seq_len(my_number_of_strata[SMC_counter])) {
            stratum_counter <- stratum_counter + 1
            temp_df <- normalized_catalogues_lists_list[[SMC]][[stratum]]
            out_strata_df[,stratum_counter] <- average_over_present(temp_df,1)
            names(out_strata_df)[stratum_counter] <- my_strata[stratum_counter]
        }
    }
    rownames(out_strata_df) <- 
        rownames(in_stratification_lists_list[[1]]$catalogues_list[[1]])
    my_number_of_SMCs <- length(my_SMCs)
    if(!(is.null(in_additional_stratum))) {
        out_strata_df$compare <- in_additional_stratum
        my_number_of_SMCs <- my_number_of_SMCs+1
        my_number_of_strata <- c(my_number_of_strata,1)
    }
    return(list(strata_df=out_strata_df,
                number_of_SMCs=my_number_of_SMCs,
                number_of_strata=my_number_of_strata))
}


#' Plot all strata from different stratification axes together
#'
#' Plot the cohort wide signature exposures of all strata from different
#' stratification axes together. Naturally called by \code{\link{compare_SMCs}}.
#'
#' @param in_strata_list Data structure created by \code{make_strata_df} or
#'   \code{make_catalogue_strata_df} in which the strata from different
#'   orthogonal stratification axes are reorganized in a consistent structure.
#' @param in_signatures_ind_df A data frame containing meta information about
#'   the signatures
#' @param output_path Path to directory where the results, especially the figure
#'   produced, are going to be stored.
#' @param in_attribute Additional string for the file name where the figure
#'   output is going to be stored.
#'
#' @return The function doesn't return any value.
#'
#' @examples
#'  NULL
#'
#' @seealso \code{\link{compare_SMCs}}
#'
#' @import ggplot2
#' @export
#' 
plot_strata <- function(in_strata_list,
                        in_signatures_ind_df,
                        output_path=NULL,
                        in_attribute="") {
    in_strata_df <- in_strata_list$strata_df
    number_of_SMCs <- in_strata_list$number_of_SMCs
    number_of_strata <- in_strata_list$number_of_strata
    plot_list <- list()
    stratum_counter <- 0
    for(stratum in names(in_strata_df)) {
        stratum_counter <- stratum_counter + 1
        temp_df <- data.frame(sig=rownames(in_strata_df),
                                exposure=in_strata_df[,stratum])
        plot_list[[stratum_counter]] <- ggplot() + 
        ggplot2::geom_bar(data=temp_df,
                        aes_string(x="sig",y="exposure",fill="sig",size=0.3),
                        stat='identity',position="dodge",width=.7) + 
        scale_fill_manual(values=in_signatures_ind_df$colour) +
        labs(x="",y="",title=stratum) +
        theme(axis.text.x = element_blank(), axis.ticks.x = element_blank(),
                legend.position = "none")
    }
    horizontal_element_width <- 10
    number_of_horizontal_units <- number_of_SMCs*horizontal_element_width
    vertical_element_height <- 10
    number_of_vertical_units <- (max(number_of_strata))*vertical_element_height
    horizontal_figure_factor <- 60
    vertical_figure_factor <- 40

    if(!is.null(output_path)){
        fileName <- file.path(output_path,paste0(in_attribute,
                                                    "_all_strata.png"))
        png(fileName,
            width=number_of_horizontal_units*horizontal_figure_factor,
            height=number_of_vertical_units*vertical_figure_factor)
    }
    grid.newpage()
    pushViewport(viewport(layout = grid.layout(number_of_vertical_units, 
                                                number_of_horizontal_units)))
    this_offsets <- c(0,cumsum(number_of_strata)[1:length(number_of_strata)-1])
    vertical_temp_stop <- 0
    for (i in seq_len(sum(number_of_strata))) {
        this_SMC <- findInterval(i,cumsum(number_of_strata)+1)+1
        this_stratum <- i - this_offsets[this_SMC]
        horizontal_temp_start <- (this_SMC-1)*horizontal_element_width+1
        horizontal_temp_stop <- 
            (horizontal_temp_start - 1) + horizontal_element_width
        vertical_temp_start <- vertical_temp_stop + 1
        vertical_temp_start <- (this_stratum-1)*vertical_element_height+1
        vertical_temp_stop <- (vertical_temp_start - 1) + 
                                    vertical_element_height    
        print(plot_list[[i]], 
            vp = vplayout(vertical_temp_start:vertical_temp_stop, 
                        horizontal_temp_start:horizontal_temp_stop))
    }
    if(!is.null(output_path)){
        dev.off()
    }
    return()
}


#' Compute a similarity matrix for different strata
#'
#' Compute and plot a similarity matrix for different strata from different
#' stratification axes together. First, \code{\link{compare_sets}} is called on
#' \code{in_strata_df} with itself, yielding a distance matrix (a numerical data
#' frame) \code{dist_df} of the strata. The corresponding similarity matrix
#' \code{1-dif_df} is then passed to \code{\link[corrplot]{corrplot}}.
#'
#'
#' @param in_strata_df Numerical data frame of all strata to be compared.
#' @param output_path Path to directory where the results, especially the figure
#'   produced by \code{\link[corrplot]{corrplot}} is going to be stored.
#' @param in_nrect Number of clusters in the clustering procedure provided by
#'   \code{\link[corrplot]{corrplot}}
#' @param in_attribute Additional string for the file name where the figure
#'   produced by \code{\link[corrplot]{corrplot}} is going to be stored.
#' @param in_palette Colour palette for the matrix
#'
#' @return The comparison matrix of cosine similarities.
#'
#' @examples
#' data(sigs)
#' make_comparison_matrix(
#'  AlexCosmicValid_sig_df,in_nrect=9,
#'  in_palette=colorRampPalette(c("blue","green","red"))(n=100))
#'
#' @seealso \code{\link{compare_SMCs}}
#'
#' @importFrom grDevices colorRampPalette png dev.off
#' @importFrom corrplot corrplot
#' @export
#' 
make_comparison_matrix <- function(in_strata_df,output_path=NULL,in_nrect=5,
                                    in_attribute="",in_palette=NULL) {
    if(is.null(in_palette)){
        myColorRange <- colorRampPalette(c("blue","green","green","green",
                                            "green","green","green","green",
                                            "green","green","red"))(n=100)    
    } else {
        myColorRange <- in_palette
    }
    compare_list <- compare_sets(in_strata_df,in_strata_df)
    dist_df <- compare_list$distance
    if(!is.null(output_path)){
        fileName <- file.path(output_path,
                                paste0(in_attribute,"_comparison_matrix.png"))
    png(fileName,width=500,height=500)
    }
    corrplot(as.matrix(1-dist_df),method="color",order="hclust",
                addrect=in_nrect,col=myColorRange)
    if(!is.null(output_path)){
        dev.off()
    }
    return(as.matrix(1-dist_df))
}


#' Compare all strata from different stratifications
#'
#' Compare all strata from different orthogonal stratification axes, i.e.
#' othogonal SMCs by cosine similarity of signature exposures. First calls
#' \itemize{ \item \code{make_strata_df}, then \item \code{\link{plot_strata}}
#' and finally \item \code{\link{make_comparison_matrix}} }
#'
#' @param in_stratification_lists_list List of lists with entries from different
#'   (orthogonal) stratification axes or SMCs
#' @param in_signatures_ind_df A data frame containing meta information about
#'   the signatures
#' @param output_path Path to directory where the results, especially the figure
#'   produced by \code{\link[corrplot]{corrplot}} is going to be stored.
#' @param in_nrect Number of clusters in the clustering procedure provided by
#'   \code{\link[corrplot]{corrplot}}
#' @param in_attribute Additional string for the file name where the figure
#'   produced by \code{\link[corrplot]{corrplot}} is going to be stored.
#'
#' @return The comparison matrix of cosine similarities.
#'
#' @examples
#'  NULL
#'
#' @seealso \code{\link{plot_strata}}
#' @seealso \code{\link{make_comparison_matrix}}
#'
#' @export
#' 
compare_SMCs <- function(in_stratification_lists_list,
                            in_signatures_ind_df,
                            output_path,
                            in_nrect=5,
                            in_attribute="") {
    strata_list <- make_strata_df(in_stratification_lists_list)
    strata_df <- strata_list$strata_df
    plot_strata(strata_list,in_signatures_ind_df,output_path,in_attribute)
    reduced_strata_df <- strata_df
    names(reduced_strata_df)[1] <- "all"
    remove_ind <- grep("_all$",names(reduced_strata_df))
    reduced_strata_df <- reduced_strata_df[,-remove_ind]
    my_matrix <- make_comparison_matrix(reduced_strata_df,output_path,
                                        in_nrect,in_attribute)
    return(my_matrix)
}

#' Wrapper function for \code{plot_strata}
#'
#' First calls \itemize{ \item \code{make_strata_df}, then \item
#' \code{\link{plot_strata}} }
#'
#' @param in_stratification_lists_list List of lists with entries from different
#'   (orthogonal) stratification axes or SMCs
#' @param in_signatures_ind_df A data frame containing meta information about
#'   the signatures
#' @param output_path Path to directory where the results, especially the figure
#'   produced by \code{\link{plot_strata}} is going to be stored.
#' @param in_attribute Additional string for the file name where the figure
#'   produced by \code{\link{plot_strata}} is going to be stored.
#' @param in_remove_signature_ind Omit one of the signatures in
#'   \code{in_signatures_ind_df} for the comparison if non-NULL. The parameter
#'   specifies the index of the signature to be removed.
#' @param in_additional_stratum Include an additionally supplied stratum in
#'   comparison in non-NULL.
#'
#' @return The function doesn't return any value.
#'
#' @examples
#'  NULL
#'
#' @seealso \code{\link{plot_strata}}
#'
#' @export
#' 
run_plot_strata_general <- function(in_stratification_lists_list,
                                    in_signatures_ind_df,
                                    output_path=NULL,
                                    in_attribute="",
                                    in_remove_signature_ind=NULL,
                                    in_additional_stratum=NULL) {
    strata_list <- make_strata_df(in_stratification_lists_list,
                                in_remove_signature_ind,
                                in_additional_stratum)
    plot_strata(strata_list$strata_df,in_signatures_ind_df,
                    output_path,in_attribute)
}


#' Compare all strata from different stratifications
#'
#' Compare all strata from different orthogonal stratification axes, i.e.
#' othogonal SMCs by cosine similarity of signature exposures. Function similar
#' to \code{\link{compare_SMCs}}, but without calling \code{\link{plot_strata}}.
#' First calls \itemize{ \item \code{make_strata_df}, then \item
#' \code{\link{make_comparison_matrix}} }
#'
#' @param in_stratification_lists_list List of lists with entries from different
#'   (orthogonal) stratification axes or SMCs
#' @param output_path Path to directory where the results, especially the figure
#'   produced by \code{\link[corrplot]{corrplot}} is going to be stored.
#' @param in_nrect Number of clusters in the clustering procedure provided by
#'   \code{\link[corrplot]{corrplot}}
#' @param in_attribute Additional string for the file name where the figure
#'   produced by \code{\link[corrplot]{corrplot}} is going to be stored.
#' @param in_remove_signature_ind Omit one of the signatures in
#'   \code{in_signatures_ind_df} for the comparison if non-NULL. The parameter
#'   specifies the index of the signature to be removed.
#' @param in_additional_stratum Include an additionally supplied stratum in
#'   comparison in non-NULL.
#'
#' @return The comparison matrix of cosine similarities.
#'
#' @examples
#'  NULL
#'
#' @seealso \code{\link{make_comparison_matrix}}
#' @seealso \code{\link{compare_SMCs}}
#' @seealso \code{\link{run_comparison_catalogues}}
#'
#' @export
#' 
run_comparison_general <- function(in_stratification_lists_list,
                                    output_path=NULL,
                                    in_nrect=5,
                                    in_attribute="",
                                    in_remove_signature_ind=NULL,
                                    in_additional_stratum=NULL) {
    strata_list <- make_strata_df(in_stratification_lists_list,
                                    in_remove_signature_ind,
                                    in_additional_stratum)
    strata_df <- strata_list$strata_df
    reduced_strata_df <- strata_df
    names(reduced_strata_df)[1] <- "all"
    remove_ind <- grep("_all$",names(reduced_strata_df))
    if(length(remove_ind)>0) {
        reduced_strata_df <- reduced_strata_df[,-remove_ind]
    }
    my_matrix <- make_comparison_matrix(reduced_strata_df,
                                    output_path,
                                    in_nrect,
                                    in_attribute)
    return(my_matrix)
}

#' Compare all strata from different stratifications
#'
#' Compare all strata from different orthogonal stratification axes, i.e.
#' othogonal SMCs by cosine similarity of mutational catalogues. Function
#' similar to \code{\link{run_comparison_general}}. First calls \itemize{ \item
#' \code{make_catalogue_strata_df}, then \item
#' \code{\link{make_comparison_matrix}} }
#'
#' @param in_stratification_lists_list List of lists with entries from different
#'   (orthogonal) stratification axes or SMCs
#' @param output_path Path to directory where the results, especially the figure
#'   produced by \code{\link[corrplot]{corrplot}} is going to be stored.
#' @param in_nrect Number of clusters in the clustering procedure provided by
#'   \code{\link[corrplot]{corrplot}}
#' @param in_attribute Additional string for the file name where the figure
#'   produced by
#'
#' @return The comparison matrix of cosine similarities.
#'
#' @examples
#'  NULL
#'
#' @seealso \code{\link{make_comparison_matrix}}
#' @seealso \code{\link{run_comparison_general}}
#'
#' @export
#' 
run_comparison_catalogues <- function(in_stratification_lists_list,
                                        output_path=NULL,
                                        in_nrect=5,
                                        in_attribute="") {
    catalogue_strata_list <- 
        make_catalogue_strata_df(in_stratification_lists_list)
    catalogue_strata_df <- catalogue_strata_list$strata_df
    reduced_strata_df <- catalogue_strata_df
    names(reduced_strata_df)[1] <- "all"
    remove_ind <- grep("_all$",names(reduced_strata_df))
    if(length(remove_ind)>0) {
        reduced_strata_df <- reduced_strata_df[,-remove_ind]
    }
    my_matrix <- make_comparison_matrix(reduced_strata_df,
                                        output_path,
                                        in_nrect,
                                        in_attribute)
    return(my_matrix)
}

## ----loadStyle, warning=FALSE, echo=FALSE, message=FALSE, results="hide"------
library(BiocStyle)

## ----packages, include=FALSE--------------------------------------------------
library(YAPSA)
library(Biostrings)
library(BSgenome.Hsapiens.UCSC.hg19)
library(knitr)
opts_chunk$set(echo=TRUE)
opts_chunk$set(fig.show='asis')

## ----loadStoredSigData--------------------------------------------------------
data(sigs)
data(cutoffs)
data("lymphomaNature2013_mutCat_df")
current_cutoff_vector <- cutoffCosmicValid_abs_df[6,]

## ----LCDwithCutoffs-----------------------------------------------------------
lymphoma_COSMIC_listsList <-
  LCD_complex_cutoff_combined(
      in_mutation_catalogue_df = lymphomaNature2013_mutCat_df,
      in_cutoff_vector = current_cutoff_vector, 
      in_signatures_df = AlexCosmicValid_sig_df, 
      in_sig_ind_df = AlexCosmicValid_sigInd_df)

## ----subrgroupAnnotation------------------------------------------------------
data(lymphoma_PID)
colnames(lymphoma_PID_df) <- "SUBGROUP"
lymphoma_PID_df$PID <- rownames(lymphoma_PID_df)
COSMIC_subgroups_df <- 
  make_subgroups_df(lymphoma_PID_df,
                    lymphoma_COSMIC_listsList$cohort$exposures)

## ----captionExposures, echo=FALSE---------------------------------------------
cap <- "Exposures to SNV mutational signatures"

## ----exposuresCutoffs, warning=FALSE, fig.width=8, fig.height=6, fig.cap= cap----
exposures_barplot(
  in_exposures_df = lymphoma_COSMIC_listsList$cohort$exposures,
  in_signatures_ind_df = lymphoma_COSMIC_listsList$cohort$out_sig_ind_df,
  in_subgroups_df = COSMIC_subgroups_df)               

## ----formatRaw, warning=FALSE, fig.width=8, fig.height=6, fig.cap= cap--------
data("lymphoma_Nature2013_raw")
names(lymphoma_PID_df) <- gsub("SUBGROUP", "subgroup", names(lymphoma_PID_df))
names(lymphoma_Nature2013_raw_df) <- c("PID","TYPE","CHROM","START",
                                       "STOP","REF","ALT","FLAG")
lymphoma_Nature2013_df <- subset(lymphoma_Nature2013_raw_df,TYPE=="subs",
                                 select=c(CHROM,START,REF,ALT,PID))
names(lymphoma_Nature2013_df)[2] <- "POS"
lymphoma_Nature2013_df$SUBGROUP <- "unknown"
DLBCL_ind <- grep("^DLBCL.*",lymphoma_Nature2013_df$PID)
lymphoma_Nature2013_df$SUBGROUP[DLBCL_ind] <- "DLBCL_other"
MMML_ind <- grep("^41[0-9]+$",lymphoma_Nature2013_df$PID)
lymphoma_Nature2013_df <- lymphoma_Nature2013_df[MMML_ind,]
for(my_PID in rownames(lymphoma_PID_df)) {
  PID_ind <- which(as.character(lymphoma_Nature2013_df$PID)==my_PID)
  lymphoma_Nature2013_df$SUBGROUP[PID_ind] <-
    lymphoma_PID_df$subgroup[which(rownames(lymphoma_PID_df)==my_PID)]
}
lymphoma_Nature2013_df$SUBGROUP <- factor(lymphoma_Nature2013_df$SUBGROUP)
lymphoma_Nature2013_df <- translate_to_hg19(lymphoma_Nature2013_df,"CHROM")
lymphoma_Nature2013_df$change <- 
  attribute_nucleotide_exchanges(lymphoma_Nature2013_df)
lymphoma_Nature2013_df <- 
  lymphoma_Nature2013_df[order(lymphoma_Nature2013_df$PID,
                               lymphoma_Nature2013_df$CHROM,
                               lymphoma_Nature2013_df$POS),]
lymphoma_Nature2013_df <- annotate_intermut_dist_cohort(lymphoma_Nature2013_df,
                                                        in_PID.field="PID")
data("exchange_colour_vector")
lymphoma_Nature2013_df$col <- 
  exchange_colour_vector[lymphoma_Nature2013_df$change]

## ----stratifyMutDensity-------------------------------------------------------
lymphoma_Nature2013_df$density_cat <- cut(lymphoma_Nature2013_df$dist,
                                          c(0,1001,100001,Inf),
                                          right=FALSE,
                                          labels=c("high","intermediate",
                                                   "background"))

## ----tableStrataMutDensity----------------------------------------------------
temp_df <- data.frame(table(lymphoma_Nature2013_df$density_cat))
names(temp_df) <- c("Stratum","Cohort-wide counts")
kable(temp_df, caption=paste0("Strata for the SMC of mutation density"))

## ----captionSMC, echo=FALSE---------------------------------------------------
cap="SMC (Stratification of the Mutational Catalogue)
        based on mutation density."

## ----SMC, results="hide",warning=FALSE,fig.width=8,fig.height=7,fig.cap=cap----
strata_order_ind <- c(1,3,2)
mut_density_list <- run_SMC(lymphoma_Nature2013_df,
                            lymphoma_COSMIC_listsList$cohort$signatures,
                            lymphoma_COSMIC_listsList$cohort$out_sig_ind_df,
                            COSMIC_subgroups_df,
                            column_name="density_cat",
                            refGenome=BSgenome.Hsapiens.UCSC.hg19,
                            cohort_method_flag="norm_PIDs",
                            in_strata_order_ind=strata_order_ind)

## ----captionSMCdodged, echo=FALSE---------------------------------------------
cap = "SMC results displayed as dodged plot."

## ----SMCdodged, results="hide",warning=FALSE,fig.width=8,fig.height=7,fig.cap=cap----
dodged_df <- do.call(rbind, mut_density_list$cohort)
names(dodged_df) <- gsub("variable","stratum", names(dodged_df))
names(dodged_df) <- gsub("sig","signature", names(dodged_df))
dodged_df$stratum <- gsub("_rel", "", as.character(dodged_df$stratum))
dodged_df <- dodged_df[which(dodged_df$stratum != "all"),]
dodged_df$stratum <-
  factor(as.character(dodged_df$stratum),
         levels = sort(unique(dodged_df$stratum))[rev(strata_order_ind)])
dodged_plot <- ggplot() +
  geom_bar(data = dodged_df,
           aes_string(x = "signature", y = "exposure",
                      group = "stratum", fill = "stratum"),
           stat = "identity", position = "dodge", size = 1.5) +
  geom_errorbar(data = dodged_df,
                aes_string(x = "signature", ymin = "exposure_min",
                           ymax = "exposure_max",
                           group = "stratum"),
                position = position_dodge(width = 0.9), width = 0.3) +
  labs(y = "relative exposures")
if(exists("current_strata_colVector")){
  dodged_plot <- dodged_plot +
    scale_fill_manual(values = current_strata_colVector[-1],
                      labels = current_labelVector[-1]
                                [current_strata_order_ind])
}
print(dodged_plot)

## ----statSMCmutDensity, warning=FALSE, message=FALSE--------------------------
stat_mut_density_list <- stat_test_SMC(mut_density_list,in_flag="norm")
kable(stat_mut_density_list$kruskal_df,
      caption=paste0("Results of Kruskal tests for cohort-wide exposures over",
                     " strata per signature without and with correction for ",
                     "multiple testing."))

## ----postHocMutDensity--------------------------------------------------------
significance_level <- 0.05
for(i in seq_len(dim(stat_mut_density_list$kruskal_df)[1])){
  if(stat_mut_density_list$kruskal_df$Kruskal_p_val_BH[i]<significance_level){
    print(paste0("Signature: ",rownames(stat_mut_density_list$kruskal_df)[i]))
    print(stat_mut_density_list$kruskal_posthoc_list[[i]])
  }
}

## ----loadStyle, warning=FALSE, echo=FALSE, message=FALSE, results="hide"------
library(BiocStyle)

## ----packages, include=FALSE--------------------------------------------------
library(YAPSA)
library(knitr)
library(gridExtra)
library(dplyr)
opts_chunk$set(echo=TRUE)
opts_chunk$set(fig.show='asis')

## ----loadSignatures-----------------------------------------------------------
data(sigs)
data(sigs_pcawg)

## ----loadCutoffs--------------------------------------------------------------
data(cutoffs)
data(cutoffs_pcawg)

## ----cutoffExample------------------------------------------------------------
data(cutoffs)
current_cutoff_vector <- cutoffCosmicValid_abs_df[6, ]
current_cutoff_vector

## ----loadData-----------------------------------------------------------------
data(lymphomaNature2013_mutCat_df)

## ----setVariables-------------------------------------------------------------
current_sig_df <- AlexCosmicValid_sig_df
current_sigInd_df <- AlexCosmicValid_sigInd_df

## ----cutoffVector-------------------------------------------------------------
current_cutoff_vector <- rep(0, dim(AlexCosmicValid_sig_df)[2])

## ----lymphomaCohortLCD_results------------------------------------------------
lymphoma_COSMIC_zero_listsList <-
  LCD_complex_cutoff_combined(
    in_mutation_catalogue_df = lymphomaNature2013_mutCat_df,
    in_cutoff_vector = current_cutoff_vector, 
    in_signatures_df = current_sig_df, 
    in_sig_ind_df = current_sigInd_df)

## ----subrgroupAnnotation------------------------------------------------------
data(lymphoma_PID)
colnames(lymphoma_PID_df) <- "SUBGROUP"
lymphoma_PID_df$PID <- rownames(lymphoma_PID_df)
COSMIC_subgroups_df <- 
  make_subgroups_df(lymphoma_PID_df,
                    lymphoma_COSMIC_zero_listsList$cohort$exposures)

## ----captionBarplot2, echo=FALSE----------------------------------------------
cap <- "Absoute exposures of the COSMIC signatures in the lymphoma mutational
        catalogs, signature-specific cutoffs with a cost factor of 6 used
        for the LCD"

## ----exposuresZero, warning=FALSE, fig.width=8, fig.height=6, fig.cap = cap----
result_cohort <- lymphoma_COSMIC_zero_listsList$cohort
exposures_barplot(
  in_exposures_df = result_cohort$exposures,
  in_signatures_ind_df = result_cohort$out_sig_ind_df,
  in_subgroups_df = COSMIC_subgroups_df)        

## ----setSignatureSpecificCutoffs----------------------------------------------
current_cutoff_df <- cutoffCosmicValid_abs_df
current_cost_factor <- 6
current_cutoff_vector <- current_cutoff_df[current_cost_factor,]

## ----LCDwithCutoffs-----------------------------------------------------------
lymphoma_COSMIC_listsList <-
  LCD_complex_cutoff_combined(
      in_mutation_catalogue_df = lymphomaNature2013_mutCat_df,
      in_cutoff_vector = current_cutoff_vector, 
      in_signatures_df = current_sig_df, 
      in_sig_ind_df = current_sigInd_df)

## ----captionBarplot, echo=FALSE-----------------------------------------------
cap <- "Absolute exposures of the COSMIC signatures in the lymphoma mutational
        catalogs, signature-specific cutoffs with a cost factor of 6 used
        for the LCD"

## ----exposuresCutoffs, warning=FALSE, fig.width=8, fig.height=6, fig.cap= cap----
result_cohort <- lymphoma_COSMIC_listsList$cohort
exposures_barplot(
  in_exposures_df = result_cohort$exposures,
  in_signatures_ind_df = result_cohort$out_sig_ind_df,
  in_subgroups_df = COSMIC_subgroups_df)               

## ----load_style, warning=FALSE, message=FALSE, results="hide"-----------------
library(BiocStyle)

## ----packages, include=FALSE--------------------------------------------------
library(YAPSA)
library(Biostrings)
library(BSgenome.Hsapiens.UCSC.hg19)
library(knitr)
opts_chunk$set(echo=TRUE)
opts_chunk$set(fig.show='asis')

## ----loadStoredSigData--------------------------------------------------------
data(sigs)
data(cutoffs)
current_sig_df <- AlexInitialArtif_sig_df
library(BSgenome.Hsapiens.UCSC.hg19)

## -----------------------------------------------------------------------------
data("smallCellLungCancerMutCat_NatureGenetics2012")

## ----loadLymphomaFtp, eval=FALSE----------------------------------------------
# smallCellLungCancer_NatureGenetics2012_ftp_path <- paste0(
#   "ftp://ftp.sanger.ac.uk/pub/cancer/AlexandrovEtAl/",
#   "somatic_mutation_data/Lung%20Small%20Cell/",
#   "Lung%20Small%20Cell_clean_somatic_mutations_for_signature_analysis.txt")
# exome_vcf_like_df <-
#   read.csv(file = smallCellLungCancer_NatureGenetics2012_ftp_path,
#            header=FALSE,sep="\t")
# names(exome_vcf_like_df) <- c("PID","TYPE","CHROM","START",
#                                        "STOP","REF","ALT","FLAG")
# exome_vcf_like_df <- subset(exome_vcf_like_df, TYPE == "subs",
#                             select = c(CHROM, START, REF, ALT, PID))
# names(exome_vcf_like_df)[2] <- "POS"
# exome_vcf_like_df <- translate_to_hg19(exome_vcf_like_df,"CHROM")
# word_length <- 3
# exome_mutCatRaw_list <-
#   create_mutation_catalogue_from_df(
#     exome_vcf_like_df,
#     this_seqnames.field = "CHROM", this_start.field = "POS",
#     this_end.field = "POS", this_PID.field = "PID",
#     this_subgroup.field = "SUBGROUP",
#     this_refGenome = BSgenome.Hsapiens.UCSC.hg19,
#     this_wordLength = 3)
# exome_mutCatRaw_df <- as.data.frame(exome_mutCatRaw_list$matrix)

## ----loadCorrectionFactors----------------------------------------------------
data(targetCapture_cor_factors)

## ----listCorrectionFactors----------------------------------------------------
names(targetCapture_cor_factors)

## ----correctTargetCapture-----------------------------------------------------
targetCapture <- "AgilentSureSelectAllExon"
cor_list <- targetCapture_cor_factors[[targetCapture]]
corrected_catalog_df <- normalizeMotifs_otherRownames(exome_mutCatRaw_df,
                                                        cor_list$rel_cor)

## ----optimalCutoffs-----------------------------------------------------------
data(cutoffs)
current_cutoff_vector <- cutoffCosmicValid_rel_df[6,]

## ----LCDwithCutoffs-----------------------------------------------------------
exome_listsList <-
  LCD_complex_cutoff_combined(
      in_mutation_catalogue_df = corrected_catalog_df,
      in_cutoff_vector = current_cutoff_vector, 
      in_signatures_df = AlexCosmicValid_sig_df, 
      in_sig_ind_df = AlexCosmicValid_sigInd_df)

## ----ExposuresCutoffsCap, echo=FALSE------------------------------------------
cap <- "Exposures barplot."

## ----exposuresCutoffs, warning=FALSE, fig.width=8, fig.height=6, fig.cap=cap----
exposures_barplot(
  in_exposures_df = exome_listsList$cohort$exposures,
  in_signatures_ind_df = exome_listsList$cohort$out_sig_ind_df)         

# Copyright © 2014-2019  The YAPSA package contributors
# This file is part of the YAPSA package. The YAPSA package is licenced under
# GPL-3

#' Read a single vcf-like file into a single data frame
#'
#' Note: this function uses \code{\link[utils]{read.csv}} to read vcf-like files
#' into data frames for single samples. As it uses
#' \code{\link[utils]{read.csv}}, the default value for \code{comment.char} is
#' "" and not "#" as it would have been for \code{\link[utils]{read.table}}.
#'
#' @param current_ind Index of the file to read from the list provided below.
#' @param in_list List of paths to vcf-like file to be read. The list may be
#'   named.
#' @param header Boolean whether a header information should be read (as in
#'   \code{\link[utils]{read.table}})
#' @param in_header Vector of column names to be substituted if non-NULL.
#' @param variant_type Default is "SNV" and provides additional plausibility and
#'   checks, omitted if other string
#' @param delete.char Character to be deleted, e.g. in order to discriminate
#'   between comment lines and header lines, if non-NULL
#' @param ... Parameters passed on to \code{\link[utils]{read.table}}
#'
#' @examples
#'  NULL
#'
#' @return A vcf-like data frame
#' @export
#' 
read_entry <- function(current_ind,
                       in_list,
                       header = TRUE,
                       in_header = NULL,
                       variant_type = "SNV",
                       delete.char = NULL,
                       ...){
  current_PID <- names(in_list)[current_ind]
  current_entry <- in_list[[current_ind]]
  vcf_like_df <- tryCatch({
    if(is.null(delete.char)){
      temp_df <- read.csv(current_entry, header = header, ...)
    } else {
      temp_df <- read.csv(pipe(paste0('zcat ', current_entry, " | sed s/^", 
                                        delete.char, "//")), 
                            header = header, ...)
    }
    if(!header & !is.null(in_header)) names(temp_df) <- in_header
    ## remove false counts, i.e. keep only SNVs
    if(variant_type == "SNV"){
      temp_true_ind <- which((temp_df$REF %in% c("A","C","G","T")) &
                               (temp_df$ALT %in% c("A","C","G","T")))
      temp_df <- temp_df[temp_true_ind,]
    }
    ## attribute PID
    temp_df$PID <- current_PID
    temp_df
  },
  error=function(cond){
    message(paste0("read_entry::error. Original error message:"))
    message(paste0(cond))
    message(paste0("Return NULL.\n"))
    return(NULL)
  })
  return(vcf_like_df)
}


#' Read a list of vcf-like files into a list of data frames
#'
#' @param in_parallel If multicore functionality is provided on a compute
#'   cluster, this option may be set to TRUE in order to enhance speed.
#'
#' @examples
#'  NULL
#'
#' @return A list with entries: \itemize{ \item \code{vcf_like_df_list}: List of
#'   the read data frames \item \code{readVcf_time}: Object of class
#'   \code{proc_time}, which stores the time needed for reading in the data }
#'
#' @importFrom doParallel registerDoParallel
#' @importFrom parallel detectCores makeCluster mclapply stopCluster
#' @export
#'
#' @rdname read_entry
#'   
read_list <- function(in_list,
                      in_parallel = FALSE,
                      header = TRUE,
                      in_header = NULL,
                      ...){
  seq_list <- seq_along(in_list)
  names(seq_list) <- names(in_list)
  buildCatalogues_time <- 0
  if(in_parallel){
    #library(parallel)
    detectCores()
    cl <- makeCluster(detectCores() - 1)
    #library(parallel)
    #library(doParallel)
    registerDoParallel(cl, cores = detectCores() - 1)
    start_time <- proc.time()
    mut_cat_df_list <- mclapply(seq_along(in_list),function(current_ind)
      read_entry(current_ind, in_list=in_list, header = header,
                 in_header = in_header, ...))
    buildCatalogues_time <- proc.time() - start_time
    stopCluster(cl)
  } else {
    start_time <- proc.time()
    vcf_like_df_list <- lapply(seq_list,function(current_ind)
      read_entry(current_ind, in_list=in_list, header = header,
                 in_header = in_header, ...))
    readVcf_time <- proc.time() - start_time
  }
  vcf_like_df_list <- vcf_like_df_list[
    which(!unlist(lapply(vcf_like_df_list,is.null)))]
  return(list(vcf_like_df_list=vcf_like_df_list,
              readVcf_time=readVcf_time))
}

# Copyright © 2014-2019  The YAPSA package contributors
# This file is part of the YAPSA package. The YAPSA package is licenced under
# GPL-3

#' Extracts the sequence context up and downstream of a nucleotide position
#'
#' @param position Start position of the considered INDEL
#' @param chr Chromosome of the considered INDEL
#' @param offsetL Number of nucleotides downstream of \code{position}
#' @param offsetR Number of nucleotides upstream of \code{position}
#'
#' @return Returns a character string containing the defined seqeunce context
#'
#' @export
#' @importFrom Biostrings getSeq DNAString subseq
#' @import BSgenome.Hsapiens.UCSC.hg19
#' @examples
#' library(Biostrings)
#' library(BSgenome.Hsapiens.UCSC.hg19)
#'
#' sequence_context <- getSequenceContext(position = 123456789, chr = "chr12",
#'                                        offsetL= 10, offsetR=50)
#' sequence_context
#' 
getSequenceContext <- function(position, chr, offsetL= 10, offsetR=50){
  if(is.numeric(chr)){
    chr <- paste0("chr", chr)
    sequence <- getSeq(Hsapiens, chr, position-offsetL, position+offsetR)
    context_string <- as.character(sequence)
    sequenceContext <- list(sequence=sequence,context_string=context_string)
    return(sequenceContext)
  }else{
    sequence <- getSeq(Hsapiens, chr, position-offsetL, position+offsetR)
    context_string <- as.character(sequence)
    sequenceContext <- list(sequence=sequence,context_string=context_string)
    return(sequenceContext)
  }
}


#' Attribution of sequence context and size for an INDEL
#'
#' The function is a wrapper and uses \code{\link[YAPSA]{getSequenceContext}}
#' to annotate the sequence context.
#'
#' @param in_dat VRanges object or data frame which carries one column for the
#'   reference base and one column for the variant base
#' @param in_REF.field String indicating which column of \code{in_dat} carries
#'   the reference base if dealing with data frames
#' @param in_ALT.field String indicating which column of \code{in_dat} carries
#'   the variant base if dealing with data frames
#' @param in_verbose Verbose if \code{in_verbose=1}
#' @param in_offsetL Number of nucleotides which should be annotated downstream
#'   of the variant. Per default 10 bps are annotated
#' @param in_offsetR Number of nucleotides which should be annotated upstream of
#'   the catiant. Per default 50 bps are annotated
#'
#' @return VRanges object or data frame with the same number rows and additional
#' columns containing the type of INDEL (Ins = insertion and Del = deletion),
#' the annotated sequence context of the defined length, the absolute number of
#' exchanged nucleotides and the nucleotide exchange between \code{in_REF.field}
#' and \code{in_ALT.field}.
#'
#' @export
#'
#' @examples
#' data(GenomeOfNl_raw)
#' GenomeOfNl_context <- attribute_sequence_contex_indel(
#'                                    in_dat = head(GenomeOfNl_raw),
#'                                    in_REF.field = "REF",
#'                                    in_ALT.field = "ALT",
#'                                    in_verbose = FALSE,
#'                                    in_offsetL= 10, in_offsetR=50)
#' GenomeOfNl_context
#' 
attribute_sequence_contex_indel <- function(in_dat, in_REF.field = "REF",
                                                 in_ALT.field = "ALT",
                                                 in_verbose = FALSE, 
                                                 in_offsetL= 10,
                                                 in_offsetR=50) {
  print(paste("Indel sequence context attribution of total ", dim(in_dat)[1],
              " indels. This could take a while..."))
  name_list <- names(in_dat)
  ## exception handling for input fields
  if(tolower(in_REF.field) %in% tolower(name_list)){
    if(in_verbose) cat("YAPSA:::attribute_nucleotide_exchanges::in_REF.field",
                       " found. Retrieving REF information.\n")
    REF_ind <- min(which(tolower(name_list)==tolower(in_REF.field)))
  }else{
    if(in_verbose) cat("YAPSA:::attribute_nucleotide_exchanges::error: ",
                       "in_REF.field not found. Return NULL.\n")
    return(NULL)
  }
  if(tolower(in_ALT.field) %in% tolower(name_list)) {
    if(in_verbose) cat("YAPSA:::attribute_nucleotide_exchanges::in_ALT.field",
                       " found. Retrieving ALT information.\n")
    ALT_ind <- min(which(tolower(name_list)==tolower(in_ALT.field)))
  }else{
    if(in_verbose) cat("YAPSA:::attribute_nucleotide_exchanges::error: ",
                       "in_ALT.field not found. Return NULL.\n")
    return(NULL)
  }
  
  diff <- abs(nchar(in_dat[,REF_ind])-nchar(in_dat[,ALT_ind]))
  
  in_dat$Type <- "dummy"
  for(index in c(1:length(in_dat$CHROM))){
     ref_length <- length(unlist(strsplit(in_dat$REF[index], split="")))
     alt_length <- length(unlist(strsplit(in_dat$ALT[index], split="")))
     if(ref_length > alt_length){
       in_dat$Type[index] <- "Del"
       context_list <- getSequenceContext(position = in_dat$POS[index],
                                          chr = in_dat$CHROM[index],
                                          offsetL= in_offsetL,
                                          offsetR= in_offsetR)
       in_dat$SequenceContext[index] <- context_list$context_string
     }else{
       in_dat$Type[index] <- "Ins"
       context_list <- getSequenceContext(position = in_dat$POS[index],
                                          chr = in_dat$CHROM[index],
                                          offsetL= in_offsetL,
                                          offsetR= in_offsetR)
       in_dat$SequenceContext[index] <- context_list$context_string
     }
  }
  if(length(which(grepl("PID", name_list)))==0){
    in_dat$PID<-"no_PID"
  }
  
  in_dat$Differnce <- diff
  in_dat$Change <- paste0(in_dat[,REF_ind],">",in_dat[,ALT_ind])
  in_dat_return <- in_dat[,c("CHROM", "POS", "REF", "ALT", "PID", "Type",
                             "Differnce", "Change", "SequenceContext")]
  return(in_dat_return)
}

#' Attribution of variant into one onf the 83 INDEL categories
#'
#' Each varaint is categorized into one of the 83 INDEL categories. The
#' classification likewise to Alexandrov et al., 2018
#' (https://www.synapse.org/#!Synapse:syn11726616). The number of 83 features
#' are classefied asfollowed: \enumerate{ \item Deletion of 1 bp C/(G) or T/(A)
#' in a repetitive context. The context is classified into 1, 2, 3, 4, 5 or
#' larger or equal to 6 times the same nucleotide(s). \item Insertion of 1 bp
#' C/(G) or T/(A) in a repetitive context. The context is classified into 0, 1,
#' 2, 3, 4,  or larger or equal to 5 times the same nucleotide(s). \item
#' Deletions of 2bps, 3bps, 4bps or more or equal to 5bps in a repetitive
#' context. Each deletion is classified in a context of 1, 2, 3, 4, 5 or larger
#' or equal to 6 times the same motif. \item Insertion of 2 bps, 3 bps, 4 bps or
#' more or equal to 5 bps in a repetitive context. Each deletion is classified
#' in a context of 0, 1, 2, 3, 4 or larger or equal to 5 times the same motif.
#' \item Microhomology deletion of 2bps, 3bps, 4bps or more or equal to 5 bps in
#' a partly repetitive context. The partly repetitive context is defined by
#' motif length of minus 1 bp, 2 bps, 3 bps, 4 bps or more or equal to 5bps,
#' which is located before and after the break-point junction of the deletion.}
#'
#' @param in_dat_return Data frame constucted form a vcf-like file of a whole
#'   cohort or a single-sample.The first columns are those of a standart vcf
#'   file, followed by an abitrary number of custom or defined columns. One of
#'   these can carry a PID (patient or sample identifyer) and subgroup
#'   information. Furthermore, the columns containing the sequence context and
#'   the absolute length of the INDEL as well as the INDEL type of the variant
#'   can be annotated to the vcf-like df with
#'   \code{\link[YAPSA]{attribute_sequence_contex_indel}}. These columns are
#'   required to enable the constuction of a mutational catalog.
#'
#' @return Data frame with the same dimention as the input data frame  plus an
#'   addional column with the INDEL classification number corrospondig to
#'   Alexandrov et al. 2018.
#'
#' @export
#' @importFrom Biostrings DNAString subseq matchPattern xscat
#'
#' @examples
#' data(GenomeOfNl_raw)
#' GenomeOfNl_context <- attribute_sequence_contex_indel(in_dat =
#' head(GenomeOfNl_raw))
#' GenomeOfNl_classified <- attribution_of_indels(GenomeOfNl_context)
#' GenomeOfNl_classified
#' 
attribution_of_indels <-function(in_dat_return = in_dat_return){ 
  print(paste("INDEL classification of total ", dim(in_dat_return)[1],
              " INDELs This could take a while..."))
  for(indel in c(1:dim(in_dat_return)[1])){
    sequence_string <- DNAString(in_dat_return$SequenceContext[indel])
    if(in_dat_return$Differnce[indel]+11 > 61){
      motive_end_index <- 60
    }else{
    motive_end_index <- in_dat_return$Differnce[indel]+11
    }
    rest_start_index <- motive_end_index+1
    motive<-sequence_string[12:motive_end_index]
    motive_length <- length(motive)
    rest_string_R <-subseq(sequence_string, start= rest_start_index)
    rest_string_L <-subseq(sequence_string, start=1, end=11)
    match <- matchPattern(motive, rest_string_R)
    
    if(length(width(match))<5){
      rest_string_R_new <-xscat(rest_string_R, rep(motive, 5))
      match <- matchPattern(motive, rest_string_R_new)
    }
    if(in_dat_return$Type[indel] == "Del"){
      if(in_dat_return$Differnce[indel] == 1){
        if(identical(as.character(match),character(0))| start(match)[1]>1){
          if(as.character(motive)== "T" | as.character(motive) == "A"){
            in_dat_return$Motiv[indel] <- "T:A"
            in_dat_return$RepeatSize[indel] <- 0
            in_dat_return$IndelNumber[indel] <- "DEL_T_1_0"
          }else{
            in_dat_return$Motiv[indel] <- "C:G"
            in_dat_return$RepeatSize[indel] <- 0
            in_dat_return$IndelNumber[indel] <- "DEL_C_1_0"  
          }
        }else if(start(match)[1]==1 && start(match)[2] == 1+motive_length && 
                 start(match)[3] == 1+(2*motive_length) && 
                 start(match)[4] == 1+(3*motive_length) && 
                 start(match)[5] == 1+(4*motive_length)){
          if(as.character(motive)== "T" | as.character(motive) == "A"){
            in_dat_return$Motiv[indel] <- "T:A"
            in_dat_return$RepeatSize[indel] <- "5+"
            in_dat_return$IndelNumber[indel] <- "DEL_T_1_5+"
          }else{
            in_dat_return$Motiv[indel] <- "C:G"
            in_dat_return$RepeatSize[indel] <- "5+"
            in_dat_return$IndelNumber[indel] <- "DEL_C_1_5+"
          }
        }else if(start(match)[1]==1 && start(match)[2] == 1+motive_length && 
                 start(match)[3] == 1+(2*motive_length) && 
                 start(match)[4] == 1+(3*motive_length)){
          if(as.character(motive)== "T" | as.character(motive) == "A"){
            in_dat_return$Motiv[indel] <- "T:A"
            in_dat_return$RepeatSize[indel] <- 4
            in_dat_return$IndelNumber[indel] <- "DEL_T_1_4"
          }else{
            in_dat_return$Motiv[indel] <- "C:G"
            in_dat_return$RepeatSize[indel] <- 4
            in_dat_return$IndelNumber[indel] <- "DEL_C_1_4"
          }
        }else if(start(match)[1]==1 && start(match)[2] == 1+motive_length && 
                 start(match)[3] == 1+(2*motive_length)){
          if(as.character(motive)== "T" | as.character(motive) == "A"){
            in_dat_return$Motiv[indel] <- "T:A"
            in_dat_return$RepeatSize[indel] <- 3
            in_dat_return$IndelNumber[indel] <- "DEL_T_1_3"
          }else{
            in_dat_return$Motiv[indel] <- "C:G"
            in_dat_return$RepeatSize[indel] <- 3
            in_dat_return$IndelNumber[indel] <- "DEL_C_1_3"
          }
        }else if(start(match)[1]==1 && start(match)[2] == 1+motive_length){
          if(as.character(motive)== "T" | as.character(motive) == "A"){
            in_dat_return$Motiv[indel] <- "T:A"
            in_dat_return$RepeatSize[indel] <- 2
            in_dat_return$IndelNumber[indel] <- "DEL_T_1_2"
          }else{
            in_dat_return$Motiv[indel] <- "C:G"
            in_dat_return$RepeatSize[indel] <- 2
            in_dat_return$IndelNumber[indel] <- "DEL_C_1_2"
          }
        }else if(start(match)[1]==1){
          if(as.character(motive)== "T" | as.character(motive) == "A"){
            in_dat_return$Motiv[indel] <- "T:A"
            in_dat_return$RepeatSize[indel] <- 1
            in_dat_return$IndelNumber[indel] <- "DEL_T_1_1"
          }else{
            in_dat_return$Motiv[indel] <- "C:G"
            in_dat_return$RepeatSize[indel] <- 1
            in_dat_return$IndelNumber[indel] <- "DEL_C_1_1"
            }
        }else{
          in_dat_return$Motiv[indel] <- "NA"
          in_dat_return$RepeatSize[indel] <- "NA"
          in_dat_return$IndelNumber[indel] <- "NOT DEFINED"
          }
      }else if(in_dat_return$Differnce[indel] == 2){
        homologR1 <- motive[1:motive_length-1]
        homologL1 <- motive[2:motive_length]
        
        match_homologR1 <- matchPattern(homologR1, rest_string_R)
        match_homologL1 <- matchPattern(homologL1, rest_string_L)
        
        if(((length(as.character(match_homologL1)) != 0 |
             length(as.character(match_homologR1)) != 0) && 
                 (start(match)[1]!=1 | identical(as.character(match),
                                             character(0)))) &&
                 ((start(match_homologR1)[1]==1 && 
                   !is.na(start(match_homologR1)[1]==1))|
                 (end(match_homologL1)[1]==11 && 
                  !is.na(end(match_homologL1)[1]==11)))){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- "1bp"
          in_dat_return$IndelNumber[indel] <- "DEL_MH_2_1"
        }else if((identical(as.character(match),character(0)) && 
                  is.na(start(match)[1]!=1)) |  start(match)[1]!=1 |
                 identical(as.character(match_homologL1),character(0)) && 
             identical(as.character(match_homologR1),character(0))){
           in_dat_return$Motiv[indel] <- as.character(motive)
           in_dat_return$RepeatSize[indel] <- 0
           in_dat_return$IndelNumber[indel] <-"DEL_repeats_2_0"
        }else if(length(match) >= 5 && 
                 (start(match)[1]==1 && 
                  start(match)[2] == 1+motive_length && 
                  start(match)[3] == 1+(2*motive_length) && 
                  start(match)[4] == 1+(3*motive_length) && 
                  start(match)[5] == 1+(4*motive_length))){
           in_dat_return$Motiv[indel] <- as.character(motive)
           in_dat_return$RepeatSize[indel] <- "5+"
           in_dat_return$IndelNumber[indel] <- "DEL_repeats_2_5+"
        }else if(length(match) >= 4 && 
                 (start(match)[1]==1 &&
                  start(match)[2] == 1+motive_length && 
                  start(match)[3] == 1+(2*motive_length) && 
             start(match)[4] == 1+(3*motive_length))){
           in_dat_return$Motiv[indel] <- as.character(motive)
           in_dat_return$RepeatSize[indel] <- 4
           in_dat_return$IndelNumber[indel] <- "DEL_repeats_2_4"
        }else if(length(match) >= 3 && 
                 (start(match)[1]==1 && 
                  start(match)[2] == 1+motive_length &&
                  start(match)[3] == 1+(2*motive_length))){
           in_dat_return$Motiv[indel] <- as.character(motive)
           in_dat_return$RepeatSize[indel] <- 3
           in_dat_return$IndelNumber[indel] <- "DEL_repeats_2_3"
        }else if(length(match) >= 2 && 
                 (start(match)[1]==1 && 
                  start(match)[2] == 1+motive_length)){
           in_dat_return$Motiv[indel] <- as.character(motive)
           in_dat_return$RepeatSize[indel] <- 2
           in_dat_return$IndelNumber[indel] <- "DEL_repeats_2_2"
        }else if(length(match) >= 1 && start(match)[1]==1){
           in_dat_return$Motiv[indel] <- as.character(motive)
           in_dat_return$RepeatSize[indel] <- 1
           in_dat_return$IndelNumber[indel] <- "DEL_repeats_2_1"
        }else{
           in_dat_return$Motiv[indel] <- "NA"
           in_dat_return$RepeatSize[indel] <- "NA"
           in_dat_return$IndelNumber[indel] <- "NOT DEFINED"
        }
      }else if(in_dat_return$Differnce[indel] == 3){
        homologR1 <- motive[1:motive_length-1]
        homologL1 <- motive[2:motive_length]
        homologR2 <- homologR1[1:length(homologR1)-1]
        homologL2 <- homologL1[2:length(homologL1)]
       
        match_homologR1 <- matchPattern(homologR1, rest_string_R)
        match_homologL1 <- matchPattern(homologL1, rest_string_L)
        match_homologR2 <- matchPattern(homologR2, rest_string_R)
        match_homologL2 <- matchPattern(homologL2, rest_string_L)
        
  
        if(((length(as.character(match_homologL1)) != 0 | 
             length(as.character(match_homologR1)) != 0) && 
             (start(match)[1]!=1 |
              identical(as.character(match),character(0)))) && 
                 ((start(match_homologR1)[1]==1 && 
                   !is.na(start(match_homologR1)[1]==1))|
                 (end(match_homologL1)[1]==11 && 
                  !is.na(end(match_homologL1)[1]==11)))){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- "2bp"
          in_dat_return$IndelNumber[indel] <- "DEL_MH_3_2" 
        }else if(((length(as.character(match_homologL2)) != 0 | 
                   length(as.character(match_homologR2)) != 0) && 
                 (start(match)[1]!=1 | 
                  identical(as.character(match),character(0)))) &&
                 (start(match_homologR2)[1]==1 && 
                  !is.na(start(match_homologR2)[1]==1))|
                 (end(match_homologL2)[1]==11 && 
                  !is.na(end(match_homologL2)[1]==11))){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- "1bp"
          in_dat_return$IndelNumber[indel] <- "DEL_MH_3_1" 
        }else if((identical(as.character(match),character(0)) && 
                  is.na(start(match)[1]!=1))| start(match)[1]!=1 | 
                 (identical(as.character(match_homologL1),character(0)) && 
                  identical(as.character(match_homologR1),character(0)) && 
                  identical(as.character(match_homologL2),character(0)) && 
                  identical(as.character(match_homologR2),character(0)))){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- 0
          in_dat_return$IndelNumber[indel] <- "DEL_repeats_3_0"
        }else if(length(match) >= 5 && 
                 (start(match)[1]==1 && 
                  start(match)[2] == 1+motive_length && 
                  start(match)[3] == 1+(2*motive_length) &&
                  start(match)[4] == 1+(3*motive_length) && 
                  start(match)[5] == 1+(4*motive_length))){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- "5+"
          in_dat_return$IndelNumber[indel] <- "DEL_repeats_3_5+"
        }else if(length(match) >= 4 && 
                 (start(match)[1]==1 && 
                  start(match)[2] == 1+motive_length && 
                  start(match)[3] == 1+(2*motive_length) &&
                  start(match)[4] == 1+(3*motive_length))){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- 4
          in_dat_return$IndelNumber[indel] <- "DEL_repeats_3_4"
        }else if(length(match) >= 3 && 
                 (start(match)[1]==1 && 
                  start(match)[2] == 1+motive_length &&
                  start(match)[3] == 1+(2*motive_length))){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- 3
          in_dat_return$IndelNumber[indel] <- "DEL_repeats_3_3"
        }else if(length(match) >= 2 && 
                 (start(match)[1]==1 && 
                  start(match)[2] == 1+motive_length)){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- 2
          in_dat_return$IndelNumber[indel] <- "DEL_repeats_3_2"
        }else if(length(match) >= 1 && start(match)[1]==1){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- 1
          in_dat_return$IndelNumber[indel] <- "DEL_repeats_3_1"
        }else{
          in_dat_return$Motiv[indel] <- "NA"
          in_dat_return$RepeatSize[indel] <- "NA"
          in_dat_return$IndelNumber[indel] <- "NOT DEFINED"
        }
      }else if(in_dat_return$Differnce[indel] == 4){
        homologR1 <- motive[1:motive_length-1]
        homologL1 <- motive[2:motive_length]
        homologR2 <- homologR1[1:length(homologR1)-1]
        homologL2 <- homologL1[2:length(homologL1)]
        homologR3 <- homologR2[1:length(homologR2)-1]
        homologL3 <- homologL2[2:length(homologL2)]
      
        
        match_homologR1 <- matchPattern(homologR1, rest_string_R)
        match_homologL1 <- matchPattern(homologL1, rest_string_L)
        match_homologR2 <- matchPattern(homologR2, rest_string_R)
        match_homologL2 <- matchPattern(homologL2, rest_string_L)
        match_homologR3 <- matchPattern(homologR3, rest_string_R)
        match_homologL3 <- matchPattern(homologL3, rest_string_L)
        
        
        if(((length(as.character(match_homologL1)) != 0 |
             length(as.character(match_homologR1)) != 0) &&
                 (start(match)[1]!=1 | 
                  identical(as.character(match),character(0)))) && 
                 ((start(match_homologR1)[1]==1 && 
                   !is.na(start(match_homologR1)[1]==1))|
                 (end(match_homologL1)[1]==11 && 
                  !is.na(end(match_homologL1)[1]==11)))){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- "3bp"
          in_dat_return$IndelNumber[indel] <- "DEL_MH_4_3"
        }else if(((length(as.character(match_homologL2)) != 0 | 
                   length(as.character(match_homologR2)) != 0) &&
                 (start(match)[1]!=1 | 
                  identical(as.character(match),character(0)))) && 
                 ((start(match_homologR2)[1]==1 &&
                   !is.na(start(match_homologR2)[1]==1))|
                 (end(match_homologL2)[1]==11 && 
                  !is.na(end(match_homologL2)[1]==11)))){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- "2bp"
          in_dat_return$IndelNumber[indel] <- "DEL_MH_4_2"
        }else if(((length(as.character(match_homologL3)) != 0 | 
                   length(as.character(match_homologR3)) != 0) &&
                 (start(match)[1]!=1 | 
                  identical(as.character(match),character(0)))) && 
                 ((start(match_homologR3)[1]==1 && 
                   !is.na(start(match_homologR3)[1]==1))|
                 (end(match_homologL3)[1]==11 && 
                  !is.na(end(match_homologL3)[1]==11)))){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- "1bp"
          in_dat_return$IndelNumber[indel] <- "DEL_MH_4_1"
        }else if((identical(as.character(match),character(0)) && 
                  is.na(start(match)[1]!=1)) |  start(match)[1]!=1 |
                 (identical(as.character(match_homologL1),character(0)) && 
                  identical(as.character(match_homologR1),character(0)) && 
                  identical(as.character(match_homologL2),character(0)) &&
                  identical(as.character(match_homologR2),character(0)) &&
                  identical(as.character(match_homologL3),character(0)) && 
                  identical(as.character(match_homologR3),character(0)))){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- 0
          in_dat_return$IndelNumber[indel] <- "DEL_repeats_4_0" 
        }else if(length(match) >= 5 && 
                 (start(match)[1] == 1 && 
                  start(match)[2] == 1+motive_length && 
                 start(match)[3] == 1+(2*motive_length) && 
                 start(match)[4] == 1+(3*motive_length) && 
                 start(match)[5] == 1+(4*motive_length))){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- "5+"
          in_dat_return$IndelNumber[indel] <- "DEL_repeats_4_5+" 
        }else if(length(match) >= 4 &&
                 (start(match)[1] == 1 &&
                  start(match)[2] == 1+motive_length && 
                  start(match)[3] == 1+(2*motive_length) &&
                  start(match)[4] == 1+(3*motive_length))){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- 4
          in_dat_return$IndelNumber[indel] <- "DEL_repeats_4_4" 
        }else if(length(match) >= 3 && 
                 (start(match)[1]==1 && 
                  start(match)[2] == 1+motive_length && 
                  start(match)[3] == 1+(2*motive_length))){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- 3
          in_dat_return$IndelNumber[indel] <- "DEL_repeats_4_3" 
        }else if(length(match) >= 2 &&
                 (start(match)[1]==1 && 
                  start(match)[2] == 1+motive_length)){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- 2
          in_dat_return$IndelNumber[indel] <- "DEL_repeats_4_2" 
        }else if(length(match) >= 1 && start(match)[1]==1){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- 1
          in_dat_return$IndelNumber[indel] <- "DEL_repeats_4_1" 
        }else{
          in_dat_return$Motiv[indel] <- "NA"
          in_dat_return$RepeatSize[indel] <- "NA"
          in_dat_return$IndelNumber[indel] <- "NOT DEFINED"
        }
      }else if(in_dat_return$Differnce[indel] >= 5){
        
           motive_first_5bp <- motive[1:5]
           start_last_5bp <- (motive_length-5)+1
           motive_last_5bp <- motive[start_last_5bp:motive_length]
           
           homologR1 <- motive_first_5bp
           homologL1 <- motive_last_5bp
           homologR2 <- homologR1[1:length(homologR1)-1]
           homologL2 <- homologL1[2:length(homologL1)]
           homologR3 <- homologR2[1:length(homologR2)-1]
           homologL3 <- homologL2[2:length(homologL2)]
           homologR4 <- homologR3[1:length(homologR3)-1]
           homologL4 <- homologL3[2:length(homologL3)]
           homologR5 <- homologR4[1:length(homologR4)-1]
           homologL5 <- homologL4[2:length(homologL4)]
           
           
           match_homologR1 <- matchPattern(homologR1, rest_string_R)
           match_homologL1 <- matchPattern(homologL1, rest_string_L)
           match_homologR2 <- matchPattern(homologR2, rest_string_R)
           match_homologL2 <- matchPattern(homologL2, rest_string_L)
           match_homologR3 <- matchPattern(homologR3, rest_string_R)
           match_homologL3 <- matchPattern(homologL3, rest_string_L)
           match_homologR4 <- matchPattern(homologR4, rest_string_R)
           match_homologL4 <- matchPattern(homologL4, rest_string_L)
           match_homologR5 <- matchPattern(homologR5, rest_string_R)
           match_homologL5 <- matchPattern(homologL5, rest_string_L)
           
         if(length(match) >= 5 && 
            (start(match)[1]==1 &&
             start(match)[2] == 1+motive_length &&
             start(match)[3] == 1+(2*motive_length) &&
             start(match)[4] == 1+(3*motive_length) &&
             start(match)[5] == 1+(4*motive_length))){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- "5+"
          in_dat_return$IndelNumber[indel] <- "DEL_repeats_5+_5+"
        }else if(length(match) >= 4 && 
                 (start(match)[1]==1 && 
                  start(match)[2] == 1+motive_length && 
                  start(match)[3] == 1+(2*motive_length) && 
                  start(match)[4] == 1+(3*motive_length))){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- 4
          in_dat_return$IndelNumber[indel] <- "DEL_repeats_5+_4"
        }else if(length(match) >= 3 &&
                 (start(match)[1]==1 &&
                 start(match)[2] == 1+motive_length &&
                 start(match)[3] == 1+(2*motive_length))){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- 3
          in_dat_return$IndelNumber[indel] <- "DEL_repeats_5+_3"
        }else if(length(match) >= 2 && 
                 (start(match)[1]==1 && 
                 start(match)[2] == 1+motive_length)){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- 3
          in_dat_return$IndelNumber[indel] <- "DEL_repeats_5+_2"
        }else if(length(match) >= 1 && start(match)[1]==1){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- 1
          in_dat_return$IndelNumber[indel] <- "DEL_repeats_5+_1"
        }else if(((length(as.character(match_homologL1)) != 0 | 
                   length(as.character(match_homologR1)) != 0) && 
                 (start(match)[1]!=1 | 
                  identical(as.character(match),character(0)))) &&
                ((start(match_homologR1)[1]==1 && 
                  !is.na(start(match_homologR1)[1]==1))|
                 (end(match_homologL1)[1]==11 && 
                  !is.na(end(match_homologL1)[1]==11)))){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- "5bp"
          in_dat_return$IndelNumber[indel] <- "DEL_MH_5+_5+"
        }else if(((length(as.character(match_homologL2)) != 0 | 
                   length(as.character(match_homologR2)) != 0) && 
                  (start(match)[1]!=1 | 
                   identical(as.character(match),character(0)))) &&
                 ((start(match_homologR2)[1]==1 && 
                   !is.na(start(match_homologR2)[1]==1))|
                  (end(match_homologL2)[1]==11 && 
                   !is.na(end(match_homologL2)[1]==11)))){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- "4bp"
          in_dat_return$IndelNumber[indel] <- "DEL_MH_5+_4"
        }else if(((length(as.character(match_homologL3)) != 0 |
                   length(as.character(match_homologR3)) != 0) &&
                  (start(match)[1]!=1 | 
                   identical(as.character(match),character(0))))&&
                 ((start(match_homologR3)[1]==1 &&
                   !is.na(start(match_homologR3)[1]==1))|
                  (end(match_homologL3)[1]==11 &&
                   !is.na(end(match_homologL3)[1]==11)))){
            in_dat_return$Motiv[indel] <- as.character(motive)
            in_dat_return$RepeatSize[indel] <- "3bp"
            in_dat_return$IndelNumber[indel] <- "DEL_MH_5+_3"
        }else if(((length(as.character(match_homologL4)) != 0 |
                   length(as.character(match_homologR4)) != 0) && 
                  (start(match)[1]!=1 | 
                   identical(as.character(match),character(0))))&&
                 ((start(match_homologR4)[1]==1 && 
                   !is.na(start(match_homologR4)[1]==1))|
                  (end(match_homologL4)[1]==11 &&
                   !is.na(end(match_homologL4)[1]==11)))){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- "2bp"
          in_dat_return$IndelNumber[indel] <- "DEL_MH_5+_2"
        }else if(((length(as.character(match_homologL5)) != 0 |
                   length(as.character(match_homologR5)) != 0) &&
                  (start(match)[1]!=1 | 
                   identical(as.character(match),character(0)))) &&
                 ((start(match_homologR5)[1]==1 && 
                   !is.na(start(match_homologR5)[1]==1))|
                  (end(match_homologL5)[1]==11 &&
                   !is.na(end(match_homologL5)[1]==11)))){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- "1bp"
          in_dat_return$IndelNumber[indel] <- "DEL_MH_5+_1"
        }else if(((identical(as.character(match),character(0)) && 
                   is.na(start(match)[1]!=1)) |  start(match)[1]!=1 | 
                  identical(as.character(match_homologL1),character(0)) &&
                  identical(as.character(match_homologR1),character(0)) &&
                  identical(as.character(match_homologL2),character(0)) && 
                  identical(as.character(match_homologR2),character(0)) && 
                  identical(as.character(match_homologL3),character(0)) && 
                  identical(as.character(match_homologR3),character(0)) &&
                  identical(as.character(match_homologL4),character(0)) && 
                  identical(as.character(match_homologR4),character(0))) &&
                  identical(as.character(match_homologL5),character(0)) && 
                 identical(as.character(match_homologR5),character(0))
                 ){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- 0
          in_dat_return$IndelNumber[indel] <- "DEL_repeats_5+_0"
        }else{
          in_dat_return$Motiv[indel] <- "NA"
          in_dat_return$RepeatSize[indel] <- "NA"
          in_dat_return$IndelNumber[indel] <- "NOT DEFINED"
        }
      }
    }else{
      if(in_dat_return$Differnce[indel] == 1){
        if(start(match)[1]==1 && 
           start(match)[2] == 1+motive_length && 
           start(match)[3] == 1+(2*motive_length) && 
           start(match)[4] == 1+(3*motive_length) && 
           start(match)[5] == 1+(4*motive_length)){
          if(as.character(motive)== "T" | as.character(motive) == "A"){
            in_dat_return$Motiv[indel] <- "T:A"
            in_dat_return$RepeatSize[indel] <- "5+"
            in_dat_return$IndelNumber[indel] <- "INS_T_1_5+"
          }else{
            in_dat_return$Motiv[indel] <- "C:G"
            in_dat_return$RepeatSize[indel] <- "5+"
            in_dat_return$IndelNumber[indel] <- "INS_C_1_5+"
          }
        }else if(start(match)[1]==1 && 
                 start(match)[2] == 1+motive_length &&
                 start(match)[3] == 1+(2*motive_length) && 
                 start(match)[4] == 1+(3*motive_length)){
          if(as.character(motive)== "T" | as.character(motive) == "A"){
            in_dat_return$Motiv[indel] <- "T:A"
            in_dat_return$RepeatSize[indel] <- 4
            in_dat_return$IndelNumber[indel] <- "INS_T_1_4"
          }else{
            in_dat_return$Motiv[indel] <- "C:G"
            in_dat_return$RepeatSize[indel] <- 4
            in_dat_return$IndelNumber[indel] <- "INS_C_1_4"
          }
        }else if(start(match)[1]==1 && 
                 start(match)[2] == 1+motive_length && 
                 start(match)[3] == 1+(2*motive_length)){
          if(as.character(motive)== "T" | as.character(motive) == "A"){
            in_dat_return$Motiv[indel] <- "T:A"
            in_dat_return$RepeatSize[indel] <- 3
            in_dat_return$IndelNumber[indel] <- "INS_T_1_3"
          }else{
            in_dat_return$Motiv[indel] <- "C:G"
            in_dat_return$RepeatSize[indel] <- 3
            in_dat_return$IndelNumber[indel] <- "INS_C_1_3"
          }
        }else if(start(match)[1]==1 && start(match)[2] == 1+motive_length){
          if(as.character(motive)== "T" | as.character(motive) == "A"){
            in_dat_return$Motiv[indel] <- "T:A"
            in_dat_return$RepeatSize[indel] <- 2
            in_dat_return$IndelNumber[indel] <- "INS_T_1_2"
          }else{
            in_dat_return$Motiv[indel] <- "C:G"
            in_dat_return$RepeatSize[indel] <- 2
            in_dat_return$IndelNumber[indel] <- "INS_C_1_2"
          }
        }else if(start(match)[1]==1){
          if(as.character(motive)== "T" | as.character(motive) == "A"){
            in_dat_return$Motiv[indel] <- "T:A"
            in_dat_return$RepeatSize[indel] <- 1
            in_dat_return$IndelNumber[indel] <- "INS_T_1_1"
          }else{
            in_dat_return$Motiv[indel] <- "C:G"
            in_dat_return$RepeatSize[indel] <- 1
            in_dat_return$IndelNumber[indel] <- "INS_C_1_1"
          }
        }else{
          if(as.character(motive)== "T" | as.character(motive) == "A"){
            in_dat_return$Motiv[indel] <- "T:A"
            in_dat_return$RepeatSize[indel] <- 0
            in_dat_return$IndelNumber[indel] <- "INS_T_1_0"
          }else{
            in_dat_return$Motiv[indel] <- "C:G"
            in_dat_return$RepeatSize[indel] <- 0
            in_dat_return$IndelNumber[indel] <- "INS_C_1_0"  
          }
        }
      }else if(in_dat_return$Differnce[indel] == 2){
        if (identical(as.character(match),character(0)) | start(match)[1]!=1){
            in_dat_return$Motiv[indel] <- as.character(motive)
            in_dat_return$RepeatSize[indel] <- 0
            in_dat_return$IndelNumber[indel] <- "INS_repeats_2_0"
        }else if(length(match) >= 5 &&
                 (start(match)[1]==1 && 
                  start(match)[2] == 1+motive_length && 
                  start(match)[3] == 1+(2*motive_length) &&
               start(match)[4] == 1+(3*motive_length) &&
               start(match)[5] == 1+(4*motive_length))){
            in_dat_return$Motiv[indel] <- as.character(motive)
            in_dat_return$RepeatSize[indel] <- "5+"
            in_dat_return$IndelNumber[indel] <- "INS_repeats_2_5+"
        }else if(length(match) >= 4 && 
                 (start(match)[1]==1 && 
                  start(match)[2] == 1+motive_length &&
                  start(match)[3] == 1+(2*motive_length) &&
                start(match)[4] == 1+(3*motive_length))){
            in_dat_return$Motiv[indel] <- as.character(motive)
            in_dat_return$RepeatSize[indel] <- 4
            in_dat_return$IndelNumber[indel] <- "INS_repeats_2_4"
        }else if(length(match) >= 3 &&
                 (start(match)[1]==1 &&
                  start(match)[2] == 1+motive_length &&
                  start(match)[3] == 1+(2*motive_length))){
            in_dat_return$Motiv[indel] <- as.character(motive)
            in_dat_return$RepeatSize[indel] <- 3
            in_dat_return$IndelNumber[indel] <- "INS_repeats_2_3"
        }else if(length(match) >= 2 &&
                 (start(match)[1]==1 &&
                  start(match)[2] == 1+motive_length)){
            in_dat_return$Motiv[indel] <- as.character(motive)
            in_dat_return$RepeatSize[indel] <- 2
            in_dat_return$IndelNumber[indel] <- "INS_repeats_2_2"
        }else if(length(match) >= 1 && start(match)[1]==1){
            in_dat_return$Motiv[indel] <- as.character(motive)
            in_dat_return$RepeatSize[indel] <- 1
            in_dat_return$IndelNumber[indel] <- "INS_repeats_2_1"
        }else{
            in_dat_return$Motiv[indel] <- "NA"
            in_dat_return$RepeatSize[indel] <- "NA"
            in_dat_return$IndelNumber[indel] <- "NOT DEFINED"
        }
      }else if(in_dat_return$Differnce[indel] == 3){
        if (identical(as.character(match),character(0))| start(match)[1]!=1){
            in_dat_return$Motiv[indel] <- as.character(motive)
            in_dat_return$RepeatSize[indel] <- 0
            in_dat_return$IndelNumber[indel] <- "INS_repeats_3_0"
        }else if(length(match) >= 5 && 
                 (start(match)[1]==1 && 
                  start(match)[2] == 1+motive_length &&
                  start(match)[3] == 1+(2*motive_length) &&
                  start(match)[4] == 1+(3*motive_length) && 
                  start(match)[5] == 1+(4*motive_length))){
            in_dat_return$Motiv[indel] <- as.character(motive)
            in_dat_return$RepeatSize[indel] <- "5+"
            in_dat_return$IndelNumber[indel] <- "INS_repeats_3_5+"
        }else if (length(match) >= 4 && 
                  (start(match)[1]==1 && 
                   start(match)[2] == 1+motive_length && 
                   start(match)[3] == 1+(2*motive_length) &&
                start(match)[4] == 1+(3*motive_length))){
            in_dat_return$Motiv[indel] <- as.character(motive)
            in_dat_return$RepeatSize[indel] <- 4
            in_dat_return$IndelNumber[indel] <- "INS_repeats_3_4"
        }else if(length(match) >= 3 && 
                 (start(match)[1]==1 && 
                  start(match)[2] == 1+motive_length && 
                  start(match)[3] == 1+(2*motive_length))){
            in_dat_return$Motiv[indel] <- as.character(motive)
            in_dat_return$RepeatSize[indel] <- 3
            in_dat_return$IndelNumber[indel] <- "INS_repeats_3_3"
        }else if(length(match) >= 2 &&
                 (start(match)[1]==1 &&
                  start(match)[2] == 1+motive_length)){
            in_dat_return$Motiv[indel] <- as.character(motive)
            in_dat_return$RepeatSize[indel] <- 2
            in_dat_return$IndelNumber[indel] <- "INS_repeats_3_2"
        }else if(length(match) >= 1 && start(match)[1]==1){
            in_dat_return$Motiv[indel] <- as.character(motive)
            in_dat_return$RepeatSize[indel] <- 1
            in_dat_return$IndelNumber[indel] <- "INS_repeats_3_1"
        }else{
            in_dat_return$Motiv[indel] <- "NA"
            in_dat_return$RepeatSize[indel] <- "NA"
            in_dat_return$IndelNumber[indel] <- "NOT DEFINED"
        }
        }else if(in_dat_return$Differnce[indel] == 4){
        if (identical(as.character(match),character(0)) | start(match)[1]!=1){
            in_dat_return$Motiv[indel] <- as.character(motive)
            in_dat_return$RepeatSize[indel] <- 0
            in_dat_return$IndelNumber[indel] <- "INS_repeats_4_0"
        }else if(length(match) >= 5 && 
                 (start(match)[1]==1 && 
                  start(match)[2] == 1+motive_length &&
                  start(match)[3] == 1+(2*motive_length) &&
               start(match)[4] == 1+(3*motive_length) &&
               start(match)[5] == 1+(4*motive_length))){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- "5+"
          in_dat_return$IndelNumber[indel] <- "INS_repeats_4_5+"
        }else if(length(match) >= 4 &&
                 (start(match)[1]==1 &&
                  start(match)[2] == 1+motive_length && 
                  start(match)[3] == 1+(2*motive_length) &&
                start(match)[4] == 1+(3*motive_length))){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- 4
          in_dat_return$IndelNumber[indel] <- "INS_repeats_4_4"
        }else if(length(match) >= 3 &&
                 (start(match)[1]==1 && 
                  start(match)[2] == 1+motive_length &&
                  start(match)[3] == 1+(2*motive_length))){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- 3
          in_dat_return$IndelNumber[indel] <- "INS_repeats_4_3"
        }else if(length(match) >= 2 &&
                 (start(match)[1]==1 && 
                  start(match)[2] == 1+motive_length)){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- 2
          in_dat_return$IndelNumber[indel] <- "INS_repeats_4_2"
        }else if(length(match) >= 1 && start(match)[1]==1){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- 1
          in_dat_return$IndelNumber[indel] <- "INS_repeats_4_1"
        }else{
          in_dat_return$Motiv[indel] <- "NA"
          in_dat_return$RepeatSize[indel] <- "NA"
          in_dat_return$IndelNumber[indel] <- "NOT DEFINED"
          }
      }else if(in_dat_return$Differnce[indel] >= 5){
        if (identical(as.character(match),character(0))| start(match)[1]!=1){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- 0
          in_dat_return$IndelNumber[indel] <- "INS_repeats_5+_0"
        }else if(length(match) >= 5 && 
                 (start(match)[1]==1 && 
                  start(match)[2] == 1+motive_length && 
                  start(match)[3] == 1+(2*motive_length) &&
               start(match)[4] == 1+(3*motive_length) && 
               start(match)[5] == 1+(4*motive_length))){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- "5+"
          in_dat_return$IndelNumber[indel] <- "INS_repeats_5+_5+"
        }else if(length(match) >= 4 &&
                 (start(match)[1]==1 && 
                  start(match)[2] == 1+motive_length && 
                  start(match)[3] == 1+(2*motive_length) &&
                start(match)[4] == 1+(3*motive_length))){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- 4
          in_dat_return$IndelNumber[indel] <- "INS_repeats_5+_4"
        }else if(length(match) >= 3 &&
                 (start(match)[1]==1 && 
                  start(match)[2] == 1+motive_length && 
                  start(match)[3] == 1+(2*motive_length))){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- 3
          in_dat_return$IndelNumber[indel] <- "INS_repeats_5+_3"
        }else if(length(match) >= 2 && 
                 (start(match)[1]==1 && 
                  start(match)[2] == 1+motive_length)){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- 2
          in_dat_return$IndelNumber[indel] <- "INS_repeats_5+_2"
        }else if(length(match) >= 1 && start(match)[1]==1){
          in_dat_return$Motiv[indel] <- as.character(motive)
          in_dat_return$RepeatSize[indel] <- 1
          in_dat_return$IndelNumber[indel] <- "INS_repeats_5+_1"
        }else{
          in_dat_return$Motiv[indel] <- "NA"
          in_dat_return$RepeatSize[indel] <- "NA"
          in_dat_return$IndelNumber[indel] <- "NOT DEFINED"
          }
        }
      }  
    }   
return(in_dat_return)}  

#' Plot the spectra of nucleotide exchanges of INDELs
#'
#' Plots the spectra of nucelotides in their triplet contexts. If several
#' columns are present in the input data frame, the spectra are ploted for every
#' column seperatly. The function is only suitable for a INDEL spectra and for
#' SNV representation the funtion \code{\link[YAPSA]{plotExchangeSpectra}}
#' should be used.
#'
#' @param in_catalogue_df Numerical data frame encoding the exchange spectra to
#'   be displayed, either a mutational catalogue \code{V} or a signatures matrix
#'   \code{W}
#'
#' @param in_colour_vector Specifies the colours of the INDELs if non-null
#' @param in_show_indel Whether or not to show the INDEL names on the x-axis
#' @param in_show_axis_title Whether or not to show the name of the y-axis
#' @param in_scales Argument passed on to \code{\link[ggplot2]{facet_grid}}
#' @param in_refLine If non-null, value on the y-axis at which a horizontal line
#'   is to be drawn
#' @param in_refAlpha Transparency of the horizontal line if it is to be drawn
#' @param in_background Option to provide a background theme, e.g.
#'   \code{\link[ggplot2]{theme_grey}}

#'
#' @return The generated barplot - a ggplot2 plot
#'
#' @export
#' @importFrom reshape2 melt
#' @import ggplot2
#' @examples
#' data(sigs_pcawg)
#' plotExchangeSpectra_indel(PCAWG_SP_ID_sigs_df[,c(6,8)])
#' 
plotExchangeSpectra_indel <- function (in_catalogue_df, 
                                       in_colour_vector = NULL,
                                       in_show_indel = FALSE, 
                                       in_show_axis_title = FALSE, 
                                       in_scales = "free_x",
                                       in_refLine = NULL, 
                                       in_refAlpha = 0.5, 
                                       in_background = NULL){
  .e <- environment()
  in_catalogue_df$indel_exchange <- rownames(in_catalogue_df)
  in_catalogue_df$nuc_exchange <- c(rep("DEL_C", 6),rep("DEL_T",6),
                                    rep("INS_C",6),rep("INS_T",6),
                                    rep("DEL_2", 6),rep("DEL_3", 6),
                                    rep("DEL_4", 6),rep("DEL_5+", 6),
                                    rep("INS_2", 6),rep("INS_3", 6),
                                    rep("INS_4", 6),rep("INS_5+", 6),
                                    rep("MH_2", 1),rep("MH_3", 2),
                                    rep("MH_4", 3),rep("MH_5+", 5))
  in_catalogue_df$repetion <- c(rep(c(1,2,3,4,5,"6+"), 2), 
                                rep(c(0,1,2,3,4,"5+"), 2), 
                                rep(c(1,2,3,4,5,"6+"), 4),
                                rep(c(0,1,2,3,4,"5+"), 4), 
                                1,1,2,1,2,3,1,2,3,4,"5+")
  catalogue_df_melt <- melt(in_catalogue_df, id.vars = c("nuc_exchange", 
                                                         "repetion", 
                                                         "indel_exchange"))
  catalogue_df_melt$nuc_exchange <- factor(catalogue_df_melt$nuc_exchange, 
                              levels = unique(catalogue_df_melt$nuc_exchange))
  
  my_palette <- c("tan1", "darkorange1", "darkseagreen3", "forestgreen", 
                  "rosybrown1", "salmon", "red3","darkred",
                  "#C9DFF3", "skyblue2", "steelblue3", "steelblue4",
                  "#D4D9FF", "#BFC1E6","#8E8EBE", "mediumpurple4")
  names(my_palette) <- c("DEL_C", "DEL_T", "INS_C", "INS_T",
                         paste0("DEL_", c(2:4, "5+")),
                         paste0("INS_", c(2:4, "5+")),
                         paste0("MH_", c(2:4, "5+")))
  if (!is.null(in_colour_vector)) 
    my_palette <- in_colour_vector
  
  p <- ggplot(catalogue_df_melt, 
              environment = .e) + geom_bar(aes_string(x = "repetion", 
                                                      y = "value",
                                                      fill = "nuc_exchange"),
                                                      stat = "identity") + 
    scale_fill_manual(name = "exchange", values = my_palette) + 
    facet_grid(variable ~ nuc_exchange, scales = in_scales, space = in_scales)+
    theme(strip.text.x = element_text(size=7))
    #theme(strip.background = element_rect(fill = my_palette))
  if (!is.null(in_background)) {
    p <- p + in_background
  }
  if (is.numeric(in_refLine)) {
    p <- p + geom_hline(yintercept = in_refLine, alpha = in_refAlpha)
  }
  p1 <- p + theme(axis.title.x = element_blank(),
                  axis.text.x = element_blank(), 
                  axis.ticks.x = element_blank())
  if (in_show_indel) {
    p1 <- p + theme(axis.title.x = element_blank(), 
                    axis.text.x = element_text(angle = 0, 
                    vjust = 0.5), axis.ticks.x = element_blank())
  }
  if (!in_show_axis_title) 
    p1 <- p1 + theme(axis.title.y = element_blank())
  return(p1)
}  

#' Create a Mutational catalog from a data frame
#'
#' This function creates a mutational catalog from a data frame. It requires the
#' returend data frame optainted with
#' \code{\link[YAPSA]{attribution_of_indels}}.
#'
#' @param in_df A data frame constucted from a vcf-like file of a whole cohort
#'   or single-sample. The first coloums are those of a standart vcf file,
#'   followed by an arbitrary number of customs or used defined columns. One if
#'   these can carry a PID (patient or sample identefyier) and the subgroup
#'   information. Additionaly to consuct the the mutational catalog each variant
#'   needs to be characterize into one of the 83 INDEL feature classes, which
#'   can be perfomed with \code{\link[YAPSA]{attribution_of_indels}}
#' @param in_signatures_df A numeric data frame \code{W} with \code{n} rows and
#'   \code{l} columns, \code{n} being the number of features and \code{l} being
#'   the number of signatures.Data frame containing INDEL signatures which
#'   should be used to create the mutational cataolog \code{V}.
#'
#' @return A count dataframe, the mutational catalog \code{V} with rownames
#'   indicating the INDELs and colnames having the PIDs
#'
#' @export
#' @importFrom reshape2 melt
#' @importFrom Biostrings DNAString subseq matchPattern xscat
#'
#' @examples
#' data(GenomeOfNl_raw)
#' data(sigs_pcawg)
#' GenomeOfNl_context <- attribute_sequence_contex_indel(in_dat =
#'  head(GenomeOfNl_raw))
#' GenomeOfNl_classified <- attribution_of_indels(GenomeOfNl_context)
#' GenomeOfNl_mut_cat <- create_indel_mut_cat_from_df(GenomeOfNl_classified,
#'  in_signatures_df=PCAWG_SP_ID_sigs_df)
#' 
create_indel_mut_cat_from_df <- function(in_df, in_signatures_df){
  PID <- unique(in_df$PID)
  count_df <- data.frame(matrix(data = 0, nrow = dim(in_signatures_df)[1], 
                                ncol=0), row.names = rownames(in_signatures_df))
  for(pid in PID){
    in_subset_df <- subset(in_df, in_df$PID %in% list(pid), drop =TRUE)
    count_per_pid <- data.frame(table(in_subset_df$IndelNumber))
    rownames(count_per_pid) <- count_per_pid$Var1
    count_per_pid$Var1 <- NULL
    colnames(count_per_pid) <- pid
    count_df <- setNames(
      cbind(count_df, 
            count_per_pid[, pid][match(rownames(count_df),
                                       rownames(count_per_pid))]),
                         c(colnames(count_df),pid))
  }
  count_df[is.na(count_df)] <- 0
  return(count_df)
}

#' Wrapper to create an INDEL mutational catalog from a vlf-like data frame
#'
#' From data frame constucted from a vcf-file file the function
#' \code{\link[YAPSA]{create_indel_mutation_catalogue_from_df}} creates a
#' mutational catalog V by squencially applying the
#' \code{\link[YAPSA]{attribute_sequence_contex_indel}},
#' \code{\link[YAPSA]{attribute_sequence_contex_indel}} and then
#' \code{\link[YAPSA]{attribution_of_indels}}. The runtime of the function is
#' about 1 sec per 6 variants as sequence context as well as INDEL
#' calssification are timeconsuming to compute (optimization ongoing)
#'
#' @param in_dat A data frame constructed from a vcf-like file of a whole cohort
#'   or single-sample. The first columns are those of a standard vcf file
#'   (\code{CHROM}, \code{POS}, \code{REF} and \code{ALT}), followed by an
#'   arbitrary number of custom or used defined columns. One of these can carry
#'   a PID (patient or sample identifyier) and one can carry subgroup
#'   information.
#' @param in_signature_df A numeric data frame \code{W} with \code{n} rows and
#'   \code{l} columns, n being the number of features and l being the number od
#'   signatures. Data frame containing INDEL signatures which should be used to
#'   create the mutational cataologe \code{V}.
#' @param in_REF.field String indicating which column of \code{in_dat} carries
#'   the reference base if dealing with data frames
#' @param in_ALT.field String indicating which column of \code{in_dat} carries
#'   the variant base if dealing with data frames
#' @param in_verbose Verbose if \code{in_verbose=1}
#'
#'
#' @return A dataframe in the format of a mutational catalog \code{V}, which can
#' be used for \code{\link[YAPSA]{LCD}} analysis
#'
#' @importFrom reshape2 melt
#' @import ggplot2
#' @importFrom Biostrings getSeq DNAString subseq matchPattern xscat
#' @import BSgenome.Hsapiens.UCSC.hg19
#' @export
#'
#' @examples
#' data(sigs_pcawg)
#' data(GenomeOfNl_raw)
#' temp_df <- translate_to_hg19(GenomeOfNl_raw[1:200,],"CHROM")
#' temp_df$PID <- sample(c("PID1","PID2","PID3","PID4","PID5"),200,replace=TRUE)
#' temp <- create_indel_mutation_catalogue_from_df(in_dat = temp_df,
#'    in_signature_df = PCAWG_SP_ID_sigs_df,
#'    in_REF.field = "REF",
#'    in_ALT.field = "ALT",
#'    in_verbose = FALSE)
#' dim(temp)
#' head(temp)
#' 
create_indel_mutation_catalogue_from_df <- function(in_dat, 
                                                    in_signature_df, 
                                                    in_REF.field="REF",
                                                    in_ALT.field="ALT",
                                                    in_verbose = FALSE){
  indel_context_atrribution <- attribute_sequence_contex_indel(
    in_dat, 
    in_REF.field=in_REF.field,
    in_ALT.field=in_ALT.field, 
    in_verbose = FALSE)
  indel_classification_attribution <- attribution_of_indels(
    in_dat_return = indel_context_atrribution)
  indel_mut_cat_creation <- create_indel_mut_cat_from_df(
    indel_classification_attribution, in_signature_df)
  return(indel_mut_cat_creation)
}


#' Wrapper to compute confidence intervals for SNV and INDEL signatures of a
#' cohort or single-sample
#'
#' Wrapper function around \code{\link[YAPSA]{confIntExp}}, which is applies to
#' every signature or sample pair in a cohort. The extracted lower bound of the
#' confidence intervals are added to the input data which is reodered and melted
#' in order to prepare for visualization with ggplot2. The calculates of
#' confidence intervals is based on a profiling likelihood algorithm and the
#' wrapper calculates the data for the exposure contubution identefied with SNV
#' and INDEL signature decompositions and application of the following cutoffs:
#' \enumerate{ \item \code{CosmicValid_absCutoffVector} \item
#' \code{CosmicValid_normCutoffVector} \item \code{CosmicArtif_absCutoffVector}
#' \item \code{CosmicArtif_normCutoffVector} \item
#' \code{PCAWGValidSNV_absCutoffVector} \item
#' \code{PCAWGValidID_absCutoffVector} } The function makes use of differnet
#' YAPSA functions. For each of the above stated cutoff vectors a per PID
#' decompostion of the SNV and INDEL catalog is calulated respectivly using
#' \code{\link[YAPSA]{LCD_complex_cutoff_perPID}}. In a next step,
#' \code{\link[YAPSA]{variateExp}} wich is a wrapper around
#' \code{\link[YAPSA]{confIntExp}} to compute confidence intervals for a cohort
#' is used. A dataframe is returend with the upper and lower bounds of the
#' confidence intervals. In a last step
#' \code{\link[YAPSA]{plotExposuresConfidence_indel}} to plot the exposures to
#' extracted signatures including confidence intervals computed with e.g. by
#' \code{\link[YAPSA]{variateExp}}.
#'
#'
#' @param in_current_indel_df A INDEL mutational catalog. Mutational catalog can
#'   be constucted with
#'   \code{\link[YAPSA]{create_indel_mutation_catalogue_from_df}}
#' @param in_current_snv_df A SNV mutational catalog. Mutational catalog can be
#'   constuced with \code{\link[YAPSA]{create_mutation_catalogue_from_df}}
#'
#' @return A list is returned containing 12 objects. For each cutoff data frame
#'   two corrosponding object are present. First, the \code{p} gtable object
#'   which can be used for gaphically visualization, and second a dataframe
#'   containing  the corrosponding upper and lower bounds of the confidence
#'   intervals.
#'
#' @export
#'
#' @examples
#' data("GenomeOfNl_MutCat")
#' 
confidence_indel_calulation <- function(in_current_indel_df, 
                                        in_current_snv_df){
  data(sigs_pcawg, envir = environment())
  data(cutoffs_pcawg, envir = environment())
  data(sigs, envir = environment())
  data(cutoffs, envir = environment())
  
  CosmicValid_absCutoffVector <- cutoffCosmicValid_abs_df[6, ]
  CosmicValid_normCutoffVector <- cutoffCosmicValid_rel_df[6, ]
  CosmicArtif_absCutoffVector <- cutoffCosmicArtif_abs_df[6, ]
  CosmicArtif_normCutoffVector <- cutoffCosmicArtif_rel_df[6, ]
  
  PCAWGValidSNV_absCutoffVector <- cutoffPCAWG_SBS_WGSWES_realPid_df[13, ]
  PCAWGValidID_absCutoffVector <- cutoffPCAWG_ID_WGS_Pid_df[3, ]
  
  current_id_catalogue_df <- data.frame(in_current_indel_df)
  current_snv_catalogue_df <- data.frame(in_current_snv_df)
  
  
  PCAWGValidSNV_abs_LCDlist <- LCD_complex_cutoff_perPID(
    in_mutation_catalogue_df = current_snv_catalogue_df,
    in_signatures_df = PCAWG_SP_SBS_sigs_Real_df,
    in_cutoff_vector = PCAWGValidSNV_absCutoffVector,
    in_filename = NULL,
    in_method = "abs",
    in_sig_ind_df = PCAWG_SP_SBS_sigInd_Real_df)
  
  PCAWGValidID_abs_LCDlist <- LCD_complex_cutoff_perPID(
    in_mutation_catalogue_df = current_id_catalogue_df,
    in_signatures_df = PCAWG_SP_ID_sigs_df,
    in_cutoff_vector = PCAWGValidID_absCutoffVector,
    in_filename = NULL,
    in_method = "abs",
    in_sig_ind_df = PCAWG_SP_ID_sigInd_df)
  
 CosmicValid_abs_LCDlist <- LCD_complex_cutoff_perPID(
    in_mutation_catalogue_df = current_snv_catalogue_df,
    in_signatures_df = AlexCosmicValid_sig_df,
    in_cutoff_vector = CosmicValid_absCutoffVector,
    in_filename = NULL,
    in_method = "abs",
    in_sig_ind_df = AlexCosmicValid_sigInd_df)
  
  CosmicValid_norm_LCDlist <- LCD_complex_cutoff_perPID(
    in_mutation_catalogue_df = current_snv_catalogue_df,
    in_signatures_df = AlexCosmicValid_sig_df,
    in_cutoff_vector = CosmicValid_normCutoffVector,
    in_filename = NULL,
    in_method = "abs",
    in_sig_ind_df = AlexCosmicValid_sigInd_df)
  
  CosmicArtif_abs_LCDlist <- LCD_complex_cutoff_perPID(
    in_mutation_catalogue_df = current_snv_catalogue_df,
    in_signatures_df = AlexCosmicArtif_sig_df,
    in_cutoff_vector = CosmicArtif_absCutoffVector,
    in_filename = NULL,
    in_method = "abs",
    in_sig_ind_df = AlexCosmicArtif_sigInd_df)
  
  CosmicArtif_norm_LCDlist <- LCD_complex_cutoff_perPID(
    in_mutation_catalogue_df = current_snv_catalogue_df,
    in_signatures_df = AlexCosmicArtif_sig_df,
    in_cutoff_vector = CosmicArtif_normCutoffVector,
    in_filename = NULL,
    in_method = "abs",
    in_sig_ind_df = AlexCosmicArtif_sigInd_df)
  
  
  
  
  exposures_list <- list(PCAWGValidSNV_abs =PCAWGValidSNV_abs_LCDlist$exposures,
                         PCAWGValidID_abs = PCAWGValidID_abs_LCDlist$exposures,
                         CosmicValid_abs = CosmicValid_abs_LCDlist$exposures,
                         CosmicValid_norm = CosmicValid_norm_LCDlist$exposures,
                         CosmicArtif_abs = CosmicArtif_abs_LCDlist$exposures,
                         CosmicArtif_norm = CosmicArtif_norm_LCDlist$exposures)
  
  name_list <- names(exposures_list)
  exposures_list <- lapply(seq_along(exposures_list),FUN=function(current_ind){
    current_df <- exposures_list[[current_ind]]
    names(current_df) <- name_list[current_ind]
    return(current_df)
  })
  
  
  names(exposures_list) <- name_list
  
  exposures_list <- lapply(exposures_list, function(list){
    colnames(list) <- colnames(current_id_catalogue_df)
    return(list)
  })
  
  subgroups_df <- data.frame(
    PID = colnames(exposures_list[[1]]), subgroup = "test", sum = 1, 
    compl_sum = 1, index = seq_along(exposures_list[[1]]), col = "#FF0000FF")
  
  
  
  complete_df_list <- lapply(name_list, function(current_condition){
    print(current_condition)
   if(grepl("CosmicValid_abs|CosmicValid_norm|CosmicArtif_abs|CosmicArtif_norm",
             current_condition)){
      current_exposures_df <- exposures_list[[current_condition]]
      current_sigs <- rownames(current_exposures_df)
      current_signatures_df <- AlexCosmicArtif_sig_df[, current_sigs,
                                                      drop=FALSE]
      suppressWarnings(variateExp(
        in_catalogue_df = current_snv_catalogue_df,
        in_sig_df = current_signatures_df,
        in_exposures_df = current_exposures_df,
        in_sigLevel = 0.025, in_delta = 0.4))
   }else if(grepl("PCAWGValidSNV_abs|PCAWGValidSNV_norm", current_condition)){
      current_exposures_df <- exposures_list[[current_condition]]
      current_sigs <- rownames(current_exposures_df)
      current_signatures_df <- PCAWG_SP_SBS_sigs_Real_df[, current_sigs, 
                                                         drop=FALSE]
      suppressWarnings(variateExp(
        in_catalogue_df = current_snv_catalogue_df,
        in_sig_df = current_signatures_df,
        in_exposures_df = current_exposures_df,
        in_sigLevel = 0.025, in_delta = 0.4))
    }else if(grepl("PCAWGValidID_abs", current_condition)){
      current_exposures_df <- exposures_list[[current_condition]]
      current_sigs <- rownames(current_exposures_df)
      current_signatures_df <- PCAWG_SP_ID_sigs_df[, current_sigs, 
                                                   drop=FALSE]
      suppressWarnings(variateExp(
        in_catalogue_df = current_id_catalogue_df,
        in_sig_df = current_signatures_df,
        in_exposures_df = current_exposures_df,
        in_sigLevel = 0.025, in_delta = 0.4))
    }else{
      print("WARNING: There is no match between names of exposure list and the
            current condition")
    }
  })
  
  complete_df_list <- lapply(complete_df_list, function(current_complete_df){
    current_complete_df$norm_exposure <- current_complete_df$exposure / 
      current_complete_df[which(current_complete_df$sig == "total"), "exposure"]
    current_complete_df$norm_lower <- current_complete_df$norm_exposure * 
      current_complete_df$relLower
    current_complete_df$norm_upper <- current_complete_df$norm_exposure * 
      current_complete_df$relUpper
    return(current_complete_df)
  })
  
  names(complete_df_list)<-names(exposures_list)
  
  one <- plotExposuresConfidence_indel(complete_df_list$PCAWGValidSNV_abs, 
                                       subgroups_df,
                                       PCAWG_SP_SBS_sigInd_Real_df)
  two <- plotExposuresConfidence_indel(complete_df_list$PCAWGValidID_abs, 
                                       subgroups_df,
                                       PCAWG_SP_ID_sigInd_df)
  three <- plotExposuresConfidence_indel(complete_df_list$CosmicValid_abs, 
                                         subgroups_df,
                                         AlexCosmicArtif_sigInd_df)
  four <- plotExposuresConfidence_indel(complete_df_list$CosmicArtif_abs, 
                                        subgroups_df,
                                        AlexCosmicArtif_sigInd_df)
  five <- plotExposuresConfidence_indel(complete_df_list$CosmicValid_norm, 
                                        subgroups_df,
                                        AlexCosmicArtif_sigInd_df)
  six <- plotExposuresConfidence_indel(complete_df_list$CosmicArtif_norm,
                                       subgroups_df,
                                       AlexCosmicArtif_sigInd_df)
  
  
  return(list(p_complete_PCAWG_SNV = one,
              p_complete_PCAWG_ID = two,
              p_complete_COSMIC_valid_abs = three, 
              p_complete_COSMIC_artif_abs = four,
              p_complete_COSMIC_valid_norm = five, 
              p_complete_COSMIC_artif_norm = six,
              complete_PCAWG_SNV=complete_df_list$PCAWGValidSNV_abs,
              complete_PCAWG_ID=complete_df_list$PCAWGValidID_abs,
              complete_COSMIC_valid_abs = complete_df_list$CosmicValid_abs,
              complete_COSMIC_artif_abs = complete_df_list$CosmicArtif_abs,
              complete_COSMIC_valid_norm = complete_df_list$CosmicValid_norm,
              complete_COSMIC_artif_norm = complete_df_list$CosmicArtif_norm))
}



#' Wrapper to compute confidence intervals for only INDEL signatures.
#'
#' Wrapper function around \code{\link[YAPSA]{confIntExp}}, which is applies to
#' every signature or sample pair in a cohort. The extracted lower bound of the
#' confidence intervals are added to the input data which is reodered and melted
#' in order to prepare for visualization with ggplot2. The calculates of
#' confidence intervals is based on a profiling likelihood algorithm and the
#' wrapper calculates the data for the exposure contubution identefied with
#' INDEL singature decomposition and the usage of
#' \code{PCAWGValidID_absCutoffVector} data frame.
#'
#' The function makes use of differnet YAPSA functions. For each of the above
#' stated cutoff vectors a per PID decompostion of the SNV and INDEL catalog is
#' calulated respectivly using \code{\link[YAPSA]{LCD_complex_cutoff_perPID}}.
#' In a next step, \code{\link[YAPSA]{variateExp}} which is a wrapper around
#' \code{\link[YAPSA]{confIntExp}} to compute confidenceintervals for a cohort
#' is used. A dataframe is returend with the upper and lower bounds of the
#' confidence intervals. In a last step
#' \code{\link[YAPSA]{plotExposuresConfidence_indel}} to plot the exposures to
#' extracted signatures including confidence intervals computed with e.g. by
#' \code{\link[YAPSA]{variateExp}}.
#'
#'
#' @param in_current_indel_df A INDEL mutational catalog. Mutational catalog can
#'   be constucted with \code{\link{create_indel_mutation_catalogue_from_df}}
#'
#' @return A list is returned containing two object. First, the \code{p} gtable
#' object which can be used for gaphically visualization, and second a dataframe
#' containing the corrosponding upper and lower bounds of the confidence
#' intervals.
#'
#' @export
#'
#' @examples
#' data("GenomeOfNl_MutCat")
#' temp_list <- confidence_indel_only_calulation(
#'                         in_current_indel_df=MutCat_indel_df)
#' plot(temp_list$p_complete_PCAWG_ID)
#' head(temp_list$complete_PCAWG_ID)
#' 
confidence_indel_only_calulation <- function(in_current_indel_df){
  
  data(sigs_pcawg, envir = environment())
  data(cutoffs_pcawg, envir = environment())
  #devtools:::use_data(sigs_pcawg, overwrite = FALSE)
  #devtools:::use_data(cutoffs_pcawg, overwrite = FALSE)
  
  PCAWGValidID_absCutoffVector <- cutoffPCAWG_ID_WGS_Pid_df[3, ]
  
  current_id_catalogue_df <- data.frame(in_current_indel_df, check.names=FALSE)

  PCAWGValidID_abs_LCDlist <- LCD_complex_cutoff_perPID(
    in_mutation_catalogue_df = current_id_catalogue_df,
    in_signatures_df = PCAWG_SP_ID_sigs_df,
    in_cutoff_vector = PCAWGValidID_absCutoffVector,
    in_filename = NULL,
    in_method = "abs",
    in_sig_ind_df = PCAWG_SP_ID_sigInd_df)

  
  exposures_list <- list(PCAWGValidID_abs = PCAWGValidID_abs_LCDlist$exposures)
  
  name_list <- names(exposures_list)
  exposures_list <- lapply(seq_along(exposures_list),FUN=function(current_ind){
    current_df <- exposures_list[[current_ind]]
    names(current_df) <- name_list[current_ind]
    return(current_df)
  })
  
  
  names(exposures_list) <- name_list
  
  exposures_list <- lapply(exposures_list, function(list){
    colnames(list) <- colnames(current_id_catalogue_df)
    return(list)
  })
  
  subgroups_df <- data.frame(
    PID = colnames(exposures_list[[1]]), subgroup = "test", sum = 1, 
    compl_sum = 1, index = seq_along(exposures_list[[1]]), col = "#FF0000FF")
  
  complete_df_list <- lapply(name_list, function(current_condition){
    print(current_condition)
    current_exposures_df <- exposures_list[[current_condition]]
    current_sigs <- rownames(current_exposures_df)
    current_signatures_df <- PCAWG_SP_ID_sigs_df[, current_sigs, drop=FALSE]
    suppressWarnings(variateExp(
        in_catalogue_df = current_id_catalogue_df,
        in_sig_df = current_signatures_df,
        in_exposures_df = current_exposures_df,
        in_sigLevel = 0.025, in_delta = 0.4))
  })
  
  complete_df_list <- lapply(complete_df_list, function(current_complete_df){
    current_complete_df$norm_exposure <- current_complete_df$exposure /
      current_complete_df[which(current_complete_df$sig == "total"), "exposure"]
    current_complete_df$norm_lower <- current_complete_df$norm_exposure *
      current_complete_df$relLower
    current_complete_df$norm_upper <- current_complete_df$norm_exposure * 
      current_complete_df$relUpper
    return(current_complete_df)
  })
  
  names(complete_df_list)<-names(exposures_list)
  
  plot_ID <- plotExposuresConfidence_indel(complete_df_list$PCAWGValidID_abs,
                                           subgroups_df,
                                           PCAWG_SP_ID_sigInd_df)
  
  
  return(list(p_complete_PCAWG_ID = plot_ID,
              complete_PCAWG_ID=complete_df_list$PCAWGValidID_abs))
}


#' Plot exposures including confidence intervals for exposures of SNVs and
#' INDELs
#'
#' Plot the exposures to extracted signatures including the confidence intervals
#' computed e.g. by \code{\link[YAPSA]{variateExp}}
#'
#' @param in_complete_df Melted numeric input data frame e.g. as computed by
#'   \code{\link{variateExp}}
#' @param in_subgroups_df Data frame containing meta information on subgroup
#'   attribution of the samples in the cohort of interest.
#' @param in_sigInd_df Data frame with meta information on the signatures used
#'   in the analysis.
#'
#' @return The function returns a gtable object which can be plotted with
#'   \code{plot} or \code{grid.draw}
#'
#' @export
#'
#' @examples NULL
#' 
plotExposuresConfidence_indel <- function(in_complete_df,
                                          in_subgroups_df,
                                          in_sigInd_df) {
  sig_colour_vector <- c("black", in_sigInd_df$colour)
  names(sig_colour_vector) <- c("total", as.character(in_sigInd_df$sig))
  in_complete_df$sample <- factor(in_complete_df$sample, 
                  levels = in_subgroups_df$PID[order(in_subgroups_df$index)])
  in_complete_df$subgroup <-
    in_subgroups_df$subgroup[match(in_complete_df$sample, 
    in_subgroups_df$PID)]
  exposure_plot <- in_complete_df[which(in_complete_df$sig != 
                        "total"), ] %>% 
                            ggplot(aes(x = reorder(sample, -exposure), 
                                      y = exposure, fill = sig)) + 
    geom_bar(stat = "identity") + 
    geom_errorbar(aes(ymin = lower, ymax = upper), width = 0.2) + 
    facet_grid(sig ~ subgroup, scales = "free_x", 
               space = "free_x", switch = "x") + 
    theme_grey() + 
    theme(axis.text.x = element_text(angle = 90,  vjust = 0.5),
                              panel.border = element_rect(fill = NA, 
                                                          colour = "black"), 
                              strip.background = element_rect(
                                colour = "black"), 
                             legend.position = "none") + 
    scale_fill_manual(values = sig_colour_vector) + 
    scale_x_discrete(name ="sample identifier")
  subgroup_aggregate_df <- aggregate(col ~ subgroup, data = in_subgroups_df, 
                                     FUN = head, 1)
  index_aggregate_df <- aggregate(index ~ subgroup, data = in_subgroups_df, 
                                  FUN = mean)
  subgroup_colour_vector <- 
    subgroup_aggregate_df$col[order(index_aggregate_df$index)]
  exposure_g <- ggplot_gtable(ggplot_build(exposure_plot))
  stripr <- which(grepl("strip-b", exposure_g$layout$name))
  k <- 1
  for (i in stripr) {
    j <- which(grepl("rect", exposure_g$grobs[[i]]$grobs[[1]]$childrenOrder))
    exposure_g$grobs[[i]]$grobs[[1]]$children[[j]]$gp$fill <-
      subgroup_colour_vector[k]
    k <- k + 1
  }
  total_p <- in_complete_df[which(in_complete_df$sig == "total"),] %>% 
    ggplot(aes(x = reorder(sample, -exposure), y = exposure, fill = sig)) + 
    geom_bar(stat = "identity", fill = "black") + 
    facet_grid(sig ~ subgroup, 
               scales = "free_x",
               space = "free_x", 
               switch = "x") + 
    theme_grey() + theme(axis.text.x = element_blank(), 
                         axis.ticks = element_blank(),
                         axis.title.x = element_blank(), 
                         axis.title.y = element_blank(),
                         panel.border = element_rect(fill = NA, 
                                                     colour = "black"), 
                         strip.background = element_rect(colour = "black"), 
                         strip.text.x = element_blank(), 
                         legend.position = "none")
  total_g <- ggplotGrob(total_p)
  all_g <- rbind(total_g, exposure_g)
  return(all_g)
}

# Copyright © 2014-2019  The YAPSA package contributors
# This file is part of the YAPSA package. The YAPSA package is licenced under
# GPL-3

#'INDEL function V1 - not compartible with AlexandrovSignatures
#' @param in_df Input data frame containing the variances in a vcf-like format 
#' @param in_ALT.field Column number for alternitve field
#' @param in_REF.field Coloumn number for reference field  
#' @param in_breaks Handed over to function cut
#' @param in_labels Handed over to function cut
#'
#' @return classVector, a factor vector of indel sizes
#' @export
#'
#' @examples
#'  NULL
#' 
classify_indels <- function(in_df,
                            in_ALT.field = "ALT",
                            in_REF.field = "REF",
                            in_breaks = c(-Inf, -10, -3, 0, 2, 9, Inf),
                            in_labels = c("del3", "del2", "del1", 
                                          "in1", "in2", "in3")){
  deltaVector <- nchar(as.character(in_df[, in_ALT.field])) - 
    nchar(as.character(in_df[, in_REF.field]))
  classVector <- cut(deltaVector, breaks = in_breaks, labels = in_labels)
  return(classVector)
}

# Copyright © 2014-2019  The YAPSA package contributors
# This file is part of the YAPSA package. The YAPSA package is licenced under
# GPL-3

#' Compare to background distribution
#'
#' Compare exposures from an analysis of mutational signatures in a cohort of
#' interest to exposures computed in a background (e.g. the set of WES and WGS
#' samples from Alexandrov 2013).
#'
#' @param in_cohort_exposures_df Numerical data frame of the exposures of the
#'   cohort of interest.
#' @param in_background_exposures_df Numerical data frame of the exposures of
#'   the background.
#' @param in_sig_df Numerical data frame encoding the mutational signatures.
#'
#' @return A data frame with counts and p-values from Fisher tests.
#'
#' @export
#'
#' @examples
#' NULL
#' 
enrichSigs <- function(in_cohort_exposures_df,
                                  in_background_exposures_df,
                                  in_sig_df){
  pos_background_vector <- 
    apply(in_background_exposures_df, 1, function(x) length(which(x > 0)))
  pos_cohort_vector <-
    apply(in_cohort_exposures_df, 1, function(x) length(which(x > 0)))
  enrichment_df <- repeat_df(0, in_rows = ncol(in_sig_df), in_cols = 4)
  rownames(enrichment_df) <- colnames(in_sig_df)
  colnames(enrichment_df) <-
    c("pos_cohort", "neg_cohort", "pos_background", "neg_universe")
  enrichment_df[names(pos_cohort_vector), "pos_cohort"] <- pos_cohort_vector
  enrichment_df$neg_cohort <-
    ncol(in_cohort_exposures_df) - enrichment_df$pos_cohort
  enrichment_df[names(pos_background_vector), "pos_background"] <-
    pos_background_vector
  enrichment_df$neg_universe <-
    ncol(in_background_exposures_df) - enrichment_df$pos_background
  enrichment_df$p_Fisher_two.sided <- apply(enrichment_df, 1, function(x){
    y <- matrix(c(x[1], x[2], x[3], x[4]), ncol = 2)
    fisher.test(y, alternative = "two.sided")$p.value
  })
  enrichment_df$p_Fisher_greater <- apply(enrichment_df, 1, function(x){
    y <- matrix(c(x[1], x[2], x[3], x[4]), ncol = 2)
    fisher.test(y, alternative = "greater")$p.value
  })
  enrichment_df$p_Fisher_less <- apply(enrichment_df, 1, function(x){
    y <- matrix(c(x[1], x[2], x[3], x[4]), ncol = 2)
    fisher.test(y, alternative = "less")$p.value
  })
  return(enrichment_df)
}

#' Compute the loglikelihood
#'
#' @param in_vector Numeric vector of input values of which the loglikelihood is
#'   computed.
#' @param in_pdf Probability distribution function, if NULL a normal
#'   distribution is used.
#' @param verbose Verbose if \code{in_verbose=1}
#'
#' @return A numeric value (sum of the logarithms of the likelihoods of the
#'   input vector)
#' @export
#'
#' @examples
#' NULL
#' 
computeLogLik <- function(in_vector, in_pdf = NULL, verbose = FALSE){
  if(verbose) cat("class(in_pdf): ", class(in_pdf), "\n")
  if(inherits(in_pdf, "function")){
    if(verbose) cat("Selection 1.\n")
    my_pdf <- function(x) in_pdf(x)
  } else if(inherits(in_pdf, "character")){
    if(in_pdf == "distrib"){
      if(verbose) cat("Selection 2.\n")
      fn <- approxfun(density(in_vector))
      my_pdf <- function(x) fn(x)
    } else if(in_pdf %in% c("zero", "0", "zeroNorm")){
      if(verbose) cat("Selection 3.\n")
      my_sd <- sd(in_vector)
      my_pdf <- function(x) dnorm(x, mean = 0, sd = my_sd)
    }
  } else {
    if(verbose) cat("Selection 4.\n")
    my_mean <- mean(in_vector)
    my_sd <- sd(in_vector)
    my_pdf <- function(x) dnorm(x, mean = my_mean, sd = my_sd)
  }
  log_likelihood <- log2(my_pdf(in_vector))
  return(sum(log_likelihood))
}

#' Compute a loglikelihood ratio test
#'
#' Compute a likelihood ratio test based on the loglikelihoods of the residuals
#' of two different models of the same data.
#'
#' @param in_1 Residuals of model 1 of the input data.
#' @param in_2 Residuals of model 2 of the input data.
#' @param df_1 Degrees of freedom of the input model 1. If either \code{df_1} or
#'   \code{df_2} is NULL, the difference between the degrees of freedom of the
#'   two models is assumed to be 1.
#' @param df_2 Degrees of freedom of the input model 2. If either \code{df_1} or
#'   \code{df_2} is NULL, the difference between the degrees of freedom of the
#'   two models is assumed to be 1.
#' @param in_pdf Probability distribution function, passed on to
#'   \link{computeLogLik}, if NULL a normal distribution is used.
#' @param verbose Verbose if \code{in_verbose=1}
#'
#' @return A list with entries \itemize{ \item \code{statistic}: The test
#' statistic \item \code{delta_df}: The difference in degrees of freedom between
#' input model 1 and 2 \item \code{p.value}: p value of the statistical test. }
#' @export
#'
#' @examples
#'  library(BSgenome.Hsapiens.UCSC.hg19)
#'  data(lymphoma_test)
#'  data(sigs)
#'  data(cutoffs)
#'  word_length <- 3
#'  temp_list <- create_mutation_catalogue_from_df(
#'    lymphoma_test_df,this_seqnames.field = "CHROM",
#'    this_start.field = "POS",this_end.field = "POS",
#'    this_PID.field = "PID",this_subgroup.field = "SUBGROUP",
#'    this_refGenome = BSgenome.Hsapiens.UCSC.hg19,
#'    this_wordLength = word_length)
#'  lymphoma_catalogue_df <- temp_list$matrix
#'  lymphoma_PIDs <- colnames(lymphoma_catalogue_df)
#'  current_sig_df <- AlexCosmicValid_sig_df
#'  current_sigInd_df <- AlexCosmicValid_sigInd_df
#'  current_cutoff_vector <- cutoffCosmicValid_rel_df[6, ]
#'  iniLCDList <- LCD_complex_cutoff(
#'    in_mutation_catalogue_df = lymphoma_catalogue_df[, 1, drop = FALSE],
#'    in_signatures_df = current_sig_df,
#'    in_cutoff_vector = current_cutoff_vector,
#'    in_method = "relative", in_rescale = TRUE,
#'    in_sig_ind_df = current_sigInd_df)
#'  current_sig_df <- AlexCosmicValid_sig_df[, -9]
#'  current_sigInd_df <- AlexCosmicValid_sigInd_df[-9,]
#'  current_cutoff_vector <- cutoffCosmicValid_rel_df[6, -9]
#'  redLCDList <- LCD_complex_cutoff(
#'    in_mutation_catalogue_df = lymphoma_catalogue_df[, 1, drop = FALSE],
#'    in_signatures_df = current_sig_df,
#'    in_cutoff_vector = current_cutoff_vector,
#'    in_method = "relative", in_rescale = TRUE,
#'    in_sig_ind_df = current_sigInd_df)
#'  logLikelihood(iniLCDList, redLCDList)
#'  
logLikelihood <- function(in_1, in_2,
                          df_1 = NULL, df_2 = NULL,
                          in_pdf = NULL, verbose = FALSE){
  if(is.null(df_1) & is.null(df_2)){
    delta_df <- 1
  } else {
    delta_df <- abs(df_1 - df_2)
  }
  if(inherits(in_1, "data.frame") & inherits(in_2, "data.frame")){
    my_res_1 <- as.numeric(as.matrix(in_1))
    my_res_2 <- as.numeric(as.matrix(in_2))
  } else if(inherits(in_1, "numeric") & inherits(in_2, "numeric")){
    my_res_1 <- in_1
    my_res_2 <- in_2
  } else if(inherits(in_1, "list") & inherits(in_2, "list")){
    my_res_1 <- as.numeric(as.matrix(in_1$residual_catalogue))
    my_res_2 <- as.numeric(as.matrix(in_2$residual_catalogue))
  } else {
    stop("Unvalid input data type.")
  }
  STATISTIC <-
    2 * (computeLogLik(my_res_1, in_pdf = in_pdf, verbose = verbose) - 
           computeLogLik(my_res_2, in_pdf = in_pdf, verbose = verbose))
  PVAL <- pchisq(STATISTIC, delta_df, lower.tail = FALSE)
  return(list(statistic = STATISTIC, delta_df = delta_df, p.value = PVAL))
}

#' Wrapper for the likelihood ratio test
#'
#' Application of the likelihood ratio test to mutational signatures, primarily
#' for one single sample.
#'
#' @param in_catalogue_vector Mutational catalog of the input sample.
#' @param in_sig_df Data frame encoding the signatures used for the analysis.
#' @param in_exposure_vector Exposure vector computed for the input sample.
#' @param in_ind Index specifying which signature among \code{in_sig_df} is to
#'   be tested.
#' @param in_factor Deviation factor of the altered alternative model.
#' @param in_pdf Probability distibution function, parameter passed on to
#'   \link{logLikelihood} and later to \link{computeLogLik}
#' @param verbose Verbose if \code{in_verbose=1}
#'
#' @return Returns a list
#'
#' @export
#'
#' @examples
#'  library(BSgenome.Hsapiens.UCSC.hg19)
#'  data(lymphoma_test)
#'  data(lymphoma_cohort_LCD_results)
#'  data(sigs)
#'  word_length <- 3
#'  temp_list <- create_mutation_catalogue_from_df(
#'    lymphoma_test_df,this_seqnames.field = "CHROM",
#'    this_start.field = "POS",this_end.field = "POS",
#'    this_PID.field = "PID",this_subgroup.field = "SUBGROUP",
#'    this_refGenome = BSgenome.Hsapiens.UCSC.hg19,
#'    this_wordLength = word_length)
#'  lymphoma_catalogue_df <- temp_list$matrix
#'  lymphoma_PIDs <- colnames(lymphoma_catalogue_df)
#'  data("lymphoma_cohort_LCD_results")
#'  lymphoma_exposures_df <-
#'    lymphoma_Nature2013_COSMIC_cutoff_exposures_df[, lymphoma_PIDs]
#'  lymphoma_sigs <- rownames(lymphoma_exposures_df)
#'  lymphoma_sig_df <- AlexCosmicValid_sig_df[, lymphoma_sigs]
#'  variateExpSingle(
#'    in_ind = 1,
#'    in_factor = 1.5,
#'    in_catalogue_vector = lymphoma_catalogue_df[, 1],
#'    in_sig_df = lymphoma_sig_df,
#'    in_exposure_vector = lymphoma_exposures_df[, 1])
#'    
variateExpSingle <- function(in_catalogue_vector, in_sig_df,
                             in_exposure_vector, in_ind,
                             in_factor = 1, in_pdf = NULL, verbose = FALSE){
  ini_lsfit <- lsfit(as.matrix(in_sig_df), in_catalogue_vector, 
                     intercept = FALSE)
  delta_catalogue_vector <- 
    in_sig_df[, in_ind] * in_exposure_vector[in_ind]
  my_catalogue_vector <- in_catalogue_vector -
    in_factor * delta_catalogue_vector
  my_lsfit <- lsfit(as.matrix(in_sig_df[, -in_ind]), my_catalogue_vector, 
                    intercept = FALSE)
  return(logLikelihood(ini_lsfit$residuals, my_lsfit$residuals,
                       in_pdf = in_pdf, verbose = verbose)$p.value)
}

#' Compute confidence intervals
#'
#' Compute confidence intervals using the (log-)likelihood ratio test, primarily
#' for one input sample.
#'
#' @param in_ind Index of the input signature to be variated.
#' @param in_sigLevel Significance leve (one-sided)
#' @param in_delta Inflation parameter for the alternative model.
#' @param in_exposure_vector Exposure vector computed for the input sample.
#' @param in_verbose Whether to run verbose (TRUE) or not (FALSE)
#' @param ... Input parameters passed on to \link{variateExpSingle}.
#'
#' @return A list with entries \itemize{ \item \code{upper}: Upper bound of the
#'   confidence interval \item \code{lower}: Lower bound of the confidence
#'   interval }
#' @importFrom pracma newtonsys
#'
#' @export
#'
#' @examples
#'  library(BSgenome.Hsapiens.UCSC.hg19)
#'  data(lymphoma_test)
#'  data(lymphoma_cohort_LCD_results)
#'  data(sigs)
#'  word_length <- 3
#'  temp_list <- create_mutation_catalogue_from_df(
#'    lymphoma_test_df,this_seqnames.field = "CHROM",
#'    this_start.field = "POS",this_end.field = "POS",
#'    this_PID.field = "PID",this_subgroup.field = "SUBGROUP",
#'    this_refGenome = BSgenome.Hsapiens.UCSC.hg19,
#'    this_wordLength = word_length)
#'  lymphoma_catalogue_df <- temp_list$matrix
#'  lymphoma_PIDs <- colnames(lymphoma_catalogue_df)
#'  data("lymphoma_cohort_LCD_results")
#'  lymphoma_exposures_df <-
#'    lymphoma_Nature2013_COSMIC_cutoff_exposures_df[, lymphoma_PIDs]
#'  lymphoma_sigs <- rownames(lymphoma_exposures_df)
#'  lymphoma_sig_df <- AlexCosmicValid_sig_df[, lymphoma_sigs]
#'  confIntExp(in_ind = 1, in_sigLevel = 0.05, in_delta = 0.4,
#'             in_exposure_vector = lymphoma_exposures_df[, 1],
#'             in_catalogue_vector = lymphoma_catalogue_df[, 1],
#'             in_sig_df = lymphoma_sig_df)
#'             
confIntExp <- function(in_ind = 1, in_sigLevel = 0.05, in_delta = 1,
                       in_exposure_vector = NULL,in_verbose = FALSE, ...){
  stopifnot(!is.null(in_exposure_vector))
  if(in_exposure_vector[in_ind] == 0){
    upper = 0
    lower = 0
  } else {
    current_fun <- function(x){
      variateExpSingle(in_ind = in_ind, in_factor = x, 
                       in_exposure_vector = in_exposure_vector,
                       verbose = in_verbose, ...) - in_sigLevel
    }
    start_delta <- in_delta
    upper <- 1
    while (upper <= 1 & start_delta < 10) {
      delta <- start_delta
      #cat("upper: start_delta: ", start_delta, "\n")
      while (upper <= 1 & delta > 1e-4) {
        #cat("\tupper: delta: ", delta, "\n")
        tryCatch({
          upper <- newtonsys(current_fun, 1 + delta)$zero
          if(upper <= 1) delta <- delta / 2
          },
        error = function(e){
          delta <<- delta / 2
          warning("\n\tupper; delta: ", delta)
        })
      }
      start_delta <- start_delta * 2
    }
    if(upper < 1){
      upper <- 1
      if(in_verbose) cat("No upper bound for CI could be found.\n")
    }
    start_delta <- in_delta
    lower <- 1
    while (lower >= 1 & start_delta < 10) {
      delta <- start_delta
      #cat("lower: start_delta: ", start_delta, "\n")
      while (lower >=1 & delta > 1e-4) {
        #cat("\tlower: delta: ", delta, "\n")
        tryCatch({
          lower <- newtonsys(current_fun, 1 - delta)$zero
          if(lower >= 1) delta <- delta / 2
          },
        error = function(e){
          delta <<- delta / 2
          warning("\n\tlower; delta: ", delta)
        })
      }
      start_delta <- start_delta * 2
    }
    if(lower > 1){
      lower <- 1
      if(in_verbose) cat("No lower bound for CI could be found.\n")
    }
  }
  return(list(upper = upper,
              lower = lower))
}

#' Test for significance of alternative models cohort wide
#'
#' Wrapper function for \link{variateExpSingle} for application cohort wide.
#'
#' @param in_catalogue_df Input numerical data frame of the mutational catalog
#'   of the cohort to be analyzed
#' @param in_sig_df Numerical data frame of the signatures used for analysis.
#' @param in_exposures_df Input numerical data frame of the exposures computed
#'   for the cohort to be analyzed
#' @param in_factor Deviation factor of the altered alternative model.
#' @param in_pdf Probability distribution function, parameter passed on to
#'   \link{confIntExp} if NULL assumed to be normal distribution.
#'
#' @return Returns a data frame
#' @export
#'
#' @examples NULL
#' 
testSigs <- function(in_catalogue_df, in_sig_df, in_exposures_df,
                     in_factor = 0, in_pdf = NULL){
  temp_list <- 
    lapply(seq_len(ncol(in_exposures_df)), function(z){
      temp_list <-
        lapply(seq_len(ncol(in_sig_df)), 
               function(y){
                 variateExpSingle(in_ind = y, in_factor = in_factor,
                                  in_catalogue_vector = in_catalogue_df[, z],
                                  in_sig_df = in_sig_df,
                                  in_exposure_vector = in_exposures_df[, z], 
                                  in_pdf = in_pdf)
               })
      names(temp_list) <- names(in_sig_df)
      return(unlist(temp_list))
    })
  names(temp_list) <- names(in_exposures_df)
  out_df <- do.call(cbind, temp_list)
  return(out_df)
}

#' Wrapper to compute confidence intervals for a cohort
#'
#' Wrapper function around \link{confIntExp}, which is applied to every
#' signature/sample pair in a cohort. The extracted upper and lower bounds of
#' the confidence intervals are added to the input data which is reordered and
#' melted in order to prepare for visualization with ggplot2.
#'
#' @param in_catalogue_df Input numerical data frame of the mutational catalog
#'   of the cohort to be analyzed.
#' @param in_sig_df Numerical data frame of the signatures used for analysis.
#' @param in_exposures_df Input numerical data frame of the exposures computed
#'   for the cohort to be analyzed.
#' @param in_sigLevel Significance level, parameter passed to \link{confIntExp}.
#' @param in_delta Inflation parameter for the alternative model, parameter
#'   passed on to \link{confIntExp}
#' @param in_pdf Probability distribution function, parameter passed on to
#'   \link{confIntExp}, if NULL assumed to be normal distribution.
#'
#' @return A melted data frame.
#' @rawNamespace import(magrittr, except=c(subtract))
#' @importFrom reshape2 melt
#' @rawNamespace import(dplyr, except = c(combine, select, setdiff, intersect,
#'   union))
#' @export
#'
#' @examples
#'  library(BSgenome.Hsapiens.UCSC.hg19)
#'  data(lymphoma_test)
#'  data(lymphoma_cohort_LCD_results)
#'  data(sigs)
#'  word_length <- 3
#'  temp_list <- create_mutation_catalogue_from_df(
#'    lymphoma_test_df,this_seqnames.field = "CHROM",
#'    this_start.field = "POS",this_end.field = "POS",
#'    this_PID.field = "PID",this_subgroup.field = "SUBGROUP",
#'    this_refGenome = BSgenome.Hsapiens.UCSC.hg19,
#'    this_wordLength = word_length)
#'  lymphoma_catalogue_df <- temp_list$matrix
#'  lymphoma_PIDs <- colnames(lymphoma_catalogue_df)
#'  data("lymphoma_cohort_LCD_results")
#'  lymphoma_exposures_df <-
#'    lymphoma_Nature2013_COSMIC_cutoff_exposures_df[,lymphoma_PIDs]
#'  lymphoma_sigs <- rownames(lymphoma_exposures_df)
#'  lymphoma_sig_df <- AlexCosmicValid_sig_df[,lymphoma_sigs]
#'  lymphoma_complete_df <- variateExp(in_catalogue_df = lymphoma_catalogue_df,
#'                                     in_sig_df = lymphoma_sig_df,
#'                                     in_exposures_df = lymphoma_exposures_df,
#'                                     in_sigLevel = 0.025, in_delta = 0.4)
#'  head(lymphoma_complete_df)
#'  lymphoma_complete_df$sample <-
#'    factor(lymphoma_complete_df$sample,
#'           levels = colnames(lymphoma_exposures_df)[
#'             order(colSums(lymphoma_exposures_df), decreasing = TRUE)])
#'  sig_colour_vector <- c("black", AlexCosmicValid_sigInd_df$colour)
#'  names(sig_colour_vector) <-
#'    c("total", as.character(AlexCosmicValid_sigInd_df$sig))
#'  ggplot(data = lymphoma_complete_df,
#'         aes(x = sample, y = exposure, fill = sig)) +
#'    geom_bar(stat = "identity") +
#'    geom_errorbar(aes(ymin = lower, ymax = upper), width = 0.2) +
#'    facet_wrap(~sig, nrow = nrow(lymphoma_exposures_df) + 1) +
#'    theme_grey() +
#'    theme(panel.border = element_rect(fill = NA, colour = "black"),
#'          strip.background = element_rect(colour = "black"),
#'          legend.position = "none") +
#'    scale_fill_manual(values = sig_colour_vector)
#'  
variateExp <- function(in_catalogue_df, in_sig_df, in_exposures_df,
                       in_sigLevel = 0.05, in_delta = 0.4, in_pdf = NULL){
  temp_list <- 
    lapply(seq_len(ncol(in_exposures_df)), function(z){
      temp_list <-
        lapply(seq_len(ncol(in_sig_df)), 
               function(y){
                 confIntExp(in_ind = y, in_sigLevel = in_sigLevel,
                            in_delta = in_delta,
                            in_catalogue_vector = in_catalogue_df[, z],
                            in_sig_df = in_sig_df,
                            in_exposure_vector = in_exposures_df[, z], 
                            in_pdf = in_pdf)
               })
      names(temp_list) <- names(in_sig_df)
      return(list(upper = unlist(lapply(temp_list, function(x) x$upper)),
                  lower = unlist(lapply(temp_list, function(x) x$lower))))
    })
  names(temp_list) <- names(in_exposures_df)
  upper_df <- do.call(cbind, lapply(temp_list, function(x) x$upper))
  lower_df <- do.call(cbind, lapply(temp_list, function(x) x$lower))
  melt_df <- Reduce(function(x, y) left_join(x, y, by = c("Var1", "Var2")), 
                    lapply(list(exposures = in_exposures_df,
                                lower = lower_df, 
                                upper = upper_df),
                           function(x) melt(as.matrix(x))))
  names(melt_df) <- c("sig", "sample", "exposure", "relLower", "relUpper")
  total_df <- data.frame(sig = "total", 
                         sample = names(in_exposures_df),
                         exposure = colSums(in_exposures_df),
                         relLower = 1, relUpper = 1)
  melt_df <- rbind(melt_df, total_df)
  melt_df %<>% mutate(lower = exposure * relLower,
                      upper = exposure * relUpper)
  melt_df$sig <- factor(melt_df$sig, levels = c("total",
                                                names(in_sig_df)))
  return(melt_df)
}

#' Plot exposures including confidence intervals
#'
#' Plot the exposures to extracted signatures including confidence intervals
#' computed e.g. by \link{variateExp}.
#'
#' @param in_complete_df Melted numeric input data frame e.g. as computed by
#'   \link{variateExp}
#' @param in_subgroups_df Data frame containing meta information on subgroup
#'   attribution of the samples in the cohort of interest.
#' @param in_sigInd_df Data frame with meta information on the signatures used
#'   in the analysis.
#'
#' @return The function doesn't return any value but plots instead.
#' @export
#'
#' @examples NULL
plotExposuresConfidence <- function(in_complete_df,
                                    in_subgroups_df,
                                    in_sigInd_df){
  sig_colour_vector <- c("black", in_sigInd_df$colour)
  names(sig_colour_vector) <- c("total", as.character(in_sigInd_df$sig))
  in_complete_df$sample <- 
    factor(in_complete_df$sample, 
           levels = in_subgroups_df$PID[order(in_subgroups_df$index)])
  in_complete_df$subgroup <- 
    in_subgroups_df$subgroup[match(in_complete_df$sample, in_subgroups_df$PID)]
  exposure_plot <- in_complete_df[which(in_complete_df$sig != "total"),] %>%
  # exposure_plot <- in_complete_df %>%
    ggplot(aes(x = sample, y = exposure, fill = sig)) +
    geom_bar(stat = "identity") +
    geom_errorbar(aes(ymin = lower, ymax = upper), width = 0.2) +
    facet_grid(sig ~ subgroup, scales = "free_x", space = "free_x",
               switch = "x") +
    theme_grey() +
    theme(axis.text.x = element_text(angle = 90, vjust = 0.5),
          panel.border = element_rect(fill = NA, colour = "black"),
          strip.background = element_rect(colour = "black"),
          legend.position = "none") +
    scale_fill_manual(values = sig_colour_vector)
  subgroup_aggregate_df <- aggregate(col ~ subgroup, data = in_subgroups_df, 
                                     FUN = head, 1)
  index_aggregate_df <- aggregate(index ~ subgroup, data = in_subgroups_df, 
                                  FUN = mean)
  subgroup_colour_vector <-
    subgroup_aggregate_df$col[order(index_aggregate_df$index)]
  exposure_g <- ggplot_gtable(ggplot_build(exposure_plot))
  stripr <- which(grepl('strip-b', exposure_g$layout$name))
  k <- 1
  for (i in stripr) {
    j <- which(grepl('rect', exposure_g$grobs[[i]]$grobs[[1]]$childrenOrder))
    exposure_g$grobs[[i]]$grobs[[1]]$children[[j]]$gp$fill <- 
      subgroup_colour_vector[k]
    k <- k+1
  }
  total_p <- in_complete_df[which(in_complete_df$sig == "total"),] %>%
    ggplot(aes(x = sample, y = exposure, fill = sig)) +
    geom_bar(stat = "identity", fill = "black") +
    facet_grid(sig ~ subgroup, scales = "free_x", space = "free_x",
               switch = "x") +
    theme_grey() +
    theme(axis.text.x = element_blank(),
          axis.ticks = element_blank(),
          axis.title.x = element_blank(),
          axis.title.y = element_blank(),
          panel.border = element_rect(fill = NA, colour = "black"),
          strip.background = element_rect(colour = "black"),
          strip.text.x = element_blank(),
          legend.position = "none")
  total_g <- ggplotGrob(total_p)
  all_g <- rbind(total_g, exposure_g)
  # grid.draw(exposure_g)
  grid.draw(all_g)
}

# Copyright © 2014-2019  The YAPSA package contributors
# This file is part of the YAPSA package. The YAPSA package is licenced under
# GPL-3

#' Compute the cosine distance of two vectors
#'
#' @param a,b Numerical vectors of same length
#' @return The scalar product of the two input vectors divided by the
#'        product of the norms of the two input vectors
#' 
#' @examples
#' ## 1. Orthogonal vectors:
#' cosineDist(c(1,0),c(0,1))
#' ## 2. Non-orthogonal vectors:
#' cosineDist(c(1,0),c(1,1))
#' ## Compare trigonometry:
#' 1-cos(pi/4)
#' 
#' @export
#' 
cosineDist <- function(a,b){
    return(1 - sum(a * b) / ( sqrt(sum(a * a)) * sqrt(sum(b * b)) )) 
}


#' Compute an altered cosine distance of two vectors
#'
#' This is an altered cosine distance: it first reduced the dimension of the
#' two input vectors to only those coordinates where both have non-zero entries.
#' The cosine similarity is then computed on these reduced vectors, i.e. on a
#' sub-vector space.
#'
#' @param a,b Numerical vectors of same length
#' @return The scalar product of the reduced input vectors divided by the
#'        product of the norms of the two reduced input vectors
#' 
#' @examples
#' ## 1. Orthogonal vectors:
#' cosineMatchDist(c(1,0),c(0,1))
#' ## 2. Non-orthogonal vectors:
#' cosineMatchDist(c(1,0),c(1,1))
#' 
#' @export
#' 
cosineMatchDist <- function(a, b){
    choice_ind <- intersect(which(a != 0), which(b != 0))
    if(length(choice_ind) == 0) return(1)
    return(cosineDist(a[choice_ind], b[choice_ind]))
}


#' @import grid
#' 
vplayout <- function(x, y) viewport(layout.pos.row = x, layout.pos.col = y)


#' Compare two sets of signatures by cosine distance
#'
#' Compare two sets of signatures, stored in numerical data frames
#' \code{W1} and \code{W2}, by computing the column-wise cosine distance
#'
#' @param in_df_small,in_df_big Numerical data frames \code{W1} and 
#'  \code{W2}, ideally the bigger one first, both with \code{n} rows
#'  and \code{l1} and \code{l2} columns, \code{n} being the number of
#'  features and \code{l1} and \code{l2} being the respective numbers
#'  of signatures of \code{W1} and \code{W2}
#' @param in_distance A function which computes the distance measure, default
#'  is \code{\link{cosineDist}}
#'  
#' @return A list with entries
#'  \code{distance},
#'  \code{hierarchy_small} and
#'  \code{hierarchy_big}.
#' \itemize{
#'  \item \code{distance}:
#'    A numerical data frame with the cosine distances between the
#'    columns of \code{W1}, indexing the rows, and \code{W2}, indexing
#'    the columns
#'  \item \code{hierarchy_small}:
#'    A data frame carrying the information of ranked similarity between
#'    the signatures in \code{W2} with the signatures in \code{W1}
#'  \item \code{hierarchy_big}:
#'    A data frame carrying the information of ranked similarity between
#'    the signatures in \code{W1} with the signatures in \code{W2}
#' }
#' 
#' @seealso \code{\link{cosineDist}}
#' 
#' @examples
#' sig_1_df <- data.frame(matrix(c(1,0,0,0,0,1,0,0,0,0,1,0),ncol=3))
#' names(sig_1_df) <- paste0("B",seq_len(dim(sig_1_df)[2]))
#' sig_2_df <- data.frame(matrix(c(1,1,0,0,0,0,1,1),ncol=2))
#' compare_sets(sig_1_df,sig_2_df)
#' 
#' @export
#' 
compare_sets <- function(in_df_small,in_df_big,
                            in_distance = cosineDist) {
    sig_names_small <- colnames(in_df_small)
    sig_names_big <- colnames(in_df_big)
    number_of_sigs_small <- dim(in_df_small)[2]
    number_of_sigs_big <- dim(in_df_big)[2]
    number_of_features_small <- dim(in_df_small)[1]
    number_of_features_big <- dim(in_df_big)[1]
        if(number_of_features_small != number_of_features_big) {
            cat("compare_sets: Error: features mismatch")
            return()
    }
    temp_ind <- match(rownames(in_df_small),rownames(in_df_big))
    df_big <- in_df_big[temp_ind,]
    df_small <- in_df_small
    distance_df <- as.data.frame(
        matrix(rep(1,number_of_sigs_small*number_of_sigs_big),
            ncol=number_of_sigs_big))
    rownames(distance_df) <- sig_names_small
    colnames(distance_df) <- sig_names_big
    for (i in 1:number_of_sigs_small) {
        for (j in 1:number_of_sigs_big) {
        distance_df[i,j] <- in_distance(df_small[,i],df_big[,j])
        }
    }  
    hierarchy_small_df <- 
        t(apply(distance_df,1,
            function(l) return(colnames(distance_df)[order(l)])))
    hierarchy_big_df <- 
        t(apply(distance_df,2,
            function(l) return(rownames(distance_df)[order(l)])))
    return(list(distance=distance_df,
            hierarchy_small=hierarchy_small_df,
            hierarchy_big=hierarchy_big_df))
}

#' Compare two sets of exposures by cosine distance
#'
#' Compare two sets of exposures, stored in numerical data frames
#' \code{H1} and \code{H2}, by computing the row-wise cosine distance
#'
#' @param in_df_small,in_df_big Numerical data frames \code{H1} and 
#'  \code{H2}, ideally the bigger one first, both with \code{l} rows
#'  and \code{m1} and \code{m2} columns, \code{l} being the number of
#'  signatures and \code{m1} and \code{m2} being the respective numbers
#'  of samples or patient identefier of \code{H1} and \code{H2}
#' @param in_distance A function which computes the distance measure, default
#'  is \code{\link{cosineDist}}
#'  
#' @return A list with entries
#'  \code{distance},
#'  \code{hierarchy_small} and
#'  \code{hierarchy_big}.
#' \itemize{
#'  \item \code{distance}:
#'    A numerical data frame with the cosine distances between the
#'    columns of \code{H1}, indexing the rows, and \code{H2}, indexing
#'    the columns
#'  \item \code{hierarchy_small}:
#'    A data frame carrying the information of ranked similarity between
#'    the signatures in \code{H2} with the signatures in \code{H1}
#'  \item \code{hierarchy_big}:
#'    A data frame carrying the information of ranked similarity between
#'    the signatures in \code{H1} with the signatures in \code{H2}
#' }
#' 
#' @seealso \code{\link{cosineDist}}
#' 
#' @examples
#' sig_1_df <- data.frame(matrix(c(1,0,0,0,0,1,0,0,0,0,1,0),ncol=3))
#' names(sig_1_df) <- paste0("B",seq_len(dim(sig_1_df)[2]))
#' sig_2_df <- data.frame(matrix(c(1,1,0,0,0,0,1,1),ncol=2))
#' compare_expousre_sets(sig_1_df,sig_2_df)
#' 
#' @export
#' 
compare_expousre_sets <-  function(in_df_small,in_df_big,
                                    in_distance = cosineDist) {
    sig_names_small <- colnames(in_df_small)
    sig_names_big <- colnames(in_df_big)
    number_of_sigs_small <- dim(in_df_small)[2]
    number_of_sigs_big <- dim(in_df_big)[2]
    number_of_samples_small <- dim(in_df_small)[1]
    number_of_samples_big <- dim(in_df_big)[1]
    if(number_of_samples_small != number_of_samples_big) {
        cat("compare_sets: Error: features mismatch")
        return()
    }
    temp_ind <- match(rownames(in_df_small),rownames(in_df_big))
    df_big <- in_df_big[temp_ind,]
    df_small <- in_df_small
    distance_df <- as.data.frame(
        matrix(rep(1,number_of_sigs_small*number_of_sigs_big),
                ncol=number_of_sigs_big))
    rownames(distance_df) <- sig_names_small
    colnames(distance_df) <- sig_names_big
    for (i in 1:number_of_sigs_small) {
        for (j in 1:number_of_sigs_big) {
            distance_df[i,j] <- in_distance(df_small[,i],df_big[,j])
        }
    }  
    hierarchy_small_df <- 
        t(apply(distance_df,1,function(l) 
            return(colnames(distance_df)[order(l)])))
    hierarchy_big_df <- 
        t(apply(distance_df,2,function(l)
            return(rownames(distance_df)[order(l)])))
    return(list(distance=distance_df,
                hierarchy_small=hierarchy_small_df,
                hierarchy_big=hierarchy_big_df))
}

uniquify<-function(x) if (length(x) == 1) x else sprintf("%s_%02d", x, 
                                                        seq_along(x))


#' Disambiguate a vector
#' 
#' Add numbered suffixes to redundant entries in a vector
#'
#' @param in_vector Input vector
#'
#' @return The disambiguated vector.
#' @export
#'
#' @examples
#'  NULL
#' 
disambiguateVector <- function(in_vector){
    ave(in_vector, in_vector, FUN = uniquify)
}


#' Make unique assignments between sets of signatures
#' 
#' Make unique assignments between a set of given signatures and a set of new
#' signatures.
#'
#' @param querySigs The signatures to compare to (given signatures).
#' @param subjectSigs The signatures to be compared (new signatures).
#'
#' @return A list of comparison vectors
#' @export
#'
#' @seealso \code{\link{compare_sets}}
#' @seealso \code{\link{disambiguateVector}}
#' 
#' @examples
#'  NULL
#' 
relateSigs <- function(querySigs, subjectSigs){
    compareList <- compare_sets(querySigs, subjectSigs)
    queryMatchVector <- compareList$hierarchy_small[, 1]
    subjectMatchVector <- compareList$hierarchy_big[, 1]
    subjectUniqueVector <- disambiguateVector(subjectMatchVector)
    uniqueInd <- 
        which(queryMatchVector[subjectMatchVector] == names(subjectMatchVector))
    subjectMatchUniqueVector <- subjectMatchVector
    subjectMatchUniqueVector[-uniqueInd] <- 
    paste0(subjectUniqueVector[-uniqueInd], "_mm")
    uniqueMatchInd <- 
        which(queryMatchVector[subjectMatchVector] == 
            names(subjectMatchVector) | 
            subjectMatchVector == subjectUniqueVector)
    subjectUniqueMatchVector <- subjectMatchVector
    subjectUniqueMatchVector[-uniqueMatchInd] <- 
        paste0(subjectUniqueVector[-uniqueMatchInd], "_mm")
    distVector <- 
        unlist(lapply(seq_along(subjectMatchVector), function(currentInd) 
    compareList$distance[subjectMatchVector[currentInd],
        names(subjectMatchVector)[currentInd]]))
    return(list(match = subjectMatchVector,
                unique = subjectUniqueVector,
                matchUnique = subjectMatchUniqueVector,
                uniqueMatch = subjectUniqueMatchVector,
                dist = distVector))
}


#' Derive a signature_indices_df object
#'
#' Derive a data frame of type signature_indices_df (additional information for
#' a set of signatures) from a set of given signatures for a set of new
#' signatures.
#'
#' @param querySigs The signatures to compare to (given signatures).
#' @param subjectSigs The signatures to be compared (new signatures).
#'   Alternatively this may be a complex object of type list and contain data
#'   from different deconvolutions, each of which having a set of signaturen to
#'   be compared.
#' @param querySigInd The object of type signature_indices_df (additional
#'   informatio for a set of signatures) belonging to the set of known
#'   signatures.
#' @param in_sort Whether to sort or not
#'
#' @return An object of type signature_indices_df (additional informatio for a
#'   set of signatures) belonging to the set of new signatures.
#' @export
#'
#' @seealso \code{\link{relateSigs}}
#'
#' @examples
#'  NULL
#' 
deriveSigInd_df <- function(querySigs, subjectSigs, 
                            querySigInd = NULL,
                            in_sort = FALSE){
    if(inherits(subjectSigs, "list")){
        if(all(unlist(lapply(subjectSigs, function(current_NMFlist){
            "signatures" %in% names(current_NMFlist)})))){
    outListsList <- lapply(subjectSigs, function(current_NMFlist){
        temp_list <- deriveSigInd_df(querySigs,
                                    current_NMFlist$signatures,
                                    querySigInd,in_sort)
        current_NMFlist$out_sig_ind_df <- temp_list$df
        if(in_sort){
            current_NMFlist$exposures <- 
                current_NMFlist$exposures[temp_list$ind,]
            current_NMFlist$norm_exposures <- 
                current_NMFlist$norm_exposures[temp_list$ind,]
            current_NMFlist$signatures <- 
                current_NMFlist$signatures[, temp_list$ind]
        }
        return(current_NMFlist)
    })
    return(outListsList)
    } else {
        cat("YAPSA:::deriveSigInd_df::error: wrong input type. Abort.\n")
    }
    } else if(inherits(subjectSigs, "data.frame")){
        reorder_ind = NULL
        relateList <- relateSigs(querySigs, subjectSigs)
        sigInd_df <- data.frame(sig = colnames(subjectSigs),
                                index = seq(dim(subjectSigs)[2]),
                                colour = rainbow(dim(subjectSigs)[2]),
                                process = relateList$uniqueMatch,
                                match = relateList$uniqueMatch,
                                dist = relateList$dist)
    if(!is.null(querySigInd)){
        if("sig" %in% names(querySigInd)){
            match_ind <- match(relateList$uniqueMatch, querySigInd$sig)
        if("process" %in% names(querySigInd)){
            sigInd_df$process = querySigInd$process[match_ind]
            na_ind <- which(is.na(sigInd_df$process))
            sigInd_df$process <- as.character(sigInd_df$process)
            sigInd_df$process[na_ind] <- "nonunique"
        }
        if("colour" %in% names(querySigInd)){
            sigInd_df$colour = querySigInd$colour[match_ind]
            na_ind <- which(is.na(sigInd_df$colour))
            valeurVector <- 
                floor(seq(from = 0, to = length(na_ind) - 1)*100/length(na_ind))
            sigInd_df$colour <- as.character(sigInd_df$colour)
            sigInd_df$colour[na_ind] <- paste0("grey",valeurVector)
        }
        if("index" %in% names(querySigInd)){
            sigInd_df$index = querySigInd$index[match_ind]
            na_ind <- which(is.na(sigInd_df$index))
            sigInd_df$index <- as.numeric(as.character(sigInd_df$index))
            #tempIndex <- as.numeric(as.character(sigInd_df$index))
            tempMax <- max(sigInd_df$index, na.rm = TRUE)
            sigInd_df$index[na_ind] <- 
                seq(from = tempMax + 1, to = tempMax + length(na_ind))
            if(in_sort){
                reorder_ind <- order(as.numeric(as.character(sigInd_df$index)))
                sigInd_df <- sigInd_df[reorder_ind,]
            }
        }
    }
}
    return(list(df = sigInd_df,
                ind = reorder_ind))
    }
}


#' Create a data frame with default values
#'
#' @param in_value Default entry to be repeated in the data frame
#' @param in_rows,in_cols Dimensions of the data frame to be created
#' @return The created data frame
#'
#' @examples
#' ## 1. Initialize with numeric value:
#' repeat_df(1,2,3)
#' ## 2. Initialize with NA value:
#' repeat_df(NA,3,2)
#' ## 3. Initialize with character:
#' repeat_df("a",4,3)
#'
#' @export
#' 
repeat_df <- function(in_value,in_rows,in_cols) {
    return(as.data.frame(matrix(rep(in_value,in_cols*in_rows),ncol=in_cols)))
}


#' Useful functions on data frames
#'
#' \code{normalize_df_per_dim}: Normalization is carried out by dividing by
#' \code{rowSums} or \code{colSums}; for rows with \code{rowSums=0} or columns
#' with \code{colSums=0}, the normalization is left out.
#'
#' @param in_df Data frame to be normalized
#' @param in_dimension Dimension along which the operation will be carried out
#' @return The normalized numerical data frame (\code{normalize_df_per_dim})
#'
#' @examples
#' test_df <- data.frame(matrix(c(1,2,3,0,5,2,3,4,0,6,0,0,0,0,0,4,5,6,0,7),
#'                              ncol=4))
#' ## 1. Normalize over rows:
#' normalize_df_per_dim(test_df,1)
#' ## 2. Normalize over columns:
#' normalize_df_per_dim(test_df,2)
#'
#' @export
#' 
normalize_df_per_dim <- function(in_df,in_dimension) {
    out_df <- repeat_df(in_value = 0,in_rows = dim(in_df)[1],
                        in_cols = dim(in_df)[2])
    if(in_dimension==1) {
        choice_ind <- which(rowSums(in_df)>0)
        if(length(choice_ind) > 0){
            out_df[choice_ind,] <- in_df[choice_ind,]/rowSums(in_df)[choice_ind]
    } else {
        warning("YAPSA:::normalize_df_per_dim::warning: input is all zero.\n",
            "Return input as output.\n")
        out_df <- in_df
    }
    } else if (in_dimension==2) {
    t_df <- t(in_df)
    choice_ind <- which(rowSums(t_df)>0)
    if(length(choice_ind) > 0){
        temp_df <- repeat_df(in_value = 0,in_rows = dim(in_df)[2],
                                in_cols = dim(in_df)[1])
        temp_df[choice_ind,] <- t_df[choice_ind,]/rowSums(t_df)[choice_ind]
        out_df <- as.data.frame(t(temp_df))
    } else {
        warning("YAPSA:::normalize_df_per_dim::warning: input is all zero.\n",
            "Return input as output.\n")
        out_df <- in_df
    }
    } else {
        return(NULL)
    }
    colnames(out_df) <- colnames(in_df)
    rownames(out_df) <- rownames(in_df)
    return(out_df)
}


#' Average a data frame over a specified dimension
#'
#' \code{average_over_present}: 
#' If averaging over columns, zero rows (i.e. those with \code{rowSums=0})
#' are left out, if averaging over rows, zero columns (i.e. those with
#' \code{colSums=0}) are left out.
#'
#' @return A vector of the means (\code{average_over_present})
#' 
#' @examples
#' test_df <- data.frame(matrix(c(1,2,3,0,5,2,3,4,0,6,0,0,0,0,0,4,5,6,0,7),
#'                              ncol=4))
#' ## 1. Average over non-zero rows:
#' average_over_present(test_df,1)
#' ## 2. Average over non-zero columns:
#' average_over_present(test_df,2)
#' 
#' @export
#' @rdname normalize_df_per_dim
#' 
average_over_present <- function(in_df,in_dimension) {
    out_vector <- c()
    if(in_dimension==2) {
        row_ind <- which(rowSums(in_df)>0)
        reduced_df <- in_df[row_ind,]
    if (length(row_ind)==0) {
        return(NULL)
    } else if (length(row_ind)==1) {
        out_vector <- reduced_df
    } else {
        out_vector <- apply(reduced_df,2,mean)      
    }
    } else if (in_dimension==1) {
        col_ind <- which(colSums(in_df)>0)
        reduced_df <- in_df[,col_ind]
        if (length(col_ind)==0) {
            return(NULL)
    } else if (length(col_ind)==1) {
        out_vector <- reduced_df
    } else {
        out_vector <- apply(reduced_df,1,mean)      
    }
    } else {
        return(NULL)
    }
    return(out_vector)
}


#' Standard deviation of a data frame over a specified dimension
#'
#' \code{sd_over_present}: 
#' If computing the standard deviation over columns, zero rows
#' (i.e. those with \code{rowSums=0}) are left out, if computing
#' the standard deviation over rows, zero columns (i.e. those with
#' \code{colSums=0}) are left out.
#'
#' @return A vector of the standard deviations (\code{sd_over_present})
#' 
#' @examples
#' test_df <- data.frame(matrix(c(1,2,3,0,5,2,3,4,0,6,0,0,0,0,0,4,5,6,0,7),
#'                              ncol=4))
#' ## 1. Compute standard deviation over non-zero rows:
#' sd_over_present(test_df,1)
#' ## 2. Compute standard deviation over non-zero columns:
#' sd_over_present(test_df,2)
#' 
#' @export
#' @rdname normalize_df_per_dim
#' 
sd_over_present <- function(in_df,in_dimension) {
    out_vector <- c()
    if(in_dimension==2) {
        row_ind <- which(rowSums(in_df)>0)
        reduced_df <- in_df[row_ind,]
        if (length(row_ind)==0) {
            return(NULL)
    } else if (length(row_ind)==1) {
        out_vector <- rep(0,dim(in_df)[1])
    } else {
        out_vector <- apply(reduced_df,2,sd)      
    }
    } else if (in_dimension==1) {
        col_ind <- which(colSums(in_df)>0)
        reduced_df <- in_df[,col_ind]
        if (length(col_ind)==0) {
            return(NULL)
    } else if (length(col_ind)==1) {
        out_vector <- rep(0,dim(in_df)[2])
    } else {
        out_vector <- apply(reduced_df,1,sd)      
    }
    } else {
        return(NULL)
    }
    return(out_vector)
}


#' Elementwise sum over a list of (numerical) data frames
#'
#' @param in_df_list
#'  List of (numerical) data frames
#' @return A numerical data frame with the same dimensions as the entries of
#'  \code{in_df_list} with elementwise sums
#' 
#' @examples
#' A <- data.frame(matrix(c(1,1,1,2,2,2),ncol=2))
#' B <- data.frame(matrix(c(3,3,3,4,4,4),ncol=2))
#' df_list <- list(A=A,B=B)
#' sum_over_list_of_df(df_list)
#' 
#' @export
#' 
sum_over_list_of_df <- function(in_df_list) {
    sum_df <- repeat_df(0,dim(in_df_list[[1]])[1],dim(in_df_list[[1]])[2])
    for (i in seq_len(length(in_df_list))) {
        sum_df <- sum_df + in_df_list[[i]]
    }
    colnames(sum_df) <- colnames(in_df_list[[1]])
    rownames(sum_df) <- rownames(in_df_list[[1]])
    return(sum_df)
}


#' Compute the standard error of the mean
#'
#' This function returns the standard deviation of an input numerical vector 
#' divided by the square root of the length of the input vector
#' 
#' @param x
#'  A numerical vector
#'  
#' @return
#'  Standard deviation of an input numerical vector divided by the square
#'  root of the length of the input vector
#'
#' @examples
#' A <- c(1,2,3)
#' sd(A)
#' stderrmean(A)
#'  
#' @export
#'  
stderrmean <- function(x) sqrt(var(x,na.rm=TRUE)/length(na.omit(x)))


#' Standard error of the mean of a data frame over a specified dimension
#'
#' \code{stderrmean_over_present}: 
#' If computing the standard error of the mean over columns, zero rows
#' (i.e. those with \code{rowSums=0}) are left out, if computing the
#' standard error of the mean over rows, zero columns (i.e. those with
#' \code{colSums=0}) are left out. Uses the function \code{\link{stderrmean}}
#'
#' @return A vector of the standard errors of the mean 
#'  (\code{stderrmean_over_present})
#' 
#' @seealso \code{\link{stderrmean}}
#' 
#' @examples
#' test_df <- data.frame(matrix(c(1,2,3,0,5,2,3,4,0,6,0,0,0,0,0,4,5,6,0,7),
#'                              ncol=4))
#' ## 1. Compute standard deviation over non-zero rows:
#' stderrmean_over_present(test_df,1)
#' ## 2. Compute standard deviation over non-zero columns:
#' stderrmean_over_present(test_df,2)
#' 
#' @export
#' @rdname normalize_df_per_dim
#' 
stderrmean_over_present <- function(in_df,in_dimension) {
    out_vector <- c()
    if(in_dimension==2) {
        row_ind <- which(rowSums(in_df)>0)
        reduced_df <- in_df[row_ind,]
    if (length(row_ind)==0) {
        return(NULL)
    } else if (length(row_ind)==1) {
        out_vector <- rep(0,dim(in_df)[1])
    } else {
        out_vector <- apply(reduced_df,2,stderrmean)      
    }
    } else if (in_dimension==1) {
        col_ind <- which(colSums(in_df)>0)
        reduced_df <- in_df[,col_ind]
    if (length(col_ind)==0) {
        return(NULL)
    } else if (length(col_ind)==1) {
        out_vector <- rep(0,dim(in_df)[2])
    } else {
        out_vector <- apply(reduced_df,1,stderrmean)      
    }
    } else {
        return(NULL)
    }
    return(out_vector)
}


#' Translate chromosome names to the hg19 naming convention
#'
#' \code{translate_to_hg19}: In hg19 naming convention, chromosome names start
#' with the prefix \emph{chr} and the gonosomes are called \emph{X} and
#' \emph{Y}. If data analysis is performed e.g. with
#' \code{\link[BSgenome.Hsapiens.UCSC.hg19]{BSgenome.Hsapiens.UCSC.hg19}}, this
#' naming convention is needed. The inverse transform is done with
#' \code{\link{translate_to_1kG}}.
#'
#' @param in_dat GRanges object, VRanges object or data frame which carries one
#'   column with chromosome information to be reformatted.
#' @param in_CHROM.field String indicating which column of \code{in_dat} carries
#'   the chromosome information
#' @param in_verbose Whether verbose or not.
#'
#' @return GRanges object, VRanges object or data frame identical to
#'   \code{in_dat}, but with the names in the chromosome column replaced (if
#'   dealing with data frames) or alternatively the seqlevels replaced (if
#'   dealing with GRanges or VRanges objects).
#'
#' @examples
#' test_df <- data.frame(CHROM=c(1,2,23,24),POS=c(100,120000000,300000,25000),
#'                       dummy=c("a","b","c","d"))
#' hg19_df <- translate_to_hg19(test_df, in_CHROM.field = "CHROM")
#' hg19_df
#'
#' @importFrom Seqinfo seqlevels seqlevels<-
#' @export
#' 
translate_to_hg19 <- function(in_dat,
                            in_CHROM.field="CHROM",
                            in_verbose = FALSE) {
    out_dat <- in_dat
    if(inherits(in_dat, "GRanges")) {
        seqlevels(out_dat) <- gsub("23", "X", seqlevels(out_dat))
        seqlevels(out_dat) <- gsub("24", "Y", seqlevels(out_dat))
        seqlevels(out_dat) <- paste0("chr", seqlevels(out_dat))
    } else if(inherits(in_dat, "data.frame") & 
        in_CHROM.field %in% names(in_dat)){
    chrom_ind <- which(names(out_dat)==in_CHROM.field)
    #names(out_dat)[chrom_ind] <- "chr"
    out_dat[,chrom_ind] <- as.character(out_dat[,chrom_ind])
    out_dat[,chrom_ind] <- gsub("23","X",out_dat[,chrom_ind])
    out_dat[,chrom_ind] <- gsub("24","Y",out_dat[,chrom_ind])
    logical_chr_vector <- grepl("^chr.*",out_dat[,chrom_ind])
    if(!(all(logical_chr_vector))) {
        replace_ind <- which(!logical_chr_vector)
        out_dat[replace_ind,chrom_ind] <- 
            paste0("chr",out_dat[replace_ind,chrom_ind])
    }
    } else {
        if(in_verbose) cat("YAPSA:::translate_to_hg19::error: input not of",
            " suitable type. Return original object.\n")
    }
    return(out_dat)
}


#' Translate chromosome names to the 1kG naming convention
#'
#' \code{translate_to_1kG}: In 1kG, i.e. 1000 genomes naming convention, 
#' chromosome names have no prefix \emph{chr} and the gonosomes are called 
#' \emph{23} for \emph{X} and \emph{24} for \emph{Y}. If data analysis is 
#' performed e.g. with \code{hs37d5.fa}, this naming convention is needed. The
#' inverse transform is done with \code{\link{translate_to_hg19}}.
#'
#' @examples
#' test_df <- data.frame(CHROM=c(1,2,23,24),POS=c(100,120000000,300000,25000),
#'                       dummy=c("a","b","c","d"))
#' hg19_df <- translate_to_hg19(test_df, in_CHROM.field = "CHROM")
#' onekG_df <- translate_to_1kG(hg19_df, in_CHROM.field = "CHROM")
#' onekG_df
#' 
#' @importFrom Seqinfo seqlevels seqlevels<-
#' @export
#' @rdname translate_to_hg19
#' 
translate_to_1kG <- function(in_dat,
                            in_CHROM.field = "chr",
                            in_verbose = FALSE) {
    out_dat <- in_dat
    # account for input data type
    if(inherits(in_dat, "GRanges")) {
        seqlevels(out_dat) <- gsub("chr", "", seqlevels(out_dat))
        seqlevels(out_dat) <- gsub("X", "23", seqlevels(out_dat))
        seqlevels(out_dat) <- gsub("Y", "24", seqlevels(out_dat))
    } else if(inherits(in_dat, "data.frame") & 
        in_CHROM.field %in% names(in_dat)){
        chrom_ind <- which(names(out_dat)==in_CHROM.field)
        #names(out_dat)[chrom_ind] <- "CHROM"
        out_dat[,chrom_ind] <- as.character(out_dat[,chrom_ind])
        out_dat[,chrom_ind] <- gsub("X","23",out_dat[,chrom_ind])
        out_dat[,chrom_ind] <- gsub("Y","24",out_dat[,chrom_ind])
        logical_chr_vector <- grepl("^[0-9]+$",out_dat[,chrom_ind])
        if(!(all(logical_chr_vector))) {
            replace_ind <- which(!logical_chr_vector)
            out_dat[replace_ind,chrom_ind] <- gsub("chr","",
                                                out_dat[replace_ind,chrom_ind])
    }
    } else {
        if(in_verbose) cat("YAPSA:::translate_to_1kG::error: input not of",
            " suitable type. Return original object.\n")
    }
        return(out_dat)
}


#' Attribute the nucleotide exchange for an SNV
#'
#' SNVs are grouped into 6 different categories (12/2 as reverse complements are
#' summed over). This function defines the attribution.
#'
#' @param in_dat VRanges object or data frame which carries one column for the
#'   reference base and one column for the variant base
#' @param in_REF.field String indicating which column of \code{in_dat} carries
#'   the reference base if dealing with data frames
#' @param in_ALT.field String indicating which column of \code{in_dat} carries
#'   the variant base if dealing with data frames
#' @param in_verbose Whether verbose or not.
#'
#' @return A character vector with as many rows as there are in \code{in_dat}
#'   which can be annotated (i.e. appended) to the input data frame.
#'
#' @examples
#' test_df <- data.frame(
#'  CHROM=c(1,1,1,2,2,2,3,3,3,4,4,4,5,5),
#'  POS=c(1,2,3,4,5,6,1,2,3,4,5,6,7,8),
#'  REF=c("C","C","C","T","T","T","A","A","A","G","G","G","N","A"),
#'  ALT=c("A","G","T","A","C","G","C","G","T","A","C","T","A","N"))
#' test_df$change <- attribute_nucleotide_exchanges(
#'  test_df,in_REF.field = "REF",in_ALT.field = "ALT")
#' test_df
#'
#' @export
#' 
attribute_nucleotide_exchanges <- function(in_dat, in_REF.field = "REF",
                                            in_ALT.field = "ALT",
                                            in_verbose = FALSE) {
    # account for input data type
    if(inherits(in_dat, "VRanges")) {
        choice_column_vector <- c("seqnames", "start", "ref", "alt")
    in_dat <- as.data.frame(in_dat)
    colum_names <- intersect(names(in_dat),choice_column_vector)
    in_dat <- in_dat[,colum_names]
    names(in_dat) <- gsub("ref", in_REF.field, names(in_dat))
    names(in_dat) <- gsub("alt", in_ALT.field, names(in_dat))
    }
    if(!(inherits(in_dat, "data.frame"))){
        if(in_verbose) cat(
            "YAPSA:::attribute_nucleotide_exchanges::error:input",
            " data is of wrong type.\n")
    return(NULL)
    }
    name_list <- names(in_dat)
    ## exception handling for input fields
    if(tolower(in_REF.field) %in% tolower(name_list)) {
        if(in_verbose) cat(
            "YAPSA:::attribute_nucleotide_exchanges::in_REF.field",
            " found. Retrieving REF information.\n")
    REF_ind <- min(which(tolower(name_list)==tolower(in_REF.field)))
    } else {
        if(in_verbose) cat("YAPSA:::attribute_nucleotide_exchanges::error: ",
            "in_REF.field not found. Return NULL.\n")
    return(NULL)
    }
    if(tolower(in_ALT.field) %in% tolower(name_list)) {
        if(in_verbose) cat(
            "YAPSA:::attribute_nucleotide_exchanges::in_ALT.field",
            " found. Retrieving ALT information.\n")
    ALT_ind <- min(which(tolower(name_list)==tolower(in_ALT.field)))
    } else {
        if(in_verbose) cat("YAPSA:::attribute_nucleotide_exchanges::error: ",
            "in_ALT.field not found. Return NULL.\n")
    return(NULL)
    }
    ## adapt nomenclature for nucleotide exchanges
    complement <- c('A' = 'T', 'C' = 'G','G' = 'C', 'T' = 'A', 'N' = 'N')
    change_vec <- rep("dummy",dim(in_dat)[1])
    sel <- which(in_dat[,REF_ind] == 'C' | in_dat[,REF_ind] == 'T')
    change_vec[sel] <- 
        paste0(as.character(in_dat[sel,REF_ind]),
                as.character(in_dat[sel,ALT_ind]))
    sel <- which(in_dat[,REF_ind] == 'A' | in_dat[,REF_ind] == 'G')
    change_vec[sel] <- 
        paste0(complement[as.character(in_dat[sel,REF_ind])],
                complement[as.character(in_dat[sel,ALT_ind])])  
    change_vec <- factor(change_vec, 
                            levels = c("CA", "CG", "CT", "TA", "TC", "TG"))
    return(change_vec)
}


#' Annotate the intermutation distance of variants per PID
#'
#' The function annotates the intermutational distance to a PID wide data frame
#' by applying \code{\link[circlize]{rainfallTransform}} to every
#' chromosome-specific subfraction of the PID wide data.
#'
#' @param in_dat VRanges object or data frame which carries (at least) one
#'   column for the chromosome and one column for the position.
#' @param in_CHROM.field String indicating which column of \code{in_dat} carries
#'   the chromosome information if dealing with data frames.
#' @param in_POS.field String indicating which column of \code{in_dat} carries
#'   the position information if dealing with data frames.
#' @param in_mode String passed to \code{\link[circlize]{rainfallTransform}}
#'   indicating which method to choose for the computation of the
#'   intermutational distance.
#' @param in_verbose Whether verbose or not.
#'
#' @return VRanges object or data frame identical to \code{in_dat}, but with the
#'   intermutation distance annotated as an additional column on the right named
#'   \code{dist}.
#'
#' @seealso \code{\link{annotate_intermut_dist_cohort}}
#' @seealso \code{\link[circlize]{rainfallTransform}}
#'
#' @examples
#' test_df <- data.frame(
#'  CHROM=c(1,1,1,2,2,2,3,3,3,4,4,4,5,5),
#'  POS=c(1,2,4,4,6,9,1,4,8,10,20,40,100,200),
#'  REF=c("C","C","C","T","T","T","A","A","A","G","G","G","N","A"),
#'  ALT=c("A","G","T","A","C","G","C","G","T","A","C","T","A","N"))
#' min_dist_df <- annotate_intermut_dist_PID(test_df,in_CHROM.field="CHROM",
#'                                           in_POS.field="POS",
#'                                           in_mode="min")
#' max_dist_df <- annotate_intermut_dist_PID(test_df,in_CHROM.field="CHROM",
#'                                           in_POS.field="POS",
#'                                           in_mode="max")
#' min_dist_df
#' max_dist_df
#'
#' @importFrom circlize rainfallTransform
#' @export
#' 
annotate_intermut_dist_PID <- function(in_dat, in_CHROM.field = "CHROM",
                                        in_POS.field = "POS", in_mode = "min",
                                        in_verbose = FALSE){
    out_dat <- in_dat
    # account for input data type
    if(inherits(in_dat, "VRanges")) {
        in_dat$dist1 <- c(1e10, as.numeric(width(gaps(in_dat)))[-1])
        in_dat$dist2 <- c(as.numeric(width(gaps(in_dat)))[-1], 1e10)
        out_dat$dist <- apply(mcols(in_dat)[,c("dist1","dist2")], 1, min)
    } else if(inherits(in_dat, "data.frame")){
        CHROM_ind <- which(names(in_dat)==in_CHROM.field)
        POS_ind <- which(names(in_dat)==in_POS.field)
        inflate_df <- data.frame()
        for(my_chrom in unique(in_dat[,CHROM_ind])) {
            my_df <- in_dat[which(in_dat[,CHROM_ind]==my_chrom),]
            region_df <- data.frame(start=my_df[,POS_ind],end=my_df[,POS_ind])
        if(dim(my_df)[1]<2) {
            temp_df <- region_df
            temp_df$dist <- c(100000000)
        } else {
            temp_df <- circlize::rainfallTransform(region_df, mode = in_mode)
        }
        temp_df$CHROM <- my_chrom
        inflate_df <- rbind(inflate_df,temp_df)
    }
    out_dat$dist <- inflate_df[,dim(inflate_df)[2]-1]
    } else {
        if(in_verbose) cat("YAPSA:::annotate_intermut_dist_PID::error: input",
                " data is neither of type VRanges nor data.frame")
        return(NULL)
    }
    return(out_dat)
}


# rainfallTransformVR <- function(in_vr){
#   in_vr$dist1 <- c(1e10, as.numeric(width(gaps(in_vr)))[-1])
#   in_vr$dist2 <- c(as.numeric(width(gaps(in_vr)))[-1], 1e10)
#   return(apply(mcols(in_vr)[,c("dist1","dist2")], 1, min))
# }


#' Annotate the intermutation distance of variants cohort-wide
#'
#' The function annotates the intermutational distance to a cohort wide data
#' frame by applying \code{\link{annotate_intermut_dist_PID}} to every
#' PID-specific subfraction of the cohort wide data. Note that
#' \code{\link{annotate_intermut_dist_PID}} calls
#' \code{\link[circlize]{rainfallTransform}}. If the PID information is missing,
#' \code{\link{annotate_intermut_dist_PID}} is called directly for the whole
#' input.
#'
#' @param in_dat VRanges object, VRangesList, data frame or list of data frames
#'   which carries (at least) one column for the chromosome and one column for
#'   the position. Optionally, a column to specify the PID can be provided.
#' @param in_CHROM.field String indicating which column of \code{in_df} carries
#'   the chromosome information
#' @param in_POS.field String indicating which column of \code{in_df} carries
#'   the position information
#' @param in_PID.field String indicating which column of \code{in_df} carries
#'   the PID information
#' @param in_mode String passed through \code{\link{annotate_intermut_dist_PID}}
#'   to \code{\link[circlize]{rainfallTransform}} indicating which method to
#'   choose for the computation of the intermutational distance.
#' @param in_verbose Whether verbose or not.
#'
#' @return VRanges object, VRangesList, data frame or list of data frames
#'   identical to \code{in_df} (reordered by \code{in_PID.field}), but with the
#'   intermutation distance annotated as an additional column on the right named
#'   \code{dist}.
#'
#' @seealso \code{\link{annotate_intermut_dist_PID}}
#' @seealso \code{\link[circlize]{rainfallTransform}}
#'
#' @examples
#' test_df <- data.frame(CHROM=c(1,1,1,2,2,2,3,3,3,4,4,4,5,5),
#'                       POS=c(1,2,4,4,6,9,1,4,8,10,20,40,100,200),
#'                       REF=c("C","C","C","T","T","T","A",
#'                             "A","A","G","G","G","N","A"),
#'                       ALT=c("A","G","T","A","C","G","C",
#'                             "G","T","A","C","T","A","N"),
#'                       PID=c(1,1,1,2,2,2,1,1,2,2,2,1,1,2))
#' test_df <- test_df[order(test_df$PID,test_df$CHROM,test_df$POS),]
#' min_dist_df <-
#'   annotate_intermut_dist_cohort(test_df,in_CHROM.field="CHROM",
#'                                 in_POS.field="POS", in_PID.field="PID",
#'                                 in_mode="min")
#' max_dist_df <-
#'   annotate_intermut_dist_cohort(test_df,in_CHROM.field="CHROM",
#'                                 in_POS.field="POS", in_PID.field="PID",
#'                                 in_mode="max")
#' min_dist_df
#' max_dist_df
#'
#' @export
#' 
annotate_intermut_dist_cohort <- function(in_dat, in_CHROM.field = "CHROM",
                                        in_POS.field = "POS", 
                                        in_PID.field = NULL, 
                                        in_mode = "min", in_verbose = FALSE){
    # account for input data type
    if(inherits(in_dat, "data.frame")) {
        if(!is.null(in_PID.field)) {
            #PID_ind <- which(names(in_dat)==in_PID.field)
            in_dat[,in_PID.field] <- as.character(in_dat[,in_PID.field])
            dat_list <- split(in_dat, f = in_dat[,in_PID.field])
            out_list <- lapply(seq_along(dat_list),function(current_ind) {
            temp_out <- annotate_intermut_dist_PID(dat_list[[current_ind]],
                                            in_CHROM.field = in_CHROM.field,
                                            in_POS.field = in_POS.field,
                                            in_mode = in_mode, 
                                            in_verbose = in_verbose)
            current_name <- names(dat_list)[current_ind]
            if(is.null(current_name)) current_name <- current_ind
            temp_out[,in_PID.field] <- current_name
            return(temp_out)
        })
        out_dat <- do.call("rbind", out_list)
        } else {
            if(in_verbose) 
                cat("YAPSA:::annotate_intermut_dist_cohort::warning:",
                "no PID variable, thus no split. Simply calling ",
                "annotate_intermut_dist_PID.\n")
            out_dat <- annotate_intermut_dist_PID(in_dat,
                                            in_CHROM.field = in_CHROM.field,
                                            in_POS.field = in_POS.field,
                                            in_mode = in_mode, 
                                            in_verbose = in_verbose)
        }
    } else if(inherits(in_dat, "list")){
        if(all(unlist(lapply(in_dat, function(current_item){
            inherits(current_item, "data.frame")})))){
        if(is.null(in_PID.field)) in_PID.field <- "PID"
            out_list <- lapply(seq_along(in_dat),function(current_ind) {
            temp_out <- annotate_intermut_dist_PID(in_dat[[current_ind]],
                                            in_CHROM.field = in_CHROM.field,
                                            in_POS.field = in_POS.field,
                                            in_mode = in_mode, 
                                            in_verbose = in_verbose)
        current_name <- names(in_dat)[current_ind]
        if(is.null(current_name)) current_name <- current_ind
            temp_out[,in_PID.field] <- current_name
            return(temp_out)
        })
    names(out_list) <- names(in_dat)
    out_dat <- out_list
    }
    } else if(inherits(in_dat, "VRanges")){
    if(!is.null(in_PID.field)) {
        if(in_verbose) cat("YAPSA:::annotate_intermut_dist_cohort: input ",
                        "VRanges, PID variable found.\n")
        mcols(in_dat)[,in_PID.field] <- 
        as.character(mcols(in_dat)[,in_PID.field])
        dat_list <- split(in_dat, mcols(in_dat)[,in_PID.field])
        out_list <- lapply(seq_along(dat_list),function(current_ind) {
            temp_out <- annotate_intermut_dist_PID(dat_list[[current_ind]],
                                            in_CHROM.field = in_CHROM.field,
                                            in_POS.field = in_POS.field,
                                            in_mode = in_mode, 
                                            in_verbose = in_verbose)
            current_name <- names(dat_list)[current_ind]
            if(is.null(current_name)) current_name <- current_ind
            mcols(temp_out)[,in_PID.field] <- current_name
            return(temp_out)
            })
        out_dat <- unlist(VRangesList(out_list))
    } else {
        if(in_verbose) cat("YAPSA:::annotate_intermut_dist_cohort::warning:",
                            "no PID variable, thus no split. Simply calling ",
                            "annotate_intermut_dist_PID.\n")
        out_dat <- annotate_intermut_dist_PID(in_dat,
                                            in_CHROM.field = in_CHROM.field,
                                            in_POS.field = in_POS.field,
                                            in_mode = in_mode, 
                                            in_verbose = in_verbose)
    }
    } else if(inherits(in_dat, "VRangesList")){
        out_list <- lapply(seq_along(in_dat),function(current_ind) {
            temp_out <- annotate_intermut_dist_PID(in_dat[[current_ind]],
                                            in_CHROM.field = in_CHROM.field,
                                            in_POS.field = in_POS.field,
                                            in_mode = in_mode, 
                                            in_verbose = in_verbose)
        current_name <- names(in_dat)[current_ind]
        if(is.null(current_name)) current_name <- current_ind
        mcols(temp_out)[,in_PID.field] <- current_name
        return(temp_out)
        })
    names(out_list) <- names(in_dat)
    out_dat <- VRangesList(out_list)
    } else {
        if(in_verbose) cat("YAPSA:::annotate_intermut_dist_cohort::error:",
                            "input of wrong type, return NULL.\n")
        return(NULL)
    }
    return(out_dat)
}


#' Make a custom data structure for subgroups
#'
#' Creates a data frame carrying the subgroup information and the order in which
#' the PIDs have to be displayed. Calls \code{\link{aggregate}} on
#' \code{in_vcf_like_df}.
#'
#' @param in_vcf_like_df vcf-like data frame with point mutation calls
#' @param in_exposures_df Data frame with the signature exposures
#' @param in_palette Palette for colour attribution to the subgroups if nun-NULL
#' @param in_subgroup.field String indicating which column of
#'   \code{in_vcf_like_df} carries the subgroup information
#' @param in_PID.field String indicating which column of \code{in_vcf_like_df}
#'   and of \code{in_exposures_df} carries the PID information
#' @param in_verbose Whether verbose or not.
#'
#' @return subgroups_df: A data frame carrying the subgroup and rank
#'   information.
#'
#' @examples
#'  data(lymphoma_test)
#'  data(lymphoma_cohort_LCD_results)
#'  choice_ind <- (names(lymphoma_Nature2013_COSMIC_cutoff_exposures_df)
#'                 %in% unique(lymphoma_test_df$PID))
#'  lymphoma_test_exposures_df <-
#'    lymphoma_Nature2013_COSMIC_cutoff_exposures_df[,choice_ind]
#'  make_subgroups_df(lymphoma_test_df,lymphoma_test_exposures_df)
#'
#' @seealso \code{\link{aggregate}}
#'
#' @export
#' 
make_subgroups_df <- function(in_vcf_like_df,
                                in_exposures_df = NULL,
                                in_palette = NULL,
                                in_subgroup.field="SUBGROUP",
                                in_PID.field="PID", in_verbose = FALSE){
    # account for input data type
    if(!(inherits(in_vcf_like_df, "VRanges")) & 
        !(inherits(in_vcf_like_df, "data.frame"))){
        if(in_verbose) 
            cat("YAPSA:::make_subgroups_df::warning: Input is neither ",
                "a VRanges object nor a data frame. Return NULL.\n")
        return(NULL)
    }
    if(inherits(in_vcf_like_df, "VRanges")) {
        choice_column_vector <- c("seqnames", "start", "ref", "alt",
                                    in_subgroup.field, in_PID.field)
        in_vcf_like_df <- as.data.frame(in_vcf_like_df)
        colum_names <- intersect(names(in_vcf_like_df),choice_column_vector)
        in_vcf_like_df <- in_vcf_like_df[,colum_names]
        names(in_vcf_like_df) <- 
            gsub("seqnames", "CHROM", names(in_vcf_like_df))
        names(in_vcf_like_df) <- 
            gsub("start", "POS", names(in_vcf_like_df))
        names(in_vcf_like_df) <- gsub("ref", "REF", names(in_vcf_like_df))
        names(in_vcf_like_df) <- gsub("alt", "ALT", names(in_vcf_like_df))
    }
    ## 1. rename the colnames in in_vcf_like_df if necessary to be able to run
    ## the aggregate command later
    subgroup_ind <- which(names(in_vcf_like_df)==in_subgroup.field)
    names(in_vcf_like_df)[subgroup_ind] <- "SUBGROUP"
    PID_ind <- which(names(in_vcf_like_df)==in_PID.field)
    names(in_vcf_like_df)[PID_ind] <- "PID"
    ## 2. start work
    out_subgroups_df <- aggregate(SUBGROUP~PID,data=in_vcf_like_df,
                                    function(l) return(l[1]))
    if(!is.null(in_exposures_df)) 
        this_sum_df <- data.frame(sum=apply(in_exposures_df,2,sum))
    else {
        this_sum_df <- as.data.frame(table(in_vcf_like_df[,PID_ind]))
        rownames(this_sum_df) <- this_sum_df[,1]
        names(this_sum_df)[2] <- "sum"
        this_sum_df[,1] <- NULL
    }
    out_subgroups_df <- merge(out_subgroups_df, this_sum_df,
                            by.x=in_PID.field,by.y=0)
    max_total_count <- max(out_subgroups_df$sum)
    out_subgroups_df$compl_sum <- max_total_count - out_subgroups_df$sum
    temp_ind <- order(out_subgroups_df$SUBGROUP,out_subgroups_df$compl_sum)
    out_subgroups_df$index <- order(temp_ind)
    names(out_subgroups_df)[2] <- "subgroup"
    if(is.null(in_palette)){
        in_palette <- rainbow(length(unique(out_subgroups_df$subgroup)))
    }
    out_subgroups_df$col <- in_palette[factor(out_subgroups_df$subgroup)]
    out_subgroups_df$subgroup <- as.character(out_subgroups_df$subgroup)
    return(out_subgroups_df)
}


#' Wrapper for Shapiro test but allow for all identical values
#' 
#' @param in_vector
#'  Numerical vector the Shapiro-Wilk test is computed on
#' 
#' @return p-value of the Shapiro-Wilk test, zero if all entries in the input
#'  vector \code{in_vector} are identical.
#' 
#' @seealso \code{\link[stats]{shapiro.test}}
#' 
#' @examples
#'  shapiro_if_possible(runif(100,min=2,max=4))
#'  shapiro_if_possible(rnorm(100,mean=5,sd=3))
#'  shapiro_if_possible(rep(4.3,100))
#'  shapiro_if_possible(c("Hello","World"))
#' 
#' @export
#' 
shapiro_if_possible <- function(in_vector){
    if(is.numeric(in_vector)){
        if(length(unique(in_vector)) > 1){
            return(shapiro.test(in_vector)$p.value)
        } else {
            return(0.0)
        }
    } else {
        cat("YAPSA:::shapiro_if_possible::error: Non-numeric input")
        return(NULL)
    }
}


#' Split an exposures data frame by subgroups
#'
#' If a cohort consists of different subgroups, this function enables to split
#' the data frame storing the signature exposures into a list of data frames
#' with signature exposures, one per subgroup. This functionality is needed for
#' \code{\link{stat_test_subgroups}} and \code{\link{stat_plot_subgroups}}
#'
#' @param in_exposures_df Numerical data frame of the exposures (i.e.
#'   contributions of the different signatures to the number of point mutations
#'   per PID)
#' @param in_subgroups_df Data frame indicating which PID belongs to which
#'   subgroup
#' @param in_subgroups.field Name indicating which column in
#'   \code{in_subgroups_df} contains the subgroup information
#' @param in_PID.field Name indicating which column in \code{in_subgroups_df}
#'   contains the PID information
#'
#' @return List of data frames with the subgroup specific signature exposures.
#'
#' @seealso \code{\link{stat_test_subgroups}}
#' @seealso \code{\link{stat_plot_subgroups}}
#'
#' @examples
#'  NULL
#'
#' @export
#' 
split_exposures_by_subgroups <- function(in_exposures_df,in_subgroups_df,
                                        in_subgroups.field="subgroup",
                                        in_PID.field="PID"){
    subgroup_index <- which(names(in_subgroups_df)==in_subgroups.field)
    PID_index <- which(names(in_subgroups_df)==in_PID.field)
    # split in_exposures_df
    subgroups_list <- split(in_subgroups_df,in_subgroups_df[,subgroup_index])
    exposures_list <- lapply(subgroups_list, FUN=function(x) {
        PID_vector <- x[,PID_index]
        choice_ind <- which(names(in_exposures_df) %in% PID_vector)
        if(length(choice_ind)>1){
            out_df <- in_exposures_df[,choice_ind]
        } else {
            out_df <- data.frame(temp=in_exposures_df[,choice_ind])
            names(out_df)[1] <- PID_vector[1]
        }
        return(out_df)
    })
    return(exposures_list)
}



#' Add an element as first entry to a list
#' 
#' Works for all types of lists and inputs
#' 
#' @param in_list
#'  List to which an element is to be added
#' @param in_element
#'  Element to be added
#' 
#' @return List with input element as first entry.
#' 
#' @examples
#'  NULL
#' 
#' @export
#' 
add_as_fist_to_list <- function(in_list,in_element){
    out_list <- in_list
    number_of_elements <- length(in_list)
    out_list[[number_of_elements+1]] <- in_element
    my_ind <- c(number_of_elements+1,seq_len(number_of_elements))
    return(out_list[my_ind])
}


#' Merge exposure data frames
#'
#' Merges with the special feature of preserving the signatures and signature
#' order.
#'
#' @param in_exposures_list List of data frames (carrying information on
#'   exposures).
#' @param in_signatures_df Data frame \code{W} in which the columns represent
#'   the signatures.
#'
#' @return A data frame with the merged exposures.
#'
#' @examples
#'  NULL
#'
#' @export
#' 
merge_exposures <- function(in_exposures_list,
                            in_signatures_df){
    exposures_list <- lapply(in_exposures_list,FUN=function(current_df) {
        current_df$sig <- rownames(current_df)
        return(current_df)
    })
    expousre_list_no_null <- exposures_list[!sapply(exposures_list, is.null)] 
    #Filter for NA
    exposures_df <- Reduce(function(...) merge(..., by="sig",
                                            all=TRUE, sort=FALSE),
                                            expousre_list_no_null)
    row_order <- order(match(exposures_df$sig,names(in_signatures_df)))
    exposures_df <- exposures_df[row_order,]
    rownames(exposures_df) <- exposures_df$sig
    exposures_df$sig <- NULL
    exposures_df[is.na(exposures_df)] <- 0
    return(exposures_df)
}


#' Generically melts exposure data frames
#' 
#' Melt an exposure data frame with signatures as ID variables.
#' 
#' @param in_df
#'  Numeric data frame with exposures.
#' 
#' @return A data frame with the molten exposures.
#' 
#' @examples
#'  NULL
#' 
#' @export
#' 
melt_exposures <- function(in_df){
    in_df$sig <- rownames(in_df)
    in_df_melt <- melt(in_df,id.vars = "sig")
    names(in_df_melt) <- gsub("variable","PID",names(in_df_melt))
    return(in_df_melt)
}


#' Compares alternative exposures
#'
#' Compares exposures computed by two alternative approaches for the same cohort
#'
#' @param in_exposures1_df Numeric data frame with exposures, ideally the
#'   smaller exposure data is supplied first.
#' @param in_exposures2_df Numeric data frame with exposures, ideally the bigger
#'   exposure data is supplied second.
#' @param deselect_flag Wehther signatures absent in both exposure data frames
#'   should be removed.
#'
#' @return A list with entries \code{merge_df}, \code{all_cor.coeff},
#'   \code{all_p.value}, \code{cor.coeff_vector}, \code{p.value_vector},
#'   \code{all_cor.test}, and \code{cor.test_list}. \itemize{ \item
#'   \code{merge_df}: Merged molten input exposure data frames \item
#'   \code{all_cor.coeff}: Pearson correlation coefficient for all data points,
#'   i.e. taken all signatures together \item \code{all_p.value}: P-value of the
#'   Pearson test for all data points, i.e. taken all signatures together \item
#'   \code{cor.coeff_vector}: A vector of Pearson correlation coefficients
#'   evaluated for every signature independently \item \code{p.value_vector}: A
#'   vector of p-values of the Pearson tests evaluated for every signature
#'   independently \item \code{all_cor.test}: A data structure as returned by
#'   \code{\link{cor.test}} for all data points, i.e. taken all signatures
#'   together \item \code{cor.test_list}: A list of data structures as returned
#'   by \code{\link{cor.test}}, but evaluated for every signature independently
#'   }
#'
#' @examples
#'  NULL
#'
#' @export
#' 
compare_exposures <- function(in_exposures1_df,
                                in_exposures2_df,
                                deselect_flag=TRUE){
    signatures1 <- rownames(in_exposures1_df)
    signatures2 <- rownames(in_exposures2_df)
    common_signatures <- intersect(signatures1,signatures2)
    if(length(common_signatures) == 0) return(NULL)
    common_signatures <- union(signatures2,signatures1)
    exposures1_df_melt <- melt_exposures(in_exposures1_df)
    names(exposures1_df_melt) <- gsub("value","exposures1",
                                names(exposures1_df_melt))
    exposures2_df_melt <- melt_exposures(in_exposures2_df)
    names(exposures2_df_melt) <- gsub("value","exposures2",
                                names(exposures2_df_melt))
    merge_df <- merge(exposures1_df_melt,exposures2_df_melt,by=c("sig","PID"),
                                sort=FALSE,all=TRUE)
    merge_df$exposures1[which(!is.finite(merge_df$exposures1))] <- 0
    merge_df$exposures2[which(!is.finite(merge_df$exposures2))] <- 0
    if(deselect_flag){
        deselect_ind <- which(merge_df$exposures1==0 & merge_df$exposures2==0)
        merge_df <- merge_df[-deselect_ind,]    
    }
    all_cor.test <- cor.test(merge_df$exposures1,merge_df$exposures2)
    cor.test_list <- lapply(
        split(merge_df,f = merge_df$sig),
        FUN=function(current_df){
        levels1 <- length(unique(current_df$exposures1))
        levels2 <- length(unique(current_df$exposures2))
        if(levels1 > 1 & levels2 > 1) {
            out.test <- cor.test(current_df$exposures1,current_df$exposures2)
        } else {
            out.test <- NULL       
        } 
    })
    cor.coeff_vector <- unlist(lapply(
        cor.test_list,
        function(current_test){
            if(is.null(current_test)) return(0)
            return(as.numeric(current_test$estimate))
    }))
    p.value_vector <- unlist(lapply(
    cor.test_list,
    function(current_test){
        if(is.null(current_test)) return(1)
            return(as.numeric(current_test$p.value))
        }))
    match_ind <- match(common_signatures,names(cor.test_list))
    cor.test_list <- cor.test_list[match_ind]
    cor.coeff_vector <- cor.coeff_vector[match_ind]
    p.value_vector <- p.value_vector[match_ind]
    return(list(merge_df=merge_df,
                all_cor.coeff=all_cor.test$estimate,
                all_p.value=all_cor.test$p.value,
                cor.coeff_vector=cor.coeff_vector,
                p.value_vector=p.value_vector,
                all_cor.test=all_cor.test,
                cor.test_list=cor.test_list))
}


#' Find samples affected
#'
#' Find samples affected by SNVs in a certain pathway
#'
#' @param in_gene_list List of genes in the pathway of interest.
#' @param in_gene_vector Character vector for genes annotated to SNVs as in
#'   \code{vcf_like_df}.
#' @param in_PID_vector Character vector for sample names annotated to SNVs as
#'   in \code{vcf_like_df}.
#'
#' @return A character vector of the names of the affected samples
#'
#' @examples
#'  NULL
#'
#' @export
#' 
find_affected_PIDs <- function(in_gene_list,
                                in_gene_vector,
                                in_PID_vector){
    choice_gene_pattern <- paste0(in_gene_list,collapse="|")
    choice_mut_ind <- grep(choice_gene_pattern,in_gene_vector)
    affected_PIDs <- unique(in_PID_vector[choice_mut_ind])
    return(affected_PIDs)
}


#' Test significance of association
#'
#' Test significance of association between a vector of exposures and a
#' selection of samples, e.g. those affected by mutations in a pathway as
#' returned by \code{\link{find_affected_PIDs}}
#'
#' @param in_exposure_vector Named vector of a phenotype (e.g. exposures to a
#'   specific signature)
#' @param in_affected_PIDs Character vector of samples affected by some
#'   criterion, e.g. mutations in a pathway as returned by
#'   \code{\link{find_affected_PIDs}}
#' @param in_mutation_label If non-NULL, prefix to the mutation status (x-axis
#'   label) in the produced boxplot
#' @param in_exposure_label If non-NULL, prefix to the exposures (y-axis label)
#'   in the produced boxplot
#'
#' @return A list with entries: \itemize{ \item \code{current_kruskal}: Kruskal
#'   test object from testing phenotype against affection \item
#'   \code{current_boxplot}: Boxplot of phenotype against affection }
#'
#' @examples
#'  NULL
#'
#' @importFrom ggbeeswarm geom_beeswarm
#' @export
#' 
test_exposureAffected <- function(in_exposure_vector,
                                    in_affected_PIDs,
                                    in_mutation_label=NULL,
                                    in_exposure_label=NULL){
    .e <- environment()
    factor_vector <- rep("wt",length(in_exposure_vector)) 
    names(factor_vector) <- names(in_exposure_vector)
    factor_vector[in_affected_PIDs] <- "mut"
    if(!is.null(in_mutation_label)) factor_vector <- 
        paste0(in_mutation_label,"-", factor_vector)
    factor_vector <- factor(factor_vector)
    test_df <- data.frame(
        exposure=as.numeric(in_exposure_vector),mut_stat=factor_vector)
    current_kruskal <- kruskal.test(exposure~mut_stat,data=test_df)
    current_boxplot <- ggplot(environment = .e, data = test_df) +  
        geom_boxplot(aes_string(x = "mut_stat", y = "exposure")) +
        geom_beeswarm(aes_string(x = "mut_stat", y = "exposure", 
                                col = "mut_stat")) +
        theme(legend.position="none")
    if(!is.null(in_exposure_label)){
        current_boxplot <- current_boxplot + ylab(paste0(in_exposure_label,
                                            "exposure"))
    }
    return(list(kruskal=current_kruskal,
                boxplot=current_boxplot))
}


#' Round to a defined precision
#'
#' This function is an extension with regard to the function \code{\link{round}}
#' from base R as it allows not only digits as precision, but can also round to
#' a user-specified precision. The interval in which the rounding operation is
#' to be carried out also can be specified by the user (default is the unit
#' interval). Alternatively, breaks can be provided.
#'
#' @param x Vector to be rounded
#' @param breaks The breaks used for rounding. Default NULL
#' @param in_precision Precition default 0.05
#' @param in_interval Interval needs to be larger than the precision value
#'
#' @return A list with two entries: \itemize{ \item \code{values}: the rounded
#'   vector \item \code{breaks}: the breaks used for rounding }
#'
#' @export
#'
#' @examples
#'  NULL
#' 
round_precision <- function(x, breaks = NULL, in_precision = 0.05, 
                            in_interval = c(0,1)){
    if(is.null(breaks)){
        if(is.null(in_interval)) in_interval <- c(min(x), max(x))
        if(any(x < in_interval[1] | x > in_interval[2])) {
            warning("YAPSA:::round_precision::warning: ",
                "input is not contained in specified interval.\n")
        return(x)
    }
    if((in_interval[2] - in_interval[1]) < in_precision) {
        warning("YAPSA:::round_precision::warning: ",
                "specified interval is smaller than specified precision.\n")
        return(x)
    }
    breaks <- seq(in_interval[1], in_interval[2], in_precision)
    }
    out_vec <- unlist(lapply(x, function(y) breaks[which.min(abs(y - breaks))]))
    return(list(values = out_vec,
                breaks = breaks))
}


#' Readjust the vector to it's original norm after rounding
#' 
#' After use of the function \code{\link{round_precision}} the norm of the 
#' input vector may have been altered by the rounding procedure. This 
#' function restores the norm by altering only the largest entry in the 
#' rounded vector (in order to create the least possible relative error).
#'
#' @param x vector to be rounded
#' @param in_interval Interval
#'
#' @return The adapted form of the input vector \code{x}.
#' 
#' @export
#'
#' @examples
#'  NULL
#' 
correct_rounded <- function(x, in_interval = c(0,1)){
    if(sum(x) == in_interval[2]) return(x)
    max_ind <- which.max(x)
    x[max_ind] <- in_interval[2] - sum(x[-max_ind])
    return(x)
}

test_that("Test cosine_dist with 2-dim vectors", {
  a <- c(1,0)
  b <- c(0,1)
  d <- c(1,1)
  expect_equal(YAPSA:::cosineDist(a,b),1)
  expect_equal(YAPSA:::cosineDist(a,a),0)
  expect_equal(YAPSA:::cosineDist(b,b),0)
  expect_lt(YAPSA:::cosineDist(a,d) - (1-cos(pi/4)),1e-08)
})


test_that("Test compare_sets", {
  ## define two sets of vectors (signatures)
  sig_1_df <- data.frame(matrix(c(1,0,0,0,0,1,0,0,0,0,1,0),ncol=3))
  names(sig_1_df) <- paste0("B",seq_len(dim(sig_1_df)[2]))
  sig_2_df <- data.frame(matrix(c(1,1,0,0,0,0,1,1),ncol=2))
  ## define control parameters
  dummy <- (1-cos(pi/4))
  distance_matrix <- data.frame(matrix(c(dummy,dummy,1,1,1,dummy),ncol=2))
  ## execute function to be tested
  test_list <- YAPSA:::compare_sets(sig_1_df,sig_2_df)
  ## compare
  expect_that(test_list$distance, is_equivalent_to(distance_matrix))
  expect_that(test_list$hierarchy_small[1,], is_equivalent_to(names(sig_2_df)))
  expect_that(test_list$hierarchy_big[1,], is_equivalent_to(names(sig_1_df)))
})


test_that("Test repeat_df", {
  test_df <- data.frame(matrix(rep(1,6),ncol=3))
  expect_equal(sum(abs(YAPSA:::repeat_df(1,2,3)-test_df)), 0)
  test_df <- data.frame(matrix(rep(NA,6),ncol=2))
  expect_that(YAPSA:::repeat_df(NA,3,2), is_equivalent_to(test_df))
  test_df <- data.frame(matrix(rep("a",12),ncol=3))
  expect_that(YAPSA:::repeat_df("a",4,3), is_equivalent_to(test_df))
})


test_that("Test normalize_df_per_dim", {
  ## define a test data set
  test_df <- data.frame(matrix(c(1,2,3,0,5,2,3,4,0,6,0,0,0,0,0,4,5,6,0,7),
                               ncol=4))
  ## 1. test row-wise
  choice_rows <- which(rowSums(test_df)>0)
  ## 1.a run function
  row_norm_df <- YAPSA:::normalize_df_per_dim(test_df,1)
  ## 1.b compare
  expect_that(rowSums(row_norm_df[choice_rows,]), 
              is_equivalent_to(rep(1,length(choice_rows))))
  expect_that(rowSums(row_norm_df[-choice_rows,]), 
              is_equivalent_to(rep(0,dim(test_df)[1]-length(choice_rows))))
  ## 2. test column-wise
  choice_cols <- which(colSums(test_df)>0)
  ## 2.a run function
  col_norm_df <- YAPSA:::normalize_df_per_dim(test_df,2)
  ## 2.b compare
  expect_that(colSums(col_norm_df[,choice_cols]), 
              is_equivalent_to(rep(1,length(choice_cols))))
  expect_that(sum(col_norm_df[,-choice_cols]), is_equivalent_to(0))
})


test_that("Test average_over_present", {
  ## define a test data set
  test_df <- data.frame(matrix(c(1,2,3,0,5,2,3,4,0,6,0,0,0,0,0,4,5,6,0,7),
                               ncol=4))
  ## 1. test row-wise
  choice_cols <- which(colSums(test_df)>0)
  ## 1.a run function
  row_mean_vec <- YAPSA:::average_over_present(test_df,1)
  ## 1.b compare
  expect_that(apply(test_df[,choice_cols],1,mean), 
              is_equivalent_to(row_mean_vec))
  ## 2. test column-wise
  choice_rows <- which(rowSums(test_df)>0)
  ## 2.a run function
  col_mean_vec <- YAPSA:::average_over_present(test_df,2)
  ## 2.b compare
  expect_that(apply(test_df[choice_rows,],2,mean), 
              is_equivalent_to(col_mean_vec))
})


test_that("Test sd_over_present", {
  ## define a test data set
  test_df <- data.frame(matrix(c(1,2,3,0,5,2,3,4,0,6,0,0,0,0,0,4,5,6,0,7),
                               ncol=4))
  ## 1. test row-wise
  choice_cols <- which(colSums(test_df)>0)
  ## 1.a run function
  row_sd_vec <- YAPSA:::sd_over_present(test_df,1)
  ## 1.b compare
  expect_that(apply(test_df[,choice_cols],1,sd), is_equivalent_to(row_sd_vec))
  ## 2. test column-wise
  choice_rows <- which(rowSums(test_df)>0)
  ## 2.a run function
  col_sd_vec <- YAPSA:::sd_over_present(test_df,2)
  ## 2.b compare
  expect_that(apply(test_df[choice_rows,],2,sd), is_equivalent_to(col_sd_vec))
})


test_that("Test sum_over_list_of_df", {
  ## define a test data set
  A <- data.frame(matrix(c(1,1,1,2,2,2),ncol=2))
  B <- data.frame(matrix(c(3,3,3,4,4,4),ncol=2))
  compare_df <- data.frame(matrix(c(4,4,4,6,6,6),ncol=2))
  ## 1. for a named list
  df_list <- list(A=A,B=B)
  ## compare
  result_df <- sum_over_list_of_df(df_list)
  expect_equal(class(result_df), "data.frame")
  expect_that(result_df, is_equivalent_to(compare_df))
  ## 2. for a non-named list
  df_list <- list()
  df_list[[1]] <- A
  df_list[[2]] <- B
  ## compare
  result_df <- sum_over_list_of_df(df_list)
  expect_equal(class(result_df), "data.frame")
  expect_that(result_df, is_equivalent_to(compare_df))
})


test_that("Test the stderrmean function with small dummy vector",{
  A <- c(1,2,3)
  expect_lt(abs(stderrmean(A)-(1/(sqrt(3)))),1e-10)
})


test_that("Test stderrmean_over_present", {
  ## define a test data set
  test_df <- data.frame(matrix(c(1,2,3,0,5,2,3,4,0,6,0,0,0,0,0,4,5,6,0,7),
                               ncol=4))
  ## 1. test row-wise
  choice_cols <- which(colSums(test_df)>0)
  ## 1.a run function
  row_stderrmean_vec <- YAPSA:::stderrmean_over_present(test_df,1)
  ## 1.b compare
  expect_that(apply(test_df[,choice_cols],1,stderrmean), 
              is_equivalent_to(row_stderrmean_vec))
  ## 2. test column-wise
  choice_rows <- which(rowSums(test_df)>0)
  ## 2.a run function
  col_stderrmean_vec <- YAPSA:::stderrmean_over_present(test_df,2)
  ## 2.b compare
  expect_that(apply(test_df[choice_rows,],2,stderrmean), 
              is_equivalent_to(col_stderrmean_vec))
})


test_that("Test translate_to_hg19 on very simple synthetic data", {
  ## define a test data set
  test_df <- data.frame(CHROM=c(1, 2, 23, 24), 
                        POS=c(100, 120000000, 300000, 25000),
                        dummy=c("a", "b", "c", "d"))
  ## run function
  hg19_df <- translate_to_hg19(test_df, in_CHROM.field = "CHROM")
  ## compare
  expect_equal(hg19_df$CHROM, c("chr1","chr2","chrX","chrY"))
  expect_equal(hg19_df[,c(2,3)], test_df[,c(2,3)])
})


test_that("Test translate_to_1kG on very simple synthetic data", {
  ## define a test data set
  test_df <- data.frame(CHROM=c(1, 2, 23, 24),
                        POS=c(100, 120000000, 300000, 25000),
                        dummy=c("a", "b", "c", "d"))
  hg19_df <- translate_to_hg19(test_df, in_CHROM.field = "CHROM")
  ## run function
  onekG_df <- translate_to_1kG(hg19_df, in_CHROM.field = "CHROM")
  ## compare
  expect_equal(onekG_df$CHROM,as.character(test_df$CHROM))
  expect_equal(onekG_df[,c(2,3)], test_df[,c(2,3)])
})


test_that(paste0("Test attribute_nucleotide_exchanges on ",
                 "very simple synthetic data"), {
  ## define a test data set
  test_df <- data.frame(CHROM=c(1,1,1,2,2,2,3,3,3,4,4,4,5,5),
                        POS=c(1,2,3,4,5,6,1,2,3,4,5,6,7,8),
                        REF=c("C","C","C","T","T","T","A",
                              "A","A","G","G","G","N","A"),
                        ALT=c("A","G","T","A","C","G","C",
                              "G","T","A","C","T","A","N"))
  ## run function
  test_df$change <- attribute_nucleotide_exchanges(test_df, 
                                                   in_REF.field = "REF",
                                                   in_ALT.field = "ALT")
  ## compare
  expect_equal(test_df$change,
              factor(c("CA","CG","CT","TA","TC","TG","TG",
                              "TC","TA","CT","CG","CA",NA,NA),
                            levels=c("CA", "CG", "CT", "TA", "TC", "TG")))
})


test_that("Test annotate_intermut_dist_PID on very simple synthetic data", {
  ## define a test data set
  test_df <- data.frame(CHROM=c(1,1,1,2,2,2,3,3,3,4,4,4,5,5),
                        POS=c(1,2,4,4,6,9,1,4,8,10,20,40,100,200),
                        REF=c("C","C","C","T","T","T","A",
                              "A","A","G","G","G","N","A"),
                        ALT=c("A","G","T","A","C","G","C",
                              "G","T","A","C","T","A","N"))
  ## run function
  min_dist_df <- annotate_intermut_dist_PID(test_df,in_CHROM.field="CHROM",
                                            in_POS.field="POS", in_mode="min")
  max_dist_df <- annotate_intermut_dist_PID(test_df,in_CHROM.field="CHROM",
                                            in_POS.field="POS", in_mode="max")
  ## compare
  expect_equal(min_dist_df$dist,c(1,1,2,2,2,3,3,3,4,10,10,20,100,100))
  expect_equal(max_dist_df$dist,c(1,2,2,2,3,3,3,4,4,10,20,20,100,100))
})


test_that("Test annotate_intermut_dist_cohort on very simple synthetic data", {
  ## define a test data set
  test_df <- data.frame(CHROM=c(1,1,1,2,2,2,3,3,3,4,4,4,5,5),
                        POS=c(1,2,4,4,6,9,1,4,8,10,20,40,100,200),
                        REF=c("C","C","C","T","T","T","A",
                              "A","A","G","G","G","N","A"),
                        ALT=c("A","G","T","A","C","G","C",
                              "G","T","A","C","T","A","N"),
                        PID=c(1,1,1,2,2,2,1,1,2,2,2,1,1,2))
  test_df <- test_df[order(test_df$PID,test_df$CHROM,test_df$POS),]
  ## run function
  min_dist_df <- annotate_intermut_dist_cohort(test_df,
                                               in_CHROM.field = "CHROM",
                                               in_POS.field = "POS",
                                               in_PID.field = "PID",
                                               in_mode = "min")
  max_dist_df <- annotate_intermut_dist_cohort(test_df,
                                               in_CHROM.field = "CHROM",
                                               in_POS.field = "POS",
                                               in_PID.field = "PID",
                                               in_mode = "max")
  ## compare
  expect_equal(min_dist_df$dist,
              c(1,1,2,3,3,1e+08,1e+08,2,2,3,1e+08,10,10,1e+08))
  expect_equal(max_dist_df$dist,
              c(1,2,2,3,3,1e+08,1e+08,2,3,3,1e+08,10,10,1e+08))
})


test_that("Test shapiro_if_possible on very simple synthetic data", {
  significance_threshold <- 0.05
  set.seed(1)
  expect_lt(shapiro_if_possible(runif(100,min=2,max=4)), 
            significance_threshold)
  set.seed(1)
  expect_gt(shapiro_if_possible(rnorm(100,mean=5,sd=3)),
            significance_threshold)
  expect_equal(shapiro_if_possible(rep(4.3,100)),0)
  expect_null(shapiro_if_possible(c("Hello","World")))
})


test_that("Test make_subgroups_df with real data",{
  data(lymphoma_test)
  data(lymphoma_cohort_LCD_results)
  choice_ind <- (names(lymphoma_Nature2013_COSMIC_cutoff_exposures_df) 
                 %in% unique(lymphoma_test_df$PID))
  lymphoma_test_exposures_df <- 
    lymphoma_Nature2013_COSMIC_cutoff_exposures_df[,choice_ind]
  test_subgroups_df <- 
    make_subgroups_df(lymphoma_test_df, lymphoma_test_exposures_df)
  real_subgroups_df <- aggregate(SUBGROUP~PID, data = lymphoma_test_df,
                                 function(l) return(l[1]))
  real_subgroups_df[,2] <- as.character(real_subgroups_df[,2])
  expect_that(test_subgroups_df[,c(1,2)],is_equivalent_to(real_subgroups_df))
})

## ----load_style, warning=FALSE, message=FALSE, results="hide"-----------------
library(BiocStyle)

## ----warning=FALSE, message=FALSE---------------------------------------------
library(YAPSA)
library(knitr)
opts_chunk$set(echo=TRUE)
opts_chunk$set(fig.show='asis')

## ----loadLymphoma-------------------------------------------------------------
data("lymphoma_Nature2013_raw")

## ----loadLymphomaFtp, eval=FALSE----------------------------------------------
# lymphoma_Nature2013_ftp_path <- paste0(
#   "https://ftp.sanger.ac.uk/pub/cancer/AlexandrovEtAl/",
#   "somatic_mutation_data/Lymphoma%20B-cell/",
#   "Lymphoma%20B-cell_clean_somatic_mutations_",
#   "for_signature_analysis.txt")
# lymphoma_Nature2013_raw_df <- read.csv(file=lymphoma_Nature2013_ftp_path,
#                                        header=FALSE,sep="\t")

## ----adaptData----------------------------------------------------------------
names(lymphoma_Nature2013_raw_df) <- c("PID","TYPE","CHROM","START",
                                       "STOP","REF","ALT","FLAG")
lymphoma_Nature2013_df <- subset(lymphoma_Nature2013_raw_df,TYPE=="subs",
                                 select=c(CHROM,START,REF,ALT,PID))
names(lymphoma_Nature2013_df)[2] <- "POS"
kable(head(lymphoma_Nature2013_df), 
      caption = "First rows of the file containing the SNV variant calls.")

## ----PIDinfo------------------------------------------------------------------
unique(lymphoma_Nature2013_df$PID)

## ----annotateSubgroup, warning=FALSE, message=FALSE---------------------------
lymphoma_Nature2013_df$SUBGROUP <- "unknown"
DLBCL_ind <- grep("^DLBCL.*",lymphoma_Nature2013_df$PID)
lymphoma_Nature2013_df$SUBGROUP[DLBCL_ind] <- "DLBCL_other"
MMML_ind <- grep("^41[0-9]+$",lymphoma_Nature2013_df$PID)
lymphoma_Nature2013_df <- lymphoma_Nature2013_df[MMML_ind,]
data(lymphoma_PID)
for(my_PID in rownames(lymphoma_PID_df)) {
  PID_ind <- which(as.character(lymphoma_Nature2013_df$PID)==my_PID)
  lymphoma_Nature2013_df$SUBGROUP[PID_ind] <-
    lymphoma_PID_df$subgroup[which(rownames(lymphoma_PID_df)==my_PID)]
}
lymphoma_Nature2013_df$SUBGROUP <- factor(lymphoma_Nature2013_df$SUBGROUP)
unique(lymphoma_Nature2013_df$SUBGROUP)

## ----intermutDistances, warning=FALSE, message=FALSE, results="hide"----------
lymphoma_Nature2013_df <- translate_to_hg19(lymphoma_Nature2013_df,"CHROM")
lymphoma_Nature2013_df$change <- 
  attribute_nucleotide_exchanges(lymphoma_Nature2013_df)
lymphoma_Nature2013_df <- 
  lymphoma_Nature2013_df[order(lymphoma_Nature2013_df$PID,
                               lymphoma_Nature2013_df$CHROM,
                               lymphoma_Nature2013_df$POS),]
lymphoma_Nature2013_df <- annotate_intermut_dist_cohort(lymphoma_Nature2013_df,
                                                        in_PID.field="PID")
data("exchange_colour_vector")
lymphoma_Nature2013_df$col <- 
  exchange_colour_vector[lymphoma_Nature2013_df$change]

## ----makeRainfallPlot, fig.cap="Rainfall plot in a trellis structure."--------
choice_PID <- "4121361"
PID_df <- subset(lymphoma_Nature2013_df,PID==choice_PID)
#trellis_rainfall_plot(PID_df,in_point_size=unit(0.5,"mm"))

## ----loadStoredSigData--------------------------------------------------------
data(sigs)

## ----processOldSigs-----------------------------------------------------------
Alex_signatures_path <- paste0("https://ftp.sanger.ac.uk/pub/cancer/",
                               "AlexandrovEtAl/signatures.txt")
AlexInitialArtif_sig_df <- read.csv(Alex_signatures_path,header=TRUE,sep="\t")
kable(AlexInitialArtif_sig_df[c(1:9),c(1:4)])

## ----reformatOldSigs----------------------------------------------------------
Alex_rownames <- paste(AlexInitialArtif_sig_df[,1],
                       AlexInitialArtif_sig_df[,2],sep=" ")
select_ind <- grep("Signature",names(AlexInitialArtif_sig_df))
AlexInitialArtif_sig_df <- AlexInitialArtif_sig_df[,select_ind]
number_of_Alex_sigs <- dim(AlexInitialArtif_sig_df)[2]
names(AlexInitialArtif_sig_df) <- gsub("Signature\\.","A",
                                       names(AlexInitialArtif_sig_df))
rownames(AlexInitialArtif_sig_df) <- Alex_rownames
kable(AlexInitialArtif_sig_df[c(1:9),c(1:6)],
      caption="Exemplary data from the initial Alexandrov signatures.")

## ----filterValidatedSignatures------------------------------------------------
AlexInitialValid_sig_df <- AlexInitialArtif_sig_df[,grep("^A[0-9]+",
                                          names(AlexInitialArtif_sig_df))]
number_of_Alex_validated_sigs <- dim(AlexInitialValid_sig_df)[2]

## ----loadSigs-----------------------------------------------------------------
data(AlexCosmicValid_sig_df)
Alex_COSMIC_rownames <- paste(AlexCosmicValid_sig_df[,1],
                              AlexCosmicValid_sig_df[,2],sep=" ")
COSMIC_select_ind <- grep("Signature",names(AlexCosmicValid_sig_df))
AlexCosmicValid_sig_df <- AlexCosmicValid_sig_df[,COSMIC_select_ind]
number_of_Alex_COSMIC_sigs <- dim(AlexCosmicValid_sig_df)[2]
names(AlexCosmicValid_sig_df) <- gsub("Signature\\.","AC",
                                         names(AlexCosmicValid_sig_df))
rownames(AlexCosmicValid_sig_df) <- Alex_COSMIC_rownames
kable(AlexCosmicValid_sig_df[c(1:9),c(1:6)],
      caption="Exemplary data from the updated Alexandrov signatures.")

## ----reorderFeatures----------------------------------------------------------
COSMIC_order_ind <- match(Alex_rownames,Alex_COSMIC_rownames)
AlexCosmicValid_sig_df <- AlexCosmicValid_sig_df[COSMIC_order_ind,]
kable(AlexCosmicValid_sig_df[c(1:9),c(1:6)],
      caption=paste0("Exemplary data from the updated Alexandrov ",
                     "signatures, rows reordered."))

## ----buildSigIndDf------------------------------------------------------------
signature_colour_vector <- c("darkgreen","green","pink","goldenrod",
                             "lightblue","blue","orangered","yellow",
                             "orange","brown","purple","red",
                             "darkblue","magenta","maroon","yellowgreen",
                             "violet","lightgreen","sienna4","deeppink",
                             "darkorchid","seagreen","grey10","grey30",
                             "grey50","grey70","grey90")
bio_process_vector <- c("spontaneous deamination","spontaneous deamination",
                        "APOBEC","BRCA1_2","Smoking","unknown",
                        "defect DNA MMR","UV light exposure","unknown",
                        "IG hypermutation","POL E mutations","temozolomide",
                        "unknown","APOBEC","unknown","unknown","unknown",
                        "unknown","unknown","unknown","unknown","unknown",
                        "nonvalidated","nonvalidated","nonvalidated",
                        "nonvalidated","nonvalidated")
AlexInitialArtif_sigInd_df <- data.frame(sig=colnames(AlexInitialArtif_sig_df))
AlexInitialArtif_sigInd_df$index <- seq_len(dim(AlexInitialArtif_sigInd_df)[1])
AlexInitialArtif_sigInd_df$colour <- signature_colour_vector
AlexInitialArtif_sigInd_df$process <- bio_process_vector

COSMIC_signature_colour_vector <- c("green","pink","goldenrod",
                                    "lightblue","blue","orangered","yellow",
                                    "orange","brown","purple","red",
                                    "darkblue","magenta","maroon",
                                    "yellowgreen","violet","lightgreen",
                                    "sienna4","deeppink","darkorchid",
                                    "seagreen","grey","darkgrey",
                                    "black","yellow4","coral2","chocolate2",
                                    "navyblue","plum","springgreen")
COSMIC_bio_process_vector <- c("spontaneous deamination","APOBEC",
                               "defect DNA DSB repair hom. recomb.",
                               "tobacco mutatgens, benzo(a)pyrene",
                               "unknown",
                               "defect DNA MMR, found in MSI tumors",
                               "UV light exposure","unknown","POL eta and SHM",
                               "altered POL E",
                               "alkylating agents, temozolomide",
                               "unknown","APOBEC","unknown",
                               "defect DNA MMR","unknown","unknown",
                               "unknown","unknown",
                               "associated w. small indels at repeats",
                               "unknown","aristocholic acid","unknown",
                               "aflatoxin","unknown","defect DNA MMR",
                               "unknown","unknown","tobacco chewing","unknown")
AlexCosmicValid_sigInd_df <- data.frame(sig=colnames(AlexCosmicValid_sig_df))
AlexCosmicValid_sigInd_df$index <- seq_len(dim(AlexCosmicValid_sigInd_df)[1])
AlexCosmicValid_sigInd_df$colour <- COSMIC_signature_colour_vector
AlexCosmicValid_sigInd_df$process <- COSMIC_bio_process_vector

## ----loadLibraries, warning=FALSE, message=FALSE------------------------------
library(BSgenome.Hsapiens.UCSC.hg19)

## ----buildMutationalCatalogue, results="hide"---------------------------------
word_length <- 3

lymphomaNature2013_mutCat_list <- 
  create_mutation_catalogue_from_df(
    lymphoma_Nature2013_df,
    this_seqnames.field = "CHROM", this_start.field = "POS",
    this_end.field = "POS", this_PID.field = "PID",
    this_subgroup.field = "SUBGROUP",
    this_refGenome = BSgenome.Hsapiens.UCSC.hg19,
    this_wordLength = word_length)

## ----displayStructureMutationCatalogueList------------------------------------
names(lymphomaNature2013_mutCat_list)
lymphomaNature2013_mutCat_df <- as.data.frame(
  lymphomaNature2013_mutCat_list$matrix)
kable(lymphomaNature2013_mutCat_df[c(1:9),c(5:10)])

## ----LCD, warning=FALSE-------------------------------------------------------
current_sig_df <- AlexCosmicValid_sig_df
current_sigInd_df <- AlexCosmicValid_sigInd_df
lymphomaNature2013_COSMICExposures_df <-
  LCD(lymphomaNature2013_mutCat_df,current_sig_df)

## ----makeSubgroupsDfLCD-------------------------------------------------------
COSMIC_subgroups_df <- 
  make_subgroups_df(lymphoma_Nature2013_df,
                    lymphomaNature2013_COSMICExposures_df)

## ----captionBarplot, echo=FALSE-----------------------------------------------
cap <- "Absoute exposures of the COSMIC signatures in the lymphoma mutational
        catalogues, no cutoff for the LCD (Linear Combination Decomposition)"

## ----exposuresBarplotLCD, fig.width=6, fig.height=5, fig.cap=cap--------------
exposures_barplot(
  in_exposures_df = lymphomaNature2013_COSMICExposures_df,
  in_subgroups_df = COSMIC_subgroups_df)

## ----captionBarplot2, echo=FALSE----------------------------------------------
cap <- "Absoute exposures of the COSMIC signatures in the lymphoma mutational
    catalogues, no cutoff for the LCD (Linear Combination Decomposition)"

## ----exposuresBarplotLCDsigInd, fig.width=6, fig.height=5, fig.cap=cap--------
exposures_barplot(
  in_exposures_df = lymphomaNature2013_COSMICExposures_df,
  in_signatures_ind_df = current_sigInd_df,
  in_subgroups_df = COSMIC_subgroups_df)

## ----rowSumsInCohort----------------------------------------------------------
rowSums(lymphomaNature2013_COSMICExposures_df)

## ----LCDcomplexCutoffZero-----------------------------------------------------
zero_cutoff_vector <- rep(0,dim(current_sig_df)[2])
CosmicValid_cutoffZero_LCDlist <- LCD_complex_cutoff(
  in_mutation_catalogue_df = lymphomaNature2013_mutCat_df,
  in_signatures_df = current_sig_df,
  in_cutoff_vector = zero_cutoff_vector,
  in_sig_ind_df = current_sigInd_df)

## ----applyMakeSubgroupsDfZero-------------------------------------------------
COSMIC_subgroups_df <- 
  make_subgroups_df(lymphoma_Nature2013_df,
                    CosmicValid_cutoffZero_LCDlist$exposures)

## ----captionBarplot3, echo=FALSE----------------------------------------------
cap="Absoute exposures of the COSMIC signatures in the lymphoma mutational
    catalogues, no cutoff for the LCD (Linear Combination Decomposition)."

## ----exposuresBarplotAbsCutoffZero, fig.width=6, fig.height=5, fig.cap=cap----
exposures_barplot(
  in_exposures_df = CosmicValid_cutoffZero_LCDlist$exposures,
  in_signatures_ind_df = CosmicValid_cutoffZero_LCDlist$out_sig_ind_df,
  in_subgroups_df = COSMIC_subgroups_df)

## ----caption_barplot_4, echo=FALSE--------------------------------------------
cap="Relative exposures of the COSMIC signatures in the lymphoma mutational
    catalogues, no cutoff for the LCD (Linear Combination Decomposition)."

## ----exposuresBarplotRelCutoffZero, fig.width=6, fig.height=5, fig.cap=cap----
exposures_barplot(
  in_exposures_df = CosmicValid_cutoffZero_LCDlist$norm_exposures,
  in_signatures_ind_df = CosmicValid_cutoffZero_LCDlist$out_sig_ind_df,
  in_subgroups_df = COSMIC_subgroups_df)

## ----definitionCutoff---------------------------------------------------------
my_cutoff <- 0.06

## ----LCDcomplexCutoffCutoffGen, warning=FALSE---------------------------------
general_cutoff_vector <- rep(my_cutoff,dim(current_sig_df)[2])
CosmicValid_cutoffGen_LCDlist <- LCD_complex_cutoff(
  in_mutation_catalogue_df = lymphomaNature2013_mutCat_df,
  in_signatures_df = current_sig_df,
  in_cutoff_vector = general_cutoff_vector,
  in_sig_ind_df = current_sigInd_df)

## -----------------------------------------------------------------------------
kable(CosmicValid_cutoffGen_LCDlist$out_sig_ind_df, row.names=FALSE,
      caption=paste0("Signatures with cohort-wide exposures > ",my_cutoff))

## ----captionBarplot5, echo=FALSE----------------------------------------------
cap="Absoute exposures of the COSMIC signatures in the lymphoma mutational
    catalogues, cutoff of 6% for the LCD (Linear Combination Decomposition)."

## ----exposuresBarplotAbsCutoffGen, fig.width=6, fig.height=4, fig.cap=cap-----
exposures_barplot(
  in_exposures_df = CosmicValid_cutoffGen_LCDlist$exposures,
  in_signatures_ind_df = CosmicValid_cutoffGen_LCDlist$out_sig_ind_df,
  in_subgroups_df = COSMIC_subgroups_df)

## ----captionBarplot6, echo=FALSE----------------------------------------------
cap="Relative exposures of the COSMIC signatures in the lymphoma mutational
    catalogues, cutoff of 6% for the LCD (Linear Combination Decomposition)."

## ----exposuresBarplotRelGutoffGen, fig.width=6, fig.height=4, fig.cap=cap-----
exposures_barplot(
  in_exposures_df = CosmicValid_cutoffGen_LCDlist$norm_exposures,
  in_signatures_ind_df = CosmicValid_cutoffGen_LCDlist$out_sig_ind_df,
  in_subgroups_df = COSMIC_subgroups_df)

## ----makeSpecificCutoffVector-------------------------------------------------
specific_cutoff_vector <- general_cutoff_vector
specific_cutoff_vector[c(1,5)] <- 0
specific_cutoff_vector

## ----LCDcomplexCutoffCutoffSpec, warning=FALSE--------------------------------
CosmicValid_cutoffSpec_LCDlist <- LCD_complex_cutoff(
  in_mutation_catalogue_df = lymphomaNature2013_mutCat_df,
  in_signatures_df = current_sig_df,
  in_cutoff_vector = specific_cutoff_vector,
  in_sig_ind_df = current_sigInd_df)

## ----captionBarplot7, echo=FALSE----------------------------------------------
cap="Absoute exposures of the COSMIC signatures in the lymphoma mutational
    catalogues, cutoff of 6% for the LCD (Linear Combination Decomposition)."

## ----exposuresBarplotAbsCutoffSpec, fig.width=6, fig.height=4, fig.cap=cap----
exposures_barplot(
  in_exposures_df = CosmicValid_cutoffSpec_LCDlist$exposures,
  in_signatures_ind_df = CosmicValid_cutoffSpec_LCDlist$out_sig_ind_df,
  in_subgroups_df = COSMIC_subgroups_df)

## ----captionBarplot8, echo=FALSE----------------------------------------------
cap="Relative exposures of the COSMIC signatures in the lymphoma mutational
    catalogues, cutoff of 6% for the LCD (Linear Combination Decomposition)."

## ----exposuresBarplotRelCutoffSpec, fig.width=6, fig.height=4, fig.cap=cap----
exposures_barplot(
  in_exposures_df = CosmicValid_cutoffSpec_LCDlist$norm_exposures,
  in_signatures_ind_df = CosmicValid_cutoffSpec_LCDlist$out_sig_ind_df,
  in_subgroups_df = COSMIC_subgroups_df)

## ----captionHeatmap, echo=FALSE-----------------------------------------------
cap="Clustering of Samples and Signatures based on the relative exposures of
    the COSMIC signatures in the lymphoma mutational catalogues."

## ----applyHeatmapExposures, fig.width=6, fig.height=4, fig.cap=cap------------
complex_heatmap_exposures(CosmicValid_cutoffGen_LCDlist$norm_exposures,
                          COSMIC_subgroups_df,
                          CosmicValid_cutoffGen_LCDlist$out_sig_ind_df,
                          in_data_type="norm exposures",
                          in_subgroup_colour_column="col",
                          in_method="manhattan",
                          in_subgroup_column="subgroup")

## ----caption_hclust, echo=FALSE-----------------------------------------------
cap="Clustering of the Samples based on the relative exposures of the
    COSMIC signatures in the lymphoma mutational catalogues."

## ----applyHclustExposures, fig.width=6, fig.height=3, fig.cap=cap-------------
hclust_list <- 
  hclust_exposures(CosmicValid_cutoffGen_LCDlist$norm_exposures,
                   COSMIC_subgroups_df,
                   in_method="manhattan",
                   in_subgroup_column="subgroup")

## ----caption_heatmap_2, echo=FALSE--------------------------------------------
cap=paste0("PIDs labelled by the clusters extracted from the
            signature analysis.")

## ----clusterPIDsSigInfo, fig.width=6, fig.height=4, fig.cap=cap---------------
cluster_vector <- cutree(hclust_list$hclust,k=4)
COSMIC_subgroups_df$cluster <- cluster_vector
subgroup_colour_vector <- rainbow(length(unique(COSMIC_subgroups_df$cluster)))
COSMIC_subgroups_df$cluster_col <- 
  subgroup_colour_vector[factor(COSMIC_subgroups_df$cluster)]
complex_heatmap_exposures(CosmicValid_cutoffGen_LCDlist$norm_exposures,
                          COSMIC_subgroups_df,
                          CosmicValid_cutoffGen_LCDlist$out_sig_ind_df,
                          in_data_type="norm exposures",
                          in_subgroup_colour_column="cluster_col",
                          in_method="manhattan",
                          in_subgroup_column="cluster")

# Copyright © 2014-2019  The YAPSA package contributors
# This file is part of the YAPSA package. The YAPSA package is licenced under
# GPL-3

#' Wrapper function for the Stratification of a Mutational Catalogue
#'
#' \code{\link{run_SMC}} takes as input a big dataframe constructed from a
#' vcf-like file of a whole cohort. This wrapper function calls custom functions
#' to construct a mutational catalogue and stratify it according to categories
#' indicated by a special column in the input dataframe: \itemize{ \item
#' \code{\link{create_mutation_catalogue_from_df}} \item
#' \code{adjust_number_of_columns_in_list_of_catalogues} } This stratification
#' yields a collection of stratified mutational catalogues, these are
#' reformatted and sent to the custom function \code{\link{SMC}} and thus
#' indirectly to \code{\link{LCD_SMC}} to perform a signature analysis of the
#' stratified mutational catalogues. The result is then handed over to
#' \code{\link{plot_SMC}} for visualization.
#'
#' @param my_table A big dataframe constructed from a vcf-like file of a whole
#'   cohort. The first columns are those of a standard vcf file, followed by an
#'   arbitrary number of custom or user defined columns. One of these must carry
#'   a PID (patient or sample identifyier) and one must be the category used for
#'   stratification.
#' @param this_signatures_df A numeric data frame \code{W} in with \code{n} rows
#'   and \code{l} columns, \code{n} being the number of features and \code{l}
#'   being the number of signatures
#' @param this_signatures_ind_df A data frame containing meta information about
#'   the signatures
#' @param this_subgroups_df A data frame indicating which PID (patient or sample
#'   identifyier) belongs to which subgroup
#' @param column_name Name of the column in \code{my_table} which is going to be
#'   used for stratification
#' @param refGenome FaFile of the reference genome to extract the motif context
#'   of the variants in \code{my_table}
#' @param cohort_method_flag Either or several of
#'   \code{c("all_PIDs","cohort","norm_PIDs")}, representing alternative ways to
#'   average over the cohort.
#' @param in_strata_order_ind Index vector defining reordering of the strata
#' @param wordLength Integer number defining the length of the features or
#'   motifs, e.g. 3 for tripletts or 5 for pentamers
#' @param verbose_flag Verbose if \code{verbose_flag=1}
#' @param target_dir Path to directory where the results of the stratification
#'   procedure are going to be stored if non-NULL.
#' @param strata_dir Path to directory where the mutational catalogues of the
#'   different strata are going to be stored if non-NULL
#' @param output_path Path to directory where the results, especially the
#'   figures produced by \code{\link{plot_SMC}} are going to be stored.
#' @param in_all_exposures_df Optional argument, if specified, \code{H}, i.e.
#'   the overall exposures without stratification, is set to equal
#'   \code{in_all_exposures_df}. This is equivalent to forcing the
#'   \code{\link{LCD_SMC}} procedure to use e.g. the exposures of a previously
#'   performed NMF decomposition.
#' @param in_rownames Optional parameter to specify rownames of the mutational
#'   catalogue \code{V} i.e. the names of the features.
#' @param in_norms If specified, vector of the correction factors for every
#'   motif due to differing trinucleotide content. If null, no correction is
#'   applied.
#' @param in_label_orientation Whether or not to turn the labels on the x-axis.
#' @param this_sum_ind Optional set of indices for reordering the PIDs
#'
#' @return A list with entries \code{exposures_list}, \code{catalogues_list},
#'   \code{cohort} and \code{name_list}. \itemize{ \item \code{exposures_list}:
#'   The list of \code{s} strata specific exposures Hi, all are numerical data
#'   frames with \code{l} rows and \code{m} columns, \code{l} being the number
#'   of signatures and \code{m} being the number of samples \item
#'   \code{catalogues_list}: A list of \code{s} strata specific cohortwide (i.e.
#'   averaged over cohort) normalized exposures \item \code{cohort}:
#'   \code{subgroups_df} adjusted for plotting \item \code{name_list}: Names of
#'   the contructed strata. }
#'
#' @examples
#'  library(BSgenome.Hsapiens.UCSC.hg19)
#'  data(sigs)
#'  data(lymphoma_test)
#'  data(lymphoma_cohort_LCD_results)
#'  strata_list <-
#'    cut_breaks_as_intervals(lymphoma_test_df$random_norm,
#'                            in_outlier_cutoffs=c(-4,4),
#'                            in_cutoff_ranges_list=list(c(-2.5,-1.5),
#'                                                       c(0.5,1.5)),
#'                            in_labels=c("small","intermediate","big"))
#'  lymphoma_test_df$random_cat <- strata_list$category_vector
#'  choice_ind <- (names(lymphoma_Nature2013_COSMIC_cutoff_exposures_df)
#'                 %in% unique(lymphoma_test_df$PID))
#'  lymphoma_test_exposures_df <-
#'    lymphoma_Nature2013_COSMIC_cutoff_exposures_df[,choice_ind]
#'  temp_subgroups_df <- make_subgroups_df(lymphoma_test_df,
#'                                         lymphoma_test_exposures_df)
#'  mut_density_list <- run_SMC(lymphoma_test_df,
#'                              AlexCosmicValid_sig_df,
#'                              AlexCosmicValid_sigInd_df,
#'                              temp_subgroups_df,
#'                              column_name="random_cat",
#'                              refGenome=BSgenome.Hsapiens.UCSC.hg19,
#'                              cohort_method_flag="norm_PIDs",
#'                              in_rownames = rownames(AlexCosmicValid_sig_df))
#'
#' @seealso \code{\link{create_mutation_catalogue_from_df}}
#' @seealso \code{\link{normalizeMotifs_otherRownames}}
#' @seealso \code{\link{plot_SMC}}
#'
#' @export
#' 
run_SMC <- 
  function(my_table, this_signatures_df, this_signatures_ind_df,
           this_subgroups_df, column_name, refGenome,
           cohort_method_flag = "all_PIDs",
           in_strata_order_ind=seq_len(length(unique(my_table[,column_name]))),
           wordLength = 3,verbose_flag = 1,
           target_dir = NULL, strata_dir = NULL, output_path = NULL,
           in_all_exposures_df=NULL, in_rownames = c(), in_norms = NULL,
           in_label_orientation="turn", this_sum_ind=NULL) {
  refGenome_Seqinfo <- seqinfo(refGenome)
  if (verbose_flag==1) cat("\nYAPSA:::run_SMC::calling ",
                           "create_mutation_catalogue_from_df...\n")
  merged_results_list <- 
    create_mutation_catalogue_from_df(my_table, refGenome_Seqinfo,
                                      this_seqnames.field="CHROM",
                                      this_start.field="POS",
                                      this_end.field="POS",
                                      this_PID.field="PID",
                                      this_subgroup.field="subgroup",
                                      this_rownames = in_rownames,
                                      refGenome,wordLength,verbose_flag)
  temp_rownames <- rownames(merged_results_list$matrix)
  if (verbose_flag==1) cat("YAPSA:::run_SMC::calling ",
                           "stratify_and_create_mutational_catalogue...\n")
  all_list <- 
    stratify_and_create_mutational_catalogue(my_table,column_name,target_dir,
                                             strata_dir, refGenome_Seqinfo,
                                             our_seqnames.field="CHROM",
                                             our_start.field="POS",
                                             our_end.field="POS",
                                             our_PID.field="PID",
                                             our_subgroup.field="subgroup",
                                             refGenome,wordLength,verbose_flag,
                                             temp_rownames)
  name_list <- all_list$name_list
  df_list <- 
    adjust_number_of_columns_in_list_of_catalogues(all_list,
                                                   merged_results_list)
  mutation_catalogue_all_df <- as.data.frame(merged_results_list$matrix)
  ## adjust for trinucleotide content if necessary
  if(!is.null(in_norms)) {
    if (verbose_flag==1) cat("\nYAPSA:::run_SMC::adapting to different kmer ",
                             "distribution by calling ",
                             "normalizeMotifs_otherRownames...\n")
    df_list <- lapply(df_list, 
                      function(l) normalizeMotifs_otherRownames(l,in_norms))
    mutation_catalogue_all_df <- 
      normalizeMotifs_otherRownames(mutation_catalogue_all_df,in_norms)
  }
  number_of_strata <- length(df_list)
  number_of_sigs <- dim(this_signatures_df)[2]
  if (verbose_flag==1) cat("\nYAPSA:::run_SMC::calling SMC...\n")
  SMC_list <- SMC(df_list, this_signatures_df, in_all_exposures_df,
                  number_of_strata, number_of_sigs, name_list,
                  this_subgroups_df, mutation_catalogue_all_df,
                  cohort_method_flag, in_verbose=verbose_flag)
  exposures_strata_list <- SMC_list$exposures_strata_list
  exposures_both_rel_df_list <- SMC_list$exposures_both_rel_df_list
  this_subgroups_df <- SMC_list$this_subgroups_df
  decomposition_method <- SMC_list$decomposition_method
  ## plot
  if (verbose_flag==1) {cat("YAPSA:::run_SMC::calling plot_SMC...\n");}
  my_plot_list <- plot_SMC(number_of_strata,output_path,decomposition_method,
                           number_of_sigs,name_list,exposures_strata_list,
                           this_signatures_ind_df,this_subgroups_df,
                           in_strata_order_ind,exposures_both_rel_df_list,
                           cohort_method_flag,
                           in_label_orientation=in_label_orientation,
                           this_sum_ind=this_sum_ind)
  return(list(exposures_list=exposures_strata_list,catalogues_list=df_list,
              cohort=exposures_both_rel_df_list,name_list=name_list))
}


#'Stratification of a Mutational Catalogue
#'
#'\code{SMC} takes a given collection of stratified mutational catalogues
#'\code{Vi}, sends them to perform a mutational signatures decomposition by
#'Linear Combination Decomposition (LCD) with the functions
#'\code{\link{LCD_SMC}} with known signatures \code{W}. It subsequently performs
#'some useful statistics and preparation for plotting with the function
#'\code{\link{plot_SMC}}. \code{SMC} is naturally called by
#'\code{\link{run_SMC}}.
#'
#'@param df_list A list of \code{s} stratified mutational catalogues \code{Vi}
#'  \(numeric data frames\) with \code{n} rows and \code{m} columns each,
#'  \code{n} being the number of features and \code{m} being the number of
#'  samples.This list is naturally provided in \code{\link{run_SMC}}.
#'@param this_signatures_df A numeric data frame \code{W} in with \code{n} rows
#'  and \code{l} columns, \code{n} being the number of features and \code{l}
#'  being the number of signatures
#'@param in_all_exposures_df The overall exposures \code{H} without
#'  stratification, a numeric data frame with \code{l} rows and \code{m}
#'  columns, \code{l} being the number of signatures and \code{m} being the
#'  number of samples
#'@param number_of_strata The length of the list \code{df_list}
#'@param number_of_sigs The number of signatures used in the current
#'  decomposition.
#'@param name_list A list of names of the different strata
#'@param this_subgroups_df A data frame indicating which PID (patient or sample
#'  identifyier) belongs to which subgroup
#'@param mutation_catalogue_all_df The overall mutational catalogue \code{V}
#'  without stratification.
#'@param cohort_method_flag Either or several of
#'  \code{c("all_PIDs","cohort","norm_PIDs")}, representing alternative ways to
#'  average over the cohort.
#'@param in_verbose Verbose if \code{in_verbose=1}
#'
#'@return A list with entries \code{exposures_strata_list},
#'  \code{exposures_both_rel_df_list}, \code{this_subgroups_df},
#'  \code{subgroup_ind} and \code{decomposition_method}. \itemize{ \item
#'  \code{exposures_strata_list}: The list of \code{s} strata specific exposures
#'  Hi, all are numerical data frames with \code{l} rows and \code{m} columns,
#'  \code{l} being the number of signatures and \code{m} being the number of
#'  samples \item \code{exposures_both_rel_df_list}: A list of \code{s} strata
#'  specific cohortwide (i.e. averaged over cohort) normalized exposures \item
#'  \code{this_subgroups_df}: \code{subgroups_df} adjusted for plotting \item
#'  \code{subgroup_ind}: Index of the subgroups chosen and relevant for
#'  plotting. \item \code{decomposition_method}: String telling whether LCD or
#'  NMF was used, relevant only for handing over to \code{\link{plot_SMC}}. }
#'
#' @examples
#' NULL
#'
#'@seealso \code{\link{run_SMC}}
#'@seealso \code{\link{plot_SMC}}
#'@seealso \code{\link{LCD_SMC}}
#'
#'@import reshape2
#'@export
#'
SMC <- function(df_list, this_signatures_df, in_all_exposures_df,
                number_of_strata,number_of_sigs, name_list, this_subgroups_df,
                mutation_catalogue_all_df, cohort_method_flag, in_verbose=1){
  ## this is the LCD_SMC procedure
  if (in_verbose==1) cat("YAPSA:::SMC::calling LCD_SMC on per-PID data...\n")
  exposures_strata_list <- 
    LCD_SMC(df_list,this_signatures_df,in_all_exposures_df)
  exposures_all_df <- exposures_strata_list$exposures_all_df
  
  sum_over_exposures_all_per_pid <- apply(exposures_all_df,2,sum)
  sum_df <- data.frame(sum = sum_over_exposures_all_per_pid,
                       PID = colnames(exposures_all_df))
  ## make cohort-wide statistics
  ## 1. compute exposures in cohort as sum over PIDs
  mean_over_exposures_all_per_sig <- apply(exposures_all_df,1,mean)
  stderrmean_over_exposures_all_per_sig <- apply(exposures_all_df,1,stderrmean)
  exposures_all_PIDs_df <- 
    data.frame(all_abs = mean_over_exposures_all_per_sig,
               all_stderrmean = stderrmean_over_exposures_all_per_sig)
  temp_denominator <- sum(exposures_all_PIDs_df$all_abs)
  exposures_all_PIDs_df$all_rel <- 
    exposures_all_PIDs_df$all_abs /temp_denominator
  exposures_all_PIDs_df$all_rstderrmean <- 
    exposures_all_PIDs_df$all_stderrmean / temp_denominator
  for (i in seq_len(number_of_strata)){
    my_index <- 4*(i)+1
    temp_exposures_df <- exposures_strata_list$sub_exposures_list[[i]]
    exposures_all_PIDs_df[,my_index] <- apply(temp_exposures_df, 1, mean)
    exposures_all_PIDs_df[,my_index+1] <- 
      apply(temp_exposures_df, 1, stderrmean)
    temp_denominator <- sum(exposures_all_PIDs_df[,my_index])
    exposures_all_PIDs_df[,my_index+2] <- 
      exposures_all_PIDs_df[,my_index] / temp_denominator
    exposures_all_PIDs_df[,my_index+3] <- 
      exposures_all_PIDs_df[,my_index+1] / temp_denominator
    names(exposures_all_PIDs_df)[my_index] <- paste0(name_list[[i]] ,"_abs")
    names(exposures_all_PIDs_df)[my_index+1] <- paste0(name_list[[i]],
                                                       "_stderrmean")
    names(exposures_all_PIDs_df)[my_index+2] <- paste0(name_list[[i]], "_rel")
    names(exposures_all_PIDs_df)[my_index+3] <- paste0(name_list[[i]],
                                                       "_rstderrmean")
  }
  exposures_all_PIDs_df$sig <- rownames(exposures_all_PIDs_df)
  exposures_all_PIDs_df$method <- "all_PIDs"
  ## 2. compute exposures in cohort by running decomposition on a fused vector
  if (in_verbose==1) cat("YAPSA:::SMC::compute exposures in cohort by ",
                         "running decomposition on a fused vector...\n")
  catalogue_in_cohort_all <- apply(mutation_catalogue_all_df,1,sum)
  catalogue_in_cohort_df <- data.frame(all_abs=catalogue_in_cohort_all)
  catalogue_in_cohort_df$all_rel <- 
    catalogue_in_cohort_df$all_abs / sum(catalogue_in_cohort_df$all_abs)
  catalogue_in_cohort_df_list <- list()
  for (i in seq_len(number_of_strata)) {
    my_index <- 2*(i)+1
    temp_catalogue_df <- df_list[[i]]
    catalogue_in_cohort_df[,my_index] <- apply(temp_catalogue_df,1,sum)
    catalogue_in_cohort_df[,my_index+1] <- 
      catalogue_in_cohort_df[,my_index] / 
      sum(catalogue_in_cohort_df[,my_index])
    names(catalogue_in_cohort_df)[my_index] <- paste0(name_list[[i]], "_abs")
    names(catalogue_in_cohort_df)[my_index+1] <- paste0(name_list[[i]], "_rel")
    catalogue_in_cohort_df_list[[i]] <- 
      data.frame(all_abs = catalogue_in_cohort_df[,my_index])
  }
  catalogue_in_cohort_in_exposures <- NULL
  decomposition_method <- "LCD"
  if (!is.null(in_all_exposures_df)) {
    temp_vector <- apply(in_all_exposures_df, 1, sum)
    catalogue_in_cohort_in_exposures <- data.frame(all_abs = temp_vector)
    decomposition_method <- "NMF"
  }
  if (in_verbose==1) cat("YAPSA:::SMC::calling LCD_SMC ",
                         "on cohort-wide data...\n")
  exposures_in_cohort_strata_list <- LCD_SMC(catalogue_in_cohort_df_list,
                                             this_signatures_df,
                                             catalogue_in_cohort_in_exposures)
  temp_dim <- dim(exposures_in_cohort_strata_list$exposures_all_df)[1]
  exposures_in_cohort_df <- 
    data.frame(all_abs = exposures_in_cohort_strata_list$exposures_all_df,
               all_stderrmean = rep(0,temp_dim))
  exposures_in_cohort_df$all_rel <- exposures_in_cohort_df$all_abs / 
    sum(exposures_in_cohort_df$all_abs)
  exposures_in_cohort_df$all_rstderrmean <- 
    rep(0,dim(exposures_in_cohort_strata_list$exposures_all_df)[1])
  for (i in seq_len(number_of_strata)) {
    my_index <- 4*(i)+1
    temp_exposures_df <- 
      exposures_in_cohort_strata_list$sub_exposures_list[[i]]
    exposures_in_cohort_df[,my_index] <- temp_exposures_df$all_abs
    exposures_in_cohort_df[,my_index+1] <- 0
    exposures_in_cohort_df[,my_index+2] <- exposures_in_cohort_df[,my_index] / 
      sum(exposures_in_cohort_df[,my_index])
    exposures_in_cohort_df[,my_index+3] <- 0
    names(exposures_in_cohort_df)[my_index] <- paste0(name_list[[i]], "_abs")
    names(exposures_in_cohort_df)[my_index+1] <- paste0(name_list[[i]],
                                                        "_stderrmean")
    names(exposures_in_cohort_df)[my_index+2] <- paste0(name_list[[i]], "_rel")
    names(exposures_in_cohort_df)[my_index+3] <- paste0(name_list[[i]],
                                                        "_rstderrmean")
  }
  exposures_in_cohort_df$sig <- rownames(exposures_in_cohort_df)
  exposures_in_cohort_df$method <- "cohort"
  ## 3. average over relative exposures
  ## 3.a) compute relative exposures
  exposures_strata_list$norm_exposures_all_df <- 
    normalize_df_per_dim(exposures_strata_list$exposures_all_df,2)
  exposures_strata_list$sub_norm_exposures_list <- 
    lapply(exposures_strata_list$sub_exposures_list,
           function(l) normalize_df_per_dim(l,2))
  ## 3.b) average and build data structure
  mean_over_norm_exposures_all_per_sig <- 
    apply(exposures_strata_list$norm_exposures_all_df, 1, mean)
  stderrmean_over_norm_exposures_all_per_sig <- 
    apply(exposures_strata_list$norm_exposures_all_df, 1, stderrmean)
  norm_exposures_all_PIDs_df <- 
    data.frame(all_abs = rep(0,length(mean_over_norm_exposures_all_per_sig)),
               all_stderrmean = rep(0,length(
                 mean_over_norm_exposures_all_per_sig)),
               all_rel=mean_over_norm_exposures_all_per_sig,
               all_rstderrmean=stderrmean_over_norm_exposures_all_per_sig)
  temp_list <- lapply(exposures_strata_list$sub_norm_exposures_list,
                      function(l) apply(l,1,mean))
  for (i in seq_len(number_of_strata)) {
    my_index <- 4*(i)+1
    norm_exposures_all_PIDs_df[,my_index] <- 0
    norm_exposures_all_PIDs_df[,my_index+1] <- 0
    temp_vec <- average_over_present(
      exposures_strata_list$sub_norm_exposures_list[[i]], 1)
    if(!is.null(temp_vec)) {
      norm_exposures_all_PIDs_df[,my_index+2] <- temp_vec
    } else {
      norm_exposures_all_PIDs_df[,my_index+2] <- 0
    }
    temp_vec <- stderrmean_over_present(
      exposures_strata_list$sub_norm_exposures_list[[i]], 1)
    if(!is.null(temp_vec)) {
      norm_exposures_all_PIDs_df[,my_index+3] <- temp_vec
    } else {
      norm_exposures_all_PIDs_df[,my_index+3] <- 0
    }
    names(norm_exposures_all_PIDs_df)[my_index] <- paste0(name_list[[i]],
                                                          "_abs")
    names(norm_exposures_all_PIDs_df)[my_index+1] <- paste0(name_list[[i]],
                                                            "_stderrmean")
    names(norm_exposures_all_PIDs_df)[my_index+2] <- paste0(name_list[[i]],
                                                            "_rel")
    names(norm_exposures_all_PIDs_df)[my_index+3] <- paste0(name_list[[i]],
                                                            "_rstderrmean")
  }
  norm_exposures_all_PIDs_df$sig <- rownames(exposures_all_PIDs_df)
  norm_exposures_all_PIDs_df$method <- "norm_PIDs"
  ## 4 unite the 3 different methods into one dataframe
  exposures_combMethod_df <- 
    rbind(exposures_all_PIDs_df, 
          exposures_in_cohort_df, 
          norm_exposures_all_PIDs_df)
  abs_ind <- grep(".*_abs|^sig$|^method$", names(exposures_combMethod_df))
  rel_ind <- grep(".*_rel|^sig$|^method$", names(exposures_combMethod_df))
  rstderrmean_ind <- grep(".*_rstderrmean|^sig$|^method$",
                          names(exposures_combMethod_df))
  exposures_combMethod_abs_df <- exposures_combMethod_df[,abs_ind]
  exposures_combMethod_rel_df <- exposures_combMethod_df[,rel_ind]
  exposures_combMethod_rstderrmean_df <- 
    exposures_combMethod_df[,rstderrmean_ind]
  ## prepare for plotting
  if (in_verbose==1) {cat("YAPSA:::SMC::prepare for plotting...\n");}
  exposures_combMethod_rel_melt_df <- 
    melt(exposures_combMethod_rel_df, id.vars=c("sig","method"), 
         value.name="exposure")
  exposures_combMethod_rstderrmean_melt_df <- 
    melt(exposures_combMethod_rstderrmean_df, id.vars=c("sig","method"),
         value.name="exposure_rstderrmean")
  exposures_combMethod_rel_melt_df$rstderrmean <- 
    exposures_combMethod_rstderrmean_melt_df$exposure_rstderrmean
  exposures_combMethod_rel_melt_df$exposure_min <- 
    exposures_combMethod_rel_melt_df$exposure - 
    exposures_combMethod_rstderrmean_melt_df$exposure_rstderrmean
  exposures_combMethod_rel_melt_df$exposure_max <- 
    exposures_combMethod_rel_melt_df$exposure + 
    exposures_combMethod_rstderrmean_melt_df$exposure_rstderrmean
  counter <- 0
  exposures_combMethod_rel_df_list <- list()
  exposures_combMethod_rstderrmean_df_list <- list()
  method_choice_ind <- 
    which(exposures_combMethod_rel_melt_df$method %in% cohort_method_flag)
  exposures_combMethod_rel_melt_df <- 
    exposures_combMethod_rel_melt_df[method_choice_ind,]
  for (temp_varname in unique(exposures_combMethod_rel_melt_df$variable)) {
    counter <- counter + 1
    temp_ind <- which(exposures_combMethod_rel_melt_df$variable==temp_varname)
    exposures_combMethod_rel_df_list[[counter]] <- 
      exposures_combMethod_rel_melt_df[temp_ind,]
    exposures_combMethod_rel_df_list[[counter]]$sig <- 
      factor(exposures_combMethod_rel_df_list[[counter]]$sig,
             levels=unique(exposures_combMethod_rel_df_list[[counter]]$sig))
  }  
  ## adapt subgroups data structure
  if(dim(mutation_catalogue_all_df)[2]==dim(this_subgroups_df)[1]) {
    this_subgroups_df$PID <- colnames(mutation_catalogue_all_df)
    this_subgroups_df$sum <- sum_df$sum
    max_total_count <- max(this_subgroups_df$sum)
    this_subgroups_df$compl_sum <- max_total_count - this_subgroups_df$sum
    subgroup_ind <- 
      order(this_subgroups_df$subgroup, this_subgroups_df$compl_sum)
    this_subgroups_df$index <- order(subgroup_ind)
  } else {
    cat("YAPSA:::SMC::Warning: dimension mismatch between ",
        "mutation_catalogue_df and subgroup_df.\n")
    q(status=5)
  }
  return(list(exposures_strata_list=exposures_strata_list,
              exposures_both_rel_df_list=exposures_combMethod_rel_df_list,
              this_subgroups_df=this_subgroups_df,
              subgroup_ind=subgroup_ind,
              decomposition_method=decomposition_method))
}


#' Apply statistical tests to a stratification (SMC)
#'
#' \code{stat_test_SMC} tests for enrichment or depletion in the different
#' strata of a stratification of the mutational catalogue for every signature
#' independently by applying Kruskal Wallis tests. For those signatures where
#' the Kruskal Wallis test gives a significant p-value, pairwise posthoc tests
#' are carried out by calling \code{\link[PMCMRplus]{kwAllPairsNemenyiTest}}.
#' Additionally all data is tested for normality by Shapiro Wilk tests, so that
#' the user may apply ANOVA and pairwise posthoc t-test where allowed.
#'
#' @param in_strat_list A list with entries \code{exposures_list},
#'   \code{catalogues_list}, \code{cohort} and \code{name_list} as in the output
#'   of \code{\link{run_SMC}}. \itemize{ \item \code{exposures_list}: The list
#'   of \code{s} strata specific exposures Hi, all are numerical data frames
#'   with \code{l} rows and \code{m} columns, \code{l} being the number of
#'   signatures and \code{m} being the number of samples \item
#'   \code{catalogues_list}: A list of \code{s} strata specific cohortwide (i.e.
#'   averaged over cohort) normalized exposures \item \code{cohort}:
#'   \code{subgroups_df} adjusted for plotting \item \code{name_list}: Names of
#'   the contructed strata. }
#' @param in_flag If "norm", all tests are performed on normalized exposures,
#'   otherwise the absolute exposures are taken.
#'
#' @return A list with entries \code{kruskal_df}, \code{shapiro_df},
#'   \code{kruskal_posthoc_list}, \itemize{ \item \code{kruskal_df}: A data
#'   frame containing results (statistic and p values) of the Kruskal Wallis
#'   tests (tests for enrichment or depletion in the different strata for every
#'   signature independently). \item \code{shapiro_df}: A data frame containing
#'   results (p values) of the Shapiro Wilk tests (tests for normal distribution
#'   in the different strata for every signature independently). \item
#'   \code{kruskal_posthoc_list}: A list of results of pairwise posthoc tests
#'   carried out for those signatures where the Kruskal Wallis test yielded a
#'   significant p-value (carried out by
#'   \code{\link[PMCMRplus]{kwAllPairsNemenyiTest}}). }
#'
#' @examples
#'  NULL
#'
#' @seealso \code{\link{run_SMC}}
#' @seealso \code{\link[PMCMRplus]{kwAllPairsNemenyiTest}}
#' @seealso \code{\link[stats]{kruskal.test}}
#' @seealso \code{\link{shapiro_if_possible}}
#' @seealso \code{\link[stats]{shapiro.test}}
#'
#' @importFrom  PMCMRplus kwAllPairsNemenyiTest
#' @export
#' 
stat_test_SMC <- function(in_strat_list,in_flag="norm"){
  my_number_of_strata <- 
    length(in_strat_list$exposures_list$sub_norm_exposures_list)
  my_signatures <- 
    rownames(in_strat_list$exposures_list$sub_norm_exposures_list[[1]])
  my_number_of_signatures <- 
    dim(in_strat_list$exposures_list$sub_norm_exposures_list[[1]])[1]
  my_number_of_PIDs <- 
    dim(in_strat_list$exposures_list$sub_norm_exposures_list[[1]])[2]
  out_stat_df <- repeat_df(NA,my_number_of_signatures,3)
  shapiro_df <- repeat_df(NA,my_number_of_signatures,my_number_of_strata)
  rownames(out_stat_df) <- my_signatures
  rownames(shapiro_df) <- my_signatures
  names(out_stat_df) <- c("Kruskal_statistic","df","Kruskal_p_val")
  posthoc_list <- list()
  for(temp_sig in my_signatures){
    sig_exposures_vector <- c()
    sig_strata_vector <- c()
    for(j in seq_len(my_number_of_strata)){
      if(in_flag=="norm"){
        temp_df <- in_strat_list$exposures_list$sub_norm_exposures_list[[j]]
      } else {
        temp_df <- in_strat_list$exposures_list$sub_exposures_list[[j]]
      }
      PID_choice_ind <- which(colSums(temp_df)>0)
      temp_exposures_vector <- as.numeric(temp_df[temp_sig,PID_choice_ind])
      sig_exposures_vector <- c(sig_exposures_vector,temp_exposures_vector)
      sig_strata_vector <- c(sig_strata_vector,
          rep(in_strat_list$name_list[[j]],length(temp_exposures_vector)))
      ## catch exception for temp_exposures_vector being all equal values 
      ## (all zero)
      shapiro_df[temp_sig,j] <- shapiro_if_possible(temp_exposures_vector)
    }
    sig_strata_vector <- factor(sig_strata_vector)
    sig_kruskal <- kruskal.test(sig_exposures_vector,sig_strata_vector)
    posthoc_list[[temp_sig]] <- 
      kwAllPairsNemenyiTest(x=sig_exposures_vector,g=sig_strata_vector)
    out_stat_df[temp_sig,1] <- sig_kruskal$statistic
    out_stat_df[temp_sig,2] <- sig_kruskal$parameter
    out_stat_df[temp_sig,3] <- sig_kruskal$p.value
  }
  out_stat_df$Kruskal_p_val_BH <- p.adjust(out_stat_df$Kruskal_p_val, 
                                           method="BH")
  return(list(kruskal_df=out_stat_df,shapiro_df = shapiro_df,
              kruskal_posthoc_list = posthoc_list))
}


#' Test for differences in average signature exposures between subgroups
#'
#' Apply Kruskal-Wallis tests to detect differences in the signature exposures
#' between different subgroups. Uses \code{\link{split_exposures_by_subgroups}}.
#' Algorithm analogous to \code{\link{stat_test_SMC}}.
#'
#' @param in_exposures_df Numerical data frame of the exposures (i.e.
#'   contributions of the different signatures to the number of point mutations
#'   per PID)
#' @param in_subgroups_df Data frame indicating which PID belongs to which
#'   subgroup
#' @param in_subgroups.field Name indicating which column in
#'   \code{in_subgroups_df} contains the subgroup information
#' @param in_PID.field Name indicating which column in \code{in_subgroups_df}
#'   contains the PID information
#'
#' @return A list with entries \code{kruskal_df}, \code{kruskal_posthoc_list},
#'   \itemize{ \item \code{kruskal_df}: A data frame containing results
#'   (statistic and p values) of the Kruskal Wallis tests (tests for enrichment
#'   or depletion in the different strata for every signature independently).
#'   \item \code{kruskal_posthoc_list}: A list of results of pairwise posthoc
#'   tests carried out for those signatures where the Kruskal Wallis test
#'   yielded a significant p-value (carried out by
#'   \code{\link[PMCMRplus]{kwAllPairsNemenyiTest}}). }
#'
#' @seealso \code{\link{split_exposures_by_subgroups}}
#' @seealso \code{\link{stat_test_SMC}}
#' @seealso \code{\link[PMCMRplus]{kwAllPairsNemenyiTest}}
#' @seealso \code{\link[stats]{kruskal.test}}
#'
#' @examples
#'  NULL
#'
#' @export
#' 
stat_test_subgroups <- function(in_exposures_df,in_subgroups_df,
                                in_subgroups.field="subgroup",
                                in_PID.field="PID"){
  # split the data with custom function
  exposures_df_list <- split_exposures_by_subgroups(
    in_exposures_df=in_exposures_df,in_subgroups_df=in_subgroups_df,
    in_subgroups.field=in_subgroups.field,
    in_PID.field=in_PID.field)
  number_of_subgroups <- length(exposures_df_list)
  my_signatures <- rownames(in_exposures_df)
  number_of_signatures <- length(my_signatures)
  out_stat_df <- repeat_df(NA,number_of_signatures,3)
  shapiro_df <- repeat_df(NA,number_of_signatures,number_of_subgroups)
  rownames(out_stat_df) <- my_signatures
  rownames(shapiro_df) <- my_signatures
  names(out_stat_df) <- c("Kruskal_statistic","df","Kruskal_p_val")
  posthoc_list <- list()
  for(temp_sig in my_signatures){
    sig_exposures_vector <- c()
    sig_subgroups_vector <- c()
    for(j in seq_len(number_of_subgroups)){
      temp_exposures_vector <- as.numeric(exposures_df_list[[j]][temp_sig,])
      sig_exposures_vector <- c(sig_exposures_vector,temp_exposures_vector)
      sig_subgroups_vector <- c(sig_subgroups_vector,
                             rep(names(exposures_df_list)[j],
                                 length(temp_exposures_vector)))
    }
    sig_subgroups_vector <- factor(sig_subgroups_vector)
    sig_kruskal <- kruskal.test(sig_exposures_vector,sig_subgroups_vector)
    posthoc_list[[temp_sig]] <- 
      kwAllPairsNemenyiTest(x = sig_exposures_vector,
                                   g = sig_subgroups_vector)
    out_stat_df[temp_sig,1] <- sig_kruskal$statistic
    out_stat_df[temp_sig,2] <- sig_kruskal$parameter
    out_stat_df[temp_sig,3] <- sig_kruskal$p.value
  }
  out_stat_df$Kruskal_p_val_BH <- p.adjust(out_stat_df$Kruskal_p_val, 
                                           method="BH")
  return(list(kruskal_df = out_stat_df,shapiro_df=shapiro_df,
              kruskal_posthoc_list = posthoc_list))
}


#' Run SMC at a per sample level
#'
#' Run an SMC analysis (stratification of the mutational catalogue) at per
#' sample / per-PID level, corresponding to a divide and conquer strategy. For
#' every single PID, only those signatures actually present in this PID will be
#' provided for the SMC analysis.
#'
#' @param in_dfList Named list of vcf-like data frames, one entry per sample/PID
#'   of a cohort.
#' @param in_LCDlist Output of an LCD list perfomed on the above cohort,
#'   carrying notably information on the exposures
#'   (\code{in_LCDlist$exposures}), the present signatures
#'   (\code{in_LCDlist$signatures}) and meta information about the
#'   signatures(\code{in_LCDlist$out_sig_ind_df}).
#' @param in_subgroups_df Data frame with subgroup information about the PIDs in
#'   the above mentioned cohort.
#' @param in_save_plot Boolean flag to indicate whether per-PID plots should be
#'   saved.
#' @param in_save_dir If per-PID plots are to be saved, this is the path where
#'   to save them.
#' @param in_save_name Suffix to be appended to the sample name to generate the
#'   name of the saved per-PID plots.
#' @param in_verbose_flag Whether to run verbose (1) or not (0).
#' @param ... Data passed on to \code{\link{run_SMC}}.
#'
#' @return A list of lists. The top level is a named per-PID list, each entry is
#'   of type SMClist (cf. \code{\link{run_SMC}}).
#'
#' @export
#'
#' @examples
#'  NULL
#'  
SMC_perPID <- function (in_dfList,
                        in_LCDlist,
                        in_subgroups_df,
                        in_save_plot = TRUE,
                        in_save_dir = NULL,
                        in_save_name = "KataegisSMCs.pdf",
                        in_verbose_flag = 0,
                        ...) {
  out_listsList <- 
    lapply(names(in_dfList), function(current_PID){
      if(in_verbose_flag == 1) cat("\nCurrent PID: ", current_PID, "\n")
      current_vcf_like_df <- in_dfList[[current_PID]]
      temp_sig_ind <- which(in_LCDlist$exposures[, current_PID] > 0)
      current_sig_df <- in_LCDlist$signatures[, temp_sig_ind, drop = FALSE]
      current_sigInd_df <- 
        in_LCDlist$out_sig_ind_df[temp_sig_ind, , drop = FALSE]
      current_all_exposures_df <- 
        in_LCDlist$exposures[temp_sig_ind, current_PID, drop = FALSE]
      current_subgroups_subdf <- 
        in_subgroups_df[which(in_subgroups_df$PID == current_PID),]
      currentNumberOfStrata <- length(unique(current_vcf_like_df$Kataegis))
      if(in_save_plot & !is.null(in_save_dir)){
        fileName <- file.path(in_save_dir, 
                              paste0(current_PID, "_", in_save_name))
        pdf(fileName, width = 6, height = currentNumberOfStrata + 1)
        temp_SMClist <- run_SMC(
          my_table = current_vcf_like_df,
          this_signatures_df = current_sig_df,
          this_signatures_ind_df = current_sigInd_df,
          this_subgroups_df = current_subgroups_subdf,
          verbose_flag = in_verbose_flag,
          in_all_exposures_df = current_all_exposures_df,
          ...)
        dev.off()
      } else {
        temp_SMClist <- run_SMC(
          my_table = current_vcf_like_df,
          this_signatures_df = current_sig_df,
          this_signatures_ind_df = current_sigInd_df,
          this_subgroups_df = current_subgroups_subdf,
          verbose_flag = in_verbose_flag,
          in_all_exposures_df = current_all_exposures_df,
          ...)
      }
      temp_names <- 
        unlist(lapply(temp_SMClist$cohort, function(current_df){
          return(current_df$variable[1])
        }))
      names(temp_SMClist$cohort) <- gsub("_rel", "", temp_names)
      return(temp_SMClist)
    })
  names(out_listsList) <- names(in_dfList)
  return(out_listsList)
}

# Copyright © 2014-2019  The YAPSA package contributors
# This file is part of the YAPSA package. The YAPSA package is licenced under
# GPL-3


#' Data for mutational signatures
#' 
#' The numerical data of the mutational signatures published initially by 
#' Alexandrov et al. (Nature 2013) and Alexandrov et al., (Bioaxiv 2018) is 
#' stored in data frames with endings \code{_sig_df}, the associated 
#' meta-information is stored in data frames with endings \code{_sigInd_df}. 
#' There are several instances of \code{_sig_df} and \code{_sigInd_df}, 
#' corresponding to results and data obtained at different times and with 
#' different raw data. There always is a one-to-one correspondence between
#' a \code{_sig_df} and a \code{_sigInd_df}. The data frames of type 
#' \code{_sig_df} have as many rows as there are features, i.e. 96 if 
#' analyzing mutational signatures of SNVs in a triplet context, and as
#' many columns as there are signatures.
#' Data frames of type \code{_sigInd_df} have as many rows as there are 
#' signatures in the corresponding \code{_sig_df} and several columns: 
#' \itemize{
#'  \item \code{sig}: signature name
#'  \item \code{index}: corresponding to the row index of the signature
#'  \item \code{colour}: colour for visualization in stacked barplots
#'  \item \code{process}: asserted biological process
#'  \item \code{cat.coarse}: categorization of the signatures according
#'   to the asserted biological processes at low level of detail
#'  \item \code{cat.medium}: categorization of the signatures according
#'   to the asserted biological processes at intermediate level of detail
#'  \item \code{cat.high}: categorization of the signatures according
#'   to the asserted biological processes at high level of detail
#'  \item \code{cat.putative}: categorization of the signatures according
#'   to the asserted biological processes based on clustering and inference
#'  }
#'  Please note, that categorization columns are only present for the data 
#'  frames corrosponding to the data from Alexandorv et al. (Nature 2013). 
#' 
#' @docType data
#' @name sigs
#' @usage data(sigs)
#' @author Daniel Huebschmann \email{huebschmann.daniel@@googlemail.com}
#' @references Alexandrov et al. (Nature 2013)
#' 
NULL

#' @docType data
#' @name sigs_pcawg
#' @usage data(sigs_pcawg)
#' @author Lea Jopp-Saile \email{huebschmann.daniel@@googlemail.com}
#' @references Alexandrov et al. (Biorxiv 2018)
#' 
NULL

#' Data for initial sigs, including artifacts
#' 
#' \code{AlexInitialArtif_sig_df}: Data frame of the signatures published 
#' initially by Alexandrov et al. 
#' (Nature 2013). There are 27 signatures which constitute the columns, 22 of 
#' which were validated by an orhtogonal sequencing technology. These 22 are in
#' the first 22 columns of the data frame. The column names are \emph{A} pasted
#' to the number of the signature, e.g. \emph{A5}. The nonvalidated signatures
#' have an additional letter in their naming convention: either 
#' \emph{AR1} - \emph{AR3} or \emph{AU1} - \emph{AU2}. The rownames are the 
#' features, i.e. an encoding of the nucleotide exchanges in their 
#' trinucleotide context, e.g. \emph{C>A ACA}. In total there are 96 different 
#' features and therefore 96 rows when dealing with a trinucleotide context. 
#' 
#' @source \code{AlexInitial}: \url{ftp://ftp.sanger.ac.uk/pub/cancer/AlexandrovEtAl/signatures.txt}
#' @name AlexInitialArtif_sig_df
#' @rdname sigs
#' 
NULL


#' Meta-info for initial sigs, including artifacts
#' 
#' \code{AlexInitialArtif_sigInd_df}: Meta-information for 
#' \code{AlexInitialArtif_sig_df} 
#'  
#' @name AlexInitialArtif_sigInd_df
#' @rdname sigs
#' 
NULL


#' Data for initial sigs, only validated
#' 
#' \code{AlexInitialValid_sig_df}: Data frame of only the validated signatures 
#' published initially by Alexandrov et al. (Nature 2013), corresponding to the
#' first 22 columns of \code{AlexInitialArtif_sig_df}
#' 
#' @name AlexInitialValid_sig_df
#' @rdname sigs
#' 
NULL


#' Meta-info for initial sigs, only validated
#' 
#' \code{AlexInitialValid_sigInd_df}: Meta-information for 
#' \code{AlexInitialValid_sig_df} 
#' 
#' @name AlexInitialValid_sigInd_df
#' @rdname sigs
#' 
NULL


#' Data for Cosmic sigs, only validated
#' 
#' \code{AlexCosmicValid_sig_df}: Data frame of the updated signatures list 
#' maintained by Ludmil Alexandrov at
#' \url{https://cancer.sanger.ac.uk/cosmic/signatures}. The column names are 
#' \emph{AC} pasted to the number of the signature, e.g. \emph{AC5}. The naming
#' convention for the rows is as described for 
#' \code{\link{AlexInitialArtif_sig_df}}.
#' 
#' @source \code{AlexCosmic}: \url{https://cancer.sanger.ac.uk/cancergenome/assets/signatures_probabilities.txt}
#' @name AlexCosmicValid_sig_df
#' @rdname sigs
#' 
NULL

#' Meta-info for Cosmic sigs, only validated
#' 
#' \code{AlexCosmicValid_sigInd_df}: Meta-information for 
#' \code{AlexCosmicValid_sig_df} 
#' 
#' @name AlexCosmicValid_sigInd_df
#' @rdname sigs
#' 
NULL


#' Data for Cosmic sigs, including artifacts
#' 
#' \code{AlexCosmicArtif_sig_df}: Data frame of the updated signatures list 
#' maintained by Ludmil Alexandrov at
#' \url{https://cancer.sanger.ac.uk/cosmic/signatures} and complemented by the 
#' artifact signatures from the initial publication, i.e. the last 5 columns of
#' \code{\link{AlexInitialArtif_sig_df}}. The column names are \emph{AC} pasted
#' to the number of the signature, e.g. \emph{AC5}. The naming convention for 
#' the rows is as described for \code{\link{AlexInitialArtif_sig_df}}.
#' 
#' @name AlexCosmicArtif_sig_df
#' @rdname sigs
#' 
NULL


#' Meta-info for Cosmic sigs, including artifacts
#' 
#' \code{AlexCosmicArtif_sigInd_df}: Meta-information for 
#' \code{AlexCosmicArtif_sig_df} 
#' 
#' @name AlexCosmicArtif_sigInd_df
#' @rdname sigs
#' 
NULL


#' Data for PCAWG SNV signatures (COSMIC v3), including artifacts
#'  
#' \code{PCAWG_SP_SBS_sigs_Artif_df}: Data frame of the signatures published 
#' by Alexandrov et al. (Biorxiv 2013) which were decomposed with the 
#' method SigProfiler. SNV signatures are labeled with SBS, single base 
#' signature. There are 67 signatures which constitute the columns, 47 of 
#' which were validated by a bayesian NFM mehtod, SignatureAnayzer. Validated 
#' signatures are SBS1-SBS26,SBS28-SBS42 and SBS44. SBS7 is split up into 
#' 7 a/b/c and d. SBS10 ans SBS17 are both split up into a and b. Resulting in
#' a 47 validated sigantures. Please note, unlike the paper by Alexandrov et al.
#' (Biorxiv 2018) the data sets do not contain a SBS84 and SBS85 as not all 
#' were availiablt to perfom supervised signature analysis. In total there are 
#' 96 different features and therefore 96 rows when dealing with a trinucleotide
#'context. 
#' 
#' @source \code{PCAWG_SNV}: \url{https://www.synapse.org/#!Synapse:syn11738319}
#' @name PCAWG_SP_SBS_sigs_Artif_df
#' @rdname sigs_pcawg
#' 
NULL


#' Meta-info for PCAWG SNV signatures, including artifacts
#' 
#' \code{PCAWG_SP_SBS_sigInd_Artif_df}: Meta-information for 
#' \code{PCAWG_SP_SBS_sigs_Artif_df} 
#'  
#' @name PCAWG_SP_SBS_sigInd_Artif_df
#' @rdname sigs_pcawg
#' 
NULL

#' Data for PCAWG SNV signatures (COSMIC v3), only validated
#' 
#' \code{PCAWG_SP_SBS_sigs_Real_df}: Data frame of only the validated
#' signatures published by Alexandrov et al. (Biorxiv 2018), corresponding 
#' to the column 1-26, 28-42 and 44 of the \code{PCAWG_SP_SBS_sigs_Artif_df}
#' data frame
#' 
#' @name PCAWG_SP_SBS_sigs_Real_df
#' @rdname sigs_pcawg
#' 
NULL


#' Meta-info for PCAWG SNV signatures, only validated
#' 
#' \code{PCAWG_SP_SBS_sigInd_Real_df}: Meta-information for 
#' \code{PCAWG_SP_SBS_sigs_Real_df} 
#' 
#' @name PCAWG_SP_SBS_sigInd_Real_df
#' @rdname sigs_pcawg
#' 
NULL


#' Data for PCAWG Indel signatures (COSMIC v3)
#'
#' \code{PCAWG_SP_ID_sigs_df}: Data frame with Indel signatures published by
#' Alexandrov et al. (Biorxiv 2018) which were decomposed with the method
#' SigProfiler. There are 17 Sigantures reported but as supervised signatures
#' are only valid for whole genome sequencing data analysis. In whole genome
#' sequencing data the Indel signature ID15 was not discribed and thus is not
#' part of this data set. In total 83 features are described. The categorization
#' consideres the size of the insertion and delition, the motif, and the
#' sequence context. Hereby the number of repetition or patial repetition of the
#' motif is determined.
#'
#' @source \code{PCAWG_INDEL}: \url{https://cancer.sanger.ac.uk/cosmic/signatures/ID}
#' @name PCAWG_SP_ID_sigs_df
#' @rdname sigs_pcawg
#'   
NULL


#' Meta-info for PCAWG Indel signatures
#' 
#' \code{PCAWG_SP_ID_sigInd_df}: Meta-information for 
#' \code{PCAWG_SP_ID_sigs_df} 
#' 
#' @name PCAWG_SP_ID_sigInd_df
#' @rdname sigs_pcawg
#' 
NULL



#' Test and example data
#' 
#' Data structures used in examples, SNV tests and the SNV signature vignette 
#' of the YAPSA package.
#' 
#' @docType data
#' @name exampleYAPSA
#' @author Daniel Huebschmann \email{huebschmann.daniel@@googlemail.com}
#' @references \url{https://www.ncbi.nlm.nih.gov/pubmed/23945592}
#' 
NULL

#' Data structures used in examples, Indel tests and the Indel signature
#' vignette of the YAPSA package.
#' 
#' @docType data
#' @name exampleINDEL_YAPSA
#' @author Daniel Huebschmann \email{huebschmann.daniel@@googlemail.com}
#' @references \url{https://www.ncbi.nlm.nih.gov/pubmed/23945592}
#' 
NULL




#' Subgroup information for some samples in the vignette
#' 
#' \code{lymphoma_PID_df}: A data frame carrying subgroup information for a 
#' subcohort of samples used in the vignette. Data in the vignette is 
#' downloaded from 
#' \url{ftp://ftp.sanger.ac.uk/pub/cancer/AlexandrovEtAl/somatic_mutation_data/Lymphoma\%20B-cell/Lymphoma\%20B-cell_clean_somatic_mutations_for_signature_analysis.txt}.
#' In the file available under that link somatic point mutation calls from 
#' several samples are listed in a vcf-like format. One column encodes the 
#' sample the variant was found in. In the vignette we want to restrict the 
#' analysis to only a fraction of these involved samples. The data frame 
#' \code{lymphoma_PID_df} carries the sample identifiers (PID) as rownames and 
#' the attributed subgroup in a column called \code{subgroup}.
#' 
#' @name lymphoma_PID_df
#' @usage data(lymphoma_PID)
#' @rdname exampleYAPSA
#' 
NULL

#' Test data for complex functions
#' 
#' \code{lymphoma_test_df}: A data frame carrying point mutation calls. It 
#' represents a subset of the data stored in
#' \url{ftp://ftp.sanger.ac.uk/pub/cancer/AlexandrovEtAl/somatic_mutation_data/Lymphoma\%20B-cell/Lymphoma\%20B-cell_clean_somatic_mutations_for_signature_analysis.txt}.
#' In the file available under that link somatic point mutation calls from 
#' several samples are listed in a vcf-like format. One column encodes the 
#' sample the variant was found in. The data frame \code{lymphoma_test_df} has 
#' only the variants occuring in the sample identifiers (PIDs) 4112512, 4194218
#' and 4121361.
#' 
#' @name lymphoma_test_df
#' @usage data(lymphoma_test)
#' @rdname exampleYAPSA
#' 
#' @examples
#' data(lymphoma_test)
#' head(lymphoma_test_df)
#' dim(lymphoma_test_df)
#' table(lymphoma_test_df$PID)
#' 
NULL


#' Example data for the vignette
#' 
#' \code{lymphoma_Nature2013_raw_df}: A data frame carrying point mutation 
#' calls. It represents a subset of the data stored in
#' \url{ftp://ftp.sanger.ac.uk/pub/cancer/AlexandrovEtAl/somatic_mutation_data/Lymphoma\%20B-cell/Lymphoma\%20B-cell_clean_somatic_mutations_for_signature_analysis.txt}.
#' In the file available under that link somatic point mutation calls from 
#' several samples are listed in a vcf-like format. One column encodes the 
#' sample the variant was found in.
#' 
#' @name lymphoma_Nature2013_raw_df
#' @usage data(lymphoma_Nature2013_raw)
#' @rdname exampleYAPSA
#' 
#' @examples
#' data(lymphoma_Nature2013_raw)
#' head(lymphoma_Nature2013_raw_df)
#' dim(lymphoma_Nature2013_raw_df)
#' 
NULL

#' Example data for the Indel vignette
#' 
#' \code{GenomeOfNl_raw}: A data frame contains the gemiline varinats of 
#' the dutch population.  carrying point mutation 
#' calls. It represents a subset of the data stored in
#' \url{ftp://ftp.sanger.ac.uk/pub/cancer/AlexandrovEtAl/somatic_mutation_data/Lymphoma\%20B-cell/Lymphoma\%20B-cell_clean_somatic_mutations_for_signature_analysis.txt}.
#' In the file available under that link somatic point mutation calls from 
#' several samples are listed in a vcf-like format. One column encodes the 
#' sample the variant was found in.
#' 
#' @name GenomeOfNl_raw
#' @usage data(GenomeOfNl_raw)
#' @references release version 5 \url{https://www.nlgenome.nl/menu/main/app-go-nl/?page_id=9}
#' @return A data frame in a vcf-like format
#' 
#' @examples
#' data(GenomeOfNl_raw)
#' head(GenomeOfNl_raw)
#' dim(GenomeOfNl_raw)
#' 
NULL

#' Example mutational catalog for the SNV vignette
#' 
#' \code{lymphomaNature2013_mutCat_df}: A data frame in the format of a SNV mutation catalog. 
#' The mutational catalog contains SNV variants from the 
#' \code{lymphoma_Nature2013_raw_df} data. Mutational catalog was created with 
#' \code{create_mutation_catalogue_from_df} function.
#' 
#' @name lymphomaNature2013_mutCat_df
#' @usage data(lymphomaNature2013_mutCat_df)
#' @references \url{ftp://ftp.sanger.ac.uk/pub/cancer/AlexandrovEtAl/somatic_mutation_data/Lymphoma\%20B-cell/Lymphoma\%20B-cell_clean_somatic_mutations_for_signature_analysis.txt}
#' @return  A data fame in the layout of a SNV mutational catalog
#' 
#' @examples
#' data(lymphomaNature2013_mutCat_df)
#' head(lymphomaNature2013_mutCat_df)
#' dim(lymphomaNature2013_mutCat_df)
#' 
NULL

#' Example mutational catalog for the exome vignette
#' 
#' \code{exome_mutCatRaw_df}: A data frame in the format of a SNV mutation 
#' catalog. The mutational catalog contains SNV variants from a cohort of 
#' small-cell lung cancer published by Rudin et al. (Nature Genetics 2012) 
#' which was later used in the de novo discovery analysis of mutational 
#' signatures in human cancer by Alexandrov et al. (Nature 2013).
#' 
#' @name exome_mutCatRaw_df
#' @usage data(smallCellLungCancerMutCat_NatureGenetics2012)
#' @references  \url{https://www.nature.com/articles/ng.2405}
#' @return  A data fame in the layout of a SNV mutational catalog
#' 
#' @examples
#' data(smallCellLungCancerMutCat_NatureGenetics2012)
#' head(exome_mutCatRaw_df)
#' dim(exome_mutCatRaw_df)
#' 
NULL

#' Example mutational catalog for the Indel vignette
#' 
#' \code{MutCat_indel_df}: A data frame in the format of a mutation catalog. 
#' The mutational catalog contains Indel variants from the 
#' \code{GenomeOfNl_raw} data. Variants were random sampled for 15 artificial
#' patient for the purpose to have a Indel mutational catalog and have to
#' show the functionality of the package. The results of the mutational 
#' catalog should not be interpreted fot they biological relevance. 
#' Mutational catalog was created with 
#' \code{create_indel_mutation_catalogue_from_df} function.
#' 
#' @name MutCat_indel_df
#' @usage data(GenomeOfNl_MutCat)
#' @references Mutational catalog created form release version 5 of the Genome 
#' of NL 
#' \url{https://www.nlgenome.nl/menu/main/app-go-nl/?page_id=9}
#' @return  A data fame in the layout of a Indel mutational catalog
#' 
#' @examples
#' data(GenomeOfNl_MutCat)
#' head(MutCat_indel_df)
#' dim(MutCat_indel_df)
#' 
NULL


#' Test exposures for plot functions
#' 
#' \code{lymphoma_Nature2013_COSMIC_cutoff_exposures_df}: Data frame with 
#' exposures for testing the plot functions. Data taken from
#' \url{ftp://ftp.sanger.ac.uk/pub/cancer/AlexandrovEtAl/somatic_mutation_data/Lymphoma\%20B-cell/Lymphoma\%20B-cell_clean_somatic_mutations_for_signature_analysis.txt}.
#' 
#' @name lymphoma_Nature2013_COSMIC_cutoff_exposures_df
#' @usage data(lymphoma_cohort_LCD_results)
#' @rdname exampleYAPSA
#' 
NULL


#' Test normalized exposures for plot functions
#' 
#' \code{rel_lymphoma_Nature2013_COSMIC_cutoff_exposures_df}: Data frame with 
#' normalized or relative exposures for testing the plot functions. Data taken 
#' from
#' \url{ftp://ftp.sanger.ac.uk/pub/cancer/AlexandrovEtAl/somatic_mutation_data/Lymphoma\%20B-cell/Lymphoma\%20B-cell_clean_somatic_mutations_for_signature_analysis.txt}.
#' 
#' @name rel_lymphoma_Nature2013_COSMIC_cutoff_exposures_df
#' @usage data(lymphoma_cohort_LCD_results)
#' @rdname exampleYAPSA
#' 
NULL


#' Subgroup information for test data for plot functions
#' 
#' \code{COSMIC_subgroups_df}: Subgroup information for the data stored in
#' \code{\link{lymphoma_Nature2013_COSMIC_cutoff_exposures_df}} and 
#' \code{\link{rel_lymphoma_Nature2013_COSMIC_cutoff_exposures_df}}.
#' 
#' @name COSMIC_subgroups_df
#' @usage data(lymphoma_cohort_LCD_results)
#' @rdname exampleYAPSA
#' 
NULL


#' Sigs info (initial, including artifacts) for test data for plot functions
#' 
#' \code{chosen_AlexInitialArtif_sigInd_df}: Signature information for the
#'  data stored in
#' \code{\link{lymphoma_Nature2013_COSMIC_cutoff_exposures_df}} and 
#' \code{\link{rel_lymphoma_Nature2013_COSMIC_cutoff_exposures_df}}.
#' 
#' @name chosen_AlexInitialArtif_sigInd_df
#' @usage data(lymphoma_cohort_LCD_results)
#' @rdname exampleYAPSA
#' 
NULL


#' Sigs info (Cosmic, only validated) for test data for plot functions
#' 
#' \code{chosen_signatures_indices_df}: Signature information for the data
#' stored in
#' \code{\link{lymphoma_Nature2013_COSMIC_cutoff_exposures_df}} and 
#' \code{\link{rel_lymphoma_Nature2013_COSMIC_cutoff_exposures_df}}.
#' 
#' @name chosen_signatures_indices_df
#' @usage data(lymphoma_cohort_LCD_results)
#' @rdname exampleYAPSA
#' 
NULL


#' Cutoffs for a supervised analysis of mutational signatures.
#' 
#' Series of data frames with signature-specific cutoffs. All values represent
#' optimal cutoffs. The optimal cutoffs were determined for different choices 
#' of parameters in the cost function of the optimization. The row index is 
#' equivalent to the ratio between costs for false negative attribution and 
#' false positive attribution. The columns correspond to the different 
#' signatures. To be used with \code{\link{LCD_complex_cutoff}}. 
#' There are two different sets of cutoffs one for the signatures described by
#' Alexandrov et al.(Natue 2013) and one for the signatures dokumented in 
#' Alexandriv et al. (biorxiv 2018). The calculation of the PCAWG signature 
#' specific cutoffs was perfomed in a single-sample resolution which are both 
#' valid for whole genome and whole exome sequencing data analysis.   
#' 
#' @docType data
#' @name cutoffs
#' @usage data(cutoffs)
#' @author Daniel Huebschmann \email{huebschmann.daniel@@googlemail.com}
#' 
NULL

#' @docType data
#' @name cutoffs_pcawg
#' @usage data(cutoffs_pcawg)
#' @author Lea Jopp-Saile \email{huebschmann.daniel@@googlemail.com}
#' 
NULL


#' Opt. cutoffs, rel exposures for the COSMIC sigs, only validated
#' 
#' \code{cutoffCosmicValid_rel_df}: Optimal cutoffs for 
#' \code{\link{AlexCosmicValid_sig_df}}, i.e. COSMIC signatures, only 
#' validated, trained on relative exposures.
#' 
#' @name cutoffCosmicValid_rel_df
#' @rdname cutoffs
#' 
NULL


#' Opt. cutoffs, rel exposures for the COSMIC sigs, including artifacts
#' 
#' \code{cutoffCosmicArtif_rel_df}: Optimal cutoffs for 
#' \code{\link{AlexCosmicArtif_sig_df}}, i.e. COSMIC signatures, including 
#' artifact signatures, trained on relative exposures.
#' 
#' @name cutoffCosmicArtif_rel_df
#' @rdname cutoffs
#' 
NULL


#' Opt. cutoffs, abs exposures for the COSMIC sigs, only validated
#' 
#' \code{cutoffCosmicValid_abs_df}: Optimal cutoffs for 
#' \code{\link{AlexCosmicValid_sig_df}}, i.e. COSMIC signatures, only 
#' validated, trained on absolute exposures.
#' 
#' @name cutoffCosmicValid_abs_df
#' @rdname cutoffs
#' 
NULL


#' Opt. cutoffs, abs exposures for the COSMIC sigs, including artifacts
#' 
#' \code{cutoffCosmicArtif_abs_df}: Optimal cutoffs for 
#' \code{\link{AlexCosmicArtif_sig_df}}, i.e. COSMIC signatures, including 
#' artifact signatures, trained on absolute exposures.
#' 
#' @name cutoffCosmicArtif_abs_df
#' @rdname cutoffs
#' 
NULL


#' Opt. cutoffs, rel exposures for the initial sigs, only validated
#' 
#' \code{cutoffInitialValid_rel_df}: Optimal cutoffs for 
#' \code{\link{AlexInitialValid_sig_df}}, i.e. initially published signatures, 
#' only validated signatures, trained on relative exposures.
#' 
#' @name cutoffInitialValid_rel_df
#' @rdname cutoffs
#' 
NULL


#' Opt. cutoffs, rel exposures for the initial sigs, including artifacts
#' 
#' \code{cutoffInitialArtif_rel_df}: Optimal cutoffs for 
#' \code{\link{AlexInitialArtif_sig_df}}, i.e. initially published signatures, 
#' including artifact signatures, trained on relative exposures.
#' 
#' @name cutoffInitialArtif_rel_df
#' @rdname cutoffs
#' 
NULL


#' Opt. cutoffs, abs exposures for the initial sigs, only validated
#' 
#' \code{cutoffInitialValid_abs_df}: Optimal cutoffs for 
#' \code{\link{AlexInitialValid_sig_df}}, i.e. initially published signatures, 
#' only validated signatures, trained on absolute exposures.
#' 
#' @name cutoffInitialValid_abs_df
#' @rdname cutoffs
#' 
NULL


#' Opt. cutoffs, abs exposures for the initial sigs, including artifacts
#' 
#' \code{cutoffInitialArtif_abs_df}: Optimal cutoffs for 
#' \code{\link{AlexInitialArtif_sig_df}}, i.e. initially published signatures, 
#' including artifact signatures, trained on absolute exposures.
#' 
#' @name cutoffInitialArtif_abs_df
#' @rdname cutoffs
#' 
NULL


#' Opt. cutoffs, PCAWG SNV signatures, including artifacts
#' 
#' \code{cutoffPCAWG_SBS_WGSWES_artifPid_df}: Optimal cutoffs for 
#' \code{\link{PCAWG_SP_SBS_sigs_Artif_df}}, i.e. initially published 
#' signatures,including artifact signatures, trained in a single-sample 
#' resolution.
#' 
#' @name cutoffPCAWG_SBS_WGSWES_artifPid_df
#' @rdname cutoffs_pcawg
#' 
NULL

#' Opt. cutoffs, PCAWG SNV signatures, only validated signatures
#' 
#' \code{cutoffPCAWG_SBS_WGSWES_realPid_df}: Optimal cutoffs for 
#' \code{\link{PCAWG_SP_SBS_sigs_Real_df}}, i.e. initially published 
#' signatures, only validated signatures, trained in a single-sample 
#' resolution.
#' 
#' @name cutoffPCAWG_SBS_WGSWES_realPid_df
#' @rdname cutoffs_pcawg
#' 
NULL

#' Opt. cutoffs, PCAWG Indel signatures, only validated signatures
#' 
#' \code{cutoffPCAWG_ID_WGS_Pid_df}: Optimal cutoffs for 
#' \code{\link{PCAWG_SP_ID_sigs_df}}, i.e. initially published signatures, 
#' signatures, trained in a single-sample resolution.
#' 
#' @name cutoffPCAWG_ID_WGS_Pid_df
#' @rdname cutoffs_pcawg
#' 
NULL


#' Correction factors for different target capture kits
#' 
#' List of lists with correction factors for different target capture kits.
#' The elements of the overall list are lists, every one carrying information
#' for one target capture kit (and namend after it). The elements of these
#' sublists are 64 dimensional vectors with correction factors for all
#' triplets. They were computed using counts of occurence of the respective
#' triplets in the target capture and in the reference genome and making
#' ratios (either for the counts themselves as in \code{abs_cor} or for the
#' relative occurences in \code{rel_cor}). The information in this data
#' structure may be used as input to
#' \code{\link{normalizeMotifs_otherRownames}}.
#' 
#' @docType data
#' @name targetCapture_cor_factors
#' @usage data(targetCapture_cor_factors)
#' @author Daniel Huebschmann \email{huebschmann.daniel@@googlemail.com}
#' @return A list of lists of data frames
#' 
NULL


#' Colours codes for displaying SNVs
#' 
#' Vector attributing colours to nucleotide exchanges used when displaying 
#' SNV information, e.g. in a rainfall plot.
#' 
#' @docType data
#' @name exchange_colour_vector
#' @usage data(exchange_colour_vector)
#' @author Daniel Huebschmann \email{huebschmann.daniel@@googlemail.com}
#' @return A named character vector
#' 
NULL

#' Generate R documentation from inline comments.
#'
#' Yet Another Package for mutational Signature analysis
#'
#' This package provides functions and routines useful in 
#' the analysis of mutational signatures (cf. L. Alexandrov et al., Nature 
#' 2013). In particular, functions to perform a signature analysis with 
#' known signatures (\code{\link{LCD}} = linear combination decomposition) and 
#' a signature analysis on stratified mutational catalogue 
#' (\code{\link{run_SMC}} = stratify mutational catalogue) are provided.
#'
#' @docType package
#' @name YAPSA
NULL

## ----loadStyle, warning=FALSE, echo=FALSE, message=FALSE, results="hide"------
library(BiocStyle)

## ----packages, include=FALSE--------------------------------------------------
library(YAPSA)
library(Biostrings)
library(BSgenome.Hsapiens.UCSC.hg19)
library(knitr)
opts_chunk$set(echo=TRUE)
opts_chunk$set(fig.show='asis')

## ----loadPCAWGsigs------------------------------------------------------------
data(sigs_pcawg)

## ----captionSpectra, echo=FALSE-----------------------------------------------
cap <-": Nucleotide exchange spectra of the Indel signatures ID3, associated 
        with tobacco smoking, and ID6, related to deficiencies in homologous 
        recombination repair."

## ----INDELsigExample, include=TRUE, fig.width=15, fig.height=6, fig.cap= cap----
plotExchangeSpectra_indel(PCAWG_SP_ID_sigs_df[,c(3,6)])

## ----INDELsigInfo-------------------------------------------------------------
current_caption <- paste0("Information on Indel mutational signatures.")
if(!exists("repress_tables"))
  kable(PCAWG_SP_ID_sigInd_df, row.names=FALSE, caption=current_caption)

## ----loadGoNL-----------------------------------------------------------------
data(GenomeOfNl_raw)
GenomeOfNl_raw <- GenomeOfNl_raw[, c(1,2,4,5)]

## ----loadGoNLraw--------------------------------------------------------------
load_data_new <- FALSE
if(load_data_new){
  data <- data.frame(matrix(ncol = 8, nrow = 0))
  for(index in seq_along(1:22)){
              print(index)
              temp <- tempfile()
              file_path <- paste0("https://molgenis26.gcc.rug.nl/
                                  downloads/gonl_public/variants/release5/
                                  gonl.chr",
                                  index, ".snps_indels.r5.vcf.gz")
              download.file(file_path, temp)
       
              data <- rbind(data, read.table(gzfile(temp, paste0("gonl.chr",
                                                    index,
                                                    ".snps_indels.r5.vcf")),
                                             header=FALSE, sep="\t", 
                                             stringsAsFactors = FALSE))
              data <- data[grep("INDEL", data$V8),]
              unlink(temp)
            
  }
  colnames(data) <- c("CHROM", "POS", "ID", "REF", "ALT", "QUAL", 
                      "FILTER","INFO")

  GenomeOfNl_raw <- data[, c(1,2,4,5)]
}

## ----showsTopOfDf, echo=FALSE-------------------------------------------------
kable(head(GenomeOfNl_raw), caption="Head of VCF file 
      containing the GoNL INDEL data")

## ----randomizeDataSet, warning= FALSE-----------------------------------------
seed = 2
set.seed(seed)
number_of_indels <- sample(c(30:70), 15,  replace = TRUE)

index=0
seed=3
set.seed(seed)
vcf_like_indel_lists <- lapply(number_of_indels, function(size){
  df_per_PID <- GenomeOfNl_raw[sample(nrow(GenomeOfNl_raw), size, 
                                      replace = FALSE), ]
  index <<- index+1
  df_per_PID$PID <- rep(paste0("PID_", index), length(size))
  df_PIDs <- df_per_PID[order(df_per_PID$CHROM),]
  return(df_PIDs)
  })

vcf_like_indel_df <- do.call(rbind.data.frame, vcf_like_indel_lists)
kable(head(vcf_like_indel_df), caption="Head of the vcf_like_df
      containing the subsampled GoNL Indel data")

## ----createMutationalCatalog, warning=FALSE-----------------------------------
vcf_like_indel_trans_df <- translate_to_hg19(vcf_like_indel_df,"CHROM")
mutational_cataloge_indel_df <- create_indel_mutation_catalogue_from_df(
  in_dat = vcf_like_indel_trans_df,
  in_signature_df = PCAWG_SP_ID_sigs_df)

kable(head(mutational_cataloge_indel_df[,1:5]))

## ----loadCutoffs, warning=FALSE-----------------------------------------------
data(cutoffs_pcawg)

## ----LCDdecompostion, warning=FALSE-------------------------------------------
current_catalogue_df <- mutational_cataloge_indel_df 
current_sig_df <- PCAWG_SP_ID_sigs_df
current_cutoff_pid_vector <- cutoffPCAWG_ID_WGS_Pid_df[3,]
current_sigInd_df <- PCAWG_SP_ID_sigInd_df

current_LCDlistsList <- LCD_complex_cutoff_combined(
  current_catalogue_df,
  current_sig_df,
  in_cutoff_vector = current_cutoff_pid_vector,
  in_filename = NULL,
  in_method = "abs",
  in_sig_ind_df = current_sigInd_df)

current_consensus_LCDlist <- current_LCDlistsList$consensus
if(!exists("repress_tables")) 
  as.character(current_consensus_LCDlist$out_sig_ind_df$sig)

## ----captionExposure, echo=FALSE----------------------------------------------
cap <- ":Exposures to Indel mutational signatures in the artificial data created 
        by sampling GoNL variants. Exposures were obtained from
        a decomposition with PCAWG Indel signatures as well as their signature
        specific-cutoffs (cutoffPCAWG_ID_WGS_Pid_df)."

## ----plotExposure, echo=TRUE, warning=FALSE, fig.width=15, fig.height=6, fig.cap= cap----
exposures_barplot(current_LCDlistsList$perPID$exposures,
                  current_LCDlistsList$perPID$out_sig_ind_df)

## ----captionCI, echo=FALSE----------------------------------------------------
cap <- "Confidence interval calculation for exposures to Indel mutational 
        signatures"

## ----CI, echo=TRUE, warning=FALSE, fig.width=17, fig.height=15, fig.cap=cap----
confidence_intervals_ID <- confidence_indel_only_calulation(
  in_current_indel_df = current_catalogue_df)
plot(confidence_intervals_ID$p_complete_PCAWG_ID)

#' @import utils
if(getRversion() >= "3.6.0") 
  utils::globalVariables(c("cutoffCosmicValid_abs_df",
                           "cutoffCosmicValid_rel_df",
                           "cutoffCosmicArtif_abs_df",
                           "cutoffCosmicArtif_rel_df",
                           "cutoffPCAWG_SBS_WGSWES_realPid_df",
                           "cutoffPCAWG_ID_WGS_Pid_df", 
                           "PCAWG_SP_SBS_sigs_Real_df", 
                           "PCAWG_SP_SBS_sigInd_Real_df", 
                           "PCAWG_SP_ID_sigs_df", 
                           "PCAWG_SP_ID_sigInd_df", 
                           "AlexCosmicValid_sig_df",
                           "AlexCosmicValid_sigInd_df",
                           "AlexCosmicArtif_sig_df",
                           "AlexCosmicArtif_sigInd_df",
                           "AlexCosmicArtif_sig_df",
                           "exposure",
                           "sig", 
                           "lower",
                           "relLower", 
                           "upper", 
                           "relUpper"))

# Copyright © 2014-2019  The YAPSA package contributors
# This file is part of the YAPSA package. The YAPSA package is licenced under
# GPL-3

#' @importFrom GetoptLong qq
#' @importFrom GetoptLong qq.options
#' 
check_perl = function(module = NULL, inc = NULL, perl_bin = "perl") {
  
  op = qq.options("code.pattern")
  qq.options("code.pattern" = "@\\{CODE\\}")
  on.exit(qq.options("code.pattern" = op))
  
  if(is.null(module)) {
    cmd = qq("\"@{perl_bin}\" -v")
  } else if(!is.null(module) && is.null(inc)) {
    cmd = qq("\"@{perl_bin}\" -M@{module} -e \"use @{module}\"")
  } else if(!is.null(module) && !is.null(inc)) {
    cmd = qq("\"@{perl_bin}\" \"-I@{inc}\" -M@{module} -e \"use @{module}\"")
  }
  
  OS = Sys.info()["sysname"]
  if(OS == "Windows") {
    res = system(cmd, ignore.stdout = TRUE, ignore.stderr = TRUE, 
                 show.output.on.console = FALSE)
  } else {
    res = system(cmd, ignore.stdout = TRUE, ignore.stderr = TRUE)
  }
  
  return(ifelse(res, FALSE, TRUE))
}

#' @importFrom GetoptLong qq
#' @importFrom GetoptLong qq.options
#' 
check_bedtools = function(module = NULL, 
                          inc = NULL, 
                          bedtools_bin = "bedtools") {
  
  op = qq.options("code.pattern")
  qq.options("code.pattern" = "@\\{CODE\\}")
  on.exit(qq.options("code.pattern" = op))
  
  if(is.null(module)) {
    cmd = qq("\"@{bedtools_bin}\" --version")
  }
  
  OS = Sys.info()["sysname"]
  if(OS == "Windows") {
    res = system(cmd, ignore.stdout = TRUE, ignore.stderr = TRUE, 
                 show.output.on.console = FALSE)
  } else {
    res = system(cmd, ignore.stdout = TRUE, ignore.stderr = TRUE)
  }
  
  return(ifelse(res, FALSE, TRUE))
}


## example:
## in_fasta <- "/ibios/co02/reference/Reference_1KG/hs37d5.fa"
## in_word_length <- 3
## project_folder <- file.path("/icgc/dkfzlsdf/analysis/hipo/hipo_028",
##                             "somaticSignatures/nucleotide_distrib")
## out_csv <- "kmer_frequencies_in_ref.csv"
## 
run_kmer_frequency_pl <- function(in_fasta,
                                  in_word_length,
                                  project_folder,
                                  out_csv) {
  if(!check_perl()) {
    cat("YAPSA:::run_kmer_frequency_pl::Error:unable to find path to perl")
    return(1)
  }
  package_path <- system.file(package='YAPSA')
  perl_command <- paste0("perl")
  script_command <- file.path(package_path,"foreign","kmer_frequencies.pl")
  script_options_command <- paste0("-r ",in_fasta, " -w ",in_word_length)
  output_command <- paste0("> ",file.path(project_folder,out_csv))
  this_command <- paste(perl_command,script_command,script_options_command,
                        output_command,collapse=" ")
  system(this_command,intern=TRUE)
  return(0)
}

## example:
## in_ref_genome <- "/ibios/co02/reference/Reference_1KG/hs37d5.fa"
## in_target_capture_bed <- file.path("/icgc/ngs_share/assemblies",
##                                    "hg19_GRCh37_1000genomes/targetRegions",
##                                    "Agilent5withUTRs_chr.bed.gz")
## project_folder <- file.path("/icgc/dkfzlsdf/analysis/hipo/hipo_028",
##                             "somaticSignatures/nucleotide_distrib")
## out_target_capture_fasta <- "hs37d5_Agilent5withUTR_targetCapture.fa"
## 
run_bedtools_getfasta <- function(in_ref_genome,in_target_capture_bed,
                                  project_folder,out_target_capture_fasta) {
  if(!check_bedtools()) {
    cat("YAPSA:::run_bedtools_getfasta::Error:unable to find path to bedtools")
    return(1)
  }
  bedtools_command <- "bedtools getfasta"
  bedtools_options_command <- 
    paste0("-fi ",in_ref_genome, " -bed ",in_target_capture_bed,
           " -fo ",file.path(project_folder,out_target_capture_fasta))
  this_command <- paste(bedtools_command,bedtools_options_command,collapse=" ")
  system(this_command)
  return(0)
}


#' Provide normalized correction factors for kmer content
#'
#' This function is analogous to
#' \code{\link[SomaticSignatures]{normalizeMotifs}}. If an analysis of
#' mutational signatures is performed on e.g. Whole Exome Sequencing (WES) data,
#' the signatures and exposures have to be adapted to the potentially different
#' kmer (trinucleotide) content of the target capture. The present function
#' takes as arguments paths to the used reference genome and target capture
#' file. It the extracts the sequence of the target capture by calling
#' \code{bedtools getfasta} on the system command prompt.
#' \code{run_kmer_frequency_normalization} then calls a custom made perl script
#' \code{kmer_frequencies.pl} also included in this package to count the
#' occurences of the tripletts in both the whole reference genome and the
#' created target capture sequence. These counts are used for normalization as
#' in \code{\link[SomaticSignatures]{normalizeMotifs}}. Note that
#' \code{\link[SomaticSignatures]{kmerFrequency}} provides a solution to
#' approximate kmer frequencies by random sampling. As opposed to that approach,
#' the function described here deterministically counts all occurences of the
#' kmers in the respective genome.
#'
#' @param in_ref_genome_fasta Path to the reference genome fasta file used.
#' @param in_target_capture_bed Path to a bed file containing the information on
#'   the used target capture. May also be a compressed bed.
#' @param in_word_length Integer number defining the length of the features or
#'   motifs, e.g. 3 for tripletts or 5 for pentamers
#' @param project_folder Path where the created files, especially the fasta file
#'   with the sequence of the target capture and the count matrices, can be
#'   stored.
#' @param in_verbose Verbose if \code{in_verbose=1}
#'
#' @return A numeric vector with correction factors
#'
#' @examples
#'  NULL
#'
#' @seealso \code{\link[SomaticSignatures]{normalizeMotifs}}
#'
#' @export
#' 
run_kmer_frequency_normalization <- function(in_ref_genome_fasta,
                                             in_target_capture_bed,
                                             in_word_length,
                                             project_folder,
                                             in_verbose=1) {
  target_capture_fasta <- "hs37d5_Agilent5withUTR_targetCapture.fa"
  target_capture_kmer_counts_file <- "kmer_frequencies_in_targetCapture.csv"
  reference_genome_kmer_counts_file <- "kmer_frequencies_in_ref.csv"
  if(!file.exists(file.path(project_folder,
                            reference_genome_kmer_counts_file))){
    if(in_verbose==1) {
      cat("\nYAPS:::run_kmer_frequency_normalization::",
          "reference_genome_kmer_counts_file doesn't exist yet. ",
          "Create first.\n")
    }
    run_kmer_frequency_pl(in_ref_genome_fasta,in_word_length,project_folder,
                          reference_genome_kmer_counts_file)
  } else {
    if(in_verbose==1) {
      cat("\nYAPS:::run_kmer_frequency_normalization::",
          "reference_genome_kmer_counts_file already exists.\n");}
  }
  if(!file.exists(file.path(project_folder,target_capture_kmer_counts_file))){
    if(in_verbose==1) {
      cat("\nYAPS:::run_kmer_frequency_normalization::",
          "target_capture_kmer_counts_file doesn't exist yet. ",
          "Create first.\n")
    }
    if(!file.exists(file.path(project_folder,target_capture_fasta))) {
      if(in_verbose==1) {
        cat("\nYAPS:::run_kmer_frequency_normalization::",
            "target_capture_fasta doesn't exist yet. Create first.\n")
      }
      run_bedtools_getfasta(in_ref_genome_fasta,in_target_capture_bed,
                            project_folder,target_capture_fasta)
    } else {
      if(in_verbose==1) {
        cat("\nYAPS:::run_kmer_frequency_normalization::target_capture_fasta",
            " already exists.\n")
      }    
    }
    run_kmer_frequency_pl(file.path(project_folder,target_capture_fasta),
                          in_word_length,project_folder,
                          target_capture_kmer_counts_file)
  } else {
    if(in_verbose==1) {
      cat("\nYAPS:::run_kmer_frequency_normalization::",
          "target_capture_kmer_counts_file already exists.\n")
    }    
  }
  if(in_verbose==1) {
    cat("\nYAPS:::run_kmer_frequency_normalization::Now read counts into data",
        " frames...\n");}
  reference_genome_kmer_frequency_df <- 
    read.csv(file.path(project_folder,reference_genome_kmer_counts_file),
             header=FALSE,sep="\t")
  names(reference_genome_kmer_frequency_df) <- c("triplet","count")
  reference_genome_total_count <- 
    sum(as.numeric(reference_genome_kmer_frequency_df$count))
  reference_genome_kmer_frequency_df$rel_counts <-
    as.numeric(reference_genome_kmer_frequency_df$count) / 
    reference_genome_total_count
  target_capture_kmer_frequency_df <- 
    read.csv(file.path(project_folder, target_capture_kmer_counts_file),
             header=FALSE, sep="\t")
  names(target_capture_kmer_frequency_df) <- c("triplet","count")
  target_capture_total_count <- 
    sum(as.numeric(target_capture_kmer_frequency_df$count))
  target_capture_kmer_frequency_df$rel_counts <- 
    as.numeric(target_capture_kmer_frequency_df$count) / 
    target_capture_total_count
  norms <- reference_genome_kmer_frequency_df$rel_counts / 
    target_capture_kmer_frequency_df$rel_counts
  names(norms) <- reference_genome_kmer_frequency_df$triplet
  return(norms)
}


#' Provide comprehensive correction factors for kmer content
#'
#' This function is analogous to
#' \code{\link[SomaticSignatures]{normalizeMotifs}}. If an analysis of
#' mutational signatures is performed on e.g. Whole Exome Sequencing (WES) data,
#' the signatures and exposures have to be adapted to the potentially different
#' kmer (trinucleotide) content of the target capture. The present function
#' takes as arguments paths to the used reference genome and target capture
#' file. It the extracts the sequence of the target capture by calling
#' \code{bedtools getfasta} on the system command prompt.
#' \code{run_kmer_frequency_normalization} then calls a custom made perl script
#' \code{kmer_frequencies.pl} also included in this package to count the
#' occurences of the tripletts in both the whole reference genome and the
#' created target capture sequence. These counts are used for normalization as
#' in \code{\link[SomaticSignatures]{normalizeMotifs}}. Note that
#' \code{\link[SomaticSignatures]{kmerFrequency}} provides a solution to
#' approximate kmer frequencies by random sampling. As opposed to that approach,
#' the function described here deterministically counts all occurences of the
#' kmers in the respective genome.
#'
#' @param in_ref_genome_fasta Path to the reference genome fasta file used.
#' @param in_target_capture_bed Path to a bed file containing the information on
#'   the used target capture. May also be a compressed bed.
#' @param in_word_length Integer number defining the length of the features or
#'   motifs, e.g. 3 for tripletts or 5 for pentamers
#' @param project_folder Path where the created files, especially the fasta file
#'   with the sequence of the target capture and the count matrices, can be
#'   stored.
#' @param target_capture_fasta Name of the fasta file of the target capture to
#'   be created if not yet existent.
#' @param in_verbose Verbose if \code{in_verbose=1}
#'
#' @return A list with 2 entries: \itemize{ \item \code{rel_cor}: The correction
#' factors after normalization as in
#' \code{\link{run_kmer_frequency_normalization}} \item \code{abs_cor}: The
#' correction factors without normalization. }
#'
#' @examples
#'  NULL
#'
#' @seealso \code{\link[SomaticSignatures]{normalizeMotifs}}
#'
#' @export
#' 
run_kmer_frequency_correction <- 
  function(in_ref_genome_fasta, in_target_capture_bed, in_word_length,
           project_folder, target_capture_fasta="targetCapture.fa",
           in_verbose=1) {
  target_capture_kmer_counts_file <- "kmer_frequencies_in_targetCapture.csv"
  reference_genome_kmer_counts_file <- "kmer_frequencies_in_ref.csv"
  dir.create(project_folder,recursive=TRUE)
  if(!file.exists(file.path(project_folder,
                            reference_genome_kmer_counts_file))){
    if(in_verbose==1) {
      cat("\nYAPS:::run_kmer_frequency_normalization::",
          "reference_genome_kmer_counts_file doesn't exist yet. ",
          "Create first.\n")
    }
    run_kmer_frequency_pl(in_ref_genome_fasta,in_word_length,project_folder,
                          reference_genome_kmer_counts_file)
  } else {
    if(in_verbose==1) {
      cat("\nYAPS:::run_kmer_frequency_normalization::",
          "reference_genome_kmer_counts_file already exists.\n")
    }
  }
  if(!file.exists(file.path(project_folder,target_capture_kmer_counts_file))){
    if(in_verbose==1) {
      cat("\nYAPS:::run_kmer_frequency_normalization::",
          "target_capture_kmer_counts_file doesn't exist yet. ",
          "Create first.\n")
    }
    if(!file.exists(file.path(project_folder,target_capture_fasta))) {
      if(in_verbose==1) {
        cat("\nYAPS:::run_kmer_frequency_normalization::",
            "target_capture_fasta doesn't exist yet. Create first.\n")
      }
      run_bedtools_getfasta(in_ref_genome_fasta,in_target_capture_bed,
                            project_folder,target_capture_fasta)
    } else {
      if(in_verbose==1) {
        cat("\nYAPS:::run_kmer_frequency_normalization::",
            "target_capture_fasta already exists.\n")
      }    
    }
    run_kmer_frequency_pl(file.path(project_folder,target_capture_fasta),
                          in_word_length,project_folder,
                          target_capture_kmer_counts_file)
  } else {
    if(in_verbose==1) {
      cat("\nYAPS:::run_kmer_frequency_normalization::",
          "target_capture_kmer_counts_file already exists.\n")
    }    
  }
  if(in_verbose==1) {
    cat("\nYAPS:::run_kmer_frequency_normalization::Now read counts into ",
        "data frames...\n")
  }
  reference_genome_kmer_frequency_df <- 
    read.csv(file.path(project_folder,reference_genome_kmer_counts_file),
             header=FALSE,sep="\t")
  names(reference_genome_kmer_frequency_df) <- c("triplet","count")
  reference_genome_total_count <- 
    sum(as.numeric(reference_genome_kmer_frequency_df$count))
  reference_genome_kmer_frequency_df$rel_counts <- 
    as.numeric(reference_genome_kmer_frequency_df$count) / 
    reference_genome_total_count
  target_capture_kmer_frequency_df <- 
    read.csv(file.path(project_folder,target_capture_kmer_counts_file),
             header=FALSE,sep="\t")
  names(target_capture_kmer_frequency_df) <- c("triplet","count")
  target_capture_total_count <- 
    sum(as.numeric(target_capture_kmer_frequency_df$count))
  target_capture_kmer_frequency_df$rel_counts <- 
    as.numeric(target_capture_kmer_frequency_df$count) / 
    target_capture_total_count
  rel_norms <- 
    reference_genome_kmer_frequency_df$rel_counts / 
    target_capture_kmer_frequency_df$rel_counts
  names(rel_norms) <- reference_genome_kmer_frequency_df$triplet
  abs_norms <- reference_genome_kmer_frequency_df$count / 
    target_capture_kmer_frequency_df$count
  names(abs_norms) <- reference_genome_kmer_frequency_df$triplet
  #out_df <- data.frame(rel_cor=rel_norms,abs_cor=abs_norms)
  #rownames(out_df) <- reference_genome_kmer_frequency_df$triplet
  #return(out_df)
  out_list <- list(rel_cor=rel_norms,abs_cor=abs_norms)
  return(out_list)
}


#' Wrapper function to annotate addition information
#'
#' Wrapper function to the perl script annotate_vcf.pl which annotates data of a
#' track stored in file_B (may be different formats) to called variants stored
#' in a vcf-like file_A.
#'
#' @param in_data_file Path to the input vcf-like file to be annotated
#' @param in_anno_track_file Path to the input file containing the annotation
#'   track
#' @param in_new_column_name String indicating the name of the column to be
#'   created for annotation.
#' @param out_file Path where the created files can be stored.
#' @param in_data_file_type \code{custom} for vcf-like
#' @param in_anno_track_file_type Type of the file \code{in_anno_track_file}
#'   containing the annotation track.
#' @param in_data_CHROM.field String indicating which column of
#'   \code{in_data_file} contains the chromosome information.
#' @param in_data_POS.field String indicating which column of
#'   \code{in_data_file} contains the position information.
#' @param in_data_END.field String indicating which column of
#'   \code{in_data_file} contains the end information if regions are considered.
#'
#' @return Return zero if no problems occur.
#'
#' @examples
#'  NULL
#'
#' @export
#' 
run_annotate_vcf_pl <- function(in_data_file,
                                in_anno_track_file,
                                in_new_column_name,
                                out_file,
                                in_data_file_type="custom",
                                in_anno_track_file_type="bed",
                                in_data_CHROM.field="CHROM",
                                in_data_POS.field="POS",
                                in_data_END.field="POS") {
  if(!check_perl()) {
    cat("YAPSA:::run_annotate_vcf_pl::Error:unable to find path to perl")
    return(1)
  }
  package_path <- system.file(package='YAPSA')
  perl_command <- paste0("perl")
  script_command <- file.path(package_path,"foreign","annotate_vcf.pl")
  script_options_command <- paste0("-a ",in_data_file,
                                   " --aFileType=",in_data_file_type,
                                   " --aChromColumn ",in_data_CHROM.field,
                                   " --aPosColumn ",in_data_POS.field,
                                   " --aEndColumn ",in_data_END.field,
                                   " -b ",in_anno_track_file,
                                   " --bFileType=",in_anno_track_file_type,
                                   " --columnName ",in_new_column_name)
  output_command <- paste0("> ",file.path(out_file))
  this_command <- paste(perl_command,script_command,script_options_command,
                        output_command,collapse=" ")
  system(this_command,intern=TRUE)
  return(0)
}


#' Build a gene list for a given pathway name
#' 
#' @param in_string
#'  Name or description of the pathway
#' @param in_organism
#'  Name of the taxon to be searched in
#' 
#' @return A character vector of gene names
#' 
#' @examples
#'    species <- "hsa"
#'    gene_lists_meta_df <- data.frame(
#'      name=c("BER","NHEJ","MMR"),
#'      explanation=c("base excision repair",
#'                    "non homologous end joining",
#'                    "mismatch repair"))
#'    number_of_pathways <- dim(gene_lists_meta_df)[1]
#'    gene_lists_list <- list()
#'    for (i in seq_len(number_of_pathways)) {
#'      temp_list <- 
#'        build_gene_list_for_pathway(gene_lists_meta_df$explanation[i],
#'                                    species)
#'      gene_lists_list <- c(gene_lists_list,list(temp_list))
#'    }
#'    gene_lists_list
#'    
#' @seealso \code{\link[KEGGREST]{keggLink}}
#' @seealso \code{\link[KEGGREST]{keggFind}}
#' @seealso \code{\link{extract_names_from_gene_list}}
#' 
#' @importFrom KEGGREST keggFind
#' @importFrom KEGGREST keggLink
#' @export
#' 
build_gene_list_for_pathway <- function(in_string,in_organism) {
  my_pathway <- keggFind("pathway",in_string)
  my_name <- gsub("map",in_organism,names(my_pathway))
  KEGG_gene_list <- keggLink(in_organism,my_name)
  out_gene_list <- c()
  for (i in seq_len(length(KEGG_gene_list))) {
    out_gene_list[i] <- extract_names_from_gene_list(KEGG_gene_list,i)
  }  
  return(out_gene_list)
}


#' Return gene names from gene lists
#'
#' @param in_KEGG_gene_list Gene list to extract names from
#' @param l Index of the gene to be extracted
#'
#' @return The gene name.
#'
#' @examples
#'  NULL
#'
#' @seealso \code{\link[KEGGREST]{keggGet}}
#' @seealso \code{\link{build_gene_list_for_pathway}}
#'
#' @importFrom KEGGREST keggGet
#' @export
#' 
extract_names_from_gene_list <- function(in_KEGG_gene_list,l) {
  temp_gene <- keggGet(in_KEGG_gene_list[l])[[1]]
  temp_gene_name <- strsplit(temp_gene$NAME,", ")[[1]][1]  
  return(temp_gene_name)
}

# Copyright © 2014-2019  The YAPSA package contributors
# This file is part of the YAPSA package. The YAPSA package is licenced under
# GPL-3

#' Plot the exposures of a cohort
#'
#' \code{plot_exposures}: The exposures \code{H}, determined by NMF or by
#' \code{\link{LCD}}, are displayed as a stacked barplot by calling \itemize{
#' \item \code{\link[ggplot2]{geom_bar}} and optionally \item
#' \code{\link[ggplot2]{geom_text}}. } The x-axis displays the PIDs (patient
#' identifier or sample), the y-axis the counts attributed to the different
#' signatures with their respective colours per PID. Is called by
#' \code{\link{plot_relative_exposures}}.
#'
#' @param in_exposures_df Numerical data frame encoding the exposures \code{H},
#'   i.e. which signature contributes how much to which PID (patient identifier
#'   or sample).
#' @param in_signatures_ind_df A data frame containing meta information about
#'   the signatures
#' @param in_subgroups_df A data frame indicating which PID (patient or sample
#'   identifyier) belongs to which subgroup
#' @param in_sum_ind Index vector influencing the order in which the PIDs are
#'   going to be displayed
#' @param in_subgroups.field String indicating the column name in
#'   \code{in_subgroups_df} to take the subgroup information from.
#' @param in_title Title for the plot to be created.
#' @param in_labels Flag, if \code{TRUE} the PIDs are displayed on the x-axis
#' @param in_show_subgroups Flag, if \code{TRUE} then PIDs are grouped by
#'   subgroups
#' @param legend_height How many signatures should be displayed in one column
#'   together at most.
#'
#' @return The generated barplot - a ggplot2 plot
#'
#' @examples
#'  data(lymphoma_cohort_LCD_results)
#'  plot_exposures(lymphoma_Nature2013_COSMIC_cutoff_exposures_df,
#'                 chosen_signatures_indices_df,
#'                 COSMIC_subgroups_df)
#'
#' @seealso \code{\link{LCD}}
#' @seealso \code{\link[ggplot2]{geom_bar}}
#' @seealso \code{\link[ggplot2]{geom_text}}
#'
#' @import ggplot2
#' @import reshape2
#' @export
#' 
plot_exposures <- function(in_exposures_df,
                           in_signatures_ind_df,
                           in_subgroups_df=NULL,
                           in_sum_ind=NULL,
                           in_subgroups.field="subgroup",
                           in_title="",
                           in_labels=TRUE,
                           in_show_subgroups=TRUE,
                           legend_height=10) {
  .e <- environment()
  temp_exposures_df <- in_exposures_df
  number_of_sigs <- dim(in_exposures_df)[1]
  number_of_PIDs <- dim(in_exposures_df)[2]
  ## prepare for output
  temp_exposures_df$sig_index <- 
    in_signatures_ind_df$index[match(rownames(temp_exposures_df),
                                     in_signatures_ind_df$sig)]
  if(!is.null(in_subgroups_df)){
    subgroups_ind <- which(names(in_subgroups_df)==in_subgroups.field)
    my_sum_ind <- order(in_subgroups_df[,subgroups_ind],
                        in_subgroups_df$compl_sum) 
    my_PIDs_vector <- in_subgroups_df$PID
  } else {
    total_counts <- colSums(in_exposures_df)
    my_sum_ind <- order(total_counts)
    my_PIDs_vector <- names(in_exposures_df)
  }
  if(!is.null(in_sum_ind)) {
    my_sum_ind <- in_sum_ind
  }
  order_sum_ind <- order(my_sum_ind)
  names(order_sum_ind) <- names(in_exposures_df)
  ## visualize as stacked barplot with ggplot2 for comparison with matlab NMF 
  ## output
  exposures_df_melt <- melt(temp_exposures_df,id.vars="sig_index")
  names(exposures_df_melt)[2] <- "PID"
  exposures_df_melt <- exposures_df_melt[order(exposures_df_melt$PID,
                                               exposures_df_melt$sig_index),]
  exposures_df_melt$PID_index <- order_sum_ind[exposures_df_melt$PID]
  exposures_df_melt$PID_index <- as.factor(exposures_df_melt$PID_index)
  exposures_df_melt$sig_index <- as.factor(exposures_df_melt$sig_index)
  number_of_legend_cols <- 
    ifelse((dim(in_signatures_ind_df)[1] %% legend_height)==0,0,1) +
    (dim(in_signatures_ind_df)[1] %/% legend_height)
  p0 <- ggplot(environment = .e) + 
    geom_bar(data=exposures_df_melt, 
             aes_string(x="PID_index",y="value",fill="sig_index"),
             stat='identity') +
    scale_fill_manual(labels=in_signatures_ind_df$sig,
                      values=in_signatures_ind_df$colour) + 
    scale_x_discrete("PID",breaks=seq(1,number_of_PIDs),
                     labels=my_PIDs_vector[my_sum_ind])
  p <- p0 + theme(axis.text.x=element_text(angle=90,size=7,vjust=0.5)) +
    guides(fill=guide_legend(ncol=number_of_legend_cols))
  q <- p0 + theme(axis.text = element_blank(), axis.ticks = element_blank()) +
    labs(x="", y="")
  if(!is.null(in_subgroups_df) & in_show_subgroups){
    pid_sums <- colSums(in_exposures_df)
    pid_ind <- match(my_PIDs_vector,names(pid_sums))
    pid_sums <- pid_sums[pid_ind]
    upper_y_lim <- 1.1*max(pid_sums)
    in_subgroups_df$pid_sums <- pid_sums
    in_subgroups_df <- in_subgroups_df[my_sum_ind,]
    in_subgroups_df$my_x <- seq(1,dim(in_subgroups_df)[1])
    p1 <- p +
      geom_text(data=in_subgroups_df,
                aes_string(label=in_subgroups.field,x="my_x",y="pid_sums"),
                angle=90,size=3,hjust=0) + ylim(0,upper_y_lim) +
      labs(title=in_title, y="")    
  } else {
    p1 <- p +
      labs(y="")
  }
  if(!in_labels) {p1 <- q + theme(legend.position = "none")}
  return(p1)
}



plot_exposures_old <- function(in_exposures_df,
                           in_signatures_ind_df,
                           in_subgroups_df,
                           in_sum_ind=NULL,
                           in_subgroups.field="subgroup",
                           in_title="",
                           in_labels=TRUE,
                           in_show_subgroups=TRUE) {
  .e <- environment()
  subgroups_ind <- which(names(in_subgroups_df)==in_subgroups.field)
  if(!is.null(in_sum_ind)) {
    my_sum_ind <- in_sum_ind
  } else {
    my_sum_ind <- order(in_subgroups_df[,subgroups_ind],
                        in_subgroups_df$compl_sum)
  }
  order_sum_ind <- order(my_sum_ind)
  legend_height <- 10
  ## prepare for output
  temp_exposures_df <- in_exposures_df
  temp_exposures_df$sig_index <- 
    in_signatures_ind_df$index[match(rownames(temp_exposures_df),
                                     in_signatures_ind_df$sig)]
  number_of_sigs <- dim(in_exposures_df)[1]
  ## visualize as stacked barplot with ggplot2 for comparison with matlab NMF 
  ## output
  exposures_df_melt <- melt(temp_exposures_df,id.vars="sig_index")
  names(exposures_df_melt)[2] <- "PID"
  exposures_df_melt <- exposures_df_melt[order(exposures_df_melt$PID,
                                               exposures_df_melt$sig_index),]
#   exposures_df_melt$PID_index <- 
#     in_subgroups_df$index[match(exposures_df_melt$PID,in_subgroups_df$PID)]
  exposures_df_melt$PID_index <- order_sum_ind[match(exposures_df_melt$PID,
                                                     in_subgroups_df$PID)]
  exposures_df_melt$PID_index <- as.factor(exposures_df_melt$PID_index)
  exposures_df_melt$sig_index <- as.factor(exposures_df_melt$sig_index)
  number_of_legend_cols <- 
    ifelse((dim(in_signatures_ind_df)[1] %% legend_height)==0,0,1) +
    (dim(in_signatures_ind_df)[1] %/% legend_height)
  p <- ggplot(environment = .e) + 
    geom_bar(data=exposures_df_melt, 
             aes_string(x="PID_index",y="value",fill="sig_index"),
             stat='identity') +
    scale_fill_manual(labels=in_signatures_ind_df$sig,
                      values=in_signatures_ind_df$colour) + 
    scale_x_discrete("PID",breaks=seq(1,dim(in_subgroups_df)[1]),
                     labels=in_subgroups_df$PID[my_sum_ind]) +
    theme(axis.text.x=element_text(angle=90,size=7,vjust=0.5)) +
    guides(fill=guide_legend(ncol=number_of_legend_cols))
  q <- ggplot(environment = .e) + 
    geom_bar(data=exposures_df_melt,
             aes_string(x="PID_index",y="value",fill="sig_index"),
             stat='identity') +
    scale_fill_manual(labels=in_signatures_ind_df$sig,
                      values=in_signatures_ind_df$colour) + 
    scale_x_discrete(breaks=seq(1,dim(in_subgroups_df)[1]),label=NULL) +
    theme(axis.text = element_blank(), axis.ticks = element_blank()) +
    labs(x="", y="")
  pid_sums <- colSums(in_exposures_df)
  pid_ind <- match(in_subgroups_df$PID,names(pid_sums))
  pid_sums <- pid_sums[pid_ind]
  upper_y_lim <- 1.1*max(pid_sums)
  in_subgroups_df$pid_sums <- pid_sums
  in_subgroups_df <- in_subgroups_df[my_sum_ind,]
  in_subgroups_df$my_x <- seq(1,dim(in_subgroups_df)[1])
  if(in_show_subgroups) {
    p1 <- p +
      geom_text(data=in_subgroups_df,
                aes_string(label=in_subgroups.field,x="my_x",y="pid_sums"),
                angle=90,size=3,hjust=0) + ylim(0,upper_y_lim) +
      labs(title=in_title, y="")
  } else {
    p1 <- p +
      labs(y="")
  }
  if(!in_labels) {p1 <- q + theme(legend.position = "none")}
  return(p1)
}


#' Plot the relative exposures of a cohort
#'
#' \code{plot_relative_exposures}: Plot the relative or normalized exposures of
#' a cohort. This function first normalizes its input and then sends the
#' normalized data to \code{\link{plot_exposures}}.
#'
#' @examples
#'  data(lymphoma_cohort_LCD_results)
#'  plot_relative_exposures(lymphoma_Nature2013_COSMIC_cutoff_exposures_df,
#'                          chosen_signatures_indices_df,
#'                          COSMIC_subgroups_df)
#'
#' @export
#' @rdname plot_exposures
#'   
plot_relative_exposures <- function(in_exposures_df,in_signatures_ind_df,
                                    in_subgroups_df,in_sum_ind=NULL,
                                    in_subgroups.field="subgroup",in_title="",
                                    in_labels=TRUE,
                                    in_show_subgroups=TRUE) {
  t_temp_temp_exposures_df <- as.data.frame(t(in_exposures_df))
  t_rowSums <- rowSums(t_temp_temp_exposures_df)
  t_rowSums[which(t_rowSums==0)] <- 1e06
  t_temp_exposures_df <- t_temp_temp_exposures_df/t_rowSums
  this_exposures_df <- as.data.frame(t(t_temp_exposures_df))
  return(plot_exposures(this_exposures_df,in_signatures_ind_df,in_subgroups_df,
                        in_sum_ind,in_subgroups.field,in_title,in_labels,
                        in_show_subgroups))
}


#' @import ComplexHeatmap
#' 
enhanced_barplot = function(mat, col, anno, anno_color, ylab = NULL,
                            title = "",in_labels=TRUE,
                            in_barplot_borders=TRUE,
                            in_column_anno_borders=FALSE) {
  names(col) = rownames(mat)
  mat_foo = matrix(rep(rownames(mat), ncol(mat)), nrow = nrow(mat))
  
  if(in_labels){
    if(!in_column_anno_borders){
      ha = HeatmapAnnotation(
        df = data.frame(anno = anno), col = list(anno = anno_color),
        text = anno_text(colnames(mat), offset = unit(1, "npc"), 
                         just = "right", rot = 90),
        annotation_height = unit.c(unit(5, "mm"), 
                                   max_text_width(colnames(mat)) ))      
    } else {
      ha = HeatmapAnnotation(
        df = data.frame(anno = anno), col = list(anno = anno_color),
        text = anno_text(colnames(mat), offset = unit(1, "npc"), 
                         just = "right", rot = 90),
        annotation_height = unit.c(unit(5, "mm"), 
                                   max_text_width(colnames(mat)) ),
        gp = gpar(col="black"))
    }
  } else {
    if(!in_column_anno_borders){
      ha = HeatmapAnnotation(
        df = data.frame(anno = anno), col = list(anno = anno_color),
        annotation_height = unit.c(unit(5, "mm"), 
                                   max_text_width(colnames(mat)) ))    
    } else {
      ha = HeatmapAnnotation(
        df = data.frame(anno = anno), col = list(anno = anno_color),
        annotation_height = unit.c(unit(5, "mm"), 
                                   max_text_width(colnames(mat)) ),
        gp = gpar(col="black"))          
    }
  }
  ht = Heatmap(mat_foo, col = col, name = "main", cluster_rows = FALSE, 
               cluster_columns = FALSE,
               rect_gp = gpar(type = "none"), bottom_annotation = ha,
               heatmap_legend_param = list(at = rev(names(col)), 
                                           labels = rev(names(col))))
  
  draw(ht, padding = unit(c(2, 20, 2, 2), "mm"), column_title = title)
  
  decorate_heatmap_body("main", {
    pushViewport(viewport(xscale = c(0, ncol(mat)),
                          yscale = c(0, max(colSums(mat)))))
    if(in_barplot_borders) {
      for(i in seq_len(ncol(mat))) {
        x = i - 0.5
        for(j in seq_len(nrow(mat))) {
          y = sum(mat[1:j, i])
          grid.rect(x, y, width = 0.9, height = mat[j, i], just = c("top"),
                    default.units = "native", gp = gpar(fill = col[j]))
        }
      }
    } else {
      for(i in seq_len(ncol(mat))) {
        x = i - 0.5
        for(j in seq_len(nrow(mat))) {
          y = sum(mat[1:j, i])
          grid.rect(x, y, width = 0.9, height = mat[j, i], just = c("top"),
                    default.units = "native", gp = gpar(fill = col[j],
                                                        col = NA))
        }
      }      
    }
    grid.yaxis(gp=gpar(fontsize=8))
    if(!is.null(ylab)){
      grid.text(ylab, x = unit(0, "npc") - unit(15, "mm"), just = "left", 
                rot = 90)      
    }    
    
    upViewport()
  })
}


#' Wrapper for enhanced_barplot
#'
#' @param in_exposures_df Numerical data frame encoding the exposures \code{H},
#'   i.e. which signature contributes how much to which PID (patient identifier
#'   or sample).
#' @param in_signatures_ind_df A data frame containing meta information about
#'   the signatures. If NULL, the colour information for the signatures is 
#'   taken from a rainbow palette.
#' @param in_subgroups_df A data frame indicating which PID (patient or sample
#'   identifyier) belongs to which subgroup. If NULL, it is assumed that all
#'   PIDs belong to one common subgroup. The colour coding for the default
#'   subgroup is red.
#' @param in_sum_ind Index vector influencing the order in which the PIDs are
#'   going to be displayed
#' @param in_subgroups.field String indicating the column name in
#'   \code{in_subgroups_df} to take the subgroup information from.
#' @param in_title Title for the plot to be created.
#' @param in_labels Flag, if \code{TRUE} the PIDs are displayed on the x-axis
#' @param in_show_subgroups Flag, if \code{TRUE} then PIDs are grouped by
#'   subgroups
#' @param ylab Label of the y-axis on the plot to be generate
#' @param in_barplot_borders Whether or not to show border lines in barplot
#' @param in_column_anno_borders Whether or not to draw separating lines 
#' between the fields in the annotation
#'
#' @return The generated barplot - a ggplot2 plot
#'
#' @examples
#'  data(lymphoma_cohort_LCD_results)
#'  exposures_barplot(lymphoma_Nature2013_COSMIC_cutoff_exposures_df,
#'                    chosen_signatures_indices_df,
#'                    COSMIC_subgroups_df)
#'
#' @importFrom grDevices rainbow
#' @export
#' 
exposures_barplot <- function(in_exposures_df,in_signatures_ind_df=NULL,
                              in_subgroups_df=NULL,in_sum_ind=NULL,
                              in_subgroups.field="subgroup",in_title="",
                              in_labels=TRUE,in_show_subgroups=TRUE,ylab=NULL,
                              in_barplot_borders=TRUE,
                              in_column_anno_borders=FALSE) {
  if(!is.null(in_subgroups_df)){
    temp_anno_color <- aggregate(col~subgroup,data=in_subgroups_df,
                                 function(l) return(l[1]))
    my_anno_color <- temp_anno_color$col
    names(my_anno_color) <- temp_anno_color$subgroup
    order_ind <- order(in_subgroups_df$index)
    if(!is.null(in_sum_ind)) order_ind <- in_sum_ind
    subgroup_vector <- in_subgroups_df$subgroup[order_ind]
  } else {
    total_counts <- colSums(in_exposures_df)
    order_ind <- rev(order(total_counts))
    if(!is.null(in_sum_ind)) order_ind <- in_sum_ind
    my_anno_color <- c("#FF0000FF")
    names(my_anno_color) <- "subgroup"
    subgroup_vector <- factor(rep("subgroup",dim(in_exposures_df)[2]))
  }
  if(!is.null(in_signatures_ind_df)){
    signature_colour_vector <- in_signatures_ind_df$colour
  } else {
    signature_colour_vector <- rainbow(dim(in_exposures_df)[1])
  }
  title  <- in_title
  enhanced_barplot(in_exposures_df[,order_ind],
                   signature_colour_vector,
                   subgroup_vector,
                   my_anno_color,in_labels=in_labels,
                   in_barplot_borders=in_barplot_borders,
                   in_column_anno_borders=in_column_anno_borders)
}


#' Add information to an annotation data structure
#'
#' Function to iteratively add information to an annotation data structure as
#' needed for \code{\link[ComplexHeatmap]{HeatmapAnnotation}} and especially 
#' for \code{\link{annotation_exposures_barplot}}
#'
#' @param in_annotation_col List, every element of which refers to one layer 
#'   of annotation List elements are structures corresponding to named colour
#'   vectors
#' @param in_annotation_df Data frame, every column of which corresponds to a
#'   layer of annotation. It has as many rows as there are samples, every 
#'   entry in a row corresponding to the attribute the samples has for the
#'   corresponding layer of annotation.The factor levels of a column of
#'   \code{in_annotation_df} correspond to the names of the corresponding
#'   element in \code{in_annotation_col}
#' @param in_attribution_vector A vector which is going to be cbinded to
#'   \code{in_annotatiin_df}, carrying the annotation information of the new
#'   layer to be added
#' @param in_colour_vector Named vector of colours to be attributed to the new
#'   annotation
#' @param in_name Name of the new layer of annotation
#'
#' @return A list with entries \itemize{ \item \code{annotation_col}: A list 
#'   as in \code{in_annotation_col} but with one additional layer of annotation
#'   \item \code{annotation_df}: A data frame as in \code{in_annotation_df}
#'   but with one additional layer of annotation}
#'
#' @examples
#'  NULL
#'
#' @export
#' 
add_annotation <- function(in_annotation_col,
                           in_annotation_df,
                           in_attribution_vector,
                           in_colour_vector,
                           in_name){
  current_name_vector <- sort(unique(as.character(in_attribution_vector)))
  current_annotation_index <- length(in_annotation_col) + 1
  annotation_col <- in_annotation_col
  annotation_col[[current_annotation_index]] <- 
    structure(in_colour_vector,names=current_name_vector)
  names(annotation_col)[current_annotation_index] <- in_name
  if(is.null(in_annotation_df)){
    annotation_df <- data.frame(in_attribution_vector)
  } else {
    annotation_df <- cbind(in_annotation_df,
                           data.frame(in_attribution_vector))
  }
  names(annotation_df)[current_annotation_index] <- in_name
  return(list(annotation_col=annotation_col,
              annotation_df=annotation_df))
}


#' Plot the exposures of a cohort with different layers of annotation
#'
#' The exposures \code{H}, determined by NMF or by \code{\link{LCD}}, are
#' displayed as a stacked barplot by calling
#' \code{\link[ComplexHeatmap]{Heatmap}}. The x-axis displays the PIDs (patient
#' identifier or sample), the y-axis the counts attributed to the different
#' signatures with their respective colours per PID. It is analogous to
#' \code{\link{plot_exposures}}. As many layers of information as desired can be
#' added via an annotation data frame. The annotation data is handled in a way
#' similar to \code{\link{annotation_heatmap_exposures}}. This function calls:
#' \itemize{ \item \code{\link[ComplexHeatmap]{rowAnnotation}}, \item
#' \code{\link[ComplexHeatmap]{HeatmapAnnotation}} and \item
#' \code{\link[ComplexHeatmap]{Heatmap}} }
#'
#' @details It might be necessary to install the newest version of the
#' development branch of the packages \pkg{circlize} and \pkg{ComplexHeatmap} by
#' Zuguang Gu: \code{devtools::install_github("jokergoo/circlize")} and
#' \code{devtools::install_github("jokergoo/ComplexHeatmap")}
#'
#' @param in_exposures_df Numerical data frame encoding the exposures \code{H},
#'   i.e. which signature contributes how much to which PID (patient identifier
#'   or sample).
#' @param in_signatures_ind_df A data frame containing meta information about
#'   the signatures
#' @param in_subgroups_df A data frame indicating which PID (patient or sample
#'   identifyier) belongs to which subgroup
#' @param in_annotation_df A data frame indicating which PID (patient or sample
#'   identifyier) belongs to which subgroup for all layers of annotation
#' @param in_annotation_col A list indicating colour attributions for all
#'  layers of annotation
#' @param ylab String indicating the column name in \code{in_subgroups_df} to
#'   take the subgroup information from.
#' @param title Title for the plot to be created.
#' @param in_labels Whether or not to show the names of the samples.
#' @param in_barplot_borders Whether or not to show border lines in barplot
#' @param in_column_anno_borders Whether or not to draw separating lines 
#'  between the fields in the annotation
#' @param in_annotation_legend_side Where to put the legends of the annotation
#'   df, default is right.
#' @param in_padding Parameter passed on to function
#'   \code{\link[ComplexHeatmap]{draw}}
#' @param in_annotation A full annotation object may also be provided by the
#'   educated user.
#'
#' @details It might be necessary to install the newest version of the
#' development branch of the packages \pkg{circlize} and \pkg{ComplexHeatmap}
#'  by Zuguang Gu: \code{devtools::install_github("jokergoo/circlize")} and
#' \code{devtools::install_github("jokergoo/ComplexHeatmap")}
#'
#' @return The function doesn't return any value.
#'
#' @examples
#'  NULL
#'
#' @seealso \code{\link[ComplexHeatmap]{HeatmapAnnotation}}
#' @seealso \code{\link[ComplexHeatmap]{Heatmap}}
#' @seealso \code{\link[ComplexHeatmap]{decorate_heatmap_body}}
#' @seealso \code{\link{annotation_heatmap_exposures}}
#' @seealso \code{\link{plot_exposures}}
#'
#' @import ComplexHeatmap
#' @import circlize
#' @export
#' 
annotation_exposures_barplot <- function(
  in_exposures_df,
  in_signatures_ind_df,
  in_subgroups_df,
  in_annotation_df = NULL,
  in_annotation_col = NULL,
  ylab = NULL,
  title = "",in_labels=FALSE,
  in_barplot_borders=TRUE,
  in_column_anno_borders=FALSE,
  in_annotation_legend_side="right",
  in_padding = unit(c(2, 20, 2, 2), "mm"),
  in_annotation = NULL){
  order_ind <- order(in_subgroups_df$index)
  mat <- in_exposures_df[,order_ind]
  this_annotation_df <- in_annotation_df[order_ind,]
  col <- in_signatures_ind_df$colour
  
  names(col) = rownames(mat)
  mat_foo = matrix(rep(rownames(mat), ncol(mat)), nrow = nrow(mat))
  
  if(!is.null(in_annotation)){
    ha <- in_annotation
  } else {
    if(in_labels){
      if(!in_column_anno_borders){
        ha = HeatmapAnnotation(
          df = this_annotation_df,
          col = in_annotation_col,
          text = anno_text(colnames(mat), offset = unit(1, "npc"), 
                           just = "right", rot = 90))      
      } else {
        ha = HeatmapAnnotation(
          df = this_annotation_df,
          col = in_annotation_col,
          text = anno_text(colnames(mat), offset = unit(1, "npc"), 
                           just = "right", rot = 90),
          gp = gpar(col="black"))
      }
    } else {
      if(!in_column_anno_borders){
        ha = HeatmapAnnotation(df = this_annotation_df,
                               col = in_annotation_col)    
      } else {
        ha = HeatmapAnnotation(df = this_annotation_df,
                               col = in_annotation_col,
                               gp = gpar(col="black"))          
      }
    }
  }
  ht = Heatmap(mat_foo, col = col, name = "main", cluster_rows = FALSE, 
               cluster_columns = FALSE,
               rect_gp = gpar(type = "none"), bottom_annotation = ha,
               heatmap_legend_param = list(at = rev(names(col)), 
                                           labels = rev(names(col))))
  
  draw(ht, padding = in_padding, column_title = title,
       annotation_legend_side=in_annotation_legend_side)
  
  decorate_heatmap_body("main", {
    pushViewport(viewport(xscale = c(0, ncol(mat)),
                          yscale = c(0, max(colSums(mat)))))
    if(in_barplot_borders) {
      for(i in seq_len(ncol(mat))) {
        x = i - 0.5
        for(j in seq_len(nrow(mat))) {
          y = sum(mat[1:j, i])
          grid.rect(x, y, width = 0.9, height = mat[j, i], just = c("top"),
                    default.units = "native", gp = gpar(fill = col[j]))
        }
      }
    } else {
      for(i in seq_len(ncol(mat))) {
        x = i - 0.5
        for(j in seq_len(nrow(mat))) {
          y = sum(mat[1:j, i])
          grid.rect(x, y, width = 0.9, height = mat[j, i], just = c("top"),
                    default.units = "native", gp = gpar(fill = col[j],
                                                        col = NA))
        }
      }      
    }
    grid.yaxis(gp=gpar(fontsize=8))
    if(!is.null(ylab)){
      grid.text(ylab, x = unit(0, "npc") - unit(15, "mm"), 
                just = "left", rot = 90)      
    }    
    
    upViewport()
  })
}

#' Plot the exposures of a cohort with different layers of annotation for 
#' SNV and INDEL signatures
#'
#' The exposures \code{H}, determined by NMF or by \code{\link{LCD}}, are
#' displayed as a stacked barplot by calling
#' \code{\link[ComplexHeatmap]{Heatmap}}. The x-axis displays the PIDs (patient
#' identifier or sample), the y-axis the counts attributed to the different
#' signatures with their respective colours per PID. It is analogous to
#' \code{\link{plot_exposures}}. As many layers of information as desired can be
#' added via an annotation data frame. The annotation data is handled in a way
#' similar to \code{\link{annotation_heatmap_exposures}}. In comparison to
#' \code{\link{annotation_exposures_barplot}} allows this function to deal with
#' a list of differn signature and mutation types. This function calls:
#' \itemize{ \item \code{\link[ComplexHeatmap]{rowAnnotation}}, \item
#' \code{\link[ComplexHeatmap]{HeatmapAnnotation}} and \item
#' \code{\link[ComplexHeatmap]{Heatmap}} }
#'
#' @details It might be necessary to install the newest version of the
#' development branch of the packages \pkg{circlize} and \pkg{ComplexHeatmap} by
#' Zuguang Gu: \code{devtools::install_github("jokergoo/circlize")} and
#' \code{devtools::install_github("jokergoo/ComplexHeatmap")}
#'
#' @param in_exposures_list A list of numerical data frame encoding the
#'   exposures \code{H} of different signature types, i.e. which signature
#'   contributes how much to which PID (patient identifier or sample).
#' @param in_signatures_ind_list A list of data frame containing meta
#'   information about the each signature type individually
#' @param in_subgroups_list A list of data frame indicating of each siganture
#'   type which PID (patient or sample identifyier) belongs to which subgroup
#' @param in_annotation_list A list data frame indicating which PID (patient or
#'   sample identifyier) belongs to which subgroup for all layers of annotation
#'   and a list indicating colour attributions for all layers of annotation for
#'   each siganture type individually
#' @param ylab String indicating the column name in \code{in_subgroups_df} to
#'   take the subgroup information from.
#' @param title Title for the plot to be created.
#' @param in_labels Whether or not to show the names of the samples.
#' @param in_barplot_borders Whether or not to show border lines in barplot
#' @param in_column_anno_borders Whether or not to draw separating lines 
#'   between the fields in the annotation
#' @param in_annotation_legend_side Where to put the legends of the annotation
#'   df, default is right.
#' @param in_padding Parameter passed on to function
#'   \code{\link[ComplexHeatmap]{draw}}
#' @param in_annotation A full annotation object may also be provided by the
#'   educated user.
#' @param in_indel_sigs Tag which is default FALSE when whole genome data are
#'   analysed the tag will be TRUE
#'
#' @details It might be necessary to install the newest version of the
#' development branch of the packages \pkg{circlize} and \pkg{ComplexHeatmap}
#' by Zuguang Gu: \code{devtools::install_github("jokergoo/circlize")} and
#' \code{devtools::install_github("jokergoo/ComplexHeatmap")}
#'
#' @return The function doesn't return any value.
#'
#' @examples
#'  NULL
#'
#' @seealso \code{\link[ComplexHeatmap]{HeatmapAnnotation}}
#' @seealso \code{\link[ComplexHeatmap]{Heatmap}}
#' @seealso \code{\link[ComplexHeatmap]{decorate_heatmap_body}}
#' @seealso \code{\link{annotation_heatmap_exposures}}
#' @seealso \code{\link{plot_exposures}}
#'
#' @import ComplexHeatmap
#' @import circlize
#' @export
#' 
annotation_exposures_list_barplot <- function(
  in_exposures_list,
  in_signatures_ind_list,
  in_subgroups_list,
  in_annotation_list,
  ylab = NULL,
  title = "",
  in_indel_sigs = FALSE,
  in_labels=FALSE,
  in_barplot_borders=TRUE,
  in_column_anno_borders=FALSE,
  in_annotation_legend_side="right",
  in_padding = unit(c(2, 20, 2, 2), "mm"),
  in_annotation = NULL){
  graphic_list <- lapply(seq(1:length(in_exposures_list)), function(i){
    
    order_ind <- order(in_subgroups_list[[i]]$index)
    mat <- in_exposures_list[[i]][,order_ind]
    this_annotation_df <- in_annotation_list[[i]]$annotation_df[order_ind,]
    col <- in_signatures_ind_list[[i]]$colour
    
    names(col) = rownames(mat)
    mat_foo= matrix(rep(rownames(mat), ncol(mat)), nrow = nrow(mat))
    
    if(!is.null(in_annotation)){
      ha <- in_annotation_list
    } else {
      if(in_labels){
        if(!in_column_anno_borders){
          ha = HeatmapAnnotation(
            df = this_annotation_df,
            col = in_annotation_list[[i]]$annotation_col,
            text = anno_text(colnames(mat), 
                             offset = unit(1, "npc"), 
                             just = "right", 
                             rot = 45, 
                             gp = gpar(fontsize = 9)))      
        } else {
          ha = HeatmapAnnotation(
            df = this_annotation_df,
            col = in_annotation_list[[i]]$annotation_col,
            text = anno_text(colnames(mat), 
                             offset = unit(1, "npc"), 
                             just = "right",
                             rot = 45, 
                             gp = gpar(fontsize = 9)),
            gp = gpar(col="black"))
        }
      } else {
        if(!in_column_anno_borders){
          ha = HeatmapAnnotation(df = this_annotation_df,
                                 col = in_annotation_list[[i]]$annotation_col)
        } else {
          ha = HeatmapAnnotation(df = this_annotation_df,
                                 col = in_annotation_list[[i]]$annotation_col,
                                 gp = gpar(col="black"))          
        }
      }
    }
    ht = Heatmap(mat_foo, col = col, name = "main", cluster_rows = FALSE, 
                 cluster_columns = FALSE,
                 rect_gp = gpar(type = "none"), bottom_annotation = ha,
                 heatmap_legend_param = list(at = rev(names(col)), 
                                             labels = rev(names(col))))
    plot = grid.grabExpr({
      draw(ht, padding = in_padding, column_title = title,
           annotation_legend_side=in_annotation_legend_side)
      
      decorate_heatmap_body("main", {
        pushViewport(viewport(xscale = c(0, ncol(mat)),
                              yscale = c(0, max(colSums(mat)))))
        if(in_barplot_borders) {
          for(i in seq_len(ncol(mat))) {
            x = i - 0.5
            for(j in seq_len(nrow(mat))) {
              y = sum(mat[1:j, i])
              grid.rect(x, y, width = 0.9, height = mat[j, i], just = c("top"),
                        default.units = "native", gp = gpar(fill = col[j]))
            }
          }
        } else {
          for(i in seq_len(ncol(mat))) {
            x = i - 0.5
            for(j in seq_len(nrow(mat))) {
              y = sum(mat[1:j, i])
              grid.rect(x, y, width = 0.9, height = mat[j, i], just = c("top"),
                        default.units = "native", gp = gpar(fill = col[j],
                                                            col = NA))
            }
          }      
        }
        grid.yaxis(gp=gpar(fontsize=8))
        if(!is.null(ylab)){
          grid.text(ylab, x = unit(0, "npc") - unit(15, "mm"), 
                    just = "left", rot = 90)      
        }    
        
        upViewport()
      })
    })
    return(list(mat=mat,
                ha=ha,
                ht=ht,
                plot=plot))
  })  
  
  names(graphic_list) <- names(in_exposures_list)
  
  grid.newpage()
  
  if(!in_indel_sigs){
    pushViewport(viewport(height=1, layout = grid.layout(nrow = 1, ncol = 2)))
  }else if(in_indel_sigs){
    pushViewport(viewport(height=1, layout = grid.layout(nrow = 2, ncol = 2)))
  }
  pushViewport(viewport(layout.pos.row = 1, layout.pos.col = 1))
  grid.draw(graphic_list$cosmic_df$plot)
  popViewport()
  pushViewport(viewport(layout.pos.row = 1, layout.pos.col = 2))
  grid.draw(graphic_list$pcawg_df$plot)
  popViewport()
  if(in_indel_sigs){
    pushViewport(viewport(layout.pos.row = 2, layout.pos.col = 1))
    grid.draw(graphic_list$indel_df$plot)
    popViewport()
  }
}


plot_colour_legend_subgroups <- function(in_subgroup_df,mycol,
                                         in_subgroup.field="subgroup",
                                         in_index.field="index",
                                         in_size=0.9) {
  .e <- environment()
  p2 <- ggplot(in_subgroup_df, 
               aes_string(x=in_index.field, y=1, fill=in_subgroup.field,
                          width = in_size, height = in_size), 
               environment = .e) + 
    geom_tile() + 
    theme_bw(base_size = 14) +
    theme(axis.text = element_blank(), axis.ticks = element_blank(), 
          panel.grid.major = element_blank(), 
          panel.grid.minor = element_blank(), 
          panel.border = element_blank()) +
    scale_fill_manual(values = mycol, 
                      guide = guide_legend(title = '', keywidth = 0.7, 
                                           keyheight = 0.7, nrow = 1)) + 
    theme(legend.position = "top") +
    xlab('') +
    ylab('') + 
    coord_fixed(ratio=1)
  return(p2)
}



#' @import ggplot2
#' @import grid
#' @import gridExtra
#' 
plot_SMC_old <- function(number_of_strata,output_path,decomposition_method,
                         number_of_sigs,name_list,
                         exposures_strata_list,this_signatures_ind_df,
                         this_subgroups_df,
                         in_strata_order_ind,exposures_both_rel_df_list,
                         cohort_method_flag) {
  plot_list_cohort <- list()
  all_method_colour_vector <- c("grey60","grey40","grey20")
  names(all_method_colour_vector) <- c("all_PIDs","cohort","norm_PIDs")
  if(length(cohort_method_flag)<2) {
    for (i in seq_len(length(exposures_both_rel_df_list))) { 
      temp_df <- exposures_both_rel_df_list[[i]]
      temp_df$sig_index <- 
        this_signatures_ind_df$index[match(temp_df$sig,
                                           this_signatures_ind_df$sig)]
      temp_df$sig_index <- as.factor(temp_df$sig_index)
      plot_list_cohort[[i]] <- ggplot() + 
        ggplot2::geom_bar(data=temp_df,
                          aes_string(x="sig_index",y="exposure",
                                     fill="sig_index",size=0.3),
                          stat='identity',position="dodge",width=.7) + 
        scale_fill_manual(name="sig",labels=this_signatures_ind_df$sig,
                          values=this_signatures_ind_df$colour) +
        geom_errorbar(data=temp_df,
                      aes_string(x="sig_index", ymin="exposure_min",
                                 ymax="exposure_max"), width=0.5) +
        labs(x="",y="") +
        theme(axis.text.x = element_blank(), axis.ticks.x = element_blank(), 
              legend.position = "none")
    }    
  } else {
    method_colour_vector <- all_method_colour_vector[cohort_method_flag]
    for (i in seq_len(length(exposures_both_rel_df_list))) { 
      temp_df <- exposures_both_rel_df_list[[i]]
      temp_df$sig_index <- 
        this_signatures_ind_df$index[match(temp_df$sig,
                                           this_signatures_ind_df$sig)]
      temp_df$sig_index <- as.factor(temp_df$sig_index)
      plot_list_cohort[[i]] <- ggplot() + 
        ggplot2::geom_bar(data=temp_df,
                          aes_string(x="sig_index", y="exposure",
                                     colour="method", fill="sig_index",
                                     size=0.3),
                          stat='identity',position="dodge",width=.7) + 
        scale_fill_manual(name="sig",labels=this_signatures_ind_df$sig,
                          values=this_signatures_ind_df$colour) +
        scale_colour_manual(values=method_colour_vector) +
        geom_errorbar(data=temp_df,
                      aes_string(x="sig_index", ymin="exposure_min",
                                 ymax="exposure_max"), width=0.5) +
        labs(x="",y="") +
        theme(axis.text.x = element_blank(), axis.ticks.x = element_blank(),
              legend.position = "none")
    }    
  }
  all_cohort_plot <- ggplotGrob(plot_list_cohort[[1]] + 
                                  theme(legend.position="right") + 
                                  guides(size=FALSE))$grobs
  common_legend <- 
    all_cohort_plot[[which(sapply(all_cohort_plot, 
                                  function(x) x$name) == "guide-box")]]
  plot_list_abs <- list()
  plot_list_rel <- list()
  plot_list_abs[[1]] <- plot_exposures(
    exposures_strata_list$exposures_all_df,
    this_signatures_ind_df,this_subgroups_df,
    in_title="new",in_labels=FALSE)
  plot_list_rel[[1]] <- plot_relative_exposures(
    exposures_strata_list$exposures_all_df,
    this_signatures_ind_df,this_subgroups_df,
    in_title="new",in_labels=FALSE)
  for (i in seq_len(number_of_strata)) {
    plot_list_abs[[i+1]] <- plot_exposures(
      exposures_strata_list$sub_exposures_list[[i]],
      this_signatures_ind_df,this_subgroups_df,
      in_title="new",in_labels=FALSE)
    plot_list_rel[[i+1]] <- plot_relative_exposures(
      exposures_strata_list$sub_exposures_list[[i]],
      this_signatures_ind_df,this_subgroups_df,
      in_title="new",in_labels=FALSE)
  }
  strata_order_ind <- c(1,in_strata_order_ind+1)
  plot_list_abs <- plot_list_abs[strata_order_ind]
  plot_list_rel <- plot_list_rel[strata_order_ind]
  plot_list_cohort <- plot_list_cohort[strata_order_ind]
  plot_list_all <- list()
  for (i in seq_len(number_of_strata+1)) {
    plot_list_all[[2*(i-1)+1]] <- plot_list_abs[[i]]
    plot_list_all[[2*(i-1)+2]] <- plot_list_rel[[i]]
  }
  
  temp_name_list <- c("all",name_list)
  name_df <- data.frame(t(data.frame(t(temp_name_list[strata_order_ind]))))
  names(name_df) <- "names"
  name_df$names <- as.character(name_df$names)
  name_df$x_pos <- 0
  name_df$y_pos <- 0
  name_df$new_names <- gsub("non_","non ",name_df$names)
  name_df$new_names <- gsub("_","\n",name_df$new_names)
  
  horizontal_label_width <- 1
  horizontal_big_element_width <- 10
  horizontal_small_element_width <- 4
  horizontal_legend_width <- 2
  number_of_horizontal_units <- 
    horizontal_label_width + 2*horizontal_big_element_width + 
    horizontal_small_element_width + horizontal_legend_width
  vertical_legend_height <- 1
  vertical_element_height <- 5
  number_of_vertical_units <- 
    vertical_legend_height + (number_of_strata+1)*vertical_element_height
  horizontal_figure_factor <- 60
  vertical_figure_factor <- 40
  
  if(!is.null(output_path)){
    png(output_path,
        width=number_of_horizontal_units*horizontal_figure_factor,
        height=number_of_vertical_units*vertical_figure_factor)    
  }
  grid.newpage()
  pushViewport(viewport(layout = grid.layout(number_of_vertical_units, 
                                             number_of_horizontal_units)))
  vertical_temp_stop <- vertical_legend_height
  for (i in seq_len(number_of_strata+1)) {
    horizontal_temp_start <- horizontal_label_width + 1
    horizontal_temp_stop <- 
      (horizontal_temp_start - 1) + horizontal_big_element_width
    vertical_temp_start <- vertical_temp_stop + 1
    vertical_temp_stop <- (vertical_temp_start - 1)+vertical_element_height    
    print(plot_list_abs[[i]], 
          vp = vplayout(vertical_temp_start:vertical_temp_stop, 
                        horizontal_temp_start:horizontal_temp_stop))
    p <- ggplot() + geom_text(data=name_df[i,],
                              aes_string(label="new_names",
                                         x="x_pos", y="y_pos"),
                              angle=90,size=3) +
      theme(axis.text = element_blank(), axis.ticks = element_blank(), 
            panel.background = element_blank()) +
      labs(x="", y="")  
    print(p, vp = vplayout(vertical_temp_start:vertical_temp_stop,
                           1:horizontal_label_width))
    horizontal_temp_start <- horizontal_temp_stop + 1
    horizontal_temp_stop <- 
      (horizontal_temp_start - 1) + horizontal_big_element_width
    print(plot_list_rel[[i]], 
          vp = vplayout(vertical_temp_start:vertical_temp_stop, 
                        horizontal_temp_start:horizontal_temp_stop))
    horizontal_temp_start <- horizontal_temp_stop + 1
    horizontal_temp_stop <- 
      (horizontal_temp_start - 1) + horizontal_small_element_width
    print(plot_list_cohort[[i]], 
          vp = vplayout(vertical_temp_start:vertical_temp_stop, 
                        horizontal_temp_start:horizontal_temp_stop))
  }
  legend_vp <- 
    vplayout(1:number_of_vertical_units, 
             (horizontal_temp_stop + 1):
               (horizontal_temp_stop + horizontal_legend_width))
  pushViewport(legend_vp)
  grid.draw(common_legend)
  if(!is.null(output_path)){
    dev.off()
  }
  return()
}


plot_SMC_PID_facet <- 
  function(in_abs_df_list,in_rel_df_list, in_signatures_ind_df,in_subgroups_df,
           in_name_list,in_sum_ind=NULL, in_subgroups.field="subgroup",
           in_strata_order_ind=seq_len(length(in_name_list)),
           in_label_orientation="turn"){
  .e <- environment()
  legend_height <- 10
  subgroups_ind <- which(names(in_subgroups_df)==in_subgroups.field)
  if(!is.null(in_sum_ind)) {
    my_sum_ind <- in_sum_ind
  } else {
    my_sum_ind <- order(in_subgroups_df[,subgroups_ind],
                        in_subgroups_df$compl_sum)
  }
  order_sum_ind <- order(my_sum_ind)
  number_of_sigs <- dim(in_abs_df_list[[1]])[1]
  abs_melt_df_list <- lapply(in_abs_df_list, FUN=function(x) {
    x$sig_index <- 
      in_signatures_ind_df$index[match(rownames(x),in_signatures_ind_df$sig)]
    exposures_df_melt <- melt(x,id.vars="sig_index")
    names(exposures_df_melt)[2] <- "PID"
    exposures_df_melt <- 
      exposures_df_melt[order(exposures_df_melt$PID,
                              exposures_df_melt$sig_index),]
    exposures_df_melt$PID_index <- as.factor(
      order_sum_ind[match(exposures_df_melt$PID,in_subgroups_df$PID)])
    exposures_df_melt$sig_index <- as.factor(exposures_df_melt$sig_index) 
    return(exposures_df_melt)
  })
  for(i in seq_len(length(abs_melt_df_list))){
    abs_melt_df_list[[i]]$stratum <- in_name_list[[i]]
  }
  abs_melt_df_list <- abs_melt_df_list[in_strata_order_ind]
  abs_melt_df <- do.call("rbind",abs_melt_df_list)
  abs_melt_df$stratum <- factor(abs_melt_df$stratum,
                                levels=unique(abs_melt_df$stratum))
  rel_melt_df_list <- lapply(in_rel_df_list, FUN=function(x) {
    x$sig_index <- in_signatures_ind_df$index[match(rownames(x),
                                                    in_signatures_ind_df$sig)]
    exposures_df_melt <- melt(x,id.vars="sig_index")
    names(exposures_df_melt)[2] <- "PID"
    exposures_df_melt <- exposures_df_melt[order(exposures_df_melt$PID,
                                                 exposures_df_melt$sig_index),]
    exposures_df_melt$PID_index <- as.factor(
      order_sum_ind[match(exposures_df_melt$PID,in_subgroups_df$PID)])
    exposures_df_melt$sig_index <- as.factor(exposures_df_melt$sig_index) 
    return(exposures_df_melt)
  })
  for(i in seq_len(length(rel_melt_df_list))){
    rel_melt_df_list[[i]]$stratum <- in_name_list[[i]]
  }
  rel_melt_df_list <- rel_melt_df_list[in_strata_order_ind]
  rel_melt_df <- do.call("rbind",rel_melt_df_list)
  rel_melt_df$stratum <- factor(rel_melt_df$stratum,
                                levels=unique(rel_melt_df$stratum))
  number_of_legend_cols <- 
    ifelse((dim(in_signatures_ind_df)[1] %% legend_height)==0,0,1) +
    (dim(in_signatures_ind_df)[1] %/% legend_height)
  abs_melt_df$method <- "abs"
  rel_melt_df$method <- "rel"
  all_melt_df <- rbind(abs_melt_df,rel_melt_df)
  all_melt_df$method <- factor(all_melt_df$method)
  p_all <- ggplot(all_melt_df,environment = .e) + 
    geom_bar(aes_string(x="PID_index",y="value",fill="sig_index"),
             stat='identity') +
    facet_wrap(~stratum+method, scales="free_y",ncol=2) +
    scale_fill_manual(labels=in_signatures_ind_df$sig,
                      values=in_signatures_ind_df$colour) + 
    scale_x_discrete("PID",breaks=seq(1,dim(in_subgroups_df)[1]),
                     labels=in_subgroups_df$PID[my_sum_ind]) +
    theme(axis.title.y=element_blank(),
          panel.background=element_rect(fill=NA, colour="black"),
          panel.border=element_rect(fill=NA, colour="black"),
          strip.background=element_rect(colour="black")) +
    guides(fill=guide_legend(ncol=number_of_legend_cols))
  if(in_label_orientation=="turn"){
    p_all <- p_all + theme(axis.text.x=element_text(angle=90,size=7,vjust=0.5))
  }
  return(p_all)
}


plot_group_facet <- 
  function(in_df_list,in_name_list, in_signatures_ind_df,
           in_strata_order_ind=seq_len(length(in_name_list))){
  for(i in seq_len(length(in_df_list))){
    in_df_list[[i]]$stratum <- paste0(in_name_list[[i]],", cohort")
  }
  in_df_list <- in_df_list[in_strata_order_ind]
  all_melt_df <- do.call("rbind",in_df_list)
  all_melt_df$stratum <- factor(all_melt_df$stratum,
                                levels=unique(all_melt_df$stratum))
  p_cohort <- ggplot(all_melt_df) + 
    ggplot2::geom_bar(aes_string(x="sig",y="exposure",fill="sig",
                                              size=0.3),
                      stat='identity',position="dodge",width=.7) + 
    scale_fill_manual(name="sig",labels=in_signatures_ind_df$sig,
                      values=in_signatures_ind_df$colour) +
    geom_errorbar(aes_string(x="sig",ymin="exposure_min",ymax="exposure_max"),
                  width=0.5) +
    facet_wrap(~stratum,ncol=1) +
    theme(axis.title.y=element_blank(),
          panel.background = element_rect(fill=NA, colour="black"),
          panel.border=element_rect(fill=NA, colour="black"),
          strip.background=element_rect(colour="black")) +
    guides(size=FALSE)
  return(p_cohort)
}


#' Plot results of the Stratification of a Mutational Catalogue
#'
#' Plot a big composite figure with 3 columns: in the left column the per-PID
#' absolute exposures will be shown, in the middle column the per_PID relative
#' or normalized exposures will be shown, in the right column the cohort-wide
#' exposures are shown (averaged over PIDs).
#'
#' @param number_of_strata Number of strata as deduced from \code{link{SMC}}
#' @param output_path Path to file where the results are going to be stored.
#'  If NULL, the results will be plotted to the running environment.
#' @param decomposition_method String for the filename of the generated 
#'  barplot.
#' @param number_of_sigs Number of signatures
#' @param name_list Names of the contructed strata.
#' @param exposures_strata_list The list of \code{s} strata specific exposures
#'   Hi, all are numerical data frames with \code{l} rows and \code{m} columns,
#'   \code{l} being the number of signatures and \code{m} being the number of
#'   samples
#' @param this_signatures_ind_df A data frame containing meta information about
#'   the signatures
#' @param this_subgroups_df A data frame indicating which PID (patient or 
#'   sample identifyier) belongs to which subgroup
#' @param in_strata_order_ind Index vector defining reordering of the strata
#' @param exposures_both_rel_df_list A list of \code{s} strata specific
#'   cohortwide (i.e. averaged over cohort) normalized exposures
#' @param cohort_method_flag Either or several of
#'   \code{c("all_PIDs","cohort","norm_PIDs")}, representing alternative ways 
#'   to average over the cohort.
#' @param fig_width Width of the figure to be plotted
#' @param fig_height Height of the figure to be plotted
#' @param fig_type png or pdf
#' @param in_label_orientation Whether or not to turn the labels on the x-axis.
#' @param this_sum_ind Optional set of indices for reordering the PIDs
#'
#' @examples
#' NULL
#'
#' @return The function doesn't return any value.
#'
#' @importFrom grDevices pdf png dev.off
#' @import ggplot2
#' @import grid
#' @import gridExtra
#' @export
#' 
plot_SMC <- function(number_of_strata,output_path,decomposition_method,
                     number_of_sigs,name_list,
                     exposures_strata_list,this_signatures_ind_df,
                     this_subgroups_df,
                     in_strata_order_ind,exposures_both_rel_df_list,
                     cohort_method_flag,
                     fig_width=1200,fig_height=900,fig_type="png",
                     in_label_orientation="turn",this_sum_ind=NULL) {
  my_strata_order_ind <- c(1,in_strata_order_ind+1)
  in_abs_df_list <- 
    add_as_fist_to_list(exposures_strata_list$sub_exposures_list,
                        exposures_strata_list$exposures_all_df)
  in_rel_df_list <- 
    add_as_fist_to_list(exposures_strata_list$sub_norm_exposures_list,
                        exposures_strata_list$norm_exposures_all_df)
  in_name_list <- c("all",name_list)
  p_all <- plot_SMC_PID_facet(in_abs_df_list,in_rel_df_list,
                              this_signatures_ind_df,this_subgroups_df,
                              in_name_list,in_sum_ind=this_sum_ind,
                              in_subgroups.field="subgroup",
                              in_strata_order_ind=my_strata_order_ind,
                              in_label_orientation=in_label_orientation)
  p_all_no_legend <- p_all + guides(fill=FALSE)  
  p_all_short <- p_all +
    theme(axis.text.x=element_blank(),
          axis.ticks.x=element_blank(),
          axis.title.x=element_blank())
  p_all_short_no_legend <- p_all_short + guides(fill=FALSE)
  p_cohort <- plot_group_facet(exposures_both_rel_df_list,
                               in_name_list,this_signatures_ind_df,
                               in_strata_order_ind=my_strata_order_ind)
  p_cohort_comb <- p_cohort + theme(strip.text=element_blank())
  p_cohort_short <- p_cohort_comb +
    theme(axis.text.x=element_blank(),
          axis.ticks.x=element_blank(),
          axis.title.x=element_blank())    
  if(!is.null(output_path)){
    if(fig_type=="png") png(output_path,width=fig_width,height=fig_height)
    else if(fig_type=="pdf") pdf(output_path,width=fig_width,height=fig_height)
  }
  grid.newpage()
  pushViewport(viewport(layout = grid.layout(nrow =1, ncol = 14)))
  if(in_label_orientation=="turn"){
    print(p_all_short_no_legend, vp = vplayout(1, c(1:10)))
    print(p_cohort_short, vp = vplayout(1, c(11:14)))    
  } else {
    print(p_all_no_legend, vp = vplayout(1, c(1:10)))
    print(p_cohort_comb, vp = vplayout(1, c(11:14)))
  }
  if(!is.null(output_path)){
    dev.off()
  }
  return(list(p_all=p_all,p_cohort=p_cohort))
}


stat_plot_subgroups_old <- function(in_exposures_df,in_subgroups_df,
                                    in_signatures_ind_df,
                                    in_subgroups.field="subgroup",
                                    in_PID.field="PID"){
  plots_per_row <- 4
  # split the data with custom function
  exposures_df_list <- split_exposures_by_subgroups(
    in_exposures_df=in_exposures_df,in_subgroups_df=in_subgroups_df,
    in_subgroups.field=in_subgroups.field,
    in_PID.field=in_PID.field)
  # compute statistical quantities to be displayed
  plot_df_list <- lapply(exposures_df_list, FUN=function(x) {
    average_vec <- average_over_present(x,1)
    SEM_vec <- stderrmean_over_present(x,1)
    max_vec <- average_vec + SEM_vec
    min_vec <- average_vec - SEM_vec
    out_df <- data.frame(index=factor(seq_len(length(average_vec))),
                         mean=average_vec,SEM=SEM_vec,
                         max=max_vec,min=min_vec)
    return(out_df)
  })
  # make similar data frame without splitting into subgroups
  average_vec <- average_over_present(in_exposures_df,1)
  SEM_vec <- stderrmean_over_present(in_exposures_df,1)
  max_vec <- average_vec + SEM_vec
  min_vec <- average_vec - SEM_vec
  plot_df_all <- data.frame(index=factor(seq_len(length(average_vec))),
                            mean=average_vec,SEM=SEM_vec,
                            max=max_vec,min=min_vec)
  all_ind <- length(plot_df_list)+1
  plot_df_list[[all_ind]] <- plot_df_all
  names(plot_df_list)[all_ind] <- "all"
  # make the plots
  plot_list_subgroups <- list()
  for(i in seq_len(length(plot_df_list))){
    temp_df <- plot_df_list[[i]]
    plot_list_subgroups[[i]] <- ggplot() + 
      ggplot2::geom_bar(data=temp_df,aes_string(x="index",y="mean",
                                                fill="index", size=0.3),
                        stat='identity',position="dodge",width=.7) + 
      scale_fill_manual(name="sig",labels=in_signatures_ind_df$sig,
                        values=in_signatures_ind_df$colour) +
      geom_errorbar(data=temp_df,aes_string(x="index",ymin="min",ymax="max"),
                    width=0.5) +
      labs(x="",y="",title=names(plot_df_list)[i]) +
      theme(axis.text.x = element_blank(), axis.ticks.x = element_blank(), 
            legend.position = "none")    
  }
  # order the plots to fit nicely in big panel
  number_of_subgroups <- length(plot_df_list)
  numer_of_rows <- ceiling(number_of_subgroups/plots_per_row)
  grid.newpage()
  pushViewport(viewport(layout = grid.layout(nrow = numer_of_rows, 
                                             ncol = plots_per_row)))
  for(i in seq_len(length(plot_df_list))){
    my_row <- ceiling(i/plots_per_row)
    my_col <- i-((my_row-1)*plots_per_row)
    print(plot_list_subgroups[[i]], vp = vplayout(my_row, my_col))    
  }
}


#' Plot averaged signature exposures per subgroup
#'
#' Plot one averaged signature exposure pattern per subgroup. Uses
#' \code{\link{split_exposures_by_subgroups}}.
#'
#' @param in_exposures_df Numerical data frame of the exposures (i.e.
#'   contributions of the different signatures to the number of point mutations
#'   per PID)
#' @param in_signatures_ind_df Data frame carrying additional information on the
#'   signatures
#' @param in_subgroups_df Data frame indicating which PID belongs to which
#'   subgroup
#' @param in_subgroups.field Name indicating which column in
#'   \code{in_subgroups_df} contains the subgroup information
#' @param in_PID.field Name indicating which column in \code{in_subgroups_df}
#'   contains the PID information
#' @param in_colour_vector If non-null, specifies the colours attributed to the
#'   subgroups
#'
#' @return The function doesn't return any value, it plots instead.
#'
#' @seealso \code{\link{split_exposures_by_subgroups}}
#'
#' @examples
#'  NULL
#'
#' @importFrom grDevices rainbow
#' @export
#' 
stat_plot_subgroups <- function(in_exposures_df,in_subgroups_df,
                                in_signatures_ind_df,
                                in_subgroups.field="subgroup",
                                in_PID.field="PID",
                                in_colour_vector=NULL){
  .e <- environment()
  plots_per_row <- 4
  # split the data with custom function
  exposures_df_list <- split_exposures_by_subgroups(
    in_exposures_df=in_exposures_df,in_subgroups_df=in_subgroups_df,
    in_subgroups.field=in_subgroups.field,
    in_PID.field=in_PID.field)
  number_of_subgroups <- length(exposures_df_list)
  # compute statistical quantities to be displayed
  my_sig_names <- rownames(exposures_df_list[[1]])
  plot_df_list <- lapply(exposures_df_list, FUN=function(x) {
    average_vec <- average_over_present(x,1)
    SEM_vec <- stderrmean_over_present(x,1)
    max_vec <- average_vec + SEM_vec
    min_vec <- average_vec - SEM_vec
    out_df <- data.frame(index=factor(seq_len(length(average_vec))),
                         mean=average_vec,SEM=SEM_vec,
                         max=max_vec,min=min_vec,
                         sig=my_sig_names)
    return(out_df)
  })
  # make similar data frame without splitting into subgroups
  average_vec <- average_over_present(in_exposures_df,1)
  SEM_vec <- stderrmean_over_present(in_exposures_df,1)
  max_vec <- average_vec + SEM_vec
  min_vec <- average_vec - SEM_vec
  plot_df_all <- data.frame(index=factor(seq_len(length(average_vec))),
                            mean=average_vec,SEM=SEM_vec,
                            max=max_vec,min=min_vec,
                            sig=my_sig_names)
  plot_df_list <- add_as_fist_to_list(plot_df_list,plot_df_all)
  names(plot_df_list)[1] <- "all"
  for(my_stratum in names(plot_df_list)){
    plot_df_list[[my_stratum]]$subgroup <- my_stratum  
  }
  plot_df <- do.call(rbind,plot_df_list)
  plot_df$subgroup <- factor(plot_df$subgroup,
                         levels=unique(plot_df$subgroup))
  plot_df$sig <- factor(plot_df$sig,levels=unique(plot_df$sig))
  # make the plots
  p <- ggplot(plot_df,environment=.e) +
    geom_bar(aes_string(x="sig",y="mean",fill="sig",size=0.3),
             stat='identity',position="dodge",width=.7) +
    scale_fill_manual(name="sig",labels=in_signatures_ind_df$sig,
                      values=in_signatures_ind_df$colour) +
    geom_errorbar(aes_string(x="sig",ymin="min",ymax="max"),width=0.5) +
    facet_wrap(~subgroup)+
    theme(axis.title.x=element_blank(),
          axis.text.x=element_blank(),
          axis.ticks.x=element_blank(),
          axis.title.y=element_blank(),
          panel.background = element_rect(fill=NA, colour="black"),
          panel.border=element_rect(fill=NA, colour="black")) +
    guides(size=FALSE)
  p1 <- p + theme(strip.background=element_rect(colour="black"))
  # display as dodged barplots
  my_palette <- c("black",rainbow(number_of_subgroups))
  names(my_palette) <- unique(plot_df$subgroup)
  if(!is.null(in_colour_vector)){
    match_ind <- match(names(in_colour_vector),names(my_palette))
    my_palette[match_ind] <- in_colour_vector
  }
  q <- ggplot(plot_df,environment=.e,
              aes_string(x="sig",y="mean",group="subgroup")) +
    geom_bar(aes_string(fill="sig",col="subgroup",size=0.3),
             stat='identity',position="dodge",width=.7,size=1) +
    scale_fill_manual(name="sig",labels=in_signatures_ind_df$sig,
                      values=in_signatures_ind_df$colour) +
    scale_colour_manual(values=my_palette) +
    geom_errorbar(aes(ymin=min,ymax=max),width=0.5,
                  position=position_dodge(width=0.7)) +
    theme(axis.title.x=element_blank(),
          axis.text.x=element_blank(),
          axis.ticks.x=element_blank(),
          axis.title.y=element_blank(),
          panel.background = element_rect(fill=NA, colour="black"),
          panel.border=element_rect(fill=NA, colour="black")) +
    guides(size=FALSE)
  plot_df <- plot_df[which(plot_df$subgroup != "all"),]
  r <- ggplot(plot_df,environment=.e,
              aes_string(x="sig",y="mean",group="subgroup")) +
    geom_bar(aes_string(fill="subgroup",size=0.3),
             stat='identity',position="dodge",width=.7,size=1) +
    scale_fill_manual(name="subgroup",
                      values=my_palette) +
    geom_errorbar(aes(ymin=min,ymax=max),width=0.5,
                  position=position_dodge(width=0.7)) +
    labs(y = "exposures", x = "signatures") + 
    theme(panel.background = element_rect(fill=NA, colour="black"),
          panel.border=element_rect(fill=NA, colour="black")) +
    guides(size=FALSE)
  return(list(facet_plot = p1, dodged_plot = q, dodgedSimple_plot = r))
}



#' Cluster the PIDs according to their signature exposures
#'
#' The PIDs are clustered according to their signature exposures by calling
#' first creating a distance matrix: \itemize{ \item \code{\link{dist}}, then
#' \item \code{\link{hclust}} and then \item
#' \code{\link[dendextend]{labels_colors}} to colour the labels (the text) of
#' the leaves in the dendrogram. } Typically one colour per subgroup.
#'
#' @param in_exposures_df Numerical data frame encoding the exposures \code{H},
#'   i.e. which signature contributes how much to which PID (patient identifier
#'   or sample).
#' @param in_subgroups_df A data frame indicating which PID (patient or sample
#'   identifyier) belongs to which subgroup
#' @param in_method Method of the clustering to be supplied to
#'   \code{\link{dist}}. Can be either of: \code{euclidean}, \code{maximum},
#'   \code{manhattan}, \code{canberra}, \code{binary} or \code{minkowski}
#' @param in_subgroup_column Indicates the name of the column in which the
#'   subgroup information is encoded in \code{in_subgroups_df}
#' @param in_palette Palette with colours or colour codes for the labels (the
#'   text) of the leaves in the dendrogram. Typically one colour per subgroup.
#'   If none is specified, a rainbow palette of the length of the number of
#'   subgroups will be used as default.
#' @param in_cutoff A numeric value less than 1. Signatures from within \code{W}
#'   with an overall exposure less than \code{in_cutoff} will be discarded for
#'   the clustering.
#' @param in_filename A path to save the dendrogram. If none is specified, the
#'   figure will be plotted to the running environment.
#' @param in_shift_factor Graphical parameter to adjust figure to be created
#' @param in_cex Graphical parameter to adjust figure to be created
#' @param in_title Title in the figure to be created under \code{in_filename}
#' @param in_plot_flag Whether or not to display the dendrogram
#'
#' @return A list with entries \code{hclust} and \code{dendrogram}. \itemize{
#'   \item \code{hclust}: The object created by \code{\link{hclust}} \item
#'   \code{dendrogram}: The above object wrapped in \code{\link{as.dendrogram}}
#'   }
#'
#' @examples
#'  data(lymphoma_cohort_LCD_results)
#'  hclust_exposures(rel_lymphoma_Nature2013_COSMIC_cutoff_exposures_df,
#'                   COSMIC_subgroups_df,
#'                   in_method="manhattan",
#'                   in_subgroup_column="subgroup")
#'
#' @seealso \code{\link{hclust}}
#' @seealso \code{\link{dist}}
#' @seealso \code{\link[dendextend]{labels_colors}}
#'
#' @importFrom grDevices rainbow png dev.off
#' @import dendextend
#' @export
#' 
hclust_exposures <- function(in_exposures_df,in_subgroups_df,
                             in_method="manhattan",
                             in_subgroup_column="subgroup",
                             in_palette=NULL,in_cutoff=0,in_filename=NULL,
                             in_shift_factor=0.3,in_cex=0.2,in_title="",
                             in_plot_flag=FALSE) {
  ## 1. choose only signatures with exposures above cutoff
  exposures_sum_df <- data.frame(sum=apply(in_exposures_df,1,sum))
  exposures_sum_df$sum_norm <- exposures_sum_df$sum/sum(exposures_sum_df$sum)
  sig_choice_ind <- which(exposures_sum_df$sum_norm >= in_cutoff)
  reduced_exposures_df <- in_exposures_df[sig_choice_ind,]
  ## 2. adapt for hierarchic clustering
  my_exposures_df <- as.data.frame(t(reduced_exposures_df))
  ## 3. run clustering
  my_exposures_hierarchy <- hclust(dist(my_exposures_df,method=in_method))
  my_exposures_hc <- as.dendrogram(my_exposures_hierarchy)
  ## 4. colour the labels of the leaves according to subgroups
  subgroup_column_index <- 
    which(tolower(names(in_subgroups_df))==tolower(in_subgroup_column))
  number_of_subgroups <- 
    length(unique(in_subgroups_df[,subgroup_column_index]))
  if(is.null(in_palette)){
    in_palette=rainbow(number_of_subgroups)
  }
  colorCodes <- in_palette[seq_len(number_of_subgroups)]
  labels_colors(my_exposures_hc) <- 
    colorCodes[factor(in_subgroups_df[,subgroup_column_index])][
      order.dendrogram(my_exposures_hc)]
  ## 5. prepare for plotting and plot
  max_height <- max(my_exposures_hierarchy$height)
  if (!is.null(in_filename)) {
    png(in_filename,width=1000,height=400)
    plot(my_exposures_hc,cex=in_cex,
         ylim=c((-1)*in_shift_factor*max_height,max_height),
         main=in_title)
    dev.off()    
  }
  if(in_plot_flag) plot(my_exposures_hc,cex=in_cex,
                        ylim=c((-1)*in_shift_factor*max_height,max_height),
                        main=in_title)
  return(list(hclust=my_exposures_hierarchy,dendrogram=my_exposures_hc))
}


#' Heatmap to cluster the PIDs on their signature 
#' exposures (ComplexHeatmap)
#'
#' The PIDs are clustered according to their signature exposures. uses package
#' \pkg{ComplexHeatmap} by Zuguang Gu. This function calls: \itemize{ \item
#' \code{\link[ComplexHeatmap]{rowAnnotation}}, \item
#' \code{\link[ComplexHeatmap]{HeatmapAnnotation}} and \item
#' \code{\link[ComplexHeatmap]{Heatmap}} }
#'
#' @param in_exposures_df Numerical data frame encoding the exposures \code{H},
#'   i.e. which signature contributes how much to which PID (patient identifier
#'   or sample).
#' @param in_subgroups_df A data frame indicating which PID (patient or sample
#'   identifyier) belongs to which subgroup
#' @param in_signatures_ind_df A data frame containing meta information about
#'   the signatures, especially the asserted colour
#' @param in_data_type Title in the figure
#' @param in_method Method of the clustering to be supplied to
#'   \code{\link{dist}}. Can be either of: \code{euclidean}, \code{maximum},
#'   \code{manhattan}, \code{canberra}, \code{binary} or \code{minkowski}
#' @param in_subgroup_column Indicates the name of the column in which the
#'   subgroup information is encoded in \code{in_subgroups_df}
#' @param in_subgroup_colour_column Indicates the name of the column in which
#'   the colour information for subgroups is encoded in \code{in_subgroups_df}.
#'   If NULL, a rainbow palette is used instead.
#' @param in_palette Palette with colours for the heatmap. Default is
#'   \code{colorRamp2(c(0, 0.2, 0.4, 0.6), c('white','yellow','orange','red'))}
#' @param in_cutoff A numeric value less than 1. Signatures from within \code{W}
#'   with an overall exposure less than \code{in_cutoff} will be discarded for
#'   the clustering.
#' @param in_filename A path to save the heatmap. If none is specified, the
#'   figure will be plotted to the running environment.
#' @param in_column_anno_borders Whether or not to draw separating lines between
#'   the fields in the annotation
#' @param in_row_anno_borders Whether or not to draw separating lines between
#'   the fields in the annotation
#'
#' @details It might be necessary to install the newest version of the
#' development branch of the packages \pkg{circlize} and \pkg{ComplexHeatmap} by
#' Zuguang Gu: \code{devtools::install_github("jokergoo/circlize")} and
#' \code{devtools::install_github("jokergoo/ComplexHeatmap")}
#'
#' @return The function doesn't return any value.
#'
#' @examples
#'  data(lymphoma_cohort_LCD_results)
#'  complex_heatmap_exposures(
#'    rel_lymphoma_Nature2013_COSMIC_cutoff_exposures_df,
#'    COSMIC_subgroups_df,
#'    chosen_signatures_indices_df,
#'    in_data_type="norm exposures",
#'    in_subgroup_colour_column="col",
#'    in_method="manhattan",
#'    in_subgroup_column="subgroup")
#'
#' @seealso \code{\link[ComplexHeatmap]{Heatmap}}
#'
#' @import ComplexHeatmap
#' @import circlize
#' @export
#' 
complex_heatmap_exposures <- function(in_exposures_df,in_subgroups_df,
                                      in_signatures_ind_df,
                                      in_data_type="norm exposures",
                                      in_method="manhattan",
                                      in_subgroup_column="subgroup",
                                      in_subgroup_colour_column=NULL,
                                      in_palette=colorRamp2(c(0,0.2,0.4,0.6),
                                                            c('white','yellow',
                                                              'orange','red')),
                                      in_cutoff=0,in_filename=NULL,
                                      in_column_anno_borders=FALSE,
                                      in_row_anno_borders=FALSE){
  if(!in_row_anno_borders){
    row_anno = rowAnnotation(
      df = data.frame(signature = in_signatures_ind_df$index),
      col = list(signature = structure(
        in_signatures_ind_df$colour, 
        names = as.character(in_signatures_ind_df$index))),
      show_legend = FALSE)
  } else {  
    row_anno = rowAnnotation(
      df = data.frame(signature = in_signatures_ind_df$index),
      col = list(signature = structure(
        in_signatures_ind_df$colour, 
        names = as.character(in_signatures_ind_df$index))),
      show_legend = FALSE,
      gp = gpar(col="black"))
  }
  if(!in_column_anno_borders){
    column_anno = HeatmapAnnotation(
      df = data.frame(subtype = in_subgroups_df[[in_subgroup_column]]), 
      col = list(subtype = structure(
        unique(in_subgroups_df[[in_subgroup_colour_column]]),
        names = unique(in_subgroups_df[[in_subgroup_column]]))))
  } else {
    column_anno = HeatmapAnnotation(
      df = data.frame(subtype = in_subgroups_df[[in_subgroup_column]]), 
      col = list(subtype = structure(
        unique(in_subgroups_df[[in_subgroup_colour_column]]),
        names = unique(in_subgroups_df[[in_subgroup_column]]))),
      gp = gpar(col="black"))   
  }
  ht_list = row_anno + Heatmap(
    in_exposures_df, col = in_palette,
    top_annotation = column_anno, 
    clustering_distance_rows = in_method,
    clustering_distance_columns = in_method,
    heatmap_legend_param = list(title = in_data_type))
    #draw(ht_list, row_dend_side = 'left')
    draw(ht_list)
}


#' Heatmap to cluster the PIDs on their signature 
#' exposures (ComplexHeatmap)
#'
#' The PIDs are clustered according to their signature exposures. The procedure
#' is analogous to \code{\link{complex_heatmap_exposures}}, but enabling more
#' than one annotation row for the PIDs. This function calls: \itemize{ \item
#' \code{\link[ComplexHeatmap]{rowAnnotation}}, \item
#' \code{\link[ComplexHeatmap]{HeatmapAnnotation}} and \item
#' \code{\link[ComplexHeatmap]{Heatmap}} }
#'
#' @param in_exposures_df Numerical data frame encoding the exposures \code{H},
#'   i.e. which signature contributes how much to which PID (patient identifier
#'   or sample).
#' @param in_annotation_df A data frame indicating which PID (patient or sample
#'   identifyier) belongs to which subgroup for all layers of annotation
#' @param in_annotation_col A list indicating colour attributions for all layers
#'   of annotation
#' @param in_signatures_ind_df A data frame containing meta information about
#'   the signatures, especially the asserted colour
#' @param in_data_type Title in the figure
#' @param in_method Method of the clustering to be supplied to
#'   \code{\link{dist}}. Can be either of: \code{euclidean}, \code{maximum},
#'   \code{manhattan}, \code{canberra}, \code{binary} or \code{minkowski}
#' @param in_palette Palette with colours or colour codes for the heatmap.
#'   Default is \code{colorRamp2(c(0, 0.2, 0.4, 0.6),
#'   c('white','yellow','orange','red'))}
#' @param in_cutoff A numeric value less than 1. Signatures from within \code{W}
#'   with an overall exposure less than \code{in_cutoff} will be discarded for
#'   the clustering.
#' @param in_filename A path to save the heatmap. If none is specified, the
#'   figure will be plotted to the running environment.
#' @param in_column_anno_borders Whether or not to draw separating lines between
#'   the fields in the annotation
#' @param in_row_anno_borders Whether or not to draw separating lines between
#'   the fields in the annotation
#' @param in_show_PIDs Whether or not to show the PIDs on the x-axis
#' @param in_annotation_legend_side Where to put the legends of the annotation
#'   df, default is right.
#'
#' @details One additional parameter, in_show_legend_bool_vector, indicating
#' which legends to display, is planned but deactivated in this version of the
#' package. In order to use this features, it will be necessary to install the
#' newest version of the packages \pkg{circlize} and \pkg{ComplexHeatmap} by
#' Zuguang Gu: \code{devtools::install_github("jokergoo/circlize")} and
#' \code{devtools::install_github("jokergoo/ComplexHeatmap")}
#'
#' @return The function doesn't return any value.
#'
#' @examples
#'  NULL
#'
#' @seealso \code{\link[ComplexHeatmap]{Heatmap}}
#' @seealso \code{\link{complex_heatmap_exposures}}
#'
#' @import ComplexHeatmap
#' @import circlize
#' @export
#' 
annotation_heatmap_exposures <- 
  function(in_exposures_df, in_annotation_df, in_annotation_col,
           in_signatures_ind_df, in_data_type="norm exposures",
           in_method="manhattan",
           in_palette=colorRamp2(c(0,0.2,0.4,0.6), 
                                 c('white','yellow', 'orange','red')),
           in_cutoff=0,in_filename=NULL, in_column_anno_borders=FALSE,
           in_row_anno_borders=FALSE, in_show_PIDs=TRUE,
           in_annotation_legend_side="right"#,
           #in_show_legend_bool_vector=rep(TRUE,length(in_annotation_col))
  ){
  if(!in_row_anno_borders){
    row_anno = rowAnnotation(
      df = data.frame(signature = in_signatures_ind_df$index),
      col = list(signature = structure(
        in_signatures_ind_df$colour, 
        names = as.character(in_signatures_ind_df$index))),
      show_legend = FALSE)        
  } else {
    row_anno = rowAnnotation(
      df = data.frame(signature = in_signatures_ind_df$index),
      col = list(signature = structure(
        in_signatures_ind_df$colour, 
        names = as.character(in_signatures_ind_df$index))),
      show_legend = FALSE,
      gp = gpar(col="black"))    
  }
  if(!in_column_anno_borders){
    column_anno = HeatmapAnnotation(
      df = in_annotation_df, 
      col = in_annotation_col#,
      #show_legend=in_show_legend_bool_vector,
      #show_annotation_name=TRUE,
      #annotation_name_offset=unit(2,"mm")
      )
  } else {
    column_anno = HeatmapAnnotation(
      df = in_annotation_df, 
      col = in_annotation_col,
      gp = gpar(col="black")#,
      #show_legend=in_show_legend_bool_vector,
      #show_annotation_name=TRUE,
      #annotation_name_offset=unit(2,"mm")
      )    
  }
  if(in_show_PIDs){
    ht_list = row_anno + Heatmap(
      in_exposures_df, col = in_palette,
      top_annotation = column_anno, 
      clustering_distance_rows = in_method,
      clustering_distance_columns = in_method,
      heatmap_legend_param = list(title = in_data_type))
  } else {
    ht_list = row_anno + Heatmap(
      in_exposures_df, col = in_palette,
      top_annotation = column_anno, 
      clustering_distance_rows = in_method,
      clustering_distance_columns = in_method,
      heatmap_legend_param = list(title = in_data_type),
      show_column_names = FALSE)
  }
  draw(ht_list, row_dend_side = 'left',
       annotation_legend_side=in_annotation_legend_side)
}




preprocess_VRanges <- function(in_rainfall_dat, in_CHROM.field, in_POS.field, 
                               in_dist.field, in_col.field){
  if(!(in_dist.field %in% names(mcols(in_rainfall_dat)))){
    in_rainfall_dat <- annotate_intermut_dist_PID(in_rainfall_dat)
  }
  choice_column_vector <- c("seqnames", "start", "ref", "alt",
                            "dist", in_col.field)
  in_rainfall_dat <- as.data.frame(in_rainfall_dat)
  colum_names <- intersect(names(in_rainfall_dat), choice_column_vector)
  in_rainfall_dat <- in_rainfall_dat[,colum_names]
  names(in_rainfall_dat) <- 
    gsub("dist", in_dist.field, names(in_rainfall_dat))
  names(in_rainfall_dat) <- 
    gsub("seqnames", in_CHROM.field, names(in_rainfall_dat))
  names(in_rainfall_dat) <- 
    gsub("start", in_POS.field, names(in_rainfall_dat))
  names(in_rainfall_dat) <- gsub("ref", "REF", names(in_rainfall_dat))
  names(in_rainfall_dat) <- gsub("alt", "ALT", names(in_rainfall_dat))
  return(in_rainfall_dat)
}

preprocess_data.frame <- function(in_rainfall_dat,
                                  in_CHROM.field, 
                                  in_POS.field, 
                                  in_dist.field){
  if(!(in_dist.field %in% names(in_rainfall_dat))){
    in_rainfall_dat <- 
      annotate_intermut_dist_PID(in_rainfall_dat, 
                                 in_CHROM.field = in_CHROM.field,
                                 in_POS.field = in_POS.field)
    names(in_rainfall_dat) <- 
      gsub("dist", in_dist.field, names(in_rainfall_dat))
  }
  return(in_rainfall_dat)
}

add_rectangles_track <- function(in_rect_list, track, in_show_labels = FALSE){
  for(i in seq_len(length(in_rect_list))){
    temp_list <- in_rect_list[[i]]
    temp_color <- temp_list$col
    if(inherits(temp_list$df, "data.frame")) temp_df <- temp_list$df
    else if(inherits(temp_list$df, "GRanges")){
      temp_df <- as.data.frame(temp_list$df)
    }
    temp_alpha <- temp_list$alpha
    add_track(temp_df, track = track, panel_fun = function(gr) {
      grid.rect(gr[[2]], unit(0, "npc"), width=gr[[4]], 
                height=unit(1, "npc"), default.units = "native", 
                hjust=0, vjust=0, 
                gp = gpar(col=temp_color,fill =temp_color,alpha=temp_alpha))
      if(in_show_labels){
        grid.text(rownames(gr), gr[[2]], unit(0, "npc"), rot = 90,
                  default.units = "native", just = "bottom")
      }
    })
  }
}

add_rainfalls_track <- function(rainfall_dat, track, in_point_size){
  add_track(rainfall_dat, track = track, panel_fun = function(gr) {
    x = gr[[2]]
    y = log10(gr[[3]])
    grid.points(x, y, pch = 16, size = in_point_size, gp = gpar(col = gr[[4]]))
  }) 
}

#'Create a rainfall plot in a trellis structure
#'
#'A trellis is a plot structure which allows space optimized multi-panel multi
#'track plots. This function uses the package \pkg{gtrellis} developed by
#'Zuguang Gu, also available at
#'\url{https://www.bioconductor.org/packages/release/bioc/html/gtrellis.html}.
#'The graphics in the tracks within a gtrellis plot are mostly drawn with
#'functions from the package \pkg{grid}. Note that for technical reasons, the
#'column indicating the chromosome MUST have the name \emph{chr} and be the
#'first column in the data frame supplied to the gtrellis functions. Therefore
#'reformatting is performed in this function before calling gtrellis functions.
#'
#'@param in_rainfall_dat Data frame which has to contain at least columns for
#'  chromosome, position, intermutational distance and colour information
#'@param in_point_size size of the points in the rainfall plot to be created has
#'  to be provided with appropriate units, e.g. in_point_size=unit(0.5,"mm")
#'@param in_rect_list Optional argument, if present, will lead to highlighting
#'  of specified regions by coloured but transparent rectangles
#'@param in_title Title in the figure to be created.
#'@param in_CHROM.field String indicating which column of \code{in_rainfall_dat}
#'  carries the chromosome information
#'@param in_POS.field String indicating which column of \code{in_rainfall_dat}
#'  carries the position information
#'@param in_dist.field String indicating which column of \code{in_rainfall_dat}
#'  carries the intermutational distance information
#'@param in_col.field String indicating which column of \code{in_rainfall_dat}
#'  carries the colour information encoding the nucleotide exchange
#'
#'@return The function doesn't return any value.
#'
#'
#'@return The function doesn't return any value.
#'
#' @examples
#'  data(lymphoma_test)
#'  choice_PID <- "4121361"
#'  PID_df <- subset(lymphoma_test_df,PID==choice_PID)
#'  trellis_rainfall_plot(PID_df,in_point_size=unit(0.5,"mm"))
#'
#'
#'@seealso \code{\link[gtrellis]{gtrellis_layout}}
#'@seealso \code{\link[gtrellis]{add_track}}
#'@seealso \code{\link[grid]{grid.points}}
#'
#'@import gtrellis
#'@export
#'
trellis_rainfall_plot <- function(in_rainfall_dat,
                                  in_point_size=unit(1,"mm"),
                                  in_rect_list=NULL,
                                  in_title="",
                                  in_CHROM.field="CHROM",
                                  in_POS.field="POS",
                                  in_dist.field="dist",
                                  in_col.field="col") {
  # account for input data type
  if(inherits(in_rainfall_dat, "VRanges")) {
    if(!(in_dist.field %in% names(mcols(in_rainfall_dat)))){
      in_rainfall_dat <- annotate_intermut_dist_PID(in_rainfall_dat)
    }
    choice_column_vector <- c("seqnames", "start", "ref", "alt",
                              "dist", in_col.field)
    in_rainfall_dat <- as.data.frame(in_rainfall_dat)
    colum_names <- intersect(names(in_rainfall_dat),choice_column_vector)
    in_rainfall_dat <- in_rainfall_dat[,colum_names]
    names(in_rainfall_dat) <- 
      gsub("dist", in_dist.field, names(in_rainfall_dat))
    names(in_rainfall_dat) <- 
      gsub("seqnames", in_CHROM.field, names(in_rainfall_dat))
    names(in_rainfall_dat) <- 
      gsub("start", in_POS.field, names(in_rainfall_dat))
    names(in_rainfall_dat) <- gsub("ref", "REF", names(in_rainfall_dat))
    names(in_rainfall_dat) <- gsub("alt", "ALT", names(in_rainfall_dat))
  } else if(inherits(in_rainfall_dat, "data.frame")){
    if(!(in_dist.field %in% names(in_rainfall_dat))){
      in_rainfall_dat <- 
        annotate_intermut_dist_PID(in_rainfall_dat, 
                                   in_CHROM.field = in_CHROM.field,
                                   in_POS.field = in_POS.field)
      names(in_rainfall_dat) <- 
        gsub("dist", in_dist.field, names(in_rainfall_dat))
    }
  } else cat("YAPSA:::trellis_rainfall_plot::warning: Input is neither ",
             "a VRanges object nor a data frame")
  # attribute nucleotide exchanges
  if(!(in_col.field %in% names(in_rainfall_dat))){
    in_rainfall_dat$change <- attribute_nucleotide_exchanges(in_rainfall_dat)
    exchange_colour_vector <- 
      c("blue", "black", "red", "purple", "orange", "green")
    names(exchange_colour_vector) <- c("CA", "CG", "CT", "TA", "TC", "TG")
    in_rainfall_dat$col <- exchange_colour_vector[in_rainfall_dat$change]
    names(in_rainfall_dat) <- gsub("col", in_col.field, names(in_rainfall_dat))
  }
  my_alpha <- 0.1
  CHROM_ind <- which(names(in_rainfall_dat)==in_CHROM.field)
  POS_ind <- which(names(in_rainfall_dat)==in_POS.field)
  dist_ind <- which(names(in_rainfall_dat)==in_dist.field)
  col_ind <- which(names(in_rainfall_dat)==in_col.field)
  names(in_rainfall_dat)[CHROM_ind] <- "chr"
  rainfall_dat <- in_rainfall_dat[,c(CHROM_ind,POS_ind,dist_ind,col_ind)]
  gtrellis::gtrellis_layout(n_track = 1, ncol = 5, byrow = FALSE,
                  title=in_title,
                  track_axis = TRUE,
                  track_height = unit.c(unit(1, "null")), 
                  track_ylim = c(0, 8),
                  track_ylab = c("intermut dist"),
                  add_name_track = TRUE, add_ideogram_track = TRUE)
  ## draw partially transparent rectangular regions if desired
  if(!is.null(in_rect_list)){
    for(i in seq_len(length(in_rect_list))){
      temp_list <- in_rect_list[[i]]
      temp_color <- temp_list$col
      temp_df <- temp_list$df
      temp_alpha <- temp_list$alpha
      add_track(temp_df, track = 2, panel_fun = function(gr) {
        grid.rect(gr[[2]], unit(0, "npc"), width=gr[[4]], 
                  height=unit(1, "npc"), default.units = "native", 
                  hjust=0, vjust=0, 
                  gp = gpar(col=temp_color,fill =temp_color,alpha=temp_alpha))
      })
    }
  }
  # track for rainfall plots
  add_track(rainfall_dat, track = 2, panel_fun = function(gr) {
    x = gr[[2]]
    y = log10(gr[[3]])
    grid.points(x, y, pch = 16, size = in_point_size, gp = gpar(col = gr[[4]]))
  }) 
}

#' Plot the spectra of nucleotide exchanges
#'
#' Plots the spectra of nucleotide exchanges in their triplet contexts. If
#' several columns are present in the input data frame, the spectra are plotted
#' for every column separately.
#'
#' @param in_catalogue_df Numerical data frame encoding the exchange spectra to
#'   be displayed, either a mutational catalogue \code{V} or a signatures matrix
#'   \code{W}.
#' @param in_colour_vector Specifies the colours of the 6 nucleotide exchanges
#'   if non-null.
#' @param in_show_triplets Whether or not to show the triplets on the x-axis
#' @param in_show_axis_title Whether or not to show the name of the y-axis
#' @param in_scales Argument passed on to \code{\link[ggplot2]{facet_grid}}
#' @param in_refLine If non-null, value on the y-axis at which a horizontal line
#'   is to be drawn
#' @param in_refAlpha Transparency of the horizontal line if it is to be drawn
#' @param in_background Option to provide a background theme, e.g.
#'   \code{\link[ggplot2]{theme_grey}}
#'
#' @return The generated barplot - a ggplot2 plot
#'
#' @examples
#'  NULL
#'
#' @seealso \code{\link[ggplot2]{geom_bar}}
#' @seealso \code{\link[ggplot2]{facet_grid}}
#'
#' @import ggplot2
#' @import reshape2
#' @export
#' 
plotExchangeSpectra <- function(in_catalogue_df,
                                in_colour_vector = NULL,
                                in_show_triplets = FALSE,
                                in_show_axis_title = FALSE,
                                in_scales = "free_x",
                                in_refLine = NULL,
                                in_refAlpha = 0.5,
                                in_background = NULL){
  .e <- environment()
  in_catalogue_df$triplet_exchange <- rownames(in_catalogue_df)
  in_catalogue_df$nuc_exchange <- gsub(" .+$","",
                                       in_catalogue_df$triplet_exchange)
  in_catalogue_df$triplet <- gsub("^.+ ","",in_catalogue_df$triplet_exchange)
  catalogue_df_melt <- melt(in_catalogue_df,id.vars=c("nuc_exchange","triplet",
                                                      "triplet_exchange"))
  my_palette <- c("lightblue","black","red","grey","green","pink")
  names(my_palette) <- c("C>A","C>G","C>T","T>A","T>C","T>G")
  if(!is.null(in_colour_vector)) my_palette <- in_colour_vector
  p <- ggplot(catalogue_df_melt,environment=.e) +
    geom_bar(aes_string(x = "triplet", y = "value", fill = "nuc_exchange"),
             stat = 'identity') +
    scale_fill_manual(name = "exchange", values = my_palette) +
    facet_grid(variable~nuc_exchange, scales = in_scales)
  if(!is.null(in_background)){
    p <- p + in_background
  }
  if(is.numeric(in_refLine)){
    p <- p + geom_hline(yintercept = in_refLine, alpha = in_refAlpha)
  }
  p1 <- p +
    theme(axis.title.x = element_blank(),
          axis.text.x = element_blank(),
          axis.ticks.x = element_blank())
  if(in_show_triplets) {
    p1 <- p +
      theme(axis.title.x = element_blank(),
            axis.text.x = element_text(angle=90,vjust=0.5),
            axis.ticks.x = element_blank())
  }
  if(!in_show_axis_title) p1 <- p1 + theme(axis.title.y=element_blank())
  return(p1)
}

---
title: "1. Usage of YAPSA"
author: "Daniel Huebschmann"
date: "26/08/2015"
vignette: >
  %\VignetteIndexEntry{1. Usage of YAPSA}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}  
output:
  BiocStyle::html_document:
    toc: yes
references:
- author:
  - family: Alexandrov
    given: LB
  - family: Nik-Zainal
    given: S
  - family: Wedge
    given: DC
  - family: Aparicio
    given: SA
  - family: Behjati
    given: S
  - family: Biankin
    given: AV
  - family: Bignell
    given: GR
  - family: Bolli
    given: N
  - family: Borg
    given: A
  - family: Borresen-Dale
    given: AL
  - family: Boyault
    given: S
  - family: Burkhardt
    given: B
  - family: Butler
    given: AP
  - family: Caldas
    given: C
  - family: Davies
    given: HR
  - family: Desmedt
    given: C
  - family: Eils
    given: R
  - family: Eyfjörd
    given: JE
  - family: Greaves
    given: M
  - family: Hosoda
    given: F
  - family: Hutter
    given: B
  - family: Ilicic
    given: T
  - family: Imbeaud
    given: S
  - family: Imielinski
    given: M
  - family: Jäger
    given: N
  - family: Jones
    given: DT
  - family: Jones
    given: D
  - family: Knappskog
    given: S
  - family: Kool
    given: M
  - family: Lakhani
    given: SR
  - family: Lopez-Otin
    given: C
  - family: Martin
    given: S
  - family: Munshi
    given: NC
  - family: Nakamura
    given: H
  - family: Northcott
    given: PA
  - family: Pajic
    given: M
  - family: Papaemmanuil
    given: E
  - family: Paradiso
    given: A
  - family: Pearson
    given: JV
  - family: Puente
    given: XS
  - family: Raine
    given: K
  - family: Ramakrishna
    given: M
  - family: Richardson
    given: AL
  - family: Richter
    given: J
  - family: Rosenstiel
    given: P
  - family: Schlesner
    given: M
  - family: Schumacher
    given: TN
  - family: Span
    given: PN
  - family: Teague
    given: JW
  - family: Tokoti
    given: Y
  - family: Tutt
    given: AN
  - family: Valdes-Mas
    given: R
  - family: van Buuren
    given: MM
  - family: van't Veer
    given: L
  - family: Vincent-Salomon
    given: A
  - family: Waddell
    given: N
  - family: Yates
    given: LR
  - family: Australian Pancreatic Cancer Initiative
    given: 
  - family: ICGC Breast Cancer Consortium
    given: 
  - family: ICGC MMML-Seq Consortium
    given: 
  - family: ICGC PedBrain
    given: 
  - family: Zucman-Rossi
    given: J
  - family: Futreal
    given: PA
  - family: McDermott
    given: U
  - family: Lichter
    given: P
  - family: Meyerson
    given: M
  - family: Grimmond
    given: SM
  - family: Siebert
    given: R
  - family: Campo
    given: E
  - family: Shibata
    given: T
  - family: Pfister
    given: SM
  - family: Campbell
    given: PJ
  - family: Stratton
    given: MR
  container-title: Nature
  id: Alex2013
  issued:
    month: 8
    volume: 500
    year: 2013
  publisher: Nature Publishing Group
  title: 'Signatures of Mutational Processes in Cancer'
- author:
  - family: Alexandrov
    given: LB
  id: Alex_package2012
  issued:
    year: 2012
  title: 'WTSI Mutational Signature Framework'
- author:
  - family: Alexandrov
    given: LB
  - family: Nik-Zainal
    given: S
  - family: Wedge
    given: DC
  - family: Campbell
    given: PJ
  - family: Stratton
    given: MR
  container-title: Cell Reports
  id: Alex_CellRep2013
  issued:
    year: 2013
  title: > 
    Deciphering signatures of mutational processes operative in human cancer
- author:
  - family: Gehring
    given: Julian
  - family: Fischer
    given: Bernd
  - family: Lawrence
    given: Michael
  - family: Huber
    given: Wolfgang
  container-title: Bioinformatics
  id: Gehring_article2015
  issued:
    year: 2015
  publisher: Oxford Journals
  title: > 
    SomaticSignatures: inferring mutational signatures from single-nucleotide
    variants
- author:
  - family: Rosenthal
    given: Rachel
  - family: McGranahan
    given: Nicholas
  - family: Herrero
    given: Javier
  - family: Taylor
    given: Barry S.
  - family: Swanton
    given: Charles
  container-title: Genome Biology
  id: Rosenthal_2016
  issued:
    year: 2016
  publisher: BioMed Central
  title: > 
    DeconstructSigs: delineating mutational processes in single tumors 
    distinguishes DNA repair deficiencies and patterns of carcinoma evolution.
- author:
  - family: Wang
    given: Yong
  - family: Lawson
    given: Charles L.
  - family: Hanson
    given: Richard J
  container-title: R-package version 1.1-1
  id: lsei_package2015
  issued:
    year: 2015
  title: >
    lsei: Solving Least Squares Problems under Equality/Inequality Constraints
- author:
  - family: Gu
    given: Z
  - family: Eils
    given: R
  - family: Schlesner
    given: M
  container-title: Bioinformatics
  id: gtrellis2015
  issued:
      year: 2016
  title: 'gtrellis: an R/Bioconductor package for making genome-level Trellis graphics.'
- author:
  - family: Gu
    given: Z
  - family: Eils
    given: R
  - family: Schlesner
    given: M
  container-title: Bioinformatics
  id: Gu2016
  issued:
      year: 2016
  title: 'Complex heatmaps reveal patterns and correlations in multidimensional genomic data'
- author:
  - family: Raue
    given: Andreas
  - family: Kreutz 
    given: C.
  - family: Maiwald 
    given: T.
  - family: Bachmann 
    given: J.
  - family: Schilling
    given: M.
  - family: Klingmüller
    given: U.
  - family: Timmer
    given: J.
  container-title: Bioinformatics
  id: Raue_Bioinformatics2009
  issued:
      year: 2009
  title: >
    'Structural and practical identifiability analysis of partially observed 
    dynamical models by exploiting the profile likelihood.'
- author:
  - family: Alexandrov
    given: LB
  - family: Kim
    given: J
  - family: Haradhvala
    given: NJ
  - family: Huang
    given: MN
  - family: Ng
    given: AW
  - family: Boot
    given: A
  - family: Covington
    given: KR
  - family: Gordenin
    given: DA
  - family: Bergstrom
    given: E
  - family: Lopez-Bigas
    given: N
  - family: Klimczak
    given: LJ
  - family: McPherson
    given: JR
  - family: Morganella
    given: S
  - family: Sabarinathan
    given: R
  - family: Wheeler
    given: DA
  - family: Mustonen
    given: V
  - family: Getz
    given: G
  - family: Rozen
    given: SG
  - family: Stratton
    given: MR
  container-title: Nature
  id: Alex2020
  issued:
    month: 02
    year: 2020
  title: 'The Repertoire of Mutational Signatures in Human Cancer'
---

  
```{r load_style, warning=FALSE, message=FALSE, results="hide"}
library(BiocStyle)
```

# Introduction {#introduction}

The concept of mutational signatures was introduced in a series of papers by 
Ludmil Alexandrov et al. [@Alex2013] and [@Alex_CellRep2013]. A computational 
framework was published [@Alex_package2012] with the purpose to detect a 
limited number of mutational processes which then describe the whole set of 
SNVs (single nucleotide variants) in a cohort of cancer samples. The general 
approach [@Alex2013] is as follows:

1. The SNVs are categorized by their nucleotide exchange. In total there are 
$4 \times 3 = 12$ different nucleotide exchanges, but if summing over reverse 
complements only $12 / 2 = 6$ different categories are left. For every SNV 
detected, the motif context around the position of the SNV is extracted. This 
may be a trinucleotide context if taking one base upstream and one base 
downstream of the position of the SNV, but larger motifs may be taken as well 
(e.g. pentamers). Taking into account the motif context increases combinatorial
complexity: in the case of the trinucleotide context, there are 
$4 \times 6 \times 4 = 96$ different variant categories. These categories are 
called **features** in the following text. The number of features will be 
called $n$.
2. A cohort consists of different samples with the number of samples denoted by
$m$. For each sample we can count the occurences of each feature, yielding an 
$n$-dimensional vector ($n$ being the number of features) per sample. For a 
cohort, we thus get an $n \times m$ -dimensional matrix, called the 
**mutational catalogue** $V$. It can be understood as a summary indicating 
which sample has how many variants of which category, but omitting the 
information of the genomic coordinates of the variants.
3. The mutational catalogue $V$ is quite big and still carries a lot of 
complexity. For many analyses a  reduction of complexity is desirable. One way 
to achieve such a complexity reduction is a matrix decomposition: we would like
to find two smaller matrices $W$ and $H$ which, if multiplied, would span a high 
fraction of the complexity of the big matrix $V$ (the mutational catalogue). 
Remember that $V$ is an $n \times m$ -dimensional matrix, $n$ being the number 
of features and $m$ being the number of samples. $W$ in this setting is an 
$n \times l$ -dimensional matrix and $H$ is an $l \times m$ -dimensional 
matrix. According to the nomeclature defined in [@Alex2013], the columns of 
$W$ are called the **mutational signatures** and the columns of $H$ are called 
**exposures**. $l$ denotes the number of mutational signatures. Hence the 
signatures are $n$-dimensional vectors (with $n$ being the number of features),
while the exposures are $l$-dimensional vectors ($l$ being the number of 
signatures). Note that as we are dealing with count data, we would like to have
only positive entries in $W$ and $H$. A mathematical method which is able to do
such a decomposition is the **NMF** (**non-negative matrix factorization**). It 
basically solves the problem as illustrated in the following figure (image 
taken from <https://en.wikipedia.org/wiki/Non-negative_matrix_factorization>):

![NMF](NMF.png)

Note that the NMF itself solves the above problem for a given number of 
signatures $l$. In order to achieve a reduction in complexity, the number of 
signatures has to be smaller than the number of features ($l < $n), as 
indicated in the above figure. The framework of Ludmil Alexandrov et al. 
[@Alex2013] performs not only the NMF decomposition itself, but also identifies 
the appropriate number of signatures by an iterative procedure.

Another software, the Bioconductor package `r Biocpkg("SomaticSignatures")` to 
perform analyses of mutational signatures, is available [@Gehring_article2015]. 
It allows the matrix decomposition to be performed by NMF and alternatively 
by PCA (principal component analysis). Both methods have in common that they 
can be used for **discovery**, i.e. for the **extraction of new signatures**. 
However, they only work well if the analyzed data set has sufficient 
statistical power, i.e. a sufficient number of samples and sufficient numbers 
of counts per feature per sample.

The package YAPSA introduced here is complementary to these existing software
packages. It is designed for a supervised analysis of mutational signatures,
i.e. an analysis with already known signatures $W$, and with much lower 
requirements on statistical power of the input data.

  
# The YAPSA package {#YAPSA_package}

In a context where mutational signatures $W$ are already known (because they 
were decribed and published as in [@Alex2013] or they are available in a 
database as under <https://cancer.sanger.ac.uk/cosmic/signatures>), we might 
want to just find the exposures $H$ for these known signatures in the 
mutational catalogue $V$ of a given cohort. Mathematically, this is a different
and potentially simpler task. 

The **YAPSA**-package (Yet Another Package for Signature Analysis) presented 
here provides the function `LCD` (**l**inear **c**ombination **d**ecomposition)
to perform this task. The advantage of this method is that there are **no 
constraints on the cohort size**, so `LCD` can be run for as little as one 
sample and thus be used e.g. for signature analysis in personalized oncology. 
In contrast to NMF, `LCD` is very fast and requires very little computational 
resources. YAPSA has some other unique functionalities, which are briefly 
mentioned below and described in detail in separate vignettes.


## Linear Combination Decomposition (LCD) {#LCD}

In the following, we will denote the columns of $V$ by $V_{(\cdot j)}$, which 
corresponds to the mutational catalogue of sample $j$. Analogously we denote 
the columns of $H$ by $H_{(\cdot j)}$, which is the exposure vector of sample 
$j$. Then `LCD` is designed to solve the optimization problem:

(@LCD_formula) $$
\begin{aligned}
\min_{H_{(\cdot j)} \in \mathbb{R}^l}||W \cdot H_{(\cdot j)} - V_{(\cdot j)}||
\quad \forall j \in \{1...m\} \\
\textrm{under the constraint of non-negativity:} \quad H_{(ij)} >= 0 \quad 
\forall i \in \{1...l\} \quad \forall j \in \{1...m\}
\end{aligned}
$$

Remember that $j$ is the index over samples, $m$ is the number of samples, 
$i$ is the index over signatures and $l$ is the number of signatures. `LCD` 
uses a non-negative least squares (NNLS) algorithm (from the R package  
`r CRANpkg("nnls")` ) to solve this optimization problem. Note that the 
optimization procedure is carried out for every $V_{(\cdot j)}$, i.e. for every 
column of $V$ separately. Of course $W$ is constant, i.e. the same for every 
$V_{(\cdot j)}$.

This procedure is highly sensitive: as soon as a signature has a contribution 
or an exposure in at least one sample of a cohort, it will be reported (within 
the floating point precision of the operating system). This might blur the 
picture and counteracts the initial purpose of complexity reduction. Therefore 
there is a function `LCD_complex_cutoff`. This function takes as a second 
argument a cutoff (a value between zero and one). In the analysis, it will keep
only those signatures which have a cumulative (over the cohort) normalized 
exposure greater than this cutoff. In fact it runs the LCD-procedure twice: 
once to find initial exposures, summing over the cohort and excluding the ones 
with too low a contribution as described just above, and a second time doing 
the analysis only with the signatures left over. Beside the exposures $H$ 
corresponding to this reduced set of signatures, the function 
`LCD_complex_cutoff` also returns the reduced set of signatures itself.

Another R package for the supervised analysis of mutational signatures is 
available: `r CRANpkg("deconstructSigs")` [@Rosenthal_2016]. One difference 
between `LCD_complex_cutoff` as described here in `YAPSA` and the corresponding
function `whichSignatures` in `r CRANpkg("deconstructSigs")` is that 
`LCD_complex_cutoff` accepts different cutoffs and signature-specific cutoffs 
(accounting for potentially different detectability of different signatures), 
whereas in `whichSignatures` in `r CRANpkg("deconstructSigs")` a general fixed 
cutoff is set to be 0.06. In the following, we briefly mention other features 
of the software package YAPSA and refer to the corresponding vignettes for 
detailed descriptions.

## Signature-specific cutoffs

One special characteristic of YAPSA is that it provides the opportunity to 
perform analyses of mutational signtures with signature-specific cutoffs. 
Different signatures have different detectability. Those with high detectability
will occur as false positive calls more often. In order to account for the 
different detectability, we introduced the concept of signature-specific 
cutoffs: a signature which leads to many false positive calls has to cross a 
higher threshold than a signature which rarely leads to false positive calls. 
While this vignette introduces [how to work with signature-specific cutoffs in 
general](#sigSpecCutoffs), optimal signature-specific cutoffs are presented in 
[2. Signature-specific cutoffs](vignette_signature_specific_cutoffs.html).

## Confidence intervals for mutational signature exposures

In order to evaluate the confidence of computed exposures to mutational 
signatures, YAPSA provides 95% confidence intervals (CIs). The computation 
relies on the concept of profile likelihood [@Raue_Bioinformatics2009]. Details 
can be found in 
[3. Confidence Intervals](vignette_confidenceIntervals.html).

## Stratification of the Mutational Catalogue (SMC)

For some questions it is useful to assign the SNVs detected in the samples of a
cohort to categories. We call an analysis of mutational signatures which takes 
into account these strata a *stratified* analysis, which has the potential to
reveal enrichment and depletion patterns. Of note, this is different from 
performing completely separate and independent NNLS analyses of mutational 
signatures on the different strata. Instead, the results of the unstratified 
analysis are used as input for a constrained analysis for the strata. Details 
can be found in 
[4. Stratified Analysis of Mutational Signatures](vignette_stratifiedAnalysis.html)

## Indel signatures

Recently a new and extended set of mutational signatures was published by the 
Pan Cancer Analysis of Whole Genomes (PCAWG) consortium [@Alex2020]. In 
addition to an extended set of SNV mutational signatures, that analysis 
for the first time had sufficient statistical power to also extract 17 Indel 
signatures, based on a classification of Indels into 83 categories or features. 
YAPSA also offers functionality to perform supervised analyses of mutational 
signatures on these Indel signatures, details can be found in
[5. Indel signature analysis](vignettes_Indel.html)

  
# Example: a cohort of B-cell lymphomas

We will now apply some functions of the YAPSA package to Whole Genome 
Sequencing datasets published in Alexandrov et al. [-@Alex2013]. First we have 
to load this data and get an overview ([first subsection](#example-data)). Then
we will load data on published signatures 
([second subsection](#loading-the-signature-information)). Only in the 
[third subsection](#performing-an-lcd-analysis) we will actually start using 
the YAPSA functions.

```{r, warning=FALSE, message=FALSE}
library(YAPSA)
library(knitr)
opts_chunk$set(echo=TRUE)
opts_chunk$set(fig.show='asis')
```

## Example data

In the following, we will load and get an overview of the data used in the 
analysis by Alexandrov et al. [@Alex2013]

### Loading example data

```{r loadLymphoma}
data("lymphoma_Nature2013_raw")
```

This creates a dataframe with `r dim(lymphoma_Nature2013_raw_df)[1]` rows. It 
is equivalent to executing the R code

```{r loadLymphomaFtp, eval=FALSE}
lymphoma_Nature2013_ftp_path <- paste0(
  "https://ftp.sanger.ac.uk/pub/cancer/AlexandrovEtAl/",
  "somatic_mutation_data/Lymphoma%20B-cell/",
  "Lymphoma%20B-cell_clean_somatic_mutations_",
  "for_signature_analysis.txt")
lymphoma_Nature2013_raw_df <- read.csv(file=lymphoma_Nature2013_ftp_path,
                                       header=FALSE,sep="\t")
```

The format is inspired by the vcf format with one line per called variant. Note
that the files provided at that URL have no header information, therefore we 
have to add some. We will also slightly adapt the data structure:

```{r adaptData}
names(lymphoma_Nature2013_raw_df) <- c("PID","TYPE","CHROM","START",
                                       "STOP","REF","ALT","FLAG")
lymphoma_Nature2013_df <- subset(lymphoma_Nature2013_raw_df,TYPE=="subs",
                                 select=c(CHROM,START,REF,ALT,PID))
names(lymphoma_Nature2013_df)[2] <- "POS"
kable(head(lymphoma_Nature2013_df), 
      caption = "First rows of the file containing the SNV variant calls.")
```

Here, we have selected only the variants characterized as `subs` (those are the
SNVs we are interested in for the mutational signatures 
analysis, small indels are filtered out by this step), so we are left with 
`r dim(lymphoma_Nature2013_df)[1]` variants or rows. Note that there are
`r length(unique(lymphoma_Nature2013_df$PID))` different samples:

```{r PIDinfo}
unique(lymphoma_Nature2013_df$PID)
```

For convenience later on, we annotate subgroup information to every variant 
(indirectly through the sample it occurs in). For reasons of simplicity, we 
also restrict the analysis to the Whole Genome Sequencing (WGS) datasets:

```{r annotateSubgroup, warning=FALSE, message=FALSE}
lymphoma_Nature2013_df$SUBGROUP <- "unknown"
DLBCL_ind <- grep("^DLBCL.*",lymphoma_Nature2013_df$PID)
lymphoma_Nature2013_df$SUBGROUP[DLBCL_ind] <- "DLBCL_other"
MMML_ind <- grep("^41[0-9]+$",lymphoma_Nature2013_df$PID)
lymphoma_Nature2013_df <- lymphoma_Nature2013_df[MMML_ind,]
data(lymphoma_PID)
for(my_PID in rownames(lymphoma_PID_df)) {
  PID_ind <- which(as.character(lymphoma_Nature2013_df$PID)==my_PID)
  lymphoma_Nature2013_df$SUBGROUP[PID_ind] <-
    lymphoma_PID_df$subgroup[which(rownames(lymphoma_PID_df)==my_PID)]
}
lymphoma_Nature2013_df$SUBGROUP <- factor(lymphoma_Nature2013_df$SUBGROUP)
unique(lymphoma_Nature2013_df$SUBGROUP)
```


### Displaying example data

Rainfall plots provide a quick overview of the mutational load of a sample. To 
this end we have to compute the intermutational distances. But first we still 
do some reformatting...

```{r intermutDistances, warning=FALSE, message=FALSE, results="hide"}
lymphoma_Nature2013_df <- translate_to_hg19(lymphoma_Nature2013_df,"CHROM")
lymphoma_Nature2013_df$change <- 
  attribute_nucleotide_exchanges(lymphoma_Nature2013_df)
lymphoma_Nature2013_df <- 
  lymphoma_Nature2013_df[order(lymphoma_Nature2013_df$PID,
                               lymphoma_Nature2013_df$CHROM,
                               lymphoma_Nature2013_df$POS),]
lymphoma_Nature2013_df <- annotate_intermut_dist_cohort(lymphoma_Nature2013_df,
                                                        in_PID.field="PID")
data("exchange_colour_vector")
lymphoma_Nature2013_df$col <- 
  exchange_colour_vector[lymphoma_Nature2013_df$change]
```

Now we can select one sample and make the rainfall plot. The plot function used
here relies on the package `r Biocpkg("gtrellis")` by Zuguang Gu 
[@gtrellis2015].

```{r makeRainfallPlot, fig.cap="Rainfall plot in a trellis structure."}
choice_PID <- "4121361"
PID_df <- subset(lymphoma_Nature2013_df,PID==choice_PID)
#trellis_rainfall_plot(PID_df,in_point_size=unit(0.5,"mm"))
```

This shows a rainfall plot typical for a lymphoma sample with clusters of 
increased mutation density e.g. at the immunoglobulin loci.
\newpage


## Loading the signature information

As stated [above](#LCD), one of the functions in the YAPSA package (`LCD`) is
designed to do mutational signatures analysis with known signatures. There are
(at least) two possible sources for signature data: i) the ones published
initially by Alexandrov et al. [@Alex2013], and ii) an updated and curated
current set of mutational signatures is maintained by Ludmil Alexandrov at
<https://cancer.sanger.ac.uk/cosmic/signatures>. The following three subsections
describe how you can load the data from these resources. Alternatively, you can
bypass the three following subsections because the signature datasets are also
included in this package:

```{r, loadStoredSigData}
data(sigs)
```


### Loading the initial set of signatures

We first load the (older) set of signatures as published in Alexandrov et al. 
[@Alex2013]:

```{r processOldSigs}
Alex_signatures_path <- paste0("https://ftp.sanger.ac.uk/pub/cancer/",
                               "AlexandrovEtAl/signatures.txt")
AlexInitialArtif_sig_df <- read.csv(Alex_signatures_path,header=TRUE,sep="\t")
kable(AlexInitialArtif_sig_df[c(1:9),c(1:4)])
```

We will now reformat the dataframe:

```{r reformatOldSigs}
Alex_rownames <- paste(AlexInitialArtif_sig_df[,1],
                       AlexInitialArtif_sig_df[,2],sep=" ")
select_ind <- grep("Signature",names(AlexInitialArtif_sig_df))
AlexInitialArtif_sig_df <- AlexInitialArtif_sig_df[,select_ind]
number_of_Alex_sigs <- dim(AlexInitialArtif_sig_df)[2]
names(AlexInitialArtif_sig_df) <- gsub("Signature\\.","A",
                                       names(AlexInitialArtif_sig_df))
rownames(AlexInitialArtif_sig_df) <- Alex_rownames
kable(AlexInitialArtif_sig_df[c(1:9),c(1:6)],
      caption="Exemplary data from the initial Alexandrov signatures.")
```

This results in a dataframe for signatures, containing `r number_of_Alex_sigs`
signatures as column vectors. It is worth noting that in the initial 
publication, only a subset of these `r number_of_Alex_sigs` signatures were 
validated by an orthogonal sequencing technology. So we can filter down:

```{r filterValidatedSignatures}
AlexInitialValid_sig_df <- AlexInitialArtif_sig_df[,grep("^A[0-9]+",
                                          names(AlexInitialArtif_sig_df))]
number_of_Alex_validated_sigs <- dim(AlexInitialValid_sig_df)[2]
```

We are left with `r number_of_Alex_validated_sigs` signatures.

### Loading the updated set of mutational signatures

An updated and curated set of mutational signatures is maintained by Ludmil 
Alexandrov at <https://cancer.sanger.ac.uk/cosmic/signatures>. We will use this 
set for the following analysis. In particular, we will use the signatures stored 
in <https://cancer.sanger.ac.uk/cancergenome/assets/signatures_probabilities.txt> 
which for convenience we have stored in a data frame in YAPSA.

```{r loadSigs}
data(AlexCosmicValid_sig_df)
Alex_COSMIC_rownames <- paste(AlexCosmicValid_sig_df[,1],
                              AlexCosmicValid_sig_df[,2],sep=" ")
COSMIC_select_ind <- grep("Signature",names(AlexCosmicValid_sig_df))
AlexCosmicValid_sig_df <- AlexCosmicValid_sig_df[,COSMIC_select_ind]
number_of_Alex_COSMIC_sigs <- dim(AlexCosmicValid_sig_df)[2]
names(AlexCosmicValid_sig_df) <- gsub("Signature\\.","AC",
                                         names(AlexCosmicValid_sig_df))
rownames(AlexCosmicValid_sig_df) <- Alex_COSMIC_rownames
kable(AlexCosmicValid_sig_df[c(1:9),c(1:6)],
      caption="Exemplary data from the updated Alexandrov signatures.")
```

This results in a dataframe containing `r number_of_Alex_COSMIC_sigs` 
signatures as column vectors. For reasons of convenience and comparability with
the initial signatures, we reorder the features. To this end, we adhere to the 
convention chosen in the initial publication by Alexandrov et al. [@Alex2013] 
for the initial signatures.

```{r reorderFeatures}
COSMIC_order_ind <- match(Alex_rownames,Alex_COSMIC_rownames)
AlexCosmicValid_sig_df <- AlexCosmicValid_sig_df[COSMIC_order_ind,]
kable(AlexCosmicValid_sig_df[c(1:9),c(1:6)],
      caption=paste0("Exemplary data from the updated Alexandrov ",
                     "signatures, rows reordered."))
```

Note that the order of the features, i.e. nucleotide exchanges in their 
trinucleotide content, is changed from the fifth line on as indicated by the 
row names.


### Preparation for later analysis

For every set of signatures, the functions in the YAPSA package require an 
additional dataframe containing meta information about the signatures. In that
dataframe you can specify the order in which the signatures are going to be 
plotted and the colours asserted to the different signatures. In the following 
subsection we will set up such a dataframe. However, the respective dataframes
are also stored in the package. If loaded by `data(sigs)` the following 
code block can be bypassed.

```{r, buildSigIndDf}
signature_colour_vector <- c("darkgreen","green","pink","goldenrod",
                             "lightblue","blue","orangered","yellow",
                             "orange","brown","purple","red",
                             "darkblue","magenta","maroon","yellowgreen",
                             "violet","lightgreen","sienna4","deeppink",
                             "darkorchid","seagreen","grey10","grey30",
                             "grey50","grey70","grey90")
bio_process_vector <- c("spontaneous deamination","spontaneous deamination",
                        "APOBEC","BRCA1_2","Smoking","unknown",
                        "defect DNA MMR","UV light exposure","unknown",
                        "IG hypermutation","POL E mutations","temozolomide",
                        "unknown","APOBEC","unknown","unknown","unknown",
                        "unknown","unknown","unknown","unknown","unknown",
                        "nonvalidated","nonvalidated","nonvalidated",
                        "nonvalidated","nonvalidated")
AlexInitialArtif_sigInd_df <- data.frame(sig=colnames(AlexInitialArtif_sig_df))
AlexInitialArtif_sigInd_df$index <- seq_len(dim(AlexInitialArtif_sigInd_df)[1])
AlexInitialArtif_sigInd_df$colour <- signature_colour_vector
AlexInitialArtif_sigInd_df$process <- bio_process_vector

COSMIC_signature_colour_vector <- c("green","pink","goldenrod",
                                    "lightblue","blue","orangered","yellow",
                                    "orange","brown","purple","red",
                                    "darkblue","magenta","maroon",
                                    "yellowgreen","violet","lightgreen",
                                    "sienna4","deeppink","darkorchid",
                                    "seagreen","grey","darkgrey",
                                    "black","yellow4","coral2","chocolate2",
                                    "navyblue","plum","springgreen")
COSMIC_bio_process_vector <- c("spontaneous deamination","APOBEC",
                               "defect DNA DSB repair hom. recomb.",
                               "tobacco mutatgens, benzo(a)pyrene",
                               "unknown",
                               "defect DNA MMR, found in MSI tumors",
                               "UV light exposure","unknown","POL eta and SHM",
                               "altered POL E",
                               "alkylating agents, temozolomide",
                               "unknown","APOBEC","unknown",
                               "defect DNA MMR","unknown","unknown",
                               "unknown","unknown",
                               "associated w. small indels at repeats",
                               "unknown","aristocholic acid","unknown",
                               "aflatoxin","unknown","defect DNA MMR",
                               "unknown","unknown","tobacco chewing","unknown")
AlexCosmicValid_sigInd_df <- data.frame(sig=colnames(AlexCosmicValid_sig_df))
AlexCosmicValid_sigInd_df$index <- seq_len(dim(AlexCosmicValid_sigInd_df)[1])
AlexCosmicValid_sigInd_df$colour <- COSMIC_signature_colour_vector
AlexCosmicValid_sigInd_df$process <- COSMIC_bio_process_vector
```

YAPSA can also perform analyses based on other sets of mutational signatures. 
Details can be found in additional vignettes on 
[signature-specific cutoffs](vignette_signature_specific_cutoffs.html) and 
[Indel signatures](vignettes_Indel.html).


## Performing an LCD analysis

Now we can start using the functions from the YAPSA package. We will start with
a mutational signatures analysis using known signatures (the ones we loaded in 
the above paragraph). For this, we will use the functions `LCD` and 
`LCD_complex_cutoff`.

### Building a mutational catalogue

This section uses functions which are to a large extent wrappers for functions 
in the package SomaticSignatures by Julian Gehring [@Gehring_article2015].

```{r loadLibraries, warning=FALSE, message=FALSE}
library(BSgenome.Hsapiens.UCSC.hg19)
```

```{r buildMutationalCatalogue, results="hide"}
word_length <- 3

lymphomaNature2013_mutCat_list <- 
  create_mutation_catalogue_from_df(
    lymphoma_Nature2013_df,
    this_seqnames.field = "CHROM", this_start.field = "POS",
    this_end.field = "POS", this_PID.field = "PID",
    this_subgroup.field = "SUBGROUP",
    this_refGenome = BSgenome.Hsapiens.UCSC.hg19,
    this_wordLength = word_length)
```

The function `create_mutation_catalogue_from_df` returns a list object with 
several entries. We will use the one called `matrix`.

```{r displayStructureMutationCatalogueList}
names(lymphomaNature2013_mutCat_list)
lymphomaNature2013_mutCat_df <- as.data.frame(
  lymphomaNature2013_mutCat_list$matrix)
kable(lymphomaNature2013_mutCat_df[c(1:9),c(5:10)])
```
\newpage


### LCD analysis without any cutoff

The `LCD` function performs the decomposition of a mutational catalogue into a 
priori known signatures and the respective exposures to these signatures as 
described in the second section of this vignette. We use the signatures from
[@Alex2013] from the COSMIC website
(<https://cancer.sanger.ac.uk/cosmic/signatures_v2>).

```{r LCD, warning=FALSE}
current_sig_df <- AlexCosmicValid_sig_df
current_sigInd_df <- AlexCosmicValid_sigInd_df
lymphomaNature2013_COSMICExposures_df <-
  LCD(lymphomaNature2013_mutCat_df,current_sig_df)
```

Some adaptation (extracting and reformatting the information which sample 
belongs to which subgroup):

```{r makeSubgroupsDfLCD}
COSMIC_subgroups_df <- 
  make_subgroups_df(lymphoma_Nature2013_df,
                    lymphomaNature2013_COSMICExposures_df)
```

The resulting signature exposures can be plotted using custom plotting 
functions. First as absolute exposures:
```{r captionBarplot, echo=FALSE}
cap <- "Absoute exposures of the COSMIC signatures in the lymphoma mutational
        catalogues, no cutoff for the LCD (Linear Combination Decomposition)"
```

```{r exposuresBarplotLCD, fig.width=6, fig.height=5, fig.cap=cap}
exposures_barplot(
  in_exposures_df = lymphomaNature2013_COSMICExposures_df,
  in_subgroups_df = COSMIC_subgroups_df)
```

Here, as no colour information was given to the plotting function 
`exposures_barplot`, the identified signatures are coloured in a rainbow 
palette. If you want to assign colours to the signatures, this is possible via
a data structure of type `sigInd_df`.
```{r captionBarplot2, echo=FALSE}
cap <- "Absoute exposures of the COSMIC signatures in the lymphoma mutational
    catalogues, no cutoff for the LCD (Linear Combination Decomposition)"
```

```{r exposuresBarplotLCDsigInd, fig.width=6, fig.height=5, fig.cap=cap}
exposures_barplot(
  in_exposures_df = lymphomaNature2013_COSMICExposures_df,
  in_signatures_ind_df = current_sigInd_df,
  in_subgroups_df = COSMIC_subgroups_df)
```

This figure has a colour coding which suits our needs, but there is one slight 
inconsistency: colour codes are assigned to all `r dim(current_sig_df)[2]` 
provided signatures, even though some of them might not have any contributions 
in this cohort:

```{r rowSumsInCohort}
rowSums(lymphomaNature2013_COSMICExposures_df)
```

This can be overcome by using `LCD_complex_cutoff`. It requires an additional 
parameter: `in_cutoff_vector`; this is already the more general framework which
will be explained in more detail in the following section.

```{r LCDcomplexCutoffZero}
zero_cutoff_vector <- rep(0,dim(current_sig_df)[2])
CosmicValid_cutoffZero_LCDlist <- LCD_complex_cutoff(
  in_mutation_catalogue_df = lymphomaNature2013_mutCat_df,
  in_signatures_df = current_sig_df,
  in_cutoff_vector = zero_cutoff_vector,
  in_sig_ind_df = current_sigInd_df)
```

We can re-create the subgroup information (even though this is identical to the
already determined one):

```{r applyMakeSubgroupsDfZero}
COSMIC_subgroups_df <- 
  make_subgroups_df(lymphoma_Nature2013_df,
                    CosmicValid_cutoffZero_LCDlist$exposures)
```

And if we plot this, we obtain:
```{r captionBarplot3, echo=FALSE}
cap="Absoute exposures of the COSMIC signatures in the lymphoma mutational
    catalogues, no cutoff for the LCD (Linear Combination Decomposition)."
```

```{r exposuresBarplotAbsCutoffZero, fig.width=6, fig.height=5, fig.cap=cap}
exposures_barplot(
  in_exposures_df = CosmicValid_cutoffZero_LCDlist$exposures,
  in_signatures_ind_df = CosmicValid_cutoffZero_LCDlist$out_sig_ind_df,
  in_subgroups_df = COSMIC_subgroups_df)
```

Note that this time, only the 
`r dim(CosmicValid_cutoffZero_LCDlist$exposures)[1]` signatures which actually 
have a contribution to this cohort are displayed in 
the legend.

Of course, also relative exposures may be plotted:
```{r caption_barplot_4, echo=FALSE}
cap="Relative exposures of the COSMIC signatures in the lymphoma mutational
    catalogues, no cutoff for the LCD (Linear Combination Decomposition)."
```

```{r exposuresBarplotRelCutoffZero, fig.width=6, fig.height=5, fig.cap=cap}
exposures_barplot(
  in_exposures_df = CosmicValid_cutoffZero_LCDlist$norm_exposures,
  in_signatures_ind_df = CosmicValid_cutoffZero_LCDlist$out_sig_ind_df,
  in_subgroups_df = COSMIC_subgroups_df)
```


### LCD analysis with a generalized cutoff

Now let's rerun the analysis with a cutoff to discard signatures with 
insufficient cohort-wide contribution. 

```{r definitionCutoff}
my_cutoff <- 0.06
```

The cutoff of `r my_cutoff` means that a signature is kept if it's exposure 
represents at least `r my_cutoff*100`% of all SNVs in the cohort. We will use 
the function `LCD_complex_cutoff` instead of `LCD`.

```{r LCDcomplexCutoffCutoffGen, warning=FALSE}
general_cutoff_vector <- rep(my_cutoff,dim(current_sig_df)[2])
CosmicValid_cutoffGen_LCDlist <- LCD_complex_cutoff(
  in_mutation_catalogue_df = lymphomaNature2013_mutCat_df,
  in_signatures_df = current_sig_df,
  in_cutoff_vector = general_cutoff_vector,
  in_sig_ind_df = current_sigInd_df)
```

At the chosen cutoff of `r my_cutoff`, we are left with 
`r dim(CosmicValid_cutoffGen_LCDlist$out_sig_ind_df)[1]` signatures. We can 
look at these signatures in detail and their attributed biological processes:

```{r}
kable(CosmicValid_cutoffGen_LCDlist$out_sig_ind_df, row.names=FALSE,
      caption=paste0("Signatures with cohort-wide exposures > ",my_cutoff))
```

Again we can plot absolute exposures:

```{r captionBarplot5, echo=FALSE}
cap="Absoute exposures of the COSMIC signatures in the lymphoma mutational
    catalogues, cutoff of 6% for the LCD (Linear Combination Decomposition)."
```

```{r exposuresBarplotAbsCutoffGen, fig.width=6, fig.height=4, fig.cap=cap}
exposures_barplot(
  in_exposures_df = CosmicValid_cutoffGen_LCDlist$exposures,
  in_signatures_ind_df = CosmicValid_cutoffGen_LCDlist$out_sig_ind_df,
  in_subgroups_df = COSMIC_subgroups_df)
```

And relative exposures:
```{r captionBarplot6, echo=FALSE}
cap="Relative exposures of the COSMIC signatures in the lymphoma mutational
    catalogues, cutoff of 6% for the LCD (Linear Combination Decomposition)."
```

```{r exposuresBarplotRelGutoffGen, fig.width=6, fig.height=4, fig.cap=cap}
exposures_barplot(
  in_exposures_df = CosmicValid_cutoffGen_LCDlist$norm_exposures,
  in_signatures_ind_df = CosmicValid_cutoffGen_LCDlist$out_sig_ind_df,
  in_subgroups_df = COSMIC_subgroups_df)
```


### LCD analysis with signature-specific cutoffs {#sigSpecCutoffs}

When using `LCD_complex_cutoff`, we have to supply a vector of cutoffs with as 
many entries as there are signatures. In the analysis carried out above, these 
were all equal, but this is not a necessary condition. Indeed it may make sense
to provide different cutoffs for different signatures.

```{r makeSpecificCutoffVector}
specific_cutoff_vector <- general_cutoff_vector
specific_cutoff_vector[c(1,5)] <- 0
specific_cutoff_vector
```

In this example, the cutoff for signatures AC1 and AC5 is thus set to 0, 
whereas the cutoffs for all other signatures remains at 0.06. Running the 
function `LCD_complex_cutoff` is completely analogous:

```{r LCDcomplexCutoffCutoffSpec, warning=FALSE}
CosmicValid_cutoffSpec_LCDlist <- LCD_complex_cutoff(
  in_mutation_catalogue_df = lymphomaNature2013_mutCat_df,
  in_signatures_df = current_sig_df,
  in_cutoff_vector = specific_cutoff_vector,
  in_sig_ind_df = current_sigInd_df)
```

Plotting absolute exposures for visualization:
```{r captionBarplot7, echo=FALSE}
cap="Absoute exposures of the COSMIC signatures in the lymphoma mutational
    catalogues, cutoff of 6% for the LCD (Linear Combination Decomposition)."
```

```{r exposuresBarplotAbsCutoffSpec, fig.width=6, fig.height=4, fig.cap=cap}
exposures_barplot(
  in_exposures_df = CosmicValid_cutoffSpec_LCDlist$exposures,
  in_signatures_ind_df = CosmicValid_cutoffSpec_LCDlist$out_sig_ind_df,
  in_subgroups_df = COSMIC_subgroups_df)
```

And relative exposures:
```{r captionBarplot8, echo=FALSE}
cap="Relative exposures of the COSMIC signatures in the lymphoma mutational
    catalogues, cutoff of 6% for the LCD (Linear Combination Decomposition)."
```

```{r exposuresBarplotRelCutoffSpec, fig.width=6, fig.height=4, fig.cap=cap}
exposures_barplot(
  in_exposures_df = CosmicValid_cutoffSpec_LCDlist$norm_exposures,
  in_signatures_ind_df = CosmicValid_cutoffSpec_LCDlist$out_sig_ind_df,
  in_subgroups_df = COSMIC_subgroups_df)
```

Note that the signatures extracted with the signature-specific cutoffs are the 
same in the example displayed here. Depending on the analyzed cohort and the 
choice of cutoffs, the extracted signatures may vary considerably. A unique 
feature of YAPSA is that it also provides optimal signature-specific cutoffs, a 
topic explained in a separate [vignette](vignette_signature_specific_cutoffs.html).



## Cluster samples based on their signature exposures

To identify groups of samples which were exposed to similar mutational 
processes, the exposure vectors of the samples can be compared. The YAPSA 
package provides a custom function for this task: `complex_heatmap_exposures`, 
which uses the package `r Biocpkg("ComplexHeatmap")` by Zuguang Gu 
[@ComplexHeatmap2015]. It produces output as follows:
```{r captionHeatmap, echo=FALSE}
cap="Clustering of Samples and Signatures based on the relative exposures of
    the COSMIC signatures in the lymphoma mutational catalogues."
```

```{r applyHeatmapExposures, fig.width=6, fig.height=4, fig.cap=cap}
complex_heatmap_exposures(CosmicValid_cutoffGen_LCDlist$norm_exposures,
                          COSMIC_subgroups_df,
                          CosmicValid_cutoffGen_LCDlist$out_sig_ind_df,
                          in_data_type="norm exposures",
                          in_subgroup_colour_column="col",
                          in_method="manhattan",
                          in_subgroup_column="subgroup")
```

If you are interested only in the clustering and not in the heatmap 
information, you could also use `hclust_exposures`:
```{r caption_hclust, echo=FALSE}
cap="Clustering of the Samples based on the relative exposures of the
    COSMIC signatures in the lymphoma mutational catalogues."
```

```{r applyHclustExposures, fig.width=6, fig.height=3, fig.cap=cap}
hclust_list <- 
  hclust_exposures(CosmicValid_cutoffGen_LCDlist$norm_exposures,
                   COSMIC_subgroups_df,
                   in_method="manhattan",
                   in_subgroup_column="subgroup")
```

The dendrogram produced by either the function `complex_heatmap_exposures` or 
the function `hclust_exposures` can be cut to yield signature exposures specific
to subgroups of PIDs.
```{r caption_heatmap_2, echo=FALSE}
cap=paste0("PIDs labelled by the clusters extracted from the
            signature analysis.")
```

```{r clusterPIDsSigInfo, fig.width=6, fig.height=4, fig.cap=cap}
cluster_vector <- cutree(hclust_list$hclust,k=4)
COSMIC_subgroups_df$cluster <- cluster_vector
subgroup_colour_vector <- rainbow(length(unique(COSMIC_subgroups_df$cluster)))
COSMIC_subgroups_df$cluster_col <- 
  subgroup_colour_vector[factor(COSMIC_subgroups_df$cluster)]
complex_heatmap_exposures(CosmicValid_cutoffGen_LCDlist$norm_exposures,
                          COSMIC_subgroups_df,
                          CosmicValid_cutoffGen_LCDlist$out_sig_ind_df,
                          in_data_type="norm exposures",
                          in_subgroup_colour_column="cluster_col",
                          in_method="manhattan",
                          in_subgroup_column="cluster")
```


# References

---
title: "6. Usage of YAPSA for Whole Exome Sequencing (WES) data"
author: "Daniel Huebschmann"
date: "06/03/2020"
vignette: >
  %\VignetteIndexEntry{6. Usage of YAPSA for WES data}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}  
output:
  BiocStyle::html_document:
    toc: yes
references:
- author:
  - family: Alexandrov
    given: LB
  - family: Nik-Zainal
    given: S
  - family: Wedge
    given: DC
  - family: Aparicio
    given: SA
  - family: Behjati
    given: S
  - family: Biankin
    given: AV
  - family: Bignell
    given: GR
  - family: Bolli
    given: N
  - family: Borg
    given: A
  - family: Borresen-Dale
    given: AL
  - family: Boyault
    given: S
  - family: Burkhardt
    given: B
  - family: Butler
    given: AP
  - family: Caldas
    given: C
  - family: Davies
    given: HR
  - family: Desmedt
    given: C
  - family: Eils
    given: R
  - family: Eyfjörd
    given: JE
  - family: Greaves
    given: M
  - family: Hosoda
    given: F
  - family: Hutter
    given: B
  - family: Ilicic
    given: T
  - family: Imbeaud
    given: S
  - family: Imielinski
    given: M
  - family: Jäger
    given: N
  - family: Jones
    given: DT
  - family: Jones
    given: D
  - family: Knappskog
    given: S
  - family: Kool
    given: M
  - family: Lakhani
    given: SR
  - family: Lopez-Otin
    given: C
  - family: Martin
    given: S
  - family: Munshi
    given: NC
  - family: Nakamura
    given: H
  - family: Northcott
    given: PA
  - family: Pajic
    given: M
  - family: Papaemmanuil
    given: E
  - family: Paradiso
    given: A
  - family: Pearson
    given: JV
  - family: Puente
    given: XS
  - family: Raine
    given: K
  - family: Ramakrishna
    given: M
  - family: Richardson
    given: AL
  - family: Richter
    given: J
  - family: Rosenstiel
    given: P
  - family: Schlesner
    given: M
  - family: Schumacher
    given: TN
  - family: Span
    given: PN
  - family: Teague
    given: JW
  - family: Tokoti
    given: Y
  - family: Tutt
    given: AN
  - family: Valdes-Mas
    given: R
  - family: van Buuren
    given: MM
  - family: van't Veer
    given: L
  - family: Vincent-Salomon
    given: A
  - family: Waddell
    given: N
  - family: Yates
    given: LR
  - family: Australian Pancreatic Cancer Initiative
    given: 
  - family: ICGC Breast Cancer Consortium
    given: 
  - family: ICGC MMML-Seq Consortium
    given: 
  - family: ICGC PedBrain
    given: 
  - family: Zucman-Rossi
    given: J
  - family: Futreal
    given: PA
  - family: McDermott
    given: U
  - family: Lichter
    given: P
  - family: Meyerson
    given: M
  - family: Grimmond
    given: SM
  - family: Siebert
    given: R
  - family: Campo
    given: E
  - family: Shibata
    given: T
  - family: Pfister
    given: SM
  - family: Campbell
    given: PJ
  - family: Stratton
    given: MR
  container-title: Nature
  id: Alex2013
  issued:
    month: 8
    volume: 500
    year: 2013
  publisher: Nature Publishing Group
  title: 'Signatures of Mutational Processes in Cancer'
- author:
  - family: Alexandrov
    given: LB
  - family: Kim
    given: J
  - family: Haradhvala
    given: NJ
  - family: Huang
    given: MN
  - family: Ng
    given: AW
  - family: Boot
    given: A
  - family: Covington
    given: KR
  - family: Gordenin
    given: DA
  - family: Bergstrom
    given: E
  - family: Lopez-Bigas
    given: N
  - family: Klimczak
    given: LJ
  - family: McPherson
    given: JR
  - family: Morganella
    given: S
  - family: Sabarinathan
    given: R
  - family: Wheeler
    given: DA
  - family: Mustonen
    given: V
  - family: Getz
    given: G
  - family: Rozen
    given: SG
  - family: Stratton
    given: MR
  container-title: Nature
  id: Alex2020
  issued:
    month: 02
    year: 2020
  publisher: Nature
  title: 'The Repertoire of Mutational Signatures in Human Cancer'
- author:
  - family: Rudin
    given: Charles M.
  - family: Durinck
    given: Steffen
  - family: Stawiski
    given: Eric W.
  - family: Poirier
    given: John T.
  - family: Modrusan
    given: Zora
  - family: Shames
    given: David S.
  - family: Bergbower
    given: Emily A.
  - family: Guan
    given: Yinghui
  - family: Shin
    given: James
  - family: Guillory
    given: Joseph
  - family: Rivers
    given: Celina Sanchez
  - family: Foo
    given: Catherine K.
  - family: Bhatt
    given: Deepali
  - family: Stinson
    given: Jeremy
  - family: Gnad
    given: Florian
  - family: Haverty
    given: Peter M.
  - family: Gentleman
    given: Robert
  - family: Chaudhuri
    given: Subhra
  - family: Janakiraman
    given: Vasantharajan
  - family: Jaiswal
    given: Bijay S.
  - family: Parikh
    given: Chaitali
  - family: Yuan
    given: Wenlin
  - family: Zhang
    given: Zemin
  - family: Koeppen
    given: Hartmut
  - family: Wu
    given: Thomas D.
  - family: Stern
    given: Howard M.
  - family: Yauch
    given: Robert L.
  - family: Huffman
    given: Kenneth E.
  - family: Paskulin
    given: Diego D.
  - family: Illei
    given: Peter B.
  - family: Varella-Garcia
    given: Marileila
  - family: Gazdar
    given: Adi F.
  - family: De Sauvage
    given: Frederic J.
  - family: Bourgon
    given: Richard
  - family: Minna
    given: John D.
  - family: Brock
    given: Malcolm V.
  - family: Seshagiri
    given: Somasekar
  container-title: Nature Genetics
  id: Rudin2012
  issued:
    month: 10
    volume: 44
    year: 2012
  publisher: Nature Publishing Group
  title: 'Comprehensive genomic analysis identifies SOX2 as a frequently amplified gene in small-cell lung cancer'
---

  
```{r load_style, warning=FALSE, message=FALSE, results="hide"}
library(BiocStyle)
```

```{r packages, include=FALSE}
library(YAPSA)
library(Biostrings)
library(BSgenome.Hsapiens.UCSC.hg19)
library(knitr)
opts_chunk$set(echo=TRUE)
opts_chunk$set(fig.show='asis')
```

# Introduction {#introduction}

The usage of YAPSA for Whole Genome Sequencing (WGS) data has been described in 
detail in the preceding vignettes, with an introduction and an overview of the 
general framework in [1. Usage of YAPSA](YAPSA.html).
YAPSA can also be applied to Whole Exome Sequencing (WES) data, however, a few 
caveats apply and a few steps have to be followed. These are described in this 
vignette.

The most important difference between WGS and WES analyses is the frequency of 
occurrence of the different k-mers. According to the concept detailed in 
[@Alex2013] and [@Alex2020], SNV mutational signatures use the triplet (or 
3-mer) context of an SNV for categorization of the mutations, leading to 96 
different categories or features. These 96 different feature don't occur with 
the same frequency in the human genome. They don't occur with the same 
frequency in the exome either, but more importantly, the relative occurrence 
differs between WGS and WES. More precisely, let $n_{X}^{WGS}$ denote the 
occurrence of feature $X$ in the whole genome and $n_{X}^{WES}$ denote the 
occurrence of $X$ in an exome target capture. We then furthermore denote

(@ratio_definition) $$
q_{X}^{WGS,WES} = \frac{n_{X}^{WGS}}{n_{X}^{WES}}
$$

to be the ratio of these two counts. Even though on average across all features, 
these ratios may vary around a value of $50$, because the genome is roughly 
$50$ times bigger than the exome, the ratios need not be identical for all 
features, i.e.,

(@inequalityOfRatios_formula) $$
\exists X,Y\in\mathbb{F}: q_{X}^{WGS,WES} \neq q_{Y}^{WGS,WES}
$$

where $\mathbb{F}$ denotes the feature space. It is thus crutial to compute 
$q_{X}^{WGS,WES}$ for all features $X\in\mathbb{F}$ and to correct for these 
differences. These corrections can be applied either to the signatures, 
converting them to "exome signatures", or the inverse corrections can be 
applied to the mutational catalogs. In YAPSA, we opt for the second alternative, 
as this keeps the function calls simple, analogous and very similar for 
analyses of both WES and WGS data.

Different target capture kits are available in order to perform WES. 
As these cover different genomic regions, for a given target capture kit $A$, 
different correction factors $q_{X}^{WGS,WES_A}$ for all features have to be 
computed. As detailed [below](#correctTargetCapture), YAPSA provides correction 
factors for 8 different target capture kits and also one correction factor 
directly derived from the gene model GENCODE 19 applied to the human reference 
genome hs37d5.


# Loading the data {#loadData}

First of all, analogously to all other vignettes, we load the signature data 
from the package:

```{r, loadStoredSigData}
data(sigs)
data(cutoffs)
current_sig_df <- AlexInitialArtif_sig_df
library(BSgenome.Hsapiens.UCSC.hg19)
```

For the purpose of analyzing exomes, a mutational catalog of small cell lung 
cancer is stored in YAPSA. The data had originally been generated by 
[@Rudin2012] and was used in the cross entity analysis in [@Alex2013]. The data 
can be accessed as follows:

```{r}
data("smallCellLungCancerMutCat_NatureGenetics2012")
```

This creates a dataframe with name `exome_mutCatRaw_df` and 
`r dim(exome_mutCatRaw_df)[1]` rows. It was originally generated by executing 
the R code below (not evaluated in this vignette):

```{r loadLymphomaFtp, eval=FALSE}
smallCellLungCancer_NatureGenetics2012_ftp_path <- paste0(
  "ftp://ftp.sanger.ac.uk/pub/cancer/AlexandrovEtAl/",
  "somatic_mutation_data/Lung%20Small%20Cell/",
  "Lung%20Small%20Cell_clean_somatic_mutations_for_signature_analysis.txt")
exome_vcf_like_df <- 
  read.csv(file = smallCellLungCancer_NatureGenetics2012_ftp_path,
           header=FALSE,sep="\t")
names(exome_vcf_like_df) <- c("PID","TYPE","CHROM","START",
                                       "STOP","REF","ALT","FLAG")
exome_vcf_like_df <- subset(exome_vcf_like_df, TYPE == "subs",
                            select = c(CHROM, START, REF, ALT, PID))
names(exome_vcf_like_df)[2] <- "POS"
exome_vcf_like_df <- translate_to_hg19(exome_vcf_like_df,"CHROM")
word_length <- 3
exome_mutCatRaw_list <- 
  create_mutation_catalogue_from_df(
    exome_vcf_like_df,
    this_seqnames.field = "CHROM", this_start.field = "POS",
    this_end.field = "POS", this_PID.field = "PID",
    this_subgroup.field = "SUBGROUP",
    this_refGenome = BSgenome.Hsapiens.UCSC.hg19,
    this_wordLength = 3)
exome_mutCatRaw_df <- as.data.frame(exome_mutCatRaw_list$matrix)
```


# Correcting for the target capture {#correctTargetCapture}

We now have an example mutational catalog at hand for WES data. In order to 
perform a correction for the different triplet content between WGS and WES, 
YAPSA provides correction factors, which can be brought to the R workspace as 
follows:

```{r loadCorrectionFactors}
data(targetCapture_cor_factors)
```

As outlined in the [introduction](#introduction), different target capture kits 
require different correction factors. The sets of available correction factors 
can be accessed by the names of the loaded object:

```{r listCorrectionFactors}
names(targetCapture_cor_factors)
```

We now have everything at hand which is needed to correct for the triplet 
content. As described [above](#loadData), the data was accessed via links 
provided in [@Alex2013], however, the data had originally been generated for 
another publication: [@Rudin2012]. As described there, the target capture kit 
*Agilent SureSelect all exon* was used, and we will use the correction factors 
computed for this very kit. The function to be used in YAPSA for such a 
correction is called `normalizeMotifs_otherRownames()`:

```{r correctTargetCapture}
targetCapture <- "AgilentSureSelectAllExon"
cor_list <- targetCapture_cor_factors[[targetCapture]]
corrected_catalog_df <- normalizeMotifs_otherRownames(exome_mutCatRaw_df,
                                                        cor_list$rel_cor)
```

Of note, the corrected mutational catalog need not contain exclusively integer 
numbers any more, it may contain floating point numbers due to the values of 
$q_{X}^{WGS,WES}$.


# Performing the analysis of mutational signatures

After having performed the corrected with the factors $q_{X}^{WGS,WES}$, 
the analysis of mutational signatures is completely analogous to 
the steps already described multiple times in the other vignettes. However, the 
choice of optimal signature-specific cutoffs is slightly different:

```{r optimalCutoffs}
data(cutoffs)
current_cutoff_vector <- cutoffCosmicValid_rel_df[6,]
```

```{r LCDwithCutoffs}
exome_listsList <-
  LCD_complex_cutoff_combined(
      in_mutation_catalogue_df = corrected_catalog_df,
      in_cutoff_vector = current_cutoff_vector, 
      in_signatures_df = AlexCosmicValid_sig_df, 
      in_sig_ind_df = AlexCosmicValid_sigInd_df)
```

As we don't have any information about subgroups in this example, we omit this 
and proceed directly with plotting the results:

```{r ExposuresCutoffsCap, echo=FALSE}
cap <- "Exposures barplot."
```

```{r exposuresCutoffs, warning=FALSE, fig.width=8, fig.height=6, fig.cap=cap}
exposures_barplot(
  in_exposures_df = exome_listsList$cohort$exposures,
  in_signatures_ind_df = exome_listsList$cohort$out_sig_ind_df)         
```

Of note, this cohort is strongly affected by signature AC4 (associated with the 
main carcinogens in tobacco smoke).


# References

---
title: "5. Indel signature analysis"
author: "Lea Jopp-Saile and Daniel Huebschmann"
date: "28/01/2019"
vignette: >
  %\VignetteIndexEntry{5. Indel signature analysis}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}  
output: 
  BiocStyle::html_document:
    toc: yes

references:
- author:
  - family: Alexandrov
    given: LB
  - family: Nik-Zainal
    given: S
  - family: Wedge
    given: DC
  - family: Aparicio
    given: SA
  - family: Behjati
    given: S
  - family: Biankin
    given: AV
  - family: Bignell
    given: GR
  - family: Bolli
    given: N
  - family: Borg
    given: A
  - family: Borresen-Dale
    given: AL
  - family: Boyault
    given: S
  - family: Burkhardt
    given: B
  - family: Butler
    given: AP
  - family: Caldas
    given: C
  - family: Davies
    given: HR
  - family: Desmedt
    given: C
  - family: Eils
    given: R
  - family: Eyfjörd
    given: JE
  - family: Greaves
    given: M
  - family: Hosoda
    given: F
  - family: Hutter
    given: B
  - family: Ilicic
    given: T
  - family: Imbeaud
    given: S
  - family: Imielinski
    given: M
  - family: Jäger
    given: N
  - family: Jones
    given: DT
  - family: Jones
    given: D
  - family: Knappskog
    given: S
  - family: Kool
    given: M
  - family: Lakhani
    given: SR
  - family: Lopez-Otin
    given: C
  - family: Martin
    given: S
  - family: Munshi
    given: NC
  - family: Nakamura
    given: H
  - family: Northcott
    given: PA
  - family: Pajic
    given: M
  - family: Papaemmanuil
    given: E
  - family: Paradiso
    given: A
  - family: Pearson
    given: JV
  - family: Puente
    given: XS
  - family: Raine
    given: K
  - family: Ramakrishna
    given: M
  - family: Richardson
    given: AL
  - family: Richter
    given: J
  - family: Rosenstiel
    given: P
  - family: Schlesner
    given: M
  - family: Schumacher
    given: TN
  - family: Span
    given: PN
  - family: Teague
    given: JW
  - family: Tokoti
    given: Y
  - family: Tutt
    given: AN
  - family: Valdes-Mas
    given: R
  - family: van Buuren
    given: MM
  - family: van't Veer
    given: L
  - family: Vincent-Salomon
    given: A
  - family: Waddell
    given: N
  - family: Yates
    given: LR
  - family: Australian Pancreatic Cancer Initiative
    given: 
  - family: ICGC Breast Cancer Consortium
    given: 
  - family: ICGC MMML-Seq Consortium
    given: 
  - family: ICGC PedBrain
    given: 
  - family: Zucman-Rossi
    given: J
  - family: Futreal
    given: PA
  - family: McDermott
    given: U
  - family: Lichter
    given: P
  - family: Meyerson
    given: M
  - family: Grimmond
    given: SM
  - family: Siebert
    given: R
  - family: Campo
    given: E
  - family: Shibata
    given: T
  - family: Pfister
    given: SM
  - family: Campbell
    given: PJ
  - family: Stratton
    given: MR
  container-title: Nature
  id: Alex2013
  issued:
    month: 08
    volume: 500
    year: 2013
  publisher: Nature Publishing Group
  title: 'Signatures of Mutational Processes in Cancer'
- author:
  - family: Alexandrov
    given: LB
  - family: Kim
    given: J
  - family: Haradhvala
    given: NJ
  - family: Huang
    given: MN
  - family: Ng
    given: AW
  - family: Boot
    given: A
  - family: Covington
    given: KR
  - family: Gordenin
    given: DA
  - family: Bergstrom
    given: E
  - family: Lopez-Bigas
    given: N
  - family: Klimczak
    given: LJ
  - family: McPherson
    given: JR
  - family: Morganella
    given: S
  - family: Sabarinathan
    given: R
  - family: Wheeler
    given: DA
  - family: Mustonen
    given: V
  - family: Getz
    given: G
  - family: Rozen
    given: SG
  - family: Stratton
    given: MR
  container-title: Nature
  id: Alex2020
  issued:
    month: 02
    year: 2020
  publisher: Nature
  title: 'The Repertoire of Mutational Signatures in Human Cancer'
- author:
  - family: Alexandrov
    given: LB
  - family: Nik-Zainal
    given: S
  - family: Wedge
    given: DC
  - family: Campbell
    given: PJ
  - family: Stratton
    given: MR
  container-title: Cell Reports
  id: Alex_CellRep2013
  issued:
    year: 2013
  title: > 
    Deciphering signatures of mutational processes operative in human cancer
- author:
  - family: Sing
    given: Tobias
  - family: Sander
    given: Oliver
  - family: Beerenwinkel
    given: Niko
  - family: Lengauer
    given: Thomas
  container-title: Bioinfomatics
  id: ROCR_package2005
  issued:
      year: 2005
  title: >
    ROCR: visualizing classifier performance in R
---

```{r loadStyle, warning=FALSE, echo=FALSE, message=FALSE, results="hide"}
library(BiocStyle)
```

```{r packages, include=FALSE}
library(YAPSA)
library(Biostrings)
library(BSgenome.Hsapiens.UCSC.hg19)
library(knitr)
opts_chunk$set(echo=TRUE)
opts_chunk$set(fig.show='asis')
```

# Introduction: PCAWG signatures {#introduction}

In May 2018 a new and extended set of mutational signatures was published as a 
preprint by the Pan-Cancer Analysis of Whole Genomes (PCAWG) consortium 
[@Alex2020]. In the following, we refer to that set of signatures as the PCAWG 
signatures. The underlying data is the largest available cohort of sequenced 
(Whole Genome Sequencing (WGS) and Whole Exome Sequencing (WES)) cancer 
samples to date and represents a substantial increase in statistical power as 
compared to [@Alex2013] and [@Alex_CellRep2013]. On this data set, de novo 
mutational signature discovery analysis was performed with two different 
algorithms of the Non-negative Matrix Factorization (NMF) family of algorithms, 
*SigPorfiler* and *SignatureAnalyzer* (Bayesian NMF). In total 65 SNV mutational 
signatures (abbreciated SBS for single base substitution) were found, 49 of 
which were called validated, either because of good consensus between the two 
calling algorithms or because of presence in an orthogonal sequencing 
technology. In addition to the SNV or SBS mutational signatures, that analysis 
for the first time had sufficient statistical power to also extract 17 Indel 
(ID) signatures, based on a classification of Indels into 83 features, and 
Doublet Base Signatures (DBS) based on somatic di-nucleotide exchanges. In this 
vignette, we present an example analysis with the new PCAWG Indel signatures. 
The setup and line of arguments is analogous to the 
[first vignette](YAPSA.html).
However, YAPSA doesn't provide functions for DBS signatures as mutation counts 
are often not sufficient for a deconvolution analysis.

As for the [COSMIC SNV mutational signatures](YAPSA.html),
the patterns for both the SNV and Indel PCAWG mutational signatures are stored 
in the software package and can be loaded into the workspace as follows: 

```{r loadPCAWGsigs}
data(sigs_pcawg)
```

For a precise description of all the data loaded by the above command, please 
refer to [2. Signature-specific cutoffs](vignette_signature_specific_cutoffs.html)


# Classification of Indels

A prerequisite for an analysis of Indel mutational signatures is a consistent 
classification system of Indels. This is non-trivial and critically depends on 
the choice of features, which have to include whether a given Indel is actually 
an insertion or a deletion, the size of the Indel,as well as the motif context 
in order to assess whether micro-homologies are present. In the classification 
proposed by the PCAWG consortium there are 83 features in total, which form 
five major groups: 

1. Deletions of 1 bp C/(G) or T/(A) in a repetitive context. Taking into 
account the motif context of the deletion, the mutational event is further 
classified into categories of 1, 2, 3, 4, 5 or larger or equal to 6 identical
nucleotide(s).
1. Insertions of 1 bp C/(G) or T/(A) in a repetitive context. Taking into 
account the motif context of the deletion, the mutational event is further 
classified into categories of 0, 1, 2, 3, 4,  or larger or equal to 5
identical nucleotide(s).
1. Deletions of 2 bp, 3 bp, 4 bp or more or equal to 5 bp in a repetitive 
context. Each deletion is classified in a context of 1, 2, 3, 4, 5 or larger
or equal to 6 times the same motif.
1. Insertions of 2 bp, 3 bp, 4 bp or more or equal to 5 bps in a repetitive 
context.  Each deletion is classified in a context of 0, 1, 2, 3, 4 or larger 
or equal to 5 times the same motif.
1. Deletions of 2 bp, 3 bp, 4 bp or more or equal to 5 bp in a partially 
repetitive context with microhomology at the breakpoints. This partially 
repetitive context is defined by motif length of minus 1 bp, 2 bp, 3 bp, 4 bps 
or more or equal to 5 bp, located before and after the break-points of the 
deletion.

Indel classifications in the range of 1 - 5 bp are assigned to individual 
categories, while all variants larger than 5bp are considered as one category.
Of note, microhomology is defined by partial sequence similarity between the 
motif of the respective Indel and the immediate neighbouring sequence context. 
In the following, we illustrate the microhomology classification with an 
example. We take a deletion of the motif **ATGCGA**, being more than 5 bp in 
length with microhomology, i.e., partially repetitive context of 4 bp at the 
breakpoint junction with the motifs **ATGC** upstream and **GCGA** downstream 
of the deletion. The annotated feature category is then **MH\_5+\_4bp**. 

In YAPSA, the function `plotExchangeSpectra_indel()` can be used to plot the 
nucleotide exchange spectra of samples and/or signatures. The representation is 
analogous to the function `plotExchangeSpectra()` for SNV mutational signatures, 
while the colors and feature annotation is taken from [@Alex2020].

```{r captionSpectra, echo=FALSE}
cap <-": Nucleotide exchange spectra of the Indel signatures ID3, associated 
        with tobacco smoking, and ID6, related to deficiencies in homologous 
        recombination repair."
```

```{r INDELsigExample, include=TRUE, fig.width=15, fig.height=6, fig.cap= cap}
plotExchangeSpectra_indel(PCAWG_SP_ID_sigs_df[,c(3,6)])
```

# PCAWG Indel signatures

The publication [@Alex2020] reports signatures decomposed with an NMF
approach (*SigProfiler*) and a Bayesian NMF approach (*SignatureAnalyser*). It
is worth noting that YAPSA only has mutational signatures decomposed with
SigProfiler integrated so far, of which the validated signatures are also found
with *SignatureAnalyser*. Signatures only decomposed with SignatureAnalyzer are
not part of YAPSA. Signature ID15 was excluded as none of the samples had a
contribution to this signature. For seven of the Indel signatures, underlying 
mutational processes were asserted. Indel Signatures ID1 and ID2 can be found 
across all entities, while others such as ID13 is associated with UV light 
exposure and is found exclusively in melanoma (cf. @Alex2020).

```{r INDELsigInfo}
current_caption <- paste0("Information on Indel mutational signatures.")
if(!exists("repress_tables"))
  kable(PCAWG_SP_ID_sigInd_df, row.names=FALSE, caption=current_caption)
```

# Example data: Genome of the Netherlands

In order to demonstrate the functionalities of the Indel signature analysis 
with YAPSA, a publicly available data set was chosen, the Genome of the 
Netherlands
(<https://www.nlgenome.nl/menu/main/app-go-nl/?page_id=9>) [release5](https://molgenis26.gcc.rug.nl/downloads/gonl_public/variants/release5/).
The data set is not related to cancer and instead contains germline variation 
in the genomes of the Dutch population. Hence no biological interpretation or 
conclusion of this analysis with respect to mutational processes should be 
made, it is of sole technical and demonstrative purpose.


# Supervised Indel signature analysis

## Loading example data

We first load the example data, which is stored in the software package 
YAPSA. The file $\texttt{GenomeOfNl_raw.rda}$ has been filtered to only contain 
Indel variant calls.

```{r loadGoNL}
data(GenomeOfNl_raw)
GenomeOfNl_raw <- GenomeOfNl_raw[, c(1,2,4,5)]
```

Optional columns are being removed from the loaded data, which results in a 
vcf-like (analogous to the variant calling format) dataframe with 
`r dim(GenomeOfNl_raw)[1]` variants.
The binary file above was created with the following R code:

```{r loadGoNLraw}
load_data_new <- FALSE
if(load_data_new){
  data <- data.frame(matrix(ncol = 8, nrow = 0))
  for(index in seq_along(1:22)){
              print(index)
              temp <- tempfile()
              file_path <- paste0("https://molgenis26.gcc.rug.nl/
                                  downloads/gonl_public/variants/release5/
                                  gonl.chr",
                                  index, ".snps_indels.r5.vcf.gz")
              download.file(file_path, temp)
       
              data <- rbind(data, read.table(gzfile(temp, paste0("gonl.chr",
                                                    index,
                                                    ".snps_indels.r5.vcf")),
                                             header=FALSE, sep="\t", 
                                             stringsAsFactors = FALSE))
              data <- data[grep("INDEL", data$V8),]
              unlink(temp)
            
  }
  colnames(data) <- c("CHROM", "POS", "ID", "REF", "ALT", "QUAL", 
                      "FILTER","INFO")

  GenomeOfNl_raw <- data[, c(1,2,4,5)]
}
```

The obtained dataframe will later be used it in order to build a mutational 
catalog for supervised analysis of mutational signatures with PCAWG Indel 
signatures.

```{r showsTopOfDf, echo=FALSE}
kable(head(GenomeOfNl_raw), caption="Head of VCF file 
      containing the GoNL INDEL data")
```

## Data Preprocessing 

`GenomeOfNl_raw` does not contain any patient identifier information. 
For the purpose of demonstrating the use of YAPSA Indel signature analysis, 
such an information on patient identity is necessary. To do so, 15 synthetic 
patient identifiers (PIDs) were generated and 50 +/- 20 Indels per PID were 
randomly sampled from the data frame `GenomeOfNl_raw`.

```{r randomizeDataSet, warning= FALSE}
seed = 2
set.seed(seed)
number_of_indels <- sample(c(30:70), 15,  replace = TRUE)

index=0
seed=3
set.seed(seed)
vcf_like_indel_lists <- lapply(number_of_indels, function(size){
  df_per_PID <- GenomeOfNl_raw[sample(nrow(GenomeOfNl_raw), size, 
                                      replace = FALSE), ]
  index <<- index+1
  df_per_PID$PID <- rep(paste0("PID_", index), length(size))
  df_PIDs <- df_per_PID[order(df_per_PID$CHROM),]
  return(df_PIDs)
  })

vcf_like_indel_df <- do.call(rbind.data.frame, vcf_like_indel_lists)
kable(head(vcf_like_indel_df), caption="Head of the vcf_like_df
      containing the subsampled GoNL Indel data")
```

Using the artificial `vcf_like_df` created above as input, the function 
`create_indel_mutation_catalogue_from_df()` then builds a mutational
catalog $V^{INDEL}$ containing the absolute feature counts ($n$) for each
patient. This functions is equivalent to the function
`create_mutation_catalogue_from_df()` for SNV data. Besides the input of type 
`vcf_like_df`, the function `create_indel_mutation_catalogue_from_df()` also 
requires the Indel signatures (`PCAWG_SP_ID_sigs_df`) loaded previously into 
the workspace.
The function `create_create_indel_mutation_catalogue_from_df()` is a wrapper of 
several other functions:

1. `attribute_sequence_contex_indel()` the function annotates to the 
`vcf_like_df` a sequence context of 10 bp down- and 60 bp upstream of every 
Indel variant. Additionally, the information whether the variant is an 
insertion or deletion and the length of the Indel is annotated to every Indel 
mutation.
1. `attribution_of_indels()` attributes each variant to one of the 83 classes of
features 
1. `create_indel_mut_cat_from_df()` carries out the counting in order to obtain 
a mutational catalog with the dimensions $n \times m$.

Please note that this pre-processing step takes longer than all other functions 
in YAPSA and may be time limiting.

```{r createMutationalCatalog, warning=FALSE}
vcf_like_indel_trans_df <- translate_to_hg19(vcf_like_indel_df,"CHROM")
mutational_cataloge_indel_df <- create_indel_mutation_catalogue_from_df(
  in_dat = vcf_like_indel_trans_df,
  in_signature_df = PCAWG_SP_ID_sigs_df)

kable(head(mutational_cataloge_indel_df[,1:5]))
```

## LCD Analysis 

The core function of YAPSA is the function `LCD` and its derived functions, 
which perform supervised mutational signature analysis. Here we describe how 
this class of functions has been extended in order to make this supervised 
signature analysis available to Indel mutational signatures. As previously 
described for 
[SNV mutational signatures](YAPSA.html), 
the deconvolution is based on a non-negative least squares (NNLS) algorithm. In 
order to reduce false positive calls, 
[signature-specific cutoffs](vignette_signature_specific_cutoffs.html) 
were introduced in YAPSA. Signature-specific cutoffs
are applied after a first decomposition with NNLS, and only signatures with 
computed contributions higher than their signature-specific cutoff are used in 
a second decomposition which then yields the exposure values. Signature-specific 
cutoffs take the different detectability of signatures into account, reflected 
by a lower signature-specific cutoff for signatures with a distinct pattern and 
a higher signature-specific cutoff for signatures with broader patterns.

Of note, mutational processes have been asserted to fractions of both the sets 
of SNV and Indel mutational signatures. There are overlaps between the asserted 
mutational processes, as some of them can indeed leave imprints on both the SNV 
and Indel mutational landscapes. Combining the information extracted with an 
analysis of mutational signatures from the different types of mutation may thus 
increase discriminatory power.

As described 
[here](vignette_signature_specific_cutoffs.html), signature-specific cutoffs were trained in a modified 
ROC analysis with the package `r CRANpkg("ROCR")` [@ROCR_package2005] using the 
results of the unsupervised discovery analysis as training data. As for the SNV 
mutational signatures, signature-specific cutoffs are stored in dataframes 
within the software package and can be loaded into the workspace:

```{r loadCutoffs, warning=FALSE}
data(cutoffs_pcawg)
```

As described in 
[2. Signature-specific cutoffs](vignette_signature_specific_cutoffs.html), the modified ROC analyses are parametrized by 
defining cost terms for punishing false-negative ($cost_{FN}$) and 
false-positive ($cost_{FP}$) findings separately, but the shape and minima of 
the cost functions depend only on the ratio between the cost for a 
false-negative finding divided by the cost for a false positive finding, the 
$cost_{factor}$ ($cost_{factor} = cost_{FN}/cost_{FP}$). Therefore, there is one 
set of optimal signature-specific cutoffs per chosen value of $cost_{factor}$.

Optimal signature-specific cutoffs are stored in data frames within the software 
package and can be loaded into the workspace as shown above. In these data 
frames every row corresponds to a different value of $cost_{factor}$. For Indel
signatures the optimal cost factor was identified to be 3, thus the third line 
in `cutoffPCAWG_ID_WGS_Pid_df` can be chosen for analysis.

```{r LCDdecompostion, warning=FALSE}
current_catalogue_df <- mutational_cataloge_indel_df 
current_sig_df <- PCAWG_SP_ID_sigs_df
current_cutoff_pid_vector <- cutoffPCAWG_ID_WGS_Pid_df[3,]
current_sigInd_df <- PCAWG_SP_ID_sigInd_df

current_LCDlistsList <- LCD_complex_cutoff_combined(
  current_catalogue_df,
  current_sig_df,
  in_cutoff_vector = current_cutoff_pid_vector,
  in_filename = NULL,
  in_method = "abs",
  in_sig_ind_df = current_sigInd_df)

current_consensus_LCDlist <- current_LCDlistsList$consensus
if(!exists("repress_tables")) 
  as.character(current_consensus_LCDlist$out_sig_ind_df$sig)
```

## Visualization

The exposures, i.e., the contributions of the different signatures to the 
mutational catalog of every sample, can be visualized with the function
`exposures_barplot()`. All the functionalities which are available for
SNV mutational signatures, such as the annotation of subgroups (cf. 
[1. Usage of YAPSA](vignette_confidenceIntervals.html)) 
are also available for the Indel mutational signatures.

```{r captionExposure, echo=FALSE}
cap <- ":Exposures to Indel mutational signatures in the artificial data created 
        by sampling GoNL variants. Exposures were obtained from
        a decomposition with PCAWG Indel signatures as well as their signature
        specific-cutoffs (cutoffPCAWG_ID_WGS_Pid_df)."
```

```{r plotExposure, echo=TRUE, warning=FALSE, fig.width=15, fig.height=6, fig.cap= cap}
exposures_barplot(current_LCDlistsList$perPID$exposures,
                  current_LCDlistsList$perPID$out_sig_ind_df)
```

# Confidence Intervals

In order to assess trustworthiness of the computed exposures, YAPSA provides 
the calculation of confidence intervals (CIs). Analogously to 
[CIs for SNV mutational signatures](YAPSA.html), 
the CIs for Indel mutational signatures are computed using the concept of 
profile likelihood.

```{r captionCI, echo=FALSE}
cap <- "Confidence interval calculation for exposures to Indel mutational 
        signatures"
```

```{r CI, echo=TRUE, warning=FALSE, fig.width=17, fig.height=15, fig.cap=cap}
confidence_intervals_ID <- confidence_indel_only_calulation(
  in_current_indel_df = current_catalogue_df)
plot(confidence_intervals_ID$p_complete_PCAWG_ID)
```

Note: With `confidence_indel_only_calulation()` only for INDELs the confidence
intervals are calculated. To calculate the confidence intervals for SNVs and
INDELs please use the function `confidence_indel_calulation()` and supply the 
mutational catalogs of both SNV and INDEL counts.

# References 

---
title: "3. Confidence Intervals"
author: "Daniel Huebschmann"
date: "30/12/2019"
vignette: >
  %\VignetteIndexEntry{3. Confidence Intervals}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}  
output: 
  BiocStyle::html_document:
    toc: yes

references:
- author:
  - family: Alexandrov
    given: LB
  - family: Nik-Zainal
    given: S
  - family: Wedge
    given: DC
  - family: Aparicio
    given: SA
  - family: Behjati
    given: S
  - family: Biankin
    given: AV
  - family: Bignell
    given: GR
  - family: Bolli
    given: N
  - family: Borg
    given: A
  - family: Borresen-Dale
    given: AL
  - family: Boyault
    given: S
  - family: Burkhardt
    given: B
  - family: Butler
    given: AP
  - family: Caldas
    given: C
  - family: Davies
    given: HR
  - family: Desmedt
    given: C
  - family: Eils
    given: R
  - family: Eyfjörd
    given: JE
  - family: Greaves
    given: M
  - family: Hosoda
    given: F
  - family: Hutter
    given: B
  - family: Ilicic
    given: T
  - family: Imbeaud
    given: S
  - family: Imielinski
    given: M
  - family: Jäger
    given: N
  - family: Jones
    given: DT
  - family: Jones
    given: D
  - family: Knappskog
    given: S
  - family: Kool
    given: M
  - family: Lakhani
    given: SR
  - family: Lopez-Otin
    given: C
  - family: Martin
    given: S
  - family: Munshi
    given: NC
  - family: Nakamura
    given: H
  - family: Northcott
    given: PA
  - family: Pajic
    given: M
  - family: Papaemmanuil
    given: E
  - family: Paradiso
    given: A
  - family: Pearson
    given: JV
  - family: Puente
    given: XS
  - family: Raine
    given: K
  - family: Ramakrishna
    given: M
  - family: Richardson
    given: AL
  - family: Richter
    given: J
  - family: Rosenstiel
    given: P
  - family: Schlesner
    given: M
  - family: Schumacher
    given: TN
  - family: Span
    given: PN
  - family: Teague
    given: JW
  - family: Tokoti
    given: Y
  - family: Tutt
    given: AN
  - family: Valdes-Mas
    given: R
  - family: van Buuren
    given: MM
  - family: van't Veer
    given: L
  - family: Vincent-Salomon
    given: A
  - family: Waddell
    given: N
  - family: Yates
    given: LR
  - family: Australian Pancreatic Cancer Initiative
    given: 
  - family: ICGC Breast Cancer Consortium
    given: 
  - family: ICGC MMML-Seq Consortium
    given: 
  - family: ICGC PedBrain
    given: 
  - family: Zucman-Rossi
    given: J
  - family: Futreal
    given: PA
  - family: McDermott
    given: U
  - family: Lichter
    given: P
  - family: Meyerson
    given: M
  - family: Grimmond
    given: SM
  - family: Siebert
    given: R
  - family: Campo
    given: E
  - family: Shibata
    given: T
  - family: Pfister
    given: SM
  - family: Campbell
    given: PJ
  - family: Stratton
    given: MR
  container-title: Nature
  id: Alex2013
  issued:
    month: 08
    volume: 500
    year: 2013
  publisher: Nature Publishing Group
  title: 'Signatures of Mutational Processes in Cancer'
- author:
  - family: Raue
    given: Andreas
  - family: Kreutz 
    given: C.
  - family: Maiwald 
    given: T.
  - family: Bachmann 
    given: J.
  - family: Schilling
    given: M.
  - family: Klingmüller
    given: U.
  - family: Timmer
    given: J.
  container-title: Bioinformatics
  id: Raue_Bioinformatics2009
  issued:
      year: 2009
  title: >
    'Structural and practical identifiability analysis of partially observed 
    dynamical models by exploiting the profile likelihood.'
---

```{r loadStyle, warning=FALSE, echo=FALSE, message=FALSE, results="hide"}
library(BiocStyle)
```

```{r packages, include=FALSE}
library(YAPSA)
library(Biostrings)
library(BSgenome.Hsapiens.UCSC.hg19)
library(knitr)
opts_chunk$set(echo=TRUE)
opts_chunk$set(fig.show='asis')
```

# Introduction: Confidence Intervals {#introduction}

In order to assess confidence in the setting of modeling in ordinary 
differential equations (ODEs), the concept of 
profile likelihood was introduced [@Raue_Bioinformatics2009]. In YAPSA, this 
concept was adapted to the computation of confidence intervals (CIs) for the 
exposures to mutational signatures (@Alex2013). To determine the CI for a 
computed single value in a high-dimensional vector, this value is perturbed and 
the remaining values of the vector are computed again, yielding an alternative 
data model with one degree of freedom less than the initial model. Then, 
log-likelihoods are computed from the distribution of the residuals of the 
initial and the alternative model and a likelihood ratio test is being computed.

In the context of mutational signatures, this corresponds to the determination 
of the CI for the exposure of one given mutational signature exposure. To this 
end, this exposure value is perturbed, i.e., $H_{uv}$, the exposure to 
signature $u$ in sample $v$, is changed by a small value 
$H_{uv} \rightarrow H_{uv} + \epsilon_{uv}$, and the exposures to the remaining 
signatures are computed again by non-negative least squares, yielding an 
alternative data model with one degree of freedom less than the initial model. 
Then, as described above, log-likelihoods are computed from the distribution of 
the residuals of the initial and the alternative model and a likelihood ratio 
test is being computed. This yields a p-value for the perturbation, which may 
need to be extrapolated by a Gauss-Newton method to yield 95% CIs.


# Recap: compute signature exposures

In the following section, we briefly recapitulate the analysis of SNV 
mutational signatures on an example data set as performed in 
[1. Usage of YAPSA](YAPSA.html).
We thus first load the example data stored in the package:

```{r, loadStoredSigData}
data(sigs)
data(cutoffs)
data("lymphomaNature2013_mutCat_df")
current_cutoff_vector <- cutoffCosmicValid_abs_df[6,]
```

We then perform a supervised analysis of SNV mutational signatures using 
[signature-specific cutoffs](vignette_signature_specific_cutoffs.html):

```{r LCDwithCutoffs}
lymphoma_COSMIC_listsList <-
  LCD_complex_cutoff_combined(
      in_mutation_catalogue_df = lymphomaNature2013_mutCat_df,
      in_cutoff_vector = current_cutoff_vector, 
      in_signatures_df = AlexCosmicValid_sig_df, 
      in_sig_ind_df = AlexCosmicValid_sigInd_df)
```

We assign subgroups to the different samples:

```{r subrgroupAnnotation}
data(lymphoma_PID)
colnames(lymphoma_PID_df) <- "SUBGROUP"
lymphoma_PID_df$PID <- rownames(lymphoma_PID_df)
COSMIC_subgroups_df <- 
  make_subgroups_df(lymphoma_PID_df,
                    lymphoma_COSMIC_listsList$cohort$exposures)
```

And finally plot the obtained result:

```{r captionExposures, echo=FALSE}
cap <- "Exposures to SNV mutational signatures"
```

```{r exposuresCutoffs, warning=FALSE, fig.width=8, fig.height=6, fig.cap= cap}
exposures_barplot(
  in_exposures_df = lymphoma_COSMIC_listsList$cohort$exposures,
  in_signatures_ind_df = lymphoma_COSMIC_listsList$cohort$out_sig_ind_df,
  in_subgroups_df = COSMIC_subgroups_df)               
```


# Compute the confidence intervals

In order to assess trustworthiness of the computed exposures, YAPSA provides 
the calculation of CIs. Analogously to CIs for SNV 
mutational signatures, the CIs for Indel mutational signatures are computed 
using the concept of profile likelihood. This is performed by the function 
`variateExp()`. 

```{r captionCI, echo=FALSE}
cap <- "Confidence interval calculation for exposures to mutational 
        signatures"
```

```{r computeCI, echo=TRUE, warning=FALSE}
complete_df <- variateExp(
  in_catalogue_df = lymphomaNature2013_mutCat_df,
  in_sig_df = lymphoma_COSMIC_listsList$cohort$signatures,
  in_exposures_df = lymphoma_COSMIC_listsList$cohort$exposures,
  in_sigLevel = 0.025, in_delta = 0.4)
```

Of note and as opposed to the output of the `LCD` function family, the result
of the function `variateExp()` is a data frame in a *long* format, because for 
every combination of a signature and a sample, several values now have to be 
stored:

```{r displayCompleteDf, echo=TRUE, warning=FALSE}
head(complete_df, 12)
```

Here, the column `exposure` contains the values which had been computed before. 
The columms `relLower` and `relUpper` contain the factors with which to 
multiply the exposures in order to get the lower and upper bounds of the 95% 
CIs. The absolute values of these lower and upper bounds are stored in the 
columns `lower` and `upper`.

There also is a custom function to plot exposures with confidence intervals:

```{r plotCI, echo=TRUE, warning=FALSE, fig.width=17, fig.height=15, fig.cap=cap}
plotExposuresConfidence(
  in_complete_df = complete_df, 
  in_subgroups_df = COSMIC_subgroups_df,
  in_sigInd_df = lymphoma_COSMIC_listsList$cohort$out_sig_ind_df)
```

This produces a figure similar to the display of exposures obtained above, but 
in contrast to this former way of displaying signature exposures by stacked 
barplots, here we chose a facet plot with the signatures as rows in order to be 
able to display the CIs, which are indicated as whiskers. We furthermore would 
like to emphasize that if a signature is not present in a sample, i.e., the 
exposure to that signature is 0, then the upper and lower bounds of the 
confidence interval are zero as well.

Of note, the functionality to compute 95% CIs for signature exposures is also 
available for the analysis of Indel mutational signatures, an example is 
provided in the 
[corresponding vignette](vignettes_Indel.html).


# References 

---
title: "4. Stratified Analysis of Mutational Signatures"
author: "Daniel Huebschmann"
date: "30/12/2019"
vignette: >
  %\VignetteIndexEntry{4. Stratified Analysis of Mutational Signatures}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}  
output: 
  BiocStyle::html_document:
    toc: yes
---

```{r loadStyle, warning=FALSE, echo=FALSE, message=FALSE, results="hide"}
library(BiocStyle)
```

```{r packages, include=FALSE}
library(YAPSA)
library(Biostrings)
library(BSgenome.Hsapiens.UCSC.hg19)
library(knitr)
opts_chunk$set(echo=TRUE)
opts_chunk$set(fig.show='asis')
```

# Introduction {#introduction}

For many biological questions, it is of relevance to group mutations, or more 
specifically, single nucleotide variants (SNVs), into different **strata** or 
categories. These strata may be defined by genomic coordinates or other measures 
derived therefrom and annotated to the variants, e.g., replication timing, 
chromatin state, coding vs. non-coding part of the genome etc. Other choices of 
stratification are also possible, as shown below for the example of mutation 
density as stratification axis.

It is noteworthy to say that it would be neither sufficient nor appropriate to 
perform completely separate and independent NNLS analyses of mutational 
signatures on the different strata. This artificially reduces the statistical 
power provided by the higher number of SNVs in the unstratified setting. 
Instead, the results of the unstratified analysis should be used as input and 
supplied to a constrained analysis for the strata.

In YAPSA, these strata or categories have to be exclusive, i.e. one SNV must be 
in one and only one category. The number of strata will be denoted by $s$. For 
example one could evaluate whether an SNV falls into a region of high, 
intermediate or low mutation density by applying meaningful cutoffs on 
intermutation distance. Following this choice, there are three strata: high, 
intermediate and low mutation density. If we have already performed an analysis 
of mutational signatures for the whole (unstratified) mutational catalog of
the cohort, we have identified a set of signatures of interest and the 
corresponding exposures. We now could ask the question if some of the 
signatures are enriched or depleted in one or the other stratum, yielding a 
strata-specific signature enrichment and depletion pattern. In YAPSA, the 
function `SMC` (Stratification of the Mutational Catalogue) solves the 
stratified optimization problem:

(@SMC_formula) $$
\begin{aligned}
\min_{H_{(\cdot j)}^k \in \mathbb{R}^l}||W \cdot H_{(\cdot j)}^{k} - 
V_{(\cdot j)}^{k}|| \quad \forall j,k \\
\textrm{under the constraint of non-negativity:} \quad H_{(ij)}^{k} >= 0 
\quad \forall i,j,k \\
\textrm{and the additional contraint:} \quad \sum_{k=1}^{s} H^{k} = H \\
\textrm{where H is defined by the optimization:} \quad \min_{H_{(\cdot j)} 
\in \mathbb{R}^l}||W \cdot H_{(\cdot j)} - V_{(\cdot j)}|| \quad \forall j \\
\textrm{also under the constraint of non-negativity:} \quad H_{(ij)} >= 0 
\quad \forall i,j \quad \textrm{and} \quad V = \sum_{k=1}^{s} V^{k}
\end{aligned}
$$

As defined in 
[1. Usage of YAPSA](YAPSA.html), 
$j$ is the index over samples, $m$ is the number of samples, $i$ 
is the index over signatures and $l$ is the number of signatures. In addition, 
$k$ is the index over strata and $s$ is the number of strata. Note that the 
last two lines of equation (@SMC_formula) correspond to the unstratified 
optimization problem. The very last part of equation (@SMC_formula) reflects the 
additivity of the stratified mutational catalogs $V^{k}$ which is due to the 
fact that by definition the sets of SNVs they were constructed from (i.e. the 
strata) are exclusive.

The SMC-procedure can also be applied when an NMF analysis has been performed 
and the exposures $\widetilde{H}$ of this NMF analysis should be used as input 
and constraint for the SMC. It then solves the task:

(@SMC_NMF_input_formula) $$
\begin{aligned}
\min_{H_{(\cdot j)}^k \in \mathbb{R}^l}||W \cdot H_{(\cdot j)}^{k} - 
V_{(\cdot j)}^{k}|| \quad \forall j,k \\
\textrm{under the constraint of non-negativity:} \quad H_{(ij)}^{k} >= 0 
\quad \forall i,j,k \\
\textrm{and the additional contraint:} \quad 
\sum_{k=1}^{s} H^{k} = \widetilde{H} \\
\end{aligned}$$


Applying `SMC` that way, the initial LCD decomposition of the unstratified 
mutational catalog is omitted and it's result replaced by the exposures 
extracted by the NMF analysis.



# Recap: compute signature exposures (without stratification)

In the following section, we briefly recapitulate the analysis of SNV 
mutational signatures on an example data set as performed in 
[1. Usage of YAPSA](YAPSA.html).
We thus first load the example data stored in the package:

```{r, loadStoredSigData}
data(sigs)
data(cutoffs)
data("lymphomaNature2013_mutCat_df")
current_cutoff_vector <- cutoffCosmicValid_abs_df[6,]
```

We then perform a supervised analysis of SNV mutational signatures using 
signature-specific cutoffs:

```{r LCDwithCutoffs}
lymphoma_COSMIC_listsList <-
  LCD_complex_cutoff_combined(
      in_mutation_catalogue_df = lymphomaNature2013_mutCat_df,
      in_cutoff_vector = current_cutoff_vector, 
      in_signatures_df = AlexCosmicValid_sig_df, 
      in_sig_ind_df = AlexCosmicValid_sigInd_df)
```

We assign subgroups to the different samples:

```{r subrgroupAnnotation}
data(lymphoma_PID)
colnames(lymphoma_PID_df) <- "SUBGROUP"
lymphoma_PID_df$PID <- rownames(lymphoma_PID_df)
COSMIC_subgroups_df <- 
  make_subgroups_df(lymphoma_PID_df,
                    lymphoma_COSMIC_listsList$cohort$exposures)
```

And finally plot the obtained result:

```{r captionExposures, echo=FALSE}
cap <- "Exposures to SNV mutational signatures"
```

```{r exposuresCutoffs, warning=FALSE, fig.width=8, fig.height=6, fig.cap= cap}
exposures_barplot(
  in_exposures_df = lymphoma_COSMIC_listsList$cohort$exposures,
  in_signatures_ind_df = lymphoma_COSMIC_listsList$cohort$out_sig_ind_df,
  in_subgroups_df = COSMIC_subgroups_df)               
```


# Stratified analysis of mutational signatures

## Preparation

The functions for the stratified analysis access the raw data in order to 
provide the highest degree of flexibility for the definition of the strata 
themselves. Therefore we have to repeat the formatting steps already performed 
in the [first vignette](YAPSA.html). 

```{r formatRaw, warning=FALSE, fig.width=8, fig.height=6, fig.cap= cap}
data("lymphoma_Nature2013_raw")
names(lymphoma_PID_df) <- gsub("SUBGROUP", "subgroup", names(lymphoma_PID_df))
names(lymphoma_Nature2013_raw_df) <- c("PID","TYPE","CHROM","START",
                                       "STOP","REF","ALT","FLAG")
lymphoma_Nature2013_df <- subset(lymphoma_Nature2013_raw_df,TYPE=="subs",
                                 select=c(CHROM,START,REF,ALT,PID))
names(lymphoma_Nature2013_df)[2] <- "POS"
lymphoma_Nature2013_df$SUBGROUP <- "unknown"
DLBCL_ind <- grep("^DLBCL.*",lymphoma_Nature2013_df$PID)
lymphoma_Nature2013_df$SUBGROUP[DLBCL_ind] <- "DLBCL_other"
MMML_ind <- grep("^41[0-9]+$",lymphoma_Nature2013_df$PID)
lymphoma_Nature2013_df <- lymphoma_Nature2013_df[MMML_ind,]
for(my_PID in rownames(lymphoma_PID_df)) {
  PID_ind <- which(as.character(lymphoma_Nature2013_df$PID)==my_PID)
  lymphoma_Nature2013_df$SUBGROUP[PID_ind] <-
    lymphoma_PID_df$subgroup[which(rownames(lymphoma_PID_df)==my_PID)]
}
lymphoma_Nature2013_df$SUBGROUP <- factor(lymphoma_Nature2013_df$SUBGROUP)
lymphoma_Nature2013_df <- translate_to_hg19(lymphoma_Nature2013_df,"CHROM")
lymphoma_Nature2013_df$change <- 
  attribute_nucleotide_exchanges(lymphoma_Nature2013_df)
lymphoma_Nature2013_df <- 
  lymphoma_Nature2013_df[order(lymphoma_Nature2013_df$PID,
                               lymphoma_Nature2013_df$CHROM,
                               lymphoma_Nature2013_df$POS),]
lymphoma_Nature2013_df <- annotate_intermut_dist_cohort(lymphoma_Nature2013_df,
                                                        in_PID.field="PID")
data("exchange_colour_vector")
lymphoma_Nature2013_df$col <- 
  exchange_colour_vector[lymphoma_Nature2013_df$change]
```


## Performing a stratification based on mutation density

We will now use the intermutational distances computed above. We set cutoffs 
for the intermutational distance at 1000 and 100000 bp, leading to three 
strata. We annotate to every variant in which stratum it falls.

```{r stratifyMutDensity}
lymphoma_Nature2013_df$density_cat <- cut(lymphoma_Nature2013_df$dist,
                                          c(0,1001,100001,Inf),
                                          right=FALSE,
                                          labels=c("high","intermediate",
                                                   "background"))
```

The following table shows the distribution of variants over strata:

```{r tableStrataMutDensity}
temp_df <- data.frame(table(lymphoma_Nature2013_df$density_cat))
names(temp_df) <- c("Stratum","Cohort-wide counts")
kable(temp_df, caption=paste0("Strata for the SMC of mutation density"))
```

We now have everything at hand to carry out a stratified signature analysis:

```{r captionSMC, echo=FALSE}
cap="SMC (Stratification of the Mutational Catalogue)
        based on mutation density."
```

```{r SMC, results="hide",warning=FALSE,fig.width=8,fig.height=7,fig.cap=cap}
strata_order_ind <- c(1,3,2)
mut_density_list <- run_SMC(lymphoma_Nature2013_df,
                            lymphoma_COSMIC_listsList$cohort$signatures,
                            lymphoma_COSMIC_listsList$cohort$out_sig_ind_df,
                            COSMIC_subgroups_df,
                            column_name="density_cat",
                            refGenome=BSgenome.Hsapiens.UCSC.hg19,
                            cohort_method_flag="norm_PIDs",
                            in_strata_order_ind=strata_order_ind)
```

This produces a multi-panel figure with 
`r length(unique(lymphoma_Nature2013_df$density_cat))+1` rows of plots. The 
first row visualizes the signature distribution over the whole cohort without 
stratification, followed by one row of plots per stratum. Hence in our example 
we have four rows of graphs with three (exclusive) strata as input. Each row 
consists of three plots. The left plots show absolute exposures in the 
respective stratum as stacked barplots on a per sample basis. The middle plots 
show relative exposures in the respective stratum on a per sample basis as 
stacked barplots. The right plots shows cohort-wide averages of the relative 
exposures in the respective stratum. The error bars indicate the standard error
of the mean (SEM).

These results can also be displayed as a dodged barplot containing the 
information of the third column of plots in the above figure, which needs 
the execution of an additional code block for its generation:

```{r captionSMCdodged, echo=FALSE}
cap = "SMC results displayed as dodged plot."
```

```{r SMCdodged, results="hide",warning=FALSE,fig.width=8,fig.height=7,fig.cap=cap}
dodged_df <- do.call(rbind, mut_density_list$cohort)
names(dodged_df) <- gsub("variable","stratum", names(dodged_df))
names(dodged_df) <- gsub("sig","signature", names(dodged_df))
dodged_df$stratum <- gsub("_rel", "", as.character(dodged_df$stratum))
dodged_df <- dodged_df[which(dodged_df$stratum != "all"),]
dodged_df$stratum <-
  factor(as.character(dodged_df$stratum),
         levels = sort(unique(dodged_df$stratum))[rev(strata_order_ind)])
dodged_plot <- ggplot() +
  geom_bar(data = dodged_df,
           aes_string(x = "signature", y = "exposure",
                      group = "stratum", fill = "stratum"),
           stat = "identity", position = "dodge", size = 1.5) +
  geom_errorbar(data = dodged_df,
                aes_string(x = "signature", ymin = "exposure_min",
                           ymax = "exposure_max",
                           group = "stratum"),
                position = position_dodge(width = 0.9), width = 0.3) +
  labs(y = "relative exposures")
if(exists("current_strata_colVector")){
  dodged_plot <- dodged_plot +
    scale_fill_manual(values = current_strata_colVector[-1],
                      labels = current_labelVector[-1]
                                [current_strata_order_ind])
}
print(dodged_plot)
```


## Testing for statistical significance of enrichment and depletion patterns

To test for statistical significance of potential differences in the signature 
exposures (i.e. signature enrichment and depletion patterns) between the 
different strata, we can use the Kruskal-Wallis test, as the data is grouped 
into (potentially more than two) categories and might not follow a normal 
distribution. As we are testing the different signatures on the same 
stratification, we have to correct for multiple testing. In order to control 
the false discovery rate (FDR), the Benjamini-Hochberg correction is 
appropriate.

```{r statSMCmutDensity, warning=FALSE, message=FALSE}
stat_mut_density_list <- stat_test_SMC(mut_density_list,in_flag="norm")
kable(stat_mut_density_list$kruskal_df,
      caption=paste0("Results of Kruskal tests for cohort-wide exposures over",
                     " strata per signature without and with correction for ",
                     "multiple testing."))
```

In the following paragraph we perform post-hoc tests for those signatures where
the Kruskal-Wallis test, as evaluated above, has given a significant result.
\newpage

```{r postHocMutDensity}
significance_level <- 0.05
for(i in seq_len(dim(stat_mut_density_list$kruskal_df)[1])){
  if(stat_mut_density_list$kruskal_df$Kruskal_p_val_BH[i]<significance_level){
    print(paste0("Signature: ",rownames(stat_mut_density_list$kruskal_df)[i]))
    print(stat_mut_density_list$kruskal_posthoc_list[[i]])
  }
}
```


From this analysis, we can see that a distinct signature enrichment and 
depletion pattern emerges:

1. Stratum of high mutation density: Enrichment of signatures AC5 and depletion 
of signatures AC1 (significant) and AC17
2. Background: signature distribution very similar to the one of the complete 
mutational catalog (first row)
3. Stratum of intermediate mutation density: intermediate signature enrichment 
and depletion pattern between the strata of high mutation density and 
background. 

---
title: "2. Signature-specific cutoffs"
author: "Lea Jopp-Saile and Daniel Hübschmann"
date: "27/11/2019"
vignette: >
  %\VignetteIndexEntry{2. Signature-specific cutoffs}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}  
output: 
  BiocStyle::html_document:
    toc: yes
    
references:
- author:
  - family: Alexandrov
    given: LB
  - family: Nik-Zainal
    given: S
  - family: Wedge
    given: DC
  - family: Aparicio
    given: SA
  - family: Behjati
    given: S
  - family: Biankin
    given: AV
  - family: Bignell
    given: GR
  - family: Bolli
    given: N
  - family: Borg
    given: A
  - family: Borresen-Dale
    given: AL
  - family: Boyault
    given: S
  - family: Burkhardt
    given: B
  - family: Butler
    given: AP
  - family: Caldas
    given: C
  - family: Davies
    given: HR
  - family: Desmedt
    given: C
  - family: Eils
    given: R
  - family: Eyfjörd
    given: JE
  - family: Greaves
    given: M
  - family: Hosoda
    given: F
  - family: Hutter
    given: B
  - family: Ilicic
    given: T
  - family: Imbeaud
    given: S
  - family: Imielinski
    given: M
  - family: Jäger
    given: N
  - family: Jones
    given: DT
  - family: Jones
    given: D
  - family: Knappskog
    given: S
  - family: Kool
    given: M
  - family: Lakhani
    given: SR
  - family: Lopez-Otin
    given: C
  - family: Martin
    given: S
  - family: Munshi
    given: NC
  - family: Nakamura
    given: H
  - family: Northcott
    given: PA
  - family: Pajic
    given: M
  - family: Papaemmanuil
    given: E
  - family: Paradiso
    given: A
  - family: Pearson
    given: JV
  - family: Puente
    given: XS
  - family: Raine
    given: K
  - family: Ramakrishna
    given: M
  - family: Richardson
    given: AL
  - family: Richter
    given: J
  - family: Rosenstiel
    given: P
  - family: Schlesner
    given: M
  - family: Schumacher
    given: TN
  - family: Span
    given: PN
  - family: Teague
    given: JW
  - family: Tokoti
    given: Y
  - family: Tutt
    given: AN
  - family: Valdes-Mas
    given: R
  - family: van Buuren
    given: MM
  - family: van't Veer
    given: L
  - family: Vincent-Salomon
    given: A
  - family: Waddell
    given: N
  - family: Yates
    given: LR
  - family: Australian Pancreatic Cancer Initiative
    given: 
  - family: ICGC Breast Cancer Consortium
    given: 
  - family: ICGC MMML-Seq Consortium
    given: 
  - family: ICGC PedBrain
    given: 
  - family: Zucman-Rossi
    given: J
  - family: Futreal
    given: PA
  - family: McDermott
    given: U
  - family: Lichter
    given: P
  - family: Meyerson
    given: M
  - family: Grimmond
    given: SM
  - family: Siebert
    given: R
  - family: Campo
    given: E
  - family: Shibata
    given: T
  - family: Pfister
    given: SM
  - family: Campbell
    given: PJ
  - family: Stratton
    given: MR
  container-title: Nature
  id: Alex2013
  issued:
    month: 08
    volume: 500
    year: 2013
  publisher: Nature Publishing Group
  title: 'Signatures of Mutational Processes in Cancer'
- author:
  - family: Alexandrov
    given: LB
  - family: Kim
    given: J
  - family: Haradhvala
    given: NJ
  - family: Huang
    given: MN
  - family: Ng
    given: AW
  - family: Boot
    given: A
  - family: Covington
    given: KR
  - family: Gordenin
    given: DA
  - family: Bergstrom
    given: E
  - family: Lopez-Bigas
    given: N
  - family: Klimczak
    given: LJ
  - family: McPherson
    given: JR
  - family: Morganella
    given: S
  - family: Sabarinathan
    given: R
  - family: Wheeler
    given: DA
  - family: Mustonen
    given: V
  - family: Getz
    given: G
  - family: Rozen
    given: SG
  - family: Stratton
    given: MR
  container-title: Nature
  id: Alex2020
  issued:
    month: 02
    year: 2020
  title: 'The Repertoire of Mutational Signatures in Human Cancer'
- author:
  - family: Alexandrov
    given: LB
  - family: Nik-Zainal
    given: S
  - family: Wedge
    given: DC
  - family: Campbell
    given: PJ
  - family: Stratton
    given: MR
  container-title: Cell Reports
  id: Alex_CellRep2013
  issued:
    year: 2013
  title: > 
    Deciphering signatures of mutational processes operative in human cancer
- author:
  - family: Wang
    given: Yong
  - family: Lawson
    given: Charles L.
  - family: Hanson
    given: Richard J
  container-title: R-package version 1.1-1
  id: lsei_package2015
  issued:
    year: 2015
  title: >
    lsei: Solving Least Squares Problems under Equality/Inequality Constraints
- author:
  - family: Sing
    given: Tobias
  - family: Sander
    given: Oliver
  - family: Beerenwinkel
    given: Niko
  - family: Lengauer
    given: Thomas
  container-title: Bioinfomatics
  id: ROCR_package2005
  issued:
      year: 2005
  title: >
    ROCR: visualizing classifier performance in R
---

```{r loadStyle, warning=FALSE, echo=FALSE, message=FALSE, results="hide"}
library(BiocStyle)
```

```{r packages, include=FALSE}
library(YAPSA)
library(knitr)
library(gridExtra)
library(dplyr)
opts_chunk$set(echo=TRUE)
opts_chunk$set(fig.show='asis')
```

# Introduction {#introduction}

The vignette 
[1. Usage of YAPSA](YAPSA.html) 
describes the general usage of YAPSA as a tool
to perform supervised analyses of mutational signatures. Calling of mutational
signature in YAPSA is performed with a Non-Negative Least Square (NNLS) 
algorithm implemented in the function  **l**inear **c**ombination 
**d**ecomposition (`LCD`) function based on the function `lsei` from the package 
`r CRANpkg("lsei")` [@lsei_package2015]. The function `LCD` can take 
signature-specific cutoffs as optional arguments. When choosing optimal cutoffs,
this can lead to an increase in sensitivity and specificity as compared to NNLS 
alone. In such a context, `LCD` then determines the exposure, i.e., the 
contribution of signature to the mutational load of a samples, in a three-step 
computational process: 

1. Find an NNLS solution with all supplied signatures using LCD
1. Identify those signatures which have a contribution higher than a
signature-specific cutoff
1. Rerun NNLS based on the selected subset of signatures

Mutational signatures as provided by 
https://cancer.sanger.ac.uk/cosmic/signatures have been extracted by 
Non-negative Matrix Factorization (NMF). Due to the constraint of 
non-negativity, these signatures cannot be orthogonal. However, orthogonality 
is a prerequisite or at least beneficial for least squares algorithms. This 
lack of orthogonality leads to potential overlapping of the signature in a 
deconvolution.

Different signatures have different detectability. Those with high detectability
will occur as false positive calls more often. In order to account for the 
different detectability, we introduced the concept of signature-specific 
cutoffs: a signature which leads to many false positive calls has to cross a 
higher threshold than a signature which rarely leads to false positive calls. 
For YAPSA, we have computed optimal signature cutoffs by a modfied Reciever 
Operating Characteristic (ROC) analysis on the same data as 
it had been used for the initial NMF analyses with the extraction of the 
published mutational signatures ([@Alex2013] and [@Alex2020]). 
Numeric values for these cutoffs are stored in dataframes accessible after 
loading the package YAPSA.  

In the implementation of the package `r CRANpkg("ROCR")` [@ROCR_package2005], a 
modified ROC analysis is parametrized by defining cost terms for punishing 
false-negative ($cost_{FN}$) and false-positive ($cost_{FP}$) findings 
separately. In the following, we will call the ratio between the cost for a 
false-negative finding divided by the cost for a false positive finding the 
$cost_{factor}$ ($cost_{factor} = cost_{FN}/cost_{FP}$). Separate ROC analyses 
were performed for every signature. For every signature, the global minimum
of the cost function defines the optimal value for the signature-specific 
cutoff. However, the shape of the cost function and hence the position of its 
minimum depend on $cost_{factor}$. Therefore there is one set of optimal 
signature-specific cutoffs per chosen value of $cost_{factor}$ 
([cf. below](#OptimalCutoffs)).

After having computed the optimal signature-specific cutoffs for a range of 
values for $cost_{factor}$, we applied an additional criterion in order to get 
an optimal value for $cost_{factor}$: minimization of the overall number of 
false attributions. Using this criterion, for the Alexandrov COSMIC signatures 
(`AC1 - AC30`), the optimal value for $cost_{factor}$ was determined to be $6$.


# Overview of the data {#DataOverview}

## Signatures

In YAPSA, the patterns of nucleotide exchanges in their triplet context 
constituting the mutational signatures are stored in data frames which can be 
loaded as follows (more information provided by the help function, cf. 
([1. Usage of YAPSA](YAPSA.html))
for an overview of how these data frames can be re-created from data available 
online):

```{r loadSignatures}
data(sigs)
data(sigs_pcawg)
```

The first command, `data(sigs)`, loads eight dataframes into the workspace. 
Among these, four contain the patterns of nucleotide exchanges in their triplet 
context, i.e., the mutational signatures themselves, and the remaining
four dataframes contain additional information on the signatures, including a 
naming and numbering convention, a description of the asserted underlying 
mutational process and a choice of generic colour coding. In particular, these 
eight signature dataframes are:

* Two signature and two additonal information dataframes containing SNV 
Alexandrov COSMIC signatures (available at 
<https://cancer.sanger.ac.uk/cosmic/signatures_v2>, downloaded on January 
15th, 2016): 
    * `AlexCosmicArtif_sig_df` and `AlexCosmicArtif_sigInd_df`,
    * `AlexCosmicValid_sig_df` and `AlexCosmicValid_sigInd_df`

* Two signature and two additonal information dataframes containing SNV
Alexadrov Initial signatures (the signatures presented in the initial 
publication [@Alex2013]): 
    * `AlexInitialArtif_sig_df` and `AlexInitialArtif_sigInd_df`,
    * `AlexInitialValid_sig_df` and `AlexInitialValid_sigInd_df`
    
Of note, all data provided in YAPSA follows a consistent naming convention:

* Names containing `Valid` or `Real` refer to those subsets of signatures which 
have been identified by NMF in the respective discovery analyses and validated 
using orthogonal sequencing technologies.
* Names containing `Artif` refer to extended sets of signatures including also 
those signatures which have later been ascribed to be artifact signatures 
(reflecting, among others, sequencing errors).

The second command in the above code block, `data(sigs_pcawg)`, loads six 
additional dataframes into the workspace, three dataframes containing 
mutational signatures themselves and three dataframes containing additional 
information on the signatures. In particular, these six dataframes are:

* Two signature and two additional information dataframes containing SNV 
Alexandrov PCAWG signatures (available at 
<https://cancer.sanger.ac.uk/cosmic/signatures_v3>, downloaded on August 16th, 
2018): 
    * `PCAWG_SP_SBS_sigs_Artif_df` and `PCAWG_SP_SBS_sigInd_Artif_df`,
    * `PCAWG_SP_SBS_sigs_Real_df` and `PCAWG_SP_SBS_sigInd_Real_df`

* One signature and one additional information dataframe containing Indel 
Alexandrov PCAWG signatures (also available at 
<https://cancer.sanger.ac.uk/cosmic/signatures_v3>, downloaded
on August 16th, 2018): 
    * `PCAWG_SP_ID_sigs_df` and `PCAWG_SP_ID_sigInd_df`

As of december 2019 and to our knowledge, it is a unique feature of YAPSA to 
include PCAWG mutational signatures. Of note, a 
[separate vignette](vignettes_Indel.html) describes the usage of and analysis with Indel signatures.


## Optimal cutoffs {#OptimalCutoffs}

For each of the signature dataframes, corresponding dataframes storing 
numerical values of the signature-specific cutoffs are available. The cutoff 
dataframes can be loaded to the workspace analogously to the signatures 
themselves:

```{r loadCutoffs}
data(cutoffs)
data(cutoffs_pcawg)
```

The command `data(cutoffs)` loads cutoff dataframes corresponding to the four 
Alexandrov COSMIC and Alexandrov initial sets of signatures. In the following, 
an additional naming convention is introduced: 

* Absolute (abs) signature-specific cutoffs were computed using an ROC analysis 
performed on absolute exposures as provided by the initial NMF analysis
* Relative (rel) signature-specific cutoffs were computed using on ROC analysis 
performed on relative, i.e., normalized exposures as provided by the initial 
NMF analysis.

This double training has proven to be both useful and necessary in order to 
account for the heterogeneity of the underlying training data: on one hand, a 
training with absolute exposures weighs all mutations equally, however a whole 
genome sequenced (WGS) sample gets a much higher weight due to the high number 
of mutations detected in it than a whole exome sequenced (WES sample). On the 
other hand, a training with relative or normalized signature exposures weighs 
all samples equally, but at the cost of having different weights for mutations 
originating from samples of different mutation count. Based on these 
considerations, cutoffs derived from the training with absolute exposures 
should be used for the supervised analysis of WGS data, whereas cutoffs trained 
on relative exposures are better suited for the analysis of WES data. The two 
different sets of cutoffs thus account for the different maximal feature 
occurrence between WGS and WES data. The correspondence between signatures and 
cutoffs is as follows:

* For `AlexCosmicValid_sig_df`, the corresponding cutoff dataframes are
`cutoffCOSMICValid_abs_df` and `cutoffCOSMICValid_rel_df`.  
* For `AlexCosmicArtif_sig_df`, the corresponding cutoff dataframes are
`cutoffCOSMICArtif_abs_df` and `cutoffCOSMICArtif_rel_df`.

With `data(cutoffs_pcawg)` the signature-specific cutoff dataframes for the
PCAWG signatures are loaded. In this case, only one dataframe with cutoffs per
signature dataframe is available. Signature-specific cutoffs are valid for WGS
and WES data analysis as differences in the feature occurrence is taken into
account during the training procedure.

In the provided dataframes with numerical values for optimal signature-specific 
cutoffs, the columns correspond to the different signatures of the chosen 
signature set, whereas the rows encode different values of $cost_{factor}$ 
(cf. [introduction](#introduction)). For an actual analysis of mutational signatures, only one 
optimal cutoff value per signature is required, i.e., the user has to choose 
one row from the chosen cutoff dataframe. As already explained above, optimal 
values for $cost_{factor}$ have also been determined. These are listed in the 
table below. Unless a user has a specific wish to use a different 
$cost_{factor}$, it is generally recommended to use these default parameter 
choices.

cutoff dataframe   | optimal cost factor
------- | -----
cutoffInitialValid_abs_df | 6
cutoffInitialValid_rel_df | 6
cutoffInitialArtif_abs_df | 6
cutoffInitialArtif_rel_df | 6
cutoffCosmicValid_abs_df | 6
cutoffCosmicValid_rel_df | 6
cutoffCosmicArtif_abs_df | 6
cutoffCosmicArtif_rel_df | 6
cutoffPCAWG_SBS_WGSWES_realPid_df | 10
cutoffPCAWG_SBS_WGSWES_artiflPid_df | 16
cutoffPCAWG_ID_WGS_Pid_df | 3

: (\#tab:Table:) Overview of signature specific cutoffs and the cost factor to
obtain the optimal cutoffs.

Thus, if a user wants to do an analysis with the Alexandrov COSMIC signatures, 
discarding the artifact signatures, on WGS data, he/she would use the following 
code snippet:

```{r cutoffExample}
data(cutoffs)
current_cutoff_vector <- cutoffCosmicValid_abs_df[6, ]
current_cutoff_vector
```



# Application example

The vignette 
[1. Usage of YAPSA](YAPSA.html) 
shows how to obtain a mutational catalog ($V$) from a
vcf file. Here, for the sake of simplicits, we just use an example data set 
stored in the software package. 

```{r loadData}
data(lymphomaNature2013_mutCat_df)
```

The mutational catalog $V$ together with the signatures $V$ and the
corresponding signature-specific cutoffs can be used to determine the signature
exposures (corresponding to the matrix $H$ in the naming convention influenced 
by NMF) per sample or cohort. This is done by the function 
`LCD_complex_cutoff_combined`.

In the examples provided in 
[1. Usage of YAPSA](YAPSA.html), 
signature exposures were determined (i) with a zero cutoff vector, i.e. without
signature-specific cutoffs or (ii) with a manually chosen but not necessarily 
optimal cutoff. In contrast, in the following, we will perform an analysis of 
mutational signatures using optimal cutoffs and compare the results to an 
analysis without any cutoffs.

```{r setVariables }
current_sig_df <- AlexCosmicValid_sig_df
current_sigInd_df <- AlexCosmicValid_sigInd_df
```


## Comparison: analysis without any cutoffs {#comparisonZeroCutoffs}

For the purpose of comparison, we first create a zero cutoff vector:

```{r cutoffVector}
current_cutoff_vector <- rep(0, dim(AlexCosmicValid_sig_df)[2])
```

Next, we compute the exposures to the mutational signatures using LCD analysis 
and this zero cutoff vector:

```{r lymphomaCohortLCD_results}
lymphoma_COSMIC_zero_listsList <-
  LCD_complex_cutoff_combined(
    in_mutation_catalogue_df = lymphomaNature2013_mutCat_df,
    in_cutoff_vector = current_cutoff_vector, 
    in_signatures_df = current_sig_df, 
    in_sig_ind_df = current_sigInd_df)
```

The function returns an object with the results per cohort, per PID and the
consensus between both analyses.

Annotation of a subgroup to each PID allows to group the samples per subgroup 
upon visualization:

```{r subrgroupAnnotation}
data(lymphoma_PID)
colnames(lymphoma_PID_df) <- "SUBGROUP"
lymphoma_PID_df$PID <- rownames(lymphoma_PID_df)
COSMIC_subgroups_df <- 
  make_subgroups_df(lymphoma_PID_df,
                    lymphoma_COSMIC_zero_listsList$cohort$exposures)
```

```{r captionBarplot2, echo=FALSE}
cap <- "Absoute exposures of the COSMIC signatures in the lymphoma mutational
        catalogs, signature-specific cutoffs with a cost factor of 6 used
        for the LCD"
```

We select the cohort-wide analysis for visualization and make use of the custom 
plotting function `exposures_barplot()` in order to display signature exposures 
as stacked barplots. Note the occurrence of multiple signatures with partially 
very low exposures.

```{r exposuresZero, warning=FALSE, fig.width=8, fig.height=6, fig.cap = cap}
result_cohort <- lymphoma_COSMIC_zero_listsList$cohort
exposures_barplot(
  in_exposures_df = result_cohort$exposures,
  in_signatures_ind_df = result_cohort$out_sig_ind_df,
  in_subgroups_df = COSMIC_subgroups_df)        
```


## Making use of optimal signature-specific cutoffs {#optimalSpecificCutoffs}

The zero-cutoff vector will now be replaced by the signature-specific cutoff
vector. After the initial LCD analysis only signatures that contribute higher
then their signature specific cutoff value will be considered, leading to a
reduction of the overall number of detected signatures.

Based on \@ref(tab:Table1) we know that for the validated COSMIC Signatures the
optimal cutoffs are the once computed with a cost factor of six. 

```{r setSignatureSpecificCutoffs}
current_cutoff_df <- cutoffCosmicValid_abs_df
current_cost_factor <- 6
current_cutoff_vector <- current_cutoff_df[current_cost_factor,]
```

We again compute signature exposures, but this time using the vector of optimal 
signature-specific cutoffs:

```{r LCDwithCutoffs}
lymphoma_COSMIC_listsList <-
  LCD_complex_cutoff_combined(
      in_mutation_catalogue_df = lymphomaNature2013_mutCat_df,
      in_cutoff_vector = current_cutoff_vector, 
      in_signatures_df = current_sig_df, 
      in_sig_ind_df = current_sigInd_df)
```

And again proceeding to a visualization (of note, the sample subgrouping 
information can be used as in the previous subsection):

```{r captionBarplot, echo=FALSE}
cap <- "Absolute exposures of the COSMIC signatures in the lymphoma mutational
        catalogs, signature-specific cutoffs with a cost factor of 6 used
        for the LCD"
```

```{r exposuresCutoffs, warning=FALSE, fig.width=8, fig.height=6, fig.cap= cap}
result_cohort <- lymphoma_COSMIC_listsList$cohort
exposures_barplot(
  in_exposures_df = result_cohort$exposures,
  in_signatures_ind_df = result_cohort$out_sig_ind_df,
  in_subgroups_df = COSMIC_subgroups_df)               
```

We note that the number of identified signatures is smaller. 
Those signatures which had been identified in 
[the analysis without any cutoffs](#comparisonZeroCutoffs) but not in 
[the analysis with optimal cutoffs](#optimalSpecificCutoffs) can be considered 
false positive calls. 


# Reference

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_functions.R
\name{add_annotation}
\alias{add_annotation}
\title{Add information to an annotation data structure}
\usage{
add_annotation(
  in_annotation_col,
  in_annotation_df,
  in_attribution_vector,
  in_colour_vector,
  in_name
)
}
\arguments{
\item{in_annotation_col}{List, every element of which refers to one layer 
of annotation List elements are structures corresponding to named colour
vectors}

\item{in_annotation_df}{Data frame, every column of which corresponds to a
layer of annotation. It has as many rows as there are samples, every 
entry in a row corresponding to the attribute the samples has for the
corresponding layer of annotation.The factor levels of a column of
\code{in_annotation_df} correspond to the names of the corresponding
element in \code{in_annotation_col}}

\item{in_attribution_vector}{A vector which is going to be cbinded to
\code{in_annotatiin_df}, carrying the annotation information of the new
layer to be added}

\item{in_colour_vector}{Named vector of colours to be attributed to the new
annotation}

\item{in_name}{Name of the new layer of annotation}
}
\value{
A list with entries \itemize{ \item \code{annotation_col}: A list 
  as in \code{in_annotation_col} but with one additional layer of annotation
  \item \code{annotation_df}: A data frame as in \code{in_annotation_df}
  but with one additional layer of annotation}
}
\description{
Function to iteratively add information to an annotation data structure as
needed for \code{\link[ComplexHeatmap]{HeatmapAnnotation}} and especially 
for \code{\link{annotation_exposures_barplot}}
}
\examples{
 NULL

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/pkgname.R
\docType{package}
\name{YAPSA}
\alias{YAPSA}
\title{Generate R documentation from inline comments.}
\description{
Yet Another Package for mutational Signature analysis
}
\details{
This package provides functions and routines useful in 
the analysis of mutational signatures (cf. L. Alexandrov et al., Nature 
2013). In particular, functions to perform a signature analysis with 
known signatures (\code{\link{LCD}} = linear combination decomposition) and 
a signature analysis on stratified mutational catalogue 
(\code{\link{run_SMC}} = stratify mutational catalogue) are provided.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SMC.R
\name{stat_test_SMC}
\alias{stat_test_SMC}
\title{Apply statistical tests to a stratification (SMC)}
\usage{
stat_test_SMC(in_strat_list, in_flag = "norm")
}
\arguments{
\item{in_strat_list}{A list with entries \code{exposures_list},
\code{catalogues_list}, \code{cohort} and \code{name_list} as in the output
of \code{\link{run_SMC}}. \itemize{ \item \code{exposures_list}: The list
of \code{s} strata specific exposures Hi, all are numerical data frames
with \code{l} rows and \code{m} columns, \code{l} being the number of
signatures and \code{m} being the number of samples \item
\code{catalogues_list}: A list of \code{s} strata specific cohortwide (i.e.
averaged over cohort) normalized exposures \item \code{cohort}:
\code{subgroups_df} adjusted for plotting \item \code{name_list}: Names of
the contructed strata. }}

\item{in_flag}{If "norm", all tests are performed on normalized exposures,
otherwise the absolute exposures are taken.}
}
\value{
A list with entries \code{kruskal_df}, \code{shapiro_df},
  \code{kruskal_posthoc_list}, \itemize{ \item \code{kruskal_df}: A data
  frame containing results (statistic and p values) of the Kruskal Wallis
  tests (tests for enrichment or depletion in the different strata for every
  signature independently). \item \code{shapiro_df}: A data frame containing
  results (p values) of the Shapiro Wilk tests (tests for normal distribution
  in the different strata for every signature independently). \item
  \code{kruskal_posthoc_list}: A list of results of pairwise posthoc tests
  carried out for those signatures where the Kruskal Wallis test yielded a
  significant p-value (carried out by
  \code{\link[PMCMRplus]{kwAllPairsNemenyiTest}}). }
}
\description{
\code{stat_test_SMC} tests for enrichment or depletion in the different
strata of a stratification of the mutational catalogue for every signature
independently by applying Kruskal Wallis tests. For those signatures where
the Kruskal Wallis test gives a significant p-value, pairwise posthoc tests
are carried out by calling \code{\link[PMCMRplus]{kwAllPairsNemenyiTest}}.
Additionally all data is tested for normality by Shapiro Wilk tests, so that
the user may apply ANOVA and pairwise posthoc t-test where allowed.
}
\examples{
 NULL

}
\seealso{
\code{\link{run_SMC}}

\code{\link[PMCMRplus]{kwAllPairsNemenyiTest}}

\code{\link[stats]{kruskal.test}}

\code{\link{shapiro_if_possible}}

\code{\link[stats]{shapiro.test}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/indel_functions.R
\name{getSequenceContext}
\alias{getSequenceContext}
\title{Extracts the sequence context up and downstream of a nucleotide position}
\usage{
getSequenceContext(position, chr, offsetL = 10, offsetR = 50)
}
\arguments{
\item{position}{Start position of the considered INDEL}

\item{chr}{Chromosome of the considered INDEL}

\item{offsetL}{Number of nucleotides downstream of \code{position}}

\item{offsetR}{Number of nucleotides upstream of \code{position}}
}
\value{
Returns a character string containing the defined seqeunce context
}
\description{
Extracts the sequence context up and downstream of a nucleotide position
}
\examples{
library(Biostrings)
library(BSgenome.Hsapiens.UCSC.hg19)

sequence_context <- getSequenceContext(position = 123456789, chr = "chr12",
                                       offsetL= 10, offsetR=50)
sequence_context

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\name{exome_mutCatRaw_df}
\alias{exome_mutCatRaw_df}
\title{Example mutational catalog for the exome vignette}
\usage{
data(smallCellLungCancerMutCat_NatureGenetics2012)
}
\value{
A data fame in the layout of a SNV mutational catalog
}
\description{
\code{exome_mutCatRaw_df}: A data frame in the format of a SNV mutation 
catalog. The mutational catalog contains SNV variants from a cohort of 
small-cell lung cancer published by Rudin et al. (Nature Genetics 2012) 
which was later used in the de novo discovery analysis of mutational 
signatures in human cancer by Alexandrov et al. (Nature 2013).
}
\examples{
data(smallCellLungCancerMutCat_NatureGenetics2012)
head(exome_mutCatRaw_df)
dim(exome_mutCatRaw_df)

}
\references{
\url{https://www.nature.com/articles/ng.2405}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/basic_functions.R
\name{cosineDist}
\alias{cosineDist}
\title{Compute the cosine distance of two vectors}
\usage{
cosineDist(a, b)
}
\arguments{
\item{a, b}{Numerical vectors of same length}
}
\value{
The scalar product of the two input vectors divided by the
       product of the norms of the two input vectors
}
\description{
Compute the cosine distance of two vectors
}
\examples{
## 1. Orthogonal vectors:
cosineDist(c(1,0),c(0,1))
## 2. Non-orthogonal vectors:
cosineDist(c(1,0),c(1,1))
## Compare trigonometry:
1-cos(pi/4)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/indel_functions.R
\name{plotExposuresConfidence_indel}
\alias{plotExposuresConfidence_indel}
\title{Plot exposures including confidence intervals for exposures of SNVs and
INDELs}
\usage{
plotExposuresConfidence_indel(in_complete_df, in_subgroups_df, in_sigInd_df)
}
\arguments{
\item{in_complete_df}{Melted numeric input data frame e.g. as computed by
\code{\link{variateExp}}}

\item{in_subgroups_df}{Data frame containing meta information on subgroup
attribution of the samples in the cohort of interest.}

\item{in_sigInd_df}{Data frame with meta information on the signatures used
in the analysis.}
}
\value{
The function returns a gtable object which can be plotted with
  \code{plot} or \code{grid.draw}
}
\description{
Plot the exposures to extracted signatures including the confidence intervals
computed e.g. by \code{\link[YAPSA]{variateExp}}
}
\examples{
NULL

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/complex_functions.R
\name{makeVRangesFromDataFrame}
\alias{makeVRangesFromDataFrame}
\title{Construct a VRanges Object from a data frame}
\usage{
makeVRangesFromDataFrame(
  in_df,
  in_keep.extra.columns = TRUE,
  in_seqinfo = NULL,
  in_seqnames.field = "X.CHROM",
  in_start.field = "POS",
  in_end.field = "POS",
  in_PID.field = "PID",
  in_subgroup.field = "subgroup",
  in_strand.field = "strand",
  verbose_flag = 1
)
}
\arguments{
\item{in_df}{A big dataframe constructed from a vcf-like file of a whole
cohort. The first columns are those of a standard vcf file, followed by an
arbitrary number of custom or user defined columns. One of these can carry
a PID (patient or sample identifyier) and one can carry subgroup
information.}

\item{in_keep.extra.columns}{in_seqinfo Argument passed on to
\code{\link{makeGRangesFromDataFrame}}}

\item{in_seqinfo}{A seqInfo object, referring to the reference genome used.
Argument passed on to \code{\link{makeGRangesFromDataFrame}}}

\item{in_seqnames.field}{Indicates the name of the column in which the
chromosome is encoded}

\item{in_start.field}{Indicates the name of the column in which the start
coordinate is encoded}

\item{in_end.field}{Indicates the name of the column in which the end
coordinate is encoded}

\item{in_PID.field}{Indicates the name of the column in which the PID
(patient or sample identifier) is encoded}

\item{in_subgroup.field}{Indicates the name of the column in which the
subgroup information is encoded}

\item{in_strand.field}{Indicates the name of the column in which the
strandedness is encoded}

\item{verbose_flag}{Verbose if 1}
}
\value{
The constructed VRanges object
}
\description{
In this package, big data frames are generated from cohort wide vcf-like
files. This function constructs a VRanges object from such a data frame by
using \code{\link{makeGRangesFromDataFrame}} from the package
\code{\link{GenomicRanges}}
}
\examples{
 data(lymphoma_test)
 temp_vr <- makeVRangesFromDataFrame(lymphoma_test_df,
                                     in_seqnames.field="CHROM",
                                     in_subgroup.field="SUBGROUP",
                                     verbose_flag=1)

}
\seealso{
\code{\link{makeGRangesFromDataFrame}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_functions.R
\name{plot_exposures}
\alias{plot_exposures}
\alias{plot_relative_exposures}
\title{Plot the exposures of a cohort}
\usage{
plot_exposures(
  in_exposures_df,
  in_signatures_ind_df,
  in_subgroups_df = NULL,
  in_sum_ind = NULL,
  in_subgroups.field = "subgroup",
  in_title = "",
  in_labels = TRUE,
  in_show_subgroups = TRUE,
  legend_height = 10
)

plot_relative_exposures(
  in_exposures_df,
  in_signatures_ind_df,
  in_subgroups_df,
  in_sum_ind = NULL,
  in_subgroups.field = "subgroup",
  in_title = "",
  in_labels = TRUE,
  in_show_subgroups = TRUE
)
}
\arguments{
\item{in_exposures_df}{Numerical data frame encoding the exposures \code{H},
i.e. which signature contributes how much to which PID (patient identifier
or sample).}

\item{in_signatures_ind_df}{A data frame containing meta information about
the signatures}

\item{in_subgroups_df}{A data frame indicating which PID (patient or sample
identifyier) belongs to which subgroup}

\item{in_sum_ind}{Index vector influencing the order in which the PIDs are
going to be displayed}

\item{in_subgroups.field}{String indicating the column name in
\code{in_subgroups_df} to take the subgroup information from.}

\item{in_title}{Title for the plot to be created.}

\item{in_labels}{Flag, if \code{TRUE} the PIDs are displayed on the x-axis}

\item{in_show_subgroups}{Flag, if \code{TRUE} then PIDs are grouped by
subgroups}

\item{legend_height}{How many signatures should be displayed in one column
together at most.}
}
\value{
The generated barplot - a ggplot2 plot
}
\description{
\code{plot_exposures}: The exposures \code{H}, determined by NMF or by
\code{\link{LCD}}, are displayed as a stacked barplot by calling \itemize{
\item \code{\link[ggplot2]{geom_bar}} and optionally \item
\code{\link[ggplot2]{geom_text}}. } The x-axis displays the PIDs (patient
identifier or sample), the y-axis the counts attributed to the different
signatures with their respective colours per PID. Is called by
\code{\link{plot_relative_exposures}}.

\code{plot_relative_exposures}: Plot the relative or normalized exposures of
a cohort. This function first normalizes its input and then sends the
normalized data to \code{\link{plot_exposures}}.
}
\examples{
 data(lymphoma_cohort_LCD_results)
 plot_exposures(lymphoma_Nature2013_COSMIC_cutoff_exposures_df,
                chosen_signatures_indices_df,
                COSMIC_subgroups_df)

 data(lymphoma_cohort_LCD_results)
 plot_relative_exposures(lymphoma_Nature2013_COSMIC_cutoff_exposures_df,
                         chosen_signatures_indices_df,
                         COSMIC_subgroups_df)

}
\seealso{
\code{\link{LCD}}

\code{\link[ggplot2]{geom_bar}}

\code{\link[ggplot2]{geom_text}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/confidence.R
\name{confIntExp}
\alias{confIntExp}
\title{Compute confidence intervals}
\usage{
confIntExp(
  in_ind = 1,
  in_sigLevel = 0.05,
  in_delta = 1,
  in_exposure_vector = NULL,
  in_verbose = FALSE,
  ...
)
}
\arguments{
\item{in_ind}{Index of the input signature to be variated.}

\item{in_sigLevel}{Significance leve (one-sided)}

\item{in_delta}{Inflation parameter for the alternative model.}

\item{in_exposure_vector}{Exposure vector computed for the input sample.}

\item{in_verbose}{Whether to run verbose (TRUE) or not (FALSE)}

\item{...}{Input parameters passed on to \link{variateExpSingle}.}
}
\value{
A list with entries \itemize{ \item \code{upper}: Upper bound of the
  confidence interval \item \code{lower}: Lower bound of the confidence
  interval }
}
\description{
Compute confidence intervals using the (log-)likelihood ratio test, primarily
for one input sample.
}
\examples{
 library(BSgenome.Hsapiens.UCSC.hg19)
 data(lymphoma_test)
 data(lymphoma_cohort_LCD_results)
 data(sigs)
 word_length <- 3
 temp_list <- create_mutation_catalogue_from_df(
   lymphoma_test_df,this_seqnames.field = "CHROM",
   this_start.field = "POS",this_end.field = "POS",
   this_PID.field = "PID",this_subgroup.field = "SUBGROUP",
   this_refGenome = BSgenome.Hsapiens.UCSC.hg19,
   this_wordLength = word_length)
 lymphoma_catalogue_df <- temp_list$matrix
 lymphoma_PIDs <- colnames(lymphoma_catalogue_df)
 data("lymphoma_cohort_LCD_results")
 lymphoma_exposures_df <-
   lymphoma_Nature2013_COSMIC_cutoff_exposures_df[, lymphoma_PIDs]
 lymphoma_sigs <- rownames(lymphoma_exposures_df)
 lymphoma_sig_df <- AlexCosmicValid_sig_df[, lymphoma_sigs]
 confIntExp(in_ind = 1, in_sigLevel = 0.05, in_delta = 0.4,
            in_exposure_vector = lymphoma_exposures_df[, 1],
            in_catalogue_vector = lymphoma_catalogue_df[, 1],
            in_sig_df = lymphoma_sig_df)
            
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/compare_SMCs.R
\name{plot_strata}
\alias{plot_strata}
\title{Plot all strata from different stratification axes together}
\usage{
plot_strata(
  in_strata_list,
  in_signatures_ind_df,
  output_path = NULL,
  in_attribute = ""
)
}
\arguments{
\item{in_strata_list}{Data structure created by \code{make_strata_df} or
\code{make_catalogue_strata_df} in which the strata from different
orthogonal stratification axes are reorganized in a consistent structure.}

\item{in_signatures_ind_df}{A data frame containing meta information about
the signatures}

\item{output_path}{Path to directory where the results, especially the figure
produced, are going to be stored.}

\item{in_attribute}{Additional string for the file name where the figure
output is going to be stored.}
}
\value{
The function doesn't return any value.
}
\description{
Plot the cohort wide signature exposures of all strata from different
stratification axes together. Naturally called by \code{\link{compare_SMCs}}.
}
\examples{
 NULL

}
\seealso{
\code{\link{compare_SMCs}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/indel_functions.R
\name{confidence_indel_only_calulation}
\alias{confidence_indel_only_calulation}
\title{Wrapper to compute confidence intervals for only INDEL signatures.}
\usage{
confidence_indel_only_calulation(in_current_indel_df)
}
\arguments{
\item{in_current_indel_df}{A INDEL mutational catalog. Mutational catalog can
be constucted with \code{\link{create_indel_mutation_catalogue_from_df}}}
}
\value{
A list is returned containing two object. First, the \code{p} gtable
object which can be used for gaphically visualization, and second a dataframe
containing the corrosponding upper and lower bounds of the confidence
intervals.
}
\description{
Wrapper function around \code{\link[YAPSA]{confIntExp}}, which is applies to
every signature or sample pair in a cohort. The extracted lower bound of the
confidence intervals are added to the input data which is reodered and melted
in order to prepare for visualization with ggplot2. The calculates of
confidence intervals is based on a profiling likelihood algorithm and the
wrapper calculates the data for the exposure contubution identefied with
INDEL singature decomposition and the usage of
\code{PCAWGValidID_absCutoffVector} data frame.
}
\details{
The function makes use of differnet YAPSA functions. For each of the above
stated cutoff vectors a per PID decompostion of the SNV and INDEL catalog is
calulated respectivly using \code{\link[YAPSA]{LCD_complex_cutoff_perPID}}.
In a next step, \code{\link[YAPSA]{variateExp}} which is a wrapper around
\code{\link[YAPSA]{confIntExp}} to compute confidenceintervals for a cohort
is used. A dataframe is returend with the upper and lower bounds of the
confidence intervals. In a last step
\code{\link[YAPSA]{plotExposuresConfidence_indel}} to plot the exposures to
extracted signatures including confidence intervals computed with e.g. by
\code{\link[YAPSA]{variateExp}}.
}
\examples{
data("GenomeOfNl_MutCat")
temp_list <- confidence_indel_only_calulation(
                        in_current_indel_df=MutCat_indel_df)
plot(temp_list$p_complete_PCAWG_ID)
head(temp_list$complete_PCAWG_ID)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SMC.R
\name{SMC}
\alias{SMC}
\title{Stratification of a Mutational Catalogue}
\usage{
SMC(
  df_list,
  this_signatures_df,
  in_all_exposures_df,
  number_of_strata,
  number_of_sigs,
  name_list,
  this_subgroups_df,
  mutation_catalogue_all_df,
  cohort_method_flag,
  in_verbose = 1
)
}
\arguments{
\item{df_list}{A list of \code{s} stratified mutational catalogues \code{Vi}
\(numeric data frames\) with \code{n} rows and \code{m} columns each,
\code{n} being the number of features and \code{m} being the number of
samples.This list is naturally provided in \code{\link{run_SMC}}.}

\item{this_signatures_df}{A numeric data frame \code{W} in with \code{n} rows
and \code{l} columns, \code{n} being the number of features and \code{l}
being the number of signatures}

\item{in_all_exposures_df}{The overall exposures \code{H} without
stratification, a numeric data frame with \code{l} rows and \code{m}
columns, \code{l} being the number of signatures and \code{m} being the
number of samples}

\item{number_of_strata}{The length of the list \code{df_list}}

\item{number_of_sigs}{The number of signatures used in the current
decomposition.}

\item{name_list}{A list of names of the different strata}

\item{this_subgroups_df}{A data frame indicating which PID (patient or sample
identifyier) belongs to which subgroup}

\item{mutation_catalogue_all_df}{The overall mutational catalogue \code{V}
without stratification.}

\item{cohort_method_flag}{Either or several of
\code{c("all_PIDs","cohort","norm_PIDs")}, representing alternative ways to
average over the cohort.}

\item{in_verbose}{Verbose if \code{in_verbose=1}}
}
\value{
A list with entries \code{exposures_strata_list},
 \code{exposures_both_rel_df_list}, \code{this_subgroups_df},
 \code{subgroup_ind} and \code{decomposition_method}. \itemize{ \item
 \code{exposures_strata_list}: The list of \code{s} strata specific exposures
 Hi, all are numerical data frames with \code{l} rows and \code{m} columns,
 \code{l} being the number of signatures and \code{m} being the number of
 samples \item \code{exposures_both_rel_df_list}: A list of \code{s} strata
 specific cohortwide (i.e. averaged over cohort) normalized exposures \item
 \code{this_subgroups_df}: \code{subgroups_df} adjusted for plotting \item
 \code{subgroup_ind}: Index of the subgroups chosen and relevant for
 plotting. \item \code{decomposition_method}: String telling whether LCD or
 NMF was used, relevant only for handing over to \code{\link{plot_SMC}}. }
}
\description{
\code{SMC} takes a given collection of stratified mutational catalogues
\code{Vi}, sends them to perform a mutational signatures decomposition by
Linear Combination Decomposition (LCD) with the functions
\code{\link{LCD_SMC}} with known signatures \code{W}. It subsequently performs
some useful statistics and preparation for plotting with the function
\code{\link{plot_SMC}}. \code{SMC} is naturally called by
\code{\link{run_SMC}}.
}
\examples{
NULL

}
\seealso{
\code{\link{run_SMC}}

\code{\link{plot_SMC}}

\code{\link{LCD_SMC}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/confidence.R
\name{testSigs}
\alias{testSigs}
\title{Test for significance of alternative models cohort wide}
\usage{
testSigs(
  in_catalogue_df,
  in_sig_df,
  in_exposures_df,
  in_factor = 0,
  in_pdf = NULL
)
}
\arguments{
\item{in_catalogue_df}{Input numerical data frame of the mutational catalog
of the cohort to be analyzed}

\item{in_sig_df}{Numerical data frame of the signatures used for analysis.}

\item{in_exposures_df}{Input numerical data frame of the exposures computed
for the cohort to be analyzed}

\item{in_factor}{Deviation factor of the altered alternative model.}

\item{in_pdf}{Probability distribution function, parameter passed on to
\link{confIntExp} if NULL assumed to be normal distribution.}
}
\value{
Returns a data frame
}
\description{
Wrapper function for \link{variateExpSingle} for application cohort wide.
}
\examples{
NULL

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\name{lymphomaNature2013_mutCat_df}
\alias{lymphomaNature2013_mutCat_df}
\title{Example mutational catalog for the SNV vignette}
\usage{
data(lymphomaNature2013_mutCat_df)
}
\value{
A data fame in the layout of a SNV mutational catalog
}
\description{
\code{lymphomaNature2013_mutCat_df}: A data frame in the format of a SNV mutation catalog. 
The mutational catalog contains SNV variants from the 
\code{lymphoma_Nature2013_raw_df} data. Mutational catalog was created with 
\code{create_mutation_catalogue_from_df} function.
}
\examples{
data(lymphomaNature2013_mutCat_df)
head(lymphomaNature2013_mutCat_df)
dim(lymphomaNature2013_mutCat_df)

}
\references{
\url{ftp://ftp.sanger.ac.uk/pub/cancer/AlexandrovEtAl/somatic_mutation_data/Lymphoma\%20B-cell/Lymphoma\%20B-cell_clean_somatic_mutations_for_signature_analysis.txt}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/basic_functions.R
\name{split_exposures_by_subgroups}
\alias{split_exposures_by_subgroups}
\title{Split an exposures data frame by subgroups}
\usage{
split_exposures_by_subgroups(
  in_exposures_df,
  in_subgroups_df,
  in_subgroups.field = "subgroup",
  in_PID.field = "PID"
)
}
\arguments{
\item{in_exposures_df}{Numerical data frame of the exposures (i.e.
contributions of the different signatures to the number of point mutations
per PID)}

\item{in_subgroups_df}{Data frame indicating which PID belongs to which
subgroup}

\item{in_subgroups.field}{Name indicating which column in
\code{in_subgroups_df} contains the subgroup information}

\item{in_PID.field}{Name indicating which column in \code{in_subgroups_df}
contains the PID information}
}
\value{
List of data frames with the subgroup specific signature exposures.
}
\description{
If a cohort consists of different subgroups, this function enables to split
the data frame storing the signature exposures into a list of data frames
with signature exposures, one per subgroup. This functionality is needed for
\code{\link{stat_test_subgroups}} and \code{\link{stat_plot_subgroups}}
}
\examples{
 NULL

}
\seealso{
\code{\link{stat_test_subgroups}}

\code{\link{stat_plot_subgroups}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/basic_functions.R
\name{attribute_nucleotide_exchanges}
\alias{attribute_nucleotide_exchanges}
\title{Attribute the nucleotide exchange for an SNV}
\usage{
attribute_nucleotide_exchanges(
  in_dat,
  in_REF.field = "REF",
  in_ALT.field = "ALT",
  in_verbose = FALSE
)
}
\arguments{
\item{in_dat}{VRanges object or data frame which carries one column for the
reference base and one column for the variant base}

\item{in_REF.field}{String indicating which column of \code{in_dat} carries
the reference base if dealing with data frames}

\item{in_ALT.field}{String indicating which column of \code{in_dat} carries
the variant base if dealing with data frames}

\item{in_verbose}{Whether verbose or not.}
}
\value{
A character vector with as many rows as there are in \code{in_dat}
  which can be annotated (i.e. appended) to the input data frame.
}
\description{
SNVs are grouped into 6 different categories (12/2 as reverse complements are
summed over). This function defines the attribution.
}
\examples{
test_df <- data.frame(
 CHROM=c(1,1,1,2,2,2,3,3,3,4,4,4,5,5),
 POS=c(1,2,3,4,5,6,1,2,3,4,5,6,7,8),
 REF=c("C","C","C","T","T","T","A","A","A","G","G","G","N","A"),
 ALT=c("A","G","T","A","C","G","C","G","T","A","C","T","A","N"))
test_df$change <- attribute_nucleotide_exchanges(
 test_df,in_REF.field = "REF",in_ALT.field = "ALT")
test_df

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/basic_functions.R
\name{add_as_fist_to_list}
\alias{add_as_fist_to_list}
\title{Add an element as first entry to a list}
\usage{
add_as_fist_to_list(in_list, in_element)
}
\arguments{
\item{in_list}{List to which an element is to be added}

\item{in_element}{Element to be added}
}
\value{
List with input element as first entry.
}
\description{
Works for all types of lists and inputs
}
\examples{
 NULL

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_functions.R
\name{stat_plot_subgroups}
\alias{stat_plot_subgroups}
\title{Plot averaged signature exposures per subgroup}
\usage{
stat_plot_subgroups(
  in_exposures_df,
  in_subgroups_df,
  in_signatures_ind_df,
  in_subgroups.field = "subgroup",
  in_PID.field = "PID",
  in_colour_vector = NULL
)
}
\arguments{
\item{in_exposures_df}{Numerical data frame of the exposures (i.e.
contributions of the different signatures to the number of point mutations
per PID)}

\item{in_subgroups_df}{Data frame indicating which PID belongs to which
subgroup}

\item{in_signatures_ind_df}{Data frame carrying additional information on the
signatures}

\item{in_subgroups.field}{Name indicating which column in
\code{in_subgroups_df} contains the subgroup information}

\item{in_PID.field}{Name indicating which column in \code{in_subgroups_df}
contains the PID information}

\item{in_colour_vector}{If non-null, specifies the colours attributed to the
subgroups}
}
\value{
The function doesn't return any value, it plots instead.
}
\description{
Plot one averaged signature exposure pattern per subgroup. Uses
\code{\link{split_exposures_by_subgroups}}.
}
\examples{
 NULL

}
\seealso{
\code{\link{split_exposures_by_subgroups}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/compare_SMCs.R
\name{make_comparison_matrix}
\alias{make_comparison_matrix}
\title{Compute a similarity matrix for different strata}
\usage{
make_comparison_matrix(
  in_strata_df,
  output_path = NULL,
  in_nrect = 5,
  in_attribute = "",
  in_palette = NULL
)
}
\arguments{
\item{in_strata_df}{Numerical data frame of all strata to be compared.}

\item{output_path}{Path to directory where the results, especially the figure
produced by \code{\link[corrplot]{corrplot}} is going to be stored.}

\item{in_nrect}{Number of clusters in the clustering procedure provided by
\code{\link[corrplot]{corrplot}}}

\item{in_attribute}{Additional string for the file name where the figure
produced by \code{\link[corrplot]{corrplot}} is going to be stored.}

\item{in_palette}{Colour palette for the matrix}
}
\value{
The comparison matrix of cosine similarities.
}
\description{
Compute and plot a similarity matrix for different strata from different
stratification axes together. First, \code{\link{compare_sets}} is called on
\code{in_strata_df} with itself, yielding a distance matrix (a numerical data
frame) \code{dist_df} of the strata. The corresponding similarity matrix
\code{1-dif_df} is then passed to \code{\link[corrplot]{corrplot}}.
}
\examples{
data(sigs)
make_comparison_matrix(
 AlexCosmicValid_sig_df,in_nrect=9,
 in_palette=colorRampPalette(c("blue","green","red"))(n=100))

}
\seealso{
\code{\link{compare_SMCs}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SMC.R
\name{run_SMC}
\alias{run_SMC}
\title{Wrapper function for the Stratification of a Mutational Catalogue}
\usage{
run_SMC(
  my_table,
  this_signatures_df,
  this_signatures_ind_df,
  this_subgroups_df,
  column_name,
  refGenome,
  cohort_method_flag = "all_PIDs",
  in_strata_order_ind = seq_len(length(unique(my_table[, column_name]))),
  wordLength = 3,
  verbose_flag = 1,
  target_dir = NULL,
  strata_dir = NULL,
  output_path = NULL,
  in_all_exposures_df = NULL,
  in_rownames = c(),
  in_norms = NULL,
  in_label_orientation = "turn",
  this_sum_ind = NULL
)
}
\arguments{
\item{my_table}{A big dataframe constructed from a vcf-like file of a whole
cohort. The first columns are those of a standard vcf file, followed by an
arbitrary number of custom or user defined columns. One of these must carry
a PID (patient or sample identifyier) and one must be the category used for
stratification.}

\item{this_signatures_df}{A numeric data frame \code{W} in with \code{n} rows
and \code{l} columns, \code{n} being the number of features and \code{l}
being the number of signatures}

\item{this_signatures_ind_df}{A data frame containing meta information about
the signatures}

\item{this_subgroups_df}{A data frame indicating which PID (patient or sample
identifyier) belongs to which subgroup}

\item{column_name}{Name of the column in \code{my_table} which is going to be
used for stratification}

\item{refGenome}{FaFile of the reference genome to extract the motif context
of the variants in \code{my_table}}

\item{cohort_method_flag}{Either or several of
\code{c("all_PIDs","cohort","norm_PIDs")}, representing alternative ways to
average over the cohort.}

\item{in_strata_order_ind}{Index vector defining reordering of the strata}

\item{wordLength}{Integer number defining the length of the features or
motifs, e.g. 3 for tripletts or 5 for pentamers}

\item{verbose_flag}{Verbose if \code{verbose_flag=1}}

\item{target_dir}{Path to directory where the results of the stratification
procedure are going to be stored if non-NULL.}

\item{strata_dir}{Path to directory where the mutational catalogues of the
different strata are going to be stored if non-NULL}

\item{output_path}{Path to directory where the results, especially the
figures produced by \code{\link{plot_SMC}} are going to be stored.}

\item{in_all_exposures_df}{Optional argument, if specified, \code{H}, i.e.
the overall exposures without stratification, is set to equal
\code{in_all_exposures_df}. This is equivalent to forcing the
\code{\link{LCD_SMC}} procedure to use e.g. the exposures of a previously
performed NMF decomposition.}

\item{in_rownames}{Optional parameter to specify rownames of the mutational
catalogue \code{V} i.e. the names of the features.}

\item{in_norms}{If specified, vector of the correction factors for every
motif due to differing trinucleotide content. If null, no correction is
applied.}

\item{in_label_orientation}{Whether or not to turn the labels on the x-axis.}

\item{this_sum_ind}{Optional set of indices for reordering the PIDs}
}
\value{
A list with entries \code{exposures_list}, \code{catalogues_list},
  \code{cohort} and \code{name_list}. \itemize{ \item \code{exposures_list}:
  The list of \code{s} strata specific exposures Hi, all are numerical data
  frames with \code{l} rows and \code{m} columns, \code{l} being the number
  of signatures and \code{m} being the number of samples \item
  \code{catalogues_list}: A list of \code{s} strata specific cohortwide (i.e.
  averaged over cohort) normalized exposures \item \code{cohort}:
  \code{subgroups_df} adjusted for plotting \item \code{name_list}: Names of
  the contructed strata. }
}
\description{
\code{\link{run_SMC}} takes as input a big dataframe constructed from a
vcf-like file of a whole cohort. This wrapper function calls custom functions
to construct a mutational catalogue and stratify it according to categories
indicated by a special column in the input dataframe: \itemize{ \item
\code{\link{create_mutation_catalogue_from_df}} \item
\code{adjust_number_of_columns_in_list_of_catalogues} } This stratification
yields a collection of stratified mutational catalogues, these are
reformatted and sent to the custom function \code{\link{SMC}} and thus
indirectly to \code{\link{LCD_SMC}} to perform a signature analysis of the
stratified mutational catalogues. The result is then handed over to
\code{\link{plot_SMC}} for visualization.
}
\examples{
 library(BSgenome.Hsapiens.UCSC.hg19)
 data(sigs)
 data(lymphoma_test)
 data(lymphoma_cohort_LCD_results)
 strata_list <-
   cut_breaks_as_intervals(lymphoma_test_df$random_norm,
                           in_outlier_cutoffs=c(-4,4),
                           in_cutoff_ranges_list=list(c(-2.5,-1.5),
                                                      c(0.5,1.5)),
                           in_labels=c("small","intermediate","big"))
 lymphoma_test_df$random_cat <- strata_list$category_vector
 choice_ind <- (names(lymphoma_Nature2013_COSMIC_cutoff_exposures_df)
                \%in\% unique(lymphoma_test_df$PID))
 lymphoma_test_exposures_df <-
   lymphoma_Nature2013_COSMIC_cutoff_exposures_df[,choice_ind]
 temp_subgroups_df <- make_subgroups_df(lymphoma_test_df,
                                        lymphoma_test_exposures_df)
 mut_density_list <- run_SMC(lymphoma_test_df,
                             AlexCosmicValid_sig_df,
                             AlexCosmicValid_sigInd_df,
                             temp_subgroups_df,
                             column_name="random_cat",
                             refGenome=BSgenome.Hsapiens.UCSC.hg19,
                             cohort_method_flag="norm_PIDs",
                             in_rownames = rownames(AlexCosmicValid_sig_df))

}
\seealso{
\code{\link{create_mutation_catalogue_from_df}}

\code{\link{normalizeMotifs_otherRownames}}

\code{\link{plot_SMC}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LCD.R
\name{LCD_complex_cutoff}
\alias{LCD_complex_cutoff}
\alias{LCD_complex_cutoff_perPID}
\alias{LCD_extractCohort_callPerPID}
\alias{LCD_complex_cutoff_consensus}
\alias{LCD_complex_cutoff_combined}
\title{LCD with a signature-specific cutoff on exposures}
\usage{
LCD_complex_cutoff(
  in_mutation_catalogue_df,
  in_signatures_df,
  in_cutoff_vector = NULL,
  in_filename = NULL,
  in_method = "abs",
  in_per_sample_cutoff = 0,
  in_rescale = TRUE,
  in_sig_ind_df = NULL,
  in_cat_list = NULL
)

LCD_complex_cutoff_perPID(
  in_mutation_catalogue_df,
  in_signatures_df,
  in_cutoff_vector = NULL,
  in_filename = NULL,
  in_method = "abs",
  in_rescale = TRUE,
  in_sig_ind_df = NULL,
  in_cat_list = NULL,
  minimumNumberOfAlterations = 25
)

LCD_extractCohort_callPerPID(
  in_mutation_catalogue_df,
  in_signatures_df,
  in_cutoff_vector = NULL,
  in_filename = NULL,
  in_method = "abs",
  in_rescale = TRUE,
  in_sig_ind_df = NULL,
  in_cat_list = NULL,
  in_verbose = FALSE,
  minimumNumberOfAlterations = 25,
  cutoff_type = "adaptive"
)

LCD_complex_cutoff_consensus(
  in_mutation_catalogue_df = NULL,
  in_signatures_df = NULL,
  in_cutoff_vector = NULL,
  in_filename = NULL,
  in_method = "abs",
  in_rescale = TRUE,
  in_sig_ind_df = NULL,
  in_cat_list = NULL,
  in_cohort_LCDlist = NULL,
  in_perPID_LCDlist = NULL,
  addSigs_cohort_cutoff = 0.25,
  addSigs_perPID_cutoff = 0.25,
  addSigs_relAbs_cutoff = 0.01,
  keep.unassigned = FALSE,
  keep.all.cohort.sigs = TRUE,
  in_verbose = FALSE,
  minimumNumberOfAlterations = 25
)

LCD_complex_cutoff_combined(
  in_mutation_catalogue_df = NULL,
  in_signatures_df = NULL,
  in_cutoff_vector = NULL,
  in_filename = NULL,
  in_method = "abs",
  in_rescale = TRUE,
  in_sig_ind_df = NULL,
  in_cat_list = NULL,
  addSigs_cohort_cutoff = 0.25,
  addSigs_perPID_cutoff = 0.25,
  addSigs_relAbs_cutoff = 0.01,
  keep.all.cohort.sigs = TRUE,
  in_verbose = FALSE,
  minimumNumberOfAlterations = 25,
  cutoff_type = "adaptive"
)
}
\arguments{
\item{in_mutation_catalogue_df}{A numeric data frame \code{V} with \code{n}
rows and \code{m} columns, \code{n} being the number of features and
\code{m} being the number of samples}

\item{in_signatures_df}{A numeric data frame \code{W} with \code{n} rows and
\code{l} columns, \code{n} being the number of features and \code{l} being
the number of signatures}

\item{in_cutoff_vector}{A numeric vector of values less than 1. Signatures
from within \code{W} with an overall exposure less than the respective value
in \code{in_cutoff_vector} will be discarded.}

\item{in_filename}{A path to generate a histogram of the signature exposures
if non-NULL}

\item{in_method}{Indicate to which data the cutoff shall be applied: absolute
exposures, relative exposures}

\item{in_per_sample_cutoff}{A numeric value less than 1. Signatures from
within \code{W} with an exposure per sample less than \code{in_cutoff} will
be discarded.}

\item{in_rescale}{Boolean, if TRUE (default) the exposures are rescaled such
that colSums over exposures match colSums over mutational catalogue}

\item{in_sig_ind_df}{Data frame of type signature_indices_df, i.e. indicating
name, function and meta-information of the signatures. Default is NULL.}

\item{in_cat_list}{List of categories for aggregation. Have to be among the
column names of \code{in_sig_ind_df}. Default is NULL.}

\item{minimumNumberOfAlterations}{The perPID part of the analysis issues a
warning if one sample has less mutations than this minimum cutoff.}

\item{in_verbose}{Verbose if \code{in_verbose=1}}

\item{cutoff_type}{If chosen to be "adaptive", the default, then 
signature-specific cutoffs are used for the the per-PID analysis in 
\code{\link[YAPSA]{LCD_extractCohort_callPerPID}}, otherwise, no cutoffs 
are used.}

\item{in_cohort_LCDlist}{Optional, if not provided, the cohort-wide exposures
are recalculated by calling \code{\link[YAPSA]{LCD_complex_cutoff}}}

\item{in_perPID_LCDlist}{Optional, if not provided, the per sample exposures
are recalculated by calling \code{\link[YAPSA]{LCD_complex_cutoff_perPID}}}

\item{addSigs_cohort_cutoff}{Numeric value for a cutoff: signatures which are
detected in a fraction of the samples of the cohort greater than this cutoff
are kept for the consensus set of signatures}

\item{addSigs_perPID_cutoff}{Numeric value for a cutoff: signatures which are
detected in one sample with exposure greater than this cutoff are kept for
the consensus set of signatures}

\item{addSigs_relAbs_cutoff}{Numeric value for a cutoff: signatures which are
detected with at least this fraction of all variants cohort wide are kept
for the consensus set of signatures}

\item{keep.unassigned}{Boolean, if TRUE the exposures from the signatures
which don't fulfill the criteria to be kept will be added and stored in the
exposures as "unassigned", otherwise the exposures are rescaled.}

\item{keep.all.cohort.sigs}{If TRUE (default), all signatures extracted cohort
wide are kept, if FALSE, the function reevaluates whether the signatures
extracted cohort wide still fulfill their criteria (i.e. exposures > cutoff)
after perPID extraction.}
}
\value{
A list with entries: \itemize{ \item \code{exposures}: The exposures
 \code{H}, a numeric data frame with \code{l} rows and \code{m} columns,
 \code{l} being the number of signatures and \code{m} being the number of
 samples \item \code{norm_exposures}: The normalized exposures \code{H}, a
 numeric data frame with \code{l} rows and \code{m} columns, \code{l} being
 the number of signatures and \code{m} being the number of samples \item
 \code{signatures}: The reduced signatures that have exposures bigger than
 \code{in_cutoff} \item \code{choice}: Index vector of the reduced signatures
 in the input signatures \item \code{order}: Order vector of the signatures
 by exposure \item \code{residual_catalogue}: Numerical data frame (matrix)
 of the difference between fit (product of signatures and exposures) and
 input mutational catalogue \item \code{rss}: Residual sum of squares (i.e.
 sum of squares of the residual catalogue) \item
 \code{cosDist_fit_orig_per_matrix}: Cosine distance between the fit (product
 of signatures and exposures) and input mutational catalogue computed after
 putting the matrix into vector format (i.e. one scaler product for the whole
 matrix) \item \code{cosDist_fit_orig_per_col}: Cosine distance between the
 fit (product of signatures and exposures) and input mutational catalogue
 computed per column (i.e. per sample, i.e. as many scaler products as there
 are samples in the cohort) \item \code{sum_ind}: Decreasing order of
 mutational loads based on the input mutational catalogue \item
 \code{out_sig_ind_df}: Data frame of the type \code{signature_indices_df}, 
 i.e. indicating name, function and meta-information of the signatures. 
 Default is NULL, non-NULL only if \code{in_sig_ind_df} is non-NULL. \item
 \code{aggregate_exposures_list}: List of exposure data frames aggregated
 over different categories. Default is NULL, non-NULL only if
 \code{in_sig_ind_df} and \code{in_cat_list} are non-NULL and if the
 categories specified in \code{in_cat_list} are among the column names of
 \code{in_sig_ind_df}. }
}
\description{
\code{LCD_cutoff} performs a mutational signatures decomposition by Linear
Combination Decomposition (LCD) of a given mutational catalogue \code{V} with
known signatures \code{W} by solving the minimization problem \eqn{min(||W*H -
V||)} with additional constraints of non-negativity on H where W and V are
known, but excludes signatures with an overall contribution less than a given
signature-specific cutoff (and thereby accounting for a background model) over
the whole cohort.

\code{\link[YAPSA]{LCD_complex_cutoff_perPID}} is a wrapper for
\code{\link[YAPSA]{LCD_complex_cutoff}} and runs individually for every PID.

\code{\link[YAPSA]{LCD_extractCohort_callPerPID}} runs
\code{\link[YAPSA]{LCD_complex_cutoff}} and takes the identified signatures as 
input for \code{\link[YAPSA]{LCD_complex_cutoff_perPID}}.

\code{\link[YAPSA]{LCD_complex_cutoff_consensus}} calls
\code{\link[YAPSA]{LCD_complex_cutoff_combined}} AND
\code{\link[YAPSA]{LCD_complex_cutoff_perPID}} and makes a consensus
signature call set.

\code{\link[YAPSA]{LCD_complex_cutoff_combined}} is a wrapper for
\code{\link[YAPSA]{LCD_complex_cutoff}},
\code{\link[YAPSA]{LCD_complex_cutoff_perPID}},
\code{\link[YAPSA]{LCD_complex_cutoff_consensus}} AND
\code{\link[YAPSA]{LCD_extractCohort_callPerPID}}.
}
\examples{
 NULL

}
\seealso{
\code{\link[YAPSA]{LCD}}

\code{\link[YAPSA]{aggregate_exposures_by_category}}

\code{\link[limSolve]{lsei}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/confidence.R
\name{variateExpSingle}
\alias{variateExpSingle}
\title{Wrapper for the likelihood ratio test}
\usage{
variateExpSingle(
  in_catalogue_vector,
  in_sig_df,
  in_exposure_vector,
  in_ind,
  in_factor = 1,
  in_pdf = NULL,
  verbose = FALSE
)
}
\arguments{
\item{in_catalogue_vector}{Mutational catalog of the input sample.}

\item{in_sig_df}{Data frame encoding the signatures used for the analysis.}

\item{in_exposure_vector}{Exposure vector computed for the input sample.}

\item{in_ind}{Index specifying which signature among \code{in_sig_df} is to
be tested.}

\item{in_factor}{Deviation factor of the altered alternative model.}

\item{in_pdf}{Probability distibution function, parameter passed on to
\link{logLikelihood} and later to \link{computeLogLik}}

\item{verbose}{Verbose if \code{in_verbose=1}}
}
\value{
Returns a list
}
\description{
Application of the likelihood ratio test to mutational signatures, primarily
for one single sample.
}
\examples{
 library(BSgenome.Hsapiens.UCSC.hg19)
 data(lymphoma_test)
 data(lymphoma_cohort_LCD_results)
 data(sigs)
 word_length <- 3
 temp_list <- create_mutation_catalogue_from_df(
   lymphoma_test_df,this_seqnames.field = "CHROM",
   this_start.field = "POS",this_end.field = "POS",
   this_PID.field = "PID",this_subgroup.field = "SUBGROUP",
   this_refGenome = BSgenome.Hsapiens.UCSC.hg19,
   this_wordLength = word_length)
 lymphoma_catalogue_df <- temp_list$matrix
 lymphoma_PIDs <- colnames(lymphoma_catalogue_df)
 data("lymphoma_cohort_LCD_results")
 lymphoma_exposures_df <-
   lymphoma_Nature2013_COSMIC_cutoff_exposures_df[, lymphoma_PIDs]
 lymphoma_sigs <- rownames(lymphoma_exposures_df)
 lymphoma_sig_df <- AlexCosmicValid_sig_df[, lymphoma_sigs]
 variateExpSingle(
   in_ind = 1,
   in_factor = 1.5,
   in_catalogue_vector = lymphoma_catalogue_df[, 1],
   in_sig_df = lymphoma_sig_df,
   in_exposure_vector = lymphoma_exposures_df[, 1])
   
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/basic_functions.R
\name{disambiguateVector}
\alias{disambiguateVector}
\title{Disambiguate a vector}
\usage{
disambiguateVector(in_vector)
}
\arguments{
\item{in_vector}{Input vector}
}
\value{
The disambiguated vector.
}
\description{
Add numbered suffixes to redundant entries in a vector
}
\examples{
 NULL

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\name{GenomeOfNl_raw}
\alias{GenomeOfNl_raw}
\title{Example data for the Indel vignette}
\usage{
data(GenomeOfNl_raw)
}
\value{
A data frame in a vcf-like format
}
\description{
\code{GenomeOfNl_raw}: A data frame contains the gemiline varinats of 
the dutch population.  carrying point mutation 
calls. It represents a subset of the data stored in
\url{ftp://ftp.sanger.ac.uk/pub/cancer/AlexandrovEtAl/somatic_mutation_data/Lymphoma\%20B-cell/Lymphoma\%20B-cell_clean_somatic_mutations_for_signature_analysis.txt}.
In the file available under that link somatic point mutation calls from 
several samples are listed in a vcf-like format. One column encodes the 
sample the variant was found in.
}
\examples{
data(GenomeOfNl_raw)
head(GenomeOfNl_raw)
dim(GenomeOfNl_raw)

}
\references{
release version 5 \url{https://www.nlgenome.nl/menu/main/app-go-nl/?page_id=9}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/confidence.R
\name{plotExposuresConfidence}
\alias{plotExposuresConfidence}
\title{Plot exposures including confidence intervals}
\usage{
plotExposuresConfidence(in_complete_df, in_subgroups_df, in_sigInd_df)
}
\arguments{
\item{in_complete_df}{Melted numeric input data frame e.g. as computed by
\link{variateExp}}

\item{in_subgroups_df}{Data frame containing meta information on subgroup
attribution of the samples in the cohort of interest.}

\item{in_sigInd_df}{Data frame with meta information on the signatures used
in the analysis.}
}
\value{
The function doesn't return any value but plots instead.
}
\description{
Plot the exposures to extracted signatures including confidence intervals
computed e.g. by \link{variateExp}.
}
\examples{
NULL
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/indel_functions.R
\name{attribute_sequence_contex_indel}
\alias{attribute_sequence_contex_indel}
\title{Attribution of sequence context and size for an INDEL}
\usage{
attribute_sequence_contex_indel(
  in_dat,
  in_REF.field = "REF",
  in_ALT.field = "ALT",
  in_verbose = FALSE,
  in_offsetL = 10,
  in_offsetR = 50
)
}
\arguments{
\item{in_dat}{VRanges object or data frame which carries one column for the
reference base and one column for the variant base}

\item{in_REF.field}{String indicating which column of \code{in_dat} carries
the reference base if dealing with data frames}

\item{in_ALT.field}{String indicating which column of \code{in_dat} carries
the variant base if dealing with data frames}

\item{in_verbose}{Verbose if \code{in_verbose=1}}

\item{in_offsetL}{Number of nucleotides which should be annotated downstream
of the variant. Per default 10 bps are annotated}

\item{in_offsetR}{Number of nucleotides which should be annotated upstream of
the catiant. Per default 50 bps are annotated}
}
\value{
VRanges object or data frame with the same number rows and additional
columns containing the type of INDEL (Ins = insertion and Del = deletion),
the annotated sequence context of the defined length, the absolute number of
exchanged nucleotides and the nucleotide exchange between \code{in_REF.field}
and \code{in_ALT.field}.
}
\description{
The function is a wrapper and uses \code{\link[YAPSA]{getSequenceContext}}
to annotate the sequence context.
}
\examples{
data(GenomeOfNl_raw)
GenomeOfNl_context <- attribute_sequence_contex_indel(
                                   in_dat = head(GenomeOfNl_raw),
                                   in_REF.field = "REF",
                                   in_ALT.field = "ALT",
                                   in_verbose = FALSE,
                                   in_offsetL= 10, in_offsetR=50)
GenomeOfNl_context

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_functions.R
\name{complex_heatmap_exposures}
\alias{complex_heatmap_exposures}
\title{Heatmap to cluster the PIDs on their signature 
exposures (ComplexHeatmap)}
\usage{
complex_heatmap_exposures(
  in_exposures_df,
  in_subgroups_df,
  in_signatures_ind_df,
  in_data_type = "norm exposures",
  in_method = "manhattan",
  in_subgroup_column = "subgroup",
  in_subgroup_colour_column = NULL,
  in_palette = colorRamp2(c(0, 0.2, 0.4, 0.6), c("white", "yellow", "orange", "red")),
  in_cutoff = 0,
  in_filename = NULL,
  in_column_anno_borders = FALSE,
  in_row_anno_borders = FALSE
)
}
\arguments{
\item{in_exposures_df}{Numerical data frame encoding the exposures \code{H},
i.e. which signature contributes how much to which PID (patient identifier
or sample).}

\item{in_subgroups_df}{A data frame indicating which PID (patient or sample
identifyier) belongs to which subgroup}

\item{in_signatures_ind_df}{A data frame containing meta information about
the signatures, especially the asserted colour}

\item{in_data_type}{Title in the figure}

\item{in_method}{Method of the clustering to be supplied to
\code{\link{dist}}. Can be either of: \code{euclidean}, \code{maximum},
\code{manhattan}, \code{canberra}, \code{binary} or \code{minkowski}}

\item{in_subgroup_column}{Indicates the name of the column in which the
subgroup information is encoded in \code{in_subgroups_df}}

\item{in_subgroup_colour_column}{Indicates the name of the column in which
the colour information for subgroups is encoded in \code{in_subgroups_df}.
If NULL, a rainbow palette is used instead.}

\item{in_palette}{Palette with colours for the heatmap. Default is
\code{colorRamp2(c(0, 0.2, 0.4, 0.6), c('white','yellow','orange','red'))}}

\item{in_cutoff}{A numeric value less than 1. Signatures from within \code{W}
with an overall exposure less than \code{in_cutoff} will be discarded for
the clustering.}

\item{in_filename}{A path to save the heatmap. If none is specified, the
figure will be plotted to the running environment.}

\item{in_column_anno_borders}{Whether or not to draw separating lines between
the fields in the annotation}

\item{in_row_anno_borders}{Whether or not to draw separating lines between
the fields in the annotation}
}
\value{
The function doesn't return any value.
}
\description{
The PIDs are clustered according to their signature exposures. uses package
\pkg{ComplexHeatmap} by Zuguang Gu. This function calls: \itemize{ \item
\code{\link[ComplexHeatmap]{rowAnnotation}}, \item
\code{\link[ComplexHeatmap]{HeatmapAnnotation}} and \item
\code{\link[ComplexHeatmap]{Heatmap}} }
}
\details{
It might be necessary to install the newest version of the
development branch of the packages \pkg{circlize} and \pkg{ComplexHeatmap} by
Zuguang Gu: \code{devtools::install_github("jokergoo/circlize")} and
\code{devtools::install_github("jokergoo/ComplexHeatmap")}
}
\examples{
 data(lymphoma_cohort_LCD_results)
 complex_heatmap_exposures(
   rel_lymphoma_Nature2013_COSMIC_cutoff_exposures_df,
   COSMIC_subgroups_df,
   chosen_signatures_indices_df,
   in_data_type="norm exposures",
   in_subgroup_colour_column="col",
   in_method="manhattan",
   in_subgroup_column="subgroup")

}
\seealso{
\code{\link[ComplexHeatmap]{Heatmap}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/complex_functions.R
\name{compare_to_catalogues}
\alias{compare_to_catalogues}
\title{Compare one mutational catalogue to reference mutational catalogues}
\usage{
compare_to_catalogues(in_index_df, in_comparison_list)
}
\arguments{
\item{in_index_df}{Data frame containing the mutational catalogue of interest}

\item{in_comparison_list}{List of data frames (ideally named) containing the
reference mutational catalogues}
}
\value{
A similarity dataframe
}
\description{
Compare one mutational catalogue (e.g. of one index patient) to a list of
reference mutational catalogues (e.g. from the initial Alexandrov
puplication) by cosine similarities
}
\examples{
 NULL

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/complex_functions.R
\name{create_mutation_catalogue_from_VR}
\alias{create_mutation_catalogue_from_VR}
\title{Create a Mutational Catalogue from a VRanges Object}
\usage{
create_mutation_catalogue_from_VR(
  in_vr,
  in_refGenome,
  in_wordLength,
  in_PID.field = "PID",
  in_verbose = 0,
  in_rownames = c(),
  adapt_rownames = 1
)
}
\arguments{
\item{in_vr}{A VRanges object constructed from a vcf-like file of a whole
cohort. The first columns are those of a standard vcf file, followed by an
arbitrary number of custom or used defined columns. One of these can carry
a PID (patient or sample identifyier) and one can carry subgroup
information.}

\item{in_refGenome}{The reference genome handed over to
\code{\link[SomaticSignatures]{mutationContext}} and used to extract the
motif context of the variants in \code{in_vr}.}

\item{in_wordLength}{The size of the motifs to be extracted by
\code{\link[SomaticSignatures]{mutationContext}}}

\item{in_PID.field}{Indicates the name of the column in which the PID
(patient or sample identifier) is encoded}

\item{in_verbose}{Verbose if \code{in_verbose=1}}

\item{in_rownames}{Optional parameter to specify rownames of the mutational
catalogue \code{V} i.e. the names of the features.}

\item{adapt_rownames}{Rownames of the output \code{matrix} will be adapted if
\code{adapt_rownames=1}}
}
\value{
A list with entries \code{matrix}, \code{frame}, \itemize{ \item
  \code{matrix}: The mutational catalogue \code{V} \item \code{frame}:
  Additional and meta information on rownames (features), colnames (PIDs) and
  subgroup attribution. }
}
\description{
This function creates a mutational catalogue from a VRanges Object by first
calling \code{\link[SomaticSignatures]{mutationContext}} to establish the
motif context of the variants in the input VRanges and then calling
\code{\link[SomaticSignatures]{motifMatrix}} to build the mutational
catalogue \code{V}.
}
\examples{
 library(BSgenome.Hsapiens.UCSC.hg19)
 data(lymphoma_test)
 data(sigs)
 word_length <- 3
 temp_vr <- makeVRangesFromDataFrame(
   lymphoma_test_df,in_seqnames.field="CHROM",
   in_subgroup.field="SUBGROUP",verbose_flag=1)
 temp_list <- create_mutation_catalogue_from_VR(
   temp_vr,in_refGenome=BSgenome.Hsapiens.UCSC.hg19,
   in_wordLength=word_length,in_PID.field="PID",
   in_verbose=1)
 dim(temp_list$matrix)
 head(temp_list$matrix)
 test_list <- split(lymphoma_test_df,f=lymphoma_test_df$PID)
 other_list <- list()
 for(i in seq_len(length(test_list))){
   other_list[[i]] <- test_list[[i]][c(1:80),]
 }
 other_df <- do.call(rbind,other_list)
 other_vr <- makeVRangesFromDataFrame(
   other_df,in_seqnames.field="CHROM",
   in_subgroup.field="SUBGROUP",verbose_flag=1)
 other_list <- create_mutation_catalogue_from_VR(
   other_vr,in_refGenome=BSgenome.Hsapiens.UCSC.hg19,
   in_wordLength=word_length,in_PID.field="PID",
   in_verbose=1,in_rownames=rownames(AlexCosmicValid_sig_df))
 dim(other_list$matrix)
 head(other_list$matrix)

}
\seealso{
\code{\link[SomaticSignatures]{mutationContext}}

\code{\link[SomaticSignatures]{motifMatrix}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/complex_functions.R
\name{aggregate_exposures_by_category}
\alias{aggregate_exposures_by_category}
\title{Aggregate exposures by category}
\usage{
aggregate_exposures_by_category(in_exposures_df, in_sig_ind_df, in_category)
}
\arguments{
\item{in_exposures_df}{Input data frame of exposures.}

\item{in_sig_ind_df}{Input data frame of meta information on the signatures.
Has to match the signatures in \code{in_exposures_df}}

\item{in_category}{Category to be aggregated over}
}
\value{
A list with entries: \itemize{ \item \code{exposures}: The exposures
  \code{H}, a numeric data frame with \code{l} rows and \code{m} columns,
  \code{l} being the number of aggregated signatures and \code{m} being the
  number of samples \item \code{norm_exposures}: The normalized exposures
  \code{H}, a numeric data frame with \code{l} rows and \code{m} columns,
  \code{l} being the number of aggregated signatures and \code{m} being the
  number of samples \item \code{out_sig_ind_df}: Data frame of the type
  \code{signature_indices_df}, i.e. indicating name, function and
  meta-information of the aggregated signatures.. }
}
\description{
If a valid category (i.e. it matches to a category specified in
in_sig_ind_df) is supplied, then the exposures are aggregated over this
category.
}
\examples{
 NULL

}
\seealso{
\code{\link{LCD_complex_cutoff}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/basic_functions.R
\name{correct_rounded}
\alias{correct_rounded}
\title{Readjust the vector to it's original norm after rounding}
\usage{
correct_rounded(x, in_interval = c(0, 1))
}
\arguments{
\item{x}{vector to be rounded}

\item{in_interval}{Interval}
}
\value{
The adapted form of the input vector \code{x}.
}
\description{
After use of the function \code{\link{round_precision}} the norm of the 
input vector may have been altered by the rounding procedure. This 
function restores the norm by altering only the largest entry in the 
rounded vector (in order to create the least possible relative error).
}
\examples{
 NULL

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/complex_functions.R
\name{transform_rownames_R_to_MATLAB}
\alias{transform_rownames_R_to_MATLAB}
\alias{transform_rownames_MATLAB_to_R}
\alias{transform_rownames_nature_to_R}
\alias{transform_rownames_YAPSA_to_deconstructSigs}
\alias{transform_rownames_deconstructSigs_to_YAPSA}
\title{Change rownames from one naming convention to another}
\usage{
transform_rownames_R_to_MATLAB(in_rownames, wordLength = 3)

transform_rownames_MATLAB_to_R(in_rownames, wordLength = 3)

transform_rownames_nature_to_R(in_rownames, wordLength = 3)

transform_rownames_YAPSA_to_deconstructSigs(in_rownames, wordLength = 3)

transform_rownames_deconstructSigs_to_YAPSA(in_rownames, wordLength = 3)
}
\arguments{
\item{in_rownames}{Character vector of input rownames}

\item{wordLength}{Size of the considered motif context}
}
\value{
A character vector of the translated rownames.
}
\description{
Rownames or names of the features used differ between the different contexts
a signature analysis is carried out in. The function
\code{transform_rownames_R_to_MATLAB} changes from the convention used in
the YAPSA pacakge to the one used by Alexandrov et al. in the MATLAB
framework.

The function \code{transform_rownames_MATLAB_to_R} changes from the 
convention used in Alexandrov et al. in the MATLAB framework to the one used
by the YAPSA pacakge.

The function \code{transform_rownames_MATLAB_to_R} changes from the 
convention used in stored mutational catalogues by Alexandrov et al. to the 
one used by the YAPSA pacakge.

The function \code{transform_rownames_YAPSA_to_deconstructSigs} changes from
the convention used in the YAPSA package to the one used by the 
deconstructSigs package.

The function \code{transform_rownames_YAPSA_to_deconstructSigs} changes from
the convention used in the deconstructSigs package to the one used by the 
YAPSA pacakge.
}
\examples{
NULL

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/compare_SMCs.R
\name{run_plot_strata_general}
\alias{run_plot_strata_general}
\title{Wrapper function for \code{plot_strata}}
\usage{
run_plot_strata_general(
  in_stratification_lists_list,
  in_signatures_ind_df,
  output_path = NULL,
  in_attribute = "",
  in_remove_signature_ind = NULL,
  in_additional_stratum = NULL
)
}
\arguments{
\item{in_stratification_lists_list}{List of lists with entries from different
(orthogonal) stratification axes or SMCs}

\item{in_signatures_ind_df}{A data frame containing meta information about
the signatures}

\item{output_path}{Path to directory where the results, especially the figure
produced by \code{\link{plot_strata}} is going to be stored.}

\item{in_attribute}{Additional string for the file name where the figure
produced by \code{\link{plot_strata}} is going to be stored.}

\item{in_remove_signature_ind}{Omit one of the signatures in
\code{in_signatures_ind_df} for the comparison if non-NULL. The parameter
specifies the index of the signature to be removed.}

\item{in_additional_stratum}{Include an additionally supplied stratum in
comparison in non-NULL.}
}
\value{
The function doesn't return any value.
}
\description{
First calls \itemize{ \item \code{make_strata_df}, then \item
\code{\link{plot_strata}} }
}
\examples{
 NULL

}
\seealso{
\code{\link{plot_strata}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/basic_functions.R
\name{compare_exposures}
\alias{compare_exposures}
\title{Compares alternative exposures}
\usage{
compare_exposures(in_exposures1_df, in_exposures2_df, deselect_flag = TRUE)
}
\arguments{
\item{in_exposures1_df}{Numeric data frame with exposures, ideally the
smaller exposure data is supplied first.}

\item{in_exposures2_df}{Numeric data frame with exposures, ideally the bigger
exposure data is supplied second.}

\item{deselect_flag}{Wehther signatures absent in both exposure data frames
should be removed.}
}
\value{
A list with entries \code{merge_df}, \code{all_cor.coeff},
  \code{all_p.value}, \code{cor.coeff_vector}, \code{p.value_vector},
  \code{all_cor.test}, and \code{cor.test_list}. \itemize{ \item
  \code{merge_df}: Merged molten input exposure data frames \item
  \code{all_cor.coeff}: Pearson correlation coefficient for all data points,
  i.e. taken all signatures together \item \code{all_p.value}: P-value of the
  Pearson test for all data points, i.e. taken all signatures together \item
  \code{cor.coeff_vector}: A vector of Pearson correlation coefficients
  evaluated for every signature independently \item \code{p.value_vector}: A
  vector of p-values of the Pearson tests evaluated for every signature
  independently \item \code{all_cor.test}: A data structure as returned by
  \code{\link{cor.test}} for all data points, i.e. taken all signatures
  together \item \code{cor.test_list}: A list of data structures as returned
  by \code{\link{cor.test}}, but evaluated for every signature independently
  }
}
\description{
Compares exposures computed by two alternative approaches for the same cohort
}
\examples{
 NULL

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/basic_functions.R
\name{make_subgroups_df}
\alias{make_subgroups_df}
\title{Make a custom data structure for subgroups}
\usage{
make_subgroups_df(
  in_vcf_like_df,
  in_exposures_df = NULL,
  in_palette = NULL,
  in_subgroup.field = "SUBGROUP",
  in_PID.field = "PID",
  in_verbose = FALSE
)
}
\arguments{
\item{in_vcf_like_df}{vcf-like data frame with point mutation calls}

\item{in_exposures_df}{Data frame with the signature exposures}

\item{in_palette}{Palette for colour attribution to the subgroups if nun-NULL}

\item{in_subgroup.field}{String indicating which column of
\code{in_vcf_like_df} carries the subgroup information}

\item{in_PID.field}{String indicating which column of \code{in_vcf_like_df}
and of \code{in_exposures_df} carries the PID information}

\item{in_verbose}{Whether verbose or not.}
}
\value{
subgroups_df: A data frame carrying the subgroup and rank
  information.
}
\description{
Creates a data frame carrying the subgroup information and the order in which
the PIDs have to be displayed. Calls \code{\link{aggregate}} on
\code{in_vcf_like_df}.
}
\examples{
 data(lymphoma_test)
 data(lymphoma_cohort_LCD_results)
 choice_ind <- (names(lymphoma_Nature2013_COSMIC_cutoff_exposures_df)
                \%in\% unique(lymphoma_test_df$PID))
 lymphoma_test_exposures_df <-
   lymphoma_Nature2013_COSMIC_cutoff_exposures_df[,choice_ind]
 make_subgroups_df(lymphoma_test_df,lymphoma_test_exposures_df)

}
\seealso{
\code{\link{aggregate}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{targetCapture_cor_factors}
\alias{targetCapture_cor_factors}
\title{Correction factors for different target capture kits}
\usage{
data(targetCapture_cor_factors)
}
\value{
A list of lists of data frames
}
\description{
List of lists with correction factors for different target capture kits.
The elements of the overall list are lists, every one carrying information
for one target capture kit (and namend after it). The elements of these
sublists are 64 dimensional vectors with correction factors for all
triplets. They were computed using counts of occurence of the respective
triplets in the target capture and in the reference genome and making
ratios (either for the counts themselves as in \code{abs_cor} or for the
relative occurences in \code{rel_cor}). The information in this data
structure may be used as input to
\code{\link{normalizeMotifs_otherRownames}}.
}
\author{
Daniel Huebschmann \email{huebschmann.daniel@googlemail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/basic_functions.R
\name{annotate_intermut_dist_cohort}
\alias{annotate_intermut_dist_cohort}
\title{Annotate the intermutation distance of variants cohort-wide}
\usage{
annotate_intermut_dist_cohort(
  in_dat,
  in_CHROM.field = "CHROM",
  in_POS.field = "POS",
  in_PID.field = NULL,
  in_mode = "min",
  in_verbose = FALSE
)
}
\arguments{
\item{in_dat}{VRanges object, VRangesList, data frame or list of data frames
which carries (at least) one column for the chromosome and one column for
the position. Optionally, a column to specify the PID can be provided.}

\item{in_CHROM.field}{String indicating which column of \code{in_df} carries
the chromosome information}

\item{in_POS.field}{String indicating which column of \code{in_df} carries
the position information}

\item{in_PID.field}{String indicating which column of \code{in_df} carries
the PID information}

\item{in_mode}{String passed through \code{\link{annotate_intermut_dist_PID}}
to \code{\link[circlize]{rainfallTransform}} indicating which method to
choose for the computation of the intermutational distance.}

\item{in_verbose}{Whether verbose or not.}
}
\value{
VRanges object, VRangesList, data frame or list of data frames
  identical to \code{in_df} (reordered by \code{in_PID.field}), but with the
  intermutation distance annotated as an additional column on the right named
  \code{dist}.
}
\description{
The function annotates the intermutational distance to a cohort wide data
frame by applying \code{\link{annotate_intermut_dist_PID}} to every
PID-specific subfraction of the cohort wide data. Note that
\code{\link{annotate_intermut_dist_PID}} calls
\code{\link[circlize]{rainfallTransform}}. If the PID information is missing,
\code{\link{annotate_intermut_dist_PID}} is called directly for the whole
input.
}
\examples{
test_df <- data.frame(CHROM=c(1,1,1,2,2,2,3,3,3,4,4,4,5,5),
                      POS=c(1,2,4,4,6,9,1,4,8,10,20,40,100,200),
                      REF=c("C","C","C","T","T","T","A",
                            "A","A","G","G","G","N","A"),
                      ALT=c("A","G","T","A","C","G","C",
                            "G","T","A","C","T","A","N"),
                      PID=c(1,1,1,2,2,2,1,1,2,2,2,1,1,2))
test_df <- test_df[order(test_df$PID,test_df$CHROM,test_df$POS),]
min_dist_df <-
  annotate_intermut_dist_cohort(test_df,in_CHROM.field="CHROM",
                                in_POS.field="POS", in_PID.field="PID",
                                in_mode="min")
max_dist_df <-
  annotate_intermut_dist_cohort(test_df,in_CHROM.field="CHROM",
                                in_POS.field="POS", in_PID.field="PID",
                                in_mode="max")
min_dist_df
max_dist_df

}
\seealso{
\code{\link{annotate_intermut_dist_PID}}

\code{\link[circlize]{rainfallTransform}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/complex_functions.R
\name{test_gene_list_in_exposures}
\alias{test_gene_list_in_exposures}
\title{Test if mutated PIDs are enriched in signatures}
\usage{
test_gene_list_in_exposures(
  in_gene_list,
  in_exposure_df,
  in_mut_table,
  in_gene.field = "GENE_short",
  in_p_cutoff = 0.05
)
}
\arguments{
\item{in_gene_list}{List with genes of interest}

\item{in_exposure_df}{Data frame with the signature exposures}

\item{in_mut_table}{Data frame or table of mutations (derived from
vcf-format)}

\item{in_gene.field}{Name of the column in which the gene names are to be
looked up}

\item{in_p_cutoff}{Significance threshold}
}
\value{
A list with entries \code{pvals}, \code{exposure_df},
  \code{number_of_mutated}, \itemize{ \item \code{pvals}: p-values of the
  t-tests performed on mutated vs. unmutated PIDs \item \code{exposure_df}:
  Transposed input exposures data frame with additional annotations for
  mutation status \item \code{number_of_mutated}: Number of PIDs carrying a
  mutation }
}
\description{
For all signatures found in a project, this function tests whether PIDs
having mutations in a specified list of genes of interest have significantly
higher exposures.
}
\examples{
 NULL

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/indel_functions.R
\name{confidence_indel_calulation}
\alias{confidence_indel_calulation}
\title{Wrapper to compute confidence intervals for SNV and INDEL signatures of a
cohort or single-sample}
\usage{
confidence_indel_calulation(in_current_indel_df, in_current_snv_df)
}
\arguments{
\item{in_current_indel_df}{A INDEL mutational catalog. Mutational catalog can
be constucted with
\code{\link[YAPSA]{create_indel_mutation_catalogue_from_df}}}

\item{in_current_snv_df}{A SNV mutational catalog. Mutational catalog can be
constuced with \code{\link[YAPSA]{create_mutation_catalogue_from_df}}}
}
\value{
A list is returned containing 12 objects. For each cutoff data frame
  two corrosponding object are present. First, the \code{p} gtable object
  which can be used for gaphically visualization, and second a dataframe
  containing  the corrosponding upper and lower bounds of the confidence
  intervals.
}
\description{
Wrapper function around \code{\link[YAPSA]{confIntExp}}, which is applies to
every signature or sample pair in a cohort. The extracted lower bound of the
confidence intervals are added to the input data which is reodered and melted
in order to prepare for visualization with ggplot2. The calculates of
confidence intervals is based on a profiling likelihood algorithm and the
wrapper calculates the data for the exposure contubution identefied with SNV
and INDEL signature decompositions and application of the following cutoffs:
\enumerate{ \item \code{CosmicValid_absCutoffVector} \item
\code{CosmicValid_normCutoffVector} \item \code{CosmicArtif_absCutoffVector}
\item \code{CosmicArtif_normCutoffVector} \item
\code{PCAWGValidSNV_absCutoffVector} \item
\code{PCAWGValidID_absCutoffVector} } The function makes use of differnet
YAPSA functions. For each of the above stated cutoff vectors a per PID
decompostion of the SNV and INDEL catalog is calulated respectivly using
\code{\link[YAPSA]{LCD_complex_cutoff_perPID}}. In a next step,
\code{\link[YAPSA]{variateExp}} wich is a wrapper around
\code{\link[YAPSA]{confIntExp}} to compute confidence intervals for a cohort
is used. A dataframe is returend with the upper and lower bounds of the
confidence intervals. In a last step
\code{\link[YAPSA]{plotExposuresConfidence_indel}} to plot the exposures to
extracted signatures including confidence intervals computed with e.g. by
\code{\link[YAPSA]{variateExp}}.
}
\examples{
data("GenomeOfNl_MutCat")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LCD.R
\name{LCD_SMC}
\alias{LCD_SMC}
\title{CD stratification analysis}
\usage{
LCD_SMC(in_mutation_sub_catalogue_list, in_signatures_df, in_F_df = NULL)
}
\arguments{
\item{in_mutation_sub_catalogue_list}{A list of \code{s} stratified
mutational catalogues \code{Vi} \(numeric data frames\) with \code{n} rows
and \code{m} columns each, \code{n} being the number of features and
\code{m} being the number of samples. This list is naturally provided in
\code{\link{run_SMC}}.}

\item{in_signatures_df}{A numeric data frame \code{W} with \code{n} rows and
\code{l} columns, \code{n} being the number of features and \code{l} being
the number of signatures}

\item{in_F_df}{Default NULL}
}
\value{
Returns a list with all exposures and the stratified ones
}
\description{
CD stratification analysis
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/compare_SMCs.R
\name{run_comparison_catalogues}
\alias{run_comparison_catalogues}
\title{Compare all strata from different stratifications}
\usage{
run_comparison_catalogues(
  in_stratification_lists_list,
  output_path = NULL,
  in_nrect = 5,
  in_attribute = ""
)
}
\arguments{
\item{in_stratification_lists_list}{List of lists with entries from different
(orthogonal) stratification axes or SMCs}

\item{output_path}{Path to directory where the results, especially the figure
produced by \code{\link[corrplot]{corrplot}} is going to be stored.}

\item{in_nrect}{Number of clusters in the clustering procedure provided by
\code{\link[corrplot]{corrplot}}}

\item{in_attribute}{Additional string for the file name where the figure
produced by}
}
\value{
The comparison matrix of cosine similarities.
}
\description{
Compare all strata from different orthogonal stratification axes, i.e.
othogonal SMCs by cosine similarity of mutational catalogues. Function
similar to \code{\link{run_comparison_general}}. First calls \itemize{ \item
\code{make_catalogue_strata_df}, then \item
\code{\link{make_comparison_matrix}} }
}
\examples{
 NULL

}
\seealso{
\code{\link{make_comparison_matrix}}

\code{\link{run_comparison_general}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/basic_functions.R
\name{relateSigs}
\alias{relateSigs}
\title{Make unique assignments between sets of signatures}
\usage{
relateSigs(querySigs, subjectSigs)
}
\arguments{
\item{querySigs}{The signatures to compare to (given signatures).}

\item{subjectSigs}{The signatures to be compared (new signatures).}
}
\value{
A list of comparison vectors
}
\description{
Make unique assignments between a set of given signatures and a set of new
signatures.
}
\examples{
 NULL

}
\seealso{
\code{\link{compare_sets}}

\code{\link{disambiguateVector}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/basic_functions.R
\name{annotate_intermut_dist_PID}
\alias{annotate_intermut_dist_PID}
\title{Annotate the intermutation distance of variants per PID}
\usage{
annotate_intermut_dist_PID(
  in_dat,
  in_CHROM.field = "CHROM",
  in_POS.field = "POS",
  in_mode = "min",
  in_verbose = FALSE
)
}
\arguments{
\item{in_dat}{VRanges object or data frame which carries (at least) one
column for the chromosome and one column for the position.}

\item{in_CHROM.field}{String indicating which column of \code{in_dat} carries
the chromosome information if dealing with data frames.}

\item{in_POS.field}{String indicating which column of \code{in_dat} carries
the position information if dealing with data frames.}

\item{in_mode}{String passed to \code{\link[circlize]{rainfallTransform}}
indicating which method to choose for the computation of the
intermutational distance.}

\item{in_verbose}{Whether verbose or not.}
}
\value{
VRanges object or data frame identical to \code{in_dat}, but with the
  intermutation distance annotated as an additional column on the right named
  \code{dist}.
}
\description{
The function annotates the intermutational distance to a PID wide data frame
by applying \code{\link[circlize]{rainfallTransform}} to every
chromosome-specific subfraction of the PID wide data.
}
\examples{
test_df <- data.frame(
 CHROM=c(1,1,1,2,2,2,3,3,3,4,4,4,5,5),
 POS=c(1,2,4,4,6,9,1,4,8,10,20,40,100,200),
 REF=c("C","C","C","T","T","T","A","A","A","G","G","G","N","A"),
 ALT=c("A","G","T","A","C","G","C","G","T","A","C","T","A","N"))
min_dist_df <- annotate_intermut_dist_PID(test_df,in_CHROM.field="CHROM",
                                          in_POS.field="POS",
                                          in_mode="min")
max_dist_df <- annotate_intermut_dist_PID(test_df,in_CHROM.field="CHROM",
                                          in_POS.field="POS",
                                          in_mode="max")
min_dist_df
max_dist_df

}
\seealso{
\code{\link{annotate_intermut_dist_cohort}}

\code{\link[circlize]{rainfallTransform}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/compare_SMCs.R
\name{make_catalogue_strata_df}
\alias{make_catalogue_strata_df}
\title{Group strata from different stratification axes}
\usage{
make_catalogue_strata_df(
  in_stratification_lists_list,
  in_additional_stratum = NULL
)
}
\arguments{
\item{in_stratification_lists_list}{List of lists with entries from different
(orthogonal) stratification axes or SMCs}

\item{in_additional_stratum}{Include an additionally supplied stratum in
comparison in non-NULL.}
}
\value{
A list with entries \code{strata_df}, \code{number_of_SMCs},
  \code{number_of_strata}. \itemize{ \item \code{strata_df}: Pasted numerical
  data frame of all strata (these are going to be compared e.g. by
  \code{\link{make_comparison_matrix}}). \item \code{number_of_SMCs}: Number
  of orthogonal stratifications in \code{in_stratification_lists_list} and
  additional ones. \item \code{number_of_strata}: Cumulative number of strata
  (sum over the numbers of strata of the different stratifications in
  \code{in_stratification_lists_list}) and additional ones. }
}
\description{
For a comparison of the strata from different orthogonal stratification axes,
i.e. othogonal SMCs, the strata have to be grouped and reformatted. This
function does this task for the comparison by cosine similarity of mutational
catalogues. Output of this function is the basis for applying
\code{\link{make_comparison_matrix}}. It is called by the wrapper function
\code{\link{run_comparison_catalogues}}.
}
\examples{
 NULL

}
\seealso{
\code{\link{plot_strata}}

\code{\link{make_comparison_matrix}}

\code{\link{run_comparison_catalogues}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/indel_functions.R
\name{create_indel_mutation_catalogue_from_df}
\alias{create_indel_mutation_catalogue_from_df}
\title{Wrapper to create an INDEL mutational catalog from a vlf-like data frame}
\usage{
create_indel_mutation_catalogue_from_df(
  in_dat,
  in_signature_df,
  in_REF.field = "REF",
  in_ALT.field = "ALT",
  in_verbose = FALSE
)
}
\arguments{
\item{in_dat}{A data frame constructed from a vcf-like file of a whole cohort
or single-sample. The first columns are those of a standard vcf file
(\code{CHROM}, \code{POS}, \code{REF} and \code{ALT}), followed by an
arbitrary number of custom or used defined columns. One of these can carry
a PID (patient or sample identifyier) and one can carry subgroup
information.}

\item{in_signature_df}{A numeric data frame \code{W} with \code{n} rows and
\code{l} columns, n being the number of features and l being the number od
signatures. Data frame containing INDEL signatures which should be used to
create the mutational cataologe \code{V}.}

\item{in_REF.field}{String indicating which column of \code{in_dat} carries
the reference base if dealing with data frames}

\item{in_ALT.field}{String indicating which column of \code{in_dat} carries
the variant base if dealing with data frames}

\item{in_verbose}{Verbose if \code{in_verbose=1}}
}
\value{
A dataframe in the format of a mutational catalog \code{V}, which can
be used for \code{\link[YAPSA]{LCD}} analysis
}
\description{
From data frame constucted from a vcf-file file the function
\code{\link[YAPSA]{create_indel_mutation_catalogue_from_df}} creates a
mutational catalog V by squencially applying the
\code{\link[YAPSA]{attribute_sequence_contex_indel}},
\code{\link[YAPSA]{attribute_sequence_contex_indel}} and then
\code{\link[YAPSA]{attribution_of_indels}}. The runtime of the function is
about 1 sec per 6 variants as sequence context as well as INDEL
calssification are timeconsuming to compute (optimization ongoing)
}
\examples{
data(sigs_pcawg)
data(GenomeOfNl_raw)
temp_df <- translate_to_hg19(GenomeOfNl_raw[1:200,],"CHROM")
temp_df$PID <- sample(c("PID1","PID2","PID3","PID4","PID5"),200,replace=TRUE)
temp <- create_indel_mutation_catalogue_from_df(in_dat = temp_df,
   in_signature_df = PCAWG_SP_ID_sigs_df,
   in_REF.field = "REF",
   in_ALT.field = "ALT",
   in_verbose = FALSE)
dim(temp)
head(temp)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/indel_functions.R
\name{plotExchangeSpectra_indel}
\alias{plotExchangeSpectra_indel}
\title{Plot the spectra of nucleotide exchanges of INDELs}
\usage{
plotExchangeSpectra_indel(
  in_catalogue_df,
  in_colour_vector = NULL,
  in_show_indel = FALSE,
  in_show_axis_title = FALSE,
  in_scales = "free_x",
  in_refLine = NULL,
  in_refAlpha = 0.5,
  in_background = NULL
)
}
\arguments{
\item{in_catalogue_df}{Numerical data frame encoding the exchange spectra to
be displayed, either a mutational catalogue \code{V} or a signatures matrix
\code{W}}

\item{in_colour_vector}{Specifies the colours of the INDELs if non-null}

\item{in_show_indel}{Whether or not to show the INDEL names on the x-axis}

\item{in_show_axis_title}{Whether or not to show the name of the y-axis}

\item{in_scales}{Argument passed on to \code{\link[ggplot2]{facet_grid}}}

\item{in_refLine}{If non-null, value on the y-axis at which a horizontal line
is to be drawn}

\item{in_refAlpha}{Transparency of the horizontal line if it is to be drawn}

\item{in_background}{Option to provide a background theme, e.g.
\code{\link[ggplot2]{theme_grey}}}
}
\value{
The generated barplot - a ggplot2 plot
}
\description{
Plots the spectra of nucelotides in their triplet contexts. If several
columns are present in the input data frame, the spectra are ploted for every
column seperatly. The function is only suitable for a INDEL spectra and for
SNV representation the funtion \code{\link[YAPSA]{plotExchangeSpectra}}
should be used.
}
\examples{
data(sigs_pcawg)
plotExchangeSpectra_indel(PCAWG_SP_ID_sigs_df[,c(6,8)])

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/confidence.R
\name{computeLogLik}
\alias{computeLogLik}
\title{Compute the loglikelihood}
\usage{
computeLogLik(in_vector, in_pdf = NULL, verbose = FALSE)
}
\arguments{
\item{in_vector}{Numeric vector of input values of which the loglikelihood is
computed.}

\item{in_pdf}{Probability distribution function, if NULL a normal
distribution is used.}

\item{verbose}{Verbose if \code{in_verbose=1}}
}
\value{
A numeric value (sum of the logarithms of the likelihoods of the
  input vector)
}
\description{
Compute the loglikelihood
}
\examples{
NULL

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/confidence.R
\name{logLikelihood}
\alias{logLikelihood}
\title{Compute a loglikelihood ratio test}
\usage{
logLikelihood(
  in_1,
  in_2,
  df_1 = NULL,
  df_2 = NULL,
  in_pdf = NULL,
  verbose = FALSE
)
}
\arguments{
\item{in_1}{Residuals of model 1 of the input data.}

\item{in_2}{Residuals of model 2 of the input data.}

\item{df_1}{Degrees of freedom of the input model 1. If either \code{df_1} or
\code{df_2} is NULL, the difference between the degrees of freedom of the
two models is assumed to be 1.}

\item{df_2}{Degrees of freedom of the input model 2. If either \code{df_1} or
\code{df_2} is NULL, the difference between the degrees of freedom of the
two models is assumed to be 1.}

\item{in_pdf}{Probability distribution function, passed on to
\link{computeLogLik}, if NULL a normal distribution is used.}

\item{verbose}{Verbose if \code{in_verbose=1}}
}
\value{
A list with entries \itemize{ \item \code{statistic}: The test
statistic \item \code{delta_df}: The difference in degrees of freedom between
input model 1 and 2 \item \code{p.value}: p value of the statistical test. }
}
\description{
Compute a likelihood ratio test based on the loglikelihoods of the residuals
of two different models of the same data.
}
\examples{
 library(BSgenome.Hsapiens.UCSC.hg19)
 data(lymphoma_test)
 data(sigs)
 data(cutoffs)
 word_length <- 3
 temp_list <- create_mutation_catalogue_from_df(
   lymphoma_test_df,this_seqnames.field = "CHROM",
   this_start.field = "POS",this_end.field = "POS",
   this_PID.field = "PID",this_subgroup.field = "SUBGROUP",
   this_refGenome = BSgenome.Hsapiens.UCSC.hg19,
   this_wordLength = word_length)
 lymphoma_catalogue_df <- temp_list$matrix
 lymphoma_PIDs <- colnames(lymphoma_catalogue_df)
 current_sig_df <- AlexCosmicValid_sig_df
 current_sigInd_df <- AlexCosmicValid_sigInd_df
 current_cutoff_vector <- cutoffCosmicValid_rel_df[6, ]
 iniLCDList <- LCD_complex_cutoff(
   in_mutation_catalogue_df = lymphoma_catalogue_df[, 1, drop = FALSE],
   in_signatures_df = current_sig_df,
   in_cutoff_vector = current_cutoff_vector,
   in_method = "relative", in_rescale = TRUE,
   in_sig_ind_df = current_sigInd_df)
 current_sig_df <- AlexCosmicValid_sig_df[, -9]
 current_sigInd_df <- AlexCosmicValid_sigInd_df[-9,]
 current_cutoff_vector <- cutoffCosmicValid_rel_df[6, -9]
 redLCDList <- LCD_complex_cutoff(
   in_mutation_catalogue_df = lymphoma_catalogue_df[, 1, drop = FALSE],
   in_signatures_df = current_sig_df,
   in_cutoff_vector = current_cutoff_vector,
   in_method = "relative", in_rescale = TRUE,
   in_sig_ind_df = current_sigInd_df)
 logLikelihood(iniLCDList, redLCDList)
 
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/indel_functions.R
\name{attribution_of_indels}
\alias{attribution_of_indels}
\title{Attribution of variant into one onf the 83 INDEL categories}
\usage{
attribution_of_indels(in_dat_return = in_dat_return)
}
\arguments{
\item{in_dat_return}{Data frame constucted form a vcf-like file of a whole
cohort or a single-sample.The first columns are those of a standart vcf
file, followed by an abitrary number of custom or defined columns. One of
these can carry a PID (patient or sample identifyer) and subgroup
information. Furthermore, the columns containing the sequence context and
the absolute length of the INDEL as well as the INDEL type of the variant
can be annotated to the vcf-like df with
\code{\link[YAPSA]{attribute_sequence_contex_indel}}. These columns are
required to enable the constuction of a mutational catalog.}
}
\value{
Data frame with the same dimention as the input data frame  plus an
  addional column with the INDEL classification number corrospondig to
  Alexandrov et al. 2018.
}
\description{
Each varaint is categorized into one of the 83 INDEL categories. The
classification likewise to Alexandrov et al., 2018
(https://www.synapse.org/#!Synapse:syn11726616). The number of 83 features
are classefied asfollowed: \enumerate{ \item Deletion of 1 bp C/(G) or T/(A)
in a repetitive context. The context is classified into 1, 2, 3, 4, 5 or
larger or equal to 6 times the same nucleotide(s). \item Insertion of 1 bp
C/(G) or T/(A) in a repetitive context. The context is classified into 0, 1,
2, 3, 4,  or larger or equal to 5 times the same nucleotide(s). \item
Deletions of 2bps, 3bps, 4bps or more or equal to 5bps in a repetitive
context. Each deletion is classified in a context of 1, 2, 3, 4, 5 or larger
or equal to 6 times the same motif. \item Insertion of 2 bps, 3 bps, 4 bps or
more or equal to 5 bps in a repetitive context. Each deletion is classified
in a context of 0, 1, 2, 3, 4 or larger or equal to 5 times the same motif.
\item Microhomology deletion of 2bps, 3bps, 4bps or more or equal to 5 bps in
a partly repetitive context. The partly repetitive context is defined by
motif length of minus 1 bp, 2 bps, 3 bps, 4 bps or more or equal to 5bps,
which is located before and after the break-point junction of the deletion.}
}
\examples{
data(GenomeOfNl_raw)
GenomeOfNl_context <- attribute_sequence_contex_indel(in_dat =
head(GenomeOfNl_raw))
GenomeOfNl_classified <- attribution_of_indels(GenomeOfNl_context)
GenomeOfNl_classified

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SMC.R
\name{SMC_perPID}
\alias{SMC_perPID}
\title{Run SMC at a per sample level}
\usage{
SMC_perPID(
  in_dfList,
  in_LCDlist,
  in_subgroups_df,
  in_save_plot = TRUE,
  in_save_dir = NULL,
  in_save_name = "KataegisSMCs.pdf",
  in_verbose_flag = 0,
  ...
)
}
\arguments{
\item{in_dfList}{Named list of vcf-like data frames, one entry per sample/PID
of a cohort.}

\item{in_LCDlist}{Output of an LCD list perfomed on the above cohort,
carrying notably information on the exposures
(\code{in_LCDlist$exposures}), the present signatures
(\code{in_LCDlist$signatures}) and meta information about the
signatures(\code{in_LCDlist$out_sig_ind_df}).}

\item{in_subgroups_df}{Data frame with subgroup information about the PIDs in
the above mentioned cohort.}

\item{in_save_plot}{Boolean flag to indicate whether per-PID plots should be
saved.}

\item{in_save_dir}{If per-PID plots are to be saved, this is the path where
to save them.}

\item{in_save_name}{Suffix to be appended to the sample name to generate the
name of the saved per-PID plots.}

\item{in_verbose_flag}{Whether to run verbose (1) or not (0).}

\item{...}{Data passed on to \code{\link{run_SMC}}.}
}
\value{
A list of lists. The top level is a named per-PID list, each entry is
  of type SMClist (cf. \code{\link{run_SMC}}).
}
\description{
Run an SMC analysis (stratification of the mutational catalogue) at per
sample / per-PID level, corresponding to a divide and conquer strategy. For
every single PID, only those signatures actually present in this PID will be
provided for the SMC analysis.
}
\examples{
 NULL
 
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/LCD.R
\name{LCD}
\alias{LCD}
\title{Linear Combination Decomposition}
\usage{
LCD(in_mutation_catalogue_df, in_signatures_df, in_per_sample_cutoff = 0)
}
\arguments{
\item{in_mutation_catalogue_df}{A numeric data frame \code{V} with \code{n}
rows and \code{m} columns, \code{n} being the number of features and
\code{m} being the number of samples}

\item{in_signatures_df}{A numeric data frame \code{W} with \code{n} rows and
\code{l} columns, \code{n} being the number of features and \code{l} being
the number of signatures}

\item{in_per_sample_cutoff}{A numeric value less than 1. Signatures from
within \code{W} with an exposure per sample less than \code{in_cutoff} will
be discarded.}
}
\value{
The exposures \code{H}, a numeric data frame with \code{l} rows and
 \code{m} columns, \code{l} being the number of signatures and \code{m} being
 the number of samples
}
\description{
\code{LCD} performs a mutational signatures decomposition of a given
mutational catalogue \code{V} with known signatures \code{W} by solving the
minimization problem \eqn{min(||W*H - V||)} with additional constraints of
non-negativity on H where W and V are known
}
\examples{

## define raw data
W_prim <- matrix(c(1,2,3,4,5,6),ncol=2)
W_prim_df <- as.data.frame(W_prim)
W_df <- YAPSA:::normalize_df_per_dim(W_prim_df,2) # corresponds to the sigs
W <- as.matrix(W_df)
## 1. Simple case: non-negativity already in raw data
H <- matrix(c(2,5,3,6,1,9,1,2),ncol=4)
H_df <- as.data.frame(H) # corresponds to the exposures
V <- W \%*\% H # matrix multiplication
V_df <- as.data.frame(V) # corresponds to the mutational catalogue
exposures_df <- YAPSA:::LCD(V_df,W_df)
## 2. more complicated: raw data already contains negative elements
## define indices where sign is going to be swapped
sign_ind <- c(5,7)
## now compute the indices of the other fields in the columns affected
## by the sign change
row_ind <- sign_ind \%\% dim(H)[1]
temp_ind <- 2*row_ind -1
other_ind <- sign_ind + temp_ind
## alter the matrix H to yield a new mutational catalogue
H_compl <- H
H_compl[sign_ind] <- (-1)*H[sign_ind]
H_compl_df <- as.data.frame(H_compl) # corresponds to the exposures
V_compl <- W \%*\% H_compl # matrix multiplication
V_compl_df <- as.data.frame(V_compl) # corresponds to the mutational catalog
exposures_df <- YAPSA:::LCD(V_compl_df,W_df)
exposures <- as.matrix(exposures_df)

}
\seealso{
\code{\link[limSolve]{lsei}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/basic_functions.R
\name{compare_sets}
\alias{compare_sets}
\title{Compare two sets of signatures by cosine distance}
\usage{
compare_sets(in_df_small, in_df_big, in_distance = cosineDist)
}
\arguments{
\item{in_df_small, in_df_big}{Numerical data frames \code{W1} and 
\code{W2}, ideally the bigger one first, both with \code{n} rows
and \code{l1} and \code{l2} columns, \code{n} being the number of
features and \code{l1} and \code{l2} being the respective numbers
of signatures of \code{W1} and \code{W2}}

\item{in_distance}{A function which computes the distance measure, default
is \code{\link{cosineDist}}}
}
\value{
A list with entries
 \code{distance},
 \code{hierarchy_small} and
 \code{hierarchy_big}.
\itemize{
 \item \code{distance}:
   A numerical data frame with the cosine distances between the
   columns of \code{W1}, indexing the rows, and \code{W2}, indexing
   the columns
 \item \code{hierarchy_small}:
   A data frame carrying the information of ranked similarity between
   the signatures in \code{W2} with the signatures in \code{W1}
 \item \code{hierarchy_big}:
   A data frame carrying the information of ranked similarity between
   the signatures in \code{W1} with the signatures in \code{W2}
}
}
\description{
Compare two sets of signatures, stored in numerical data frames
\code{W1} and \code{W2}, by computing the column-wise cosine distance
}
\examples{
sig_1_df <- data.frame(matrix(c(1,0,0,0,0,1,0,0,0,0,1,0),ncol=3))
names(sig_1_df) <- paste0("B",seq_len(dim(sig_1_df)[2]))
sig_2_df <- data.frame(matrix(c(1,1,0,0,0,0,1,1),ncol=2))
compare_sets(sig_1_df,sig_2_df)

}
\seealso{
\code{\link{cosineDist}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/indel_functions.R
\name{create_indel_mut_cat_from_df}
\alias{create_indel_mut_cat_from_df}
\title{Create a Mutational catalog from a data frame}
\usage{
create_indel_mut_cat_from_df(in_df, in_signatures_df)
}
\arguments{
\item{in_df}{A data frame constucted from a vcf-like file of a whole cohort
or single-sample. The first coloums are those of a standart vcf file,
followed by an arbitrary number of customs or used defined columns. One if
these can carry a PID (patient or sample identefyier) and the subgroup
information. Additionaly to consuct the the mutational catalog each variant
needs to be characterize into one of the 83 INDEL feature classes, which
can be perfomed with \code{\link[YAPSA]{attribution_of_indels}}}

\item{in_signatures_df}{A numeric data frame \code{W} with \code{n} rows and
\code{l} columns, \code{n} being the number of features and \code{l} being
the number of signatures.Data frame containing INDEL signatures which
should be used to create the mutational cataolog \code{V}.}
}
\value{
A count dataframe, the mutational catalog \code{V} with rownames
  indicating the INDELs and colnames having the PIDs
}
\description{
This function creates a mutational catalog from a data frame. It requires the
returend data frame optainted with
\code{\link[YAPSA]{attribution_of_indels}}.
}
\examples{
data(GenomeOfNl_raw)
data(sigs_pcawg)
GenomeOfNl_context <- attribute_sequence_contex_indel(in_dat =
 head(GenomeOfNl_raw))
GenomeOfNl_classified <- attribution_of_indels(GenomeOfNl_context)
GenomeOfNl_mut_cat <- create_indel_mut_cat_from_df(GenomeOfNl_classified,
 in_signatures_df=PCAWG_SP_ID_sigs_df)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/interact_foreign.R
\name{build_gene_list_for_pathway}
\alias{build_gene_list_for_pathway}
\title{Build a gene list for a given pathway name}
\usage{
build_gene_list_for_pathway(in_string, in_organism)
}
\arguments{
\item{in_string}{Name or description of the pathway}

\item{in_organism}{Name of the taxon to be searched in}
}
\value{
A character vector of gene names
}
\description{
Build a gene list for a given pathway name
}
\examples{
   species <- "hsa"
   gene_lists_meta_df <- data.frame(
     name=c("BER","NHEJ","MMR"),
     explanation=c("base excision repair",
                   "non homologous end joining",
                   "mismatch repair"))
   number_of_pathways <- dim(gene_lists_meta_df)[1]
   gene_lists_list <- list()
   for (i in seq_len(number_of_pathways)) {
     temp_list <- 
       build_gene_list_for_pathway(gene_lists_meta_df$explanation[i],
                                   species)
     gene_lists_list <- c(gene_lists_list,list(temp_list))
   }
   gene_lists_list
   
}
\seealso{
\code{\link[KEGGREST]{keggLink}}

\code{\link[KEGGREST]{keggFind}}

\code{\link{extract_names_from_gene_list}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/basic_functions.R
\name{test_exposureAffected}
\alias{test_exposureAffected}
\title{Test significance of association}
\usage{
test_exposureAffected(
  in_exposure_vector,
  in_affected_PIDs,
  in_mutation_label = NULL,
  in_exposure_label = NULL
)
}
\arguments{
\item{in_exposure_vector}{Named vector of a phenotype (e.g. exposures to a
specific signature)}

\item{in_affected_PIDs}{Character vector of samples affected by some
criterion, e.g. mutations in a pathway as returned by
\code{\link{find_affected_PIDs}}}

\item{in_mutation_label}{If non-NULL, prefix to the mutation status (x-axis
label) in the produced boxplot}

\item{in_exposure_label}{If non-NULL, prefix to the exposures (y-axis label)
in the produced boxplot}
}
\value{
A list with entries: \itemize{ \item \code{current_kruskal}: Kruskal
  test object from testing phenotype against affection \item
  \code{current_boxplot}: Boxplot of phenotype against affection }
}
\description{
Test significance of association between a vector of exposures and a
selection of samples, e.g. those affected by mutations in a pathway as
returned by \code{\link{find_affected_PIDs}}
}
\examples{
 NULL

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/confidence.R
\name{variateExp}
\alias{variateExp}
\title{Wrapper to compute confidence intervals for a cohort}
\usage{
variateExp(
  in_catalogue_df,
  in_sig_df,
  in_exposures_df,
  in_sigLevel = 0.05,
  in_delta = 0.4,
  in_pdf = NULL
)
}
\arguments{
\item{in_catalogue_df}{Input numerical data frame of the mutational catalog
of the cohort to be analyzed.}

\item{in_sig_df}{Numerical data frame of the signatures used for analysis.}

\item{in_exposures_df}{Input numerical data frame of the exposures computed
for the cohort to be analyzed.}

\item{in_sigLevel}{Significance level, parameter passed to \link{confIntExp}.}

\item{in_delta}{Inflation parameter for the alternative model, parameter
passed on to \link{confIntExp}}

\item{in_pdf}{Probability distribution function, parameter passed on to
\link{confIntExp}, if NULL assumed to be normal distribution.}
}
\value{
A melted data frame.
}
\description{
Wrapper function around \link{confIntExp}, which is applied to every
signature/sample pair in a cohort. The extracted upper and lower bounds of
the confidence intervals are added to the input data which is reordered and
melted in order to prepare for visualization with ggplot2.
}
\examples{
 library(BSgenome.Hsapiens.UCSC.hg19)
 data(lymphoma_test)
 data(lymphoma_cohort_LCD_results)
 data(sigs)
 word_length <- 3
 temp_list <- create_mutation_catalogue_from_df(
   lymphoma_test_df,this_seqnames.field = "CHROM",
   this_start.field = "POS",this_end.field = "POS",
   this_PID.field = "PID",this_subgroup.field = "SUBGROUP",
   this_refGenome = BSgenome.Hsapiens.UCSC.hg19,
   this_wordLength = word_length)
 lymphoma_catalogue_df <- temp_list$matrix
 lymphoma_PIDs <- colnames(lymphoma_catalogue_df)
 data("lymphoma_cohort_LCD_results")
 lymphoma_exposures_df <-
   lymphoma_Nature2013_COSMIC_cutoff_exposures_df[,lymphoma_PIDs]
 lymphoma_sigs <- rownames(lymphoma_exposures_df)
 lymphoma_sig_df <- AlexCosmicValid_sig_df[,lymphoma_sigs]
 lymphoma_complete_df <- variateExp(in_catalogue_df = lymphoma_catalogue_df,
                                    in_sig_df = lymphoma_sig_df,
                                    in_exposures_df = lymphoma_exposures_df,
                                    in_sigLevel = 0.025, in_delta = 0.4)
 head(lymphoma_complete_df)
 lymphoma_complete_df$sample <-
   factor(lymphoma_complete_df$sample,
          levels = colnames(lymphoma_exposures_df)[
            order(colSums(lymphoma_exposures_df), decreasing = TRUE)])
 sig_colour_vector <- c("black", AlexCosmicValid_sigInd_df$colour)
 names(sig_colour_vector) <-
   c("total", as.character(AlexCosmicValid_sigInd_df$sig))
 ggplot(data = lymphoma_complete_df,
        aes(x = sample, y = exposure, fill = sig)) +
   geom_bar(stat = "identity") +
   geom_errorbar(aes(ymin = lower, ymax = upper), width = 0.2) +
   facet_wrap(~sig, nrow = nrow(lymphoma_exposures_df) + 1) +
   theme_grey() +
   theme(panel.border = element_rect(fill = NA, colour = "black"),
         strip.background = element_rect(colour = "black"),
         legend.position = "none") +
   scale_fill_manual(values = sig_colour_vector)
 
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/basic_functions.R
\name{translate_to_hg19}
\alias{translate_to_hg19}
\alias{translate_to_1kG}
\title{Translate chromosome names to the hg19 naming convention}
\usage{
translate_to_hg19(in_dat, in_CHROM.field = "CHROM", in_verbose = FALSE)

translate_to_1kG(in_dat, in_CHROM.field = "chr", in_verbose = FALSE)
}
\arguments{
\item{in_dat}{GRanges object, VRanges object or data frame which carries one
column with chromosome information to be reformatted.}

\item{in_CHROM.field}{String indicating which column of \code{in_dat} carries
the chromosome information}

\item{in_verbose}{Whether verbose or not.}
}
\value{
GRanges object, VRanges object or data frame identical to
  \code{in_dat}, but with the names in the chromosome column replaced (if
  dealing with data frames) or alternatively the seqlevels replaced (if
  dealing with GRanges or VRanges objects).
}
\description{
\code{translate_to_hg19}: In hg19 naming convention, chromosome names start
with the prefix \emph{chr} and the gonosomes are called \emph{X} and
\emph{Y}. If data analysis is performed e.g. with
\code{\link[BSgenome.Hsapiens.UCSC.hg19]{BSgenome.Hsapiens.UCSC.hg19}}, this
naming convention is needed. The inverse transform is done with
\code{\link{translate_to_1kG}}.

\code{translate_to_1kG}: In 1kG, i.e. 1000 genomes naming convention, 
chromosome names have no prefix \emph{chr} and the gonosomes are called 
\emph{23} for \emph{X} and \emph{24} for \emph{Y}. If data analysis is 
performed e.g. with \code{hs37d5.fa}, this naming convention is needed. The
inverse transform is done with \code{\link{translate_to_hg19}}.
}
\examples{
test_df <- data.frame(CHROM=c(1,2,23,24),POS=c(100,120000000,300000,25000),
                      dummy=c("a","b","c","d"))
hg19_df <- translate_to_hg19(test_df, in_CHROM.field = "CHROM")
hg19_df

test_df <- data.frame(CHROM=c(1,2,23,24),POS=c(100,120000000,300000,25000),
                      dummy=c("a","b","c","d"))
hg19_df <- translate_to_hg19(test_df, in_CHROM.field = "CHROM")
onekG_df <- translate_to_1kG(hg19_df, in_CHROM.field = "CHROM")
onekG_df

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/io_functions.R
\name{read_entry}
\alias{read_entry}
\alias{read_list}
\title{Read a single vcf-like file into a single data frame}
\usage{
read_entry(
  current_ind,
  in_list,
  header = TRUE,
  in_header = NULL,
  variant_type = "SNV",
  delete.char = NULL,
  ...
)

read_list(in_list, in_parallel = FALSE, header = TRUE, in_header = NULL, ...)
}
\arguments{
\item{current_ind}{Index of the file to read from the list provided below.}

\item{in_list}{List of paths to vcf-like file to be read. The list may be
named.}

\item{header}{Boolean whether a header information should be read (as in
\code{\link[utils]{read.table}})}

\item{in_header}{Vector of column names to be substituted if non-NULL.}

\item{variant_type}{Default is "SNV" and provides additional plausibility and
checks, omitted if other string}

\item{delete.char}{Character to be deleted, e.g. in order to discriminate
between comment lines and header lines, if non-NULL}

\item{...}{Parameters passed on to \code{\link[utils]{read.table}}}

\item{in_parallel}{If multicore functionality is provided on a compute
cluster, this option may be set to TRUE in order to enhance speed.}
}
\value{
A vcf-like data frame

A list with entries: \itemize{ \item \code{vcf_like_df_list}: List of
  the read data frames \item \code{readVcf_time}: Object of class
  \code{proc_time}, which stores the time needed for reading in the data }
}
\description{
Note: this function uses \code{\link[utils]{read.csv}} to read vcf-like files
into data frames for single samples. As it uses
\code{\link[utils]{read.csv}}, the default value for \code{comment.char} is
"" and not "#" as it would have been for \code{\link[utils]{read.table}}.
}
\examples{
 NULL

 NULL

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/basic_functions.R
\name{melt_exposures}
\alias{melt_exposures}
\title{Generically melts exposure data frames}
\usage{
melt_exposures(in_df)
}
\arguments{
\item{in_df}{Numeric data frame with exposures.}
}
\value{
A data frame with the molten exposures.
}
\description{
Melt an exposure data frame with signatures as ID variables.
}
\examples{
 NULL

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/basic_functions.R
\name{find_affected_PIDs}
\alias{find_affected_PIDs}
\title{Find samples affected}
\usage{
find_affected_PIDs(in_gene_list, in_gene_vector, in_PID_vector)
}
\arguments{
\item{in_gene_list}{List of genes in the pathway of interest.}

\item{in_gene_vector}{Character vector for genes annotated to SNVs as in
\code{vcf_like_df}.}

\item{in_PID_vector}{Character vector for sample names annotated to SNVs as
in \code{vcf_like_df}.}
}
\value{
A character vector of the names of the affected samples
}
\description{
Find samples affected by SNVs in a certain pathway
}
\examples{
 NULL

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/basic_functions.R
\name{deriveSigInd_df}
\alias{deriveSigInd_df}
\title{Derive a signature_indices_df object}
\usage{
deriveSigInd_df(querySigs, subjectSigs, querySigInd = NULL, in_sort = FALSE)
}
\arguments{
\item{querySigs}{The signatures to compare to (given signatures).}

\item{subjectSigs}{The signatures to be compared (new signatures).
Alternatively this may be a complex object of type list and contain data
from different deconvolutions, each of which having a set of signaturen to
be compared.}

\item{querySigInd}{The object of type signature_indices_df (additional
informatio for a set of signatures) belonging to the set of known
signatures.}

\item{in_sort}{Whether to sort or not}
}
\value{
An object of type signature_indices_df (additional informatio for a
  set of signatures) belonging to the set of new signatures.
}
\description{
Derive a data frame of type signature_indices_df (additional information for
a set of signatures) from a set of given signatures for a set of new
signatures.
}
\examples{
 NULL

}
\seealso{
\code{\link{relateSigs}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/basic_functions.R
\name{round_precision}
\alias{round_precision}
\title{Round to a defined precision}
\usage{
round_precision(x, breaks = NULL, in_precision = 0.05, in_interval = c(0, 1))
}
\arguments{
\item{x}{Vector to be rounded}

\item{breaks}{The breaks used for rounding. Default NULL}

\item{in_precision}{Precition default 0.05}

\item{in_interval}{Interval needs to be larger than the precision value}
}
\value{
A list with two entries: \itemize{ \item \code{values}: the rounded
  vector \item \code{breaks}: the breaks used for rounding }
}
\description{
This function is an extension with regard to the function \code{\link{round}}
from base R as it allows not only digits as precision, but can also round to
a user-specified precision. The interval in which the rounding operation is
to be carried out also can be specified by the user (default is the unit
interval). Alternatively, breaks can be provided.
}
\examples{
 NULL

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/basic_functions.R
\name{merge_exposures}
\alias{merge_exposures}
\title{Merge exposure data frames}
\usage{
merge_exposures(in_exposures_list, in_signatures_df)
}
\arguments{
\item{in_exposures_list}{List of data frames (carrying information on
exposures).}

\item{in_signatures_df}{Data frame \code{W} in which the columns represent
the signatures.}
}
\value{
A data frame with the merged exposures.
}
\description{
Merges with the special feature of preserving the signatures and signature
order.
}
\examples{
 NULL

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/basic_functions.R
\name{repeat_df}
\alias{repeat_df}
\title{Create a data frame with default values}
\usage{
repeat_df(in_value, in_rows, in_cols)
}
\arguments{
\item{in_value}{Default entry to be repeated in the data frame}

\item{in_rows, in_cols}{Dimensions of the data frame to be created}
}
\value{
The created data frame
}
\description{
Create a data frame with default values
}
\examples{
## 1. Initialize with numeric value:
repeat_df(1,2,3)
## 2. Initialize with NA value:
repeat_df(NA,3,2)
## 3. Initialize with character:
repeat_df("a",4,3)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/complex_functions.R
\name{get_extreme_PIDs}
\alias{get_extreme_PIDs}
\title{Return those PIDs which have an extreme pattern for signature exposure}
\usage{
get_extreme_PIDs(in_exposures_df, in_quantile = 0.03)
}
\arguments{
\item{in_exposures_df}{Data frame with the signature exposures}

\item{in_quantile}{Quantile for the amount of extreme PIDs to be selected.}
}
\value{
A data frame with 4 rows per signature (high PIDs, high exposures,
  low PIDs, low exposures); the number of columns depends on the quantile
  chosen.
}
\description{
For all signatures found in a project, this function returns the sample
identifiers (PIDs) with extremely high or extremely low exposures of the
respective signatures.
}
\examples{
 data(lymphoma_cohort_LCD_results)
 get_extreme_PIDs(lymphoma_Nature2013_COSMIC_cutoff_exposures_df,0.05)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/complex_functions.R
\name{compute_comparison_stat_df}
\alias{compute_comparison_stat_df}
\title{Extract statistical measures for entity comparison}
\usage{
compute_comparison_stat_df(in_sim_df)
}
\arguments{
\item{in_sim_df}{A similarity data frame as extracted by
\code{\link{compare_to_catalogues}}}
}
\value{
A dataframe containing statistical measures, prepared for bar plot
}
\description{
Compare one mutational catalogue (e.g. of one index patient) to a list of
reference mutational catalogues (e.g. from the initial Alexandrov
puplication) by cosine similarities
}
\examples{
 NULL

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/basic_functions.R
\name{shapiro_if_possible}
\alias{shapiro_if_possible}
\title{Wrapper for Shapiro test but allow for all identical values}
\usage{
shapiro_if_possible(in_vector)
}
\arguments{
\item{in_vector}{Numerical vector the Shapiro-Wilk test is computed on}
}
\value{
p-value of the Shapiro-Wilk test, zero if all entries in the input
 vector \code{in_vector} are identical.
}
\description{
Wrapper for Shapiro test but allow for all identical values
}
\examples{
 shapiro_if_possible(runif(100,min=2,max=4))
 shapiro_if_possible(rnorm(100,mean=5,sd=3))
 shapiro_if_possible(rep(4.3,100))
 shapiro_if_possible(c("Hello","World"))

}
\seealso{
\code{\link[stats]{shapiro.test}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/confidence.R
\name{enrichSigs}
\alias{enrichSigs}
\title{Compare to background distribution}
\usage{
enrichSigs(in_cohort_exposures_df, in_background_exposures_df, in_sig_df)
}
\arguments{
\item{in_cohort_exposures_df}{Numerical data frame of the exposures of the
cohort of interest.}

\item{in_background_exposures_df}{Numerical data frame of the exposures of
the background.}

\item{in_sig_df}{Numerical data frame encoding the mutational signatures.}
}
\value{
A data frame with counts and p-values from Fisher tests.
}
\description{
Compare exposures from an analysis of mutational signatures in a cohort of
interest to exposures computed in a background (e.g. the set of WES and WGS
samples from Alexandrov 2013).
}
\examples{
NULL

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\name{MutCat_indel_df}
\alias{MutCat_indel_df}
\title{Example mutational catalog for the Indel vignette}
\usage{
data(GenomeOfNl_MutCat)
}
\value{
A data fame in the layout of a Indel mutational catalog
}
\description{
\code{MutCat_indel_df}: A data frame in the format of a mutation catalog. 
The mutational catalog contains Indel variants from the 
\code{GenomeOfNl_raw} data. Variants were random sampled for 15 artificial
patient for the purpose to have a Indel mutational catalog and have to
show the functionality of the package. The results of the mutational 
catalog should not be interpreted fot they biological relevance. 
Mutational catalog was created with 
\code{create_indel_mutation_catalogue_from_df} function.
}
\examples{
data(GenomeOfNl_MutCat)
head(MutCat_indel_df)
dim(MutCat_indel_df)

}
\references{
Mutational catalog created form release version 5 of the Genome 
of NL 
\url{https://www.nlgenome.nl/menu/main/app-go-nl/?page_id=9}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/SMC.R
\name{stat_test_subgroups}
\alias{stat_test_subgroups}
\title{Test for differences in average signature exposures between subgroups}
\usage{
stat_test_subgroups(
  in_exposures_df,
  in_subgroups_df,
  in_subgroups.field = "subgroup",
  in_PID.field = "PID"
)
}
\arguments{
\item{in_exposures_df}{Numerical data frame of the exposures (i.e.
contributions of the different signatures to the number of point mutations
per PID)}

\item{in_subgroups_df}{Data frame indicating which PID belongs to which
subgroup}

\item{in_subgroups.field}{Name indicating which column in
\code{in_subgroups_df} contains the subgroup information}

\item{in_PID.field}{Name indicating which column in \code{in_subgroups_df}
contains the PID information}
}
\value{
A list with entries \code{kruskal_df}, \code{kruskal_posthoc_list},
  \itemize{ \item \code{kruskal_df}: A data frame containing results
  (statistic and p values) of the Kruskal Wallis tests (tests for enrichment
  or depletion in the different strata for every signature independently).
  \item \code{kruskal_posthoc_list}: A list of results of pairwise posthoc
  tests carried out for those signatures where the Kruskal Wallis test
  yielded a significant p-value (carried out by
  \code{\link[PMCMRplus]{kwAllPairsNemenyiTest}}). }
}
\description{
Apply Kruskal-Wallis tests to detect differences in the signature exposures
between different subgroups. Uses \code{\link{split_exposures_by_subgroups}}.
Algorithm analogous to \code{\link{stat_test_SMC}}.
}
\examples{
 NULL

}
\seealso{
\code{\link{split_exposures_by_subgroups}}

\code{\link{stat_test_SMC}}

\code{\link[PMCMRplus]{kwAllPairsNemenyiTest}}

\code{\link[stats]{kruskal.test}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_functions.R
\name{plot_SMC}
\alias{plot_SMC}
\title{Plot results of the Stratification of a Mutational Catalogue}
\usage{
plot_SMC(
  number_of_strata,
  output_path,
  decomposition_method,
  number_of_sigs,
  name_list,
  exposures_strata_list,
  this_signatures_ind_df,
  this_subgroups_df,
  in_strata_order_ind,
  exposures_both_rel_df_list,
  cohort_method_flag,
  fig_width = 1200,
  fig_height = 900,
  fig_type = "png",
  in_label_orientation = "turn",
  this_sum_ind = NULL
)
}
\arguments{
\item{number_of_strata}{Number of strata as deduced from \code{link{SMC}}}

\item{output_path}{Path to file where the results are going to be stored.
If NULL, the results will be plotted to the running environment.}

\item{decomposition_method}{String for the filename of the generated 
barplot.}

\item{number_of_sigs}{Number of signatures}

\item{name_list}{Names of the contructed strata.}

\item{exposures_strata_list}{The list of \code{s} strata specific exposures
Hi, all are numerical data frames with \code{l} rows and \code{m} columns,
\code{l} being the number of signatures and \code{m} being the number of
samples}

\item{this_signatures_ind_df}{A data frame containing meta information about
the signatures}

\item{this_subgroups_df}{A data frame indicating which PID (patient or 
sample identifyier) belongs to which subgroup}

\item{in_strata_order_ind}{Index vector defining reordering of the strata}

\item{exposures_both_rel_df_list}{A list of \code{s} strata specific
cohortwide (i.e. averaged over cohort) normalized exposures}

\item{cohort_method_flag}{Either or several of
\code{c("all_PIDs","cohort","norm_PIDs")}, representing alternative ways 
to average over the cohort.}

\item{fig_width}{Width of the figure to be plotted}

\item{fig_height}{Height of the figure to be plotted}

\item{fig_type}{png or pdf}

\item{in_label_orientation}{Whether or not to turn the labels on the x-axis.}

\item{this_sum_ind}{Optional set of indices for reordering the PIDs}
}
\value{
The function doesn't return any value.
}
\description{
Plot a big composite figure with 3 columns: in the left column the per-PID
absolute exposures will be shown, in the middle column the per_PID relative
or normalized exposures will be shown, in the right column the cohort-wide
exposures are shown (averaged over PIDs).
}
\examples{
NULL

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/basic_functions.R
\name{normalize_df_per_dim}
\alias{normalize_df_per_dim}
\alias{average_over_present}
\alias{sd_over_present}
\alias{stderrmean_over_present}
\title{Useful functions on data frames}
\usage{
normalize_df_per_dim(in_df, in_dimension)

average_over_present(in_df, in_dimension)

sd_over_present(in_df, in_dimension)

stderrmean_over_present(in_df, in_dimension)
}
\arguments{
\item{in_df}{Data frame to be normalized}

\item{in_dimension}{Dimension along which the operation will be carried out}
}
\value{
The normalized numerical data frame (\code{normalize_df_per_dim})

A vector of the means (\code{average_over_present})

A vector of the standard deviations (\code{sd_over_present})

A vector of the standard errors of the mean 
 (\code{stderrmean_over_present})
}
\description{
\code{normalize_df_per_dim}: Normalization is carried out by dividing by
\code{rowSums} or \code{colSums}; for rows with \code{rowSums=0} or columns
with \code{colSums=0}, the normalization is left out.

\code{average_over_present}: 
If averaging over columns, zero rows (i.e. those with \code{rowSums=0})
are left out, if averaging over rows, zero columns (i.e. those with
\code{colSums=0}) are left out.

\code{sd_over_present}: 
If computing the standard deviation over columns, zero rows
(i.e. those with \code{rowSums=0}) are left out, if computing
the standard deviation over rows, zero columns (i.e. those with
\code{colSums=0}) are left out.

\code{stderrmean_over_present}: 
If computing the standard error of the mean over columns, zero rows
(i.e. those with \code{rowSums=0}) are left out, if computing the
standard error of the mean over rows, zero columns (i.e. those with
\code{colSums=0}) are left out. Uses the function \code{\link{stderrmean}}
}
\examples{
test_df <- data.frame(matrix(c(1,2,3,0,5,2,3,4,0,6,0,0,0,0,0,4,5,6,0,7),
                             ncol=4))
## 1. Normalize over rows:
normalize_df_per_dim(test_df,1)
## 2. Normalize over columns:
normalize_df_per_dim(test_df,2)

test_df <- data.frame(matrix(c(1,2,3,0,5,2,3,4,0,6,0,0,0,0,0,4,5,6,0,7),
                             ncol=4))
## 1. Average over non-zero rows:
average_over_present(test_df,1)
## 2. Average over non-zero columns:
average_over_present(test_df,2)

test_df <- data.frame(matrix(c(1,2,3,0,5,2,3,4,0,6,0,0,0,0,0,4,5,6,0,7),
                             ncol=4))
## 1. Compute standard deviation over non-zero rows:
sd_over_present(test_df,1)
## 2. Compute standard deviation over non-zero columns:
sd_over_present(test_df,2)

test_df <- data.frame(matrix(c(1,2,3,0,5,2,3,4,0,6,0,0,0,0,0,4,5,6,0,7),
                             ncol=4))
## 1. Compute standard deviation over non-zero rows:
stderrmean_over_present(test_df,1)
## 2. Compute standard deviation over non-zero columns:
stderrmean_over_present(test_df,2)

}
\seealso{
\code{\link{stderrmean}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/interact_foreign.R
\name{run_kmer_frequency_correction}
\alias{run_kmer_frequency_correction}
\title{Provide comprehensive correction factors for kmer content}
\usage{
run_kmer_frequency_correction(
  in_ref_genome_fasta,
  in_target_capture_bed,
  in_word_length,
  project_folder,
  target_capture_fasta = "targetCapture.fa",
  in_verbose = 1
)
}
\arguments{
\item{in_ref_genome_fasta}{Path to the reference genome fasta file used.}

\item{in_target_capture_bed}{Path to a bed file containing the information on
the used target capture. May also be a compressed bed.}

\item{in_word_length}{Integer number defining the length of the features or
motifs, e.g. 3 for tripletts or 5 for pentamers}

\item{project_folder}{Path where the created files, especially the fasta file
with the sequence of the target capture and the count matrices, can be
stored.}

\item{target_capture_fasta}{Name of the fasta file of the target capture to
be created if not yet existent.}

\item{in_verbose}{Verbose if \code{in_verbose=1}}
}
\value{
A list with 2 entries: \itemize{ \item \code{rel_cor}: The correction
factors after normalization as in
\code{\link{run_kmer_frequency_normalization}} \item \code{abs_cor}: The
correction factors without normalization. }
}
\description{
This function is analogous to
\code{\link[SomaticSignatures]{normalizeMotifs}}. If an analysis of
mutational signatures is performed on e.g. Whole Exome Sequencing (WES) data,
the signatures and exposures have to be adapted to the potentially different
kmer (trinucleotide) content of the target capture. The present function
takes as arguments paths to the used reference genome and target capture
file. It the extracts the sequence of the target capture by calling
\code{bedtools getfasta} on the system command prompt.
\code{run_kmer_frequency_normalization} then calls a custom made perl script
\code{kmer_frequencies.pl} also included in this package to count the
occurences of the tripletts in both the whole reference genome and the
created target capture sequence. These counts are used for normalization as
in \code{\link[SomaticSignatures]{normalizeMotifs}}. Note that
\code{\link[SomaticSignatures]{kmerFrequency}} provides a solution to
approximate kmer frequencies by random sampling. As opposed to that approach,
the function described here deterministically counts all occurences of the
kmers in the respective genome.
}
\examples{
 NULL

}
\seealso{
\code{\link[SomaticSignatures]{normalizeMotifs}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{exchange_colour_vector}
\alias{exchange_colour_vector}
\title{Colours codes for displaying SNVs}
\usage{
data(exchange_colour_vector)
}
\value{
A named character vector
}
\description{
Vector attributing colours to nucleotide exchanges used when displaying 
SNV information, e.g. in a rainfall plot.
}
\author{
Daniel Huebschmann \email{huebschmann.daniel@googlemail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/basic_functions.R
\name{sum_over_list_of_df}
\alias{sum_over_list_of_df}
\title{Elementwise sum over a list of (numerical) data frames}
\usage{
sum_over_list_of_df(in_df_list)
}
\arguments{
\item{in_df_list}{List of (numerical) data frames}
}
\value{
A numerical data frame with the same dimensions as the entries of
 \code{in_df_list} with elementwise sums
}
\description{
Elementwise sum over a list of (numerical) data frames
}
\examples{
A <- data.frame(matrix(c(1,1,1,2,2,2),ncol=2))
B <- data.frame(matrix(c(3,3,3,4,4,4),ncol=2))
df_list <- list(A=A,B=B)
sum_over_list_of_df(df_list)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_functions.R
\name{trellis_rainfall_plot}
\alias{trellis_rainfall_plot}
\title{Create a rainfall plot in a trellis structure}
\usage{
trellis_rainfall_plot(
  in_rainfall_dat,
  in_point_size = unit(1, "mm"),
  in_rect_list = NULL,
  in_title = "",
  in_CHROM.field = "CHROM",
  in_POS.field = "POS",
  in_dist.field = "dist",
  in_col.field = "col"
)
}
\arguments{
\item{in_rainfall_dat}{Data frame which has to contain at least columns for
chromosome, position, intermutational distance and colour information}

\item{in_point_size}{size of the points in the rainfall plot to be created has
to be provided with appropriate units, e.g. in_point_size=unit(0.5,"mm")}

\item{in_rect_list}{Optional argument, if present, will lead to highlighting
of specified regions by coloured but transparent rectangles}

\item{in_title}{Title in the figure to be created.}

\item{in_CHROM.field}{String indicating which column of \code{in_rainfall_dat}
carries the chromosome information}

\item{in_POS.field}{String indicating which column of \code{in_rainfall_dat}
carries the position information}

\item{in_dist.field}{String indicating which column of \code{in_rainfall_dat}
carries the intermutational distance information}

\item{in_col.field}{String indicating which column of \code{in_rainfall_dat}
carries the colour information encoding the nucleotide exchange}
}
\value{
The function doesn't return any value.

The function doesn't return any value.
}
\description{
A trellis is a plot structure which allows space optimized multi-panel multi
track plots. This function uses the package \pkg{gtrellis} developed by
Zuguang Gu, also available at
\url{https://www.bioconductor.org/packages/release/bioc/html/gtrellis.html}.
The graphics in the tracks within a gtrellis plot are mostly drawn with
functions from the package \pkg{grid}. Note that for technical reasons, the
column indicating the chromosome MUST have the name \emph{chr} and be the
first column in the data frame supplied to the gtrellis functions. Therefore
reformatting is performed in this function before calling gtrellis functions.
}
\examples{
 data(lymphoma_test)
 choice_PID <- "4121361"
 PID_df <- subset(lymphoma_test_df,PID==choice_PID)
 trellis_rainfall_plot(PID_df,in_point_size=unit(0.5,"mm"))


}
\seealso{
\code{\link[gtrellis]{gtrellis_layout}}

\code{\link[gtrellis]{add_track}}

\code{\link[grid]{grid.points}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{sigs_pcawg}
\alias{sigs_pcawg}
\alias{PCAWG_SP_SBS_sigs_Artif_df}
\alias{PCAWG_SP_SBS_sigInd_Artif_df}
\alias{PCAWG_SP_SBS_sigs_Real_df}
\alias{PCAWG_SP_SBS_sigInd_Real_df}
\alias{PCAWG_SP_ID_sigs_df}
\alias{PCAWG_SP_ID_sigInd_df}
\title{Data for PCAWG SNV signatures (COSMIC v3), including artifacts
 
\code{PCAWG_SP_SBS_sigs_Artif_df}: Data frame of the signatures published 
by Alexandrov et al. (Biorxiv 2013) which were decomposed with the 
method SigProfiler. SNV signatures are labeled with SBS, single base 
signature. There are 67 signatures which constitute the columns, 47 of 
which were validated by a bayesian NFM mehtod, SignatureAnayzer. Validated 
signatures are SBS1-SBS26,SBS28-SBS42 and SBS44. SBS7 is split up into 
7 a/b/c and d. SBS10 ans SBS17 are both split up into a and b. Resulting in
a 47 validated sigantures. Please note, unlike the paper by Alexandrov et al.
(Biorxiv 2018) the data sets do not contain a SBS84 and SBS85 as not all 
were availiablt to perfom supervised signature analysis. In total there are 
96 different features and therefore 96 rows when dealing with a trinucleotide
context.}
\source{
\code{PCAWG_SNV}: \url{https://www.synapse.org/#!Synapse:syn11738319}

\code{PCAWG_INDEL}: \url{https://cancer.sanger.ac.uk/cosmic/signatures/ID}
}
\usage{
data(sigs_pcawg)
}
\description{
\code{PCAWG_SP_SBS_sigInd_Artif_df}: Meta-information for 
\code{PCAWG_SP_SBS_sigs_Artif_df}

\code{PCAWG_SP_SBS_sigs_Real_df}: Data frame of only the validated
signatures published by Alexandrov et al. (Biorxiv 2018), corresponding 
to the column 1-26, 28-42 and 44 of the \code{PCAWG_SP_SBS_sigs_Artif_df}
data frame

\code{PCAWG_SP_SBS_sigInd_Real_df}: Meta-information for 
\code{PCAWG_SP_SBS_sigs_Real_df}

\code{PCAWG_SP_ID_sigs_df}: Data frame with Indel signatures published by
Alexandrov et al. (Biorxiv 2018) which were decomposed with the method
SigProfiler. There are 17 Sigantures reported but as supervised signatures
are only valid for whole genome sequencing data analysis. In whole genome
sequencing data the Indel signature ID15 was not discribed and thus is not
part of this data set. In total 83 features are described. The categorization
consideres the size of the insertion and delition, the motif, and the
sequence context. Hereby the number of repetition or patial repetition of the
motif is determined.

\code{PCAWG_SP_ID_sigInd_df}: Meta-information for 
\code{PCAWG_SP_ID_sigs_df}
}
\references{
Alexandrov et al. (Biorxiv 2018)
}
\author{
Lea Jopp-Saile \email{huebschmann.daniel@googlemail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/complex_functions.R
\name{create_mutation_catalogue_from_df}
\alias{create_mutation_catalogue_from_df}
\title{Create a Mutational Catalogue from a data frame}
\usage{
create_mutation_catalogue_from_df(
  this_df,
  this_refGenome_Seqinfo = NULL,
  this_seqnames.field = "X.CHROM",
  this_start.field = "POS",
  this_end.field = "POS",
  this_PID.field = "PID",
  this_subgroup.field = "subgroup",
  this_refGenome,
  this_wordLength,
  this_verbose = 1,
  this_rownames = c(),
  this_adapt_rownames = 1
)
}
\arguments{
\item{this_df}{A data frame constructed from a vcf-like file of a whole
cohort. The first columns are those of a standard vcf file, followed by an
arbitrary number of custom or used defined columns. One of these can carry
a PID (patient or sample identifyier) and one can carry subgroup
information.}

\item{this_refGenome_Seqinfo}{A seqInfo object, referring to the reference
genome used. Argument passed on to \code{\link{makeGRangesFromDataFrame}}
and thus indirectly to \code{\link{makeGRangesFromDataFrame}}.}

\item{this_seqnames.field}{Indicates the name of the column in which the
chromosome is encoded}

\item{this_start.field}{Indicates the name of the column in which the start
coordinate is encoded}

\item{this_end.field}{Indicates the name of the column in which the end
coordinate is encoded}

\item{this_PID.field}{Indicates the name of the column in which the PID
(patient or sample identifier) is encoded}

\item{this_subgroup.field}{Indicates the name of the column in which the
subgroup information is encoded}

\item{this_refGenome}{The reference genome handed over to
\code{\link{create_mutation_catalogue_from_VR}} and indirectly to
\code{\link[SomaticSignatures]{mutationContext}} and used to extract the
motif context of the variants in \code{in_vr}.}

\item{this_wordLength}{The size of the motifs to be extracted by
\code{\link[SomaticSignatures]{mutationContext}}}

\item{this_verbose}{Verbose if \code{this_verbose=1}}

\item{this_rownames}{Optional parameter to specify rownames of the mutational
catalogue \code{V} i.e. the names of the features.}

\item{this_adapt_rownames}{Rownames of the output \code{matrix} will be
adapted if \code{this_adapt_rownames=1}}
}
\value{
A list with entries \code{matrix} and \code{frame} obtained from
  \code{\link{create_mutation_catalogue_from_VR}}: \itemize{ \item
  \code{matrix}: The mutational catalogue \code{V} \item \code{frame}:
  Additional and meta information on rownames (features), colnames (PIDs) and
  subgroup attribution. }
}
\description{
This function creates a mutational catalogue from a data frame. It is a
wrapper function for \code{\link{create_mutation_catalogue_from_VR}}: it
first creates a VRanges object from the data frame by
\code{\link{makeVRangesFromDataFrame}} and then passes this object on to the
above mentioned custom function.
}
\examples{
 library(BSgenome.Hsapiens.UCSC.hg19)
 data(lymphoma_test)
 word_length <- 3
 temp_list <- create_mutation_catalogue_from_df(
   lymphoma_test_df,this_seqnames.field = "CHROM",
   this_start.field = "POS",this_end.field = "POS",
   this_PID.field = "PID",this_subgroup.field = "SUBGROUP",
   this_refGenome = BSgenome.Hsapiens.UCSC.hg19,
   this_wordLength = word_length)
   dim(temp_list$matrix)
   head(temp_list$matrix)

}
\seealso{
\code{\link{makeVRangesFromDataFrame}}

\code{\link{create_mutation_catalogue_from_VR}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/interact_foreign.R
\name{extract_names_from_gene_list}
\alias{extract_names_from_gene_list}
\title{Return gene names from gene lists}
\usage{
extract_names_from_gene_list(in_KEGG_gene_list, l)
}
\arguments{
\item{in_KEGG_gene_list}{Gene list to extract names from}

\item{l}{Index of the gene to be extracted}
}
\value{
The gene name.
}
\description{
Return gene names from gene lists
}
\examples{
 NULL

}
\seealso{
\code{\link[KEGGREST]{keggGet}}

\code{\link{build_gene_list_for_pathway}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_functions.R
\name{exposures_barplot}
\alias{exposures_barplot}
\title{Wrapper for enhanced_barplot}
\usage{
exposures_barplot(
  in_exposures_df,
  in_signatures_ind_df = NULL,
  in_subgroups_df = NULL,
  in_sum_ind = NULL,
  in_subgroups.field = "subgroup",
  in_title = "",
  in_labels = TRUE,
  in_show_subgroups = TRUE,
  ylab = NULL,
  in_barplot_borders = TRUE,
  in_column_anno_borders = FALSE
)
}
\arguments{
\item{in_exposures_df}{Numerical data frame encoding the exposures \code{H},
i.e. which signature contributes how much to which PID (patient identifier
or sample).}

\item{in_signatures_ind_df}{A data frame containing meta information about
the signatures. If NULL, the colour information for the signatures is 
taken from a rainbow palette.}

\item{in_subgroups_df}{A data frame indicating which PID (patient or sample
identifyier) belongs to which subgroup. If NULL, it is assumed that all
PIDs belong to one common subgroup. The colour coding for the default
subgroup is red.}

\item{in_sum_ind}{Index vector influencing the order in which the PIDs are
going to be displayed}

\item{in_subgroups.field}{String indicating the column name in
\code{in_subgroups_df} to take the subgroup information from.}

\item{in_title}{Title for the plot to be created.}

\item{in_labels}{Flag, if \code{TRUE} the PIDs are displayed on the x-axis}

\item{in_show_subgroups}{Flag, if \code{TRUE} then PIDs are grouped by
subgroups}

\item{ylab}{Label of the y-axis on the plot to be generate}

\item{in_barplot_borders}{Whether or not to show border lines in barplot}

\item{in_column_anno_borders}{Whether or not to draw separating lines 
between the fields in the annotation}
}
\value{
The generated barplot - a ggplot2 plot
}
\description{
Wrapper for enhanced_barplot
}
\examples{
 data(lymphoma_cohort_LCD_results)
 exposures_barplot(lymphoma_Nature2013_COSMIC_cutoff_exposures_df,
                   chosen_signatures_indices_df,
                   COSMIC_subgroups_df)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_functions.R
\name{annotation_exposures_barplot}
\alias{annotation_exposures_barplot}
\title{Plot the exposures of a cohort with different layers of annotation}
\usage{
annotation_exposures_barplot(
  in_exposures_df,
  in_signatures_ind_df,
  in_subgroups_df,
  in_annotation_df = NULL,
  in_annotation_col = NULL,
  ylab = NULL,
  title = "",
  in_labels = FALSE,
  in_barplot_borders = TRUE,
  in_column_anno_borders = FALSE,
  in_annotation_legend_side = "right",
  in_padding = unit(c(2, 20, 2, 2), "mm"),
  in_annotation = NULL
)
}
\arguments{
\item{in_exposures_df}{Numerical data frame encoding the exposures \code{H},
i.e. which signature contributes how much to which PID (patient identifier
or sample).}

\item{in_signatures_ind_df}{A data frame containing meta information about
the signatures}

\item{in_subgroups_df}{A data frame indicating which PID (patient or sample
identifyier) belongs to which subgroup}

\item{in_annotation_df}{A data frame indicating which PID (patient or sample
identifyier) belongs to which subgroup for all layers of annotation}

\item{in_annotation_col}{A list indicating colour attributions for all
layers of annotation}

\item{ylab}{String indicating the column name in \code{in_subgroups_df} to
take the subgroup information from.}

\item{title}{Title for the plot to be created.}

\item{in_labels}{Whether or not to show the names of the samples.}

\item{in_barplot_borders}{Whether or not to show border lines in barplot}

\item{in_column_anno_borders}{Whether or not to draw separating lines 
between the fields in the annotation}

\item{in_annotation_legend_side}{Where to put the legends of the annotation
df, default is right.}

\item{in_padding}{Parameter passed on to function
\code{\link[ComplexHeatmap]{draw}}}

\item{in_annotation}{A full annotation object may also be provided by the
educated user.}
}
\value{
The function doesn't return any value.
}
\description{
The exposures \code{H}, determined by NMF or by \code{\link{LCD}}, are
displayed as a stacked barplot by calling
\code{\link[ComplexHeatmap]{Heatmap}}. The x-axis displays the PIDs (patient
identifier or sample), the y-axis the counts attributed to the different
signatures with their respective colours per PID. It is analogous to
\code{\link{plot_exposures}}. As many layers of information as desired can be
added via an annotation data frame. The annotation data is handled in a way
similar to \code{\link{annotation_heatmap_exposures}}. This function calls:
\itemize{ \item \code{\link[ComplexHeatmap]{rowAnnotation}}, \item
\code{\link[ComplexHeatmap]{HeatmapAnnotation}} and \item
\code{\link[ComplexHeatmap]{Heatmap}} }
}
\details{
It might be necessary to install the newest version of the
development branch of the packages \pkg{circlize} and \pkg{ComplexHeatmap} by
Zuguang Gu: \code{devtools::install_github("jokergoo/circlize")} and
\code{devtools::install_github("jokergoo/ComplexHeatmap")}

It might be necessary to install the newest version of the
development branch of the packages \pkg{circlize} and \pkg{ComplexHeatmap}
 by Zuguang Gu: \code{devtools::install_github("jokergoo/circlize")} and
\code{devtools::install_github("jokergoo/ComplexHeatmap")}
}
\examples{
 NULL

}
\seealso{
\code{\link[ComplexHeatmap]{HeatmapAnnotation}}

\code{\link[ComplexHeatmap]{Heatmap}}

\code{\link[ComplexHeatmap]{decorate_heatmap_body}}

\code{\link{annotation_heatmap_exposures}}

\code{\link{plot_exposures}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/interact_foreign.R
\name{run_annotate_vcf_pl}
\alias{run_annotate_vcf_pl}
\title{Wrapper function to annotate addition information}
\usage{
run_annotate_vcf_pl(
  in_data_file,
  in_anno_track_file,
  in_new_column_name,
  out_file,
  in_data_file_type = "custom",
  in_anno_track_file_type = "bed",
  in_data_CHROM.field = "CHROM",
  in_data_POS.field = "POS",
  in_data_END.field = "POS"
)
}
\arguments{
\item{in_data_file}{Path to the input vcf-like file to be annotated}

\item{in_anno_track_file}{Path to the input file containing the annotation
track}

\item{in_new_column_name}{String indicating the name of the column to be
created for annotation.}

\item{out_file}{Path where the created files can be stored.}

\item{in_data_file_type}{\code{custom} for vcf-like}

\item{in_anno_track_file_type}{Type of the file \code{in_anno_track_file}
containing the annotation track.}

\item{in_data_CHROM.field}{String indicating which column of
\code{in_data_file} contains the chromosome information.}

\item{in_data_POS.field}{String indicating which column of
\code{in_data_file} contains the position information.}

\item{in_data_END.field}{String indicating which column of
\code{in_data_file} contains the end information if regions are considered.}
}
\value{
Return zero if no problems occur.
}
\description{
Wrapper function to the perl script annotate_vcf.pl which annotates data of a
track stored in file_B (may be different formats) to called variants stored
in a vcf-like file_A.
}
\examples{
 NULL

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/basic_functions.R
\name{cosineMatchDist}
\alias{cosineMatchDist}
\title{Compute an altered cosine distance of two vectors}
\usage{
cosineMatchDist(a, b)
}
\arguments{
\item{a, b}{Numerical vectors of same length}
}
\value{
The scalar product of the reduced input vectors divided by the
       product of the norms of the two reduced input vectors
}
\description{
This is an altered cosine distance: it first reduced the dimension of the
two input vectors to only those coordinates where both have non-zero entries.
The cosine similarity is then computed on these reduced vectors, i.e. on a
sub-vector space.
}
\examples{
## 1. Orthogonal vectors:
cosineMatchDist(c(1,0),c(0,1))
## 2. Non-orthogonal vectors:
cosineMatchDist(c(1,0),c(1,1))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{cutoffs}
\alias{cutoffs}
\alias{cutoffCosmicValid_rel_df}
\alias{cutoffCosmicArtif_rel_df}
\alias{cutoffCosmicValid_abs_df}
\alias{cutoffCosmicArtif_abs_df}
\alias{cutoffInitialValid_rel_df}
\alias{cutoffInitialArtif_rel_df}
\alias{cutoffInitialValid_abs_df}
\alias{cutoffInitialArtif_abs_df}
\title{Cutoffs for a supervised analysis of mutational signatures.}
\usage{
data(cutoffs)
}
\description{
Series of data frames with signature-specific cutoffs. All values represent
optimal cutoffs. The optimal cutoffs were determined for different choices 
of parameters in the cost function of the optimization. The row index is 
equivalent to the ratio between costs for false negative attribution and 
false positive attribution. The columns correspond to the different 
signatures. To be used with \code{\link{LCD_complex_cutoff}}. 
There are two different sets of cutoffs one for the signatures described by
Alexandrov et al.(Natue 2013) and one for the signatures dokumented in 
Alexandriv et al. (biorxiv 2018). The calculation of the PCAWG signature 
specific cutoffs was perfomed in a single-sample resolution which are both 
valid for whole genome and whole exome sequencing data analysis.

\code{cutoffCosmicValid_rel_df}: Optimal cutoffs for 
\code{\link{AlexCosmicValid_sig_df}}, i.e. COSMIC signatures, only 
validated, trained on relative exposures.

\code{cutoffCosmicArtif_rel_df}: Optimal cutoffs for 
\code{\link{AlexCosmicArtif_sig_df}}, i.e. COSMIC signatures, including 
artifact signatures, trained on relative exposures.

\code{cutoffCosmicValid_abs_df}: Optimal cutoffs for 
\code{\link{AlexCosmicValid_sig_df}}, i.e. COSMIC signatures, only 
validated, trained on absolute exposures.

\code{cutoffCosmicArtif_abs_df}: Optimal cutoffs for 
\code{\link{AlexCosmicArtif_sig_df}}, i.e. COSMIC signatures, including 
artifact signatures, trained on absolute exposures.

\code{cutoffInitialValid_rel_df}: Optimal cutoffs for 
\code{\link{AlexInitialValid_sig_df}}, i.e. initially published signatures, 
only validated signatures, trained on relative exposures.

\code{cutoffInitialArtif_rel_df}: Optimal cutoffs for 
\code{\link{AlexInitialArtif_sig_df}}, i.e. initially published signatures, 
including artifact signatures, trained on relative exposures.

\code{cutoffInitialValid_abs_df}: Optimal cutoffs for 
\code{\link{AlexInitialValid_sig_df}}, i.e. initially published signatures, 
only validated signatures, trained on absolute exposures.

\code{cutoffInitialArtif_abs_df}: Optimal cutoffs for 
\code{\link{AlexInitialArtif_sig_df}}, i.e. initially published signatures, 
including artifact signatures, trained on absolute exposures.
}
\author{
Daniel Huebschmann \email{huebschmann.daniel@googlemail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{sigs}
\alias{sigs}
\alias{AlexInitialArtif_sig_df}
\alias{AlexInitialArtif_sigInd_df}
\alias{AlexInitialValid_sig_df}
\alias{AlexInitialValid_sigInd_df}
\alias{AlexCosmicValid_sig_df}
\alias{AlexCosmicValid_sigInd_df}
\alias{AlexCosmicArtif_sig_df}
\alias{AlexCosmicArtif_sigInd_df}
\title{Data for mutational signatures}
\source{
\code{AlexInitial}: \url{ftp://ftp.sanger.ac.uk/pub/cancer/AlexandrovEtAl/signatures.txt}

\code{AlexCosmic}: \url{https://cancer.sanger.ac.uk/cancergenome/assets/signatures_probabilities.txt}
}
\usage{
data(sigs)
}
\description{
The numerical data of the mutational signatures published initially by 
Alexandrov et al. (Nature 2013) and Alexandrov et al., (Bioaxiv 2018) is 
stored in data frames with endings \code{_sig_df}, the associated 
meta-information is stored in data frames with endings \code{_sigInd_df}. 
There are several instances of \code{_sig_df} and \code{_sigInd_df}, 
corresponding to results and data obtained at different times and with 
different raw data. There always is a one-to-one correspondence between
a \code{_sig_df} and a \code{_sigInd_df}. The data frames of type 
\code{_sig_df} have as many rows as there are features, i.e. 96 if 
analyzing mutational signatures of SNVs in a triplet context, and as
many columns as there are signatures.
Data frames of type \code{_sigInd_df} have as many rows as there are 
signatures in the corresponding \code{_sig_df} and several columns: 
\itemize{
 \item \code{sig}: signature name
 \item \code{index}: corresponding to the row index of the signature
 \item \code{colour}: colour for visualization in stacked barplots
 \item \code{process}: asserted biological process
 \item \code{cat.coarse}: categorization of the signatures according
  to the asserted biological processes at low level of detail
 \item \code{cat.medium}: categorization of the signatures according
  to the asserted biological processes at intermediate level of detail
 \item \code{cat.high}: categorization of the signatures according
  to the asserted biological processes at high level of detail
 \item \code{cat.putative}: categorization of the signatures according
  to the asserted biological processes based on clustering and inference
 }
 Please note, that categorization columns are only present for the data 
 frames corrosponding to the data from Alexandorv et al. (Nature 2013).

\code{AlexInitialArtif_sig_df}: Data frame of the signatures published 
initially by Alexandrov et al. 
(Nature 2013). There are 27 signatures which constitute the columns, 22 of 
which were validated by an orhtogonal sequencing technology. These 22 are in
the first 22 columns of the data frame. The column names are \emph{A} pasted
to the number of the signature, e.g. \emph{A5}. The nonvalidated signatures
have an additional letter in their naming convention: either 
\emph{AR1} - \emph{AR3} or \emph{AU1} - \emph{AU2}. The rownames are the 
features, i.e. an encoding of the nucleotide exchanges in their 
trinucleotide context, e.g. \emph{C>A ACA}. In total there are 96 different 
features and therefore 96 rows when dealing with a trinucleotide context.

\code{AlexInitialArtif_sigInd_df}: Meta-information for 
\code{AlexInitialArtif_sig_df}

\code{AlexInitialValid_sig_df}: Data frame of only the validated signatures 
published initially by Alexandrov et al. (Nature 2013), corresponding to the
first 22 columns of \code{AlexInitialArtif_sig_df}

\code{AlexInitialValid_sigInd_df}: Meta-information for 
\code{AlexInitialValid_sig_df}

\code{AlexCosmicValid_sig_df}: Data frame of the updated signatures list 
maintained by Ludmil Alexandrov at
\url{https://cancer.sanger.ac.uk/cosmic/signatures}. The column names are 
\emph{AC} pasted to the number of the signature, e.g. \emph{AC5}. The naming
convention for the rows is as described for 
\code{\link{AlexInitialArtif_sig_df}}.

\code{AlexCosmicValid_sigInd_df}: Meta-information for 
\code{AlexCosmicValid_sig_df}

\code{AlexCosmicArtif_sig_df}: Data frame of the updated signatures list 
maintained by Ludmil Alexandrov at
\url{https://cancer.sanger.ac.uk/cosmic/signatures} and complemented by the 
artifact signatures from the initial publication, i.e. the last 5 columns of
\code{\link{AlexInitialArtif_sig_df}}. The column names are \emph{AC} pasted
to the number of the signature, e.g. \emph{AC5}. The naming convention for 
the rows is as described for \code{\link{AlexInitialArtif_sig_df}}.

\code{AlexCosmicArtif_sigInd_df}: Meta-information for 
\code{AlexCosmicArtif_sig_df}
}
\references{
Alexandrov et al. (Nature 2013)
}
\author{
Daniel Huebschmann \email{huebschmann.daniel@googlemail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_functions.R
\name{plotExchangeSpectra}
\alias{plotExchangeSpectra}
\title{Plot the spectra of nucleotide exchanges}
\usage{
plotExchangeSpectra(
  in_catalogue_df,
  in_colour_vector = NULL,
  in_show_triplets = FALSE,
  in_show_axis_title = FALSE,
  in_scales = "free_x",
  in_refLine = NULL,
  in_refAlpha = 0.5,
  in_background = NULL
)
}
\arguments{
\item{in_catalogue_df}{Numerical data frame encoding the exchange spectra to
be displayed, either a mutational catalogue \code{V} or a signatures matrix
\code{W}.}

\item{in_colour_vector}{Specifies the colours of the 6 nucleotide exchanges
if non-null.}

\item{in_show_triplets}{Whether or not to show the triplets on the x-axis}

\item{in_show_axis_title}{Whether or not to show the name of the y-axis}

\item{in_scales}{Argument passed on to \code{\link[ggplot2]{facet_grid}}}

\item{in_refLine}{If non-null, value on the y-axis at which a horizontal line
is to be drawn}

\item{in_refAlpha}{Transparency of the horizontal line if it is to be drawn}

\item{in_background}{Option to provide a background theme, e.g.
\code{\link[ggplot2]{theme_grey}}}
}
\value{
The generated barplot - a ggplot2 plot
}
\description{
Plots the spectra of nucleotide exchanges in their triplet contexts. If
several columns are present in the input data frame, the spectra are plotted
for every column separately.
}
\examples{
 NULL

}
\seealso{
\code{\link[ggplot2]{geom_bar}}

\code{\link[ggplot2]{facet_grid}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/indels.R
\name{classify_indels}
\alias{classify_indels}
\title{INDEL function V1 - not compartible with AlexandrovSignatures}
\usage{
classify_indels(
  in_df,
  in_ALT.field = "ALT",
  in_REF.field = "REF",
  in_breaks = c(-Inf, -10, -3, 0, 2, 9, Inf),
  in_labels = c("del3", "del2", "del1", "in1", "in2", "in3")
)
}
\arguments{
\item{in_df}{Input data frame containing the variances in a vcf-like format}

\item{in_ALT.field}{Column number for alternitve field}

\item{in_REF.field}{Coloumn number for reference field}

\item{in_breaks}{Handed over to function cut}

\item{in_labels}{Handed over to function cut}
}
\value{
classVector, a factor vector of indel sizes
}
\description{
INDEL function V1 - not compartible with AlexandrovSignatures
}
\examples{
 NULL

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{exampleYAPSA}
\alias{exampleYAPSA}
\alias{lymphoma_PID_df}
\alias{lymphoma_test_df}
\alias{lymphoma_Nature2013_raw_df}
\alias{lymphoma_Nature2013_COSMIC_cutoff_exposures_df}
\alias{rel_lymphoma_Nature2013_COSMIC_cutoff_exposures_df}
\alias{COSMIC_subgroups_df}
\alias{chosen_AlexInitialArtif_sigInd_df}
\alias{chosen_signatures_indices_df}
\title{Test and example data}
\usage{
data(lymphoma_PID)

data(lymphoma_test)

data(lymphoma_Nature2013_raw)

data(lymphoma_cohort_LCD_results)

data(lymphoma_cohort_LCD_results)

data(lymphoma_cohort_LCD_results)

data(lymphoma_cohort_LCD_results)

data(lymphoma_cohort_LCD_results)
}
\description{
Data structures used in examples, SNV tests and the SNV signature vignette 
of the YAPSA package.

\code{lymphoma_PID_df}: A data frame carrying subgroup information for a 
subcohort of samples used in the vignette. Data in the vignette is 
downloaded from 
\url{ftp://ftp.sanger.ac.uk/pub/cancer/AlexandrovEtAl/somatic_mutation_data/Lymphoma\%20B-cell/Lymphoma\%20B-cell_clean_somatic_mutations_for_signature_analysis.txt}.
In the file available under that link somatic point mutation calls from 
several samples are listed in a vcf-like format. One column encodes the 
sample the variant was found in. In the vignette we want to restrict the 
analysis to only a fraction of these involved samples. The data frame 
\code{lymphoma_PID_df} carries the sample identifiers (PID) as rownames and 
the attributed subgroup in a column called \code{subgroup}.

\code{lymphoma_test_df}: A data frame carrying point mutation calls. It 
represents a subset of the data stored in
\url{ftp://ftp.sanger.ac.uk/pub/cancer/AlexandrovEtAl/somatic_mutation_data/Lymphoma\%20B-cell/Lymphoma\%20B-cell_clean_somatic_mutations_for_signature_analysis.txt}.
In the file available under that link somatic point mutation calls from 
several samples are listed in a vcf-like format. One column encodes the 
sample the variant was found in. The data frame \code{lymphoma_test_df} has 
only the variants occuring in the sample identifiers (PIDs) 4112512, 4194218
and 4121361.

\code{lymphoma_Nature2013_raw_df}: A data frame carrying point mutation 
calls. It represents a subset of the data stored in
\url{ftp://ftp.sanger.ac.uk/pub/cancer/AlexandrovEtAl/somatic_mutation_data/Lymphoma\%20B-cell/Lymphoma\%20B-cell_clean_somatic_mutations_for_signature_analysis.txt}.
In the file available under that link somatic point mutation calls from 
several samples are listed in a vcf-like format. One column encodes the 
sample the variant was found in.

\code{lymphoma_Nature2013_COSMIC_cutoff_exposures_df}: Data frame with 
exposures for testing the plot functions. Data taken from
\url{ftp://ftp.sanger.ac.uk/pub/cancer/AlexandrovEtAl/somatic_mutation_data/Lymphoma\%20B-cell/Lymphoma\%20B-cell_clean_somatic_mutations_for_signature_analysis.txt}.

\code{rel_lymphoma_Nature2013_COSMIC_cutoff_exposures_df}: Data frame with 
normalized or relative exposures for testing the plot functions. Data taken 
from
\url{ftp://ftp.sanger.ac.uk/pub/cancer/AlexandrovEtAl/somatic_mutation_data/Lymphoma\%20B-cell/Lymphoma\%20B-cell_clean_somatic_mutations_for_signature_analysis.txt}.

\code{COSMIC_subgroups_df}: Subgroup information for the data stored in
\code{\link{lymphoma_Nature2013_COSMIC_cutoff_exposures_df}} and 
\code{\link{rel_lymphoma_Nature2013_COSMIC_cutoff_exposures_df}}.

\code{chosen_AlexInitialArtif_sigInd_df}: Signature information for the
 data stored in
\code{\link{lymphoma_Nature2013_COSMIC_cutoff_exposures_df}} and 
\code{\link{rel_lymphoma_Nature2013_COSMIC_cutoff_exposures_df}}.

\code{chosen_signatures_indices_df}: Signature information for the data
stored in
\code{\link{lymphoma_Nature2013_COSMIC_cutoff_exposures_df}} and 
\code{\link{rel_lymphoma_Nature2013_COSMIC_cutoff_exposures_df}}.
}
\examples{
data(lymphoma_test)
head(lymphoma_test_df)
dim(lymphoma_test_df)
table(lymphoma_test_df$PID)

data(lymphoma_Nature2013_raw)
head(lymphoma_Nature2013_raw_df)
dim(lymphoma_Nature2013_raw_df)

}
\references{
\url{https://www.ncbi.nlm.nih.gov/pubmed/23945592}
}
\author{
Daniel Huebschmann \email{huebschmann.daniel@googlemail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_functions.R
\name{hclust_exposures}
\alias{hclust_exposures}
\title{Cluster the PIDs according to their signature exposures}
\usage{
hclust_exposures(
  in_exposures_df,
  in_subgroups_df,
  in_method = "manhattan",
  in_subgroup_column = "subgroup",
  in_palette = NULL,
  in_cutoff = 0,
  in_filename = NULL,
  in_shift_factor = 0.3,
  in_cex = 0.2,
  in_title = "",
  in_plot_flag = FALSE
)
}
\arguments{
\item{in_exposures_df}{Numerical data frame encoding the exposures \code{H},
i.e. which signature contributes how much to which PID (patient identifier
or sample).}

\item{in_subgroups_df}{A data frame indicating which PID (patient or sample
identifyier) belongs to which subgroup}

\item{in_method}{Method of the clustering to be supplied to
\code{\link{dist}}. Can be either of: \code{euclidean}, \code{maximum},
\code{manhattan}, \code{canberra}, \code{binary} or \code{minkowski}}

\item{in_subgroup_column}{Indicates the name of the column in which the
subgroup information is encoded in \code{in_subgroups_df}}

\item{in_palette}{Palette with colours or colour codes for the labels (the
text) of the leaves in the dendrogram. Typically one colour per subgroup.
If none is specified, a rainbow palette of the length of the number of
subgroups will be used as default.}

\item{in_cutoff}{A numeric value less than 1. Signatures from within \code{W}
with an overall exposure less than \code{in_cutoff} will be discarded for
the clustering.}

\item{in_filename}{A path to save the dendrogram. If none is specified, the
figure will be plotted to the running environment.}

\item{in_shift_factor}{Graphical parameter to adjust figure to be created}

\item{in_cex}{Graphical parameter to adjust figure to be created}

\item{in_title}{Title in the figure to be created under \code{in_filename}}

\item{in_plot_flag}{Whether or not to display the dendrogram}
}
\value{
A list with entries \code{hclust} and \code{dendrogram}. \itemize{
  \item \code{hclust}: The object created by \code{\link{hclust}} \item
  \code{dendrogram}: The above object wrapped in \code{\link{as.dendrogram}}
  }
}
\description{
The PIDs are clustered according to their signature exposures by calling
first creating a distance matrix: \itemize{ \item \code{\link{dist}}, then
\item \code{\link{hclust}} and then \item
\code{\link[dendextend]{labels_colors}} to colour the labels (the text) of
the leaves in the dendrogram. } Typically one colour per subgroup.
}
\examples{
 data(lymphoma_cohort_LCD_results)
 hclust_exposures(rel_lymphoma_Nature2013_COSMIC_cutoff_exposures_df,
                  COSMIC_subgroups_df,
                  in_method="manhattan",
                  in_subgroup_column="subgroup")

}
\seealso{
\code{\link{hclust}}

\code{\link{dist}}

\code{\link[dendextend]{labels_colors}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{cutoffs_pcawg}
\alias{cutoffs_pcawg}
\alias{cutoffPCAWG_SBS_WGSWES_artifPid_df}
\alias{cutoffPCAWG_SBS_WGSWES_realPid_df}
\alias{cutoffPCAWG_ID_WGS_Pid_df}
\title{Opt. cutoffs, PCAWG SNV signatures, including artifacts}
\usage{
data(cutoffs_pcawg)
}
\description{
\code{cutoffPCAWG_SBS_WGSWES_artifPid_df}: Optimal cutoffs for 
\code{\link{PCAWG_SP_SBS_sigs_Artif_df}}, i.e. initially published 
signatures,including artifact signatures, trained in a single-sample 
resolution.

\code{cutoffPCAWG_SBS_WGSWES_realPid_df}: Optimal cutoffs for 
\code{\link{PCAWG_SP_SBS_sigs_Real_df}}, i.e. initially published 
signatures, only validated signatures, trained in a single-sample 
resolution.

\code{cutoffPCAWG_ID_WGS_Pid_df}: Optimal cutoffs for 
\code{\link{PCAWG_SP_ID_sigs_df}}, i.e. initially published signatures, 
signatures, trained in a single-sample resolution.
}
\author{
Lea Jopp-Saile \email{huebschmann.daniel@googlemail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{exampleINDEL_YAPSA}
\alias{exampleINDEL_YAPSA}
\title{Data structures used in examples, Indel tests and the Indel signature
vignette of the YAPSA package.}
\description{
Data structures used in examples, Indel tests and the Indel signature
vignette of the YAPSA package.
}
\references{
\url{https://www.ncbi.nlm.nih.gov/pubmed/23945592}
}
\author{
Daniel Huebschmann \email{huebschmann.daniel@googlemail.com}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_functions.R
\name{annotation_heatmap_exposures}
\alias{annotation_heatmap_exposures}
\title{Heatmap to cluster the PIDs on their signature 
exposures (ComplexHeatmap)}
\usage{
annotation_heatmap_exposures(
  in_exposures_df,
  in_annotation_df,
  in_annotation_col,
  in_signatures_ind_df,
  in_data_type = "norm exposures",
  in_method = "manhattan",
  in_palette = colorRamp2(c(0, 0.2, 0.4, 0.6), c("white", "yellow", "orange", "red")),
  in_cutoff = 0,
  in_filename = NULL,
  in_column_anno_borders = FALSE,
  in_row_anno_borders = FALSE,
  in_show_PIDs = TRUE,
  in_annotation_legend_side = "right"
)
}
\arguments{
\item{in_exposures_df}{Numerical data frame encoding the exposures \code{H},
i.e. which signature contributes how much to which PID (patient identifier
or sample).}

\item{in_annotation_df}{A data frame indicating which PID (patient or sample
identifyier) belongs to which subgroup for all layers of annotation}

\item{in_annotation_col}{A list indicating colour attributions for all layers
of annotation}

\item{in_signatures_ind_df}{A data frame containing meta information about
the signatures, especially the asserted colour}

\item{in_data_type}{Title in the figure}

\item{in_method}{Method of the clustering to be supplied to
\code{\link{dist}}. Can be either of: \code{euclidean}, \code{maximum},
\code{manhattan}, \code{canberra}, \code{binary} or \code{minkowski}}

\item{in_palette}{Palette with colours or colour codes for the heatmap.
Default is \code{colorRamp2(c(0, 0.2, 0.4, 0.6),
c('white','yellow','orange','red'))}}

\item{in_cutoff}{A numeric value less than 1. Signatures from within \code{W}
with an overall exposure less than \code{in_cutoff} will be discarded for
the clustering.}

\item{in_filename}{A path to save the heatmap. If none is specified, the
figure will be plotted to the running environment.}

\item{in_column_anno_borders}{Whether or not to draw separating lines between
the fields in the annotation}

\item{in_row_anno_borders}{Whether or not to draw separating lines between
the fields in the annotation}

\item{in_show_PIDs}{Whether or not to show the PIDs on the x-axis}

\item{in_annotation_legend_side}{Where to put the legends of the annotation
df, default is right.}
}
\value{
The function doesn't return any value.
}
\description{
The PIDs are clustered according to their signature exposures. The procedure
is analogous to \code{\link{complex_heatmap_exposures}}, but enabling more
than one annotation row for the PIDs. This function calls: \itemize{ \item
\code{\link[ComplexHeatmap]{rowAnnotation}}, \item
\code{\link[ComplexHeatmap]{HeatmapAnnotation}} and \item
\code{\link[ComplexHeatmap]{Heatmap}} }
}
\details{
One additional parameter, in_show_legend_bool_vector, indicating
which legends to display, is planned but deactivated in this version of the
package. In order to use this features, it will be necessary to install the
newest version of the packages \pkg{circlize} and \pkg{ComplexHeatmap} by
Zuguang Gu: \code{devtools::install_github("jokergoo/circlize")} and
\code{devtools::install_github("jokergoo/ComplexHeatmap")}
}
\examples{
 NULL

}
\seealso{
\code{\link[ComplexHeatmap]{Heatmap}}

\code{\link{complex_heatmap_exposures}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/basic_functions.R
\name{stderrmean}
\alias{stderrmean}
\title{Compute the standard error of the mean}
\usage{
stderrmean(x)
}
\arguments{
\item{x}{A numerical vector}
}
\value{
Standard deviation of an input numerical vector divided by the square
 root of the length of the input vector
}
\description{
This function returns the standard deviation of an input numerical vector 
divided by the square root of the length of the input vector
}
\examples{
A <- c(1,2,3)
sd(A)
stderrmean(A)
 
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/complex_functions.R
\name{normalizeMotifs_otherRownames}
\alias{normalizeMotifs_otherRownames}
\title{Normalize Somatic Motifs with different rownames}
\usage{
normalizeMotifs_otherRownames(in_matrix, in_norms, adjust_counts = TRUE)
}
\arguments{
\item{in_matrix, in_norms}{Arguments to
\code{\link[SomaticSignatures]{normalizeMotifs}}}

\item{adjust_counts}{Whether to rescale the counts after adaption or not.
Default is true.}
}
\value{
The matrix returned by
\code{\link[SomaticSignatures]{normalizeMotifs}}, but with rownames
transformed back to the convention of the input
}
\description{
This is a wrapper function to
\code{\link[SomaticSignatures]{normalizeMotifs}}. The rownames are first
transformed to fit the convention of the
\code{\link[SomaticSignatures]{SomaticSignatures}} package and then passed on
to the above mentioned function.
}
\examples{
 NULL

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/complex_functions.R
\name{cut_breaks_as_intervals}
\alias{cut_breaks_as_intervals}
\title{Wrapper for cut}
\usage{
cut_breaks_as_intervals(
  in_vector,
  in_outlier_cutoffs = c(0, 3000),
  in_cutoff_ranges_list = list(c(60, 69), c(25, 32)),
  in_labels = c("late", "intermediate", "early"),
  in_name = "",
  output_path = NULL
)
}
\arguments{
\item{in_vector}{Vector of numerical continuously distributed input}

\item{in_outlier_cutoffs}{Interval specifyinf the upper and lower bounds of
the range to be considered}

\item{in_cutoff_ranges_list}{List if intervals in which the cutoffs for
\code{\link{cut}} have to be optimized.}

\item{in_labels}{Labels assigned to the strata or factors returned}

\item{in_name}{String specifying the name of the quantity analyzed (and
plotted on the x-axis of the figure to be created).}

\item{output_path}{Path where the figure produced by the density function
should be stored if non-NULL.}
}
\value{
A list with entries \code{category_vector}, and \code{density_plot}
  and \code{cutoffs} \itemize{ \item \code{category_vector}: Factor vector of
  the categories or strata, of the same length as \code{in_vector} \item
  \code{density_plot}: Density plot produced by the density function and
  indication of the chosen cutoffs. \item \code{cutoffs}: Vector of the
  computed optimal cutoffs }
}
\description{
In this wrapper function for the known \code{\link{cut}} function, the
\code{breaks} vector need not be supplied directly, instead, for every break,
an interval is supplied and the function optimizes the choice of the
breakpoint by chosing a local minimum of the distribution.
}
\examples{
 data(lymphoma_test)
 lymphoma_test_df$random_norm <- rnorm(dim(lymphoma_test_df)[1])
 temp_list <- cut_breaks_as_intervals(
   lymphoma_test_df$random_norm,
   in_outlier_cutoffs=c(-4,4),
   in_cutoff_ranges_list=list(c(-2.5,-1.5),c(0.5,1.5)),
   in_labels=c("small","intermediate","big"))
  temp_list$density_plot

}
\seealso{
\code{\link{cut}}

\code{\link[stats]{density}}
}
